note

	description:

		"Utility to build a STRING from a POINTER and a length."

	author: "Mark Howard"
	last_editor: "$Author: c4 $"
	date: "$Date: 2014/02/14 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/library/external/src/makestr.e $"

class	MAKESTR

inherit

	STRING_HANDLER

feature -- Implementation.

	makestr (a_pointer: POINTER; a_length: INTEGER): STRING
			-- String built from `a_pointer' and `a_length'
		do
			create Result.make (a_length)
			Result.set_count (a_length)
			Result.area.base_address.memory_copy (a_pointer, a_length)
		ensure
			makestr_attached: Result /= Void
			correct_count: Result.count = a_length
		end

	c_string (a_string: STRING): ROSE_BYTES
			-- Copy of `a_string' accessible from C
		do
			create Result.make (a_string)
		ensure
			c_string_attached: Result /= Void
		end

end
