note

	description:

		"Operations on C memory"

	author: "Pierre Nallet"
	last_editor: "$Author: c4 $"
	date: "$Date: 2014/02/14 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/library/external/src/memory_functions.e $"

class	MEMORY_FUNCTIONS


feature -- Access

	pointer_to_integer (p: POINTER): INTEGER
			-- `p' cast as a 32-bit integer (guess)
		external
			"C [macro <string.h>] (EIF_POINTER):EIF_INTEGER"
		alias
			" "
		end

	integer_to_pointer (p: INTEGER): POINTER
			-- `p' cast as a pointer (guess)
		external
			"C [macro <string.h>] (EIF_INTEGER):EIF_POINTER"
		alias
			" "
		end

	zero_memory (p: POINTER; a_len: INTEGER)
			-- Clear `a_len' bytes of memory at `p'.
		external
			"C [macro <string.h>] (void*, int)"
		alias
			"ZeroMemory"
		end

	memcpy (a_dest, a_src: POINTER; a_len: INTEGER)
			-- Copy `a_len' bytes of memory from `a_src' to `a_dest'.
		external
			"C [macro <string.h>] (void*, const void*, size_t)"
		alias
			"memcpy"
		end

	memcmp (a_dest, a_src: POINTER; a_len: INTEGER): INTEGER
			-- Compare `a_len' bytes at `a_src' with `a_dest'.
		external
			"C [macro <string.h>] (void*, const void*, size_t): EIF_INTEGER"
		alias
			"memcmp"
		end

	memmove (a_dest, a_src: POINTER; a_len: INTEGER)
			-- Copy `a_len' bytes of memory from `a_src' to `a_dest'.
			-- Unlike `mwmcpy', this is guaranteed safe for overlapping byte-strings.
		external
			"C [macro <string.h>] (void*, const void*, size_t)"
		alias
			"memmove"
		end

--	You can debug calloc and free by removing the comments below.  RJ.

--	c_memory_objects_used : INTEGER_REF is
--	once
--		create Result
--	end

	calloc (i, j: INTEGER): POINTER
			-- Allocate and clear `i' elements of memory of size `j' bytes each.
--	do
--		Result := c_calloc(i, j)
--		if Result/=default_pointer
--		then
--			c_memory_objects_used.set_item(c_memory_objects_used.item + 1)
--		end
--	end
--
--	c_calloc (i, j: INTEGER): POINTER
		external
			"C [macro <string.h>] (size_t, size_t): EIF_POINTER"
		alias
			"calloc"
		end

	free (p: POINTER)
			-- Free memory pointed to by `p'.
--	do
--		if p/=default_pointer
--		then
--			c_memory_objects_used.set_item(c_memory_objects_used.item - 1)
--		end
--
--		c_free(p)
--	end
--
--	c_free (p: POINTER) is
		external
			"C [macro <string.h>] (void *) "
		alias
			"free"
		end

end


