note
	
	description: "Byte consumer that produces a message digest"

	author: "Franck Arnaud (from pre-AXA Rosenberg days)"
	last_editor: "$Author: c4 $"
	date: "$Date: 2014/02/10 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/third_party/crypto/src/crypt_digest.e $"
	project: "http://www.nenie.org/eiffel/"
	license: "http://www.opensource.org/licenses/mit-license.html"


deferred class CRYPT_DIGEST

inherit
	
	CRYPT_BYTE_CONSUMER
	
feature -- Digest

	digest: detachable CRYPT_BYTES 
			-- Message digest.
			-- Attached after call to `final'.
		deferred
		ensure
			size: attached Result as l_result implies l_result.count = digest_size
		end
	
	digest_size: INTEGER 
			-- Message digest size;
			-- (fixed for each algorithm)
		deferred
		end
	
	block_size: INTEGER
			-- Input block size;
			-- This is normally not of interest for clients as 
			-- descendants handle padding.
		deferred
		end
		
end
