note

	description:

		"Simple implementation of an ordered four tuple."

	keywords: "tuple, ordered"
	author: "David Stevens"
	last_editor: "$Author: c4 $"
	date: "$Date: 2014/05/13 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/library/containers_base/src/tuple/four_tuple.e $"

class 
	
	FOUR_TUPLE [G, H, I, J]
	
create
	
	make
	
feature -- Access
	
	first: G
			-- Projection 1
	
	second: H
			-- Projection 2
	
	third: I
			-- Projection 3
	
	fourth: J
			-- Projection 4

feature -- Setting

	make, set (a_first: G; a_second: H; a_third: I; a_fourth: J)
			-- Initalize all projections.
		do
			first := a_first
			second := a_second
			third := a_third
			fourth := a_fourth
		ensure
			first_aliased: (first = first) implies (first = a_first) -- for non-reflexive types e.g. REAL_nn
			second_aliased: (second = second) implies (second = a_second)
			third_aliased: (third = third) implies (third = a_third)
			fourth_aliased: (fourth = fourth) implies (fourth = a_fourth)
		end
	
	put_first (a_first: G)
			-- Set `first' from `a_first'.
		do
			first := a_first
		ensure
			first_aliased: first = a_first
		end
	
	put_second (a_second: H)
			-- Set `second' from `a_second'.
		do
			second := a_second
		ensure
			second_aliased: second = a_second
		end
	
	put_third (a_third: I)
			-- Set `third' from `a_third'.
		do
			third := a_third
		ensure
			third_aliased: third = a_third
		end
	
	put_fourth (a_fourth: J)
			-- Set `fourth'  from `a_fourth'.
		do
			fourth := a_fourth
		ensure
			fourth_aliased: fourth = a_fourth
		end
	
end
