note

	description:

		"2-ary key for multi-keyed hash table"

	keywords: "hash,multikey,pair"
	storable_version: ""
	author: "Mark Howard"
	last_editor: "$Author: c4 $"
	date: "$Date: 2014/05/14 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/library/containers_base/src/tuple/key_pair.e $"

class	KEY_PAIR [G -> HASHABLE, H -> HASHABLE]

inherit
	
	PAIR [G, H]
		redefine
			is_equal
		end

	HASHABLE
		export
			{NONE} all
		undefine
			default_create
		redefine
			is_equal
		end

	DEBUG_OUTPUT
		undefine
			is_equal, default_create
		end

create

	make

feature -- Access

	hash_code: INTEGER
		-- <Precursor>
		local
			l_first_hash_code, l_second_hash_code: INTEGER
		do
			if attached first as l_first then
				l_first_hash_code := l_first.hash_code
			end
			if attached second as l_second then
				l_second_hash_code := l_second.hash_code
			end
			Result := (l_first_hash_code + l_second_hash_code.bit_shift_left (1)).hash_code
		end

	is_equal (a_other: like Current): BOOLEAN
			-- <Precursor>
		do
			Result := first ~ a_other.first and second ~ a_other.second
		end
	
feature -- Output
	
	debug_output: STRING
		-- for debug
		do
			if not attached first as l_first then
				Result := "Void:"
			else
				Result := l_first.out + ":"
			end
			if not attached second as l_second then
				Result.append ("Void")
			else
				Result.append (l_second.out)
			end
		end
	
feature -- Access
	
	reverse_key: KEY_PAIR [H, G]
			-- directional
			-- first is the second, second is the first
		do
			Create Result.make (second, first)
		ensure
			reverse_key_attached: Result /= Void
		end

end
