note

	description:

		"3-ary key for multi-keyed hash table"

	keywords: "hash,multikey,triple"
	storable_version: ""
	author: "David Stevens"
	last_editor: "$Author: c4 $"
	date: "$Date: 2014/05/13 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/library/containers_base/src/tuple/key_triple.e $"

class	KEY_TRIPLE [G -> HASHABLE, H -> HASHABLE, I -> HASHABLE]

inherit
	
	TRIPLE[G, H, I]
		redefine
			is_equal
		end

	HASHABLE
		export
			{NONE} all
		undefine
			default_create
		redefine
			is_equal
		end

create

	make

feature -- Access
	
	hash_code: INTEGER
			-- <Precursor>
		do
			if attached first as l_first then
				Result := Result + l_first.hash_code
			end
			if attached second as l_second then
				Result := Result + l_second.hash_code
			end
			if attached third as l_third then
				Result := Result + l_third.hash_code
			end
			Result := Result.hash_code
		end

	is_equal (a_other: like Current): BOOLEAN
			-- <Precursor>
		do
			Result := first ~ a_other.first and
				second ~ a_other.second and
				third ~ a_other.third
		end

end
