note

	description:

		"Descendent of LINEAR which gets its LINEAR behavior from the feature linear"

	author: "Mark Howard"
	last_editor: "$Author: c4 $"
	date: "$Date: 2014/05/13 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/library/containers_base/src/linear/linear_proxy.e $"

deferred class	LINEAR_PROXY [G]

inherit 
	
	LINEAR [G]
	
feature -- Access
	
	is_empty: BOOLEAN
			-- Is proxied structure empty? 
		do
			Result := linear.is_empty
		end

	item: G
			-- Item at current position
		do
			Result := linear.item
		end
	
	start
			-- Move to first position if any.
		do
			linear.start
		end 
	
	after: BOOLEAN
			-- Is there no valid position to the right of current one?
		do
			Result := linear.after
		end 

	finish
			-- Move to last position.
		do
			linear.finish
		end
	
	forth
			-- Move to next position; if no next position,
			-- ensure that `exhausted' will be true.
		do
			linear.forth 
		end

	index: INTEGER
			-- Index of current position
		do
			Result := linear.index
		end

feature {NONE} -- Implementation

	linear: LINEAR [G]
			-- Proxied structure
		deferred
		ensure
			linear_attached: Result /= Void
		end 

end
