note

	description:

		"[
        Simple implementation of an ordered pair of items

        Neither generic may represent a self-initializing type.
       ]"

	keywords: "pair,ordered"
	storable_version: ""
	author: "Mark Howard"
	last_editor: "$Author: c4 $"
	date: "$Date: 2014/05/14 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/library/containers_base/src/tuple/pair.e $"

class	PAIR [G, H]

inherit

	RP_SERIALIZABLE
	
	ANY
		redefine
			default_create
		end

create
	
	make, default_create
	
feature -- Initialization
	
	default_create
			-- <Precursor>
		do
			check ({G}).has_default then
					-- programmer obligation, as expressed in class description
				first := ({G}).default
			end
			check ({H}).has_default then
					-- programmer obligation, as expressed in class description
				second := ({H}).default
			end			
		end
	
	make, set (a_first: G; a_second: H)
			-- Creation procedure.
		do
			first := a_first
			second := a_second
		end

feature --Access

	first: G
			-- Projection 1
	
	second: H
			-- Projection 2

feature -- Basic operations

	set_first (a_value: like first)
			-- Set `first'.
		do
			first := a_value
		ensure
			first_aliased: (a_value = a_value) implies first = a_value
					-- Reflexivity. REAL and DOUBLE do not have this property.
		end

	set_second (a_value: like second)
			-- Set `second'.
		do
			second := a_value
		ensure
			second_aliased: (a_value = a_value) implies second = a_value			
		end

end
