note

	description:

		"Nodes in a linked structure"

	author: "Mark Howard"
	last_editor: "$Author: c4 $"
	date: "$Date: 2014/05/13 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/library/containers_base/src/queue/rose_link_cell.e $"

class	ROSE_LINK_CELL [G]

inherit
	
	DEBUG_OUTPUT
	
create 

	make
	
feature {NONE} -- Initialization
	
	make (a_container: ROSE_CELL_CONTAINER [like item]; a_item: like item)
			-- Initialize from `a_container' and `a_item'.
		require
			a_container_attached: a_container /= Void
		do
			container := a_container
			item := a_item
		ensure
			container_aliased: container = a_container
			item_aliased: item = a_item
		end
	
feature -- Access
	
	debug_output: STRING
			-- <Precursor>
		do
			if attached item as l_item then
				Result := l_item.out
			else
				Result := "<Void>"
			end
		end

	item: G
			-- Boxed value
	
	left: detachable like Current
			-- Previous cell
	
	right: detachable like Current
			-- Next cell
	
	container: ROSE_CELL_CONTAINER [like item]
			-- Linear structure

feature -- Setting
	
	set_left (a_left: detachable like Current)
			-- Set `left' to `a_left'.
		do
			left := a_left
		end
	
	set_right (a_right: detachable like Current)
			-- Set `right' to `a_right'.
		do
			right := a_right
		end
		
	detach
			-- Remove `Current' from structure.
		do
			if attached left as l_left then
				l_left.set_right (right)
			end
			if attached right as l_right then
				l_right.set_left (left)
			end
			left := Void
			right := Void
		end
	
invariant

	container_attached: container /= Void

end 









