note

	description:

		"Simple implementation of an ordered six tuple."

	keywords: "tuple, ordered"
	author: "David Stevens"
	last_editor: "$Author: c4 $"
	date: "$Date: 2014/05/13 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/library/containers_base/src/tuple/six_tuple.e $"

class 
	
	SIX_TUPLE [G, H, I, J, K, L]
	
create
	
	make
	
feature -- Access
	
	first: G
			-- Projection 1
	
	second: H
			-- Projection 2
	
	third: I
			-- Projection 3
	
	fourth: J
			-- Projection 4
	
	fifth: K
			-- Projection 5
	
	sixth: L
			-- Projection 6
	
feature {NONE} -- Initialization
	
	make (a_first: G; a_second: H; a_third: I; a_fourth: J; a_fifth: K; a_sixth: L)
			-- Initialize all fields.
		do
			first := a_first
			second := a_second
			third := a_third
			fourth := a_fourth
			fifth := a_fifth
			sixth := a_sixth
		ensure
			first_aliased: (a_first = a_first) implies first = a_first -- for non-reflexive types e.g. REAL_nn
			second_aliased: (a_second = a_second) implies second = a_second
			third_aliased: (a_third = a_third) implies third = a_third
			fourth_aliased: (a_fourth = a_fourth) implies fourth = a_fourth
			fifth_aliased: (a_fifth = a_fifth) implies fifth = a_fifth
			sixth_aliased: (a_sixth = a_sixth) implies sixth = a_sixth
		end

feature -- Setting
	
	put_first (a_first: G)
			-- Set `first' from `a_first'.
		do
			first := a_first
		ensure
			first_aliased: (a_first = a_first) implies first = a_first
		end
	
	put_second (a_second: H)
			-- Set `second' from `a_second'.
		do
			second := a_second
		ensure
			second_aliased: (a_second = a_second) implies second = a_second
		end
	
	put_third (a_third: I)
			-- Set `third' from `a_third'.
		do
			third := a_third
		ensure
			third_aliased: (a_third = a_third) implies third = a_third	
		end
	
	put_fourth (a_fourth: J)
			-- Set `fourth' from `a_fourth'.
		do
			fourth := a_fourth
		ensure
			fourth_aliased: (a_fourth = a_fourth) implies fourth = a_fourth
		end
	
	put_fifth (a_fifth: K)
			-- Set `fifth' from `a_fifth'.
		do
			fifth := a_fifth
		ensure
			fifth_aliased: (a_fifth = a_fifth) implies fifth = a_fifth
		end
	
	put_sixth (a_sixth: L)
			-- Set `sixth' from `a_sixth'.
		do
			sixth := a_sixth
		ensure
			sixth_aliased: (a_sixth = a_sixth) implies sixth = a_sixth
		end
	
end
