note

	description:

		"[
        Hash table which can use a tuple as a key,
        and which will use is_equal on the items of the tuple, rather than =
       ]"

	author: "Mark Howard"
	last_editor: "$Author: c4 $"
	date: "$Date: 2014/05/13 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/library/containers_base/src/table/tuple_keyed_hash_table.e $"

class	TUPLE_KEYED_HASH_TABLE [G, K -> TUPLE]

inherit
	
	HASH_TABLE [G, K]
		redefine
			same_keys
		end

create

	make

feature -- Comparison

	same_keys (a_search_key, a_key: K): BOOLEAN
			-- Does `a_search_key' equal to `a_key'?
			--| Default implementation is using ~.
		local
			i, nb: INTEGER
		do
			if a_search_key ~ a_key then
				Result := True
			else
				nb := a_search_key.count
				if nb = a_key.count and then a_search_key.same_type (a_key) then
					from
						Result := True
						i := 1
					until
						i > nb or else not Result
					loop
						Result := a_search_key.item (i) ~ a_key.item (i)
						i := i + 1
					end
				end
			end
		end

end
