note

	description:

		"Represents an abstract description of a field in a record"

	author: "Mark Howard"
	last_editor: "$Author: c4 $"
	date: "$Date: 2014/05/13 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/library/containers_core/src/data/data_descriptor.e $"

deferred class	DATA_DESCRIPTOR

feature --Access
	
	name: STRING
			-- Field name
	
	is_null: BOOLEAN
			-- Does `Current' represent no information?
		deferred
		end
	
	integer_value: INTEGER
			-- `Current' interpreted as a 32-bit integer
      deferred
      end

   boolean_value: BOOLEAN
			-- `Current' interpreted as a boolean
      deferred
		end
	
   real_value: REAL
			-- `Current' interpreted as a 32-bit floating point number
      deferred
      end
	
   double_value: DOUBLE
			-- `Current' interpreted as a 64-bit floating point number
      deferred
      end
	
   character_value: CHARACTER
			-- `Current' interpreted as an 8-bit character
      deferred
      end

   date_time_value: ROSE_DATE
			-- `Current' interpreted as a date or datetime value
      deferred
      end

   string_value: STRING
			-- `Current' interpreted as an 8-bit character string
      deferred
      end

feature -- Setting

	set_null_value (a_boolean: BOOLEAN)
			-- Possibly set `is_null' to `a_boolean'.
			-- (One implementation dies nothing, and is_null is always `False').
		deferred
		end

invariant
	
	name_not_void : name /= Void
	
end
