note

	description:

		"Represents a sequence of DATA_DESCRIPTOR"

	author: "Mark Howard"
	last_editor: "$Author: c4 $"
	date: "$Date: 2014/05/13 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/library/containers_core/src/data/data_descriptors.e $"

class	DATA_DESCRIPTORS [G -> DATA_DESCRIPTOR]

inherit
	
	ARRAY [G]
	
create
	
	make
	
feature -- Access
	
	ordered_column_names: ROSE_LINEAR_ARRAY [STRING]
			-- Upper-cased field names
		local
			l_string: STRING
			i: INTEGER
		do
			create Result.make_empty
			from i := 1 until i > count loop
				l_string := item (i).name.twin
				l_string.prune_all (' ')
				l_string.to_upper
				Result.extend (l_string)
				i := i + 1
			end
		ensure
			ordered_column_names_attached: Result /= Void
			every_name_attached: not Result.has (({STRING}).default)
		end
	
	columns: attached like columns_saved
			-- Field position indexed by name
		local
			l_string: STRING
			i: INTEGER
		do
			if not attached columns_saved as l_saved then
				create Result.make (count)
				from i := 1 until i > count loop
					l_string := item (i).name.twin
					l_string.prune_all (' ')
					l_string.to_upper
					Result.put (i, l_string)
					i := i + 1
				end
				columns_saved := Result
			else
				Result := l_saved
			end
		end
	
	column_index (a_string: STRING): INTEGER
			-- Position of field named `a_string'
		require
			a_string_attached: a_string /= Void
		local
			l_string: STRING
		do
			l_string := a_string.twin
			l_string.prune_all (' ')
			l_string.to_upper
			Result := columns.item (l_string)
		end
	
feature -- Basic operations
	
	reset_columns
			-- Force next call to `columns' to re-read array.
		do
			columns_saved := Void
		end
	
	update_input_map (a_input: detachable ANY; a_binding: ARRAY [STRING])
			-- Setup the input map based on `a_object' and `a_binding'.
		require
			a_binding_attached: a_binding /= Void
		do
		end
	
	set_parameters (a_object: detachable ANY; a_values: detachable ARRAY [ANY])
			-- Set column parameters from eith `a_object' or `a_values'.
		do
		end
	
	get_values (a_receptacle: detachable ANY)
			-- Put values into `a_receptacle'.
		do
		end
	
feature {NONE} -- Implementation
	
	columns_saved: detachable HASH_TABLE [INTEGER, STRING]
			-- Cache for `columns'
	
end
