note

	description:

		"Rose keyed partition"

	author: "Michael Zhang"
	last_editor: "$Author: c4 $"
	date: "$Date: 2014/05/13 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/library/containers_core/src/rose_keyed_partition.e $"

class	ROSE_KEYED_PARTITION [G, H -> HASHABLE]

inherit

	ROSE_INDEXED_ARRAY [ROSE_LINEAR_ARRAY [G], H]
		rename
			make as indexed_make
		end

create
	
	make, indexed_make
	
create {ROSE_KEYED_PARTITION}

	make_empty, make_from_array

feature {NONE} -- Initialization
	
	make (a_array: ARRAY [G]; a_mapping_function: attached like mapping_function)
			-- Initialize from `a_array' using `a_mapping_function'.
		require
			valid_array: a_array /= Void
			valid_mapping: a_mapping_function /= Void
		local
			i: INTEGER
			l_item: G
			l_items: ROSE_LINEAR_ARRAY [G]
		do
			mapping_function := a_mapping_function
			make_empty
			from
				i := a_array.lower
			until
				i > a_array.upper
			loop
				l_item := a_array.item (i)
				if attached a_mapping_function.item ([l_item]) as l_key then
					if attached item_at (l_key) as l_item_2 then
						l_item_2.extend (l_item)
					else
						create l_items.make_empty
						l_items.extend (l_item)
						extend (l_items, l_key)
					end
				end
				i := i + 1
			end
		end
	
feature -- Agents
	
	mapping_function: detachable FUNCTION [ANY, TUPLE [G], H]
			-- Optional function for determining key
	
end
