note

	description:

		"Columns for displaying results of ROSE_MOMENTS"

	author: "Michael Zhang"
	last_editor: "$Author: c4 $"
	date: "$Date: 2014/05/13 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/library/containers_core/src/rose_moments_access.e $"

class	ROSE_MOMENTS_ACCESS

feature -- Access
	
	column_names: ROSE_HASHED_LINEAR_ARRAY [STRING]
			-- Report headers
		once
			create Result.make_from_array (<<"Count", "Mean", "StdDev", "Min", "1stQtile", "Median",
				"3rdQtile", "Max", "Total", "Weight", "WtTotal", "SqTotal">>)
		ensure
			column_names_attached: Result /= Void
			correct_count: Result.count = 12
		end	
	
	column_id (a_variable_name: STRING): INTEGER
			-- Column index of `a_variable_name';
			-- Zero if `a_variable_name' not understood
		do
			if a_variable_name /= Void and then column_names.has_value (a_variable_name) then
				Result := column_names.new_index_of (a_variable_name)
			end
		end
		
end 
