note
	
	description: "INTERNAL plus"

	documentation: "http://prism/modules/wacko/wakka.php?wakka=EnhancedInternal"
	author: "Nate McNamara"
	last_editor: "$Author: c4 $"
	date: "$Date: 2014/05/13 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/library/kernel_infrastructure_base/src/enhanced_internal.e $"

class ENHANCED_INTERNAL

inherit

	INTERNAL

feature -- Creation

	new_special_any_instance_filled (type_id, count: INTEGER): SPECIAL [detachable ANY]
			-- New instance of dynamic `type_id' that represents
			-- a SPECIAL with `count' element. To create a SPECIAL of
			-- basic type, use `SPECIAL'.
		require
			count_valid: count >= 0
			type_id_nonnegative: type_id >= 0
			special_type: is_special_any_type (type_id)
		do
			Result := new_special_any_instance (type_id, count)
			Result.fill_with (Void, 0, count - 1)
		ensure
			special_type: is_special (Result)
			dynamic_type_set: dynamic_type (Result) = type_id
			count_set: Result.count = count
			capacity_set: Result.capacity = count
		end

feature -- Commonly used type IDs
	
	any_type_id: INTEGER
			-- The dynamic type id of ANY
		once
			Result := dynamic_type(create {ANY})
		ensure
			non_negative: Result >= 0
		end

	boolean_type_id: INTEGER
			-- The dynamic type id of BOOLEAN
		once
			Result := dynamic_type(create {BOOLEAN})
		ensure
			non_negative: Result >= 0
		end

	boolean_ref_type_id: INTEGER
			-- The dynamic type id of BOOLEAN_REF
		once
			Result := dynamic_type(create {BOOLEAN_REF})
		ensure
			non_negative: Result >= 0
		end

	character_8_type_id: INTEGER
			-- The dynamic type id of CHARACTER_8
		once
			Result := dynamic_type(create {CHARACTER_8})
		ensure
			non_negative: Result >= 0
		end

	character_8_ref_type_id: INTEGER
			-- The dynamic type id of CHARACTER_8_REF
		once
			Result := dynamic_type(create {CHARACTER_8_REF})
		ensure
			non_negative: Result >= 0
		end

	character_32_type_id: INTEGER
			-- The dynamic type id of CHARACTER_32
		once
			Result := dynamic_type(create {CHARACTER_32})
		ensure
			non_negative: Result >= 0
		end

	character_32_ref_type_id: INTEGER
			-- The dynamic type id of CHARACTER_32_REF
		once
			Result := dynamic_type(create {CHARACTER_32_REF})
		ensure
			non_negative: Result >= 0
		end

	integer_8_type_id: INTEGER
			-- The dynamic type id of INTEGER_8
		once
			Result := dynamic_type(create {INTEGER_8})
		ensure
			non_negative: Result >= 0
		end

	integer_8_ref_type_id: INTEGER
			-- The dynamic type id of INTEGER_8_REF
		once
			Result := dynamic_type(create {INTEGER_8_REF})
		ensure
			non_negative: Result >= 0
		end

	integer_16_type_id: INTEGER
			-- The dynamic type id of INTEGER_16
		once
			Result := dynamic_type(create {INTEGER_16})
		ensure
			non_negative: Result >= 0
		end

	integer_16_ref_type_id: INTEGER
			-- The dynamic type id of INTEGER_16_REF
		once
			Result := dynamic_type(create {INTEGER_16_REF})
		ensure
			non_negative: Result >= 0
		end

	integer_32_type_id: INTEGER
			-- The dynamic type id of INTEGER_32
		once
			Result := dynamic_type(create {INTEGER_32})
		ensure
			non_negative: Result >= 0
		end

	integer_32_ref_type_id: INTEGER
			-- The dynamic type id of INTEGER_32_REF
		once
			Result := dynamic_type(create {INTEGER_32_REF})
		ensure
			non_negative: Result >= 0
		end

	integer_64_type_id: INTEGER
			-- The dynamic type id of INTEGER_64
		once
			Result := dynamic_type(create {INTEGER_64})
		ensure
			non_negative: Result >= 0
		end

	integer_64_ref_type_id: INTEGER
			-- The dynamic type id of INTEGER_64_REF
		once
			Result := dynamic_type(create {INTEGER_64_REF})
		ensure
			non_negative: Result >= 0
		end

	natural_8_type_id: INTEGER
			-- The dynamic type id of NATURAL_8
		once
			Result := dynamic_type(create {NATURAL_8})
		ensure
			non_negative: Result >= 0
		end

	natural_8_ref_type_id: INTEGER
			-- The dynamic type id of NATURAL_8_REF
		once
			Result := dynamic_type(create {NATURAL_8_REF})
		ensure
			non_negative: Result >= 0
		end

	natural_16_type_id: INTEGER
			-- The dynamic type id of NATURAL_16
		once
			Result := dynamic_type(create {NATURAL_16})
		ensure
			non_negative: Result >= 0
		end

	natural_16_ref_type_id: INTEGER
			-- The dynamic type id of NATURAL_16_REF
		once
			Result := dynamic_type(create {NATURAL_16_REF})
		ensure
			non_negative: Result >= 0
		end

	natural_32_type_id: INTEGER
			-- The dynamic type id of NATURAL_32
		once
			Result := dynamic_type(create {NATURAL_32})
		ensure
			non_negative: Result >= 0
		end

	natural_32_ref_type_id: INTEGER
			-- The dynamic type id of NATURAL_32_REF
		once
			Result := dynamic_type(create {NATURAL_32_REF})
		ensure
			non_negative: Result >= 0
		end

	natural_64_type_id: INTEGER
			-- The dynamic type id of NATURAL_64
		once
			Result := dynamic_type(create {NATURAL_64})
		ensure
			non_negative: Result >= 0
		end

	natural_64_ref_type_id: INTEGER
			-- The dynamic type id of NATURAL_64_REF
		once
			Result := dynamic_type(create {NATURAL_64_REF})
		ensure
			non_negative: Result >= 0
		end

	real_32_type_id: INTEGER
			-- The dynamic type id of REAL_32
		once
			Result := dynamic_type(create {REAL_32})
		ensure
			non_negative: Result >= 0
		end

	real_32_ref_type_id: INTEGER
			-- The dynamic type id of REAL_32_REF
		once
			Result := dynamic_type(create {REAL_32_REF})
		ensure
			non_negative: Result >= 0
		end

	real_64_type_id: INTEGER
			-- The dynamic type id of REAL_64
		once
			Result := dynamic_type(create {REAL_64})
		ensure
			non_negative: Result >= 0
		end

	real_64_ref_type_id: INTEGER
			-- The dynamic type id of REAL_64_REF
		once
			Result := dynamic_type(create {REAL_64_REF})
		ensure
			non_negative: Result >= 0
		end

	string_type_id: INTEGER
			-- The dynamic type id of STRING
		once
			Result := dynamic_type("")
		ensure
			non_negative: Result >= 0
		end

	tuple_type_id: INTEGER
			-- The dynamic type ID of TUPLE.
		once
			Result := dynamic_type([])
		end

feature -- Access
	
	field_by_name (f: STRING; o: ANY): detachable ANY
			-- `o.f'
		require
			known_field: has_field_by_name (f, o)
		do
			Result := field (field_index_by_name (f, o), o)
		end

	field_index_by_name (f: STRING; o: ANY): INTEGER
			-- Returns zero if f is not a field of o.
		require
			f_not_void: f /= Void
			o_not_void: o /= Void
		do
			from Result := field_count(o)
			until Result <= 0 or else f.as_lower.is_equal(field_name(Result, o).as_lower)
			loop Result := Result - 1
			end
		ensure
			field_index_by_name_in_range:
				0 <= Result and Result <= field_count(o)
			non_zero_implies_name_matches:
				Result > 0 implies field_name (Result, o).as_lower.is_equal (f.as_lower)
		end

	field_names (o: ANY): ARRAYED_LIST[STRING]
			-- With compare_objects turned on.
		require
			o_not_void: o /= Void
		local
			i, l_count: INTEGER
		do
			l_count := field_count(o)
			create Result.make(l_count)
			from i := 1 until i > l_count loop
				Result.extend(field_name(i, o))
				i := i + 1
			end
			Result.compare_objects
--		ensure
--			field_names_correct:
--				(1 |..| field_count(o)).for_all(agent (
--					j: INTEGER; p: ANY; r: ARRAY[STRING]): BOOLEAN do
--						Result := field_name(j, p).as_lower.is_equal(r[j].as_lower)
--					end (?, o, Result))
		end

	field_static_type (i: INTEGER; o: ANY): INTEGER
			-- The dynamic type of o's ith field.
		require
			o_not_void: o /= Void
			i_in_range: 1 <= i and i <= field_count(o)
		do
			Result := field_static_type_of_type (i, dynamic_type(o))
		ensure
			field_static_type_non_negative: Result >= 0
		end

	field_static_type_by_name (f: STRING; o: ANY): INTEGER
			-- The dynamic type of o's field named f.
		require
			f_not_void: f /= Void
			o_not_void: o /= Void
			known_field: has_field_by_name(f, o)
		do
			Result := field_static_type (field_index_by_name(f, o), o)
		ensure
			field_static_type_by_name_non_negative: Result >= 0
		end

	field_type_by_name (f: STRING; o: ANY): INTEGER
			-- This is the internal field type,
			-- e.g., internal.integer_32_type.
			-- It is NOT the dynamic type.
		require
			f_not_void: f /= Void
			o_not_void: o /= Void
			known_field: has_field_by_name(f, o)
		do
			Result := field_type (field_index_by_name(f, o), o)
		end

	fieldx (i: INTEGER; o: ANY): detachable ANY
			-- Like field, except that if the result is
			-- one of the builtin expanded types,
			-- that's what you'll get (not *_REF).
		require
			o_not_void: o /= Void
			valid_i: 1 <= i and i <= field_count(o)
			not_special: not is_special(o)
		do
			Result := field (i, o)
			if field_type (i, o) /= reference_type then
				if attached {INTEGER_32_REF} Result as l_32 then
					Result := l_32.item
				elseif attached {REAL_64_REF} Result as l_d then
					Result := l_d.item
				elseif attached {INTEGER_64_REF} Result as l_64 then
					Result := l_64.item
				elseif attached {BOOLEAN_REF} Result as l_b then
					Result := l_b.item
				elseif attached {CHARACTER_8_REF} Result as l_c then
					Result := l_c.item
				elseif attached {INTEGER_8_REF} Result as l_8 then
					Result := l_8.item
				elseif attached {INTEGER_16_REF} Result as l_16 then
					Result := l_16.item
				elseif attached {NATURAL_8_REF} Result as l_n8 then
					Result := l_n8.item
				elseif attached {NATURAL_16_REF} Result as l_n16 then
					Result := l_n16.item
				elseif attached {NATURAL_32_REF} Result as l_n32 then
					Result := l_n32.item
				elseif attached {NATURAL_64_REF} Result as l_n64 then
					Result := l_n64.item
				elseif attached {CHARACTER_32_REF} Result as l_c32 then
					Result := l_c32.item
				elseif attached {REAL_32_REF} Result as l_r then
					Result := l_r.item
				elseif attached {POINTER_REF} Result as l_p then
					Result := l_p.item
				end
			end
		end

	has_field_by_name (f: STRING; o: ANY): BOOLEAN
			-- Does o have a field named f?
		require
			f_not_void: f /= Void
			o_not_void: o /= Void
		do
			Result := field_index_by_name (f, o) > 0
		ensure
			definition: Result = (field_index_by_name (f, o) > 0)
		end

feature -- Basic operations
	
	copy_fields (a_source, a_sink: ANY)
			-- Shallow copy of field from a_source to a_sink.
		require
			a_source_not_void: a_source /= Void
			a_sink_not_void: a_sink /= Void
			same_types: a_source.same_type (a_sink)
		local
			i, l_count: INTEGER
		do
			l_count := field_count (a_sink)
			from i := 1 until i > l_count loop
				set_field (i, a_sink, field (i, a_source))
				i := i + 1
			end
		end

	is_known_class (a_class_name: STRING): BOOLEAN
			-- Is a_class_name in the system?
		require
			a_class_name_not_void: a_class_name /= Void
		do
			Result := dynamic_type_from_string (a_class_name) /= -1
		end

	new_instance_by_name (a_class_name: STRING): ANY
			-- new_instance_of(dynamic_type_from_string(a_class_name))
		require
			a_class_name_not_void: a_class_name /= Void
			known_class: is_known_class (a_class_name)
		do
			Result := new_instance_of(
				dynamic_type_from_string (a_class_name))
		ensure
			new_instance_by_name_not_void: Result /= Void
		end

	set_field (i: INTEGER; o: ANY; v: detachable ANY)
			-- o[i] := v or die
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
		do
			if attached {PROCEDURE [ANY, TUPLE [INTEGER, ANY, detachable ANY]]}
				field_setter_table [field_type (i, o)] as l_setter then
				l_setter.call ([i, o, v])
			else
				raise("Unsupported field type " + field_type (i, o).out)
			end
		ensure
			-- I believe this should be so, but damn
			-- if it ain't when v is BOOLEAN using
			-- 6.0.7.946.
			--field_set: equal(v, field(i, o))
		end

	set_field_by_name (f: STRING; o: ANY; v: ANY)
			-- o.f := v or die
		require
			known_field: has_field_by_name (f, o)
		do
			set_field(field_index_by_name (f, o), o, v)
		ensure
			field_set: equal (v, field_by_name (f, o))
		end

	set_field_from_string (i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.to_X or die
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
		do
			if {c: PROCEDURE[ANY, TUPLE[INTEGER, ANY, STRING]]}
				from_string_converter_table [field_type(i, o)]
			then
				c.call ([i, o, v])
			else
				raise ("Unsupported type internal field type" +
					field_type (i, o).out)
			end
		end

	set_field_by_name_from_string(f: STRING; o: ANY; v: STRING)
			-- o.f := v.to_X or die
		require
			known_field: has_field_by_name(f, o)
			v_not_void: v /= Void
		do
			set_field_from_string(field_index_by_name(f, o), o, v)
		end

feature -- set_X_from_string
	
	set_boolean_from_string (i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.to_boolean
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			v_is_boolean: v.is_boolean
		do
			set_boolean_field(i, o, v.to_boolean)
		ensure
			field_set: v.to_boolean = boolean_field (i, o)
		end

	set_boolean_ref_from_string (i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.to_boolean.to_reference
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			v_is_boolean: v.is_boolean
		do
			set_reference_field (i, o,	v.to_boolean.to_reference)
		ensure
			field_set: attached {BOOLEAN_REF} field(i, o) as l_b and then
				l_b.item = v.to_boolean
		end

	set_character_from_string (i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.item(1)
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			one_character: v.count = 1
		do
			set_character_field (i, o, v.item(1))
		ensure
			field_set: v.item(1) = character_field (i, o)
		end

	set_character_ref_from_string (i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.item(1).to_reference
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			one_character: v.count = 1
		do
			set_reference_field(i, o, v.item(1).to_reference)
		ensure
			field_set: attached {CHARACTER_8_REF} field(i, o) as l_c and then
				l_c.item = v.item(1)
		end

	set_integer_8_from_string (i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.to_integer_8
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			integer_8: v.is_integer_8
		do
			set_integer_8_field (i, o, v.to_integer_8)
		ensure
			field_set: v.to_integer_8 = integer_8_field (i, o)
		end

	set_integer_8_ref_from_string (i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.to_integer_8.to_reference
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
						integer_8: v.is_integer_8
		do
			set_reference_field(i, o, v.to_integer_8.to_reference)
		ensure
			field_set: attached {INTEGER_8_REF} field(i, o) as l_x and then
				l_x.item = v.to_integer_8
		end

	set_integer_16_from_string (i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.to_integer_16
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			integer_16: v.is_integer_16
		do
			set_integer_16_field (i, o, v.to_integer_16)
		ensure
			field_set: v.to_integer_16 = integer_16_field (i, o)
		end

	set_integer_16_ref_from_string (i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.to_integer_16.to_reference
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			integer_16: v.is_integer_16
		do
			set_reference_field(i, o, v.to_integer_16.to_reference)
		ensure
			field_set: attached {INTEGER_16_REF} field(i, o) as l_x and then
				l_x.item = v.to_integer_16
		end

	set_integer_from_string, set_integer_32_from_string (
		i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.to_integer_32
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			integer_32: v.is_integer_32
		do
			set_integer_32_field (i, o, v.to_integer_32)
		ensure
			field_set: v.to_integer = integer_field (i, o)
		end

	set_integer_ref_from_string,
	set_integer_32_ref_from_string(
		i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.to_integer_32.to_reference
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			integer_32: v.is_integer_32
		do
			set_reference_field (i, o, v.to_integer_32.to_reference)
		ensure
			field_set: attached {INTEGER_32_REF} field(i, o) as l_x and then
				l_x.item = v.to_integer_32
		end

	set_integer_64_from_string (i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.to_integer_64
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			integer_64: v.is_integer_64
		do
			set_integer_64_field (i, o, v.to_integer_64)
		ensure
			field_set: v.to_integer_64 = integer_64_field(i, o)
		end

	set_integer_64_ref_from_string(
		i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.to_integer_64.to_reference
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			integer_64: v.is_integer_64
		do
			set_reference_field (i, o, v.to_integer_64.to_reference)
		ensure
			field_set: attached {INTEGER_64_REF} field(i, o) as l_x and then
				l_x.item = v.to_integer_64
		end

	set_natural_8_from_string (i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.to_natural_8
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			natural_8: v.is_natural_8
		do
			set_natural_8_field (i, o, v.to_natural_8)
		ensure
			field_set: v.to_natural_8 = natural_8_field (i, o)
		end

	set_natural_8_ref_from_string (i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.to_natural_8.to_reference
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			natural_8: v.is_natural_8
		do
			set_reference_field(i, o, v.to_natural_8.to_reference)
		ensure
			field_set: attached {NATURAL_8_REF} field (i, o) as l_x and then
				l_x.item = v.to_natural_8
		end

	set_natural_16_from_string (i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.to_natural_16
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			natural_16: v.is_natural_16
		do
			set_natural_16_field (i, o, v.to_natural_16)
		ensure
			field_set: v.to_natural_16 = natural_16_field (i, o)
		end

	set_natural_16_ref_from_string (i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.to_natural_16.to_reference 
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			natural_16: v.is_natural_16
		do
			set_reference_field (i, o,	v.to_natural_16.to_reference)
		ensure
			field_set: attached {NATURAL_16_REF} field (i, o) as l_x and then
				l_x.item = v.to_natural_16
		end

	set_natural_from_string, set_natural_32_from_string (
		i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.to_natural_32
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			natural_32: v.is_natural_32
		do
			set_natural_32_field (i, o, v.to_natural_32)
		ensure
			field_set: v.to_natural_32 = natural_32_field (i, o)
		end

	set_natural_ref_from_string,
	set_natural_32_ref_from_string (
		i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.to_natural_32.to_reference
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			natural_32: v.is_natural_32
		do
			set_reference_field (i, o,	v.to_natural_32.to_reference)
		ensure
			field_set: attached {NATURAL_32_REF} field (i, o) as l_x and then
				l_x.item = v.to_natural_32
		end

	set_natural_64_from_string (i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.to_natural_64
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			natural_64: v.is_natural_64
		do
			set_natural_64_field (i, o, v.to_natural_64)
		ensure
			field_set: v.to_natural_64 = natural_64_field (i, o)
		end

	set_natural_64_ref_from_string(
		i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.to_natural_64.to_reference
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			natural_64: v.is_natural_64
		do
			set_reference_field (i, o,	v.to_natural_64.to_reference)
		ensure
			field_set: attached {NATURAL_64_REF} field (i, o) as l_x and then
				l_x.item = v.to_natural_64
		end

	set_pointer_from_string (i: INTEGER; o: ANY; v: STRING)
			-- Raise (we don't support string->pointer conversion).
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
		do
			raise (conversion_failure_message(i, "POINTER", o, v))
		end

	set_real_32_from_string, set_real_from_string (
		i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.to_real
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			real_32: v.is_real
		do
			set_real_32_field (i, o, v.to_real)
		ensure
			field_set: v.to_real = real_field (i, o)
		end

	set_real_32_ref_from_string,
	set_real_ref_from_string (
		i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.to_real.to_reference
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			real_32: v.is_real
		do
			set_reference_field (i, o, v.to_real.to_reference)
		ensure
			field_set: attached {REAL_32_REF} field (i, o) as l_x and then
				l_x.item = v.to_real
		end

	set_real_64_from_string, set_double_from_string (
		i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.to_double
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			real_64: v.is_real_64
		do
			set_real_64_field (i, o, v.to_double)
		ensure
			field_set: v.to_double = real_64_field (i, o)
		end

	set_real_64_ref_from_string,
	set_double_ref_from_string (
		i: INTEGER; o: ANY; v: STRING)
			-- o[i] := v.to_real_64.to_reference or die
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			real_64: v.is_real_64
		do
			set_reference_field (i, o, v.to_double.to_reference)
		ensure
			field_set: attached {REAL_64_REF} field (i, o) as l_x and then
				l_x.item = v.to_double
		end

	set_string_from_string (i: INTEGER; o: ANY; v: STRING)
			-- if o.i is STRING then o.i := v else raise
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			string_type: type_conforms_to(string_type_id, field_static_type (i, o))
		do
			set_reference_field (i, o, v)
		ensure
			field_set: equal (field (i, o), v)
		end

feature {NONE} -- Implementation
	conversion_failure_message(
		i: INTEGER;
		a_target_type_name: STRING;
		o: ANY;
		v: STRING): STRING
			-- Returns a failure message.
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			a_target_type_name_not_void: a_target_type_name /= Void
			v_not_void: v /= Void
		do
			Result := "Cannot convert STRING to " +
				a_target_type_name + ": " + o.generator + "." +
				field_name(i, o) + " /= " + v
		ensure
			conversion_failure_message_not_void: Result /= Void
		end

	field_setter_table:
		HASH_TABLE [PROCEDURE [ANY, TUPLE[INTEGER, ANY, detachable ANY]], INTEGER]
			-- Maps internal types to setters.
		once
			create Result.make(0)
			Result.put (agent set_boolean, Boolean_type)
			Result.put (agent set_character, Character_8_type)
			Result.put (agent set_character_32, Character_32_type)
			Result.put (agent set_integer_8, Integer_8_type)
			Result.put (agent set_integer_16, Integer_16_type)
			Result.put (agent set_integer_32, Integer_32_type)
			Result.put (agent set_integer_64, Integer_64_type)
			Result.put (agent set_natural_8, Natural_8_type)
			Result.put (agent set_natural_16, Natural_16_type)
			Result.put (agent set_natural_32, Natural_32_type)
			Result.put (agent set_natural_64, Natural_64_type)
			Result.put (agent set_pointer, Pointer_type)
			Result.put (agent set_real_32, Real_32_type)
			Result.put (agent set_real_64, Real_64_type)
			Result.put (agent set_reference_field, Reference_type)
		end

	from_string_converter_table:
		HASH_TABLE [PROCEDURE [ANY, TUPLE [INTEGER, ANY, STRING]], INTEGER]
			-- Maps internal types to from-string converters.
		once
			create Result.make(0)
			Result.put (agent set_boolean_from_string, Boolean_type)
			Result.put (agent set_character_from_string, Character_8_type)
			Result.put (agent set_integer_8_from_string, Integer_8_type)
			Result.put (agent set_integer_16_from_string, Integer_16_type)
			Result.put (agent set_integer_from_string, Integer_32_type)
			Result.put (agent set_integer_64_from_string, Integer_64_type)
			Result.put (agent set_natural_8_from_string, Natural_8_type)
			Result.put (agent set_natural_16_from_string, Natural_16_type)
			Result.put (agent set_natural_from_string, Natural_32_type)
			Result.put (agent set_natural_64_from_string, Natural_64_type)
			Result.put (agent set_pointer_from_string, Pointer_type)
			Result.put (agent set_real_32_from_string, Real_32_type)
			Result.put (agent set_real_64_from_string, Real_64_type)
			Result.put (agent set_string_from_string, Reference_type)
		end

	raise(a_message: STRING)
			-- Raises an exceptions with a_message
		require
			message_exists : a_message /= Void
		do
			(create {EXCEPTIONS}).raise(a_message)
		end

feature {NONE} -- set_X
	
	set_boolean (i: INTEGER; o: ANY; v: ANY)
			-- o[i] := v as BOOLEAN
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			v_boolean: attached {BOOLEAN_REF} v
		do
			check attached {BOOLEAN_REF} v as l_b then
					-- precondition "v_boolean"
				set_boolean_field (i, o, l_b.item)
			end
		end

	set_character (i: INTEGER; o: ANY; v: ANY)
			-- o[i] := v as CHARACTER
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			v_character: attached {CHARACTER_REF} v
		do
			check attached {CHARACTER_REF} v as l_c then
					-- precondition "v_character"
				set_character_field(i, o, l_c.item)
			end
		end

	set_character_32 (i: INTEGER; o: ANY; v: ANY)
			-- o[i] := v as CHARACTER_32
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			v_character_32: attached {CHARACTER_32_REF} v
		do
			check attached {CHARACTER_32_REF} v as l_c then
					-- precondition "v_character_32"
				set_character_32_field (i, o, l_c.item)
			end
		end

	set_integer_8 (i: INTEGER; o: ANY; v: ANY)
			-- o[i] := v as INTEGER_8
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			v_integer_8: attached {INTEGER_8_REF} v
		do
			check attached {INTEGER_8_REF} v as l_i then
					-- precondition "v_integer_8"
				set_integer_8_field(i, o, l_i.item)
			end
		end

	set_integer_16 (i: INTEGER; o: ANY; v: ANY)
			-- o[i] := v as INTEGER_16
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			v_integer_16: attached {INTEGER_16_REF} v
		do
			check attached {INTEGER_16_REF} v as l_16 then
					-- precondition "v_integer_16"
				set_integer_16_field (i, o, l_16.item)
			end
		end

	set_integer_32 (i: INTEGER; o: ANY; v: ANY)
			-- o[i] := v as INTEGER_32
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			v_integer_32: attached {INTEGER_32_REF} v
		do
			check attached {INTEGER_32_REF} v as l_32 then
					-- precondition "v_integer_32"
				set_integer_32_field (i, o, l_32.item)
			end
		end

	set_integer_64 (i: INTEGER; o: ANY; v: ANY)
			-- o[i] := v as INTEGER_64
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			v_integer_64: attached {INTEGER_64_REF} v
		do
			check attached {INTEGER_64_REF} v as l_64 then
					-- precondition "v_integer_64"
				set_integer_64_field(i, o, l_64.item)
			end
		end

	set_natural_8 (i: INTEGER; o: ANY; v: ANY)
			-- o[i] := v as NATURAL_8
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			v_natural_8: attached {NATURAL_8_REF} v
		do
			check attached {NATURAL_8_REF} v as l_8 then
					-- precondition "v_natural_8"
				set_natural_8_field (i, o, l_8.item)
			end
		end

	set_natural_16 (i: INTEGER; o: ANY; v: ANY)
			-- o[i] := v as NATURAL_16
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			v_natural_16: attached {NATURAL_16_REF} v			
		do
			check attached {NATURAL_16_REF} v as l_16 then
					-- precondition "v_natural_16"
				set_natural_16_field(i, o, l_16.item)
			end
		end

	set_natural_32 (i: INTEGER; o: ANY; v: ANY)
			-- o[i] := v as NATURAL_32
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			v_natural_32: attached {NATURAL_32_REF} v						
		do
			check attached {NATURAL_32_REF} v as l_32 then
					-- precondition "v_natural_32"
				set_natural_32_field(i, o, l_32.item)
			end
		end

	set_natural_64 (i: INTEGER; o: ANY; v: ANY)
			-- o[i] := v as NATURAL_64
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			v_natural_64: attached {NATURAL_64_REF} v			
		do
			check attached {NATURAL_64_REF} v as l_64 then
					-- precondition "v_natural_64"
				set_natural_64_field(i, o, l_64.item)
			end
		end

	set_pointer (i: INTEGER; o: ANY; v: ANY)
			-- o[i] := v as POINTER
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			v_pointer: attached {POINTER_REF} v
		do
			check attached {POINTER_REF} v as l_p then
					-- precondition "v_pointer"
				set_pointer_field (i, o, l_p.item)
			end
		end

	set_real_32 (i: INTEGER; o: ANY; v: ANY)
			-- o[i] := v as REAL_32
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			v_real_32: attached {REAL_32_REF} v
		do
			check attached {REAL_32_REF} v as l_32 then
					-- precondition "v_real_32"
				set_real_32_field (i, o, l_32.item)
			end
		end

	set_real_64 (i: INTEGER; o: ANY; v: ANY)
			-- o[i] := v as REAL_64
		require
			o_not_void: o /= Void
			i_is_valid_field_index: 1 <= i and i <= field_count(o)
			v_not_void: v /= Void
			v_real_64: attached {REAL_64_REF} v
		do
			check attached {REAL_64_REF} v as l_64 then
					-- precondition "v_real_64"
				set_real_64_field (i, o, l_64.item)
			end
		end

invariant
	
	any_type_id_is_valid: any_type_id >= 0
	field_setter_table_not_void: field_setter_table /= Void
	from_string_converter_table_not_void: from_string_converter_table /= Void
	string_type_id_is_valid: string_type_id >= 0

end
