note

	description:

		"Week from Saturday to Friday"

	author: "Michael Zhang"
	last_editor: "$Author: c4 $"
	date: "$Date: 2014/01/08 $"
	revision: "$Revision: #2 $"
	path: "$File: //rose/source/library/datetime/src/rose_week.e $"

class	ROSE_WEEK

inherit

	ROSE_DATE
		rename
			make as rose_date_make
		end

create

	make_from_rose_julian_week, make_from_date
	
create {ROSE_WEEK}

	rose_date_make	

feature {NONE} -- Initialization
	
	make_from_rose_julian_week (a_julian_week : INTEGER)
			-- Create as `a_julian_week' weeks since 1950/01/01.
		require
			a_julian_week_positive: a_julian_week > 0
		do
			make_from_rose_julian_day (a_julian_week * 7 - 1)
		end

	make_from_date (a_date: ROSE_DATE)
			-- Create as week corresponding to `a_date'.
		require
			a_date_attached: a_date /= Void
		do
			make_from_rose_julian_week (a_date.rose_julian_week)
		end

feature -- Access
	
	next_week: ROSE_WEEK
			-- One week later than `Current'.
		do
			create Result.make_from_rose_julian_week (rose_julian_week + 1)
		ensure
			next_week_attached: Result /= Void			
		end

	previous_week: ROSE_WEEK
			-- One week earlier than `Current'.
		do
			create Result.make_from_rose_julian_week (rose_julian_week - 1)
		ensure
			previous_week_attached: Result /= Void						
		end

	first_date: ROSE_DATE
			-- First day of week (Saturday)
		do
			create Result.make_from_rose_julian_day ((rose_julian_week - 1) * 7)
		ensure
			first_date_attached: Result /= Void
			Saturday: Result.day_of_the_week = Saturday
		end

	last_date: ROSE_DATE
			-- Last day of week
		do
			Result := Current
		ensure
			last_date_attached: Result /= Void
			Friday: Result.day_of_the_week = Friday
		end

	first_weekday: ROSE_DATE
			-- Monday
		do
			create Result.make_from_rose_julian_day ((rose_julian_week - 1) * 7 + 2)
		ensure
			first_weekday_attached: Result /= Void
			Monday: Result.day_of_the_week = Monday
		end

	last_weekday: ROSE_DATE
			-- Friday
		do
			Result := last_date
		ensure
			last_weekday_attached: Result /= Void
			Friday: Result.day_of_the_week = Friday	
		end

end
