note

	description:

		"Objects that provide shared access to a date near to the start of the execution of the program"

	author: "Colin Adams"
	last_editor: "$Author: it $"
	date: "$Date: 2014/11/25 $"
	revision: "$Revision: #3 $"
	path: "$File: //rose/source/library/datetime/src/shared_today.e $"

class SHARED_TODAY

feature -- Access

	today: ROSE_DATE
			-- Date in local time zone near of start of program execution
		once ("PROCESS")
			create Result.make_today
		ensure
			today_not_void: Result /= Void
		end

	utc_today: ROSE_DATE
			-- Date in UTC time zone near of start of program execution
		once ("PROCESS")
			create Result.make_today_utc
		ensure
			today_not_void: Result /= Void
		end

end
