note

	description:

		"Definition of a partitioning criteria"

	author: "Zoran Simic"
	last_editor: "$Author: c4 $"
	date: "$Date: 2014/05/13 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/library/quotient/src/rose_quotient_criteria.e $"

deferred class	ROSE_QUOTIENT_CRITERIA [G]

inherit
	
	DEBUG_OUTPUT
		undefine
			out
		end

feature -- Access

	property (a_object: detachable G): detachable COMPARABLE
			-- First property for `a_object'
		deferred
		end

	properties (a_object: detachable G): ARRAY [detachable COMPARABLE]
			-- All properties in this criteria for `a_object'
		deferred
		ensure
			properties_attached: Result /= Void
		end

	compared (a, b: G): INTEGER 
			-- Compare `a' and `b', return -1 if a < b, 0 if equal, 1 if a > b
		deferred
		end

	invariant_compared (a_object: detachable G; a_invariant: ROSE_QUOTIENT_INVARIANT [G]): INTEGER
			-- Compare `a_object' to `a_invariant' accordingly to this criteria
			-- Return -1 if `a_object' < `Current', 0 if equal, 1 otherwise
		require
			a_invariant_attached: a_invariant /= Void
		deferred
		end

	names: ARRAY [STRING]
			-- Atomic criteria names composing this criteria
		deferred
		ensure
			names_attached: Result /= Void
			all_names_attached: across Result as i_name all i_name.item /= Void end
		end

	has (a_criteria: ROSE_QUOTIENT_CRITERIA [G]): BOOLEAN
			-- Is `a_criteria' part of this criteria?
		require
			a_criteria_attached: a_criteria /= Void
		deferred
		end

	includes (a_other: ROSE_QUOTIENT_CRITERIA [G]): BOOLEAN
			-- Does this criteria include `a_other'?
		require
			a_other_attached: a_other /= Void
		deferred
		end

	is_empty: BOOLEAN
			-- Is this criteria empty?
		deferred
		end

	string_representation (a_object: detachable G; a_separator: STRING): STRING
			-- Representation of `a_object' for this criteria
			-- `a_separator' is used to separated multiple criterias
		require
			a_separator_attached: a_separator /= Void
		deferred
		end

end
