indexing
	description: "Abstract Format"
	author: "MK"
	last_editor: "$Author: mz $"
	date: "$Date: 2009/02/02 $"
	revision: "$Revision: #1 $"
	archive: "$Archive: $"

class
	ABSTRACT_FORMAT

inherit
	ROSE_CONSTANT_VALUES
	ROSE_SHARED_GLOBAL

feature -- Access

	type: INTEGER
			-- Internal type id of the las filled vessel

	number_of_columns: INTEGER
			-- Number of columns this format supports

	inverse_map: ROSE_LINEAR_ARRAY [INTEGER]
			-- Map from

feature -- Basic operations

	set_number_of_columns (a_number: INTEGER) is
			-- Number of columns in this format.
		require
			positive_number: a_number > 0
		do
			number_of_columns := a_number
			create column_info.make (1, a_number)
			create column_name_info.make (a_number)
		end

	set_column_info (a_column_number: INTEGER; a_info: TEXT_COLUMN_INFO) is
			-- Assign 'a_info' to 'a_column_number'.
		do
			column_info.put (a_info, a_column_number)
		end

	map_fields (a_vessel: ANY) is
			-- map fields
		require
			valid_vessel : a_vessel /= Void
		local
			i, n: INTEGER
			l_name: STRING
		do
			from
				n := internal.field_count (a_vessel)
				create inverse_map.make (1, n)
				i := 1
			until
				i > n
			loop
				l_name := internal.field_name (i, a_vessel).as_lower
				inverse_map.force (column_name_info.item (l_name), i)
				i := i + 1
			end
		end

feature {NONE} -- Implementation

	column_info: ARRAY [TEXT_COLUMN_INFO]

	column_name_info: HASH_TABLE [INTEGER, STRING]

end
