indexing
	description: "Abstract portfolio."
	author: "Michael Zhang"
	date: "$Date: 2010/04/28 $"
	revision: "$Revision: #7 $"

deferred class
	ABSTRACT_PORTFOLIO [G-> INVESTMENT_ENTITY]

inherit
	HAS_NAME

feature -- Access
	name : STRING
			-- Name of `Current'.
		deferred
		end

	is_bogie : BOOLEAN
		deferred
		end

	is_mn : BOOLEAN
			-- Is `Current' market neutral?
		deferred
		end

	is_long_short : BOOLEAN
		deferred
		end

	is_long : BOOLEAN
		deferred
		end

	is_short : BOOLEAN
		deferred
		end

	is_composite : BOOLEAN
		deferred
		end

	is_global : BOOLEAN
		deferred
		end

	is_hedged (a_date : ROSE_DATE) : BOOLEAN
		deferred
		end

	is_sim : BOOLEAN
		deferred
		end

feature -- Holdings
	company_matrix_at (a_date : ROSE_DATE) : ENTITY_MATRIX [like company_template]
		deferred
		end

	company_weights_history (a_dates : ARRAY [ROSE_DATE]) : ROSE_TIME_SERIES [ENTITY_VALUES [like company_template]]
		local
			i, l_lower : INTEGER
			l_values : ENTITY_VALUES[like company_template]
			l_date : ROSE_DATE
			l_ent_matrix : like company_matrix_at
		do
			create Result.make_empty
			if a_dates /= Void and then a_dates.count > 0 then
				l_lower := a_dates.lower
				from i := 1 until i > a_dates.count loop
					l_date := a_dates.item(l_lower + i - 1)
					l_ent_matrix := company_matrix_at(l_date)
					l_values := l_ent_matrix.selected_values(weight_label)
					--l_values.normalize
					l_values.set_name("Weights_"+l_date.ccyymmdd.out)
					Result.extend(l_values, l_date)
					i := i + 1
				end
			end
		end

	holdings : HOLDINGS [G, HOLDING_INTERVAL [G], HOLDING_HISTORY [G, HOLDING_INTERVAL [G]]]
		deferred
		end

	has_holding_at(a_entity : G; a_date : ROSE_DATE) : BOOLEAN is
		do
			Result := holdings /= Void and then holdings.has_holding_at(a_entity, a_date)
		end

	holding_at (a_entity : G; a_date : ROSE_DATE) : DOUBLE is
		do
			if holdings /= Void then
				Result := holdings.units_at (a_entity, a_date)
			end
		end

feature -- Templates
	company_template : COMPANY
		do
		end

feature -- Constants
	weight_label : STRING is "weights"

	share_label : STRING is "shares"

end
