indexing
	description: "Embeds ADSTYPEENUM"
	author: "Pierre Nallet"
	date: "$Date: 2009/01/05 $"
	revision: "$Revision: #1 $"
	archive: "$File: //rose/source/Kernel/infrastructure/windows/activedirectory/ad_ads_types.e $"

class
	AD_ADS_TYPES

feature -- Access

	ADSTYPE_INVALID: INTEGER is  0
			-- The data type is invalid.

	ADSTYPE_DN_STRING: INTEGER is  1
			-- The string is of Distinguished Name (path) of a directory service object.

	ADSTYPE_CASE_EXACT_STRING: INTEGER is  2
			-- The string is of the case-sensitive type.

	ADSTYPE_CASE_IGNORE_STRING: INTEGER is  3
			-- The string is of the case-insensitive type.

	ADSTYPE_PRINTABLE_STRING: INTEGER is  4
			-- The string is displayable on screen or in print.

	ADSTYPE_NUMERIC_STRING: INTEGER is  5
			-- The string is of a numeral to be interpreted as text.

	ADSTYPE_BOOLEAN: INTEGER is  6
			-- The data is of a Boolean value.

	ADSTYPE_INTEGER: INTEGER is  7
			-- The data is of an integer value.

	ADSTYPE_OCTET_STRING: INTEGER is  8
			-- The string is of a byte array.

	ADSTYPE_UTC_TIME: INTEGER is  9
			-- The data is of the universal time as expressed in Universal Time Coordinate (UTC).

	ADSTYPE_LARGE_INTEGER: INTEGER is  10
			-- The data is of a long integer value.

	ADSTYPE_PROV_SPECIFIC: INTEGER is  11
			-- The string is of a provider-specific string.

	ADSTYPE_OBJECT_CLASS: INTEGER is  12
			-- Not used.

	ADSTYPE_CASEIGNORE_LIST: INTEGER is  13
			-- The data is of a list of case insensitive strings.

	ADSTYPE_OCTET_LIST: INTEGER is  14
			-- The data is of a list of octet strings.

	ADSTYPE_PATH: INTEGER is  15
			-- The string is of a directory path.

	ADSTYPE_POSTALADDRESS: INTEGER is  16
			-- The string is of the postal address type.

	ADSTYPE_TIMESTAMP: INTEGER is  17
			-- The data is of a time stamp in seconds.

	ADSTYPE_BACKLINK: INTEGER is  18
			-- The string is of a back link.

	ADSTYPE_TYPEDNAME: INTEGER is  19
			-- The string is of a typed name.

	ADSTYPE_HOLD: INTEGER is  20
			-- The data is of the Hold data structure.

	ADSTYPE_NETADDRESS: INTEGER is  21
			-- The string is of a net address.

	ADSTYPE_REPLICAPOINTER: INTEGER is  22
			-- The data is of a replica pointer.

	ADSTYPE_FAXNUMBER: INTEGER is  23
			-- The string is of a fax number.

	ADSTYPE_EMAIL: INTEGER is  24
			-- The data is of an e-mail message.

	ADSTYPE_NT_SECURITY_DESCRIPTOR: INTEGER is  25
			-- The data is of Windows NT/Windows 2000 security descriptor as represented by a byte array.

	ADSTYPE_UNKNOWN: INTEGER is  26
			-- The data is of an undefined type.

	ADSTYPE_DN_WITH_BINARY: INTEGER is  27
			-- The data is of ADS_DN_WITH_BINARY used for mapping a distinguished name to a non varying GUID.

	ADSTYPE_DN_WITH_STRING: INTEGER is  28
			-- The data is of ADS_DN_WITH_STRING used for mapping a distinguished name to a non-varying string value.

end
