indexing
	description: "Encapsulation of the ADSVALUE structure, this should not be used directly"
	author: "Pierre Nallet"
	date: "$Date: 2009/01/05 $"
	revision: "$Revision: #1 $"
	archive: "$File: //rose/source/Kernel/infrastructure/windows/activedirectory/ad_adsvalue.e $"

class
	AD_ADSVALUE

inherit
	COM_STRUCTURE

create
	default_create

feature -- Access

	structure_size: INTEGER_32 is
			-- Size in bytes of the ADSVALUE structure
		do
			Result := sizeofadsvalue
		end

feature -- Basic operations

	set_type (a_type: INTEGER_32) is
			-- Set the type of the value. The type is an enum of type ADS_SEARCHPREF_ENUM
		do
			set_integer_value (a_type, offsetofdwtype)
		end

	set_integer (a_value: INTEGER_32) is
			-- Set the value of the structure to an integer value
		do
			set_integer_value (a_value, offsetofboolean)
		end

feature {NONE} -- Implementation

	sizeofadsvalue: INTEGER_32 is
			-- Size in bytes of the ADSVALUE structure
		external
			"C blocking macro use <Iads.h>"
		alias
			"sizeof (ADSVALUE)"
		end

	offsetofdwtype: INTEGER_32 is
			-- Offset of the dwType field in ADSVALUE
		external
			"C blocking macro use <Iads.h>"
		alias
			"offsetof (ADSVALUE, dwType)"
		end

	offsetofboolean: INTEGER_32 is
			-- Offset of the Boolean field in ADSVALUE
		external
			"C blocking macro use <Iads.h>"
		alias
			"offsetof (ADSVALUE, Boolean)"
		end

end
