indexing
	description: "Encapsulation of an active directory entry"
	author: ""
	last_editor: "$Author: er $"
	date: "$Date: 2014/02/26 $"
	revision: "$Revision: #3 $"
	archive: "$File: //rose/source/kernel/infrastructure/windows/activedirectory/ad_any.e $"

class
	AD_ANY

inherit
	HASHABLE

feature {NONE} -- Initialization

	make_with_path (a_path: STRING) is
			-- Initialize by creating `entry' from `a_path'.
		do
			create entry.make_with_path (a_path)
		end

	make_with_entry (a_entry: like entry) is
			-- Initialize using `a_entry' for `entry'
		do
			entry := a_entry
		ensure
			entry_set: entry = a_entry
		end

feature -- Access

	entry: AD_DIRECTORY_ENTRY
		-- Associated Active Directory entry

	name: STRING is
			-- Name of the entry
		local
			l_name_saved: STRING
		do
			if name_saved = Void then
				l_name_saved:= entry.property ("name").out
				if l_name_saved /= Void then
					name_saved := l_name_saved
				end
			end
			Result := name_saved
		end

	path: STRING
		-- Path of the entry
		do
			Result := entry.path
		end

feature -- Comparison

	hash_code: INTEGER is
			-- <Precursor>
		do
			if path /= Void then
				Result := path.hash_code
			end
		end

feature {NONE} -- Implementation

	name_saved: STRING
			-- Cache for the name


end
