indexing
	description: "Represents a search column for Acitve Directory searches"
	author: "Pierre Nallet"
	date: "$Date: 2009/01/05 $"
	revision: "$Revision: #1 $"
	archive: "$File: //rose/source/Kernel/infrastructure/windows/activedirectory/ad_search_column.e $"

class
	AD_SEARCH_COLUMN

inherit
	COM_STRUCTURE
	COM_STRING_FUNCTIONS
		undefine
			is_equal
		end
	AD_ADS_TYPES
		undefine
			is_equal
		end

create
	make

feature {NONE} -- Implementation

	make is
		do
			item := calloc (structure_size, 1)
		end

feature -- Access

	type: INTEGER is
			-- Search type
		do
			Result := get_type (item)
		end

	value: ANY is
			-- Search value
		do
			inspect (type)
			when ADSTYPE_CASE_IGNORE_STRING then
				Result := widechar_to_string (get_case_ignore_string (get_values (item)))
			else
				print ("not implemented")
			end
		end

feature {NONE} -- Implementation

	structure_size: INTEGER is
		external
			"C blocking macro use <Iads.h>"
		alias
			"sizeof(ADS_SEARCH_COLUMN)"
		end

	get_type (p: POINTER): INTEGER is
			-- Access field x of struct pointed by `p'.
		external
			"C [struct <iads.h>] (ADS_SEARCH_COLUMN): EIF_INTEGER"
		alias
			"dwADsType"
		end

	get_case_exact_string (p: POINTER): POINTER is
			-- Access field x of struct pointed by `p'.
		external
			"C [struct <iads.h>] (ADSVALUE): EIF_POINTER"
		alias
			"CaseExactString"
		end

	get_case_ignore_string (p: POINTER): POINTER is
			-- Access field x of struct pointed by `p'.
		external
			"C [struct <iads.h>] (ADSVALUE): EIF_POINTER"
		alias
			"CaseIgnoreString"
		end

	get_values (p: POINTER): POINTER is
		external
			"C [struct <iads.h>] (ADS_SEARCH_COLUMN): EIF_POINTER"
		alias
			"pADsValues"
		end

end
