note
	description: "Adjustment interval"
	author: "Michael Zhang"
	last_editor: "$Author: myeager $"
	date: "$Date: 2014/11/14 $"
	revision: "$Revision: #10 $"
	path: "$File: //rose/source/kernel/data/market/adjustment_interval.e $"

class
	ADJUSTMENT_INTERVAL[G->ENTITY]

inherit
	ROSE_CLOSED_INTERVAL[G]
		rename
			make as rose_make,
			item as entity
		redefine
			debug_output
		end

create
	make,
	rose_make

feature -- creation

	make(a_entity : like entity; a_start_date, a_end_date : ROSE_DATE; a_adjustment, a_split_factor : DOUBLE) is
			--making an adjustment
		require
			ordered_dates: a_end_date >= a_start_date
		do
			rose_make (a_entity, a_start_date, a_end_date, weight)
			adjustment := a_adjustment
			split_factor := a_split_factor
		end

	adjustment : DOUBLE
	split_factor : DOUBLE

feature -- Settings

	set_adjustment (a_value: DOUBLE) is
			-- sets adjustment
		require
			positive_adjustment: a_value > 0
		do
			adjustment := a_value
		end

	set_split_factor (a_value: DOUBLE) is
			-- sets split factor
		require
			positive_split: a_value > 0
		do
			split_factor := a_value
		end

feature -- Debug

	debug_output : STRING is
			-- debugging output
		do
			Result:= start_date.ccyymmdd.out + " : " + end_date.ccyymmdd.out + " : " + split_factor.out + " : " + adjustment.out
		end
end
