indexing
	description: "Predicate with ARRAY [ANY] as vessel"
	author : "Mark Howard"
	date: "$Date: 2009/02/10 $"
	revision: "$Revision: #19 $"
	archive: "$File: //rose/source/kernel/infrastructure/persistence/predicates/anonymous_predicate.e $"

class
	ANONYMOUS_PREDICATE

inherit
	SELECTION_PREDICATE [ARRAY [ANY]]
		redefine
			new_vessel
		end

create
	make_using_server,
	make_using_server_with_parameter_template

feature {NONE} -- Initialization

	make_using_server (a_server: DATA_SERVER; a_selection: STRING) is
			-- Make from a server and selection
		do
			make_using_server_with_parameter_template (a_server,a_selection, Void)
		end

	make_using_server_with_parameter_template (a_server: DATA_SERVER; a_selection: STRING; a_parameter_template: ARRAY [STRING]) is
		require
			a_server_not_void: a_server /= Void
		local
			l_array: ARRAY [ANY]
			l_fac_output_count: INTEGER
		do
			debug("make_movies")
				create cam.make(generating_type + "/" + a_selection + "/" + a_server.node + "/" + a_server.database)
			end

			server := a_server
			set_selection (server,a_selection, a_parameter_template)

			if playback_movie
			then
				l_fac_output_count :=cam. next_frame("make_using_server_with_parameter_template").frame_data_as_integer
				cam.compare_not_needed
			else
				if (facilitator.output /= Void) then
					l_fac_output_count := facilitator.output.count
				end
			end

			debug("make_movies")
				if record_movie
				then
					cam.record_integer_movie_frame("make_using_server_with_parameter_template", l_fac_output_count)
				end
			end

			create l_array.make (1,l_fac_output_count )
			set_template (l_array)
			create array.make_empty
			set_container (array)
	end

feature -- Access

	array: EXTENDABLE_BOUNDED_ARRAY [ARRAY [ANY]]
	server: DATA_SERVER

	new_vessel: like empty_vessel is
		do
			create Result.make(1,empty_vessel.count)
		end

feature -- Basic operations

	retrieve_committed (a_object: ANY; a_arguments: ARRAY [ANY]) is
		do
			retrieve (a_object, a_arguments)
			data_server.commit
		end

end -- class ANONYMOUS_PREDICATE
