indexing

	description:

		"Access to shared contexts"

	author: "Mark Howard"
	last_editor: "$Author: c4 $"
	date: "$Date: 2011/03/31 $"
	revision: "$Revision: #8 $"
	path: "$File: //rose/source/kernel/entities/aware.e $"

deferred class AWARE

inherit

	CONTEXT_AWARE

feature -- Access

	research_context_preferred (a_supplier_id: INTEGER_32): SUPPLIER_CONTEXT is
			-- Preferred context for `a_supplied_id';
			-- A suitable function to pass as the second argument to `entity_from_uid',
			--  preferring {RESEARCH_CONTEXT} when ambiguous
		local
			l_research: SUPPLIER_CONTEXT
		do
			l_research := existing_context_from_name ("RESEARCH")
			if l_research /= Void and then a_supplier_id = l_research.supplier_id then
				Result := l_research
			else
				Result := context_from_supplier_id (a_supplier_id) 
			end
		end

	entity_from_uid (a_uid: INTEGER_64; a_context_mapper: FUNCTION [ANY, TUPLE [INTEGER_32], SUPPLIER_CONTEXT]): ENTITY is
			-- Entity (if any) corresponding to `a_uid'
		require
			a_context_mapper_not_void: a_context_mapper /= Void
		local
			l_context: SUPPLIER_CONTEXT
			l_category_id: INTEGER
		do
			l_context := a_context_mapper.item ([(a_uid.bit_and (0xFFFF000000000000) |>> 48).to_integer_32])
			if l_context /= Void then
				l_category_id := (a_uid.bit_and (0x0000FFFF00000000) |>> 32).to_integer_32
				if attached {CATEGORY_HANDLER [SUPPLIER_CONTEXT, ENTITY]} l_context.handler (l_category_id) as l_handler then
					Result := l_handler.entity_from_uid (a_uid)
				end
			end
		ensure
			correct_uid: (Result /= Void) implies Result.uid = a_uid
		end

end
