class C_ACCESS_SUPPORT

inherit
	ACCESS_EXTERNALS

feature

    copy_to_pointer_with_fill(dst_:POINTER;
			      src_:POINTER;
			      dst_length:INTEGER;
			      src_length:INTEGER;
			      fill:INTEGER) is
	    -- Copy up to 'dst_length' bytes from 'src_' to 'dst_'.
	    -- If 'src_length' is smaller than 'dst_length' then fill the
	    -- excess bytes with 'fill'.
	local
		copy_count : INTEGER
		fill_count : INTEGER
	do
		if src_length >= dst_length
		then
			copy_count := dst_length
			fill_count := 0
		else
			copy_count := src_length
			fill_count := dst_length - copy_count
		end

		copy_to_pointer(dst_, src_, copy_count)

		if fill_count > 0
		then
--			c_memset(pointer_plus(dst_, copy_count), fill, fill_count)
			pointer_plus (dst_, copy_count).memory_set (fill, fill_count)
		end
	end;

end -- class C_ACCESS_SUPPORT
