indexing
	description : "[
		Predates MANAGED_POINTER ... perhaps should be replaced
		]"
	author : "Mark Howard"

deferred class	C_POINTER

inherit

	ROSE_C_LIBRARY

feature -- Access

	c_data: POINTER is
		deferred
		end

	deref_int: INTEGER is
		do
			Result := dereference_integer (c_data)
		end
	deref_real: REAL is
		do
			Result := dereference_real (c_data)
		end
	deref_double: DOUBLE is
		do
			Result := dereference_double (c_data)
		end
	deref_character: CHARACTER is
		do
			Result := dereference_character (c_data)
		end
	deref_short: INTEGER is
		do
			Result := short_pointer_to_integer (c_data)
		end
	deref_boolean: BOOLEAN is
		do
			Result := dereference_boolean (c_data)
		end
	deref_pointer: POINTER is
		do
			Result := dereference_pointer (c_data)
		end
	deref_vms_integer: INTEGER is
		do
			Result := c_vms_integer (c_data)
		end
	deref_vms_short: INTEGER is
		do
			Result := c_vms_short (c_data)
		end

feature -- Basic operations

	put_integer (a_arg: INTEGER) is
		do
			copy_to_pointer (c_data,$a_arg,4)
		end
	put_real (a_arg: REAL) is
		do
			copy_to_pointer (c_data,$a_arg,4)
		end
	put_double (a_arg: DOUBLE) is
		do
			copy_to_pointer (c_data,$a_arg,8)
		end
	put_character (a_arg: CHARACTER) is
		do
			copy_to_pointer (c_data,$a_arg,1)
		end
	put_short (a_arg: INTEGER) is
		do
			integer_to_short_pointer (c_data,a_arg)
		end
	put_boolean (a_arg: BOOLEAN) is
		do
			copy_to_pointer (c_data,$a_arg,4)
		end
	put_string (a_arg: STRING) is
		local
			area: C_STRING;
		do
			create area.make (a_arg)
			copy_to_pointer (c_data, area.item,a_arg.count)
		end
	put_pointer (a_arg: POINTER) is
		do
			copy_to_pointer (c_data,$a_arg,4)
		end

feature {NONE} -- Implementation

	copy_from_pointer (a_target: POINTER; a_source: POINTER; a_length: INTEGER) is
		do
			a_target.memory_copy (a_source, a_length)
		end
	copy_to_pointer (a_target: POINTER; a_source: POINTER; a_length: INTEGER) is
		do
			a_target.memory_copy (a_source, a_length)
		end
	pointer_plus (a_pointer: POINTER; a_offset: INTEGER): POINTER is
		do
			Result := a_pointer + a_offset
		end
	c_pointer_plus (a_pointer: POINTER; a_offset: INTEGER): POINTER is
		do
			Result := a_pointer + a_offset
		end

end
