indexing
	description: "rose capital action expression: non-renounceable bonus in other instrument given out"
	author: "Janet Small"
	date: "$Date: 2009/11/06 $"
	revision: "$Revision: #11 $"
	archive: "$File: //rose/source/kernel/capital_actions/expressions/capact_bonus_in_other_expression.e $"

class
	CAPACT_BONUS_IN_OTHER_EXPRESSION

inherit
	CAPACT_DEFAULT_EXPRESSION

	CAPACT_BONUS_IN_OTHER
		rename
			signature as target, exdate as integer_exdate, name as template_name
		undefine
			default_create
		end

create
	make,instantiate,make_empty


feature -- creation

	instantiate (a_target: CAPACT_SIGNATURE_RECORD) is
			-- populate expression from storage
		do
			target := a_target
			set_signature(a_target)
			instantiate_all
			delta_new_shares := new_shares_rate
			rmdat_adjustment_factor := 1
		end

	processing_instruction (
		a_basis: RP_CORPORATE_ACTION_PROCESSING_SHARE_BASIS_TYPE;
		a_processing_system: RP_CORPORATE_ACTION_PROCESSING_SYSTEM): !RP_CORPORATE_ACTION_PROCESSING_INSTRUCTIONS is
			-- processing corp action instruction
		do
	    	Result := a_processing_system.bonus_in_other_instructions (a_basis, Current)
		end

feature -- Access

	name: STRING is
			-- name with component expression string for display in capact brorwser
		do
			Result := "BONUS IN OTHER" + ": F" + target.member_number.out
		end

	other_instrument (a_reference_system: RP_REFERENCE_SYSTEM): RP_INSTRUMENT is
			-- Capact other instrument
		require
			reference_system_not_void: a_reference_system /= Void
		do
			Result := a_reference_system.instrument_from_brimsym (other_entity.brim_code (exdate))
		end

	bonus  (a_reference_system: RP_REFERENCE_SYSTEM) : RP_QUANTITY is
			-- -- Capact delta shares
		do
			Result := other_instrument (a_reference_system).quantity (delta_new_shares)
		end

end
