note

	description:

		"rose capital action expression: non-renounceable bonus in parent instrument"

	author: "Janet Small"
	last_editor: "$Author: it $"
	date: "$Date: 2012/05/22 $"
	revision: "$Revision: #15 $"
	path: "$File: //rose/source/kernel/capital_actions/expressions/capact_bonus_in_same_expression.e $"

class
	CAPACT_BONUS_IN_SAME_EXPRESSION
inherit
	CAPACT_BONUS_IN_SAME
		rename
			signature as target, exdate as integer_exdate, name as template_name
		undefine
			default_create
		end
	CAPACT_EXPRESSION
	CAPACT_COMMON
			undefine default_create end
create
	make,
	instantiate,make_empty

feature {NONE} -- creation

	instantiate (a_target: CAPACT_SIGNATURE_RECORD) is
			-- populate expression from storage
		do
			set_expression_index
			target := a_target
			set_signature(a_target)
			instantiate_all
			delta_new_shares := new_shares_rate
			rmdat_adjustment_factor := new_shares_rate + 1
		end

feature -- Access

	processing_instruction (
		a_basis: RP_CORPORATE_ACTION_PROCESSING_SHARE_BASIS_TYPE;
		a_processing_system: RP_CORPORATE_ACTION_PROCESSING_SYSTEM): RP_CORPORATE_ACTION_PROCESSING_INSTRUCTIONS is
			-- processing corp action instruction
		do
	    	create Result.make (a_basis, create {RP_SIMPLE_CORPORATE_ACTION}.make (exdate, a_processing_system.bonus_in_same_instructions (Current)))
		end

	cash_inflow(a_currency : CURRENCY) : DOUBLE is
			-- cash into portfolio as a result of capital action
		do
			Result := 0
		end

	cash_outflow(a_currency : CURRENCY)  :DOUBLE is
			-- cash out of portfolio as a result of capital action
		do
			Result := 0
		end

	cash_dividend(a_currency : CURRENCY) : DOUBLE is
			-- dividend to porfolio as a result of capital action
		do
			Result := 0
		end

	name : STRING is
			-- name with component expression string for display in capact browser
		do
			Result := template_name + " F"+ target.member_number.out
		end

	cash_rate : DOUBLE is
			-- does it make sense to define this here?
		do
			Result := undefined_double
		end

	cash_currency_iso : STRING is
			-- iso of cash currency, not relevant to this capital action
		do
			Result := Void
		end

	adjustment_factor : DOUBLE is
			-- This may be redundant
		do
			Result := rmdat_adjustment_factor
		end

	share_factor : DOUBLE is
			-- not defined for bonus in same
		do
			Result := undefined_double
		end

	subscription_price : DOUBLE is
			-- not defined for bonus in same
		do
			Result := undefined_double
		end

	child_units : DOUBLE is
			-- not defined for bonus in same
		do
			Result := undefined_double
		end

	legacy_basis_prop : DOUBLE is
		-- not defined for bonus in same	
		do
			Result := undefined_double
		end

	legacy_basis_price : DOUBLE is
		-- not defined for bonus in same
			do
			Result := undefined_double
		end

	split_rate : DOUBLE is
			-- not defined for bonus in same
		do
			Result := undefined_double
		end

	dividend_rate : DOUBLE is
			-- not defined for bonus in same
		do
			Result := undefined_double
		end

	legacy_basis_currency : STRING is
			-- legacy basis currency
		do
			Result := Void
		end

end
