note

	description:

		"rose capital action expression: capital return of casht"

	author: "Srilatha Singh"
	last_editor: "$Author: it $"
	date: "$Date: 2012/05/22 $"
	revision: "$Revision: #26 $"
	path: "$File: //rose/source/kernel/capital_actions/expressions/capact_capital_return_of_cash_expression.e $"

class
	CAPACT_CAPITAL_RETURN_OF_CASH_EXPRESSION
inherit
	CAPACT_RETURN_EXPRESSION
	rename
		instantiate_data as return_instantiate_data
	end
	CAPACT_CAPITAL_RETURN_OF_CASH
	rename
		signature as target, exdate as integer_exdate, name as template_name
	undefine
		default_create
	end

create
	make,
	instantiate,make_empty

feature {NONE} -- creation

	instantiate (a_target: CAPACT_SIGNATURE_RECORD) is
			-- Populate from storate
		do
			set_expression_index
			target := a_target
			set_signature(a_target)
			instantiate_all
			rmdat_adjustment_factor := 1
		end

feature -- Access

	processing_instruction (
		a_basis: RP_CORPORATE_ACTION_PROCESSING_SHARE_BASIS_TYPE;
		a_processing_system: RP_CORPORATE_ACTION_PROCESSING_SYSTEM): RP_CORPORATE_ACTION_PROCESSING_INSTRUCTIONS is
			-- processing corp action instruction
		do
			create Result.make (a_basis, create {RP_SIMPLE_CORPORATE_ACTION}.make (exdate, a_processing_system.capital_return_of_cash_instructions (Current)))
		end

	name :STRING is
			-- constructed name
		do
			Result := template_name + " F"+ target.member_number.out
		end

	cash_inflow,cash_dividend(a_currency:CURRENCY):DOUBLE is
			-- cash inflow or cash_dividends computed from capital action expressed in input currency
		local
			l_xrate:DOUBLE
		do
			if (a_currency /= Void and cash_currency /= Void) and then a_currency.is_equal(cash_currency) then
				Result := cash_rate
			else
				if cash_currency = Void or exdate = Void then
					Result := undefined_double
				else
					if (a_currency /= Void and cash_currency /= Void) then
						l_xrate := a_currency.exchange_rate (cash_currency, exdate)
						if legacy_undefined.is_defined_double(l_xrate) then
							Result := cash_rate*l_xrate
						else
							Result := undefined_double
						end
					else
						Result := undefined_double
					end
				end
			end
			Result := cash_dividend_value (Current, Result)
		end

	cash_outflow(a_currency:CURRENCY):DOUBLE is
			-- no cash outflow for this type of capital action
		do
			Result := 0
		end

	adjustment_factor : DOUBLE is
			-- This may be redundant
		do
			Result := rmdat_adjustment_factor
		end

	legacy_basis_currency : STRING is
			-- base currency
		do
			Result := Void
		end

	share_factor : DOUBLE is
			-- share factor
		do
			Result := undefined_double
		end

	bonus_rate : DOUBLE is
			-- bonus rate
		do
			Result := undefined_double
		end

	subscription_price : DOUBLE is
			-- subscription price
		do
			Result := undefined_double
		end

	child_units : DOUBLE is
			-- undefined for that capact
		do
			Result := undefined_double
		end

	legacy_basis_prop : DOUBLE is
			-- undefined for that capact
		do
			Result := undefined_double
		end

	legacy_basis_price : DOUBLE is
			-- legacy basis price
		do
			Result := undefined_double
		end

	dividend_rate : DOUBLE is
			-- dividend rate
		do
			Result := undefined_double
		end

	split_rate : DOUBLE is
			-- split rate
		do
			Result := undefined_double
		end

end -- class CAPACT_CAPITAL_RETURN_OF_CASH_EXPRESSION
