indexing

	description:

		"Cash Dividend CA template"

	date: "$Date: 2010/02/05 $"
	sccid: "$Id: //rose/source/kernel/capital_actions/capact_cash_dividend_template.e#6 $"

class CAPACT_CASH_DIVIDEND_TEMPLATE

inherit

	CAPITAL_ACTION_TEMPLATE

	CAPACT_INCOME_LIKE

	CAPACT_COMMON
		export {NONE} all end

feature -- Access

	name: STRING is "CASH DIVIDEND"
			-- CA name

	capital_action_type_id: INTEGER is 1

	cash_rate: DOUBLE 
			-- Cash rate

	legacy_cash_adj: DOUBLE
			-- Cash adjusment used for Canadian securities in legacy

	set_cash_rate (a_value: like cash_rate) is
			-- Set `cash_rate' to `a_value'
		do
			cash_rate := a_value
		ensure
			cash_rate_set: cash_rate = a_value
		end

	set_legacy_cash_adj (a_value: like legacy_cash_adj) is
			-- Set legacy cash rate
		do
			legacy_cash_adj := a_value
		ensure
			cash_adj_set: legacy_cash_adj = a_value
		end

	cash_currency: CURRENCY
			-- cash currency

	set_cash_currency (a_value: like cash_currency) is
			-- sets cash currency
		do
			cash_currency := a_value
		end

	cash_currency_iso: STRING

	set_cash_currency_iso (a_value: like cash_currency_iso) is
			--
		do
			cash_currency_iso := a_value
		end

	lotsize: INTEGER

	set_lotsize (a_value: like lotsize) is
			--
		do
			lotsize := a_value
		end

end -- class CAPACT_CASH_DIVIDEND_TEMPLATE
