note

	description:

	"[
		Value of cash dividend
	]"

	author: "Ivan Tarnavsky"
	last_editor: "$Author: it $"
	date: "$Date: 2014/02/05 $"
	revision: "$Revision: #4 $"
	path: "$File: //rose/source/kernel/capital_actions/expressions/capact_cash_dividend_value.e $"

deferred class CAPACT_CASH_DIVIDEND_VALUE

inherit

	CAPACT_SHARED_CASH_DIVIDEND_VALUE_CONTROL

feature -- Access

	cash_dividend (a_currency: CURRENCY): DOUBLE is
			-- Cash dividend value in `a_curreny'
		require
			a_currency_not_void: a_currency /= Void
		deferred
		end

	cash_dividend_value (a_capact: CAPACT_CAPITAL_ACTION; a_cash_dividend: DOUBLE): DOUBLE is
			-- 0.0 when `a_capact' is special dividend and they are ignored
			-- `a_cash_dividend' otherwise
	 	do
	 		Result := a_cash_dividend
	 		if dividend_value_control.is_ignoring_special_dividends and then dividend_value_control.is_special_dividend (a_capact) then
	 			Result := 0.0
	 		end
	 	ensure
	 		zero_when_ignoring_and_is_special: (dividend_value_control.is_ignoring_special_dividends and then dividend_value_control.is_special_dividend (a_capact)) implies Result ~ Result.zero
	 		a_cash_dividend_otherwise: ((not dividend_value_control.is_ignoring_special_dividends) or else (not dividend_value_control.is_special_dividend (a_capact))) implies Result ~ a_cash_dividend
	 	end

end
