indexing

	description:

		"Data items for CAs that change # of shares"

	date: "$Date: 2009/11/17 $"
	sccid: "$Id: //rose/source/kernel/capital_actions/capact_change_of_shares_template.e#7 $"

deferred class CAPACT_CHANGE_OF_SHARES_TEMPLATE

inherit

	CAPITAL_ACTION_TEMPLATE

feature -- Access

	split_rate: RP_DECIMAL assign set_split_rate is
			-- Split rate
		do
			if split_rate_saved = Void then
				set_split_rate (0)
			end
			Result := split_rate_saved
		end

	lotsize: INTEGER
			-- Lot size

	in_lieu_cash_rate: RP_DECIMAL assign set_in_lieu_cash_rate is
			-- In lieu cash rate
		do
			if in_lieu_cash_rate_saved = Void then
				set_in_lieu_cash_rate (0)
			end
			Result := in_lieu_cash_rate_saved
		end

	in_lieu_cash_currency: CURRENCY
			-- In lieu cash currency

	in_lieu_cash_currency_iso: STRING
			-- In lieu cash currency ISO code

	affects_par_value: BOOLEAN
			-- Whether share par value is affected

feature -- Change

	set_split_rate (a_value: like split_rate) is
			-- Set split rate
		do
			split_rate_saved := a_value
		ensure
			split_rate_set: split_rate.is_equal (a_value)
		end

	set_lotsize (a_value: like lotsize) is
			-- Set lot size
		do
			lotsize := a_value
		ensure
			lotsize_set: lotsize = a_value
		end

	set_in_lieu_cash_rate (a_value: like in_lieu_cash_rate) is
			-- Set in lieu cash rate
		do
			in_lieu_cash_rate_saved := a_value
		ensure
			in_lieu_cash_rate_set: in_lieu_cash_rate.is_equal (a_value)
		end

	set_in_lieu_cash_currency (a_value: like in_lieu_cash_currency) is
			-- Set in lieu cash currency
		do
			in_lieu_cash_currency := a_value
		ensure
			in_lieu_cash_currency_set: in_lieu_cash_currency = a_value
		end

	set_in_lieu_cash_currency_iso (a_value: like in_lieu_cash_currency_iso) is
			-- Set in lieu cash currency iso
		do
			in_lieu_cash_currency_iso := a_value
		end

	set_affects_par_value (a_value: like affects_par_value) is
			-- Set affect part value
		do
			affects_par_value := a_value
		end

feature {NONE} -- Implementation

	split_rate_saved: like split_rate
		-- Implementation of the split rate to avoid void references

	in_lieu_cash_rate_saved: like in_lieu_cash_rate
		-- Implementation of the in_lieu_cash_rate to avoid void references

invariant

	split_rate_not_void: split_rate /= Void

	in_lieu_cash_rate_not_void: in_lieu_cash_rate /= Void

end -- class CAPACT_CHANGE_OF_SHARES_TEMPLATE
