note
	description: "Rose capital actions, shared"
	author: "Janet Small"
	last_editor: "$Author: bn $"
	date: "$Date: 2014/02/19 $"
	revision: "$Revision: #11 $"
	path: "$File: //rose/source/kernel/capital_actions/capact_common.e $"

deferred class CAPACT_COMMON

inherit

	DATABASE_SERVER
		export {NONE} all end

	ROSE_LEGACY_UNDEFINED
		export {NONE} all end

	ROSE_ENTITY_FOREGROUND_AWARE
		rename
			context as rose_context
		undefine
			copy,
			default_create
		end

feature -- capact type names

	stock_dividend_string: STRING is "STOCK DIVIDEND"

	stock_dividend_in_other_string: STRING is "STOCK DIVIDEND IN OTHER"

	exercise_of_rights_string: STRING is "EXERCISE OF RIGHTS"

	cash_return_of_capital_string: STRING is "CAPITAL RETURN OF CASH"

	return_share_premium_string: STRING is "RETURN SHARE PREMIUM"

	legacy_distribution_string: STRING is "LEGACY DISTRIBUTION"

	bonus_in_other_string: STRING is "BONUS IN OTHER (NON-RENOUNCEABLE)"

	renounceable_bonus_in_same_string: STRING is "RENOUNCEABLE BONUS IN SAME"

	renounceable_bonus_in_other_string: STRING is "RENOUNCEABLE BONUS IN OTHER"

	rights_in_same_string: STRING is "RIGHTS IN SAME"

	rights_in_other_string: STRING is "RIGHTS IN OTHER"

	renounceable_rights_in_same_string: STRING is "RENOUNCEABLE RIGHTS IN SAME"

	renounceable_rights_in_other_string: STRING is "RENOUNCEABLE RIGHTS IN OTHER"

	writeup_of_capital_string: STRING is "WRITE-UP OF CAPITAL"

	writedown_of_capital_string: STRING is "WRITE-DOWN OF CAPITAL"

	public_offering_string: STRING is "PUBLIC OFFERING"

	preliminary_subscription_string: STRING is "PRELIMINARY SUBSCRIPTION"

	redenomination_string: STRING is "REDENOMINATION"

	renominalization_string: STRING is "RENOMINALIZATION"

	call_payment_string: STRING is "CALL PAYMENT"

	additive_expression_string: STRING is
			-- name for additive expression	
		once
			Result := "ADDITIVE EXPRESSION"
		end

	cash_rate_string: STRING is
			-- Why is this not a constant?
		once
			Result := "cash_rate"
		end

feature {CAPACT_COMMON} -- Implementation

	capact_server (a_zone: STRING): SQL_DATA_SERVER is
			-- Zonal capact sql server
		require
			has_zone: a_zone /= Void
		local
			l_zone: STRING
		do
			l_zone := a_zone.as_upper
			if l_zone.is_equal ("U") then
				Result := servers.rose_capital_action_U_server
			elseif l_zone.is_equal ("C") then
				Result := servers.rose_capital_action_C_server
			elseif l_zone.is_equal ("J") then
				Result := servers.rose_capital_action_J_server
			elseif l_zone.is_equal ("E") then
				Result := servers.rose_capital_action_E_server
			elseif l_zone.is_equal ("O") then
				Result := servers.rose_capital_action_O_server
			elseif l_zone.is_equal ("S") then
				Result := servers.rose_capital_action_S_server
			end
			Result.set_implicit_transaction_on
		end

end
