note

	description:

		"Compound expression"

	author: "mk"
	last_editor: "$Author: it $"
	date: "$Date: 2012/05/22 $"
	revision: "$Revision: #18 $"
	path: "$File: //rose/source/kernel/capital_actions/expressions/capact_compound_expression.e $"

class

	CAPACT_COMPOUND_EXPRESSION
inherit
	CAPACT_EXPRESSION
	CAPACT_COMMON
			undefine default_create end
create
	make_with_expressions

feature {NONE} -- Initialization

	make_with_expressions(a_inner,a_outer:CAPACT_EXPRESSION) is
			-- Create with 'a_inner' and 'a_outer' expressions
		require
			inner_expression_not_void: a_inner /= Void
			outer_expression_not_void: a_outer /= Void
		do
			set_expression_index
			inner_expression := a_inner
			outer_expression := a_outer
			if inner_expression.rmdat_adjustment_factor_available and outer_expression.rmdat_adjustment_factor_available then
				rmdat_adjustment_factor := outer_expression.rmdat_adjustment_factor * inner_expression.rmdat_adjustment_factor
			else
				rmdat_adjustment_factor := undefined_double
			end
		ensure
			inner_expression_set: inner_expression = a_inner
			outer_expression_set: outer_expression = a_outer
		end

feature -- Access

	processing_instruction (
		a_basis: RP_CORPORATE_ACTION_PROCESSING_SHARE_BASIS_TYPE;
		a_corporate_action_processing_system: RP_CORPORATE_ACTION_PROCESSING_SYSTEM): RP_CORPORATE_ACTION_PROCESSING_INSTRUCTIONS is
			-- processing instructions for the corp action - no processing
		do
		end

	inner_expression:CAPACT_EXPRESSION

	outer_expression :CAPACT_EXPRESSION

	name : STRING is
			-- Name
		do
			Result := outer_expression.name + " following " + 	inner_expression.name
		end

	cash_outflow(a_currency:CURRENCY):DOUBLE is
		do
			if is_defined_double (outer_expression.cash_outflow (a_currency)) and
			   is_defined_double (inner_expression.cash_outflow(a_currency)) then
				Result := (outer_expression.cash_outflow(a_currency))* inner_expression.rmdat_adjustment_factor + inner_expression.cash_outflow(a_currency)
			end
		end

	cash_inflow(a_currency:CURRENCY):DOUBLE is
		do
			if is_defined_double (outer_expression.cash_inflow (a_currency)) and
			   is_defined_double (inner_expression.cash_inflow(a_currency)) then
				Result := outer_expression.cash_inflow(a_currency)*inner_expression.rmdat_adjustment_factor + inner_expression.cash_inflow(a_currency)
			end
		end

	cash_dividend(a_currency:CURRENCY):DOUBLE is
		do
			if is_defined_double (outer_expression.cash_dividend (a_currency)) and
			   is_defined_double (inner_expression.cash_dividend(a_currency)) then
				Result := outer_expression.cash_dividend(a_currency)*inner_expression.rmdat_adjustment_factor + inner_expression.cash_dividend(a_currency)
			end
		end

feature--capact_capital_action

	instantiate_data is
		do

		end

	template_name:STRING  is "COMPOUND EXPRESSION"

	set_data_items is
		do

		end

	update_data_items is
		do

		end

	adjustment_factor : DOUBLE is
			-- This may be redundant
		do
			Result := rmdat_adjustment_factor
		end

end -- class CAPACT_COMPOUND_EXPRESSION
