indexing
	description: "Template fields for Rose capital actions conversion, for bonuses"
	author: "Janet Small"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #3 $"
	archive: "$File: //rose/source/kernel/capital_actions/capact_conversion_template.e $"

deferred class
	CAPACT_CONVERSION_TEMPLATE
inherit
	CAPITAL_ACTION_TEMPLATE
	--inherited by renounceable bonus only
	--dataline : conversion_rate comes from kd_record   = new / old

feature -- Access

	conversion_rate: DOUBLE -- like subscription_rate
	set_conversion_rate (a_value: like conversion_rate) is
			--
		do
			conversion_rate := a_value
		end

	new_shares_conversion: DOUBLE
	set_new_shares_conversion (a_value: like new_shares_conversion) is
			--
		do
			new_shares_conversion := a_value
		end

	old_shares_conversion: DOUBLE
	set_old_shares_conversion (a_value: like old_shares_conversion) is
			--
		do
			old_shares_conversion := a_value
		end



	issue_date: INTEGER
	set_issue_date (a_value: like issue_date) is
			--
		do
			issue_date := a_value
		end


	first_trading_date: INTEGER
	set_first_trading_date (a_value: like first_trading_date) is
			--
		do
			first_trading_date := a_value
		end

	last_trading_date: INTEGER
	set_last_trading_date (a_value: like last_trading_date) is
			--
		do
			last_trading_date := a_value
		end

	last_date_to_convert: INTEGER -- parallels last_date_to_subscribe (in dataline, both from last_renunciation_date)
	set_last_date_to_convert (a_value: like last_date_to_convert) is
			--
		do
			last_date_to_convert := a_value
		end

	call_due_date: INTEGER
	set_call_due_date (a_value: like call_due_date) is
			--
		do
			call_due_date := a_value
		end


feature -- Basic operations

feature {NONE} -- Implementation


end
