indexing
	description: "rose capital actions distributions, renounceable and non-renounceable..."
	author: "Janet Small"
	date: "$Date: 2014/02/26 $"
	revision: "$Revision: #7 $"
	archive: "$File: //rose/source/kernel/capital_actions/capact_distribution.e $"

deferred class
	CAPACT_DISTRIBUTION
inherit
	CAPACT_CAPITAL_ACTION
	CAPACT_DISTRIBUTION_TEMPLATE

feature -- Access

feature -- Basic operations


	instantiate_distribution_data is
		-- retrieve data items from storage
		local
			s: STRING
		do

			s := string_value(new_shares_rate_expression, signature)
			if s /= Void and then s.is_double then
				set_new_shares_rate(s.to_double)
			end

			s := string_value (old_shares_distribution_expression, signature)
			if s /= Void and then s.is_double then
				set_old_shares_distribution(s.to_double)
			end

			s := string_value (new_shares_distribution_expression, signature)
			if s /= Void and then s.is_double then
				set_new_shares_distribution(s.to_double)
			end

			s := string_value( distribution_rate_expression, signature)
			if s /= Void and then s.is_double then
				set_distribution_rate(s.to_double)
			end


-- can these ever change? for now, don't store. Can determine based on child type?
-- for exmaple, child renouneable defines these as True			
--			s := is_tradeable_expression.string_value(signature)
--			if s /= Void and then s.as_upper.is_equal("T")  then
--				set_is_tradeable(True)
--			end	
--			
--			s := is_transferable_expression.string_value(signature)
--			if s /= Void and then s.as_upper.is_equal("T")  then
--				set_is_transferable(True)
--			end	

			-- for backward compatibility with STOCK BONUS (now BONUS IN SAME)
			if new_shares_rate = 0 then
				s := string_value(bonus_rate_expression, signature)
				if s /= Void and then s.is_double then
					set_new_shares_rate(s.to_double - 1)
				end
			end
		end

	set_distribution_data_items is
			--
		local
			l_variable: CAPACT_VARIABLE_DESCRIPTION_ROW
			s: STRING
		do
			if new_shares_rate > 0 then
				l_variable := variable_table.item("NEW_SHARES_RATE")
				s := format_rate.formatted (new_shares_rate)
				string_items.put(s, l_variable.item_id)
			end

			if new_shares_distribution > 0 then
				l_variable := variable_table.item("NEW_SHARES_DISTRIBUTION")
				s := format_rate.formatted (new_shares_distribution)
				string_items.put(s, l_variable.item_id)
			end

			if old_shares_distribution > 0 then
				l_variable := variable_table.item("OLD_SHARES_DISTRIBUTION")
				s := format_rate.formatted (old_shares_distribution)
				string_items.put(s, l_variable.item_id)
			end

			if distribution_rate > 0 then
				l_variable := variable_table.item("DISTRIBUTION_RATE")
				s := format_rate.formatted (distribution_rate)
				string_items.put(s, l_variable.item_id)
			end
--			
--			if distribution_lotsize > 0 then
--				l_variable := variable_table.item("DISTRIBUTION_LOTSIZE")
--				s := format_rate.formatted (distribution_lotsize)
--				string_items.put(s, l_variable.item_id)
--			end
--			
--			if distribution_date > 0 then
--				l_variable := variable_table.item("DISTRIBUTION_DATE")
--				integer_items.put(distribution_date, l_variable.item_id)
--			end

-- can these ever change? for now, don't store. Can determine based on child type?
-- for exmaple, child renouneable defines these as True			

--			if is_tradeable = True then
--				l_variable := variable_table.item("IS_TRADEABLE")
--				string_items.put("T", l_variable.item_id)
--			end
--			
--			if is_transferable = True then
--				l_variable := variable_table.item("IS_TRANSFERABLE")
--				string_items.put("T", l_variable.item_id)
--			end
--
		end

feature  -- Implementation

	new_shares_rate_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			--new shares rate
		once
			Result := ur_target.expression_from_name("NEW_SHARES_RATE")
		end

	old_shares_distribution_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			--
		once
			Result := ur_target.expression_from_name("OLD_SHARES_DISTRIBUTION")
		end

	new_shares_distribution_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			--
		once
			Result := ur_target.expression_from_name("NEW_SHARES_DISTRIBUTION")
		end

	distribution_rate_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			-- Distribution rate expression
		once
			Result := ur_target.expression_from_name("DISTRIBUTION_RATE")
		end

--	distribution_date_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
--			--
--		once
--			Result := ur_target.expression("DISRIBUTION_DATE")
--		end
--	distribution_lotsize_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
--			--
--		once
--			Result := ur_target.expression("DISRIBUTION_LOTSIZE")
--		end
--
--	is_tradeable_expression: ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
--			--
--		once
--			Result := ur_target.expression("IS_TRADEABLE")
--		end
--	is_transferable_expression: ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
--			--
--		once
--			Result := ur_target.expression("IS_TRANSFERABLE")
--		end



feature -- for backward compatability, temporary
	bonus_rate_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			--
		once
			Result := ur_target.expression_from_name("BONUS_RATE")
		end
end
