indexing
	description: "Rose capital action generic exercise of rights (legacy)"
	author: "Janet Small"
	date: "$Date: 2010/04/01 $"
	revision: "$Revision: #11 $"
	archive: "$File: //rose/source/kernel/capital_actions/capact_exercise_rights.e $"

class
	CAPACT_EXERCISE_RIGHTS
inherit
	CAPACT_CAPITAL_ACTION
	CAPACT_EXERCISE_RIGHTS_TEMPLATE

feature  --Modifiers

	set_data_items is
			--set data items
		local
			l_variable: CAPACT_VARIABLE_DESCRIPTION_ROW
			s: STRING
		do

			l_variable := variable_table.item("SHARE_FACTOR")
			s := format_share_factor.formatted (share_factor)
			string_items.put(s, l_variable.item_id)

			l_variable := variable_table.item("CASH_RATE")
			s := format_cash_rate.formatted (cash_rate)
			string_items.put(s, l_variable.item_id)

			if subscription_price > 0 then
				l_variable := variable_table.item("SUBSCRIPTION_PRICE")
				s := format_price.formatted (subscription_price)
				string_items.put(s, l_variable.item_id)
			end

			if cash_currency /= Void then
				l_variable := variable_table.item("CASH_CURRENCY")
				s := cash_currency.iso_code_most_recent_key (constants.now)
				string_items.put(s, l_variable.item_id)
			end
		end

	instantiate_data is
			-- retrieve data items from storage
		local
			s: STRING
			i: INTEGER
			l_curr: CURRENCY
		do

			s :=string_value ( share_factor_expression, signature)
			if s /= Void and then s.is_double then
				set_share_factor(s.to_double)
			end

			s := string_value (cash_rate_expression, signature)
			if s /= Void and then s.is_double then
				set_cash_rate(s.to_double)
			end

			s := string_value (subscription_price_expression, signature)
			if s/= Void and then s.is_double then
				set_subscription_price(s.to_double)
			end

			s := string_value (cash_currency_expression, signature)
			if s /= Void then
				l_curr := rose_context.currency_by_iso_code (s,constants.now)
				if l_curr /= Void then
					set_cash_currency(l_curr)
				end
			end

			--i := lotsize_expression.integer_value (signature)
			if i <= 0 then
				set_lotsize (1)
			end
		end

feature -- expressions

	share_factor_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			--
		once
			Result := ur_target.expression_from_name("SHARE_FACTOR")
		end

	subscription_price_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			--
		once
			Result := ur_target.expression_from_name("SUBSCRIPTION_PRICE")
		end

	cash_rate_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			--
		once
			Result := ur_target.expression_from_name("CASH_RATE")
		end

	cash_currency_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			-- Cash currency expression
		once
			Result := ur_target.expression_from_name("CASH_CURRENCY")
		end

	lotsize_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			-- Lotsize expression
		once
			Result := ur_target.expression_from_name("LOTSIZE")
		end


end -- class CAPACT_EXERCISE_RIGHTS
