indexing
	description: "Exercise rights expression"
	author: "mk"
	date: "$Date: 2009/11/06 $"
	revision: "$Revision: #28 $"
	archive: "$File: //rose/source/kernel/capital_actions/expressions/capact_exercise_rights_expression.e $"

class
	CAPACT_EXERCISE_RIGHTS_EXPRESSION

inherit
	CAPACT_EXERCISE_RIGHTS
--	rename
--		exdate as capact_exdate,
--		name as template_name
--	end
		rename
			signature as target, exdate as integer_exdate, name as template_name
		undefine
			default_create
		end
	CAPACT_EXPRESSION


--EXERCISE RIGHTS
--quantity_affected_shares  = LOTS(holding,lotsize)
--rights_cash_rate = subscription_price / lotsize
--cash_given_up = rights_cash_rate * quantity_affected_shares
--additional_shares_received =  (share_factor -1) * quantity_affected_shares

create
	make,instantiate,make_empty

feature {NONE} -- Initialization

	instantiate (a_target: CAPACT_SIGNATURE_RECORD) is
			-- instantiate capact
		do
			set_expression_index
			target := a_target
			set_signature(a_target)
			instantiate_all
--			instantiate_attributes
--			instantiate_data
			parent_instrument_id := parent_instrument_expression.integer_value(target)
			parent_instrument := rose_context.listing_accessor.entity (parent_instrument_id)
			if share_factor > 1 and cash_rate <= 0 then
				rmdat_adjustment_factor := share_factor
			else
				rmdat_adjustment_factor := 1
			end
		end

feature -- Access

	processing_instruction (
		a_basis: RP_CORPORATE_ACTION_PROCESSING_SHARE_BASIS_TYPE;
		a_processing_system: RP_CORPORATE_ACTION_PROCESSING_SYSTEM): RP_CORPORATE_ACTION_PROCESSING_INSTRUCTIONS is
			-- <Precursor>
		do
			create Result.make (a_basis, create {RP_SIMPLE_CORPORATE_ACTION}.make (exdate, a_processing_system.exercise_rights_instructions (Current)))
		end

	name : STRING is
			-- capact name
		do
			Result := template_name + " F"+ target.member_number.out
		end

	parent_instrument_id:INTEGER
		-- Parent instrument

	adjustment_factor : DOUBLE is
			-- This may be redundant
		do
			Result := rmdat_adjustment_factor
		end

	cash_outflow(a_currency:CURRENCY):DOUBLE is
			-- cash outflow
		local
			l_xrate : DOUBLE
			l_date:ROSE_DATE
			i:INTEGER
		do
			if cash_currency = Void and then target.listing/= Void then
				if target.listing.zone.is_j_zone then
					cash_currency := rose_context.currency_by_iso_code ("JPY",exdate)
				end
			end

			if (a_currency /= Void and cash_currency /= Void) and then a_currency.handle = cash_currency.handle then
				Result := subscription_price*(share_factor-1)
			else
				if cash_currency = Void or exdate = Void then
					Result := undefined_double
				else
					if (a_currency /= Void and cash_currency /= Void) then
						l_xrate := -999.0
						from
							if exdate /= Void then
								l_date := exdate.twin
							end
						until l_xrate /= -999.0 or i>10
						loop

							l_xrate := a_currency.exchange_rate (cash_currency, l_date)
							l_date.day_back
							i:=i+1
						end
						If not legacy_undefined.is_defined_double (l_xrate) then
							Result := undefined_double
						else
							Result := subscription_price*(share_factor-1)*l_xrate
						end
					else
						Result := undefined_double
					end
				end
			end
		end

	cash_inflow(a_currency:CURRENCY):DOUBLE is
			-- cash inflow for exercise rights i.e. zero
		do
			Result := 0
		end

	cash_dividend(a_currency:CURRENCY):DOUBLE is
			-- cash dividend for exercise rights i.e. zero
		do
			Result := 0
		end

--	parent_instrument_expression: ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
--		once
--			Result := ur_target.expression ("PARENT_INSTRUMENT")
--		end
--   Notes
---- if subscription_price > closing parent_price +> assume no subscription
---- or even if underwritten then cash_value := 0
----
--	computed_portfolio(a_target: PORTFOLIO_DATE): PORTFOLIO_DATE is
--		do
--		-- sets computed_portfolio with results
--		end

--	computed_delta_portfolio(a_target:PORTFOLIO_DATE):PORTFOLIO_DATE is
--		do
--		--set the difference between input and computed portfolios
--		end

--	contract(a_corporate_action_processing_system: RP_CORPORATE_ACTION_PROCESSING_SYSTEM; a_portfolio:RP_PORTFOLIO; a_holding: RP_QUANTITY):RP_RIGHTS is
--		do
--			to_be_implemented ("create the contract from this expression")
--		end

--	cash_currency_iso : STRING is
--			-- iso code for cash currency
--		do
--			Result := cash_currency_expression.string_value(target)
--		end

--	bonus_rate : DOUBLE is
--			-- Bonus rate
--		do
--			Result := undefined_double
--		end

--	dividend_rate : DOUBLE is
--			-- Dividend rate
--		do
--			Result := undefined_double
--		end

--	child_units : DOUBLE is
--		do
--			Result := undefined_double
--		end

--	legacy_basis_prop : DOUBLE is
--		do
--			Result := undefined_double
--		end

--	legacy_basis_price : DOUBLE is
--		do
--			Result := undefined_double
--		end

--	split_rate : DOUBLE is
--			-- Undefined
--		do
--			Result := undefined_double
--		end

--	legacy_basis_currency : STRING is
--			-- legacy basis currency
--		do
--			Result := Void
--		end
--		
--	comment : STRING is		
--		do
--			Result := Void
--		end
--		
end
