indexing
	description: "Factor for creating rose capital action expressions"
	author: "Srilatha Singh"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #6 $"
	archive: "$File: //rose/source/kernel/capital_actions/expressions/capact_expression_factory.e $"

class
	CAPACT_EXPRESSION_FACTORY
inherit
	RX_EXPRESSION_FACTORY[CAPACT_EXPRESSION]

feature -- Access

	expression_from_id (a_id: STRING): CAPACT_EXPRESSION is
			-- Expression corresponding to 'a_id'
	local
		l_index:INTEGER
	do
		if a_id = Void or else a_id.is_empty then
			-- Do nothing, return Void
		elseif a_id.item (1) = 'F' then
			if a_id.substring (2, a_id.count).is_integer then
				l_index := a_id.substring (2, a_id.count).to_integer
				if  l_index > capact_expressions.upper then
					Result := Void
				else
					Result := capact_Expressions.item (l_index)
				end
			else
				Result := Void
			end
		end
	end

	binary_operator_plus (a_left, a_right: CAPACT_EXPRESSION): CAPACT_EXPRESSION is
			-- Expression corresponding to 'a_left' + 'a_right'
	do
		Result := a_left + a_right
	end

	binary_operator_at (a_left, a_right: CAPACT_EXPRESSION): CAPACT_EXPRESSION is
			-- Expression corresponding to 'a_left' @ 'a_right'
	do
		Result := a_left @ a_right
	end


	binary_operator_delta (a_left, a_right: CAPACT_EXPRESSION): CAPACT_EXPRESSION is
			-- Expression corresponding to 'a_left' & 'a_right'
	do
		Result := a_left & a_right
	end

--	binary_operator_unknown (a_left, a_right: CAPACT_EXPRESSION): CAPACT_EXPRESSION is
	binary_operator_unknown (a_left, a_right: CAPACT_EXPRESSION): CAPACT_UNKNOWN_EXPRESSION is
			-- Expression corresponding to 'a_left' ? 'a_right'; default to additive
	do
--		Result := a_left ? a_right
		create Result.make_with_expressions (a_right, a_left)
	end

	capact_expressions: ROSE_LINEAR_ARRAY [CAPACT_EXPRESSION]
			-- Capact expressions

feature -- Basic operations

	set_capact_Expressions (a_expressions: like capact_Expressions) is
			-- set capital action expressions
		do
			capact_Expressions := a_expressions
		end


feature {NONE} -- Implementation

end
