indexing
	description: ""
	author: ""
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #2 $"
	archive: "$File: //rose/source/kernel/capital_actions/capact_income_like.e $"

deferred class
	CAPACT_INCOME_LIKE

feature -- Access

	-- removes cash from retained earnings account

	-- want to be able to track benchmarks, who use the most onerous tax possible - ???
	
	-- different needs for performance and for return calculations?


	cost_basis_change: BOOLEAN is False -- --no transition of parent
	
	income_instrument: LISTING -- (instrument+market)
	
	income_currency: CURRENCY
	
	income_units: DOUBLE
	
	-- true_gross_income_units: DOUBLE --??
	
	-- Three catogies:
	-- net of standard withholding
	-- gross, net of tax credit
	-- gross including tax credit
	
feature -- Access, Tax Related

	is_taxable_as_income: BOOLEAN is True

	country_of_taxation: COUNTRY -- if we make a template for this that can be used by other suppliers, we
									--may want to make this more general
	
	has_imputation_system: BOOLEAN is
			-- 
		do
			--depends on country and date
		end
	
	tax_status: INTEGER  is
		-- must be one of gross_net or net_net, gross_gross
		--default is gross_net
		do
			if tax_status_saved > 0 then
				Result := tax_status_saved
			else
				Result := default_tax_status
			end
		end
		
	set_tax_status (a_value: INTEGER) is
			-- 
		do
			if a_value = gross_net or a_value = net_net or a_value = gross_gross then
				tax_status_saved := a_value
			else
				-- invalid tax status, do what?
				-- do nothing will default to gross_net
			end
		end

	tax_free: BOOLEAN is
			-- 
		do
			--to be computed based on tax flags
		end
		
		
	--other enumerations?
	
	issuance_fee: DOUBLE 	-- only applies to adrs
	
	set_issuance_fee (a_value: like issuance_fee) is
			-- 
		do
		 	-- this will initially not be set, requires additional records
		 	-- instrument must be an adr
		end
		
	
feature -- Basic operations

feature {NONE} -- Implementation

	tax_status_saved: INTEGER
	
	default_tax_status: INTEGER is
			-- 
		once
			Result := gross_net
		end
		
	gross_net: INTEGER is 1
	net_net: INTEGER is 2
	gross_gross: INTEGER is 3
		

end
