indexing
	description: ""
	author: ""
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #6 $"
	archive: "$File: //rose/source/kernel/capital_actions/capact_legacy_distribution_template.e $"

class
	CAPACT_LEGACY_DISTRIBUTION_TEMPLATE
inherit 
	CAPITAL_ACTION_TEMPLATE
	CAPACT_COMMON

-- The assumption is that the parent coming in is given up, and then everything you end up with including
-- original shares, if you still have them, is represented as children received. 
--
-- For each distrbution entry, each 1 parent share either:
--	child_instrument_received = 1 child_instrument_unit ( 1 share) * unit_factor	
-- or
--	child_cash_received =  1 child_cash_unit (1 currency unit) * unit_factor
--
-- If child = parent and unit_factor = 0, parent is given up and doesn't come back (ex. liquidation)

-- IF units < 0 then contribution to be applied to all but parent=child original shares (I=1)
-- proportion to be determined later, so
-- either: 
--	additional cash must be contributed: 1 additional instrument unit * -unit_factor
-- or
--	additional shares must be contributed: 1 additional currency unit * -unit_factor

feature
	name : STRING is 
		once
			Result := legacy_distribution_string
		end
	capital_action_type_id: INTEGER is 9 
		
feature -- Access

	--children, may be listing or currency

	child_instrument: LISTING
	set_child_instrument(a_value: like child_instrument) is
			-- 
		do
			child_instrument := a_value
		end
	
	child_is_cash: BOOLEAN is
		do
			Result := child_cash /= Void
		end

	child_cash: CURRENCY
	set_child_cash(a_value: like child_cash) is
			-- 
		do
			child_cash := a_value
		end

	child_unit_factor: DOUBLE
	set_child_unit_factor(a_value: like child_unit_factor) is
			-- 
		do
			child_unit_factor := a_value
		end
	
	-- additional instrument in
	-- if one of the children has a negative unit rate, it means it's actually an instrument or cash 
	-- added in with the parent to produce the result. 
	-- the total value is entered for each distribution in the option, proportion to be attributed to each
	-- can be handled later. 
	
	
	additional_instrument: LISTING
	set_additional_instrument(a_value: like additional_instrument) is
			-- 
		do
			additional_instrument := a_value
		end
	
	additional_is_cash: BOOLEAN is
		do
			Result := additional_cash /= Void
		end

	additional_cash: CURRENCY
	set_additional_cash(a_value: like additional_cash) is
			-- 
		do
			additional_cash := a_value
		end

	additional_unit_factor: DOUBLE
	set_additional_unit_factor(a_value: like additional_unit_factor) is
			-- 
		do
			additional_unit_factor := a_value
		end
	
	-- vendor specific
	legacy_basis_prop: DOUBLE
	set_legacy_basis_prop (a_value: like legacy_basis_prop) is
			-- 
		do
			legacy_basis_prop := a_value
		end
		
	legacy_basis_price: DOUBLE
	set_legacy_basis_price (a_value: like legacy_basis_price) is
			-- 
		do
			legacy_basis_price := a_value
		end
		
	legacy_basis_currency: STRING
	set_legacy_basis_currency (a_value: like legacy_basis_currency) is
			-- 
		do
			legacy_basis_currency := a_value
		end
		
	legacy_order: INTEGER
	set_legacy_order (a_value: like legacy_order) is
			-- 
		do
			legacy_order := a_value
		end
		
	legacy_user_id: STRING
	set_legacy_user_id (a_value: like legacy_user_id) is
			-- 
		do
			legacy_user_id := a_value
		end
		
	legacy_comment: STRING
	set_legacy_comment (a_value: like legacy_comment) is
			-- 
		do
			legacy_comment := a_value
		end
		
-- use change_date
--		
--	legacy_change_date: INTEGER
--	set_legacy_change_date (a_value: like legacy_change_date) is
--			-- 
--		do
--			legacy_change_date := a_value
--		end
			

			

  -- not currently used, but may need them later

	share_factor: DOUBLE
	set_share_factor (a_value: like share_factor) is
			-- 
		do
			share_factor := a_value
		end
		

	in_lieu_cash_rate: DOUBLE
	set_in_lieu_cash_rate(a_value: like in_lieu_cash_rate) is
			-- 
		do
			in_lieu_cash_rate := a_value
		end
		
	
	in_lieu_cash_currency: CURRENCY
	set_in_lieu_cash_currency(a_value: like in_lieu_cash_currency) is
			-- 
		do
			in_lieu_cash_currency := a_value
		end
		
	
	lotsize: INTEGER
	set_lotsize(a_value: like lotsize) is
			-- 
		do
			lotsize := a_value
		end

end -- class CAPACT_LEGACY_DISTRIBUTION_TEMPLATE
