indexing
	description: "rose capital actions that have distribution in other issuer"
	author: "Janet Small"
	last_editor: "$Author: bn $"
	date: "$Date: 2014/02/19 $"
	revision: "$Revision: #9 $"
	path: "$File: //rose/source/kernel/capital_actions/capact_other.e $"

deferred class
	CAPACT_OTHER
inherit
	CAPACT_CAPITAL_ACTION
	CAPACT_OTHER_TEMPLATE
	ATTRIBUTES
		rename
			variable_index as attributes_variable_index,
			name as attributes_name,
			mnemonic as attributes_mnemonic
		end

	ROSE_CAPACT_DATE_USE

feature -- Access
	other_xrfzone: STRING  --other issue
	set_other_xrfzone (a_value: like other_xrfzone) is
			-- Set other_xrfzone.
		do
			other_xrfzone := a_value
		end



feature -- Basic operations

	instantiate_other_data is
		-- retrieve data items from storage
		do

			exdate_rose := safe_date_from_ccyymmdd (exdate)
			set_other_sedol(string_value (other_sedol_expression, signature))

			if other_sedol /= Void then
				other_entity := rose_context.listing_at (sedol (other_sedol), today)
				if other_entity = Void or else other_entity.handle = 0 then
					other_entity := rose_context.listing_at (sedol (other_sedol), safe_date_from_ccyymmdd (exdate))
				end
			end
			if other_entity /= Void and then other_entity.handle > 0 then
				other_xrfzone := other_entity.xrfzone_key (today)
				other_rmdat_price := other_entity.price_record (exdate_rose)
				cash_equivalent_currency := other_currency
			end

			set_other_security_type(string_value (other_security_type_expression, signature))
		end

	set_other_data_items is
			-- set data items specific to other security in capital action
		local
			l_variable: CAPACT_VARIABLE_DESCRIPTION_ROW
		do
			if other_sedol /= Void then
				l_variable := variable_table.item("OTHER_SEDOL")
				string_items.put(other_sedol, l_variable.item_id)
			end
			if other_security_type /= Void then
				l_variable := variable_table.item("OTHER_SECURITY_TYPE")
				string_items.put(other_security_type, l_variable.item_id)
			end
		end

--		
--	cash_equivalent_rate: DOUBLE  is
--			--
--		local
--			l_price: RMDAT_PRICE_RECORD
--		do
--			if other_entity /= Void then
--				if exdate_rose /= Void then
--					cash_equivalent_currency := other_entity.currency (exdate_rose)
--					l_price := other_entity.price_record (exdate_rose)
--					Result := new_shares_rate * price
--				end
--			end
--		end
--		

feature -- Expressions

	other_sedol_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			-- expression to get "other sedol" item from virtual record
		once
			Result := ur_target.expression_from_name("OTHER_SEDOL")
		end
	other_security_type_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			-- expression to get "other security type" item from virtual record
		once
			Result := ur_target.expression_from_name("OTHER_SECURITY_TYPE")
		end


end
