note

	description:

		"Rose capital action overrides"

	author: "Srilatha Singh"
	last_editor: "$Author: it $"
	date: "$Date: 2012/10/23 $"
	revision: "$Revision: #20 $"
	path: "$File: //rose/source/kernel/capital_actions/capact_override_aware.e $"

class
	CAPACT_OVERRIDE_AWARE
inherit
	ROSE_LEGACY_UNDEFINED
feature -- Access

	retrieve_override (a_signature: ROSE_CAPACT_OVERRIDE_SIGNATURE): ROSE_VIRTUAL_RECORD [ROSE_CAPACT_OVERRIDE_SIGNATURE] is
			-- read override records from the database
	local
		l_signatures: ROSE_LINEAR_ARRAY [ROSE_VIRTUAL_RECORD [ROSE_CAPACT_OVERRIDE_SIGNATURE]]
	do
		create capact_override_data_manager.make_named("capact_override", "CAPITAL ACTIONS OVERRIDE", override_data_server )
		l_signatures := capact_override_data_manager.retrieve_signature (a_signature,
			"#listing_id.id = listing_id  and #exdate.id = exdate and #member_number.id = member_number",
			Void)
		if l_signatures /= Void and l_signatures.count > 0 then
			Result := l_signatures.item (1)
		end
	end

	save_overrides  is
		-- write overrides to database and commit
	do
		create capact_override_data_manager.make_named("capact_override", "CAPITAL ACTIONS OVERRIDE", override_data_server )
		create option_override_data_manager.make_named("capact_option_override", "CAPITAL ACTIONS OPTIONS OVERRIDE", override_data_server )
		from override_capital_actions_table.start
		until override_capital_actions_table.off
		loop
			capact_override_data_manager.replace_signature_data(override_capital_actions_table.item_for_iteration.signature)
			capact_override_data_manager.replace_virtual_record(override_capital_actions_table.item_for_iteration) -- (override_capital_action_virtual_records.current_item)
			override_capital_actions_table.forth
		end
		capact_override_data_manager.submit
		override_data_server.commit

		from override_options.start
		until override_options.off
		loop
			option_override_data_manager.replace_signature_data(override_options.item_for_iteration)
			override_options.forth
		end
		option_override_data_manager.submit
		override_data_server.commit
	end

	save_rose_best is
			-- write rose capital actions to database and commit
		local
			l_date_now:ROSE_DATE
			l_items_to_commit: BOOLEAN
			l_zone: STRING
			l_capact_rose_manager:SIGNATURE_TAGGED_ITEM_DATABASE[CAPACT_SIGNATURE_RECORD]
			l_option_rose_manager: SIGNATURE_TAGGED_ITEM_DATABASE[CAPACT_OPTION_SIGNATURE_RECORD]
			l_integrate: CAPACT_INTEGRATE_ONE
		do
			create l_integrate
			l_integrate.populate_rose_best (Current)
			create  l_date_now.make_now
			check
				rose_best_capital_actions /= Void
			end
			if rose_best_capital_actions.count > 0 then
				l_items_to_commit := True
				rose_best_capital_actions.start
				l_zone := rose_best_capital_actions.item_for_iteration.signature.listing.zone_code_key (constants.today_rdt)
				l_capact_rose_manager := rose_best_capital_actions.item_for_iteration.signature.data_manager
				l_capact_rose_manager.process_id_manager.start_process("CAPITAL ACTIONS OVERRIDE",l_date_now,l_date_now,l_date_now)
				from rose_best_capital_actions.start until rose_best_capital_actions.off loop
					l_capact_rose_manager.replace_signature_data(rose_best_capital_actions.item_for_iteration.signature)
					l_capact_rose_manager.replace_virtual_record(rose_best_capital_actions.item_for_iteration) -- (override_capital_action_virtual_records.current_item)
					rose_best_capital_actions.forth
				end
				l_capact_rose_manager.submit
			end
			check
				rose_best_options /= Void
			end
			if rose_best_options.count > 0 then
				l_items_to_commit := True
				rose_best_options.start
				if l_zone = void then
					l_zone := rose_best_options.item_for_iteration.listing.zone_code_key (constants.today_rdt)
				end
				l_option_rose_manager := rose_best_options.item_for_iteration.data_manager
				l_option_rose_manager.process_id_manager.start_process ("CAPITAL ACTIONS OPTIONS OVERRIDE", l_date_now,l_date_now,l_date_now)    --(" CAPITAL ACTIONS OVERRIDE ")
				from rose_best_options.start until rose_best_options.off loop
					l_option_rose_manager.replace_signature_data(rose_best_options.item_for_iteration)
					rose_best_options.forth
				end
				l_option_rose_manager.submit
			end
			---commit all the zonal servers
			if l_items_to_commit then
				database_servers.rose_zonal_capact_server (l_zone.item (1)).commit
			end
		end

	override_capital_actions(a_key_tuple:TUPLE) :ROSE_LINEAR_ARRAY[ROSE_VIRTUAL_RECORD [ROSE_CAPACT_OVERRIDE_SIGNATURE]] is
			-- fetch all the cached capital actions tied to an option , give the option's key tuple --market,exdate,option_number
	local
		i:INTEGER
		l_tuple:TUPLE
		l_done: BOOLEAN
	do
		create Result.make_empty
		l_done := false
		from i:= 1
		until l_done
		loop
			l_tuple := a_key_tuple.twin
			l_tuple.put_integer (i,a_key_tuple.count) -- assumes member_number is the final item in the tuple
			override_capital_actions_table.search(l_tuple)
			if override_capital_actions_table.found then
				Result.extend(override_capital_actions_table.found_item)
			else
				l_done := True
			end
			i := i+1
		end
	end

feature---Actions	

	delete_capital_action(a_expression:CAPACT_EXPRESSION) is
		-- mark capital action as cancelled for override
	local
		l_virtual_record:ROSE_VIRTUAL_RECORD[like ur_override_capact_signature]
		l_override_capact_signature:like ur_override_capact_signature
		l_rose_best_signatures: ROSE_LINEAR_ARRAY [ROSE_VIRTUAL_RECORD [like ur_rose_capact_signature]]
		l_rose_best_data:ROSE_VIRTUAL_RECORD [like ur_rose_capact_signature]
	do
		---modify_capact_option expressions by deleting the appropriate one
		is_duplicate_override:= false
		override_capital_actions_table.search(a_expression.target.key_tuple)
		if not override_capital_actions_table.found then
			create l_override_capact_signature.make_from_signature (a_expression.target)
			l_override_capact_signature.set_status_code ("Y")
			l_rose_best_signatures := a_expression.target.data_manager.retrieve_signature (
											a_expression.target,
											ur_rose_capact_signature.signature_statement,
											Void)
			if l_rose_best_signatures = Void or else l_rose_best_signatures.count /= 1 then
				(create {EXCEPTION}).raise
			end
			l_rose_best_data := l_rose_best_signatures.first
			create l_virtual_record
			l_virtual_record.set_signature(l_override_capact_signature)
			l_virtual_record.copy_string_items (l_rose_best_data.string_items)
			l_virtual_record.copy_integer_items (l_rose_best_data.integer_items)
			override_capital_actions_table.put(l_virtual_record,l_override_capact_signature.key_tuple)
		else
			is_duplicate_override := True
		end
	end

	is_duplicate_override:BOOLEAN


feature--Implementation

	ur_override_capact_signature:ROSE_CAPACT_OVERRIDE_SIGNATURE is
			-- override capact signature template object
		once
			create Result
		end

	ur_override_option_signature:ROSE_CAPACT_OPTION_OVERRIDE_SIGNATURE is
			-- override option signature template object
		once
			create Result
		end

	ur_rose_capact_signature:CAPACT_SIGNATURE_RECORD is
			-- rose capact signature template object
		once
			create Result
		end

	ur_rose_option_signature:CAPACT_OPTION_SIGNATURE_RECORD is
			-- rose option signature template object
		once
			create Result
		end

	override_capital_actions_table:ROSE_MULTI_KEYED_TABLE[ROSE_VIRTUAL_RECORD[ROSE_CAPACT_OVERRIDE_SIGNATURE]] is
			-- multi_key consists of ROSE_CAPACT_OVERRIDE_SIGNATURE.multi_key
		once
			create Result.make(5)
		end

	override_options:ROSE_MULTI_KEYED_TABLE[ROSE_CAPACT_OPTION_OVERRIDE_SIGNATURE] is
			-- multi_key consists of ROSE_CAPACT_OPTION_OVERRIDE_SIGNATURE.multi_key
			-- Can be populated both from Gui as well as intgeration --For now only from GUI
		once
			create Result.make(5)
		end

	rose_best_capital_actions:ROSE_MULTI_KEYED_TABLE[ROSE_VIRTUAL_RECORD[CAPACT_SIGNATURE_RECORD]] is
			-- multi_key consists of ROSE_CAPACT_OVERRIDE_SIGNATURE.multi_key
		once
			create Result.make(5)
		end

	rose_best_options:ROSE_MULTI_KEYED_TABLE[CAPACT_OPTION_SIGNATURE_RECORD] is
			-- multi_key consists of ROSE_CAPACT_OVERRIDE_SIGNATURE.multi_key
		once
			create Result.make(5)
		end

feature {NONE} -- Implementation

	capact_override_data_manager :SIGNATURE_TAGGED_ITEM_DATABASE[like ur_override_capact_signature]
	option_override_data_manager:SIGNATURE_TAGGED_ITEM_DATABASE[like ur_override_option_signature]


	override_data_server:SQL_DATA_SERVER is
			-- Retrieve the instance of the override data server
		once
			Result:= database_servers.rose_override_server
		end

	database_servers: DATABASE_SERVERS is
			-- Pointer to database servers
		once
			create Result
		end

	rose_Global:ROSE_SHARED_GLOBAL is
			-- Pointer to shared global variables and procedures
		once
			create result
		end

	clear_all is
			-- clear all caches
		do
			rose_best_capital_actions.wipe_out
			rose_best_options.wipe_out
			override_capital_actions_table.wipe_out
			override_options.wipe_out
			ur_rose_capact_signature.wipe_out
			ur_rose_option_signature.wipe_out
			ur_rose_capact_signature.ur_expression.refresh_cache
		end

end
