note

	description:

		"rose capital actions: renominalization"

	author: "Janet Small"
	last_editor: "$Author: yc $"
	date: "$Date: 2011/09/29 $"
	revision: "$Revision: #3 $"
	path: "$File: //rose/source/kernel/capital_actions/capact_renominalization.e $"

class
	CAPACT_RENOMINALIZATION
inherit
	CAPACT_CAPITAL_ACTION
	CAPACT_CHANGE_OF_SHARES_TEMPLATE

feature -- Access

	name : STRING is
			-- name of type of capact
		once
			Result := renominalization_string
		end

	capital_action_type_id: INTEGER is 22
			-- type id of current capact type

feature -- Basic operations

	instantiate_data is
			-- set data items from storage through expressions
		local
			l_string_value: STRING
		do
			l_string_value := string_value  (split_rate_expression, signature)
			if l_string_value /= Void and then l_string_value.is_double then
				set_split_rate (l_string_value)
			end
		end

	set_data_items is
			-- set string_item and integer_item data items hash tables
		local
			l_variable: CAPACT_VARIABLE_DESCRIPTION_ROW
			l_string_value: STRING
		do
			l_variable := variable_table.item (name_variable_item_split_rate)
			l_string_value := format_split_rate.formatted (split_rate)
			string_items.put (l_string_value, l_variable.item_id)
		end

feature {NONE} -- Implementation

	name_variable_item_split_rate: STRING is "SPLIT_RATE"
			-- name of variable item of split rate

feature {NONE} -- Expressions

	split_rate_expression: ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			-- Split rate expression
		once
			Result := ur_target.expression_from_name (name_variable_item_split_rate)
		end

end
