note

	description:

		"rose capital action expression: renominalization"

	author: "Janet Small"
	last_editor: "$Author: yc $"
	date: "$Date: 2011/09/29 $"
	revision: "$Revision: #7 $"
	path: "$File: //rose/source/kernel/capital_actions/expressions/capact_renominalization_expression.e $"

class CAPACT_RENOMINALIZATION_EXPRESSION

inherit
	CAPACT_DEFAULT_EXPRESSION
	CAPACT_RENOMINALIZATION
		rename
			signature as target, exdate as integer_exdate, name as template_name
		undefine
			default_create
		end

create
	make,instantiate,make_empty

feature {NONE} -- Initialization

	instantiate (a_target: CAPACT_SIGNATURE_RECORD) is
			-- Create with 'a_target'
		do
			target := a_target
			set_signature(a_target)
			instantiate_all
			rmdat_adjustment_factor := split_rate
		end

feature -- Access

	processing_instruction (
		a_basis: RP_CORPORATE_ACTION_PROCESSING_SHARE_BASIS_TYPE;
		a_processing_system: RP_CORPORATE_ACTION_PROCESSING_SYSTEM): RP_CORPORATE_ACTION_PROCESSING_INSTRUCTIONS is
			-- processing instructions for the corp action - no processing
		do
		    create Result.make (a_basis, create {RP_SIMPLE_CORPORATE_ACTION}.make (exdate, a_processing_system.renominalization_instructions (Current)))
		end

	name: STRING is
			-- Name
		do
			Result := "RENOMINALIZATION" + ": F" + target.member_number.out
		ensure then
			result_not_void: Result /= Void
		end

end
