indexing
	description: "rose capital action expression: renounceable bonus in same instrument given out"
	author: "Janet Small"
	date: "$Date: 2009/11/06 $"
	revision: "$Revision: #7 $"
	archive: "$File: //rose/source/kernel/capital_actions/expressions/capact_renounceable_bonus_in_same_expression.e $"

class
	CAPACT_RENOUNCEABLE_BONUS_IN_SAME_EXPRESSION

inherit
	CAPACT_DEFAULT_EXPRESSION

	CAPACT_RENOUNCEABLE_BONUS_IN_SAME
		rename
			signature as target, exdate as integer_exdate, name as template_name
		undefine
			default_create
		end

create
	make,instantiate,make_empty


feature -- creation

	instantiate (a_target: CAPACT_SIGNATURE_RECORD) is
			-- Populate expression from storage
		do
			target := a_target
			set_signature(a_target)
			instantiate_all
			delta_new_shares := new_shares_rate
			rmdat_adjustment_factor := 1  + new_shares_rate
		end

feature -- Access

	processing_instruction (
		a_basis: RP_CORPORATE_ACTION_PROCESSING_SHARE_BASIS_TYPE;
		a_processing_system: RP_CORPORATE_ACTION_PROCESSING_SYSTEM): RP_CORPORATE_ACTION_PROCESSING_INSTRUCTIONS is
			-- Processing corp action instruction
		do
			create Result.make (a_basis, create {RP_SIMPLE_CORPORATE_ACTION}.make (exdate, a_processing_system.renounceable_bonus_in_same_instructions (Current)))
		end

feature -- Output

	name: STRING is
			-- Name
		do
			Result := "RENOUNCEABLE BONUS IN SAME" + ": F" + target.member_number.out
		end

end
