indexing
	description: "Rose capital action returns"
	author: "Janet Small"
	date: "$Date: 2010/04/01 $"
	revision: "$Revision: #12 $"
	archive: "$File: //rose/source/kernel/capital_actions/capact_return.e $"

deferred class
	CAPACT_RETURN
inherit
	CAPACT_CAPITAL_ACTION
	CAPACT_RETURN_TEMPLATE

feature -- operations

	set_data_items is
			-- Set data items
		local
			l_variable: CAPACT_VARIABLE_DESCRIPTION_ROW
			s: STRING
		do
			l_variable := variable_table.item("CASH_RATE")
			s := format_cash_rate.formatted (cash_rate)
			string_items.put(s, l_variable.item_id)

			if cash_currency_iso /= Void then
				l_variable := variable_table.item("CASH_CURRENCY")
				string_items.put(cash_currency_iso,l_variable.item_id)
			elseif cash_currency /= Void then
				l_variable := variable_table.item("CASH_CURRENCY")
				s := cash_currency.iso_code_most_recent_key (constants.now)
				string_items.put(s,l_variable.item_id)
			end

			if dl_taxflag /= Void then
				l_variable := variable_table.item("DL_TAXFLAG")
				string_items.put(dl_taxflag, l_variable.item_id)
			end
		end

	instantiate_data is
			-- retrieve data items from storage
		local
			s: STRING
			i: INTEGER
			l_curr: CURRENCY
		do
			s :=string_value (cash_rate_expression, signature)
			if s /= Void and then s.is_double then
				set_cash_rate(s.to_double)
			end
			s := string_value(cash_currency_expression,signature)
			if s /= Void then
				set_cash_currency_iso (s)
				l_curr := rose_context.currency_by_iso_code (s,constants.now)
				if l_curr /= Void then
					set_cash_currency(l_curr)
				end
			end
			i := lotsize_expression.integer_value (signature)
			if i <= 0 then
				set_lotsize (1)
			end
			s := string_value (dl_taxflag_expression, signature)
			if s /= Void then
				set_dl_taxflag(s)
			end
		end

feature -- expressions


	cash_rate_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			--expression with name "CASH_RATE"
		once
			Result := ur_target.expression_from_name("CASH_RATE")
		end

	cash_currency_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			--
		once
			Result := ur_target.expression_from_name("CASH_CURRENCY")
		end

	lotsize_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			-- Lotsize expression
		once
			Result := ur_target.expression_from_name("LOTSIZE")
		end

	dl_taxflag_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			--
		once
			Result := ur_target.expression_from_name("DL_TAXFLAG")
		end




end -- class CAPACT_RETURN
