note

	description:

		"rose capital action expression: return on share premium"

	author: "Srilatha Singh"
	last_editor: "$Author: it $"
	date: "$Date: 2012/05/22 $"
	revision: "$Revision: #23 $"
	path: "$File: //rose/source/kernel/capital_actions/expressions/capact_return_on_share_premium_expression.e $"

class
	CAPACT_RETURN_ON_SHARE_PREMIUM_EXPRESSION
inherit
	CAPACT_RETURN_EXPRESSION
		redefine name end

	CAPACT_RETURN_ON_SHARE_PREMIUM
		rename signature as target, exdate as integer_exdate, name as template_name
		undefine default_create end

create
	make,instantiate,make_empty

feature {NONE} -- Initialization

	instantiate (a_target: CAPACT_SIGNATURE_RECORD) is
			--populate from storage
		do
			set_expression_index
			target := a_target
			set_signature(a_target)
			instantiate_all
			rmdat_adjustment_factor := 1
		end

feature -- Access

	processing_instruction (
		a_basis: RP_CORPORATE_ACTION_PROCESSING_SHARE_BASIS_TYPE;
		a_processing_system: RP_CORPORATE_ACTION_PROCESSING_SYSTEM): RP_CORPORATE_ACTION_PROCESSING_INSTRUCTIONS is
			-- processing corp action instruction
		do
			create Result.make (a_basis, create {RP_SIMPLE_CORPORATE_ACTION}.make (exdate, a_processing_system.return_on_share_premium (Current)))
		end

	cash_inflow,cash_dividend(a_currency:CURRENCY):DOUBLE is
			-- cash inflow or cash dividend
		local
			l_xrate:DOUBLE
		do
			if (a_currency /= Void and cash_currency /= Void) and then a_currency.is_equal(cash_currency) then
				Result := cash_rate
			else
				if cash_currency = Void or exdate = Void then
					Result := undefined_double
				else
					if (a_currency /= Void and cash_currency /= Void) then
						l_xrate := a_currency.exchange_rate (cash_currency, exdate)
						if legacy_undefined.is_defined_double(l_xrate) then
							Result := cash_rate*l_xrate
						else
							Result := undefined_double
						end
					else
						Result := undefined_double
					end
				end
			end
			Result := cash_dividend_value (Current, Result)
		end

	cash_outflow(a_currency:CURRENCY):DOUBLE is
			-- cash outflow = 0
		do
			Result := 0
		end

	name : STRING is
			-- name
		do
			Result := template_name + " F"+ target.member_number.out
		end

	adjustment_factor : DOUBLE is
			-- This may be redundant
		do
			Result := rmdat_adjustment_factor
		end

end
