indexing
	description: "rose capital actions: non-renounceable rights in other instrument given out"
	author: "Janet Small"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #2 $"
	archive: "$File: //rose/source/kernel/capital_actions/capact_rights_in_other.e $"

class
	CAPACT_RIGHTS_IN_OTHER
inherit
	CAPACT_CAPITAL_ACTION
	CAPACT_OTHER
	CAPACT_SUBSCRIPTION
	CAPACT_NONRENOUNCEABLE

feature -- Access

	name : STRING is 
		once
			Result := rights_in_other_string
		end
	
	capital_action_type_id: INTEGER is 14  
	
	cash_rate: DOUBLE is 
			-- 
		do
			Result := - (new_shares_rate  * subscription_price)
		end

feature -- Basic operations


	instantiate_data is  
		-- retrieve data items from storage
		do
			instantiate_distribution_data
			instantiate_subscription_data
			instantiate_renounceable_data
			instantiate_other_data
		end
		
	set_data_items is 
		-- string_item and integer_item hash tables
		do 
			set_distribution_data_items
			set_subscription_data_items
			set_renounceable_data_items
			set_other_data_items
			
		end
			
	cash_equivalent_rate: DOUBLE  is
			-- 
		do
			Result := new_shares_rate * other_price
		end
		
		
feature {NONE} -- Implementation

end
