indexing
	description: "rose capital action expression: non-renounceable rights in other instrument given out"
	author: "Janet Small"
	date: "$Date: 2009/11/06 $"

	revision: "$Revision: #10 $"
	archive: "$File: //rose/source/kernel/capital_actions/expressions/capact_rights_in_other_expression.e $"

class
	CAPACT_RIGHTS_IN_OTHER_EXPRESSION

inherit
	CAPACT_DEFAULT_EXPRESSION
--		undefine
--			cash_rate
		redefine
			cash_inflow, cash_outflow, cash_dividend
	    end
	CAPACT_RIGHTS_IN_OTHER
		rename
			signature as target, exdate as integer_exdate, name as template_name
		undefine
			default_create
		end

create
	make, instantiate, make_empty

feature {NONE} -- Initialization

	instantiate (a_target: CAPACT_SIGNATURE_RECORD) is
			-- populate expression from storage
		do
			target := a_target
			set_signature(a_target)
			instantiate_all
			delta_new_shares := new_shares_rate
			rmdat_adjustment_factor := 1
			participation_rate := 1
		end

feature -- Access

	processing_instruction (
		a_basis: RP_CORPORATE_ACTION_PROCESSING_SHARE_BASIS_TYPE;
		a_processing_system: RP_CORPORATE_ACTION_PROCESSING_SYSTEM): RP_CORPORATE_ACTION_PROCESSING_INSTRUCTIONS is
			-- processing corp action instruction
		do
		    create Result.make (a_basis, create {RP_SIMPLE_CORPORATE_ACTION}.make (exdate, a_processing_system.rights_in_other_instructions (Current)))
		end

	name: STRING is
			-- Capact browser display name
		do
			Result := "RIGHTS IN OTHER" + ": F" + target.member_number.out
		end

	cash_outflow(a_currency:CURRENCY):DOUBLE is
		-- any money out as holder of the shares
		do
			Result := 0
		end

	cash_inflow(a_currency:CURRENCY):DOUBLE is
		-- any money (including cash equivalent) that comes in to you as holder of the shares
		do
			Result := 0
		end

	cash_dividend (a_currency:CURRENCY):DOUBLE is
			-- cash dividend into portfolio as a result of capital action
		do
			Result := 0
		end

end
