indexing
	description: "rose capital actions: non-renounceable rights in same instrument given out"
	author: "Janet Small"
	date: "$Date: 2009/10/06 $"
	revision: "$Revision: #8 $"
	archive: "$File: //rose/source/kernel/capital_actions/capact_rights_in_same.e $"

class
	CAPACT_RIGHTS_IN_SAME

inherit
	CAPACT_CAPITAL_ACTION

	CAPACT_NONRENOUNCEABLE

	CAPACT_SUBSCRIPTION

feature -- Access

-- editable:
-- 	subscription_price (price of 1 new share)
-- 	bonus_rate: percent, per each unit that you hold  eg. for 20 shares entitled to 1, so  1/20 = .05
	-- (bonus_rate = delta_shares = new_shares_rate)
-- currency
-- (participation rate)

-- calculate (old)
	-- cash_rate = - ( bonus_rate * subscription_price )
	-- sh_factor = bonus_rate + 1

	name : STRING is
			-- corp action name
		once
			Result := rights_in_same_string
		end

	capital_action_type_id: INTEGER is
			-- capact type id
		once
			Result := 11
		end

	cash_rate: DOUBLE is
			-- cash rate
		do
			Result := - (new_shares_rate  * subscription_price)
		end

feature -- Basic operations

	instantiate_data is
		-- retrieve data items from storage
		do
			instantiate_subscription_data
			instantiate_distribution_data
		end

	set_data_items is
		-- string_item and integer_item hash tables
		do
			set_subscription_data_items
			set_distribution_data_items
		end

end
