note

	description:

		"CAPACT_SIGNATURE_RECORD fields"

	author: "Ivan Tarnavsky"
	last_editor: "$Author: it $"
	date: "$Date: 2012/10/23 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/capital_actions/capact_signature_record_fields.e $"

deferred class CAPACT_SIGNATURE_RECORD_FIELDS

inherit

	CAPACT_COMMON_SIGNATURE_FIELDS

feature -- Access

	record_date: INTEGER
			-- Record date

	capact_type_id: INTEGER
			-- Capital action type

	member_number: INTEGER
			-- Key field to distinguish individual capital action among those on same exdate

	company_id: INTEGER
			-- Entity id of company

	vendor_key: STRING
			-- Field allowing rose capital action to be traced back to supplier capital action

feature -- Status report

	has_company_id (a_value: like company_id): BOOLEAN is
			-- Is `company_id' equal to `a_value'?
		do
			Result := company_id = a_value
		ensure
			definition: Result = (company_id = a_value)
		end

feature -- Setting

	set_record_date (a_value: like record_date) is
			-- Set `record_date' to `a_value'
		do
			record_date := a_value
		ensure
			value_set: record_date = a_value
		end

	set_capact_type_id (a_value: like capact_type_id) is
			-- Set `capact_type_id' to `a_value'
		do
			capact_type_id := a_value
		ensure
			value_set: capact_type_id = a_value
		end

	set_member_number (a_value: like member_number) is
			-- Set `member_number' to `a_value'
		do
			member_number := a_value
		ensure
			value_set: member_number = a_value
		end

	set_company_id (a_value: like company_id) is
			-- Set `company_id' to `a_value'
		do
			company_id := a_value
		ensure
			value_set: company_id = a_value
		end

	set_vendor_key (a_value: like vendor_key) is
			-- Set `vendor_key' to `a_value'
		do
			vendor_key := a_value
		ensure
			value_set: vendor_key = a_value
		end

end
