indexing

	description:

		"Rose capital action splits"

	author: "Janet Small"
	date: "$Date: 2010/04/01 $"
	sccid: "$Id: //rose/source/kernel/capital_actions/capact_split.e#12 $"

deferred class CAPACT_SPLIT

inherit

	CAPACT_CAPITAL_ACTION

	CAPACT_CHANGE_OF_SHARES_TEMPLATE

feature -- Initialization

	set_data_items is
			--set data items
		local
			l_variable: CAPACT_VARIABLE_DESCRIPTION_ROW
			s: STRING
		do
			l_variable := variable_table.item ("SPLIT_RATE")
			s := format_split_rate.formatted (split_rate)
			string_items.put (s, l_variable.item_id)
			l_variable := variable_table.item ("LOTSIZE")
			integer_items.put (lotsize, l_variable.item_id)
				-- in_lieu_cash_rate
			if in_lieu_cash_currency /= Void then
				l_variable := variable_table.item ("IN_LIEU_CASH_CURRENCY")
				s := in_lieu_cash_currency.iso_code_most_recent_key (constants.now)
				string_items.put (s, l_variable.item_id)
			end
		end

	instantiate_data is
			-- retrieve data items from storage
		local
			s: STRING
			i: INTEGER
			l_curr: CURRENCY
		do
			s := string_value  (split_rate_expression, signature)
			if s /= Void and then s.is_double then
				set_split_rate (s)
			end
				--i := lotsize_expression.integer_value (signature)
			if i <= 0 then
				set_lotsize (1)
			end
				-- in_lieu_cash_rate
			s := string_value (in_lieu_cash_currency_expression, signature)
			if s /= Void then
				l_curr := rose_context.currency_by_iso_code (s, constants.now)
				if l_curr /= Void then
					set_in_lieu_cash_currency (l_curr)
				end
			end
		end

feature -- expressions

	lotsize_expression: ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			-- Lot size expression
		once
			Result := ur_target.expression_from_name ("LOTSIZE")
		end

	split_rate_expression: ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			-- Split rarte expression
		once
			Result := ur_target.expression_from_name ("SPLIT_RATE")
		end

	in_lieu_cash_rate_expression: ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			-- In lieu cash rate expression
		once
			Result := ur_target.expression_from_name ("IN_LIEU_CASH_RATE")
		end

	in_lieu_cash_currency_expression: ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			-- In lieu cash currency expression
		once
			Result := ur_target.expression_from_name ("IN_LIEU_CASH_CURRENCY")
		end

end -- class CAPACT_SPLIT
