note

	description:

		"Split expression"

	author: "mk"
	last_editor: "$Author: it $"
	date: "$Date: 2012/05/22 $"
	revision: "$Revision: #26 $"
	path: "$File: //rose/source/kernel/capital_actions/expressions/capact_split_expression.e $"

class CAPACT_SPLIT_EXPRESSION

inherit

	CAPACT_SPLIT
		rename
			signature as target,
			exdate as integer_exdate,
			name as template_name
		undefine
			default_create
		end

	CAPACT_EXPRESSION

	CAPACT_COMMON
		undefine
			default_create
		end

create

	make,
	instantiate,
	make_empty

feature {NONE} -- creation

	instantiate (a_target: CAPACT_SIGNATURE_RECORD) is
			-- Initialize from 'a_target'
		do
			set_expression_index
			target := a_target
			set_signature (a_target)
			instantiate_all
			rmdat_adjustment_factor := split_rate
		end

feature -- Access

	processing_instruction (a_basis: RP_CORPORATE_ACTION_PROCESSING_SHARE_BASIS_TYPE; a_processing_system: RP_CORPORATE_ACTION_PROCESSING_SYSTEM): RP_CORPORATE_ACTION_PROCESSING_INSTRUCTIONS is
			-- processing corp action instruction
		do
			create Result.make (a_basis, create {RP_SIMPLE_CORPORATE_ACTION}.make (exdate, a_processing_system.split_instructions (Current)))
		end

feature -- Access

	name: STRING is
			-- corp action name
		do
			if split_rate > 1 then
				Result := "FORWARD SPLIT" + ": F" + target.member_number.out
			else
				Result := "REVERSE SPLIT" + ": F" + target.member_number.out
			end
		end

	template_name: STRING is
			-- template name
		do
			if split_rate > 1 then
				Result := "FORWARD SPLIT"
			else
				Result := "REVERSE SPLIT"
			end
		end

	capital_action_type_id: INTEGER is 0
			-- if we need this, we need to make descendents

	cash_inflow (a_currency: CURRENCY): DOUBLE is
			-- Cash inflow
		do
			Result := 0
		end

	cash_outflow (a_currency: CURRENCY): DOUBLE is
			-- Cash outflow
		do
			Result := 0
		end

	cash_dividend (a_currency: CURRENCY): DOUBLE is
			-- Cash dividend
		do
			Result := 0
		end

	adjustment_factor: DOUBLE is
			-- This may be redundant
		do
			Result := rmdat_adjustment_factor
		end

end
