note

	description:

		"Stock bonus expression"

	author: "mk"
	last_editor: "$Author: it $"
	date: "$Date: 2012/05/22 $"
	revision: "$Revision: #24 $"
	path: "$File: //rose/source/kernel/capital_actions/expressions/capact_stock_bonus_expression.e $"

class
	CAPACT_STOCK_BONUS_EXPRESSION

inherit
	CAPACT_STOCK_BONUS
		rename
			signature as target, exdate as integer_exdate, name as template_name
		undefine
			default_create
		end
	CAPACT_EXPRESSION
	CAPACT_COMMON
			undefine default_create end

create
	make,
	instantiate,make_empty

feature {NONE} -- creation
	instantiate (a_target: CAPACT_SIGNATURE_RECORD) is
			-- creation procedure
		do
			set_expression_index
			target := a_target
			set_signature(a_target)
			instantiate_all
			rmdat_adjustment_factor := bonus_rate
		end

feature -- Access

	processing_instruction (
		a_basis: RP_CORPORATE_ACTION_PROCESSING_SHARE_BASIS_TYPE;
		a_processing_system: RP_CORPORATE_ACTION_PROCESSING_SYSTEM): RP_CORPORATE_ACTION_PROCESSING_INSTRUCTIONS is
			-- processing corp action instruction
		do
			create Result.make (a_basis, create {RP_SIMPLE_CORPORATE_ACTION}.make (exdate, a_processing_system.stock_bonus_instructions (Current)))
		end

	cash_inflow(a_currency : CURRENCY) : DOUBLE is
			-- compute inflow of cash; must be zero for stock bonus
		do
			Result := 0
		end

	cash_outflow(a_currency : CURRENCY)  :DOUBLE is
			-- cash outflow = 0 for stock bonus
		do
			Result := 0
		end

	cash_dividend(a_currency : CURRENCY) : DOUBLE is
			-- cash dividend
		do
			Result := 0
		end

	name : STRING is
			-- Name
		do
			Result := template_name + " F"+ target.member_number.out
		end

	adjustment_factor : DOUBLE is
			-- This may be redundant
		do
			Result := rmdat_adjustment_factor
		end

end -- class CAPACT_STOCK_BONUS_EXPRESSION
