indexing
	description: "Rose capital action stock dividend"
	author: "Janet Small"
	date: "$Date: 2010/04/01 $"
	revision: "$Revision: #12 $"
	archive: "$File: //rose/source/kernel/capital_actions/capact_stock_dividend.e $"

class
	CAPACT_STOCK_DIVIDEND
inherit
	CAPACT_CAPITAL_ACTION
	CAPACT_STOCK_DIVIDEND_TEMPLATE

feature -- Basic Operations

	set_data_items is
			--set data items
		local
			l_variable: CAPACT_VARIABLE_DESCRIPTION_ROW
			s: STRING
		do
			l_variable := variable_table.item("DIVIDEND_RATE")
			s := format_dividend_rate.formatted(dividend_rate)
			string_items.put(s, l_variable.item_id)

			-- lotsize

			-- in_lieu_cash_rate

			if in_lieu_cash_currency /= Void then
				l_variable := variable_table.item("IN_LIEU_CASH_CURRENCY")
				s := in_lieu_cash_currency.iso_code_most_recent_key (constants.now)
				string_items.put(s, l_variable.item_id)
			end
		end

	instantiate_data is
		-- retrieve data items from storage
		local
			s: STRING
			i: INTEGER
			l_curr: CURRENCY
		do
			s := string_value(dividend_rate_expression,signature)
			if s /= Void and then s.is_double then
				set_dividend_rate(s.to_double)
			end

			--i := lotsize_expression.integer_value (signature)
			if i <= 0 then
				set_lotsize (1)
			end

			-- in_lieu_cash_rate

			s := string_value(in_lieu_cash_currency_expression,signature)
			if s /= Void then
				l_curr := rose_context.currency_by_iso_code(s,constants.now)
				if l_curr /= Void then
					set_in_lieu_cash_currency(l_curr)
				end
			end

		end

feature -- expressions

	dividend_rate_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			--
		once
			Result := ur_target.expression_from_name("DIVIDEND_RATE")
		end

	lotsize_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			-- Lotsize expression
		once
			Result := ur_target.expression_from_name("LOTSIZE")
		end

	in_lieu_cash_rate_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			-- In lieu cash rate expression
		once
			Result := ur_target.expression_from_name("IN_LIEU_CASH_RATE")
		end

	in_lieu_cash_currency_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			-- Expression for in lieu cash
		once
			Result := ur_target.expression_from_name("IN_LIEU_CASH_CURRENCY")
		end

end
