note

	description:

		"Stock dividend expression"

	author: "mk"
	last_editor: "$Author: it $"
	date: "$Date: 2012/05/22 $"
	revision: "$Revision: #25 $"
	path: "$File: //rose/source/kernel/capital_actions/expressions/capact_stock_dividend_expression.e $"

class
	CAPACT_STOCK_DIVIDEND_EXPRESSION

inherit

	CAPACT_STOCK_DIVIDEND
		rename
			signature as target, exdate as integer_exdate, name as template_name
		undefine
			default_create
		end

	CAPACT_EXPRESSION
		redefine
			name
		end

create
	make,instantiate,make_empty

feature {NONE} -- creation

	instantiate (a_target: CAPACT_SIGNATURE_RECORD) is
			-- creation procedure
		do
			set_expression_index
			target := a_target
			set_signature(a_target)
			instantiate_all
			rmdat_adjustment_factor := 1 + dividend_rate / 100.0
		end

feature -- Access	

	processing_instruction (
		a_basis: RP_CORPORATE_ACTION_PROCESSING_SHARE_BASIS_TYPE;
		a_processing_system: RP_CORPORATE_ACTION_PROCESSING_SYSTEM): RP_CORPORATE_ACTION_PROCESSING_INSTRUCTIONS is
			-- processing corp action instruction
		do
			create Result.make (a_basis, create {RP_SIMPLE_CORPORATE_ACTION}.make (exdate, a_processing_system.stock_dividend_instructions (Current)))
		end

	name:STRING is
			-- constructed name
		do
			Result := template_name+ " F"+ target.member_number.out
		end

	cash_inflow(a_currency : CURRENCY) : DOUBLE is
			-- cash inflow = 0 for stock dividend
		do
			Result := 0
		end

	cash_outflow(a_currency : CURRENCY) : DOUBLE is
			-- cash outflow = 0
		do
			Result := 0
		end

	cash_dividend(a_currency : CURRENCY) : DOUBLE is
			-- Cash dividend
		do
			Result := 0
		end

	cash_rate : DOUBLE is
			-- does it make sense to define this here?
		do
			Result := undefined_double
		end

	share_factor : DOUBLE is
			-- does it make sense to define this here?
		do
			Result := undefined_double
		end

	subscription_price : DOUBLE is
			-- does it make sense to define this here?
		do
			Result := undefined_double
		end

	child_units : DOUBLE is
			-- child units
		do
			Result := undefined_double
		end

	legacy_basis_price : DOUBLE is
			-- Legacy basis price
		do
			Result := undefined_double
		end

	bonus_rate : DOUBLE is
			-- Bonus rate
		do
			Result := undefined_double
		end

	split_rate : DOUBLE is
			-- Split rate
		do
			Result := undefined_double
		end

	legacy_basis_currency : STRING is
			-- Basis currency
		do
			Result := Void
		end

	legacy_basis_prop : DOUBLE is
			-- does it make sense to define this here?
		do
			Result := undefined_double
		end

	cash_currency_iso : STRING is
			-- Currency ISO
		do
			Result := Void
		end

	adjustment_factor : DOUBLE is
			-- This may be redundant
		do
			Result := rmdat_adjustment_factor
		end

end
