indexing
	description: "subscription capital actions"
	author: "Janet Small"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #3 $"
	archive: "$File: //rose/source/kernel/capital_actions/capact_subscription_template.e $"

deferred class
	CAPACT_SUBSCRIPTION_TEMPLATE
inherit
	CAPITAL_ACTION_TEMPLATE

feature -- Access

	subscription_price: DOUBLE	
	set_subscription_price (a_value: like subscription_price) is
			-- 
		do
			subscription_price := a_value
		end
		
	market_price_record:  RMDAT_PRICE_RECORD
	market_price: DOUBLE is
			-- 
		do
			if market_price_record /= Void then
				Result := market_price_record.close
			end
		end		
		-- ##: sanity check: in update: look up most recent price of parent, compare with subscription price
		-- will want to see the current price of the parent security in browser

		
	subscription_currency_iso: STRING	
	set_subscription_currency_iso (a_value: like subscription_currency_iso) is
			-- 
		do
			subscription_currency_iso := a_value
		end
		
	subscription_currency: CURRENCY	
	set_subscription_currency (a_value: like subscription_currency) is
			-- 
		do
			subscription_currency := a_value
		end
	
	subscription_rate: DOUBLE	
	set_subscription_rate (a_value: like subscription_rate) is
			-- 
		do
			subscription_rate := a_value
		end

	new_shares_subscription: DOUBLE 
	set_new_shares_subscription (a_value: like new_shares_subscription) is
			-- 
		do
			new_shares_subscription := a_value
		end	
		
	old_shares_subscription: DOUBLE 
	set_old_shares_subscription (a_value: like old_shares_subscription) is
			-- 
		do
			old_shares_subscription := a_value
		end	


		
	last_date_for_splitting: INTEGER
	set_last_date_for_splitting (a_value: like last_date_for_splitting) is
			-- 
		do
			last_date_for_splitting := a_value
		end
	last_date_to_subscribe: INTEGER
	set_last_date_to_subscribe (a_value: like last_date_to_subscribe) is
			-- 
		do
			last_date_to_subscribe := a_value
		end	
	first_date_to_subscribe: INTEGER
	set_first_date_to_subscribe (a_value: like first_date_to_subscribe) is
			-- 
		do
			first_date_to_subscribe := a_value
		end
	call_due_date: INTEGER
	set_call_due_date (a_value: like call_due_date) is
			-- 
		do
			call_due_date := a_value
		end	
	
	issue_date: INTEGER
	set_issue_date (a_value: like issue_date) is
			-- 
		do
			issue_date := a_value
		end	
		
	books_closed_date: INTEGER
	set_books_closed_date(a_value: like books_closed_date) is
			-- 
		do
			books_closed_date := a_value
		end	
	
	
	is_oversubscription_allowed: BOOLEAN	 --dataline: set to true when Issue Qualification marker = 'O' or 'N'
	set_is_oversubscription_allowed (a_value: like is_oversubscription_allowed) is
			-- 
		do
			is_oversubscription_allowed := a_value
		end	

	
	is_underwritten: BOOLEAN	 --  dataline: set to true when Issue Qualification marker = 'H'.
	set_is_underwritten (a_value: like is_underwritten) is
			-- if true, participation_rate = 100%
		do
			is_underwritten := a_value
		end	

	
--	-- what's being given, how many:
--	-- these are either fully paid shares, or ranked for dividend shares
--	temp_instrument_rate: DOUBLE  -- ## how to represent this?
--	temp_instrument_identifier: STRING	
--	temp_identifier_type: INTEGER
--	temp_instrument_conversion_date: INTEGER -- from B1 record of sedol , XREF MARKER A (B4) = N, may be indefinite date
--	--temp_instrument_conversion_rate: 	DOUBLE -- defaulting to 1:1, make editable
-- 
--feature -- when a non-renounceable subscription has to act renounceable
--	-- fields to implement distribution-like events, purely operational
--	
--	rights_instrument_rate: DOUBLE  -- ## how to represent this?
--	rights_instrument_identifier: STRING -- editable (not from supplier
--	rights_identifier_type: INTEGER -- editable (rose_entity_attribute_type_id)
--	rights_delivery_date: INTEGER  -- editable (not from suppliers)
--	rights_expiration_date: INTEGER -- editable (not from suppliers)
--	
--	

feature -- Basic operations

feature {NONE} -- Implementation

end
