indexing
	description: "Utilis for CAPACT clients"
	author: ""
	last_editor: "$Author: sm $"
	date: "$Date: 2010/06/04 $"
	revision: "$Revision: #2 $"
	archive: "$File: //rose/source/kernel/capital_actions/capact_utils.e $"

class CAPACT_UTILS

inherit
	RP_AXAROSENBERG_AWARE
		rename manager as axarosenberg end

feature -- Access

	rose_ieee_undefined : ROSE_IEEE_UNDEFINED is
			-- access to non-legacy undefined values
		once
			create Result
		end

	rp_currency_inferred  (a_ref_system: RP_REFERENCE_SYSTEM; a_instrument: RP_INSTRUMENT; a_currency_iso: STRING): RP_CURRENCY is
			-- return a_currency if a_currency is not void; else if a_instrument in japan return JPY
		require
			reference_system_not_void: a_ref_system /= Void
			iso_code_not_void: a_currency_iso /= Void
		do
			if a_currency_iso /= Void then
				Result := a_ref_system.currency_from_iso_code (a_currency_iso)
			end
			if Result = Void then
				if {l_rp_currency: RP_CURRENCY} a_instrument and then l_rp_currency.currency.iso.is_equal ("JPY") then
					Result := rp_currency_jpy (a_ref_system)
				else -- if brimsym is JP then use JPY as currency
					if a_instrument /= Void and then a_instrument.brimsym /= Void and then a_instrument.brimsym.substring (1, 2).is_equal ("JP") then
						Result := rp_currency_jpy (a_ref_system)
					end
				end
			end
		end

	rp_currency_jpy (a_ref_system: RP_REFERENCE_SYSTEM): RP_CURRENCY is
			-- JPY currency
		once
			Result := a_ref_system.currency_from_iso_code ("JPY")
		end

	iso_from_currency (a_currency: CURRENCY): STRING is
			-- return iso code or void
		do
			if a_currency /= Void then
				Result := a_currency.iso
			end
		end

	brimsym_from_listing (a_listing: LISTING; a_date: ROSE_DATE): STRING is
			-- get brimsym from a_instrument on a_date; if void, try using today
		require
			non_void_args: a_listing /= Void and a_date /= Void
		do
			Result := a_listing.brim_code (a_date)
			if Result = Void then
				Result := a_listing.brim_code_most_recent_key (Void)
			end
		end

	usd_currency: RP_CURRENCY is
			-- usd in case currency is not available
		once
			Result := axarosenberg.reference_system.currency_from_iso_code ("USD")
		end

	zero_usd: RP_MONIES is
			-- 0 USD
		once
			 Result := usd_currency.monies (0.)
		end

end
