indexing
	description: "rose capital actions: write-down of capital"
	author: "Janet Small"
	date: "$Date: 2010/04/01 $"
	revision: "$Revision: #4 $"
	archive: "$File: //rose/source/kernel/capital_actions/capact_writedown_of_capital.e $"

class
	CAPACT_WRITEDOWN_OF_CAPITAL
inherit
	CAPACT_CAPITAL_ACTION
	CAPITAL_ACTION_TEMPLATE

feature -- Access


	name : STRING is
		once
			Result := writedown_of_capital_string
		end

	capital_action_type_id: INTEGER is 18


	ending_par_value_currency: CURRENCY
	set_ending_par_value_currency (a_value: like ending_par_value_currency) is
			--set currency of ending par value
		do
			ending_par_value_currency := a_value
		end

	ending_par_value: DOUBLE
	set_ending_par_value (a_value: like ending_par_value) is
			--
		do
			ending_par_value := a_value
		end

	ending_par_value_iso: STRING
	set_ending_par_value_iso (a_value: like ending_par_value_iso) is
			--
		do
			ending_par_value_iso := a_value
		end

	beginning_par_value_currency: CURRENCY
	set_beginning_par_value_currency (a_value: like beginning_par_value_currency) is
			--
		do
			beginning_par_value_currency := a_value
		end

	beginning_par_value: DOUBLE
			-- Beginning par value
			
	set_beginning_par_value (a_value: like beginning_par_value) is
			--
		do
			beginning_par_value := a_value
		end


	beginning_par_value_iso: STRING
	set_beginning_par_value_iso (a_value: like beginning_par_value_iso) is
			--
		do
			beginning_par_value_iso := a_value
		end



feature -- Basic operations

	instantiate_data is
		-- retrieve data items from storage
		local
			s: STRING
		do
			s := string_value(beginning_par_value_expression,signature)
			if s /= Void and then s.is_double then
				set_beginning_par_value(s.to_double)
			end

			s := string_value(beginning_par_value_iso_expression,signature)
			set_beginning_par_value_iso(s)

			s := string_value(ending_par_value_expression,signature)
			if s /= Void and then s.is_double then
				set_ending_par_value(s.to_double)
			end

			s := string_value(ending_par_value_iso_expression,signature)
			set_ending_par_value_iso(s)
		end

	set_data_items is--## not started yet
		-- string_item and integer_item hash tables
		local
			l_variable: CAPACT_VARIABLE_DESCRIPTION_ROW
			s: STRING
		do
			l_variable := variable_table.item("BEGINNING_PAR_VALUE")
			s := format_rate.formatted (beginning_par_value)
			string_items.put(s, l_variable.item_id)

			l_variable := variable_table.item("BEGINNING_PAR_VALUE_CURRENCY")
			string_items.put(beginning_par_value_iso, l_variable.item_id)

			l_variable := variable_table.item("ENDING_PAR_VALUE")
			s := format_rate.formatted (ending_par_value)
			string_items.put(s, l_variable.item_id)

			l_variable := variable_table.item("ENDING_PAR_VALUE_CURRENCY")
			string_items.put(ending_par_value_iso, l_variable.item_id)

		end



feature {NONE} -- Implementation



	beginning_par_value_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			--
		once
			Result := ur_target.expression_from_name("BEGINNING_PAR_VALUE")
		end

	beginning_par_value_iso_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			--
		once
			Result := ur_target.expression_from_name("BEGINNING_PAR_VALUE_CURRENCY")
		end

	ending_par_value_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			--
		once
			Result := ur_target.expression_from_name("ENDING_PAR_VALUE")
		end

	ending_par_value_iso_expression:ROSE_EXPRESSION [ROSE_ENTITY_DATE [ENTITY]] is
			--
		once
			Result := ur_target.expression_from_name("ENDING_PAR_VALUE_CURRENCY")
		end





feature {NONE} -- Implementation

end
