indexing
	description: "Context required by rose_signature_record"
	author: "Janet Small"
	last_editor: "$Author: rj $"
	date: "$Date: 2011/08/31 $"
	revision: "$Revision: #14 $"
	path: "$File: //rose/source/kernel/capital_actions/capital_actions_context_shared.e $"

deferred class CAPITAL_ACTIONS_CONTEXT_SHARED

inherit

	DATABASE_SERVER

	ROSE_SHARED_GLOBAL

	CAPACT_COMMON
		export
			{NONE} all
		end

feature -- Access

	capact_context: CAPITAL_ACTIONS_CONTEXT is
			-- capact context
		once
			create Result.make
		end

	capact_context_name: STRING is "CAPITAL ACTIONS" -- capact context name

	rose_capact_process_name: STRING -- rose capact process name


feature -- Basic operations

	rose_capital_action_server (a_zone: ZONE[LOCATION]): SQL_DATA_SERVER is
			-- rose capital action server by zone
		require
			valid_zone: valid_zone(a_zone)
		do
			capact_servers.search (a_zone.mnemonic)
			if capact_servers.found then
				Result := capact_servers.found_item
			end
		ensure
			result_not_void: Result /= Void
		end

	valid_zone(a_zone: ZONE[LOCATION]): BOOLEAN
	-- Used as a precondition for 'rose_capital_action_server'.
	do
		Result := a_zone/=Void and then capact_servers.has (a_zone.mnemonic)
	end

feature {NONE} -- Implementation

	capact_servers: DS_HASH_TABLE [SQL_DATA_SERVER, CHARACTER] is
			-- Server by zone
		once
			Create Result.make_default
			Result.force (servers.rose_capital_action_u_server, rose_context.u_zone.mnemonic)
			Result.force (servers.rose_capital_action_j_server,rose_context.j_zone.mnemonic)
			Result.force (servers.rose_capital_action_c_server,rose_context.c_zone.mnemonic)
			Result.force (servers.rose_capital_action_e_server,rose_context.e_zone.mnemonic)
			Result.force (servers.rose_capital_action_o_server,rose_context.o_zone.mnemonic)
			Result.force (servers.rose_capital_action_s_server,rose_context.s_zone.mnemonic)
		end

end
