indexing
	description : "[
		SIMPLE_PREDICATE which creates and populates an array of vessels from the retrieved rows
		]"
	author : "Mark Howard"
	last_editor: "$Author: fa $"
	date: "$Date: 2010/02/08 $"
	revision: "$Revision: #21 $"

class
	COLLECTING_PREDICATE[G -> ANY create default_create end]
inherit
	SIMPLE_PREDICATE[G]
		rename
			make_with_parameter_template as simple_predicate_make_with_parameter_template
		redefine
			make,
			reset_container
		end

create
	make, make_verbose, make_with_parameter_template, make_strict

feature {NONE} -- Creation

	make (a_server : DATA_SERVER; a_statement : STRING) is
			-- Initialize predicate for a server and SQL statement
		do
        		make_with_parameter_template(a_server, a_statement, Void)
       		end

   	make_with_parameter_template(a_server : DATA_SERVER;
                                a_statement : STRING;
                                a_parameter_template: ARRAY[STRING]) is
			-- Initialize predicate for a server and SQL statement,
			-- with known parameter types specified with `a_parameter_template'
		do
			simple_predicate_make_with_parameter_template(a_server, new_vessel, a_statement, a_parameter_template)
			create array.make_empty
			set_container_internal(array)
			selection := a_statement
	 	end

feature -- Access

 	array : ROSE_LINEAR_ARRAY[G]
   			-- Array holding rows with data result

feature -- Setting

	reset_container is
			-- Clear container bound with query
		do
			if container_set then
				Precursor
			else
				reset_array
				set_container_internal(array)
			end
		end

	reset_array is
			-- Clear array implementing underlying container
		do
			if container_set then
				array.wipe_out
			else
			 	create array.make_empty
			end
			index := 0
		ensure
			array_not_void: array /= Void
			array_empty: array.is_empty
		end

end -- class COLLECTING_PREDICATE
