indexing

	description: "Create instance context constants"
	status: "See notice at end of class"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #3 $"
	
class
	COM_CLSCTX

feature -- Access

	Clsctx_inproc_server: INTEGER is
			-- The code that creates and manages objects of 
			-- descendant class runs in the same process as the 
			-- caller of the function specifying the class context. 
		external
			"C [macro <wtypes.h>]"
		alias
			"CLSCTX_INPROC_SERVER"
		end
		
	Clsctx_inproc_handler: INTEGER is
			-- The code that manages objects of descendant class
			-- is an in-process handler. This is a DLL that runs 
			-- in the client process and implements client-side 
			-- structures of this class when instances of the 
			-- class are accessed remotely. 
		external
			"C [macro <wtypes.h>]"
		alias
			"CLSCTX_INPROC_SERVER"
		end			
		
	Clsctx_local_server: INTEGER is
			-- The EXE code that creates and manages objects of
			-- descendant class is loaded in a separate process space
			-- (runs on same machine but in a different process).
		external
			"C [macro <wtypes.h>]"
		alias
			"CLSCTX_LOCAL_SERVER"
		end
		
	Clsctx_server: INTEGER is
			-- Indicates server code, whether in-process or local.
		external
			"C [macro <objbase.h>]"
		alias
			"CLSCTX_SERVER"
		end
		
	Clsctx_all: INTEGER is
			-- Indicates all class contexts.
		external
			"C [macro <objbase.h>]"
		alias
			"CLSCTX_ALL"
		end
		

end -- class EOLE_CLSCTX
