indexing
	description: ""
	author: ""
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #8 $"

class
	COM_DISPPARAMS

inherit
	COM_SMART_STRUCTURE [RUN_TIME_MEMORY_MODEL]
		redefine
			make,
			release
		end

create
	make,
	make_by_pointer

feature -- Initialization


	make_by_pointer (p: POINTER) is do
		item := p
		memory_model := 3
	end
	make is
		do
			precursor
			set_rgvarg (calloc(MAXPARAMS, sizeofVARIANTARG ))
			set_rgdispidNamedArgs(calloc(MAXPARAMS, 4))
		end

	release is
		do
			if (memory_model /= 3) then

			reset
			free (get_rgvarg)
			free (get_rgdispidNamedArgs)
			end
			precursor
		end

	MAXPARAMS: INTEGER is 40

	init is
		do
			reset
		end;

	reset is
		local
			i: INTEGER
			var_ptr: POINTER
		do
			from i := 0 until i >= get_cargs loop
				var_ptr := get_rgvarg
				var_ptr := var_ptr + (i* sizeofVARIANTARG )
				VariantClear(var_ptr)
				i := i + 1
			end
			set_cargs(0)
			set_cnamedargs(0)
		end

	add_named_arg_dispid (id: INTEGER) is
		local
			var_ptr: POINTER
		do
			var_ptr := get_rgdispidNamedArgs
			var_ptr := var_ptr + (get_cNamedArgs* 4)
			var_ptr.memory_copy ($id, 4)
			set_cnamedargs (get_cnamedargs + 1)
		end;

	add_argument (a_value: COM_VARIANT) is
		local
			var_ptr: POINTER
		do
			var_ptr := get_rgvarg
			var_ptr := var_ptr + (get_cargs * sizeofVARIANTARG )
			VariantCopy(var_ptr, a_value.item)
			set_cargs(get_cargs + 1)
		end;

	get_value (a_index: INTEGER): ANY is
	local
		v: COM_VARIANT
			var_ptr: POINTER
		do
			create v;
			var_ptr := get_rgvarg
			var_ptr := var_ptr + (a_index * sizeofVARIANTARG )
			v.set (var_ptr)
			Result := v.to_any
		end

	get_boolean_value (a_index: INTEGER): BOOLEAN is
	local
		v: COM_VARIANT
			var_ptr: POINTER
		do
			create v;
			var_ptr := get_rgvarg
			var_ptr := var_ptr + (a_index * sizeofVARIANTARG )
			v.set (var_ptr)
			Result := v.boolean
		end

	get_integer_array_value (a_index: INTEGER): ARRAY[INTEGER] is
	local
		v: COM_VARIANT
			var_ptr: POINTER
		do
			create v;
			var_ptr := get_rgvarg
			var_ptr := var_ptr + (a_index * sizeofVARIANTARG )
			v.set (var_ptr)
			Result := v.to_int_array
		end

	get_string_array_value (a_index: INTEGER): ARRAY[STRING] is
	local
		v: COM_VARIANT
			var_ptr: POINTER
		do
			create v;
			var_ptr := get_rgvarg
			var_ptr := var_ptr + (a_index * sizeofVARIANTARG )
			v.set (var_ptr)
			Result := v.to_string_array
		end

	VariantCopy(p1, p2: POINTER) is
		external
			"C [macro <windows.h>](VARIANTARG FAR  *, VARIANTARG FAR *)"
		alias
			"VariantCopy"
		end

	VariantClear(p1: POINTER)is
		external
			"C [macro <windows.h>](VARIANTARG FAR  *)"
		alias
			"VariantClear"
		end

	sizeofVARIANTARG : INTEGER is
		external
			"C [macro <windows.h>]"
		alias
			"sizeof(VARIANTARG)"
		end

	cwel_size_of_dispparams: INTEGER is
		external
			"C [macro <windows.h>] "
		alias
			"sizeof(DISPPARAMS)"
		end;

	structure_size: INTEGER is
		do
			Result := cwel_size_of_dispparams
		end;

	offsetofrgvarg: INTEGER is
		external
			"C [macro <windows.h>]"
		alias
			"offsetof(DISPPARAMS, rgvarg)"
		end;

	set_rgvarg (a_value: POINTER) is
		do
			set_pointer_value (a_value, offsetofrgvarg)
		end;

	get_rgvarg: POINTER is
		do
			Result := get_pointer_value (offsetofrgvarg)
		end;

	offsetofrgdispidnamedargs: INTEGER is
		external
			"C [macro <windows.h>]"
		alias
			"offsetof(DISPPARAMS, rgdispidNamedArgs)"
		end;

	set_rgdispidnamedargs (a_value: POINTER) is
		do
			set_pointer_value (a_value, offsetofrgdispidnamedargs)
		end;

	get_rgdispidnamedargs: POINTER is
		do
			Result := get_pointer_value (offsetofrgdispidnamedargs)
		end;

	offsetofcargs: INTEGER is
		external
			"C [macro <windows.h>]"
		alias
			"offsetof(DISPPARAMS, cArgs)"
		end;

	set_cargs (a_value: INTEGER) is
		do
			set_integer_value (a_value, offsetofcargs)
		end;

	get_cargs: INTEGER is
		do
			Result := get_integer_value (offsetofcargs)
		end;

	offsetofcnamedargs: INTEGER is
		external
			"C [macro <windows.h>]"
		alias
			"offsetof(DISPPARAMS, cNamedArgs)"
		end

	set_cnamedargs (a_value: INTEGER) is
		do
			set_integer_value (a_value, offsetofcnamedargs)
		end

	get_cnamedargs: INTEGER is
		do
			Result := get_integer_value (offsetofcnamedargs)
		end

end
