indexing
	description: ""
	author: "Pierre Nallet"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #11 $"

class
	COM_EXCEPINFO

inherit
	COM_SMART_STRUCTURE [RUN_TIME_MEMORY_MODEL]
	COM_STRING_FUNCTIONS
		undefine
			is_equal, copy
		end

feature -- Initialization

	init is
		do
			release
			make
		end

feature -- Access

	error_description: STRING is
			-- Textual, human-readable description of error intended for customer
		do
			Result := widechar_to_string (get_bstrDescription)
		end

	error_code: INTEGER is
		do
			Result := get_wcode
		end

	structure_size: INTEGER is
		do
			Result := cwel_size_of_excepinfo
		end

	get_wCode: INTEGER is do Result := get_integer_value (offsetofwCode) end
	get_wReserved: INTEGER is do Result := get_integer_value (offsetofwReserved) end
	get_bstrSource: POINTER is do Result := get_pointer_value (offsetofbstrSource) end
	get_bstrDescription: POINTER is do Result := get_pointer_value (offsetofbstrDescription) end
	get_bstrHelpFile: POINTER is do Result := get_pointer_value (offsetofbstrHelpFile) end
	get_dwHelpContext: INTEGER is do Result := get_integer_value (offsetofdwHelpContext) end
	get_pvReserved: POINTER is do Result := get_pointer_value (offsetofpvReserved) end

feature -- Status setting

	set_wCode (a_value: INTEGER) is do set_integer_value (a_value, offsetofwCode) end
	set_wReserved (a_value: INTEGER) is do set_INTEGER_value (a_value, offsetofwReserved) end
	set_bstrSource (a_value: POINTER) is do set_pointer_value (a_value, offsetofbstrSource) end
	set_bstrDescription (a_value: POINTER) is do set_pointer_value (a_value,offsetofbstrDescription) end
	set_bstrHelpFile (a_value: POINTER) is do set_pointer_value (a_value, offsetofbstrHelpFile) end
	set_dwHelpContext (a_value:INTEGER) is do set_integer_value (a_value,offsetofdwHelpContext) end
	set_pvReserved (a_value:POINTER) is do set_pointer_value (a_value, offsetofpvReserved) end

feature {NONE} -- Implementation

	cwel_size_of_excepinfo: INTEGER is external "C [macro <allwindows.h>] " alias "sizeof(EXCEPINFO)" end
	offsetofwCode: INTEGER is external "C [macro <allwindows.h >]" alias "offsetof(EXCEPINFO, wCode)" end
	offsetofwReserved: INTEGER is external "C [macro <allwindows.h>]" alias "offsetof(EXCEPINFO, wReserved)" end
	offsetofbstrSource: INTEGER is external "C [macro <allwindows.h>]" alias "offsetof(EXCEPINFO, bstrSource)" end
	offsetofbstrDescription: INTEGER is external "C [macro <allwindows.h>]" alias "offsetof(EXCEPINFO, bstrDescription)" end
	offsetofbstrHelpFile: INTEGER is external "C [macro <allwindows.h>]" alias "offsetof(EXCEPINFO, bstrHelpFile)" end
	offsetofdwHelpContext: INTEGER is external "C [macro <allwindows.h>]" alias "offsetof(EXCEPINFO, dwHelpContext)" end
	offsetofpvReserved: INTEGER is external "C [macro <allwindows.h>]" alias "offsetof(EXCEPINFO, pvReserved)" end

end
