indexing
	description: ""
	author: "Pierre Nallet"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #15 $"

class
	COM_GUID [MM -> MEMORY_MODEL create default_create end]

inherit
	COM_SMART_STRUCTURE [MM]
	COM_RUN_TIME
		undefine
			is_equal,
			copy
		end
	HASHABLE
		undefine
			is_equal,
			copy
		end

create
	make

feature -- Access

	hash_code: INTEGER is
		do
			Result := to_string_.hash_code
		end

	structure_size: INTEGER is
		do
			Result := sizeofguid
		end

	upper_string (s: STRING): STRING is
		do
			Result := clone (s)
			Result.to_upper
		end

	to_string_: STRING is
		do
			Result := guid_to_string (item)
		end

feature -- Basic operations

	set_from_string (a_string: STRING) is
		local
			p: POINTER
			hr: INTEGER
		do
			p := string_to_widechar (a_string)
			hr := CLSIDFromString (p,item)
			free (p)
		ensure
			string_set: equal (upper_string (to_string_) , upper_string (a_string))
		end

	set_from_progid (a_prog_id: STRING) is
		local
			p: POINTER
			hr: INTEGER
		do
			p := string_to_widechar (a_prog_id)
			hr := CLSIDFromProgID (p, item)
			free (p)
		end

feature {NONE} -- Implementation

	sizeofguid: INTEGER is
		external
			"C [macro <windows.h>]"
		alias
			"sizeof(GUID)"
		end

end -- class COM_GUID
