indexing
	description: "Portable com helper"
	author: ""
	last_editor: "$Author: it $"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #4 $"
	archive: "$File: //rose/source/kernel/infrastructure/windows/com/classic/com_helper.e $"

class
	COM_HELPER
inherit COM_IUNKNOWN_INTERFACE
	COM_VARENUM
	ROSE_CONSTANTS

feature -- Access

feature -- Basic operations

	release (a_object: COM_UNKNOWN) is
		-- Release the com object
		do
			release_result (a_object).do_nothing
		end

	release_result (a_object: COM_UNKNOWN): INTEGER is
		-- Release the com object and return the reference count
		do
			Result := IUnknown_Release(a_object.p)
		end

	missing: ANY is
			-- Missing parameter
		do

		end

	com_array2 (a: ARRAY2[ANY]): ANY
		-- Com representation of a ARRAY2
		do
			Result := array2_to_safe_array (a)
		end

	array2_to_safe_array (array: ARRAY2 [ANY]): COM_SAFEARRAY is
			-- Utility function to transform an array into a safearray
		local
			i, j: INTEGER
			l_bounds: COM_SAFEARRAY_BOUND
			a: ANY
			r: REAL_REF
			d: DOUBLE_REF
			s: STRING
			ii: INTEGER_REF
			l_date : ROSE_DATE
			var : COM_VARIANT
		do
			create l_bounds.make (2)
			create var
			var.init
			l_bounds.set_element_count (1, array.height)
			l_bounds.set_lower_bound (1, 1)
			l_bounds.set_element_count (2, array.width)
			l_bounds.set_lower_bound (2, 1)
			create Result.make (2, VT_VARIANT, l_bounds)
			from i := 1 until i > array.height loop
				from j := 1 until j > array.width loop
					a := array.item (i, j)
					r ?= a
					if r /= Void then
						if is_defined_real(r.item) then
							var.set_real4 (r.item)
						elseif not constants.ieee.isfinite(r.item) then
							var.set_from_string("#DIV/0!")
						else
							var.set_from_string("#N/A")
						end
					else
						d ?= a
						if d /= Void then
							if is_defined_double(d.item) then
								var.set_real8 (d.item)
							elseif not constants.ieee.isfinite(d.item) then
								var.set_from_string("#DIV/0!")
							else
								var.set_from_string("#N/A")
							end
						else
							ii ?= a
							if ii /= Void then
								var.set_integer4 (ii.item)
							else
								l_date ?= a
								if l_date /= Void then
									s := l_date.ccyymmdd.out
								else
									s ?= a
								end
								if s = Void then
									s := ""
								end
								var.set_from_string (s)
							end
						end
					end
					Result.put_element (<<i, j>>, var)
					j := j + 1
				end
				i := i + 1
			end
		end


	string (s: STRING): STRING is
			-- .net compatibility for strings
		do
			 Result := s
		end




feature {NONE} -- Implementation

end
