indexing
	description: "COM IUnknown interface"
	author: "Pierre Nallet"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #8 $"
	archive: "$File: //rose/source/kernel/infrastructure/windows/com/com_iunknown_interface.e $"

class
	COM_IUNKNOWN_INTERFACE

feature -- Access

	IUnknown_QueryInterface (this, iid, other: POINTER): INTEGER is
			-- Retrieves an interface for a service from a specified object
		external
			"C blocking inline use <ecom.h>"
		alias
			"[
#ifdef __cplusplus
			return (EIF_INTEGER) ((IUnknown*)$this)->QueryInterface((REFIID)$iid, (void**)$other);
#else
			return (EIF_INTEGER)IUnknown_QueryInterface((IUnknown*)$this, (REFIID)$iid, (void**)$other);
#endif
			]"
		end

	IUnknown_AddRef (this: POINTER): INTEGER is
			-- The IUnknown_AddRef_Proxy function implements the AddRef method for all interface proxies
		external
			"C blocking inline use <ecom.h>"
		alias
			"[
#ifdef __cplusplus
			return (EIF_INTEGER) ((IUnknown*)$this)->AddRef();
#else
			return (EIF_INTEGER)IUnknown_AddRef((IUnknown*)$this);
#endif
			]"
		end

	IUnknown_Release (this: POINTER): INTEGER is
			-- The IUnknown_Release_Proxy function implements the Release method for all interface proxies
		external
			"C blocking inline use <ecom.h>"
		alias
			"[
#ifdef __cplusplus
			return (EIF_INTEGER) ((IUnknown*)$this)->Release();
#else
			return (EIF_INTEGER)IUnknown_Release((IUnknown*)$this);
#endif
			]"
		end

end
