indexing
	description: "COM memory model"
	author: "Pierre Nallet"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #7 $"

class
	COM_MEMORY_MODEL

inherit
	MEMORY_MODEL

feature -- Access

	id: INTEGER is 2
			-- Identification of this MEMORY_MODEL

	alloc (a_size: INTEGER): POINTER is
			-- Address of new allocated memory buffer with 'a_size' in bytes
		do
			Result := CoTaskMemAlloc (a_size)
		end

feature -- Basic operations

	free (a_pointer: POINTER) is
			-- Free memory block pointed by 'a_pointer'.
		do
			CoTaskMemFree (a_pointer)
		end

feature {NONE} -- Implementation

	CoTaskMemAlloc (cb: INTEGER) : POINTER is
		external
			"C [macro <windows.h>](ULONG): EIF_POINTER"
		alias
			"CoTaskMemAlloc"
		end

	CoTaskMemFree(pv: POINTER) is
		external
			"C [macro <windows.h>](LPVOID )"
		alias
			"CoTaskMemFree"
		end

end -- class COM_MEMORY_MODEL
