indexing
	description: ""
	author: "Pierre Nallet"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #20 $"

deferred class
	COM_SMART_STRUCTURE [MM -> MEMORY_MODEL create default_create end]

inherit
	COM_STRUCTURE
		redefine
			set
		end

	MEMORY
		rename
			free as eiffel_free
		undefine
			is_equal,
			copy
		redefine
			dispose
		end

feature {NONE} -- Initialization

	make is
		local
			l_model: MM
		do
			create l_model.default_create
			memory_model := l_model.id
			item := l_model.alloc (structure_size)
		end

feature -- Access

	memory_model: INTEGER
			-- Associated memory model

feature -- Basic operations

	set (p: POINTER) is
		local
			l_model: MM
		do
			if memory_model = 0 then
				create l_model.default_create
				memory_model := l_model.id
			end
			dispose
			item := p
		end

	dispose is
		do
			release
		end

	release is
		do
			if item /= default_pointer then
--				memory_model.free (item)
				inspect memory_model
				when 1 then
					-- RUN_TIME_MEMORY_MODEL
					c_free (item)
				when 2 then
					-- COM_MEMORY_MODEL
					CoTaskMemFree (item)
				when 3 then
					-- STACK_MEMORY_MODEL
				else
					print ("Warning: uknown memory model " + memory_model.out + "%N")
				end
				item := default_pointer
			end
		end

feature {NONE} -- Implementation

	c_calloc (a_size, a_byte_size: INTEGER): POINTER is
		external
			"C [macro <string.h>] (size_t, size_t): EIF_POINTER"
		alias
			"calloc"
		end

	c_free (a_pointer: POINTER) is
		external
			"C [macro <string.h>] (void *) "
		alias
			"free"
		end

	CoTaskMemAlloc (cb: INTEGER) : POINTER is
		external
			"C [macro <windows.h>](ULONG): EIF_POINTER"
		alias
			"CoTaskMemAlloc"
		end

	CoTaskMemFree(pv: POINTER) is
		external
			"C [macro <windows.h>](LPVOID )"
		alias
			"CoTaskMemFree"
		end

end -- class OLEDB_SMART_STRUCTURE
