note

	description:

		"Constant boolean value"

	author: "Pierre Nallet"
	last_editor: "$Author: it $"
	date: "$Date: 2014/03/14 $"
	revision: "$Revision: #4 $"
	path: "$File: //rose/source/kernel/math/constant_boolean_expression.e $"

class
	CONSTANT_BOOLEAN_EXPRESSION [reference G]
inherit
	CONSTANT_EXPRESSION [G]
		undefine
			boolean_value
		end

creation

	make_boolean

feature {NONE} -- Initialization

	make_boolean (a_boolean : BOOLEAN) is
			-- Create a new constant value
		do
			set_expression_index
			type := {INTERNAL}.Boolean_type
			boolean_constant_value := a_boolean
			name := a_boolean.out
			create variable_description
			variable_description.set_name(name)
			variable_description.set_mnemonic(name)
			variable_description.set_type ("boolean")
		end

feature -- Access

	boolean_constant_value : BOOLEAN
		-- Actual value
	boolean_value (a_entity : G) : BOOLEAN is
		-- Boolean value
		do
			Result := boolean_constant_value
		end

feature -- Basic operations

	set_boolean (a_boolean : BOOLEAN) is
			-- Set the boolean value
		do
			type := {INTERNAL}.Boolean_type
			boolean_constant_value := a_boolean
		end


end
