indexing
	description: "Contexts accessor"
	author: "Mark Howard"
	last_editor: "$Author: rj $"
	date: "$Date: 2012/07/30 $"
	revision: "$Revision: #4 $"
	path: "$File: //rose/source/kernel/supplier_data/context_aware.e $"

deferred class
	CONTEXT_AWARE

inherit
	CONTEXT_ANCHOR
		undefine
			is_equal
		end

	ANY
		undefine
			is_equal
		end

feature -- Access

	contexts : CONTEXT_DESCRIPTORS is
			-- Shared contexts array
		once
			create Result.make
		end

	context_from_index (a_index : INTEGER): SUPPLIER_CONTEXT
			-- Context for 'a_index' in the contexts array
		do
			Result := context_from_descriptor (contexts.descriptor_from_index(a_index))
		end

	context_from_supplier_id (a_id : INTEGER): SUPPLIER_CONTEXT
			-- Context with supplier_id 'a_id'
		do
			Result := context_from_descriptor (contexts.descriptor_from_supplier_id(a_id))
		end

	existing_context_from_name (a_name : STRING): SUPPLIER_CONTEXT
			-- Context with name 'a_name'
		do
			Result := context_from_descriptor (contexts.descriptor_from_name(a_name))
		end

feature {NONE} -- Implementation

	context_from_descriptor (a_descriptor: CONTEXT_DESCRIPTOR): SUPPLIER_CONTEXT
			-- 'a_descriptor' context
		do
			if a_descriptor /= Void then
				Result := a_descriptor.context
			end
		end

end
