indexing
	description: "n/a"
	author: "Mark Howard"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/02/16 $"
	revision: "$Revision: #5 $"
	path: "$File: //rose/source/kernel/supplier_data/context_descriptor.e $"

class
	CONTEXT_DESCRIPTOR

inherit
	DATABASE_SERVER

	DEBUG_OUTPUT

	CONTEXT_CLIENT

	ROSE_CONTEXT_AWARE
create
	make

feature {NONE} -- Initialization

	make (a_supplier_name,a_name : STRING;a_index : INTEGER) is
		--note that context is not set here.  this is because this class cannot know about specific contexts, so they are added
		--as they are created.  If this class knew about specific contexts then we would not be able to vertically partition our
		--classes by vendor.
		do
			supplier_name := a_supplier_name
			name := a_name
			index := a_index
			supplier_id := servers.supplier_product_id_by_name (a_supplier_name)
		end

feature -- Acces

	supplier_name : STRING

	name : STRING

	index : INTEGER

	supplier_id : INTEGER

feature -- Output

	debug_output : STRING is
			-- <Precursor>
		do
			Result := supplier_name + " : " + name + " : " + supplier_id.out + " : " + index.out
		end
	uses_rose_foregound_ids : BOOLEAN
			-- Are we using entity ids from ROSE_ENTITY_FOREGROUND?
		do
			Result :=
				supplier_name ~ rose_entity_foreground_name or else
				supplier_name ~ research_name or else
				supplier_name ~ model_name
		end
	uses_rose_background_ids : BOOLEAN
			-- Are we using entity ids from ROSE_ENTITY_BACKGROUND?
		do
			Result := supplier_name ~ rose_entity_background_name
		end
	uses_rose_ids : BOOLEAN
			-- Are we using rose entity ids?
		do
			Result := uses_rose_foregound_ids or else uses_rose_background_ids
		end
end
