indexing
	description: "A Collection of all known Context Descriptors"
	author: "Mark Howard"
	date: "$Date: 2013/04/01 $"
	last_editor: "$Author: da $"
	revision: "$Revision: #70 $"
 	path: "$File: //rose/source/kernel/supplier_data/context_descriptors.e $"

class
	CONTEXT_DESCRIPTORS

inherit
	DATABASE_SERVER
	CONTEXT_ANCHOR
	ROSE_CONTEXT_AWARE
create
	make, make_no_db

feature -- Descriptor list

	descriptor_list: ARRAY[TUPLE[db_name: STRING; context_name: STRING; context_index: INTEGER]] is
			-- List of descriptors
		once
			Result := <<
				-- do not change the order of these descriptors! You can add to the end, but changing the order will
				-- cause stored entities to think that they belong to the wrong context
				-- Please also update `descriptor_count'
				--
				-- For a supplier to appear in the Data platform, 3 names are to be identical:
				-- 1.the second string of the following array
				-- 2.the name in rose_entity_background.supplier_product
				-- 3.the name in supplier_CONTEXT class
				--   in the case that no supplier_CONTEXT class is needed then the first name
				--   and the second name of in the array have to be *identical* and therefore
				--   equal to the name of the database.
				--
				[rose_entity_background_name,rose_entity_background_name,1],
				["PORTFOLIO CHARACTERISTIC","PORTFOLIO CHARACTERISTIC",2],
				["NIKKEI_NEW","NIKKEI_NEW",3],
				["NIKKEI_NEW","NIKKEI",4],
				["NIKKEI_NEW","NIKKEI PROD",5],
				["TEJ","TEJ",6],
				["PRIMARK","PRIMARK",7],
				["GLOBAL VANTAGE","GLOBAL VANTAGE",8],
				["NOMURA","NOMURA",9],
				["WORLDSCOPE_2","WORLDSCOPE_2",10],
				["WORLDSCOPE_2","WORLDSCOPE",11],
				["COMPUSTAT","COMPUSTAT",12],
				["COMPUSTAT CANADA","COMPUSTAT CANADA",13],
				[ibes_name,ibes_name,14],
				["ZACKS","ZACKS",15],
				["DATALINE","DATALINE",16],
				["BLOOMBERG EQUITY","BLOOMBERG EQUITY",17],
				["REUTERS","REUTERS",18],
				["IDSI","IDSI",19],
				["IDSI","IDSI PRICE",20],
				["IDSI CANADA","IDSI CANADA",21],
				["XPRESSFEED","XPRESSFEED",22],
				["VALUELINE","VALUELINE",23],
				["CRSP","CRSP",24],
				["INFOGLOBE","INFOGLOBE",25],
				["BARRA","BARRA",26],
				["SIGNATURE_TAGGED_DATABASES","SIGNATURE TAGGED DATABASE",27],
				["RISK MODEL","RISK MODEL",28],
				["RISK UNIVERSE","RISK UNIVERSE",29],
				["ROSE","ROSE",30],
				["BRIM ENTITIES","BRIM ENTITIES",31],
				[rose_entity_foreground_name,"RESEARCH",32],
				[rose_entity_foreground_name,rose_entity_foreground_name,33],
				["MSCI","MSCI",34],
				["FTSE","FTSE",35],
				["CRI","CRI",36],
				["HSBC","HSBC",37],
				["RUSSELL","RUSSELL",38],
				["STOXX","STOXX",39],
				["STANDARD AND POORS","STANDARD AND POORS",40],
				["CITIBANK","CITIBANK",41],
				["INDEX_SIMULATION","INDEX_SIMULATION",42],
				["TOPIX","TOPIX",43],
				["MULTEX","MULTEX",44],
				["TELEKURS","TELEKURS",45],
				["INTEGRATION_W","INTEGRATION_W",46],
				["GLOBAL CLIENT","GLOBAL CLIENT",47],
				["SUPPLIER_PRODUCT","SUPPLIER_PRODUCT",48],
				["SPECTRUM","SPECTRUM",49],
				["RC_DEVELOPMENT","RC_DEVELOPMENT",50],
				["ROSE ENTITY ARCHIVE","ROSE ENTITY ARCHIVE",51],
				["BRIM_CAPITAL_ACTIONS","BRIM_CAPITAL_ACTIONS",52],
				["CAPITAL_ACTIONS","CAPITAL_ACTIONS",53],
				["TOYO_KEIZAI","TOYO_KEIZAI",54],
				["ROSE_CHANGE_CASCADE","ROSE_CHANGE_CASCADE",55],
				["SWX","SWX",56],
				["ROSE CAPITAL ACTION","ROSE CAPITAL ACTION",57],
				["ACTIVE BATCH","ACTIVE BATCH",58],
				["TASKS","TASKS",59],
				["MODEL","MODEL",60],
				["SURVEY","SURVEY",61],
				["DATALINE_CAPITAL_ACTIONS","DATALINE_CAPITAL_ACTIONS",62],
				["PACAP","PACAP",63],
				["LEGACY_EXTEL_BUSINESS_SEGMENTS","LEGACY_EXTEL_BUSINESS_SEGMENTS",64],
				["DOW_JONES","DOW_JONES",65],
				["ROSE OVERRIDE","ROSE OVERRIDE",66],
				["BLOOMBERG_CURRENCY","BLOOMBERG CURRENCY",67],
				["COMPUSTAT_SEGMENT","COMPUSTAT_SEGMENT",68],
				["QUOP","QUOP",69],
				["IDC","IDC",70],
				["BRSTEARNS_SHORT","BRSTEARNS_SHORT",71],
				["TSX","TSX",72],
				["WILSHIRE","WILSHIRE",73],
				["NYSE_SHORT_INTEREST","NYSE_SHORT_INTEREST",74],
				["NASDAQ_SHORT_INTEREST","NASDAQ_SHORT_INTEREST",75],
				["AMEX_SHORT_INTEREST","AMEX_SHORT_INTEREST",76],
				["PROCESS_FLOWS", "PROCESS_FLOWS", 77],
				["QUOP INSTRUCTION SET", "QUOP INSTRUCTION SET", 78],
				["COMPOSITE_ASSETS", "COMPOSITE_ASSETS", 79],
				["COMPUSTAT_SEGMENT_LEGACY", "COMPUSTAT_SEGMENT_LEGACY", 80],
				[rose_entity_foreground_name,"PERSISTENT ROSE",81],
				["ECONOMATICA","ECONOMATICA", 82],
				["COMPUSTAT SEGMENT TAGGED", "COMPUSTAT SEGMENT TAGGED", 83],
				["COMPUSTAT SEGMENT LEGACY TAGGED", "COMPUSTAT SEGMENT LEGACY TAGGED", 84],
				["STARMINE","STARMINE", 85],
				["REVERE","REVERE", 86],
				["SUPPLIER_PRODUCT_FILE", "SUPPLIER_PRODUCT_FILE", 87],
				["ROSE ENTITY BACKGROUND NEW", "ROSE ENTITY BACKGROUND NEW", 88],
				["SDN", "SDN", 89],
				["DARK_POOLS", "DARK_POOLS", 90],
				["FINANCIAL_CALENDAR", "FINANCIAL_CALENDAR", 91],
				["HFR", "HFR", 92],
				["THOMSON_DEALS", "THOMSON_DEALS", 93],
		                ["MULTEX_TEST","MULTEX_TEST",94],
				["TELEKURS_TEST","TELEKURS_TEST",95],
				["TFO","TFO",96],
				["CAPITALIQ","CAPITALIQ", 97],
				["NORTHERN TRUST","NORTHERN TRUST", 98]
			>>
		ensure
			last_index_equal_descriptor_count: Result /= Void and then Result [Result.upper].context_index = descriptor_count
		end

	descriptor_count: INTEGER is 98
			-- This should be equal to the highest descriptor id. It is needed to initialize some arrays,
			-- when DB access is not yet available

feature {NONE} -- Creation

	make is
			-- Creates list of known descriptors to index into the entity database
		do
			make_descriptors(descriptor_list)
		end

	make_no_db is
			-- This creates a special object that does not access the DB
		local
			l_i: INTEGER
		do
			no_db_mode := True
			create index_from_name.make (descriptor_count)
			from
				l_i := descriptor_list.lower
			until
				l_i > descriptor_list.upper
			loop
				index_from_name.put (descriptor_list.item (l_i).context_index, descriptor_list.item (l_i).context_name)
				l_i := l_i + 1
			end
		end

feature -- Descriptor access

	descriptors : ROSE_LINEAR_ARRAY[CONTEXT_DESCRIPTOR]
		-- List of descriptors mapping the foreground supplier_product_id to a name for a context.
	descriptor_from_index (a_index : INTEGER) : CONTEXT_DESCRIPTOR is
			-- Return a descriptor for 'a_index` which is known by the context class.
		require
			not_no_db: not no_db_mode
		do
			Result := descriptors.safe_item(a_index)
		end
	descriptor_from_supplier_id (a_id : INTEGER) : CONTEXT_DESCRIPTOR is
			-- Return a descriptor for 'a_id` which is known by the supplier_product_id table.
		require
			not_no_db: not no_db_mode
		do
			Result := descriptors_by_supplier_id.safe_item(a_id)
		end
	descriptor_from_name (a_name : STRING) : CONTEXT_DESCRIPTOR is
			-- Return descriptor from 'a_name` which is known by the name.
		require
			not_no_db: not no_db_mode
		do
			Result := descriptors_by_name.item(a_name.as_upper)
		end
	context_uses_rose_foreground_ids(a_supplier_id : INTEGER) : BOOLEAN
			-- Does the context with supplier_id 'a_supplier_id' use rose_ids
		local
			l_descriptor : CONTEXT_DESCRIPTOR
		do
			l_descriptor := descriptor_from_supplier_id (a_supplier_id)
			Result := l_descriptor /= Void and then l_descriptor.uses_rose_foregound_ids
		end
	context_uses_rose_background_ids(a_supplier_id : INTEGER) : BOOLEAN
			-- Does the context with supplier_id 'a_supplier_id' use rose_ids
		local
			l_descriptor : CONTEXT_DESCRIPTOR
		do
			l_descriptor := descriptor_from_supplier_id (a_supplier_id)
			Result := l_descriptor /= Void and then l_descriptor.uses_rose_background_ids
		end
	ibes_supplier_id :INTEGER
			-- Supplier_id of ibes
		local
			l_descriptor : CONTEXT_DESCRIPTOR
		do
			l_descriptor := descriptor_from_name(ibes_name)
			Result := l_descriptor.supplier_id
		end
feature {ENTITY_ACCESSORS, CONTEXT_DESCRIPTORS} -- Context access

	-- SM 20090825: I temporarily removed  {SUPPLIER_CONTEXT} from the export list but
	-- this should be restored to {ENTITIES_SUPPLIER} after Rose Journal is merged

	add_context (a_context : like context_anchor) is
			-- Add a context 'a_context` to an existing context.
		require
			valid_context: a_context /= Void and a_context.name /= void
			not_no_db: not no_db_mode
		local
			l_descriptor : CONTEXT_DESCRIPTOR
		do
			l_descriptor := descriptors_by_name.item(a_context.name)
			if l_descriptor /= Void then
				l_descriptor.set_context(a_context)
				a_context.set_descriptor(l_descriptor)
			end
		end
	descriptors_by_name : HASH_TABLE[CONTEXT_DESCRIPTOR,STRING]
		-- Return descriptor which corresponds to a name in the hash table.
	descriptors_by_supplier_id : ROSE_LINEAR_ARRAY[CONTEXT_DESCRIPTOR]
		-- Return supplier_id which is in the supplier_product id table.

feature {NONE} -- Implemention
	make_descriptors (a_array : ARRAY[TUPLE[STRING,STRING,INTEGER]]) is
			-- Initialize descriptor lists
		require
			valid_array: a_array /= Void
		local
			i : INTEGER
			l_descriptor : CONTEXT_DESCRIPTOR
			l_supplier_name,l_name : STRING
		do
			create descriptors.make_empty
			create descriptors_by_name.make(100)
			create descriptors_by_supplier_id.make_empty
			from i := 1 until i > a_array.count loop
				l_supplier_name ?= a_array.item(i).item(1)
				l_name ?= a_array.item(i).item(2)
				if i /= a_array.item(i).integer_item(3) then
					print("Context out of order : " + l_name + "%N")
				end
				create l_descriptor.make(l_supplier_name,l_name,i)
				descriptors.extend(l_descriptor)
				descriptors_by_name.put(l_descriptor,l_name)
				descriptors_by_supplier_id.force(l_descriptor,l_descriptor.supplier_id)
				i := i + 1
			end
		end

feature -- No DB stuff

	no_db_mode: BOOLEAN

	context_id_from_name (a_name: STRING): INTEGER is
			-- Get the context_id for the context with name `a_name'
		require
			no_db_mode: no_db_mode
			name_not_void: a_name /= Void
		do
			Result := index_from_name.item (a_name)
		end

feature {NONE} -- No DB implementation

	index_from_name: HASH_TABLE[INTEGER, STRING]

end
