indexing
	description : "Context manager"
	author : "Pierre Nallet"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #5 $"

class
	CONTEXT_MANAGER

inherit 
	DATABASE_SERVER
	CONTEXT_AWARE

feature -- Access

	supplier_ids: ROSE_HASH_TABLE [INTEGER, STRING] is
		once
			create Result.make (100)
			supplier_product_predicate.apply (agent add_id_name, Void, Void)
			Result.put (Result.item ("BRIM ENTITIES"), "RESEARCH")
		end
		
	supplier_product_predicate: SIMPLE_PREDICATE [ROSE_SUPPLIER_ID_NAME] is
		once
			create Result.make (
				servers.rose_entity_foreground_server,
				"select supplier_product_id,name from supplier_product"
			)
		end
		
	add_id_name (a_id_name: ROSE_SUPPLIER_ID_NAME) is
		do
			a_id_name.name.to_upper
			a_id_name.name.prune_all_leading (' ')
			a_id_name.name.prune_all_trailing (' ')
			context_names.put (a_id_name.name,a_id_name.supplier_product_id)
			supplier_ids.put (a_id_name.supplier_product_id,a_id_name.name)
		end

	context_names:  HASH_TABLE [STRING, INTEGER] is
		once
			create Result.make(100)
			supplier_ids.do_nothing	--| trigger
		end

end
