indexing
	description : "Context hub"
	author: ""
	last_editor: "$Author: sm $"
	date: "$Date: 2009/08/25 $"
	revision: "$Revision: #4 $"
	archive: "$File: //rose/source/kernel/entities/context_server.e $"

class
	CONTEXT_SERVER

inherit
	CONTEXT_AWARE

	DATABASE_SERVER

	ROSE_ENTITY_FOREGROUND_AWARE
		rename
			context as rose_entity_foreground_context
		end

	CONTEXTS_CONTAINER

feature  --Access

	context_from_name (a_name: STRING): like context_anchor is
			-- Context with 'a_name'
		local
			l_descriptor: CONTEXT_DESCRIPTOR
			l_server: SQL_DATA_SERVER
			l_name: STRING
		do
			l_name := a_name.as_upper
			l_descriptor := contexts.descriptor_from_name (l_name)
			if l_descriptor /= Void then
				Result := l_descriptor.context
				if Result = Void then
					if l_name.is_equal("ROSE ENTITY FOREGROUND") then
						Result := rose_entity_foreground_context
					elseif servers.is_valid_repository_logical (l_descriptor.supplier_name) then
						l_server := servers.make_from_repository (l_descriptor.supplier_name)
						if l_server /= Void and l_server.success then
							create {ROSE_SUPPLIER_CONTEXT} Result.make (l_server, l_descriptor.name) -- SM 20090825: will need to replace {ROSE_SUPPLIER_CONTEXT} with {ROSE_SQL_CONTEXT}
						end
					end
				end
			end
		end

	rose_context: ROSE_CONTEXT is
			-- Integration context
		do
			Result := rose_entity_foreground_context
		end

end
