indexing
	description: "Contexts data store - items can be retrieved by name or supplier_id"
	author: ""
	last_editor: "$Author: sm $"
	date: "$Date: 2009/08/24 $"
	revision: "$Revision: #4 $"
	path: "$File: //rose/source/kernel/supplier_data/contexts_container.e $"

deferred class
	CONTEXTS_CONTAINER

inherit
	ROSE_SERVERS

	CONTEXT_AWARE

feature -- Access

	context_from_id (a_supplier_id : INTEGER) : like context_anchor is
			-- Context with 'a_supplier_id'
		local
			l_descriptor : CONTEXT_DESCRIPTOR
		do
			l_descriptor := contexts.descriptor_from_supplier_id(a_supplier_id)
			if l_descriptor /= void then
				Result := l_descriptor.context
				if Result = void then
					Result := context_from_name(l_descriptor.name)
				end
			end
		end

	category_from_full_name (a_name: STRING): CATEGORY_HANDLER [like context_anchor,ENTITY] is
			-- Category associated to 'a_name'
			-- 'a_name' is expected of the form "[SUPPLIER]CATEGORY"
		local
			i: INTEGER
			l_supplier: like context_from_name
		do
			if a_name /= Void and then a_name.count > 4 and then a_name.item (1) = '[' then
				i := a_name.index_of (']',2)
				if i > 2 and then i < a_name.count then
					l_supplier := context_from_name (a_name.substring (2,i-1))
					if l_supplier /= Void then
						Result := l_supplier.category_handler_from_name (a_name.substring (i+1,a_name.count))
					end
				end
			end
		end

	context_from_name (a_name  : STRING) : like context_anchor is
			-- Context from 'a_name'
		deferred
		end

end
