indexing
	description : "Units specific to currency"
	author : "Mark Howard"
	last_editor: "$Author: er $"
	date: "$Date: 2013/06/18 $"
	revision: "$Revision: #17 $"
	path: "$File: //rose/source/kernel/math/currency_units.e $"
	storable_version: ""

class
	CURRENCY_UNITS

inherit
	RP_SERIALIZABLE

	ROSE_BASE_UNITS
		redefine
			make_from_record
		end

	CONTEXT_AWARE

	MISMATCH_CORRECTOR
		undefine
			is_equal
		redefine
			correct_mismatch
		end

	ATTRIBUTES
		rename
			name as attributes_name
		undefine
			is_equal
		end

	ROSE_ENTITY_FOREGROUND_AWARE
create
	make_from_record, make_generic

feature {NONE} -- Initialization

	make_from_record (a_record : UNITS_RECORD) is
			-- Make from units record
		local
			l_context : like existing_context_from_name
		do
			Precursor (a_record)
			l_context := existing_context_from_name("RESEARCH")
			if l_context /= Void and then attached {CURRENCY} l_context.currency_at (iso_code (a_record.mnemonic),Void) as l_currency then
				currency := l_currency
			else
				currency := context.currency_at (iso_code(a_record.mnemonic),Void)
			end
			currency_primes_table.put(Current,a_record.prime)
		end

	make_generic is
			-- Create anynoymous currency from RESEARCH or ROSE
		local
			l_context : like existing_context_from_name
		do
			name := "Currency"
			create rational.default_create
			l_context := existing_context_from_name("RESEARCH")
			if l_context /= Void and then attached {CURRENCY} l_context.currency_at (iso_code (""),Void) as l_currency then
				currency := l_currency
			else
				currency := context.currency_at (iso_code (""),Void)
			end
		end

feature -- Access

	currency : CURRENCY
		-- Currency

feature {NONE} --Implementation

	correct_mismatch is
			-- Correct mismatch
		local
			l_mismatch: MISMATCH_INFORMATION
		do
			l_mismatch := mismatch_information
		end

end
