indexing
	description : "[
		Used by RECORD_BUILDER to determine the flattened size of a structure.  Could easily
		be replaced with the use of agents.
		]"
	author : "Mark Howard"

class
	DATA_STRUCTURE_LENGTH [G->DATA_COMPONENT]

inherit
   DATA_STRUCTURE_ITERATOR [G]

create
   make

feature {RECORD_BUILDER,DATA_STRUCTURE} -- Implementation

   length : INTEGER				-- Length
   symbolic_length: STRING
   uses_symbolic: BOOLEAN

   non_basic_data_type (a_type: STRING): BOOLEAN is
		do
			if a_type /= Void then
				a_type.to_upper
				Result := not a_type.is_equal ("INTEGER") and not a_type.is_equal ("REAL")
					and not a_type.is_equal ("CHARACTER") and not a_type.is_equal ("DOUBLE")
					and not a_type.is_equal ("STRING") and not a_type.is_equal ("BOOLEAN")
			end
		end

   item_action (an_item : G) is
	  local
	     l_total_length: INTEGER
	  do
		 if an_item.uses_symbolic_indexes
		 then
		    if symbolic_length = Void
		    then
		       uses_symbolic := True
			   if length>0
			   then
		          symbolic_length := length.out + "+"
			   else
				  symbolic_length := ""
			   end
			else
			   symbolic_length.append("+")
			end

		    symbolic_length.append("("+an_item.length_out+")" + "*" + an_item.repeat_count_out)
		else
			if uses_symbolic then
				if an_item.length_out.is_integer and then an_item.repeat_count_out.is_integer then
					l_total_length := an_item.length_out.to_integer*an_item.repeat_count_out.to_integer
					if l_total_length > 0 then
						symbolic_length.append("+"+l_total_length.out)
					end
				else
					symbolic_length.append("+("+an_item.length_out+")" + "*" + an_item.repeat_count_out)

				end
			else
				if non_basic_data_type (an_item.type_string) then--an_item.length = 0 and then an_item.min_index_name = Void and then an_item.max_index_name = Void then -- e.g., an_item isn't a primitive type such as INTEGER, STRING, CHARACTER
					if symbolic_length = Void then
						symbolic_length := length.out
						uses_symbolic := True
					end
					symbolic_length.append("+("+an_item.length_out+")" + "*" + an_item.repeat_count_out)
				else
					l_total_length := an_item.length * an_item.repeat_count
				end
				if l_total_length > 0 then
					length := length + l_total_length
				end
			end
		 end
	  end
end
