note

	description:

		"Interface to a database definition"

	author: "Pierre Nallet"
	last_editor: "$Author: an $"
	date: "$Date: 2013/10/09 $"
	revision: "$Revision: #5 $"
	path: "$File: //rose/source/kernel/infrastructure/persistence/database_definition.e $"

deferred class
	DATABASE_DEFINITION

feature -- Access
	full_path: STRING
			--|
		deferred
		end

	logical: STRING
			--|
		deferred
		end

	overridden: DATABASE_DEFINITION
			--|
		deferred
		end

	path: STRING
			--|
		deferred
		end

	server: STRING
			--|
		deferred
		end

feature -- Basic operations
	increment_selection_count
			--|
		deferred
		end

	increment_execution_count
			--|
		deferred
		end

	increment_bulk_insert_count (a_table: STRING) is
			-- Add one to count of BULK INSERTs committed against `a_table'.
		require
			a_table_not_void: a_table /= Void
		deferred
		end

	increment_truncate_count (a_table: STRING) is
			-- Add one to count of TRUNCATE TABLE issued for `a_table'.
		require
			a_table_not_void: a_table /= Void
		deferred
		end

	increment_create_count (a_table: STRING) is
			-- Add one to count of CREATE TABLE issued for `a_table'.
		require
			a_table_not_void: a_table /= Void
		deferred
		end

	increment_drop_count (a_table: STRING) is
			-- Add one to count of DROP TABLE issued for `a_table'.
		require
			a_table_not_void: a_table /= Void
		deferred
		end

	add_input_table_name (a_table_name: STRING)
			-- Indicate that `a_table_name' has been accessed as input.
		require
			a_table_name_not_void: a_table_name /= Void
		deferred
		end

	add_output_table_name (a_table_name: STRING)
			-- Indicate that `a_table_name' has been accessed as output.
		require
			a_table_name_not_void: a_table_name /= Void
		deferred
		end

	is_same_path(a_other: DATABASE_DEFINITION): BOOLEAN
			--|
		deferred
		end
end
