indexing

	description: "Exception denoting database server for logical name could not be obtained"

	author: "Colin Adams"
	last_editor: "$Author: c4 $"
	path: "$File: //rose/source/kernel/infrastructure/persistence/database_server_not_available_exception.e $"
	date: "$Date: 2010/08/11 $"
	revision: "$Revision: #3 $"

class	DATABASE_SERVER_NOT_AVAILABLE_EXCEPTION

inherit

	DATABASE_EXCEPTION
		redefine
			internal_meaning
		end

create
	make_with_logical

feature {NONE} -- Initialization

	make_with_logical (a_logical: like logical_name) is
			-- Initialize from `a_logical'.
		require
			a_logical_not_void: a_logical /= Void
			a_logical_not_empty: not a_logical.is_empty
		do
			logical_name := a_logical
		ensure
			logical_name_set: logical_name = a_logical
		end

feature -- Access

	logical_name: STRING
			-- Logical name for database

feature {NONE} -- Access

	internal_meaning: STRING is
			-- <Precursor>
		do
			Result := "Could not obtain reference to database server for logical database " + logical_name
		end

invariant

	logical_name_not_void: logical_name /= Void
	logical_name_not_empty: not logical_name.is_empty

end


