indexing
	description: "Used by RCMD_DATA_CONNECTION_VIEWER to represent most of the rows returned by %N%
				 %a join on sys.dm_tran_database_transactions and sys.dm_tran_session_transactions."
	author: "RJ"
	last_editor: "$Author: rj $"
	date: "$Date: 2010/07/01 $"
	revision: "$Revision: #1 $"
	archive: "$File: //rose/source/applications/system/data_connection_viewer/dcv_open_transaction.e $"

class
	DCV_OPEN_TRANSACTION

feature -- Access.
	interpreted_database_transaction_type: STRING
	-- A readable version of 'database_transaction_type'.
	do
		inspect database_transaction_type
		when 1 then
			Result := "RW"
		when 2 then
			Result := "RO"
		when 3 then
			Result := "System"
		else
			Result := database_transaction_type.out
		end
	end

	interpreted_database_transaction_state: STRING
	-- A readable version of 'database_transaction_state'.
	do
		inspect database_transaction_state
		when 1 then
			Result := "Not initialized"
		when 3 then
			Result := "No log records"
		when 4 then
			Result := "Has log records"
		when 5 then
			Result := "Prepared"
		when 10 then
			Result := "Committed"
		when 11 then
			Result := "Rolled back"
		when 12 then
			Result := "Being committed"
		else
			Result := database_transaction_state.out
		end
	end

feature -- Attributes from sys.dm_tran_database_transactions.  See Microsoft documentation.
	transaction_id: INTEGER_64

	database_id: INTEGER

	database_transaction_begin_time: ROSE_DATE

	database_transaction_type: INTEGER

	database_transaction_state: INTEGER

	database_transaction_log_record_count: INTEGER

	database_transaction_replicate_record_count: INTEGER

	database_transaction_log_bytes_used: INTEGER_64

	database_transaction_log_bytes_reserved: INTEGER_64

	database_transaction_log_bytes_used_system: INTEGER

	database_transaction_log_bytes_reserved_system: INTEGER

feature -- Attributes from sys.dm_tran_session_transactions.  See Microsoft documentation.
	session_id: INTEGER								-- AKA SPID.

end
