indexing
	description : "object for storing enough statistics on an array to compute normalized values"
	author : "Mark Howard"

class
	DOUBLE_PAIR

inherit
	ROSE_CONSTANTS
	ROSE_LEGACY_UNDEFINED
	DEBUG_OUTPUT

create
	make

feature -- Initialization

	make (a_data,a_weight:DOUBLE) is
			-- Creation procedure.
		do
			weight := a_weight
			data := a_data
		end

	weight:DOUBLE
	data:DOUBLE

feature -- Access

	debug_output : STRING is
		do
			Result := double_string(data) + " : " + double_string(weight)
		end

	double_string(a_value : DOUBLE) : STRING is
		do
			if is_defined_double(a_value) then
				Result := format.formatted (a_value)
			else
				Result := "n\a"
			end
		end

	format : FORMAT_DOUBLE is once create Result.make(10, 4) end

end
