note

	description:

		"ROSE_EXPRESSION where all of the values are defined from double_value"

	author: "Mark Howard"
	last_editor: "$Author: mk $"
	date: "$Date: 2011/02/15 $"
	revision: "$Revision: #18 $"
	path: "$File: //rose/source/kernel/math/double_valued_expression.e $"

deferred class
	DOUBLE_VALUED_EXPRESSION[reference G]

inherit
	ROSE_EXPRESSION[G]
		redefine
			make
		end

feature -- Initialization

	make (a_variable_description : like variable_description) is
			-- Make with 'a_variable_description'
		do
			Precursor(a_variable_description)
			type := Double_type
		end

feature -- Access

	moments (a_array: ARRAY [like expression_target]): ROSE_MOMENTS is
		local
			l_array: ROSE_LINEAR_ARRAY [DOUBLE]
			i: INTEGER
			l_value: DOUBLE
		do
			create l_array.make_empty
			from
				i := a_array.lower
			until
				i > l_array.upper
			loop
				l_value := at (a_array.item (i))
				if l_value /= undefined_real then
					l_array.extend (l_value)
				end
				i := i + 1
			end
			create Result.make (l_array, Void)
		end

	partial_at (a_target : like expression_target) : DOUBLE is
		do
			if defined(a_target) then
				Result := at(a_target)
			end
		end

	output_type : INTEGER is
		once
			Result := Real_type
		end

	at (a_target : like expression_target) : DOUBLE is
		deferred
		end

	get_real_value (a_target : like expression_target) : REAL is
		do
			Result := at (a_target).truncated_to_real
		end

	get_double_value (a_target : like expression_target) : DOUBLE is
		do
			Result := at(a_target)
		end

	get_integer_value (a_target : like expression_target) : INTEGER is
		do
			Result := at(a_target).truncated_to_integer
		end



end
