indexing
	description: "Constants for Date and Time Picker control styles"
	author: "David Jenkins"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #2 $"

class
	DTS_CONSTANTS

feature -- Access

	Dts_appcanparse: INTEGER is
			-- Allows the owner to parse user input and take necessary action. It enables users to edit within the client area of the control when they press the F2 key. The control sends DTN_USERSTRING notification messages when users are finished.
		external
			"C [macro %"wel.h%"]:EIF_INTEGER"
		alias
			"DTS_APPCANPARSE"
		end

	Dts_longdateformat: INTEGER is
			-- Displays the date in long format. 
			-- The default format string for this style is defined by LOCALE_SLONGDATEFORMAT, which produces output like "Friday, April 19, 1996".
		external
			"C [macro %"wel.h%"]:EIF_INTEGER"
		alias
			"DTS_LONGDATEFORMAT"
		end

	Dts_rightalign: INTEGER is
			-- The drop-down month calendar will be right-aligned with the control instead of left-aligned, which is the default. 
		external
			"C [macro %"wel.h%"]:EIF_INTEGER"
		alias
			"DTS_RIGHTALIGN"
		end

	Dts_shownone: INTEGER is
			-- It is possible to have no date currently selected in the control. With this style, the control displays a check box that users can check once they have entered or selected a date. Until this check box is checked, the application will not be able to retrieve the date from the control because, in essence, the control has no date. This state can be set with the DTM_SETSYSTEMTIME message or queried with the DTM_GETSYSTEMTIME message.
		external
			"C [macro %"wel.h%"]:EIF_INTEGER"
		alias
			"DTS_SHOWNONE"
		end

	Dts_shortdateformat: INTEGER is
			-- Displays the date in short format. The default format string for this style is defined by LOCALE_SSHORTDATE, which produces output like "4/19/96".
		external
			"C [macro %"wel.h%"]:EIF_INTEGER"
		alias
			"DTS_SHORTDATEFORMAT"
		end

--	Dts_shortdatecenturyformat: INTEGER is
--			-- Version 5.80. Similar to the DTS_SHORTDATEFORMAT style, except the year is a four-digit field. The default format string for this style is based on LOCALE_SSHORTDATE. The output looks like: "4/19/1996".
--		external
--			"C [macro %"wel.h%"]:EIF_INTEGER"
--		alias
--			"DTS_SHORTDATECENTURYFORMAT"
--		end

	Dts_timeformat: INTEGER is
			-- Displays the time. The default format string for this style is defined by LOCALE_STIMEFORMAT, which produces output like "5:31:42 PM".
		external
			"C [macro %"wel.h%"]:EIF_INTEGER"
		alias
			"DTS_TIMEFORMAT"
		end

	Dts_updown: INTEGER is
			-- Places an up-down control to the right of the DTP control to modify date-time values. This style can be used in place of the drop-down month calendar, which is the default style.
		external
			"C [macro %"wel.h%"]:EIF_INTEGER"
		alias
			"DTS_UPDOWN"
		end

	valid_dts_value(v:INTEGER):BOOLEAN is
		do
			Result := v = Dts_appcanparse or else
				v = Dts_longdateformat or else
				v = Dts_rightalign or else
				v = Dts_shownone or else
				v = Dts_shortdateformat or else
				v = Dts_timeformat or else
				v = Dts_updown
		end

end -- class DTS_CONSTANTS

--|-------------------------------------------------------------|
--|Created by David Jenkins										|
--|																|
--|It's not my fault if it works								|
--|-------------------------------------------------------------|
