note

	description:

		"Record with has table of key value pairs"

	author: "Mark Howard"
	last_editor: "$Author: mb $"
	date: "$Date: 2014/03/03 $"
	revision: "$Revision: #3 $"
	path: "$File: //rose/source/kernel/support/dynamic_record.e $"

class DYNAMIC_RECORD

inherit

	FIELD_DESCRIPTORS

feature -- Query

	unitized_value (a_name: STRING): DATED_UNITIZED_VALUE [DOUBLE] is
			-- Dated unitized value
		do
			Result := dynamic_values [a_name]
		end
	
feature -- Access

	dynamic_values: HASH_TABLE [DATED_UNITIZED_VALUE [DOUBLE], STRING] is
			-- Dynamic key value pairs
		do
			if dynamic_values_saved = Void then
				create dynamic_values_saved.make (200)
			end
			Result := dynamic_values_saved
		end

feature -- Basic operations
	
	transfer_double_values is
			-- Copy double values to `dynamic_values' table.
		local
			i, l_count: INTEGER
		do
			l_count := internal.field_count (Current)
			from
				i := 1
			until
				i > l_count
			loop
				inspect internal.field_type (i, Current)
				when {INTERNAL}.Real_type then
					dynamic_values [internal.field_name (i, Current)] := create {DATED_UNITIZED_VALUE [DOUBLE]}.make_with_units (internal.real_field (i, Current), Void)
				when {INTERNAL}.Double_type then
					dynamic_values [internal.field_name (i, Current)] := create {DATED_UNITIZED_VALUE [DOUBLE]}.make_with_units (internal.double_field (i, Current), Void)
				else
					-- Do nothing
				end
				i := i + 1
			end
		end

feature {NONE} -- Implementation

	dynamic_values_saved: like dynamic_values

end
