indexing

	description:

		"EDB_CLIENT_INTERVAL"

	generator: "[
		Classifier -class_name="EDB_CLIENT_INTERVAL"
	]"
	keywords: "classifier,database,record,generated"
	date: "$Date: 2010/01/25 $"
	sccid: "$Id: //rose/source/kernel/capital_actions/elections/edb_client_interval.e#1 $"

class EDB_CLIENT_INTERVAL

inherit

	IEEE_MATH
		export {NONE} all end

	ANY

feature -- Access

	client: STRING
			-- Database column `client'

	start_date: INTEGER
			-- Database column `start_date'

	end_date: INTEGER
			-- Database column `end_date'

	tax_factor: STRING
			-- Database column `tax_factor'

	swept: INTEGER
			-- Database column `swept'

	date_type: INTEGER
			-- Database column `date_type'

feature -- Setting

	set_client (a_value: like client) is
			-- Set `client' to `a_value'
		do
			client := a_value
		ensure
			client_assigned: client = a_value
		end

	set_start_date (a_value: like start_date) is
			-- Set `start_date' to `a_value'
		do
			start_date := a_value
		ensure
			start_date_assigned: start_date = a_value
		end

	set_end_date (a_value: like end_date) is
			-- Set `end_date' to `a_value'
		do
			end_date := a_value
		ensure
			end_date_assigned: end_date = a_value
		end

	set_tax_factor (a_value: like tax_factor) is
			-- Set `tax_factor' to `a_value'
		do
			tax_factor := a_value
		ensure
			tax_factor_assigned: tax_factor = a_value
		end

	set_swept (a_value: like swept) is
			-- Set `swept' to `a_value'
		do
			swept := a_value
		ensure
			swept_assigned: swept = a_value
		end

	set_date_type (a_value: like date_type) is
			-- Set `date_type' to `a_value'
		do
			date_type := a_value
		ensure
			date_type_assigned: date_type = a_value
		end

end
