indexing
	description: "Prefix and Postfix settings"
	library: "elogger"
	copyright: "Copyright (c) 2006, AXA Rosenberg, and others (see copyright.txt)"
	author: "Ulrich Weiss, and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2014/02/26 $"
	revision: "$Revision: #4 $"
	archive: "$File: //rose/source/kernel/infrastructure/logging/layouts/elog_affix.e $"

deferred class ELOG_AFFIX

inherit
	ANY
		redefine
			default_create
		end

feature {NONE} -- Initialization

	default_create is
			-- Initialization
		do
			prefix_string := ""
			postfix_string := ""
		end

feature -- Access

	postfix_string: STRING
			-- the postfix

	prefix_string: STRING
			-- the pretfix

feature -- Basic operations

	set_prefix_string (a_prefix: STRING) is
			-- sets `prefix_string'
		require
			a_prefix_not_void: a_prefix /= Void
		do
			prefix_string := a_prefix
		ensure
			prefix_string_set: prefix_string = a_prefix
		end

	set_postfix_string (a_postfix: STRING) is
			-- sets `postfix_string'
		require
			a_postfix_nto_void: a_postfix /= Void
		do
			postfix_string := a_postfix
		ensure
			postfix_string_set: postfix_string = a_postfix
		end

invariant
	postfix_string_not_void: postfix_string /= Void
	prefix_string_not_void: prefix_string /= Void

end
