indexing
	description: "Concurrent linked queue node"
	library: "elogger"
	copyright: "Copyright (c) 2006, AXA Rosenberg, and others (see copyright.txt)"
	author: "Ulrich Weiss, and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2009/04/16 $"
	revision: "$Revision: #3 $"
	archive: "$File: //rose/source/kernel/infrastructure/logging/concurrency/elog_concurrent_linked_queue_node.e $"

class ELOG_CONCURRENT_LINKED_QUEUE_NODE [G]

create
	default_create,
	make

feature {NONE} -- Initialization

	make (a_value: G)
			-- create a new node
		do
			value := a_value
		end

feature -- Access

	value: G assign set_value
			-- the value of the node

	next: like current assign set_next
			-- link to the next element

feature -- Change

	set_value (a_value: like value)
			-- set 'value'
		require
			a_value_exists: a_value /= Void
		do
			value := a_value
		end

	set_next (a_next: like next)
			-- set the link to the next element
		require
			a_next_exists: a_next /= Void
		do
			next := a_next
		end

invariant
	value_not_void: value /= Void

end
