indexing
	description: "Pattern converter for formatting literal strings"
	library: "elogger"
	copyright: "Copyright (c) 2006, AXA Rosenberg, and others (see copyright.txt)"
	author: "Ulrich Weiss, and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #3 $"
	archive: "$File: //rose/source/kernel/infrastructure/logging/layouts/pattern/elog_date_pattern_converter.e $"

class ELOG_DATE_PATTERN_CONVERTER

inherit

	ELOG_PATTERN_CONVERTER
		rename
			make as pattern_converter_make
		export
			{NONE} pattern_converter_make
		end

create

	make

feature -- Initialisation

	make (formatting_info: ELOG_FORMATTING_INFO; options: STRING) is
			-- Initialise with 'formatting_info'.
		require
			formatting_info_exists: formatting_info /= Void
		do
			pattern_converter_make (formatting_info)
		end

feature {NONE} -- Implementation

	convert_event (event: ELOG_EVENT): STRING is
			-- Convert conversion specifiers appropriately.
		do
			Result := event.creation_time.date.out
		end

end -- ELOG_DATE_PATTERN_CONVERTER
