indexing
	description: "Layout using 'formatted_date_time - priority - message'"
	library: "elogger"
	copyright: "Copyright (c) 2006, AXA Rosenberg, and others (see copyright.txt)"
	author: "Ulrich Weiss, and others"
	last_editor: "$Author: rj $"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2012/02/24 $"
	revision: "$Revision: #6 $"
	path: "$File: //rose/source/kernel/infrastructure/logging/layouts/elog_date_time_layout.e $"

class ELOG_DATE_TIME_LAYOUT

inherit

	ELOG_SIMPLE_LAYOUT
		redefine
			format
		end

feature -- Rendering

	format (event: ELOG_EVENT): STRING is
			-- Format contents of 'event' according to this layout's
			-- formatting rules.
			-- Format is: formatted_date - priority - message
		do
			Result := event.creation_time.precise_out
			if use_utc.item
			then
				Result.append(" UT")
			end

			Result.append (" - ")
			Result.append (event.severity.abbreviation)
			Result.append (" - ")
			Result.append (event.message)
			Result.append (nl)
		end

end
