indexing
	description: "Log event filter constants. "
	library: "elogger"
	copyright: "Copyright (c) 2006, AXA Rosenberg, and others (see copyright.txt)"
	author: "Ulrich Weiss, and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #2 $"
	archive: "$File: //rose/source/kernel/infrastructure/logging/elog_filter_constants.e $"

class
	ELOG_FILTER_CONSTANTS

feature -- Filter Constants

	Filter_accept: INTEGER is unique
			-- if 'filters_anded' is set all filters must
			-- return Filter_accept to be accepted.

	Filter_reject: INTEGER is unique
			-- if 'filters_anded' is not set all filters must
			-- return Filter_reject rejected.

	Filter_neutral: INTEGER is unique
			-- Remaining filters will be consulted to determine
			-- if the event should be logged. If there are no
			-- remaining filters then the event will be logged.
			-- Note: neutral filters are ignored!

feature {NONE} -- Implementation

	valid_filter_decision (code: INTEGER): BOOLEAN is
			-- Is 'code' a valid filter result code?
		do
			Result := code = Filter_accept or code = Filter_reject or code = Filter_neutral
		end

end
