indexing
	description: "Deferred class of a filter containing other filters. "
	library: "elogger"
	copyright: "Copyright (c) 2006, AXA Rosenberg, and others (see copyright.txt)"
	author: "Ulrich Weiss, and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #2 $"
	archive: "$File: //rose/source/kernel/infrastructure/logging/filters/elog_filter_container.e $"

deferred class
	ELOG_FILTER_CONTAINER

inherit
	ELOG_FILTER

feature -- Element Change

	add_filter (a_filter: ELOG_FILTER) is
			-- adds 'a_filter' to the list of filters
		require
			a_filter_not_void: a_filter /= Void
		do
			filters.force_last (a_filter)
		ensure
			filters_has_filter: filters.has (a_filter)
		end

feature {NONE} -- Implementation

	filters: DS_LINKED_LIST [ELOG_FILTER]
			-- List of filters that will be anded

invariant
	filters_not_void: filters /= Void

end
