indexing
	description: "Abstract notion of an event layout formatter."
	library: "elogger"
	copyright: "Copyright (c) 2006, AXA Rosenberg, and others (see copyright.txt)"
	author: "Ulrich Weiss, and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2009/07/15 $"
	revision: "$Revision: #5 $"
	archive: "$File: //rose/source/kernel/infrastructure/logging/elog_layout.e $"

deferred class ELOG_LAYOUT

feature -- Access

	format (event: ELOG_EVENT): STRING is
			-- Format contents of 'event' according to this layout's
			-- formatting rules
		require
			event_exists: event /= Void
		deferred
		ensure
			formatted_exists: Result /= Void
		end

	header: STRING is
			-- Format a header for this layout.
		deferred
		ensure
			header_exists: Result /= Void
		end

	footer: STRING is
			-- Format a footer for this layout.
		deferred
		ensure
			footer_exists: Result /= Void
		end

	nl: STRING is
			-- newline
		once
			if {PLATFORM}.is_windows then
				Result := "%R%N"
			else
				Result := "%N"
			end
		end

feature -- Element Change

	set_header (h: STRING) is
			-- sets the printed header
		do
			header_internal := h
		end

	set_footer (f: STRING) is
			-- sets the printed footer
		do
			footer_internal := f
		end

feature {NONE} -- Implementation

	header_internal: STRING
			-- internal header

	footer_internal: STRING
			-- internal footer


end
