indexing
	description: "Pattern converter for formatting literal strings"
	library: "elogger"
	copyright: "Copyright (c) 2006, AXA Rosenberg, and others (see copyright.txt)"
	author: "Ulrich Weiss, and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #3 $"
	archive: "$File: //rose/source/kernel/infrastructure/logging/layouts/pattern/elog_literal_pattern_converter.e $"

class ELOG_LITERAL_PATTERN_CONVERTER

inherit

	ELOG_PATTERN_CONVERTER
		rename
			make as pattern_converter_make
		redefine
			format
		end

create

	make

feature -- Initialisation

	make (value: STRING) is
			-- Create literal converter for 'value'
		require
			value_exists: value /= Void
		do
			literal := value
		end

feature -- Basic operations

	format (sbuf: STRING; event: ELOG_EVENT) is
			-- Format literal and append to 'sbuf'
		do
			sbuf.append (literal)
		end

feature {NONE} -- Implementation

	literal: STRING
			-- String to format

	convert_event (event: ELOG_EVENT): STRING is
			-- Convert conversion specifiers appropriately.
		do
			-- not used
		end

end -- class ELOG_LITERAL_PATTERN_CONVERTER
