indexing
	description: "Simple layout using 'message'"
	library: "elogger"
	copyright: "Copyright (c) 2006, AXA Rosenberg, and others (see copyright.txt)"
	author: "Ulrich Weiss, and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #3 $"
	archive: "$File: //rose/source/kernel/infrastructure/logging/layouts/elog_minimal_layout.e $"

class ELOG_MINIMAL_LAYOUT

inherit

	ELOG_LAYOUT

	ELOG_SHARED_SYSTEM_CLOCK
		export
			{NONE} all
		end

feature -- Rendering

	format (event: ELOG_EVENT): STRING is
			-- Format contents of 'event' according to this layout's
			-- formatting rules.
			-- Format is: message
		do
			Result := event.message
		end

	header: STRING is
			-- Format a header for this layout.
		do
			if header_internal /= Void then
				Result := header_internal
			else
				Result := ""
			end
		end

	footer: STRING is
			-- Format a footer for this layout.
		do
			if footer_internal /= Void then
				Result := footer_internal
			else
				Result := ""
			end
		end

end
