indexing
	description: "turns the result of a filter to Filter_reject, if it was Filter_neutral"
	library: "elogger"
	copyright: "Copyright (c) 2006, AXA Rosenberg, and others (see copyright.txt)"
	author: "Ulrich Weiss, and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #3 $"
	archive: "$File: //rose/source/kernel/infrastructure/logging/filters/elog_neutral_to_reject_filter.e $"

class ELOG_NEUTRAL_TO_REJECT_FILTER

inherit

	ELOG_FILTER

create

	make

feature {NONE} -- Initialization

	make (a_filter: ELOG_FILTER) is
			-- turns neutral results into accepts.
		require
			filter_exists: a_filter /= Void
		do
			filter := a_filter
		end

feature -- Basic operations

	decide (event: ELOG_EVENT): INTEGER is
			-- always returns Filter_accept.
		local
			i: INTEGER
		do
			i := filter.decide (event)
			if i = Filter_neutral or i = Filter_reject then
				Result := Filter_reject
			else
				Result := Filter_accept
			end
		end

feature {NONE} -- Implementation

	filter: ELOG_FILTER
			-- a filter.

invariant
	filter_not_void: filter /= Void

end
