indexing
	description: "Pattern converter for formatting timestamps relative to the application start time."
	library: "elogger"
	copyright: "Copyright (c) 2006, AXA Rosenberg, and others (see copyright.txt)"
	author: "Ulrich Weiss, and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #3 $"
	archive: "$File: //rose/source/kernel/infrastructure/logging/layouts/pattern/elog_relative_time_pattern_converter.e $"

class ELOG_RELATIVE_TIME_PATTERN_CONVERTER

inherit

	ELOG_PATTERN_CONVERTER

create

	make

feature {NONE} -- Implementation

	convert_event (event: ELOG_EVENT): STRING is
			-- Convert conversion specifiers appropriately.
		local
			t: DT_DATE_TIME_DURATION
		do
			if start_time /= Void then
				t := event.creation_time - start_time
				Result := t.second_count.out+"."+t.millisecond.out
			else
				Result := "(start time not set)"
			end
		end

end -- ELOG_RELATIVE_TIME_PATTERN_CONVERTER
