indexing
	description: "Shared instance of the internal logger. "
	library: "elogger"
	copyright: "Copyright (c) 2006, AXA Rosenberg, and others (see copyright.txt)"
	author: "Ulrich Weiss, and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2009/04/16 $"
	revision: "$Revision: #5 $"
	archive: "$File: //rose/source/kernel/infrastructure/logging/internal_logger/elog_shared_internal_logger.e $"

class ELOG_SHARED_INTERNAL_LOGGER

inherit

	ELOG_SEVERITY_CONSTANTS
		export
			{NONE} all
		end
	ANY
feature {NONE} -- Internal use only

	internal_logger: ELOG_LOGGER is
			-- default internal logger used for usual
			-- events, such as internal errors or warnings.
		indexing
			once_status: global
		once
			Result := internal_hierarchy.logger ("default")
		end

	internal_logger_stderr: ELOG_LOGGER is
			-- default internal logger used for usual
			-- events, such as internal errors or warnings.
		indexing
			once_status: global
		once
			Result := internal_hierarchy.logger ("default_stderr")
		end

	internal_hierarchy: ELOG_HIERARCHY is
			-- internal logger hierarchy
		indexing
			once_status: global
		local
			layout: ELOG_MINIMAL_LAYOUT_AFFIX
			a: ELOG_APPENDER
		once
			create layout
			create Result.make (Unknown_severity)
			layout.set_prefix_string ("elogger Internal Log: ")
			layout.set_postfix_string (layout.nl)

			a := create {ELOG_STDOUT_APPENDER}.
				make ("internal stdout appender", True)
			a.set_layout (layout)
			Result.logger ("default").add_appender (a)

			a := create {ELOG_STDERR_APPENDER}.
				make ("internal stdout appender", True)
			a.set_layout (layout)
			Result.logger ("default_stderr").add_appender (a)
		end

end
