indexing
	description: "Simple layout using 'priority - message'"
	library: "elogger"
	copyright: "Copyright (c) 2006, AXA Rosenberg, and others (see copyright.txt)"
	author: "Ulrich Weiss, and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2009/11/18 $"
	revision: "$Revision: #5 $"
	archive: "$File: //rose/source/kernel/infrastructure/logging/layouts/elog_simple_layout.e $"

class ELOG_SIMPLE_LAYOUT

inherit

	ELOG_LAYOUT

	ELOG_SHARED_SYSTEM_CLOCK
		export
			{NONE} all
		end

feature -- Rendering

	format (event: ELOG_EVENT): STRING is
			-- Format contents of 'event' according to this layout's
			-- formatting rules.
			-- Format is: priority - message
		do
			Result := event.severity.abbreviation.twin
			Result.append (" - ")
			Result.append (event.message)
			Result.append (nl)
		end

	header: STRING is
			-- Format a header for this layout.
		do
			if header_internal /= Void then
				Result := header_internal
			else
				Result := "Log opened: " + system_clock.date_time_now.out
				if use_utc.item then
					Result.append_string (" (UTC)")
				end
				Result.append_string (nl)
			end
		end

	footer: STRING is
			-- Format a footer for this layout.
		do
			if footer_internal /= Void then
				Result := footer_internal
			else
				Result := "Log closed: " + system_clock.date_time_now.out
				if use_utc.item then
					Result.append_string (" (UTC)")
				end
				Result.append_string (nl)
			end
		end

end
