indexing
	description: "Standard output appender using io.error.put_string()"
	library: "elogger"
	copyright: "Copyright (c) 2006, AXA Rosenberg, and others (see copyright.txt)"
	author: "Ulrich Weiss, and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2009/04/16 $"
	revision: "$Revision: #4 $"
	archive: "$File: //rose/source/kernel/infrastructure/logging/appenders/elog_stderr_appender.e $"

class ELOG_STDERR_APPENDER

inherit

	ELOG_APPENDER
		rename
			make as make_unopened,
			make_open as make
		export
			{NONE} make_unopened
		end

	KL_SHARED_STANDARD_FILES

create

	make

feature -- Removal

	dispose
			-- Close this appender when garbage collected. Perform
			-- minimal operations to release resources. Do not call
			-- other object as they may have been garbage collected.
		do
			is_open := False
		end

feature {NONE} -- Implementation

	do_append_string (a_string: STRING)
			-- append 'a_string'
		do
			std.error.put_string (a_string)
		end

	internal_close
			-- Release any resources for this appender.
		do
		end

end
