indexing
	description: "Storable logging event. Memento of an event that does not retain the logger reference."
	library: "elogger"
	copyright: "Copyright (c) 2006, AXA Rosenberg, and others (see copyright.txt)"
	author: "Ulrich Weiss, and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2009/11/18 $"
	revision: "$Revision: #4 $"
	archive: "$File: //rose/source/kernel/infrastructure/logging/appenders/netappender/elog_storable_event.e $"

class ELOG_STORABLE_EVENT

create

	make

feature -- Initialisation

	make (event: ELOG_EVENT) is
			-- Create a new storable logging event for the
			-- specified event.
			-- Remember to set the formatted message before
			-- sending across the wire.
		require
			event_not_void: event /= Void
		do
			logger_name := event.logger.name
			severity := event.severity.description
			message := event.message.out
			time_stamp := event.creation_time.out
		end

feature -- Status Report

	logger_name: STRING
			-- The logger name

	severity: STRING
			-- The logging priority level for this event.

	message: STRING
			-- String representation of message object

	formatted_message: STRING
			-- Formatted message

	time_stamp: STRING
			-- String representation of time stamp

feature -- Status Setting

	set_formatted_message (formatted: STRING) is
			-- Set the formatted message. Should be generated by
			-- calling 'layout.format (event))' in the appender.
		require
			formatted_not_void: formatted /= Void
		do
			formatted_message := formatted
		end

end
