indexing
	description: "Generates unique integers in a thread-safe manner"
	author: "Nate McNamara & James Phillips"
	last_editor: "$Author: rj $"
	date: "$Date: 2014/09/05 $"
	revision: "$Revision: #3 $"
	path: "$File: //rose/source/kernel/infrastructure/logging/concurrency/elog_thread_safe_auto_incremeneter.e $"

class
	ELOG_THREAD_SAFE_AUTO_INCREMENETER

feature -- Basic operations

	next_integer: INTEGER
			--|
		do
			auto_incrementer_mutex.lock
			Result := next_int
			next_int.set_item (next_int.item + 1)
			auto_incrementer_mutex.unlock
		end

feature {NONE} -- Implementation

	auto_incrementer_mutex: ELOG_MUTEX
			-- Protects next_int
		indexing
			once_status: global
		once
			create Result.make
		end

	next_int: INTEGER_REF
			--|
		indexing
			once_status: global
		once
			create Result
		end

end
