indexing
	description: "Layout using 'seconds_since_start - severity - message'"
	library: "elogger"
	copyright: "Copyright (c) 2006, AXA Rosenberg, and others (see copyright.txt)"
	author: "Ulrich Weiss, and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2009/11/18 $"
	revision: "$Revision: #4 $"
	archive: "$File: //rose/source/kernel/infrastructure/logging/layouts/elog_time_layout.e $"

class ELOG_TIME_LAYOUT

inherit

	ELOG_SIMPLE_LAYOUT
		redefine
			format
		end

create

	make

feature -- Initialisation

	make is
			-- Create new time layout and record start
			-- time
		do
			start_time := system_clock.date_time_now
		end

feature -- Rendering

	format (event: ELOG_EVENT): STRING is
			-- Format contents of 'event' according to this layout's
			-- formatting rules.
			-- Format is: seconds_since_start - priority - message
		do
			Result := event.creation_time.duration (start_time).second_count.out
			Result.append (" - ")
			Result.append (event.severity.abbreviation)
			Result.append (" - ")
			Result.append (event.message)
			Result.append (nl)
		end

feature {NONE} -- Implementation

	start_time: DT_DATE_TIME
			-- Time this log layout was initialised

end -- class ELOG_TIME_LAYOUT
