indexing
   description: "Entity server"
   author: ""
   date: "$Date: 2009/06/18 $"
   revision: "$Revision: #28 $"

class
   ENTITY_SERVER[G->SUPPLIER_ENTITY create default_create end]

inherit
   MISSING_PARAMETERS

create
   make

feature {SUPPLIER_ENTITY_BASE, SUPPLIER_ENTITY_CACHE, SUPPLIER_ENTITY_ATTRIBUTE, SUPPLIER_ENTITY_RELATIONSHIP_CACHE} -- Initialization

   make (a_server : DATA_SERVER) is
			-- Make with 'a_server'.
	  local
		 l_entity_cache : SUPPLIER_ENTITY_CACHE[G]
	  do
		 create empty_entity.default_create
		 create empty_attribute_entity.default_create
		 create l_entity_cache.make_empty
		 data_server := a_server
		 create attribute_type_manager.make(data_server)

		 create select_transition_history_predicate_saved.make(0, 10)

		 select_identity_predicate ?= empty_entity.make_select_identity_predicate
		 validate(select_identity_predicate)
		 select_next_predicate ?= empty_entity.make_select_next_predicate
		 validate(select_next_predicate)
		 select_attribute_predicate ?= empty_entity.make_select_attribute_predicate
		 validate(select_attribute_predicate)
		 select_attributes_between_predicate ?= empty_entity.make_select_attributes_between_predicate
		 validate(select_attributes_between_predicate)
		 select_attribute_history_predicate ?= empty_entity.make_select_attribute_history_predicate
		 validate(select_attribute_history_predicate)
		 select_next_attribute_predicate ?= empty_entity.make_select_next_attribute_predicate
		 validate(select_next_attribute_predicate)
		 select_attribute_by_value_predicate ?= empty_entity.make_select_attribute_by_value_predicate
		 validate(select_attribute_by_value_predicate)
		 select_most_recent_attribute_by_value_predicate ?= empty_entity.make_select_most_recent_attribute_by_value_predicate
		 validate(select_most_recent_attribute_by_value_predicate)
		 select_attribute_by_historical_value_predicate ?= empty_entity.make_select_attribute_by_historical_value_predicate
		 validate(select_attribute_by_historical_value_predicate)
		 select_attribute_by_value_set_predicate ?= empty_entity.make_select_attribute_by_value_set_predicate
		 validate(select_attribute_by_value_set_predicate)
		 select_relationships_1_predicate ?= empty_entity.make_select_relationships_1_predicate
		 validate(select_relationships_1_predicate)
		 select_relationships_2_predicate ?= empty_entity.make_select_relationships_2_predicate
		 validate(select_relationships_2_predicate)
		 select_relationship_predicate ?= empty_entity.make_select_relationship_predicate
		 validate(select_relationship_predicate)
		 select_all_relationships_predicate ?= empty_entity.make_select_all_relationships_predicate
		 validate(select_all_relationships_predicate)
		 insert_relationship_predicate ?= empty_entity.make_insert_relationship_predicate
		 validate(insert_relationship_predicate)
		 update_relationship_predicate ?= empty_entity.make_update_relationship_predicate
		 validate(update_relationship_predicate)
		 update_relationship_id_predicate ?= empty_entity.make_update_relationship_id_predicate
		 validate(update_relationship_id_predicate)
		 terminate_relationship_predicate ?= empty_entity.make_terminate_relationship_predicate
		 validate(terminate_relationship_predicate)
		 select_relationships_2_predicate ?= empty_entity.make_select_relationships_2_predicate
		 validate(select_relationships_2_predicate)
		 select_all_relationships_predicate ?= empty_entity.make_select_all_relationships_predicate
		 validate(select_all_relationships_predicate)
		 insert_relationship_predicate ?= empty_entity.make_insert_relationship_predicate
		 validate(insert_relationship_predicate)
		 update_relationship_predicate ?= empty_entity.make_update_relationship_predicate
		 validate(update_relationship_predicate)
		 terminate_relationship_predicate ?= empty_entity.make_terminate_relationship_predicate
		 validate(terminate_relationship_predicate)
		 delete_relationships_predicate ?= empty_entity.make_delete_relationships_predicate
		 validate(delete_relationships_predicate)
		 select_predicate ?= empty_entity.make_select_predicate
		 validate(select_predicate)
		 select_entity_predicate ?= empty_entity.make_select_entity_predicate
		 validate(select_entity_predicate)
		 insert_predicate ?= empty_entity.make_insert_predicate
		 validate(insert_predicate)
		 update_predicate ?= empty_entity.make_update_predicate
		 validate(update_predicate)
		 delete_predicate ?= empty_entity.make_delete_predicate
		 validate(delete_predicate)
		 terminate_predicate ?= empty_entity.make_terminate_predicate
		 validate(terminate_predicate)
		 delete_attributes_predicate ?= empty_entity.make_delete_attributes_predicate
		 delete_attribute_history_row_predicate ?= empty_entity.make_delete_attribute_history_row_predicate
		 validate(delete_attributes_predicate)

		 insert_entity_attribute_predicate ?= empty_attribute_entity.make_insert_predicate
		 validate(insert_entity_attribute_predicate)
		 update_entity_attribute_predicate ?= empty_attribute_entity.make_update_predicate
		 validate(update_entity_attribute_predicate)
		 update_entity_attribute_start_date_predicate ?= empty_attribute_entity.make_update_start_date_predicate
		 validate(update_entity_attribute_start_date_predicate)
		 update_entity_attribute_end_date_predicate ?= empty_attribute_entity.make_update_end_date_predicate
		 validate(update_entity_attribute_end_date_predicate)
	  end

	validate (a: ANY) is
			-- Is `a' Void?
		do
			if a = Void then
				print("ENTITY_SERVER: A reverse assignment to a predicate has failed.%N")
			end
		end

	new_empty_entity : G is
		do
			Result := empty_entity.twin
		end

   	empty_attribute_entity: SUPPLIER_ENTITY_ATTRIBUTE[G]

   	select_identity_predicate: COLLECTING_PREDICATE [G]
   	select_next_predicate: COLLECTING_PREDICATE [G]
   	select_attribute_predicate: COLLECTING_PREDICATE [SUPPLIER_ENTITY_ATTRIBUTE[G]]
   	select_attributes_between_predicate: COLLECTING_PREDICATE [SUPPLIER_ENTITY_ATTRIBUTE[G]]
   	select_attribute_history_predicate: COLLECTING_PREDICATE [SUPPLIER_ENTITY_ATTRIBUTE[G]]
   	select_next_attribute_predicate: COLLECTING_PREDICATE [SUPPLIER_ENTITY_ATTRIBUTE[G]]
   	select_attribute_by_value_predicate: COLLECTING_PREDICATE [G]
   	select_most_recent_attribute_by_value_predicate: COLLECTING_PREDICATE [G]
   	select_attribute_by_historical_value_predicate: COLLECTING_PREDICATE [G]
   	select_attribute_by_value_set_predicate: COLLECTING_PREDICATE [G]
   	select_relationships_1_predicate: COLLECTING_PREDICATE [SUPPLIER_ENTITY_RELATIONSHIP]
   	select_relationships_2_predicate: COLLECTING_PREDICATE [SUPPLIER_ENTITY_RELATIONSHIP]
   	select_relationship_predicate: COLLECTING_PREDICATE [SUPPLIER_ENTITY_RELATIONSHIP]
   	select_all_relationships_predicate: COLLECTING_PREDICATE [SUPPLIER_ENTITY_RELATIONSHIP]
   	insert_relationship_predicate: EXECUTION_PREDICATE
   	update_relationship_predicate: EXECUTION_PREDICATE
   	update_relationship_id_predicate: EXECUTION_PREDICATE
   	terminate_relationship_predicate: EXECUTION_PREDICATE
   	delete_relationships_predicate: EXECUTION_PREDICATE
   	delete_attributes_predicate: EXECUTION_PREDICATE
	delete_attribute_history_row_predicate : EXECUTION_PREDICATE
   	select_predicate: COLLECTING_PREDICATE [G]
   	select_entity_predicate: COLLECTING_PREDICATE [G]
   	insert_predicate: EXECUTION_PREDICATE
   	update_predicate: EXECUTION_PREDICATE
   	delete_predicate: EXECUTION_PREDICATE
   	insert_entity_attribute_predicate: EXECUTION_PREDICATE
   	update_entity_attribute_predicate: EXECUTION_PREDICATE
   	update_entity_attribute_start_date_predicate: EXECUTION_PREDICATE
   	update_entity_attribute_end_date_predicate: EXECUTION_PREDICATE
   	delete_entity_attribute_predicate: EXECUTION_PREDICATE		-- Not used.
   	terminate_predicate: EXECUTION_PREDICATE

	select_transition_history_predicate (a_count: INTEGER): COLLECTING_PREDICATE [ENTITY_TRANSITION] is
	-- Because many databases don't have the entity_transition table
	-- these predicates are handled differently from the rest.
	  require
		count_not_negative: a_count>=0
	  local
		l_select_transition_history_predicate: COLLECTING_PREDICATE [ENTITY_TRANSITION]
	  do
			if not select_transition_history_predicate_saved.valid_index (a_count)
			or else select_transition_history_predicate_saved.item (a_count) = Void then
			l_select_transition_history_predicate ?= empty_entity.make_select_transition_history_predicate(a_count)
			validate(l_select_transition_history_predicate)
			select_transition_history_predicate_saved.force(l_select_transition_history_predicate, a_count)
		end
		Result := select_transition_history_predicate_saved.item(a_count)
	  end

   select_transition_predicate: COLLECTING_PREDICATE [ENTITY_TRANSITION] is
	  do
		 if select_transition_predicate_saved = Void then
			select_transition_predicate_saved ?= empty_entity.make_select_transition_predicate
			validate(select_transition_predicate_saved)
		 end
		 Result := select_transition_predicate_saved
	  end

   add_transition_predicate: EXECUTION_PREDICATE is
	  do
		 if add_transition_predicate_saved = Void then
			add_transition_predicate_saved ?= empty_entity.make_add_transition_predicate
			validate(add_transition_predicate_saved)
		 end
		 Result := add_transition_predicate_saved
	  end

	update_transition_predicate: EXECUTION_PREDICATE is
	do
			if update_transition_predicate_saved = Void then
			update_transition_predicate_saved := empty_entity.make_update_transition_predicate
			validate(update_transition_predicate_saved)
		end
		Result := update_transition_predicate_saved
	end

	update_transition_event_id_predicate: EXECUTION_PREDICATE is
	do
			if update_transition_event_id_predicate_saved = Void then
			update_transition_event_id_predicate_saved := empty_entity.make_update_transition_event_id_predicate
			validate(update_transition_event_id_predicate_saved)
		end
		Result := update_transition_event_id_predicate_saved
	end

   select_transition_history_predicate_saved : ROSE_LINEAR_ARRAY[COLLECTING_PREDICATE [ENTITY_TRANSITION]]
   select_transition_predicate_saved : COLLECTING_PREDICATE [ENTITY_TRANSITION]
   add_transition_predicate_saved : EXECUTION_PREDICATE
   update_transition_predicate_saved: EXECUTION_PREDICATE
   update_transition_event_id_predicate_saved: EXECUTION_PREDICATE

   data_server: DATA_SERVER

   entity_cache : SUPPLIER_ENTITY_CACHE[G]
   relationship_cache : SUPPLIER_ENTITY_RELATIONSHIP_CACHE [G]
   entity_cache_made : BOOLEAN
   relationship_cache_made : BOOLEAN

   set_entity_cache (a_entity_cache: SUPPLIER_ENTITY_CACHE[G]): SUPPLIER_ENTITY_CACHE[G] is
      do
		 if not entity_cache_made then
			entity_cache := a_entity_cache
				entity_cache_made := True
		 end
		 Result := entity_cache
	  end

	set_relationship_cache (a_relationship_cache: SUPPLIER_ENTITY_RELATIONSHIP_CACHE[G]): SUPPLIER_ENTITY_RELATIONSHIP_CACHE[G] is
      do
		 if not relationship_cache_made then
			relationship_cache := a_relationship_cache
				relationship_cache_made := True
		 end
		 Result := relationship_cache
      end

   identity (a_any : ANY) : ANY is
	  do
		 Result := a_any
	  end

feature {SUPPLIER_ENTITY_BASE, SUPPLIER_ENTITY_CACHE, SUPPLIER_ENTITY_ATTRIBUTE, SUPPLIER_ENTITY_RELATIONSHIP_CACHE, WORLDSCOPE_ATTRIBUTE_TYPE_CODE_MANAGER} -- Implementation

   attribute_type_manager : SUPPLIER_ATTRIBUTE_TYPE_MANAGER

feature {NONE }-- Implementation

   empty_entity : G

end
