indexing
	description: "A container of all of the ENTITY_TRANSITIONs for one SUPPLIER_ENTITY"
	author: "RJ"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #4 $"

class
	ENTITY_TRANSITION_HISTORY

inherit
	EXTENDABLE_BOUNDED_ARRAY [ENTITY_TRANSITION]

create
	make_empty

feature -- Access

	first_transition(a_type_id: INTEGER): ENTITY_TRANSITION is
	require
		a_type_id_not_zero: a_type_id /= 0
	local
		i: INTEGER
	do
		from
			i := lower
		until
			i > upper or Result/=Void
		loop
			if item (i).transition_type_id = a_type_id
			then
				Result := item (i)
			end

			i := i + 1
		end
	end

	last_transition(a_type_id: INTEGER): ENTITY_TRANSITION is
	require
		a_type_id_not_zero: a_type_id /= 0
	local
		i: INTEGER
	do
		from
			i := upper
		until
			i < lower or Result/=Void
		loop
			if item (i).transition_type_id = a_type_id
			then
				Result := item (i)
			end

			i := i - 1
		end
	end

	first_transition_date (a_type_id: INTEGER): ROSE_DATE is
	require
		a_type_id_not_zero: a_type_id /= 0
	local
		l_transition: ENTITY_TRANSITION
	do
		l_transition := first_transition(a_type_id)
		if l_transition/=Void
		then
			Result := l_transition.transition_date
		end
	end

end
