indexing
	description: "error info"
	author: ""
	date: "$Date: 2010/09/07 $"
	revision: "$Revision: #18 $"

class
	ERROR_INFO

inherit
	COM_UNKNOWN
	MEMORY_FUNCTIONS
	COM_STRING_FUNCTIONS
	MEMORY
		rename
			free as memory_free
		redefine
			dispose
		end

create
	make,
	make_by_record

feature -- Initialization

	make is
			-- Creation procedure.
		local
			i: INTEGER
		do
			i := GetErrorInfo (0, $p)
		end

	make_by_record (e: ERROR_RECORDS; i: INTEGER) is
		require
			e_not_void: e /= Void
			e_exists: e.p /= default_pointer
			i_large_enough: i >= 0
			i_small_enough: i < e.get_record_count
		local
			hr: INTEGER
			l_p: POINTER
		do
			release
			l_p := p
			hr := e.Get_error_info (i, $l_p)
			p := l_p
		end

	get_description: STRING is
		require
			exists: exists
		local
			i: INTEGER
			l_ptr: POINTER
		do
			i := IErrorInfo_GetDescription (p, $l_ptr)
			if i = 0 then
				Result := widechar_to_string (l_ptr)
				SysFreeString (l_ptr)
			else
				Result := "ERROR"
				Result.append (i.out)
				Result.append ("xxxxxxx")
			end
		end


	IErrorInfo_GetDescription(This,pBstrDescription: POINTER): INTEGER is
		external
			"C [macro <oledb.h>] (IErrorInfo*, BSTR*): EIF_INTEGER"
		alias
			"IErrorInfo_GetDescription"
		end

	get_source: STRING
			-- Wrapper for IErrorInfo::GetSource.
		require
			exists: exists
		local
			i: INTEGER
			l_ptr: POINTER
			str_length: INTEGER
			str_pointer: POINTER
			dummy: INTEGER
		do
			i := IErrorInfo_GetSource(p, $l_ptr)
			if i = 0 then
				Result := "xxx"
				str_length := SysStringLen (l_ptr)
				str_pointer := calloc (1, str_length + 1)
				dummy := WideCharToMultiByte (0, 0, l_ptr, -1, str_pointer, str_length, default_pointer, default_pointer)
				create Result.make (0)
				Result.from_c (str_pointer)
				free (str_pointer)
				SysFreeString (l_ptr)
			else
				Result := "Source could not be determined.  Error = "
				Result.append (i.out)
				Result.append ("xxxxxxx")
			end
		end

feature {NONE} -- Implementation.
	dispose
	-- Tell OLEDB to remove our reference.
	do
		release
	end

	IErrorInfo_GetSource(This,pBstrDescription: POINTER): INTEGER is
		external
			"C [macro <oledb.h>] (IErrorInfo*, BSTR*): EIF_INTEGER"
		alias
			"IErrorInfo_GetSource"
		end

	GetErrorInfo(dwReserved:INTEGER; pperrinfo: POINTER): INTEGER is
		external
			"C [macro <oleauto.h>] (DWORD, IErrorInfo  **): EIF_INTEGER"
		alias
			"GetErrorInfo"
		end

	IID_IErrorInfo: POINTER is
		external
			"C [macro <oledb.h>]"
		alias
			"&IID_IErrorInfo"
		end

end
