indexing
	description: "error records"
	author: ""
	date: "$Date: 2010/09/07 $"
	revision: "$Revision: #11 $"

class
	ERROR_RECORDS

inherit
	COM_UNKNOWN
		redefine
			out
		end
	MEMORY
		rename
			free as memory_free
		redefine
			out,
			dispose
		end

create
	make

feature -- Initialization

	make (e: ERROR_INFO) is
			-- Creation procedure.
		require
			e_not_void: e /= Void
			e_exists: e.p /= default_pointer
		local
			i: INTEGER
		do
			i := e.query_interface (IID_IErrorRecords, $p)
		end

	get_record_count: INTEGER
			-- Wrapper for IErrorRecords::GetRecordCount.
		require
			exists: exists
		do
			IErrorRecords_GetRecordCount (p, $Result)
		end

	Get_custom_error_object (i: INTEGER;riid: POINTER; ppObject: POINTER): INTEGER is
		require
			exists: exists
		do
			Result := IErrorRecords_GetCustomErrorObject (p, i, riid, ppobject)
		end

	Get_error_info (i: INTEGER; ppObject: POINTER): INTEGER is
		require
			exists: exists
		do
			Result := IErrorRecords_GetErrorInfo (p, i, GetUserDefaultLCID, ppobject)
		end

	out: STRING is
	local
		l_sql_error_info: SQL_ERROR_INFO
		l_child_error_info: ERROR_INFO
		i: INTEGER
	do
		Result := ""
		from
			i :=  get_record_count - 1
		until
			i < 0
		loop
			create l_sql_error_info.make_by_record(Current, i)
			if l_sql_error_info.exists
			then
				Result.append("Native error = " + l_sql_error_info.native_error.out + "%N")
			else
				Result.append("Native error = ?%N")
			end

			create l_child_error_info.make_by_record(Current, i)
			if l_child_error_info.exists
			then
				Result.append("Error text: ")
				Result.append(l_child_error_info.get_description)
				Result.append("%N")
				Result.append("Source: ")
				Result.append(l_child_error_info.get_source)
				Result.append("%N")
			else
				Result.append("Unable to get the child error info.%N")
			end

			i := i - 1
		end
	end

feature {NONE} -- Implementation.
	dispose
	-- Tell OLEDB to remove our reference.
	do
		release
	end

feature -- Externals

	GetUserDefaultLCID: INTEGER is
		external
			"C [macro <winnls.h>]: EIF_INTEGER"
		alias
			"GetUserDefaultLCID ()"
		end
--	IErrorRecords_AddErrorRecord(This,pErrorInfo: POINTER;dwLookupID: INTEGER;pdispparams: POINTER,punkCustomError,dwDynamicErrorID)	\

--#define IErrorRecords_GetBasicErrorInfo(This,ulRecordNum,pErrorInfo)	\

IErrorRecords_GetErrorInfo(This: POINTER;ulRecordNum,lcid: INTEGER;ppErrorInfo: POINTER): INTEGER is
		external
			"C [macro <oledb.h>] (IErrorRecords*, ULONG, LCID, IUnknown**): EIF_INTEGER"
		alias
			"IErrorRecords_GetErrorInfo"
		end

IErrorRecords_GetBasicErrorInfo(This: POINTER;ulRecordNum: INTEGER;ppErrorInfo: POINTER): INTEGER is
		external
			"C [macro <oledb.h>] (IErrorRecords*, ULONG, IUnknown**): EIF_INTEGER"
		alias
			"IErrorRecords_GetBasicErrorInfo"
		end

	IErrorRecords_GetCustomErrorObject(This: POINTER;ulRecordNum: INTEGER; riid: POINTER; ppObject: POINTER): INTEGER is
		external
			"C [macro <oledb.h>] (IErrorRecords*, ULONG, REFIID, IUnknown**): EIF_INTEGER"
		alias
			"IErrorRecords_GetCustomErrorObject"
		end


--#define IErrorRecords_GetErrorInfo(This,ulRecordNum,lcid,ppErrorInfo)	\

--#define IErrorRecords_GetErrorParameters(This,ulRecordNum,pdispparams)	\

	IErrorRecords_GetRecordCount(This: POINTER; pcRecords: POINTER)is
		external
			"C [macro <oledb.h>] (IErrorRecords*, ULONG*)"
		alias
			"IErrorRecords_GetRecordCount"
		end

	IID_IErrorRecords: POINTER is
		external
			"C [macro <oledb.h>]"
		alias
			"&IID_IErrorRecords"
		end
end
