note

	description: "EVENT_Z_A:DIVIDEND_EXTENSION.PARM file record"

	author: "Ivan Tarnavsky"
	last_editor: "$Author: it $"
	date: "$Date: 2011/03/04 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/expert_system/aflows/event_z_a_corporate_actions_settlement_parm.e $"

class EVENT_Z_A_CORPORATE_ACTIONS_SETTLEMENT_PARM

inherit

	RP_PORTFOLIO_PARM [EVENT_Z_A_CORPORATE_ACTIONS_SETTLEMENT_PARM_RECORD]
		redefine
			make
		end

	RP_EVENT_TYPE_CONSTANTS
		export {NONE} all end

	DEBUG_OUTPUT

create

	make

feature {NONE} -- Initialization

	make (a_record: like record) is
			-- <Precursor>
		do
			Precursor (a_record)
			create exdate.make_ccyymmdd (record.exdate_ccyymmdd)
			create paydate.make_ccyymmdd (record.paydate_ccyymmdd)
		end

feature -- Access

	brimsym: STRING is
			-- Brimsym
		do
			Result := record.brimsym
		end

	exdate: ROSE_DATE
			-- Ex-date

	paydate: ROSE_DATE
			-- Paydate

	is_stock_dividend: BOOLEAN is
			-- Does `Current' apply to stock dividend?
		do
			Result := record.event_type = stock_dividend_event_type_5
		end

feature -- Output

	debug_output: STRING is
			-- <Precursor>
		do
			create Result.make_empty
			Result.append (clicode)
			Result.append_character (':')
			Result.append (brimsym)
			Result.append_character (':')
			Result.append_integer (exdate.ccyymmdd)
			Result.append_character (':')
			Result.append_integer (paydate.ccyymmdd)
		end

invariant

	exdate_not_void: exdate /= Void
	exdate_set: exdate.ccyymmdd = record.exdate_ccyymmdd
	paydate_not_void: paydate /= Void
	paydate_set: paydate.ccyymmdd = record.paydate_ccyymmdd

end
