note

	description:
	"[
		Definition of EVENT_Z_A:DIVIDEND_EXTENSION.PARM file format
			
		--- snip ---
		Account__Brimsym___________|Trans|___Exdate|_settled_|____Comment__________________________________
		DOLL     AUE000001101...SYD     5  20010629 20010629
		DUGLO    AUE000001101...SYD     5  20010629 20010629
		GIANTO   AUE000001101...SYD     5  20010629 20010629
		SKI      KRE000179091...SEO     5  20010712 20010712
		--- snip ---
		|      | |                | |   |  |      | |      |
		         111111111122222222223333333333444444444455555555556666666666777777777788
		123456789012345678901234567890123456789012345678901234567890123456789012345678901
	]"
	author: "Ivan Tarnavsky"
	last_editor: "$Author: it $"
	date: "$Date: 2011/03/04 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/expert_system/aflows/event_z_a_corporate_actions_settlement_parm_file.e $"

class EVENT_Z_A_CORPORATE_ACTIONS_SETTLEMENT_PARM_FILE

inherit

	ROSE_ROBUST_FIXED_FORMATTED_TEXT_FILE [EVENT_Z_A_CORPORATE_ACTIONS_SETTLEMENT_PARM_RECORD]

create

	make

feature -- Access

	format: ROSE_ROBUST_FIXED_FORMAT
			-- <Precursor>
		once
			create Result.make (
				<<
					[constants.string_type,           "clicode",  1,  8],
					[constants.string_type,           "brimsym", 10, 27],
					[constants.integer_type,       "event_type", 29, 33],
					[constants.integer_type,  "exdate_ccyymmdd", 36, 43],
					[constants.integer_type, "paydate_ccyymmdd", 45, 52]
				>>
			)
		end

	header_lines_count: INTEGER is 1
		-- <Precursor>

end
