note

	description:

		"EVENT_Z_A:CORPORATE_ACTIONS_SETTLEMENT.PARM file RAW record"

	author: "Ivan Tarnavsky"
	last_editor: "$Author: it $"
	date: "$Date: 2011/03/04 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/expert_system/aflows/event_z_a_corporate_actions_settlement_parm_record.e $"

class EVENT_Z_A_CORPORATE_ACTIONS_SETTLEMENT_PARM_RECORD

inherit

	RP_PORTFOLIO_PARM_RECORD

	RP_EVENT_TYPE_CONSTANTS
		export {NONE} all end

feature -- Access

	brimsym: STRING
		-- Instrument brimsym

	event_type: INTEGER
		-- Event type

	exdate_ccyymmdd: INTEGER
		-- Ex-dividend date

	paydate_ccyymmdd: INTEGER
		-- Payment date (settlement)

feature -- Status

	is_valid: BOOLEAN
			-- <Precursor>
		do
			Result := string_not_void_or_empty (clicode) and string_not_void_or_empty (brimsym)
			Result := Result and (event_type = stock_dividend_event_type_5 or event_type = stock_distribution_event_type_6 or event_type = dividend_taxed_event_type_33)
			Result := Result and valid_ccyymmdd (exdate_ccyymmdd) and valid_ccyymmdd (paydate_ccyymmdd)
		ensure then
			brimsym_not_empty_or_void: Result implies string_not_void_or_empty (brimsym)
			correct_event_type: Result implies event_type = stock_dividend_event_type_5 or event_type = stock_distribution_event_type_6 or event_type = dividend_taxed_event_type_33
			valid_exdate: Result implies valid_ccyymmdd (exdate_ccyymmdd)
			valid_paydate: Result implies valid_ccyymmdd (paydate_ccyymmdd)
		end

end
