note

	description: "EVENT_Z_A:DIVIDEND_EXTENSION.PARM file record"

	author: "Ivan Tarnavsky"
	last_editor: "$Author: it $"
	date: "$Date: 2011/03/04 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/expert_system/aflows/event_z_a_dividend_extension_parm.e $"

class EVENT_Z_A_DIVIDEND_EXTENSION_PARM

inherit

	RP_PORTFOLIO_PARM [EVENT_Z_A_DIVIDEND_EXTENSION_PARM_RECORD]
		rename
			clicode as country_iso_code
		redefine
			make
		end

	DEBUG_OUTPUT

create

	make

feature {NONE} -- Initialization

	make (a_record: like record) is
			-- <Precursor>
		do
			Precursor (a_record)
			create start_date.make_ccyymmdd (record.start_ccyymmdd)
			if record.end_ccyymmdd \\ 1_00_00 = 99_99 then
				create end_date.make_max_date
			else
				create end_date.make_ccyymmdd (record.end_ccyymmdd)
			end
		end

feature -- Access

	number_of_days: INTEGER
			-- Number of market days to extend dividend settlement
		do
			Result := record.number_of_days
		end

	currency_iso_code: STRING is
			-- Currency ISO code
		do
			Result := record.currency_iso_code
		end

	start_date: ROSE_DATE
			-- Start date

	end_date: ROSE_DATE
			-- End date

feature -- Output

	debug_output: STRING is
			-- <Precursor>
		do
			create Result.make_empty
			Result.append (country_iso_code)
			Result.append_character (':')
			Result.append_integer (number_of_days)
			Result.append_character (':')
			Result.append (currency_iso_code)
			Result.append_character (':')
			Result.append_integer (start_date.ccyymmdd)
			Result.append_character ('-')
			Result.append_integer (end_date.ccyymmdd)
		end

invariant

	start_date_not_void: start_date /= Void
	start_date_set: start_date.ccyymmdd = record.start_ccyymmdd
	end_date_not_void: end_date /= Void
	end_date_set: end_date.ccyymmdd = record.end_ccyymmdd or (record.end_ccyymmdd \\ 1_00_00 = 99_99 and end_date ~ end_date.max_date)

end
