note

	description:
	"[
		Definition of EVENT_Z_A:DIVIDEND_EXTENSION.PARM file format
			
		--- snip ---
		! There is at least 1 space character between columns of data  (all lines starting with '!' will be ignored.)
		! First column is the Country code (2 characters), followed by the number of days to extend the effective paydate (5 digits)
		! The 3rd col is the applicable currency, the 4th is the start of time period (by paydate) where this line is valid (inclusive)
		! The 5th col is the end of the time period (by pay date) where the record is valid (inclusive)
		! Special Nday codes: 0 effect DIVFX
		!2**12345***123*12345678*12345678********** < not read only for user comments>
		!CTRY NDAYS Cur  start   end date
		!-  -----   --- -------- --------
		AU      7   AUD 19850501 99999999           ! extend 7 days after settlement date
		AU      7   USD 19850501 99999999           ! extend 7 days after settlement date
		AU      7   NZD 19850501 99999999           ! extend 7 days after settlement date
		HK      7   HKD 19850501 99999999           ! extend 7 days after settlement date
		--- snip ---
		||  |   |   | | |      | |      |
		         111111111122222222223333333333444444444455555555556666666666777777777788
		123456789012345678901234567890123456789012345678901234567890123456789012345678901
	]"
	author: "Ivan Tarnavsky"
	last_editor: "$Author: it $"
	date: "$Date: 2011/03/04 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/expert_system/aflows/event_z_a_dividend_extension_parm_file.e $"

class EVENT_Z_A_DIVIDEND_EXTENSION_PARM_FILE

inherit

	ROSE_ROBUST_FIXED_FORMATTED_TEXT_FILE [EVENT_Z_A_DIVIDEND_EXTENSION_PARM_RECORD]

create

	make

feature -- Access

	format: ROSE_ROBUST_FIXED_FORMAT
			-- <Precursor>
		once
			create Result.make (
				<<
					[constants.string_type,  "country_iso_code",  1,  2],
					[constants.integer_type,   "number_of_days",  5,  9],
					[constants.string_type, "currency_iso_code", 13, 15],
					[constants.integer_type,   "start_ccyymmdd", 17, 24],
					[constants.integer_type,     "end_ccyymmdd", 26, 33]
				>>
			)
		end

	header_lines_count: INTEGER is 8
		-- <Precursor>

end
