note

	description:

		"EVENT_Z_A:DIVIDEND_EXTENSION.PARM file RAW record"

	author: "Ivan Tarnavsky"
	last_editor: "$Author: it $"
	date: "$Date: 2011/03/04 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/expert_system/aflows/event_z_a_dividend_extension_parm_record.e $"

class EVENT_Z_A_DIVIDEND_EXTENSION_PARM_RECORD

inherit

	RP_PORTFOLIO_PARM_RECORD
		rename
			clicode as country_iso_code
		end

feature -- Access

	number_of_days: INTEGER
		-- Number of market days to extend dividend settlement

	currency_iso_code: STRING
		-- Currency ISO code

	start_ccyymmdd: INTEGER
		-- Start of period

	end_ccyymmdd: INTEGER
		-- End of period

feature -- Status

	is_valid: BOOLEAN
			-- <Precursor>
		do
			Result := string_not_void_or_empty (country_iso_code) and string_not_void_or_empty (currency_iso_code)
			Result := Result and number_of_days >= 0
			Result := Result and valid_ccyymmdd (start_ccyymmdd) and valid_ccyymmdd (end_ccyymmdd)
			Result := Result and start_ccyymmdd <= end_ccyymmdd
		ensure then
			currency_not_void_or_empty: Result implies string_not_void_or_empty (currency_iso_code)
			number_of_days_ge_0: Result implies number_of_days >= 0
			valid_dates: Result implies valid_ccyymmdd (start_ccyymmdd) and valid_ccyymmdd (end_ccyymmdd)
			start_date_le_end_date: Result implies start_ccyymmdd <= end_ccyymmdd
		end

end
