note

	description:

		"Excel workbook"

	author: "pn"
	last_editor: "$Author: myeager $"
	date: "$Date: 2014/02/19 $"
	revision: "$Revision: #11 $"
	path: "$File: //rose/source/kernel/infrastructure/windows/classic/excel_workbook.e $"

class
	EXCEL_WORKBOOK

inherit

	COM_DISPATCH

create
	make_by_pointer

feature -- Access properties

	name: STRING is
			-- Name of workbook
		do
			Result := get_string_property (get_id ("Name"))
		end

feature -- Basic operations

	close (save_changes: COM_VARIANT; filename: ANY;
				route_workbook: ANY) is
				-- Close the workbook
		do
			dispparams.init
			function_exception.init
			dispparams.add_argument (save_changes)
			g_variant.init
			invoke (get_id ("Close"), Dispatch_method, dispparams, g_variant, function_exception)
			check_result
			if g_variant.dispatch_pointer /= default_pointer then
			end
			release_variant

		end
	save_as (a_file_name: STRING) is
			-- Save to file
		do
			dispparams.init
			function_exception.init
			g_variant.init
			g_variant.set_from_string (a_file_name)
			dispparams.add_argument (g_variant)
		--	g_variant.init
			invoke (get_id ("SaveAs"), Dispatch_method, dispparams, g_variant, function_exception)
			check_result
			if g_variant.dispatch_pointer /= default_pointer then
			end
			release_variant

		end

	save_copy_as (a_file_name: STRING)
			-- Save to file.
			-- Same as `save_as', but with the same feature name as in .NET.
		do
			save_as (a_file_name)
		end

	save_as_text (a_file_name: STRING) is
		-- Save as text.
		do
			save_as_format (a_file_name, 20)
		end

	save_as_csv (a_file_name: STRING) is
		-- Save as text.
		do
			save_as_format (a_file_name, 23)
		end

	save_as_format (a_file_name: STRING; a_format: INTEGER) is
			-- Save to file
		do
			dispparams.init
			function_exception.init
			g_variant.init
			g_variant.set_from_string (a_file_name)
			dispparams.add_named_arg_dispid (0)
			dispparams.add_argument (g_variant)
			g_variant.init
			g_variant.set_from_integer (a_format)
			dispparams.add_named_arg_dispid (1)
			dispparams.add_argument (g_variant)
		--	g_variant.init
			invoke (get_id ("SaveAs"), Dispatch_method, dispparams, g_variant, function_exception)
			check_result
			if g_variant.dispatch_pointer /= default_pointer then
			end
			release_variant

		end

	sheets: EXCEL_WORKSHEETS is
			-- Worksheets
		local
			l_pointer: POINTER
		do
			l_pointer := get_dispatch_property (get_id ("Sheets"))
			if l_pointer /= default_pointer then
				create Result.make_by_pointer (l_pointer)
				release_variant
			end
		end


end -- class EXCEL_WORKBOOK
