note

	description:

		"EXCEL workbooks"

	author: "pn"
	last_editor: "$Author: er $"
	date: "$Date: 2013/02/05 $"
	revision: "$Revision: #11 $"
	path: "$File: //rose/source/kernel/infrastructure/windows/classic/excel_workbooks.e $"

class
	EXCEL_WORKBOOKS

inherit
	COM_DISPATCH

create
	make_by_pointer

feature -- Initialization

	add (a_template: ANY): EXCEL_WORKBOOK is
			-- Add a workbook
		do
			method(get_id ("Add"))
			create Result.make_by_pointer (g_variant.dispatch_pointer)
			release_variant
		end

	com_item(v: COM_VARIANT): EXCEL_WORKBOOK is
		require
			v_not_void: v /= Void
		do
			dispparams.init
			function_exception.init
			dispparams.add_argument (v)
			g_variant.init
			invoke (get_id ("Item"), Dispatch_propertyget, dispparams, g_variant, function_exception)
			check_result
			if g_variant.dispatch_pointer /= default_pointer then
				create Result.make_by_pointer (g_variant.dispatch_pointer)
			end
			release_variant
		end


	com_count: INTEGER is
			-- count
		do
			Result := Get_integer_property (get_id ("Count"))
		end

	open (a_file_name: STRING) is
		require
			file_name_ok: a_file_name /= Void
		local
			l_book : EXCEL_WORKBOOK
		do
			dispparams.init
			function_exception.init
			g_variant.init
			g_variant.set_from_string (a_file_name)
			dispparams.add_argument (g_variant)
			g_variant.init
			invoke (get_id ("Open"), Dispatch_method, dispparams, g_variant, function_exception)
			check_result
			if g_variant.dispatch_pointer /= default_pointer then
				create l_book.make_by_pointer (g_variant.dispatch_pointer)
			end
			release_variant
		end

	item (i : INTEGER) : EXCEL_WORKBOOK is
			-- Item at index `i'
		do
			g_variant.init
			g_variant.set_from_integer(i)
			Result := com_item(g_variant)
			release_variant
		end

	count: INTEGER
			-- Number of items
		do
			Result := com_count
		end

end
