indexing
	description: "Excel worksheet"
	author: ""
	date: "$Date: 2010/01/21 $"
	revision: "$Revision: #12 $"

class
	EXCEL_WORKSHEET

inherit

	COM_DISPATCH

create
	make_by_pointer

feature -- Initialization

	range_by_name (s: STRING): EXCEL_RANGE is
			-- Get the range with name s.
		require
			s_not_void: s /= Void
		do
			dispparams.init
			function_exception.init
			g_variant.init
			g_variant.set_from_string (s)
			dispparams.add_argument (g_variant)
			g_variant.init
			invoke (get_id ("Range"), Dispatch_propertyget, dispparams, g_variant, function_exception)
			check_result
			if g_variant.dispatch_pointer /= default_pointer then
				create Result.make_by_pointer (g_variant.dispatch_pointer)
			end
			release_variant
		end

	range (cell1: SYSTEM_STRING; cell2: ANY): EXCEL_RANGE is
			-- portable range
		do
			Result := range_by_name (cell1)
		end


	set_name (a_name: STRING) is
			-- Set the name of the current worksheet. The name appears on the tab at the bottom left of the workbook.
		do
			set_string_property(get_id ("Name"), a_name)
		end

	name: STRING is 
			-- Get the name of the current worksheet
		do
			Result := get_string_property (get_id ("Name"))
		end

	pictures : EXCEL_PICTURES is
			-- The list of pictures in the current worksheet
		do
			dispparams.init
			function_exception.init
			g_variant.init
			invoke (get_id ("Pictures"), Dispatch_propertyget, dispparams, g_variant, function_exception)
			check_result
			if g_variant.dispatch_pointer /= default_pointer then
				create Result.make_by_pointer (g_variant.dispatch_pointer)
			end
			release_variant
		end

end -- class EXCEL_WORKSHEET
