note

	description:

		"Excel worksheets"

	author: "Pierre Nallet"
	last_editor: "$Author: er $"
	date: "$Date: 2014/02/16 $"
	revision: "$Revision: #8 $"
	path: "$File: //rose/source/kernel/infrastructure/windows/classic/excel_worksheets.e $"

class
	EXCEL_WORKSHEETS

inherit

	COM_DISPATCH

create

	make_by_pointer


feature -- Initialization

	add (a_before, a_after, a_count, a_type: ANY): EXCEL_WORKSHEET is
			-- Add a worksheet, ignore the parameters
		do
			method(get_id ("Add"))
			create Result.make_by_pointer (g_variant.dispatch_pointer)
			release_variant

		end

	com_item(v: COM_VARIANT): EXCEL_WORKSHEET is
			-- Excel worksheet associated with `v'
		require
			v_not_void: v /= Void
		do
			dispparams.init
			function_exception.init
			dispparams.add_argument (v)
			g_variant.init
			invoke (get_id ("Item"), Dispatch_propertyget, dispparams, g_variant, function_exception)
			check_result
			if g_variant.dispatch_pointer /= default_pointer then
				create Result.make_by_pointer (g_variant.dispatch_pointer)
			end
			release_variant
		end

	item (i : INTEGER) : EXCEL_WORKSHEET is
			-- `i'-th Excel worksheet
		do
			g_variant.init
			g_variant.set_from_integer(i)
			Result := com_item(g_variant)
			release_variant
		end

	count: INTEGER
			-- Number of items.
		do
			Result := get_integer_property (get_id ("Count"))
		end

end
