note

	description:

		"exchange object"

	keywords: "exchange,currency,country"
	author: "Mark Howard"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #36 $"
	path: "$File: //rose/source/kernel/investment_entities/exchange.e $"

class
	EXCHANGE

inherit
	INVESTMENT_ENTITY
		undefine
			name_identifier_key
		end
	PERSISTENT_EXCHANGE
		undefine
			context,
			make,
			make_context,
			debug_output
		end
	ROSE_ID_USER
		undefine
			is_equal
		end

create
   make,make_anonymous

feature -- Basic operations

	register is
			-- Register this entity.
		do
			name := name_key(today)
			set_is_composite
			set_zone_mnemonic
			reuters_code := reuters_code_key(Void)
		end

	name : STRING
	is_composite : BOOLEAN
	reuters_code : STRING

	set_is_composite is
			-- Set 'is_composite' to True.
		local
			l_flag : STRING
		do
			l_flag := attribute_by_name (composite_attribute_string, Void)
			if l_flag /= Void then
				l_flag.to_lower
				is_composite := l_flag.is_equal(true_string)
			end
		end

	set_zone_mnemonic is
				-- Set zone mnemonic
		local
			l_country : COUNTRY
		do
			l_country := country
			if l_country /= Void then
				zone_mnemonic := l_country.zone_mnemonic
			end
		end

	listing_count : INTEGER is
			-- Number of listings returned by `all_listings'.
		local
			l_listings : like all_listings
		do
			l_listings := all_listings
			if l_listings /= Void then
				Result := l_listings.count
			end
		end

	listing(i : INTEGER) : like context.listing_template 
			--`i'th listing in this exchange
		local
			l_listings : like all_listings
		do
			l_listings := all_listings
			if l_listings /= Void and then l_listings.valid_index(i) then
				Result := l_listings.item(i)
			end
		end

	all_listings :  like all_listings_saved is
		local
			l_handler : RELATIONSHIP_HANDLER[like context.listing_template, like Current]
		do
			if all_listings_saved = Void then
				create l_handler.make(context, ids.listing_exchange_relationship_type_id)
				all_listings_saved := l_handler.corelated_entities(Current)
			end
			Result := all_listings_saved
		end

	all_listings_saved : ROSE_LINEAR_ARRAY[like context.listing_template]

	listings_at(a_date : ROSE_DATE) :  like all_listings_saved is
		local
			l_handler : RELATIONSHIP_HANDLER[like context.listing_template, like Current]
		do
			create l_handler.make(context, ids.listing_exchange_relationship_type_id)
			Result := l_handler.corelated_entities_at(Current, a_date)
		end

feature {NONE} -- Implementation

	true_string : STRING is "true"
	composite_attribute_string : STRING is "IS COMPOSITE"

end
