indexing
	author : "Mark Howard"
	description : "exchange rate of two currencies, with division defined to give the relative exchange rate if the denominators are the same"
	keywords : "foreign_exchange,exchange_rate,rate,currency"
class
	EXCHANGE_RATE 
	
create
	make
	
feature 
	
	make (a_currency_1,a_currency_2 : PERSISTENT_CURRENCY;a_rate : DOUBLE;a_date : ROSE_DATE) is
		do 
			numerator := a_currency_1
			denominator := a_currency_2
			rate := a_rate
			date := a_date
		end
	
feature 
	
	numerator : PERSISTENT_CURRENCY
	denominator : PERSISTENT_CURRENCY
	rate : DOUBLE
	date : ROSE_DATE
	
feature -- Infix
	
	infix "/" (a_other : like Current) : EXCHANGE_RATE is
		require
			denominators_match : denominator = void or else a_other.denominator = void or else
								 denominator.is_equal(a_other.denominator)
		do 
			if denominator = void or else a_other.denominator = void or else
				denominator.is_equal(a_other.denominator) then
				create Result.make(numerator,a_other.numerator,rate / a_other.rate,date)
			end
		end
	infix "*" (a_other : like Current) : EXCHANGE_RATE is
		require
			currencies_match : denominator.is_equal(a_other.numerator)
		do 
			if denominator.is_equal(a_other.numerator) then
				create Result.make(numerator,a_other.denominator,rate * a_other.rate,date)
			end
		end
	
end 
