indexing
	description: "selection predicate for expanded types"
	author: ""
	date: "$Date: 2009/05/27 $"
	revision: "$Revision: #23 $"

deferred class
	EXPANDED_SELECTION_PREDICATE[G]

inherit
	GENERAL_SELECTION_PREDICATE[G]
		rename
			make_with_parameter_template as selection_predicate_make_with_parameter_template
		redefine
			facilitator,
			set_template,
			reset_container
		end

feature {NONE} -- Initialization

	make (a_server : DATA_SERVER;a_selection : STRING) is
		do
            make_with_parameter_template(a_server, a_selection, Void)
        end

	make_with_parameter_template (a_server : DATA_SERVER;
		a_selection : STRING;
		a_parameter_template: ARRAY[STRING]) is
		require
			a_server_not_void: a_server /= Void
		do
			debug("make_movies")
				create cam.make(generating_type + "/" + a_selection + "/" + a_server.node + "/" + a_server.database)
			end

			set_selection(a_server,a_selection, a_parameter_template)
			--create {DYNAMIC_ITERATOR[G]} iterator.make(~action)
			create iterator.make(Current)
			create array.make_empty
			set_container_internal(array)
			selection := a_selection
		end	

feature -- Miscellaneous

	set_template (a_template : G) is
			-- Set `vessel' and `empty_vessel' to `a_template'.
		do
			vessel := a_template
			empty_vessel := a_template
		end

	facilitator : SELECTOR

	reset_container is
		do
			if container_set then
				Precursor
			else
				reset_array
				set_container_internal(array)
			end
		end

	reset_array is
		do
			if container_set then
				array.wipe_out
			else
				create array.make_empty
			end
			index := 0
		end

	make_extendable_iterator is
		do
			create {EXTENDABLE_EXPANDED_PREDICATE_ITERATOR[G]} iterator.make(Current)
		end

	make_indexable_iterator is
		do
			   create {INDEXABLE_EXPANDED_PREDICATE_ITERATOR[G]} iterator.make(Current)
		end

	array : ROSE_LINEAR_ARRAY[G]

	forth is	
		local
			l_triple: TRIPLE[G, BOOLEAN, BOOLEAN]
			l_after: BOOLEAN
			l_vessel: G
		do
			if playback_movie
			then
				l_triple ?= cam.next_frame("forth").frame_data
				l_vessel := l_triple.first
				success := l_triple.second
				l_after := l_triple.third
				cam.compare_not_needed
			else
			 	--6/16/2000collection_off
				facilitator.fetch(void)
				success := facilitator.success
				l_after := facilitator.after
			end

		 	if success and not l_after then
		 		if playback_movie
		 		then
		 			vessel := l_vessel
		 		else
					vessel := next_value
				end

		 		--6/16/2000if needs_collecting then collection_on end
				index := index + 1
				item := vessel
				records_fetched := records_fetched + 1
				--6/16/2000if records_fetched \\ 65536 = 0 then
				--6/16/2000   full_collect
				--6/16/2000   full_coalesce
				--6/16/2000end
		 	end

			debug("make_movies")
				if record_movie
				then
					create l_triple.make(vessel, success, l_after)
					cam.record_movie_frame("forth", l_triple)
				end
			end
		end

	new_vessel : G is
		do
			Result := empty_vessel
		end

	next_value : G is deferred end

end
