indexing
	description: "Operator facilities for expressions"
	author: "Shujing Li"
	date: "$Date: 2009/07/17 $"
	revision: "$Revision: #6 $"
	archive: "$File: //rose/source/kernel/math/expression_math.e $"

class
	EXPRESSION_MATH [reference G]
inherit
	DOUBLE_MATH
	ROSE_CONSTANTS
feature -- Access

	e_sqrt (a_expression: ROSE_EXPRESSION [G]): like a_expression is --!
		do
			Result := Create {ROSE_UNARY_EXPRESSION [G]}.make (a_expression, operator_of (Agent internal_sqrt, "sqrt"))
		end

	e_floor (a_expression: ROSE_EXPRESSION [G]; a_floor: DOUBLE): like a_expression is --!
		do
			Result := Create {ROSE_UNARY_EXPRESSION [G]}.make (a_expression, operator_of (Agent internal_floor (?, a_floor,?,?), "floor"))
		end

	e_ceiling (a_expression: ROSE_EXPRESSION [G]; a_ceiling: DOUBLE): like a_expression is --!
		do
			Result := Create {ROSE_UNARY_EXPRESSION [G]}.make (a_expression, operator_of (Agent internal_ceiling (?, a_ceiling,?,?), "ceiling"))
		end

feature -- Basic operations

feature {NONE}	-- Implementation
	operator_of (a_function: like function; a_function_name: STRING): ROSE_FUNCTION_OPERATOR [G] is
			-- !
		do
			create Result.make_with_function (a_function, a_function_name)
		end

	function: FUNCTION [ANY, TUPLE [DOUBLE,G,ROSE_EXPRESSION[G]], DOUBLE] is --!
		do  end

	internal_sqrt (a_v: DOUBLE; a_g:G; a_expr:ROSE_EXPRESSION[G]): DOUBLE is
			-- square_root operator
		do
			if is_defined_double (a_v) and then a_v >= 0 then
				Result := sqrt (a_v)
			else
				Result := constants.missing_double
			end
		end
	internal_floor (a_v, a_floor: DOUBLE; a_g:G; a_expr:ROSE_EXPRESSION[G]): DOUBLE is
			--!
		do
			if a_v < a_floor  then
				Result := a_floor
			else
				Result := a_v
			end
		end
	internal_ceiling (a_v, a_ceiling: DOUBLE; a_g:G; a_expr:ROSE_EXPRESSION[G]): DOUBLE is  --!
		do
			if a_v > a_ceiling  then
				Result := a_ceiling
			else
				Result := a_v
			end
		end

end
