note

	description:

		"ROSE_OPERATOR factory"

	author: "Mark Howard"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/02/22 $"
	revision: "$Revision: #16 $"
	path: "$File: //rose/source/kernel/math/expression_operators.e $"

class
	EXPRESSION_OPERATORS[reference G]
inherit
	ROSE_CONSTANTS
create
	make
feature  --Creation
	make is
			-- create
		do
			create binary_operators.make(20)
			create unary_operators.make(20)
			add_binary_operator (create {ROSE_PLUS_OPERATOR [G]}.make(constants.Double_type,2,"+"))
			add_binary_operator (create {ROSE_TIMES_OPERATOR [G]}.make(constants.Double_type,3,"*"))
			add_binary_operator (create {ROSE_MINUS_OPERATOR [G]}.make(constants.Double_type,2,"-"))
			add_binary_operator (create {ROSE_RATIO_OPERATOR [G]}.make(constants.Double_type,3,"/"))
			add_binary_operator (create {ROSE_INTEGER_DIVISION_OPERATOR [G]}.make(constants.Double_type,3,"div "))
			add_binary_operator (create {ROSE_AND_OPERATOR [G]}.make(constants.Boolean_type,0,"and "))
			add_binary_operator (create {ROSE_OR_OPERATOR [G]}.make(constants.Boolean_type,0,"or "))
			add_binary_operator (create {ROSE_IMPLIES_OPERATOR [G]}.make(constants.Boolean_type,0,"implies "))
			add_binary_operator (create {ROSE_LESS_THAN_OPERATOR [G]}.make(constants.Boolean_type,1,"<"))
			add_binary_operator (create {ROSE_GREATER_THAN_OPERATOR [G]}.make(constants.Boolean_type,1,">"))
			add_binary_operator (create {ROSE_RELATIVE_DELTA_OPERATOR [G]}.make(constants.Double_type,1,"#~"))
			add_binary_operator (create {ROSE_EQUAL_OPERATOR [G]}.make (constants.Boolean_type,1,"="))
			add_binary_operator (create {ROSE_LAG_MONTHS_OPERATOR [G]}.make (constants.Double_type, 5, "lag_months"))
			add_unary_operator(create {ROSE_POSITIVE_OPERATOR[G]}.make(constants.Double_type,4,"+"))
			add_unary_operator(create {ROSE_NEGATIVE_OPERATOR[G]}.make(constants.Double_type,4,"-"))
			add_unary_operator(create {ROSE_NOT_OPERATOR[G]}.make(constants.Boolean_type,4,"not "))
			add_unary_operator(create {ROSE_ABSOLUTE_OPERATOR[G]}.make(constants.Double_type,4,"abs "))
			add_unary_operator(create {ROSE_LOG_OPERATOR[G]}.make(constants.Double_type,4,"log "))
			add_unary_operator(create {ROSE_EXPONENTIAL_OPERATOR[G]}.make(constants.Double_type,4,"exp "))
			add_unary_operator (create {ROSE_LAG_MONTH_OPERATOR [G]}.make (constants.Double_type, 5, "lag_month"))
			add_unary_operator (create {ROSE_UNDERRIDE_OPERATOR [G]}.make (constants.Double_type, 5, "underride"))
			add_unary_operator (create {ROSE_NORMALIZED_VALUE_OPERATOR [G]}.make (constants.Double_type, 5, "normalized"))
			binary_operator("*").set_inverse(binary_operator("/"))
			binary_operator("/").set_inverse(binary_operator("*"))
		end
	add_unary_operator (a_operator: ROSE_UNARY_OPERATOR[like generic_template]) is
			--add unary operator
		do
			unary_operators.put(a_operator,a_operator.name)
		end
	add_binary_operator (a_operator: ROSE_BINARY_OPERATOR[like generic_template]) is
		do
			binary_operators.put(a_operator,a_operator.name)
		end
	unary_operator (a_string: STRING): ROSE_UNARY_OPERATOR[G] is
		do
			Result := unary_operators.item(a_string)
		end

	binary_operator (a_string: STRING): ROSE_BINARY_OPERATOR[G] is
		do
			Result := binary_operators.item(a_string)
		end

	operator (a_string: STRING): ROSE_OPERATOR is
			-- Operator from name
		do
			Result := unary_operator(a_string)
			if Result = void then
				Result := binary_operator(a_string)
			end
		end

	binary_operators : HASH_TABLE[ROSE_BINARY_OPERATOR[like generic_template],STRING]
	unary_operators : HASH_TABLE[ROSE_UNARY_OPERATOR[like generic_template],STRING]
	operator_count: INTEGER is
			-- Total number of operators
		once
			Result := unary_operators.count + binary_operators.count
		end
	generic_template : G is do end
feature --Operators
	plus_operator : ROSE_PLUS_OPERATOR [G]
			--+
		 do Result ?= binary_operators["+"] end
	times_operator : ROSE_TIMES_OPERATOR [G]
			--*
		 do Result ?= binary_operators["*"] end
	minus_operator : ROSE_MINUS_OPERATOR [G]
			---
		 do Result ?= binary_operators["-"] end
	ratio_operator : ROSE_RATIO_OPERATOR [G]
			--/
		 do Result ?= binary_operators["/"] end
	integer_division_operator : ROSE_INTEGER_DIVISION_OPERATOR [G]
			--div 
		 do Result ?= binary_operators["div "] end
	and_operator : ROSE_AND_OPERATOR [G]
			--and 
		 do Result ?= binary_operators["and "] end
	or_operator : ROSE_OR_OPERATOR [G]
			--or 
		 do Result ?= binary_operators["or "] end
	implies_operator : ROSE_IMPLIES_OPERATOR [G]
			--implies 
		 do Result ?= binary_operators["implies "] end
	less_than_operator : ROSE_LESS_THAN_OPERATOR [G]
			--<
		 do Result ?= binary_operators["<"] end
	greater_than_operator : ROSE_GREATER_THAN_OPERATOR [G]
			-->
		 do Result ?= binary_operators[">"] end
	relative_delta_operator : ROSE_RELATIVE_DELTA_OPERATOR [G]
			--#~
		 do Result ?= binary_operators["#~"] end
	equal_operator : ROSE_EQUAL_OPERATOR [G]
			--=
		 do Result ?= binary_operators["="] end
	lag_months_operator : ROSE_LAG_MONTHS_OPERATOR [G]
			--lag_months
		 do Result ?= binary_operators["lag_months"] end
	positive_operator : ROSE_POSITIVE_OPERATOR[G]
			--+
		 do Result ?= unary_operators["+"] end
	negative_operator : ROSE_NEGATIVE_OPERATOR[G]
			---
		 do Result ?= unary_operators["-"] end
	not_operator : ROSE_NOT_OPERATOR[G]
			--not 
		 do Result ?= unary_operators["not "] end
	absolute_operator : ROSE_ABSOLUTE_OPERATOR[G]
			--abs 
		 do Result ?= unary_operators["abs "] end
	log_operator : ROSE_LOG_OPERATOR[G]
			--log 
		 do Result ?= unary_operators["log "] end
	exponential_operator : ROSE_EXPONENTIAL_OPERATOR[G]
			--exp 
		 do Result ?= unary_operators["exp "] end
	lag_month_operator : ROSE_LAG_MONTH_OPERATOR [G]
			--lag_month
		 do Result ?= unary_operators["lag_month"] end
	underride_operator : ROSE_UNDERRIDE_OPERATOR [G]
			--underride
		 do Result ?= unary_operators["underride"] end
	normalized_value_operator : ROSE_NORMALIZED_VALUE_OPERATOR [G]
			--normalized
		 do Result ?= unary_operators["normalized"] end
end


