indexing
	description: "EXTEL Currency access"
	author: "Bruno Pradal"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #2 $"
	archive: "$File: //rose/source/kernel/market/extel_currency_market.e $"

class

	EXTEL_CURRENCY_MARKET

inherit

	SIGNATURE_TAGGED_CURRENCY_MARKET
	
feature

	source: STRING is "EXTEL"

	base_currency (a_date: ROSE_DATE): CURRENCY is
		do
			if a_date < first_euro then
				Result := context.gbp
			else
				Result := context.eur
			end
		end

	is_valid_record (a_record: ROSE_VIRTUAL_RECORD[FOREX_SIGNATURE]) : BOOLEAN is
		do
			Result := a_record /= Void and then a_record.signature.spot > 0
		end

	actual_rate (a_record: ROSE_VIRTUAL_RECORD[FOREX_SIGNATURE]): DOUBLE is
		do
			Result := a_record.signature.spot
		end

feature
	
	first_euro : ROSE_DATE is
		once
			create Result.make_ccyymmdd(19990104)
		end

	first_extel : ROSE_DATE is
		once
			create Result.make_ccyymmdd(19950801)
		end
			
end


