indexing
	description : "Container for factored rationals keyed by the pair (numerator,denominator)"
	author : "Mark Howard"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #6 $"
	archive: "$File: //rose/source/kernel/infrastructure/math/factored_rationals.e $"

class
	FACTORED_RATIONALS

feature -- Access

	rationals: HASH_TABLE [FACTORED_RATIONAL, KEY_PAIR [INTEGER, INTEGER]] is
		once
			create Result.make (1000)
		end

	pair (i, j: INTEGER): KEY_PAIR [INTEGER, INTEGER] is
		do
			once_pair.set (i, j)
			Result := once_pair
		end

	new_pair (i, j: INTEGER): KEY_PAIR [INTEGER, INTEGER] is
		do
			create Result.make (i, j)
		end

	factors: HASH_TABLE [ROSE_LINEAR_ARRAY [INTEGER], INTEGER] is
		once
			create Result.make (1000)
			Result.put (create {ROSE_LINEAR_ARRAY [INTEGER]}.make_empty, 0)
		end

feature {NONE} -- Implementation

	once_pair: KEY_PAIR [INTEGER, INTEGER] is
		once
			create Result.make (0, 0)
		end

end
