note

	description:

		"ROSE_CONTEXT version of PERSISTENT_FUTURE"

	author: "Mark Howard"
	last_editor: "$Author: m5 $"
	date: "$Date: 2013/04/18 $"
	revision: "$Revision: #29 $"
	path: "$File: //rose/source/kernel/investment_entities/future.e $"

class
	FUTURE
inherit
	INVESTMENT_ENTITY
		undefine
			peer_anchor,
			expression_tag
		end
	PERSISTENT_FUTURE
		undefine
			context,
			make,
			make_context,
			debug_output
		end
	RMDAT_INSTRUMENT
		undefine
			is_equal
		end
	LEGACY_INSTRUMENT
create

	make_anonymous,make

feature --  Basic operations

	is_composite : BOOLEAN = false
		-- Futures can not be composites
	composite_record (a_date : ROSE_DATE) : COMPOSITE_RECORD
			--Void
		do
		end
	register is
			-- Register this entity.
		do
		end

	asset_class_code (a_date: ROSE_DATE) : STRING is
			-- Asset class code as of `a_date'.
		do
			Result := "D"
		end

	risk_region_code (a_date: ROSE_DATE) : STRING is
			-- Risk region ISO code
		local
			s: STRING
		do
			s := brim_code( a_date)
			if s /= void then
				Result := s.substring(1,2)
			end
		end
	future_details_template : FUTURE_DETAILS is do end

feature -- Additional attributes
	bloomberg_code (a_date: ROSE_DATE) : STRING is
			-- BLOOMBERG
		do
			Result := attribute_by_name ("BLOOMBERG IDENTIFIER", constants.now)
		end
end
