note

	description:

		"Listing of futures instrument"

	author: "Janet Small"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #20 $"
	path: "$File: //rose/source/kernel/investment_entities/future_listing.e $"

class FUTURE_LISTING

inherit

	INVESTMENT_ENTITY
		undefine
			peer_anchor,
			ur_targets
		redefine
			make,
			make_with_zone_xrf
		end
	PERSISTENT_FUTURE_LISTING
		undefine
			context,
			make,
			make_context,
			debug_output,
			ur_targets,
			issue
		end

create

	make,
	make_with_zone_xrf,
	make_anonymous

feature {FUTURE_LISTING}-- Creation

	make (a_context : like context;a_category_id : INTEGER;a_handle : INTEGER;a_start_date,a_end_date : ROSE_DATE) is
			--Initialization
		do
			Precursor{INVESTMENT_ENTITY}(a_context,a_category_id,a_handle,a_start_date,a_end_date)
		end

	make_with_zone_xrf(a_context : like context;a_category_id : INTEGER;a_handle : INTEGER;a_start_date,a_end_date : ROSE_DATE;a_zone : ZONE[LOCATION];a_xrf : INTEGER) is
		do
			Precursor{INVESTMENT_ENTITY}(a_context,a_category_id,a_handle,a_start_date,a_end_date,a_zone,a_xrf)
		end

feature -- Basic operations

	ur_targets : ROSE_LINEAR_ARRAY[ROSE_ENTITY_DATE[ENTITY]] is
			-- ur targets
		local
			l_signature : RMDAT_SIGNATURE_RECORD
		once
			create l_signature
			l_signature.set_zone(zone_by_mnemonic('F'))
			create Result.make_empty
			Result.extend(l_signature)
		end

	register  is
			-- Register this entity.
		do
			if zone /= void then
				zone.add_future_listing(Current)
			end
		end


	issue: like context.future_template is
		do
			Result := something_corelated_by_future_to_future_listing
		end
end








