note

	description:

		"Automagically Generated -- Empty Description in GCDB"

	keywords: "entity, gcdb, account"
	author: "$Author: mk $"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #25 $"
	path: "$File: //rose/source/kernel/gcdb/generated/gcdb_account_base.e $"

deferred class
	GCDB_ACCOUNT_BASE

inherit
	PERSISTENT_ACCOUNT
		export
			{GCDB_ACCOUNT_BASE,GCDB_HOME} all
		undefine
			make,
			context
		redefine
			name_at
		end
	GCDB_ENTITY
		export
			{GCDB_ACCOUNT_BASE,GCDB_HOME} all
			{ANY} handle, is_equal, hash_code,
					entity_at, start_date, end_date,
					as_of_date, set_as_of_date
		undefine
			is_equal
		redefine
			name_at
		end

feature {NONE} -- Implementation

	upcast: like context.account_template is
			-- convert to base
		do
			Result ?= Current
		end

feature -- GCDB Attributes and Relationships

	code: STRING is
			-- Short name.\r\nIt must be unique for each client.
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

	is_axa: EGCDB_TRISTATE is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := tristate_attribute_value (10110, as_of_date)
		end

	is_split: BOOLEAN is
			-- Yes/No flag for sub-divided accounts (not used now)
		do
			Result := boolean_attribute_value (10112, as_of_date)
		end

	name: STRING is
			-- Full name used for reporting purpose.
		do
			Result := attribute_from_supplier_attribute_id_at (46, as_of_date)
		end

	client_history: ROSE_ENTITY_HISTORY[GCDB_CLIENT] is
			-- history of Short name for client
		do
			Result := context.account_to_client.related_entity_intervals (upcast)
		end

	client: GCDB_CLIENT is
			-- Short name for client
		do
			Result := client_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	report_currencies_history: ROSE_ENTITY_HISTORY[GCDB_CURRENCY] is
			-- history of The currency used for the reports.
		do
			Result := context.account_to_reporting_currency.related_entity_intervals (upcast)
		end

	report_currencies: ROSE_LINEAR_ARRAY[GCDB_CURRENCY] is
			-- The currency used for the reports. (314)
		do
			Result := report_currencies_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	is_confidential: EGCDB_TRISTATE is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := tristate_attribute_value (10149, as_of_date)
		end

	domicile_country_history: ROSE_ENTITY_HISTORY[GCDB_COUNTRY] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.account_to_domicile_country.related_entity_intervals (upcast)
		end

	domicile_country: GCDB_COUNTRY is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := domicile_country_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	domicile_region_history: ROSE_ENTITY_HISTORY[GCDB_INVESTMENT_REGION] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.account_to_domicile_region.related_entity_intervals (upcast)
		end

	domicile_region: GCDB_INVESTMENT_REGION is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := domicile_region_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	is_offshore: BOOLEAN is
			-- custodied offshore from the client domicile and investment
		do
			Result := boolean_attribute_value (10152, as_of_date)
		end

	imc_marketing_history: ROSE_ENTITY_HISTORY[GCDB_IMC] is
			-- history of Which is the IMC responsible for the sale?
		do
			Result := context.account_to_imc_marketing.related_entity_intervals (upcast)
		end

	imc_marketing: GCDB_IMC is
			-- Which is the IMC responsible for the sale?
		do
			Result := imc_marketing_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	imc_client_services_history: ROSE_ENTITY_HISTORY[GCDB_IMC] is
			-- history of Which is the IMC performing the client service?
		do
			Result := context.account_to_imc_client_services.related_entity_intervals (upcast)
		end

	imc_client_services: GCDB_IMC is
			-- Which is the IMC performing the client service?
		do
			Result := imc_client_services_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	imc_accounting_history: ROSE_ENTITY_HISTORY[GCDB_IMC] is
			-- history of Which is the IMC billing the client?
		do
			Result := context.account_to_imc_accounting.related_entity_intervals (upcast)
		end

	imc_accounting: GCDB_IMC is
			-- Which is the IMC billing the client?
		do
			Result := imc_accounting_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	is_discretionary: BOOLEAN is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := boolean_attribute_value (10164, as_of_date)
		end

	taft_hartley: BOOLEAN is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := boolean_attribute_value (10259, as_of_date)
		end

	-- relationship -- consultant -> 451 GCDB_CONSULTANT -- 260 GCDB doesn't have description for this attribute/relationship

	client_services_operator: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10273, as_of_date)
		end

	benchmark_history: ROSE_ENTITY_HISTORY[GCDB_BENCHMARK] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.account_to_benchmark.related_entity_intervals (upcast)
		end

	benchmark: GCDB_BENCHMARK is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := benchmark_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	account_type_history: ROSE_ENTITY_HISTORY[GCDB_CLIENT_TYPE] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.account_to_account_type.related_entity_intervals (upcast)
		end

	account_type: GCDB_CLIENT_TYPE is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := account_type_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	client_type: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10329, as_of_date)
		end

	pension_type: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10331, as_of_date)
		end

	dc_type: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10332, as_of_date)
		end

	take_on_coordinator: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10382, as_of_date)
		end

	is_public: BOOLEAN is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := boolean_attribute_value (10385, as_of_date)
		end

	is_taxable: BOOLEAN is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := boolean_attribute_value (10386, as_of_date)
		end

	is_retail: BOOLEAN is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := boolean_attribute_value (10387, as_of_date)
		end

	base_currency_history: ROSE_ENTITY_HISTORY[GCDB_CURRENCY] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.account_to_base_currency.related_entity_intervals (upcast)
		end

	base_currency: GCDB_CURRENCY is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := base_currency_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	has_mfn_clause: EGCDB_TRISTATE is
			-- Indicates that account has MFN clause
		do
			Result := tristate_attribute_value (434, as_of_date)
		end

	is_axar_voting: EGCDB_TRISTATE is
			-- When checked indicates that this account has been setup to vote or not to vote proxy
		do
			Result := tristate_attribute_value (437, as_of_date)
		end

	-- relationship -- composite_state -> 334 GCDB_COMPOSITE_MEMBERSHIP -- 453 GCDB doesn't have description for this attribute/relationship

	local_name: STRING is
			-- Name written in local alphabet
		do
			Result := attribute_from_supplier_attribute_id_at (458, as_of_date)
		end

	distributed_by_history: ROSE_ENTITY_HISTORY[GCDB_DISTRIBUTOR] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.account_to_distributed_by.related_entity_intervals (upcast)
		end

	distributed_by: GCDB_DISTRIBUTOR is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := distributed_by_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	custodian_registration_date: ROSE_DATE is
			-- Date by which the custodian bank \r\nfinished processing all the necessary forms \r\nand registered the account domicile.\r\nFrom this date on all tax treaties\r\nbased on the account domicile\r\nwill be in effect.
		do
			Result := date_attribute_value (257, as_of_date)
		end

	client_specific_code: STRING is
			-- Identification code used by the client's system
		do
			Result := attribute_from_supplier_attribute_id_at (258, as_of_date)
		end

	monthly_rebalance: BOOLEAN is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := boolean_attribute_value (503, as_of_date)
		end

	is_fund_participant: BOOLEAN is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := boolean_attribute_value (508, as_of_date)
		end

	-- relationship -- domicile -> 524 GCDB_DOMICILE -- 529 Domicile as it is in the contract

	composite_history: ROSE_ENTITY_HISTORY[GCDB_PRODUCT] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.account_to_composite.related_entity_intervals (upcast)
		end

	composite: GCDB_PRODUCT is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := composite_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	reporting_attribution_model_history: ROSE_ENTITY_HISTORY[GCDB_REPORTING_ATTRIBUTION_MODEL] is
			-- history of The model used for performance attribution
		do
			Result := context.account_to_reporting_attribution_model.related_entity_intervals (upcast)
		end

	reporting_attribution_model: GCDB_REPORTING_ATTRIBUTION_MODEL is
			-- The model used for performance attribution
		do
			Result := reporting_attribution_model_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	-- relationship -- imc_legal -> 49 GCDB_IMC -- 573 Legal IMC - requested by SA and R1

	-- attribute -- is_kag: EGCDB_TRISTATE -- 574 A KAG is a German fund management intermediary.  So in order to manage any German assets, the asset owner has to go via a KAG to us.  The KAG is a regulated entity and where AXA Rosenberg internally delegate such mandates between offices (from the Legal IMC to the investment IMC0 special regulatory terms and condition must apply.  So by having a field marking a certain client as being a KAG any office will know that certain contract terms apply to them.

	-- relationship -- product -> 154 GCDB_PRODUCT -- 576 GCDB doesn't have description for this attribute/relationship

	fx_base_currency_history: ROSE_ENTITY_HISTORY[GCDB_CURRENCY] is
			-- history of If income is in a restricted currency
		do
			Result := context.account_to_fx_base_currency.related_entity_intervals (upcast)
		end

	fx_base_currency: GCDB_CURRENCY is
			-- If income is in a restricted currency
		do
			Result := fx_base_currency_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	is_cls_enabled: BOOLEAN is
			-- True indicates that this accounts FXs will use CLS with the supporting brokers.
		do
			Result := boolean_attribute_value (587, as_of_date)
		end

	-- attribute -- portfolio_manager: STRING -- 604 GCDB doesn't have description for this attribute/relationship

	-- attribute -- assistant_portfolio_manager: STRING -- 605 GCDB doesn't have description for this attribute/relationship

	-- attribute -- client_communications_manager: STRING -- 606 GCDB doesn't have description for this attribute/relationship

	-- relationship -- credit_interest_frequency -> 616 GCDB_PERIOD -- 619 The frequency of Credit Interest for a Long Short Account, e.g. Daily, Weekly, Monthly, Other

	-- relationship -- shortmarket_interest_frequency -> 616 GCDB_PERIOD -- 620 The frequency of Short Market Interest for a Long Short Account, e.g. Daily, Weekly, Monthly, Other

	-- attribute -- custodian_reporting_date: STRING -- 624 The number of business days each month before any Custodian Reports needs to be submitted.

	-- attribute -- reconciliation_due_date: STRING -- 625 The number of business days each month before the Cash and Assets Reconciliation must be completed

	-- attribute -- client_reporting_date: STRING -- 626 The number of business days each month before any Client Report needs to be submitted.

	-- attribute -- is_perf_inception_month_partial: EGCDB_TRISTATE -- 635 GCDB doesn't have description for this attribute/relationship

	-- relationship -- class_action -> 637 GCDB_CLASS_ACTION_RESPONSE_TYPE -- 639 GCDB doesn't have description for this attribute/relationship

	civ_annual_management_fee: STRING is
			-- Annual management fee in basis points
		do
			Result := attribute_from_supplier_attribute_id_at (720, as_of_date)
		end

	-- attribute -- client_start_override: ROSE_DATE -- 729 This is the date on which we gain a discretion to trade the account. It needs to be entered only if different then account start date.

	-- attribute -- discretion_end: ROSE_DATE -- 730 We lose discretion to trade the account. There may be activity after that date but the performance is not representative after it.

	nof_perf: BOOLEAN is
			-- Indicates that Net of Fee performance should be generated for the account by the performance programs.
		do
			Result := boolean_attribute_value (734, as_of_date)
		end

	portfolios_by_account_history: ROSE_ENTITY_HISTORY[GCDB_PORTFOLIO] is
			-- history of account to portfolio by account
		do
			Result := context.portfolio_to_account.corelated_entity_intervals (upcast)
		end

	portfolios_by_account: ROSE_LINEAR_ARRAY[GCDB_PORTFOLIO] is
			-- account to portfolio by account (139)
		do
			Result := portfolios_by_account_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	-- relationship -- products_by_highest_fee_account -> 154 GCDB_PRODUCT -- 0 account to product by highest_fee_account

	-- relationship -- products_by_representative_account -> 154 GCDB_PRODUCT -- 0 account to product by representative_account

	taxes_by_account_history: ROSE_ENTITY_HISTORY[GCDB_TAX] is
			-- history of account to tax by account
		do
			Result := context.tax_to_account.corelated_entity_intervals (upcast)
		end

	taxes_by_account: ROSE_LINEAR_ARRAY[GCDB_TAX] is
			-- account to tax by account (268)
		do
			Result := taxes_by_account_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	-- relationship -- proxy_votings_by_account -> 264 GCDB_PROXY_VOTING -- 0 account to proxy_voting by account

	bank_accounts_by_account_history: ROSE_ENTITY_HISTORY[GCDB_BANK_ACCOUNT] is
			-- history of account to bank_account by account
		do
			Result := context.bank_account_to_account.corelated_entity_intervals (upcast)
		end

	bank_accounts_by_account: ROSE_LINEAR_ARRAY[GCDB_BANK_ACCOUNT] is
			-- account to bank_account by account (193)
		do
			Result := bank_accounts_by_account_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	-- relationship -- account_reports_by_account -> 396 GCDB_ACCOUNT_REPORT -- 0 account to account_report by account

	-- relationship -- account_reporting_benchmarks_by_account -> 482 GCDB_ACCOUNT_REPORTING_BENCHMARK -- 0 account to account_reporting_benchmark by account

	-- relationship -- explicit_fx_with_11as_by_account -> 493 GCDB_EXPLICIT_FX_WITH_11A -- 0 account to explicit_fx_with_11a by account

	name_at (a_date: ROSE_DATE): STRING is
			-- name_at queries the unique code attribute
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

end -- GCDB_ACCOUNT
