note

	description:

		"Automagically Generated -- Empty Description in GCDB"

	keywords: "entity, gcdb, bank_account"
	author: "$Author: mk $"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #18 $"
	path: "$File: //rose/source/kernel/gcdb/generated/gcdb_bank_account_base.e $"

deferred class
	GCDB_BANK_ACCOUNT_BASE

inherit
	PERSISTENT_BANK_ACCOUNT
		export
			{GCDB_BANK_ACCOUNT_BASE,GCDB_HOME} all
		undefine
			make,
			context
		end
	GCDB_ENTITY
		export
			{GCDB_BANK_ACCOUNT_BASE,GCDB_HOME} all
			{ANY} handle, is_equal, hash_code, 
					entity_at, start_date, end_date, 
					as_of_date, set_as_of_date
		undefine
			is_equal
		end

feature {NONE} -- Implementation

	upcast: like context.bank_account_template is
			-- convert to base
		do
			Result ?= Current
		end

feature -- GCDB Attributes and Relationships

	account_history: ROSE_ENTITY_HISTORY[GCDB_ACCOUNT] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.bank_account_to_account.related_entity_intervals (upcast)
		end

	account: GCDB_ACCOUNT is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := account_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	custodian_history: ROSE_ENTITY_HISTORY[GCDB_BANK] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.bank_account_to_custodian.related_entity_intervals (upcast)
		end

	custodian: GCDB_BANK is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := custodian_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	custodian_account: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10282, as_of_date)
		end

	sub_custodian_history: ROSE_ENTITY_HISTORY[GCDB_BANK] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.bank_account_to_sub_custodian.related_entity_intervals (upcast)
		end

	sub_custodian: GCDB_BANK is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := sub_custodian_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	sub_custodian_account: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10284, as_of_date)
		end

	currency_history: ROSE_ENTITY_HISTORY[GCDB_CURRENCY] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.bank_account_to_currency.related_entity_intervals (upcast)
		end

	currency: GCDB_CURRENCY is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := currency_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	countries_history: ROSE_ENTITY_HISTORY[GCDB_COUNTRY] is
			-- history of Optional list of countries that this bank account information applies to.
		do
			Result := context.bank_account_to_country.related_entity_intervals (upcast)
		end

	countries: ROSE_LINEAR_ARRAY[GCDB_COUNTRY] is
			-- Optional list of countries that this bank account information applies to. (191)
		do
			Result := countries_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	bank_account_id: STRING is
			-- The two-digit bank account after the currency in the event files.
		do
			Result := attribute_from_supplier_attribute_id_at (10304, as_of_date)
		end

	custodian_local_id: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10359, as_of_date)
		end

	sub_custodian_local_id: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10360, as_of_date)
		end

	pset_history: ROSE_ENTITY_HISTORY[GCDB_PSET] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.bank_account_to_pset.related_entity_intervals (upcast)
		end

	pset: GCDB_PSET is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := pset_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	-- relationship -- counterparty_role -> 609 GCDB_COUNTERPARTY_ROLE -- 612 Counterparty role for this relationship

	-- attribute -- is_fee_per_transaction: BOOLEAN -- 621 True if the custody fees per transaction are applied on a per transaction basis. False if custody fees per transaction are lumped into a single amount once per month.

	-- relationship -- reconciliation_type -> 613 GCDB_RECONCILIATION_TYPE -- 622 How do we reconcile with this counterparty

	-- attribute -- is_overdraft_allowed: BOOLEAN -- 623 True if short term overdrafts are allowed for investment or settlement purposes.

	-- attribute -- is_third_part_fx_allowed: BOOLEAN -- 627 If true then account can be traded with third party FX broker. If false then FX can only be traded with the custodian.

	-- attribute -- is_fx_matched_via_mt300: BOOLEAN -- 628 True if the account have FX matching via an MT300. False otherwise.

	-- attribute -- is_forward_bank_transaction_allowed: BOOLEAN -- 629 True if Custodian posts bank entries for a forward value date.

	-- attribute -- is_providing_management_fees_preadvice: BOOLEAN -- 630 True if Third Party pre-notifiies AXA Rosenberg of any Management fees. False otherwise.

	-- attribute -- is_with_standing_instructions: BOOLEAN -- 631 Does the account have standing instructions for Corporate Actions with the Custodian, e.g. always take cash on cash / stock Dividends?

	-- attribute -- is_sweeping_dividends: BOOLEAN -- 632 Does the account sweep dividends out of the custody account, i.e. an EVent Type 31 (without cash effect)?

	-- attribute -- is_delaying_dividends: BOOLEAN -- 633 Does the account systematically delay the payment of dividends (entry in VMS PARM file to delay the Dividend Value Date by a number of business days)

end -- GCDB_BANK_ACCOUNT