note

	description:

		"Automagically Generated -- Empty Description in GCDB"

	keywords: "entity, gcdb, bank"
	author: "$Author: mk $"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #20 $"
	path: "$File: //rose/source/kernel/gcdb/generated/gcdb_bank_base.e $"

deferred class
	GCDB_BANK_BASE

inherit
	PERSISTENT_BANK
		export
			{GCDB_BANK_BASE,GCDB_HOME} all
		undefine
			make,
			context
		redefine
			name_at
		end
	GCDB_ENTITY
		export
			{GCDB_BANK_BASE,GCDB_HOME} all
			{ANY} handle, is_equal, hash_code,
					entity_at, start_date, end_date,
					as_of_date, set_as_of_date
		undefine
			is_equal
		redefine
			name_at
		end

feature {NONE} -- Implementation

	upcast: like context.bank_template is
			-- convert to base
		do
			Result ?= Current
		end

feature -- GCDB Attributes and Relationships

	code: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

	name: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (46, as_of_date)
		end

	bic: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10277, as_of_date)
		end

	branch: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10278, as_of_date)
		end

	-- relationship -- fx_broker -> 168 GCDB_BROKER -- 431 FX broker arm of the bank.

	parm_code: STRING is
			-- Bank identifier used in clients_z.parm
		do
			Result := attribute_from_supplier_attribute_id_at (510, as_of_date)
		end

	is_cls_participant: BOOLEAN is
			-- True if this custodian uses CLS for FX settlement.
		do
			Result := boolean_attribute_value (589, as_of_date)
		end

	restricted_cls_currencies_history: ROSE_ENTITY_HISTORY[GCDB_CURRENCY] is
			-- history of List of currencies not supported by the custodian for FX settlement thru CLS.
		do
			Result := context.custodian_to_restricted_cls_currency.related_entity_intervals (upcast)
		end

	restricted_cls_currencies: ROSE_LINEAR_ARRAY[GCDB_CURRENCY] is
			-- List of currencies not supported by the custodian for FX settlement thru CLS. (323)
		do
			Result := restricted_cls_currencies_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	-- attribute -- is_settlement_swift_capable: BOOLEAN -- 713 Indication that we expect the counterparty to provide settlement report via swift.

	-- relationship -- swift_recipients_by_from -> 190 GCDB_SWIFT_RECIPIENT -- 0 bank to swift_recipient by from

	-- relationship -- swift_recipients_by_counterparty -> 190 GCDB_SWIFT_RECIPIENT -- 0 bank to swift_recipient by counterparty

	bank_accounts_by_sub_custodian_history: ROSE_ENTITY_HISTORY[GCDB_BANK_ACCOUNT] is
			-- history of bank to bank_account by sub_custodian
		do
			Result := context.bank_account_to_sub_custodian.corelated_entity_intervals (upcast)
		end

	bank_accounts_by_sub_custodian: ROSE_LINEAR_ARRAY[GCDB_BANK_ACCOUNT] is
			-- bank to bank_account by sub_custodian (196)
		do
			Result := bank_accounts_by_sub_custodian_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	bank_accounts_by_custodian_history: ROSE_ENTITY_HISTORY[GCDB_BANK_ACCOUNT] is
			-- history of bank to bank_account by custodian
		do
			Result := context.bank_account_to_custodian.corelated_entity_intervals (upcast)
		end

	bank_accounts_by_custodian: ROSE_LINEAR_ARRAY[GCDB_BANK_ACCOUNT] is
			-- bank to bank_account by custodian (195)
		do
			Result := bank_accounts_by_custodian_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	bank_swift_options_by_bank_history: ROSE_ENTITY_HISTORY[GCDB_BANK_SWIFT_OPTION] is
			-- history of bank to bank_swift_option by bank
		do
			Result := context.bank_swift_option_to_bank.corelated_entity_intervals (upcast)
		end

	bank_swift_options_by_bank: ROSE_LINEAR_ARRAY[GCDB_BANK_SWIFT_OPTION] is
			-- bank to bank_swift_option by bank (343)
		do
			Result := bank_swift_options_by_bank_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	name_at (a_date: ROSE_DATE): STRING is
			-- name_at queries the unique code attribute
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

end -- GCDB_BANK
