note

	description:

		"Automagically Generated -- Empty Description in GCDB"

	keywords: "entity, gcdb, benchmark"
	author: "$Author: mk $"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #21 $"
	path: "$File: //rose/source/kernel/gcdb/generated/gcdb_benchmark_base.e $"

deferred class
	GCDB_BENCHMARK_BASE

inherit
	PERSISTENT_BENCHMARK
		export
			{GCDB_BENCHMARK_BASE,GCDB_HOME} all
		undefine
			make,
			context
		redefine
			name_at
		end
	GCDB_ENTITY
		export
			{GCDB_BENCHMARK_BASE,GCDB_HOME} all
			{ANY} handle, is_equal, hash_code,
					entity_at, start_date, end_date,
					as_of_date, set_as_of_date
		undefine
			is_equal
		redefine
			name_at
		end

feature {NONE} -- Implementation

	upcast: like context.benchmark_template is
			-- convert to base
		do
			Result ?= Current
		end

feature -- GCDB Attributes and Relationships

	code: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

	name: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (46, as_of_date)
		end

	type_history: ROSE_ENTITY_HISTORY[GCDB_STRATEGY_TYPE] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.benchmark_to_strategy_type.related_entity_intervals (upcast)
		end

	type: GCDB_STRATEGY_TYPE is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := type_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	currency_history: ROSE_ENTITY_HISTORY[GCDB_CURRENCY] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.benchmark_to_currency.related_entity_intervals (upcast)
		end

	currency: GCDB_CURRENCY is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := currency_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	is_hedged: BOOLEAN is
			-- Indicates that this benchmark has curency hedge
		do
			Result := boolean_attribute_value (414, as_of_date)
		end

	-- relationship -- region -> 419 GCDB_STRATEGY_REGION -- 423 GCDB doesn't have description for this attribute/relationship

	-- relationship -- holdret_universe -> 514 GCDB_HOLDRET_UNIVERSE -- 519 Default Holdret universe to be used in client_bogies_u.parm for all portfolios that use this benchmark. This default can be overriden by a holdret universe set for the portfolio itself.

	-- relationship -- imc_engineering -> 49 GCDB_IMC -- 530 Owner of the benchmark setup and the returns as well as permission control of who can edit its returns. In case of benchmark return entered in more than one file - this will determine the source for the return. The others will just be propagated from it.

	-- relationship -- legacy_replacement -> 48 GCDB_BENCHMARK -- 544 If populated will be used in generating client_bogies_z.parm in place of the existing benchmark

	-- relationship -- benchmark_mtd_rtn_source -> 545 GCDB_BENCHMARK_MTD_RTN_SOURCE -- 549 The source of the month-to-date return

	-- relationship -- benchmark_monthly_rtn_source -> 546 GCDB_BENCHMARK_MONTHLY_RTN_SOURCE -- 550 The source of the monthly return

	-- attribute -- client_reporting_name: STRING -- 640 Name displayed on all client reports. \r\nShould be the same for all aliases of a given set of returns. \r\nIt is only required if different than the benchmark name. \r\nOtherwise the benchmark name will be used.

	dividend_reinvestment_history: ROSE_ENTITY_HISTORY[GCDB_DIVIDEND_REINVESTMENT_MODEL] is
			-- history of Provides information about the reinvestment of dividends in the benchmark return calculations.
		do
			Result := context.benchmark_to_dividend_reinvestment.related_entity_intervals (upcast)
		end

	dividend_reinvestment: GCDB_DIVIDEND_REINVESTMENT_MODEL is
			-- Provides information about the reinvestment of dividends in the benchmark return calculations.
		do
			Result := dividend_reinvestment_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	master_history: ROSE_ENTITY_HISTORY[GCDB_BENCHMARK] is
			-- history of Name of the master benchmark
		do
			Result := context.benchmark_to_master_benchmark.related_entity_intervals (upcast)
		end

	master: GCDB_BENCHMARK is
			-- Name of the master benchmark
		do
			Result := master_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	portfolios_by_benchmark_history: ROSE_ENTITY_HISTORY[GCDB_PORTFOLIO] is
			-- history of benchmark to portfolio by benchmark
		do
			Result := context.portfolio_to_benchmark.corelated_entity_intervals (upcast)
		end

	portfolios_by_benchmark: ROSE_LINEAR_ARRAY[GCDB_PORTFOLIO] is
			-- benchmark to portfolio by benchmark (141)
		do
			Result := portfolios_by_benchmark_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	accounts_by_benchmark_history: ROSE_ENTITY_HISTORY[GCDB_ACCOUNT] is
			-- history of benchmark to account by benchmark
		do
			Result := context.account_to_benchmark.corelated_entity_intervals (upcast)
		end

	accounts_by_benchmark: ROSE_LINEAR_ARRAY[GCDB_ACCOUNT] is
			-- benchmark to account by benchmark (187)
		do
			Result := accounts_by_benchmark_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	benchmarks_by_master_history: ROSE_ENTITY_HISTORY[GCDB_BENCHMARK] is
			-- history of benchmark to benchmark by master
		do
			Result := context.benchmark_to_master_benchmark.related_entity_intervals (upcast)
		end

	benchmarks_by_master: ROSE_LINEAR_ARRAY[GCDB_BENCHMARK] is
			-- benchmark to benchmark by master (354)
		do
			Result := benchmarks_by_master_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	-- relationship -- benchmarks_by_legacy_replacement -> 48 GCDB_BENCHMARK -- 0 benchmark to benchmark by legacy_replacement

	-- relationship -- benchmark_constituents_by_benchmark -> 254 GCDB_BENCHMARK_CONSTITUENT -- 0 benchmark to benchmark_constituent by benchmark

	-- relationship -- benchmark_constituents_by_composing_benchmark -> 254 GCDB_BENCHMARK_CONSTITUENT -- 0 benchmark to benchmark_constituent by composing_benchmark

	-- relationship -- product_benchmarks_by_benchmark -> 289 GCDB_PRODUCT_BENCHMARK -- 0 benchmark to product_benchmark by benchmark

	-- relationship -- portfolio_group_benchmarks_by_benchmark -> 415 GCDB_PORTFOLIO_GROUP_BENCHMARK -- 0 benchmark to portfolio_group_benchmark by benchmark

	fund_participants_by_benchmark_history: ROSE_ENTITY_HISTORY[GCDB_FUND_PARTICIPANT] is
			-- history of benchmark to fund_participant by benchmark
		do
			Result := context.fund_participant_to_benchmark.corelated_entity_intervals (upcast)
		end

	fund_participants_by_benchmark: ROSE_LINEAR_ARRAY[GCDB_FUND_PARTICIPANT] is
			-- benchmark to fund_participant by benchmark (360)
		do
			Result := fund_participants_by_benchmark_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	-- relationship -- portfolio_reporting_benchmarks_by_benchmark -> 478 GCDB_PORTFOLIO_REPORTING_BENCHMARK -- 0 benchmark to portfolio_reporting_benchmark by benchmark

	-- relationship -- account_reporting_benchmarks_by_benchmark -> 482 GCDB_ACCOUNT_REPORTING_BENCHMARK -- 0 benchmark to account_reporting_benchmark by benchmark

	-- relationship -- portfolio_group_reporting_benchmarks_by_benchmark -> 486 GCDB_PORTFOLIO_GROUP_REPORTING_BENCHMARK -- 0 benchmark to portfolio_group_reporting_benchmark by benchmark

	-- relationship -- benchmark_return_definitions_by_benchmark -> 537 GCDB_BENCHMARK_RETURN_DEFINITION -- 0 benchmark to benchmark_return_definition by benchmark

	-- relationship -- product_reporting_benchmarks_by_reporting_benchmark -> 592 GCDB_PRODUCT_REPORTING_BENCHMARK -- 0 benchmark to product_reporting_benchmark by reporting_benchmark

	products_by_benchmark_history: ROSE_ENTITY_HISTORY[GCDB_PRODUCT] is
			-- history of benchmark to product by benchmark
		do
			Result := context.benchmark_to_composite.related_entity_intervals (upcast)
		end

	products_by_benchmark: ROSE_LINEAR_ARRAY[GCDB_PRODUCT] is
			-- benchmark to product by benchmark (136)
		do
			Result := products_by_benchmark_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	portfolio_groups_by_benchmark_history: ROSE_ENTITY_HISTORY[GCDB_PORTFOLIO_GROUP] is
			-- history of benchmark to portfolio_group by benchmark
		do
			Result := context.portfolio_group_to_benchmark.corelated_entity_intervals (upcast)
		end

	portfolio_groups_by_benchmark: ROSE_LINEAR_ARRAY[GCDB_PORTFOLIO_GROUP] is
			-- benchmark to portfolio_group by benchmark (190)
		do
			Result := portfolio_groups_by_benchmark_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	name_at (a_date: ROSE_DATE): STRING is
			-- name_at queries the unique code attribute
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

end -- GCDB_BENCHMARK
