note

	description:

		"Automagically Generated -- Empty Description in GCDB"

	keywords: "entity, gcdb, broker"
	author: "$Author: mk $"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #20 $"
	path: "$File: //rose/source/kernel/gcdb/generated/gcdb_broker_base.e $"

deferred class
	GCDB_BROKER_BASE

inherit
	PERSISTENT_BROKER
		export
			{GCDB_BROKER_BASE,GCDB_HOME} all
		undefine
			make,
			context
		redefine
			name_at
		end
	GCDB_ENTITY
		export
			{GCDB_BROKER_BASE,GCDB_HOME} all
			{ANY} handle, is_equal, hash_code,
					entity_at, start_date, end_date,
					as_of_date, set_as_of_date
		undefine
			is_equal
		redefine
			name_at
		end

feature {NONE} -- Implementation

	upcast: like context.broker_template is
			-- convert to base
		do
			Result ?= Current
		end

feature -- GCDB Attributes and Relationships

	code: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

	bic: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10248, as_of_date)
		end

	name: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (46, as_of_date)
		end

	contact: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10250, as_of_date)
		end

	phone: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10251, as_of_date)
		end

	fax: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10252, as_of_date)
		end

	branch: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10267, as_of_date)
		end

	no_internal_confirms: BOOLEAN is
			-- If checked indicates that this broker doesn't want to receive MT300 for non-3rd part FXs
		do
			Result := boolean_attribute_value (10384, as_of_date)
		end

	aka_code: STRING is
			-- broker code aliases used by GTA
		do
			Result := attribute_from_supplier_attribute_id_at (432, as_of_date)
		end

	-- attribute -- local_code: STRING -- 565 Local market broker identifier.

	-- attribute -- local_name: STRING -- 566 Local market broker name.

	is_cls_participant: BOOLEAN is
			-- True if broker uses CLS for FX settlement.
		do
			Result := boolean_attribute_value (585, as_of_date)
		end

	restricted_cls_currencies_history: ROSE_ENTITY_HISTORY[GCDB_CURRENCY] is
			-- history of List of currencies not supported by the broker for FX settlement thru CLS.
		do
			Result := context.broker_to_restricted_cls_currency.related_entity_intervals (upcast)
		end

	restricted_cls_currencies: ROSE_LINEAR_ARRAY[GCDB_CURRENCY] is
			-- List of currencies not supported by the broker for FX settlement thru CLS. (325)
		do
			Result := restricted_cls_currencies_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	settlement_chains_by_broker_history: ROSE_ENTITY_HISTORY[GCDB_SETTLEMENT_CHAIN] is
			-- history of broker to settlement_chain by broker
		do
			Result := context.settlement_chain_to_broker.corelated_entity_intervals (upcast)
		end

	settlement_chains_by_broker: ROSE_LINEAR_ARRAY[GCDB_SETTLEMENT_CHAIN] is
			-- broker to settlement_chain by broker (150)
		do
			Result := settlement_chains_by_broker_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	-- relationship -- banks_by_fx_broker -> 274 GCDB_BANK -- 0 broker to bank by fx_broker

	name_at (a_date: ROSE_DATE): STRING is
			-- name_at queries the unique code attribute
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

end -- GCDB_BROKER
