note

	description:

		"Automagically Generated -- Empty Description in GCDB"

	keywords: "entity, gcdb, client"
	author: "$Author: mk $"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #19 $"
	path: "$File: //rose/source/kernel/gcdb/generated/gcdb_client_base.e $"

deferred class
	GCDB_CLIENT_BASE

inherit
	PERSISTENT_CLIENT
		export
			{GCDB_CLIENT_BASE,GCDB_HOME} all
		undefine
			make,
			context
		redefine
			name_at
		end
	GCDB_ENTITY
		export
			{GCDB_CLIENT_BASE,GCDB_HOME} all
			{ANY} handle, is_equal, hash_code,
					entity_at, start_date, end_date,
					as_of_date, set_as_of_date
		undefine
			is_equal
		redefine
			name_at
		end

feature {NONE} -- Implementation

	upcast: like context.client_template is
			-- convert to base
		do
			Result ?= Current
		end

feature -- GCDB Attributes and Relationships

	code: STRING is
			-- Short name for client
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

	name: STRING is
			-- Full name used in reporting
		do
			Result := attribute_from_supplier_attribute_id_at (46, as_of_date)
		end

	domicile_country_history: ROSE_ENTITY_HISTORY[GCDB_COUNTRY] is
			-- history of The domicile country of the client
		do
			Result := context.client_to_domicile_country.related_entity_intervals (upcast)
		end

	domicile_country: GCDB_COUNTRY is
			-- The domicile country of the client
		do
			Result := domicile_country_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	domicile_region_history: ROSE_ENTITY_HISTORY[GCDB_COUNTRY_GROUP] is
			-- history of The domicile region of the client
		do
			Result := context.client_to_domicile_region.related_entity_intervals (upcast)
		end

	domicile_region: GCDB_COUNTRY_GROUP is
			-- The domicile region of the client
		do
			Result := domicile_region_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	local_name: STRING is
			-- Name written in local alphabet
		do
			Result := attribute_from_supplier_attribute_id_at (459, as_of_date)
		end

	-- relationship -- domicile -> 524 GCDB_DOMICILE -- 702 The domicile country of the client. Replaces the old style two column setup.

	accounts_by_client_history: ROSE_ENTITY_HISTORY[GCDB_ACCOUNT] is
			-- history of client to account by client
		do
			Result := context.account_to_client.corelated_entity_intervals (upcast)
		end

	accounts_by_client: ROSE_LINEAR_ARRAY[GCDB_ACCOUNT] is
			-- client to account by client (131)
		do
			Result := accounts_by_client_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	fund_participants_by_client_history: ROSE_ENTITY_HISTORY[GCDB_FUND_PARTICIPANT] is
			-- history of client to fund_participant by client
		do
			Result := context.fund_participant_to_client.corelated_entity_intervals (upcast)
		end

	fund_participants_by_client: ROSE_LINEAR_ARRAY[GCDB_FUND_PARTICIPANT] is
			-- client to fund_participant by client (353)
		do
			Result := fund_participants_by_client_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	name_at (a_date: ROSE_DATE): STRING is
			-- name_at queries the unique code attribute
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

end -- GCDB_CLIENT
