note

	description:

		"Automagically Generated -- Empty Description in GCDB"

	keywords: "entity, gcdb, country"
	author: "$Author: mk $"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #20 $"
	path: "$File: //rose/source/kernel/gcdb/generated/gcdb_country_base.e $"

deferred class
	GCDB_COUNTRY_BASE

inherit
	PERSISTENT_COUNTRY
		export
			{GCDB_COUNTRY_BASE,GCDB_HOME} all
		undefine
			make,
			context,
			name_at
		end
	GCDB_ENTITY
		export
			{GCDB_COUNTRY_BASE,GCDB_HOME} all
			{ANY} handle, is_equal, hash_code,
					entity_at, start_date, end_date,
					as_of_date, set_as_of_date
		undefine
			is_equal
		redefine
			name_at
		end

feature {NONE} -- Implementation

	upcast: like context.country_template is
			-- convert to base
		do
			Result ?= Current
		end

feature -- GCDB Attributes and Relationships

	code: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

	name: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (46, as_of_date)
		end

	alpha3: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10245, as_of_date)
		end

	numerical_code: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10246, as_of_date)
		end

	investment_region_history: ROSE_ENTITY_HISTORY[GCDB_INVESTMENT_REGION] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.country_to_investment_region.related_entity_intervals (upcast)
		end

	investment_region: GCDB_INVESTMENT_REGION is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := investment_region_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	legacy_index: STRING is
			-- The country's legacy IndeX
		do
			Result := attribute_from_supplier_attribute_id_at (533, as_of_date)
		end

	accounts_by_domicile_country_history: ROSE_ENTITY_HISTORY[GCDB_ACCOUNT] is
			-- history of country to account by domicile_country
		do
			Result := context.account_to_domicile_country.corelated_entity_intervals (upcast)
		end

	accounts_by_domicile_country: ROSE_LINEAR_ARRAY[GCDB_ACCOUNT] is
			-- country to account by domicile_country (184)
		do
			Result := accounts_by_domicile_country_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	clients_by_domicile_country_history: ROSE_ENTITY_HISTORY[GCDB_CLIENT] is
			-- history of country to client by domicile_country
		do
			Result := context.client_to_domicile_country.corelated_entity_intervals (upcast)
		end

	clients_by_domicile_country: ROSE_LINEAR_ARRAY[GCDB_CLIENT] is
			-- country to client by domicile_country (188)
		do
			Result := clients_by_domicile_country_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	currency_history: ROSE_ENTITY_HISTORY[GCDB_CURRENCY] is
			-- history of country to currency by country
		do
			Result := context.country_to_alternate_currency.related_entity_intervals (upcast)
		end

	currency: GCDB_CURRENCY is
			-- country to currency by country
		do
			Result := currency_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	psets_by_country_history: ROSE_ENTITY_HISTORY[GCDB_PSET] is
			-- history of country to pset by country
		do
			Result := context.pset_to_country.corelated_entity_intervals (upcast)
		end

	psets_by_country: ROSE_LINEAR_ARRAY[GCDB_PSET] is
			-- country to pset by country (149)
		do
			Result := psets_by_country_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	taxes_by_country_history: ROSE_ENTITY_HISTORY[GCDB_TAX] is
			-- history of country to tax by country
		do
			Result := context.tax_to_country.corelated_entity_intervals (upcast)
		end

	taxes_by_country: ROSE_LINEAR_ARRAY[GCDB_TAX] is
			-- country to tax by country (269)
		do
			Result := taxes_by_country_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	country_group_history: ROSE_ENTITY_HISTORY[GCDB_COUNTRY_GROUP] is
			-- history of country to country_group by country
		do
			Result := context.country_group_to_country.corelated_entity_intervals (upcast)
		end

	country_group: GCDB_COUNTRY_GROUP is
			-- country to country_group by country
		do
			Result := country_group_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	bank_accounts_by_country_history: ROSE_ENTITY_HISTORY[GCDB_BANK_ACCOUNT] is
			-- history of country to bank_account by country
		do
			Result := context.bank_account_to_country.corelated_entity_intervals (upcast)
		end

	bank_accounts_by_country: ROSE_LINEAR_ARRAY[GCDB_BANK_ACCOUNT] is
			-- country to bank_account by country (191)
		do
			Result := bank_accounts_by_country_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	country_taxes_by_country_history: ROSE_ENTITY_HISTORY[GCDB_COUNTRY_TAX] is
			-- history of country to country_tax by country
		do
			Result := context.country_tax_to_country.corelated_entity_intervals (upcast)
		end

	country_taxes_by_country: ROSE_LINEAR_ARRAY[GCDB_COUNTRY_TAX] is
			-- country to country_tax by country (265)
		do
			Result := country_taxes_by_country_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	investment_taxes_by_investment_country_history: ROSE_ENTITY_HISTORY[GCDB_INVESTMENT_TAX] is
			-- history of country to investment_tax by investment_country
		do
			Result := context.investment_tax_to_investment_country.corelated_entity_intervals (upcast)
		end

	investment_taxes_by_investment_country: ROSE_LINEAR_ARRAY[GCDB_INVESTMENT_TAX] is
			-- country to investment_tax by investment_country (264)
		do
			Result := investment_taxes_by_investment_country_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	investment_taxes_by_domicile_country_history: ROSE_ENTITY_HISTORY[GCDB_INVESTMENT_TAX] is
			-- history of country to investment_tax by domicile_country
		do
			Result := context.investment_tax_to_domicile_country.corelated_entity_intervals (upcast)
		end

	investment_taxes_by_domicile_country: ROSE_LINEAR_ARRAY[GCDB_INVESTMENT_TAX] is
			-- country to investment_tax by domicile_country (263)
		do
			Result := investment_taxes_by_domicile_country_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	-- relationship -- domiciles_by_country -> 524 GCDB_DOMICILE -- 0 country to domicile by country

	name_at (a_date: ROSE_DATE): STRING is
			-- name_at queries the unique code attribute
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

end -- GCDB_COUNTRY
