note

	description:

		"Automagically Generated -- Empty Description in GCDB"

	keywords: "entity, gcdb, currency"
	author: "$Author: mk $"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #23 $"
	path: "$File: //rose/source/kernel/gcdb/generated/gcdb_currency_base.e $"

deferred class
	GCDB_CURRENCY_BASE

inherit
	PERSISTENT_CURRENCY
		export
			{GCDB_CURRENCY_BASE,GCDB_HOME} all
		undefine
			make,
			context,
			name_at
		end
	GCDB_ENTITY
		export
			{GCDB_CURRENCY_BASE,GCDB_HOME} all
			{ANY} handle, is_equal, hash_code,
					entity_at, start_date, end_date,
					as_of_date, set_as_of_date
		undefine
			is_equal
		redefine
			name_at
		end

feature {NONE} -- Implementation

	upcast: like context.currency_template is
			-- convert to base
		do
			Result ?= Current
		end

feature -- GCDB Attributes and Relationships

	code: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

	name: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (46, as_of_date)
		end

	is_obsolete: BOOLEAN is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := boolean_attribute_value (10214, as_of_date)
		end

	minor_unit: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10215, as_of_date)
		end

	iso_id: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10216, as_of_date)
		end

	countries_history: ROSE_ENTITY_HISTORY[GCDB_COUNTRY] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.country_to_alternate_currency.corelated_entity_intervals (upcast)
		end

	countries: ROSE_LINEAR_ARRAY[GCDB_COUNTRY] is
			-- GCDB doesn't have description for this attribute/relationship (124)
		do
			Result := countries_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	is_swift_restricted: BOOLEAN is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := boolean_attribute_value (10218, as_of_date)
		end

	is_for_trading_only: BOOLEAN is
			-- Indicates that this currency code is used for specific trading purposes.
		do
			Result := boolean_attribute_value (504, as_of_date)
		end

	is_cls_eligible: BOOLEAN is
			-- True for currencies that can be settled thru CLS (Continous Linked Settlement). CLS is a mean of settling foreign exchange transactions.
		do
			Result := boolean_attribute_value (584, as_of_date)
		end

	portfolios_by_restrict_fx_mt304_history: ROSE_ENTITY_HISTORY[GCDB_PORTFOLIO] is
			-- history of currency to portfolio by restrict_fx_mt304
		do
			Result := context.portfolio_to_mt304_fx_restricted_currency.corelated_entity_intervals (upcast)
		end

	portfolios_by_restrict_fx_mt304: ROSE_LINEAR_ARRAY[GCDB_PORTFOLIO] is
			-- currency to portfolio by restrict_fx_mt304 (324)
		do
			Result := portfolios_by_restrict_fx_mt304_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	portfolios_by_restrict_fx_mt300_history: ROSE_ENTITY_HISTORY[GCDB_PORTFOLIO] is
			-- history of currency to portfolio by restrict_fx_mt300
		do
			Result := context.portfolio_to_mt300_fx_restricted_currency.corelated_entity_intervals (upcast)
		end

	portfolios_by_restrict_fx_mt300: ROSE_LINEAR_ARRAY[GCDB_PORTFOLIO] is
			-- currency to portfolio by restrict_fx_mt300 (294)
		do
			Result := portfolios_by_restrict_fx_mt300_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	accounts_by_fx_base_currency_history: ROSE_ENTITY_HISTORY[GCDB_ACCOUNT] is
			-- history of currency to account by fx_base_currency
		do
			Result := context.account_to_fx_base_currency.corelated_entity_intervals (upcast)
		end

	accounts_by_fx_base_currency: ROSE_LINEAR_ARRAY[GCDB_ACCOUNT] is
			-- currency to account by fx_base_currency (320)
		do
			Result := accounts_by_fx_base_currency_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	accounts_by_base_currency_history: ROSE_ENTITY_HISTORY[GCDB_ACCOUNT] is
			-- history of currency to account by base_currency
		do
			Result := context.account_to_base_currency.corelated_entity_intervals (upcast)
		end

	accounts_by_base_currency: ROSE_LINEAR_ARRAY[GCDB_ACCOUNT] is
			-- currency to account by base_currency (213)
		do
			Result := accounts_by_base_currency_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	account_by_report_currency_history: ROSE_ENTITY_HISTORY[GCDB_ACCOUNT] is
			-- history of currency to account by report_currency
		do
			Result := context.account_to_reporting_currency.corelated_entity_intervals (upcast)
		end

	account_by_report_currency: GCDB_ACCOUNT is
			-- currency to account by report_currency
		do
			Result := account_by_report_currency_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	benchmarks_by_currency_history: ROSE_ENTITY_HISTORY[GCDB_BENCHMARK] is
			-- history of currency to benchmark by currency
		do
			Result := context.benchmark_to_currency.corelated_entity_intervals (upcast)
		end

	benchmarks_by_currency: ROSE_LINEAR_ARRAY[GCDB_BENCHMARK] is
			-- currency to benchmark by currency (361)
		do
			Result := benchmarks_by_currency_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	products_by_audit_currency_history: ROSE_ENTITY_HISTORY[GCDB_PRODUCT] is
			-- history of currency to product by audit_currency
		do
			Result := context.composite_to_audit_currency.corelated_entity_intervals (upcast)
		end

	products_by_audit_currency: ROSE_LINEAR_ARRAY[GCDB_PRODUCT] is
			-- currency to product by audit_currency (322)
		do
			Result := products_by_audit_currency_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	broker_by_restricted_cls_currency_history: ROSE_ENTITY_HISTORY[GCDB_BROKER] is
			-- history of currency to broker by restricted_cls_currency
		do
			Result := context.broker_to_restricted_cls_currency.corelated_entity_intervals (upcast)
		end

	broker_by_restricted_cls_currency: GCDB_BROKER is
			-- currency to broker by restricted_cls_currency
		do
			Result := broker_by_restricted_cls_currency_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	portfolio_groups_by_report_currency_history: ROSE_ENTITY_HISTORY[GCDB_PORTFOLIO_GROUP] is
			-- history of currency to portfolio_group by report_currency
		do
			Result := context.portfolio_group_to_reporting_currency.corelated_entity_intervals (upcast)
		end

	portfolio_groups_by_report_currency: ROSE_LINEAR_ARRAY[GCDB_PORTFOLIO_GROUP] is
			-- currency to portfolio_group by report_currency (319)
		do
			Result := portfolio_groups_by_report_currency_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	bank_by_restricted_cls_currency_history: ROSE_ENTITY_HISTORY[GCDB_BANK] is
			-- history of currency to bank by restricted_cls_currency
		do
			Result := context.custodian_to_restricted_cls_currency.corelated_entity_intervals (upcast)
		end

	bank_by_restricted_cls_currency: GCDB_BANK is
			-- currency to bank by restricted_cls_currency
		do
			Result := bank_by_restricted_cls_currency_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	bank_accounts_by_currency_history: ROSE_ENTITY_HISTORY[GCDB_BANK_ACCOUNT] is
			-- history of currency to bank_account by currency
		do
			Result := context.bank_account_to_currency.corelated_entity_intervals (upcast)
		end

	bank_accounts_by_currency: ROSE_LINEAR_ARRAY[GCDB_BANK_ACCOUNT] is
			-- currency to bank_account by currency (192)
		do
			Result := bank_accounts_by_currency_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	-- relationship -- explicit_fx_with_11as_by_to_currency -> 493 GCDB_EXPLICIT_FX_WITH_11A -- 0 currency to explicit_fx_with_11a by to_currency

	-- relationship -- explicit_fx_with_11as_by_currency -> 493 GCDB_EXPLICIT_FX_WITH_11A -- 0 currency to explicit_fx_with_11a by currency

	-- relationship -- benchmark_return_definitions_by_currency -> 537 GCDB_BENCHMARK_RETURN_DEFINITION -- 0 currency to benchmark_return_definition by currency

	name_at (a_date: ROSE_DATE): STRING is
			-- name_at queries the unique code attribute
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

end -- GCDB_CURRENCY
