note

	description:

		"Automagically Generated -- Fund particiapation for each client. This is simplified form of full blown account."

	keywords: "entity, gcdb, fund_participant"
	author: "$Author: mk $"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #5 $"
	path: "$File: //rose/source/kernel/gcdb/generated/gcdb_fund_participant_base.e $"

deferred class
	GCDB_FUND_PARTICIPANT_BASE

inherit
	PERSISTENT_FUND_PARTICIPANT
		export
			{GCDB_FUND_PARTICIPANT_BASE,GCDB_HOME} all
		undefine
			make,
			context
		end
	GCDB_ENTITY
		export
			{GCDB_FUND_PARTICIPANT_BASE,GCDB_HOME} all
			{ANY} handle, is_equal, hash_code, 
					entity_at, start_date, end_date, 
					as_of_date, set_as_of_date
		undefine
			is_equal
		end

feature {NONE} -- Implementation

	upcast: like context.fund_participant_template is
			-- convert to base
		do
			Result ?= Current
		end

feature -- GCDB Attributes and Relationships

	code: STRING is
			-- Unique identifier for a client's particiaption in a fund.
		do
			Result := attribute_from_supplier_attribute_id_at (447, as_of_date)
		end

	name: STRING is
			-- Full name participation name - to be used in all account reports
		do
			Result := attribute_from_supplier_attribute_id_at (448, as_of_date)
		end

	brimsym: STRING is
			-- Brimsym that is used for NAV and performance for this fund participant
		do
			Result := attribute_from_supplier_attribute_id_at (449, as_of_date)
		end

	client_history: ROSE_ENTITY_HISTORY[GCDB_CLIENT] is
			-- history of Client that participates in the fund
		do
			Result := context.fund_participant_to_client.related_entity_intervals (upcast)
		end

	client: GCDB_CLIENT is
			-- Client that participates in the fund
		do
			Result := client_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	client_services_operator: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (469, as_of_date)
		end

	is_confidential: EGCDB_TRISTATE is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := tristate_attribute_value (470, as_of_date)
		end

	-- attribute -- has_mfn_clause: EGCDB_TRISTATE -- 701 Indicates that account has MFN clause

	participation_level: STRING is
			-- Fund participation level, i.e. units or percentage
		do
			Result := attribute_from_supplier_attribute_id_at (723, as_of_date)
		end

	benchmark_history: ROSE_ENTITY_HISTORY[GCDB_BENCHMARK] is
			-- history of Custon benchmark assignment if different from parent fund
		do
			Result := context.fund_participant_to_benchmark.related_entity_intervals (upcast)
		end

	benchmark: GCDB_BENCHMARK is
			-- Custon benchmark assignment if different from parent fund
		do
			Result := benchmark_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	open_date: ROSE_DATE is
			-- Opening date for fund participant
		do
			Result := date_attribute_value (731, as_of_date)
		end

	close_date: ROSE_DATE is
			-- Closing date for fund participant
		do
			Result := date_attribute_value (732, as_of_date)
		end

	-- attribute -- account_number: STRING -- 733 Account identifier used by the fund administrator

end -- GCDB_FUND_PARTICIPANT