indexing
	description: "Accessor For GCDB Classes -- Automagically Generated"
	author: "$Author: it $"
	keywords: "entity, gcdb"
	date: "$Date: 2009/07/29 $"
	revision: "$Revision: #25 $"

class
	GCDB_HOME

inherit
	GCDB_AWARE
		export
			{NONE} all
			{ANY} context
		end
	GCDB_SHARED_HOME

create

	make

feature {NONE} -- Initialization

	make is
			-- Create a singleton object.
		require
			singleton_not_created: not singleton_created
		do
			singleton_cell.put (Current)
		end

feature -- Factory methods

	portfolio_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_PORTFOLIO is
			--|
		do
			Result := context.portfolio_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (96))
			set_entity_as_of_date (Result, a_date)
		end

	portfolio_by_entity_id (a_entity_id: INTEGER): GCDB_PORTFOLIO is
			--|
		do
			Result := context.portfolio_accessor.entity (a_entity_id)
		end

	portfolios_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_PORTFOLIO] is
			--|
		do
			create Result.make_from_linear (context.portfolio_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	account_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_ACCOUNT is
			--|
		do
			Result := context.account_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (96))
			set_entity_as_of_date (Result, a_date)
		end

	account_by_entity_id (a_entity_id: INTEGER): GCDB_ACCOUNT is
			--|
		do
			Result := context.account_accessor.entity (a_entity_id)
		end

	accounts_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_ACCOUNT] is
			--|
		do
			create Result.make_from_linear (context.account_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	client_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_CLIENT is
			--|
		do
			Result := context.client_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (96))
			set_entity_as_of_date (Result, a_date)
		end

	client_by_entity_id (a_entity_id: INTEGER): GCDB_CLIENT is
			--|
		do
			Result := context.client_accessor.entity (a_entity_id)
		end

	clients_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_CLIENT] is
			--|
		do
			create Result.make_from_linear (context.client_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	benchmark_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_BENCHMARK is
			--|
		do
			Result := context.benchmark_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (96))
			set_entity_as_of_date (Result, a_date)
		end

	benchmark_by_entity_id (a_entity_id: INTEGER): GCDB_BENCHMARK is
			--|
		do
			Result := context.benchmark_accessor.entity (a_entity_id)
		end

	benchmarks_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_BENCHMARK] is
			--|
		do
			create Result.make_from_linear (context.benchmark_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	imc_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_IMC is
			--|
		do
			Result := context.imc_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (96))
			set_entity_as_of_date (Result, a_date)
		end

	imc_by_entity_id (a_entity_id: INTEGER): GCDB_IMC is
			--|
		do
			Result := context.imc_accessor.entity (a_entity_id)
		end

	imcs_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_IMC] is
			--|
		do
			create Result.make_from_linear (context.imc_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	product_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_PRODUCT is
			--|
		do
			Result := context.composite_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (96))
			set_entity_as_of_date (Result, a_date)
		end

	product_by_entity_id (a_entity_id: INTEGER): GCDB_PRODUCT is
			--|
		do
			Result := context.composite_accessor.entity (a_entity_id)
		end

	products_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_PRODUCT] is
			--|
		do
			create Result.make_from_linear (context.composite_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	broker_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_BROKER is
			--|
		do
			Result := context.broker_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (96))
			set_entity_as_of_date (Result, a_date)
		end

	broker_by_entity_id (a_entity_id: INTEGER): GCDB_BROKER is
			--|
		do
			Result := context.broker_accessor.entity (a_entity_id)
		end

	brokers_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_BROKER] is
			--|
		do
			create Result.make_from_linear (context.broker_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	country_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_COUNTRY is
			--|
		do
			Result := context.country_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (96))
			set_entity_as_of_date (Result, a_date)
		end

	country_by_entity_id (a_entity_id: INTEGER): GCDB_COUNTRY is
			--|
		do
			Result := context.country_accessor.entity (a_entity_id)
		end

	countries_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_COUNTRY] is
			--|
		do
			create Result.make_from_linear (context.country_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	instrument_type_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_INSTRUMENT_TYPE is
			--|
		do
			Result := context.security_type_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (96))
			set_entity_as_of_date (Result, a_date)
		end

	instrument_type_by_entity_id (a_entity_id: INTEGER): GCDB_INSTRUMENT_TYPE is
			--|
		do
			Result := context.security_type_accessor.entity (a_entity_id)
		end

	instrument_types_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_INSTRUMENT_TYPE] is
			--|
		do
			create Result.make_from_linear (context.security_type_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	currency_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_CURRENCY is
			--|
		do
			Result := context.currency_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (96))
			set_entity_as_of_date (Result, a_date)
		end

	currency_by_entity_id (a_entity_id: INTEGER): GCDB_CURRENCY is
			--|
		do
			Result := context.currency_accessor.entity (a_entity_id)
		end

	currencies_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_CURRENCY] is
			--|
		do
			create Result.make_from_linear (context.currency_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	pset_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_PSET is
			--|
		do
			Result := context.pset_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (96))
			set_entity_as_of_date (Result, a_date)
		end

	pset_by_entity_id (a_entity_id: INTEGER): GCDB_PSET is
			--|
		do
			Result := context.pset_accessor.entity (a_entity_id)
		end

	psets_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_PSET] is
			--|
		do
			create Result.make_from_linear (context.pset_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	portfolio_group_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_PORTFOLIO_GROUP is
			--|
		do
			Result := context.portfolio_group_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (96))
			set_entity_as_of_date (Result, a_date)
		end

	portfolio_group_by_entity_id (a_entity_id: INTEGER): GCDB_PORTFOLIO_GROUP is
			--|
		do
			Result := context.portfolio_group_accessor.entity (a_entity_id)
		end

	portfolio_groups_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_PORTFOLIO_GROUP] is
			--|
		do
			create Result.make_from_linear (context.portfolio_group_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	country_group_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_COUNTRY_GROUP is
			--|
		do
			Result := context.country_group_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (96))
			set_entity_as_of_date (Result, a_date)
		end

	country_group_by_entity_id (a_entity_id: INTEGER): GCDB_COUNTRY_GROUP is
			--|
		do
			Result := context.country_group_accessor.entity (a_entity_id)
		end

	country_groups_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_COUNTRY_GROUP] is
			--|
		do
			create Result.make_from_linear (context.country_group_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	bank_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_BANK is
			--|
		do
			Result := context.bank_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (96))
			set_entity_as_of_date (Result, a_date)
		end

	bank_by_entity_id (a_entity_id: INTEGER): GCDB_BANK is
			--|
		do
			Result := context.bank_accessor.entity (a_entity_id)
		end

	banks_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_BANK] is
			--|
		do
			create Result.make_from_linear (context.bank_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	client_type_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_CLIENT_TYPE is
			--|
		do
			Result := context.client_type_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (96))
			set_entity_as_of_date (Result, a_date)
		end

	client_type_by_entity_id (a_entity_id: INTEGER): GCDB_CLIENT_TYPE is
			--|
		do
			Result := context.client_type_accessor.entity (a_entity_id)
		end

	client_types_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_CLIENT_TYPE] is
			--|
		do
			create Result.make_from_linear (context.client_type_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	investment_region_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_INVESTMENT_REGION is
			--|
		do
			Result := context.investment_region_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (96))
			set_entity_as_of_date (Result, a_date)
		end

	investment_region_by_entity_id (a_entity_id: INTEGER): GCDB_INVESTMENT_REGION is
			--|
		do
			Result := context.investment_region_accessor.entity (a_entity_id)
		end

	investment_regions_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_INVESTMENT_REGION] is
			--|
		do
			create Result.make_from_linear (context.investment_region_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	strategy_type_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_STRATEGY_TYPE is
			--|
		do
			Result := context.strategy_type_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (247))
			set_entity_as_of_date (Result, a_date)
		end

	strategy_type_by_entity_id (a_entity_id: INTEGER): GCDB_STRATEGY_TYPE is
			--|
		do
			Result := context.strategy_type_accessor.entity (a_entity_id)
		end

	strategy_types_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_STRATEGY_TYPE] is
			--|
		do
			create Result.make_from_linear (context.strategy_type_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	tax_type_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_TAX_TYPE is
			--|
		do
			Result := context.tax_type_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (10444))
			set_entity_as_of_date (Result, a_date)
		end

	tax_type_by_entity_id (a_entity_id: INTEGER): GCDB_TAX_TYPE is
			--|
		do
			Result := context.tax_type_accessor.entity (a_entity_id)
		end

	tax_types_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_TAX_TYPE] is
			--|
		do
			create Result.make_from_linear (context.tax_type_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	fund_participant_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_FUND_PARTICIPANT is
			--|
		do
			Result := context.fund_participant_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (447))
			set_entity_as_of_date (Result, a_date)
		end

	fund_participant_by_entity_id (a_entity_id: INTEGER): GCDB_FUND_PARTICIPANT is
			--|
		do
			Result := context.fund_participant_accessor.entity (a_entity_id)
		end

	fund_participants_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_FUND_PARTICIPANT] is
			--|
		do
			create Result.make_from_linear (context.fund_participant_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	distributor_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_DISTRIBUTOR is
			--|
		do
			Result := context.distributor_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (10465))
			set_entity_as_of_date (Result, a_date)
		end

	distributor_by_entity_id (a_entity_id: INTEGER): GCDB_DISTRIBUTOR is
			--|
		do
			Result := context.distributor_accessor.entity (a_entity_id)
		end

	distributors_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_DISTRIBUTOR] is
			--|
		do
			create Result.make_from_linear (context.distributor_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	selection_universe_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_SELECTION_UNIVERSE is
			--|
		do
			Result := context.universe_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (472))
			set_entity_as_of_date (Result, a_date)
		end

	selection_universe_by_entity_id (a_entity_id: INTEGER): GCDB_SELECTION_UNIVERSE is
			--|
		do
			Result := context.universe_accessor.entity (a_entity_id)
		end

	selection_universes_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_SELECTION_UNIVERSE] is
			--|
		do
			create Result.make_from_linear (context.universe_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	reporting_attribution_model_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_REPORTING_ATTRIBUTION_MODEL is
			--|
		do
			Result := context.reporting_attribution_model_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (10568))
			set_entity_as_of_date (Result, a_date)
		end

	reporting_attribution_model_by_entity_id (a_entity_id: INTEGER): GCDB_REPORTING_ATTRIBUTION_MODEL is
			--|
		do
			Result := context.reporting_attribution_model_accessor.entity (a_entity_id)
		end

	reporting_attribution_models_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_REPORTING_ATTRIBUTION_MODEL] is
			--|
		do
			create Result.make_from_linear (context.reporting_attribution_model_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	swift_option_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_SWIFT_OPTION is
			--|
		do
			Result := context.swift_option_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (10642))
			set_entity_as_of_date (Result, a_date)
		end

	swift_option_by_entity_id (a_entity_id: INTEGER): GCDB_SWIFT_OPTION is
			--|
		do
			Result := context.swift_option_accessor.entity (a_entity_id)
		end

	swift_options_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_SWIFT_OPTION] is
			--|
		do
			create Result.make_from_linear (context.swift_option_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	dividend_reinvestment_model_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_DIVIDEND_REINVESTMENT_MODEL is
			--|
		do
			Result := context.dividend_reinvestment_model_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (10653))
			set_entity_as_of_date (Result, a_date)
		end

	dividend_reinvestment_model_by_entity_id (a_entity_id: INTEGER): GCDB_DIVIDEND_REINVESTMENT_MODEL is
			--|
		do
			Result := context.dividend_reinvestment_model_accessor.entity (a_entity_id)
		end

	dividend_reinvestment_models_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_DIVIDEND_REINVESTMENT_MODEL] is
			--|
		do
			create Result.make_from_linear (context.dividend_reinvestment_model_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	property_by_property_id (a_property_id: STRING; a_date: ROSE_DATE): GCDB_PROPERTY is
			--|
		do
			Result := context.property_accessor.entity_from_identifier (a_property_id,
																			a_date,
																			context.identifier (10668))
			set_entity_as_of_date (Result, a_date)
		end

	property_by_entity_id (a_entity_id: INTEGER): GCDB_PROPERTY is
			--|
		do
			Result := context.property_accessor.entity (a_entity_id)
		end

	properties_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_PROPERTY] is
			--|
		do
			create Result.make_from_linear (context.property_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	class_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_CLASS is
			--|
		do
			Result := context.class_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (10661))
			set_entity_as_of_date (Result, a_date)
		end

	class_by_entity_id (a_entity_id: INTEGER): GCDB_CLASS is
			--|
		do
			Result := context.class_accessor.entity (a_entity_id)
		end

	class_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_CLASS] is
			--|
		do
			create Result.make_from_linear (context.class_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	role_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_ROLE is
			--|
		do
			Result := context.role_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (10663))
			set_entity_as_of_date (Result, a_date)
		end

	role_by_entity_id (a_entity_id: INTEGER): GCDB_ROLE is
			--|
		do
			Result := context.role_accessor.entity (a_entity_id)
		end

	roles_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_ROLE] is
			--|
		do
			create Result.make_from_linear (context.role_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

	activity_by_code (a_code: STRING; a_date: ROSE_DATE): GCDB_ACTIVITY is
			--|
		do
			Result := context.activity_accessor.entity_from_identifier (a_code,
																			a_date,
																			context.identifier (10667))
			set_entity_as_of_date (Result, a_date)
		end

	activity_by_entity_id (a_entity_id: INTEGER): GCDB_ACTIVITY is
			--|
		do
			Result := context.activity_accessor.entity (a_entity_id)
		end

	activities_by_date (a_date: ROSE_DATE): ROSE_LINEAR_ARRAY[GCDB_ACTIVITY] is
			--|
		do
			create Result.make_from_linear (context.activity_accessor.all_entities)
			if a_date /= void then
				filter_entities_by_date (a_date, Result)
			end
		end

feature {NONE} -- Implementation

	filter_entities_by_date (a_date: ROSE_DATE; a_entities: ROSE_LINEAR_ARRAY[GCDB_ENTITY]) is
			--|
		local
			l_entity: GCDB_ENTITY
		do
			from
				a_entities.finish
			until
				a_entities.off
			loop
				l_entity := a_entities.current_item
				if not l_entity.brackets (a_date) then
					a_entities.remove
				else
					set_entity_as_of_date (a_entities.current_item, a_date)
				end
				a_entities.back
			end
		end

	set_entity_as_of_date (a_entity: GCDB_ENTITY; a_as_of_date: ROSE_DATE) is
			--|
		do
			if a_entity /= void and a_as_of_date /= void then
				a_entity.set_as_of_date (a_as_of_date)
			end
		end

invariant

	singleton_created: singleton_created
	singleton_pattern: Current = singleton

end -- GCDB_HOME
