note

	description:

		"Automagically Generated -- Empty Description in GCDB"

	keywords: "entity, gcdb, imc"
	author: "$Author: mk $"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #19 $"
	path: "$File: //rose/source/kernel/gcdb/generated/gcdb_imc_base.e $"

deferred class
	GCDB_IMC_BASE

inherit
	PERSISTENT_IMC
		export
			{GCDB_IMC_BASE,GCDB_HOME} all
		undefine
			make,
			context,
			name_at
		end
	GCDB_ENTITY
		export
			{GCDB_IMC_BASE,GCDB_HOME} all
			{ANY} handle, is_equal, hash_code,
					entity_at, start_date, end_date,
					as_of_date, set_as_of_date
		undefine
			is_equal
		redefine
			name_at
		end

feature {NONE} -- Implementation

	upcast: like context.imc_template is
			-- convert to base
		do
			Result ?= Current
		end

feature -- GCDB Attributes and Relationships

	code: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

	name: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (46, as_of_date)
		end

	portfolios_by_imc_engineering_history: ROSE_ENTITY_HISTORY[GCDB_PORTFOLIO] is
			-- history of imc to portfolio by imc_engineering
		do
			Result := context.portfolio_to_imc_engineering.corelated_entity_intervals (upcast)
		end

	portfolios_by_imc_engineering: ROSE_LINEAR_ARRAY[GCDB_PORTFOLIO] is
			-- imc to portfolio by imc_engineering (142)
		do
			Result := portfolios_by_imc_engineering_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	portfolios_by_imc_operations_history: ROSE_ENTITY_HISTORY[GCDB_PORTFOLIO] is
			-- history of imc to portfolio by imc_operations
		do
			Result := context.portfolio_to_imc_operations.corelated_entity_intervals (upcast)
		end

	portfolios_by_imc_operations: ROSE_LINEAR_ARRAY[GCDB_PORTFOLIO] is
			-- imc to portfolio by imc_operations (143)
		do
			Result := portfolios_by_imc_operations_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	portfolios_by_imc_trading_history: ROSE_ENTITY_HISTORY[GCDB_PORTFOLIO] is
			-- history of imc to portfolio by imc_trading
		do
			Result := context.portfolio_to_imc_trading.corelated_entity_intervals (upcast)
		end

	portfolios_by_imc_trading: ROSE_LINEAR_ARRAY[GCDB_PORTFOLIO] is
			-- imc to portfolio by imc_trading (144)
		do
			Result := portfolios_by_imc_trading_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	-- relationship -- accounts_by_imc_legal -> 46 GCDB_ACCOUNT -- 0 imc to account by imc_legal

	accounts_by_imc_accounting_history: ROSE_ENTITY_HISTORY[GCDB_ACCOUNT] is
			-- history of imc to account by imc_accounting
		do
			Result := context.account_to_imc_accounting.corelated_entity_intervals (upcast)
		end

	accounts_by_imc_accounting: ROSE_LINEAR_ARRAY[GCDB_ACCOUNT] is
			-- imc to account by imc_accounting (132)
		do
			Result := accounts_by_imc_accounting_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	accounts_by_imc_client_services_history: ROSE_ENTITY_HISTORY[GCDB_ACCOUNT] is
			-- history of imc to account by imc_client_services
		do
			Result := context.account_to_imc_client_services.corelated_entity_intervals (upcast)
		end

	accounts_by_imc_client_services: ROSE_LINEAR_ARRAY[GCDB_ACCOUNT] is
			-- imc to account by imc_client_services (133)
		do
			Result := accounts_by_imc_client_services_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	accounts_by_imc_marketing_history: ROSE_ENTITY_HISTORY[GCDB_ACCOUNT] is
			-- history of imc to account by imc_marketing
		do
			Result := context.account_to_imc_marketing.corelated_entity_intervals (upcast)
		end

	accounts_by_imc_marketing: ROSE_LINEAR_ARRAY[GCDB_ACCOUNT] is
			-- imc to account by imc_marketing (134)
		do
			Result := accounts_by_imc_marketing_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	-- relationship -- benchmarks_by_imc_engineering -> 48 GCDB_BENCHMARK -- 0 imc to benchmark by imc_engineering

	-- relationship -- investment_regions_by_default_imc_trading -> 339 GCDB_INVESTMENT_REGION -- 0 imc to investment_region by default_imc_trading

	name_at (a_date: ROSE_DATE): STRING is
			-- name_at queries the unique code attribute
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

end -- GCDB_IMC
