note

	description:

		"Automagically Generated -- Empty Description in GCDB"

	keywords: "entity, gcdb, instrument_type"
	author: "$Author: mk $"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #19 $"
	path: "$File: //rose/source/kernel/gcdb/generated/gcdb_instrument_type_base.e $"

deferred class
	GCDB_INSTRUMENT_TYPE_BASE

inherit
	PERSISTENT_SECURITY_TYPE
		export
			{GCDB_INSTRUMENT_TYPE_BASE,GCDB_HOME} all
		undefine
			make,
			context,
			name_at
		end
	GCDB_ENTITY
		export
			{GCDB_INSTRUMENT_TYPE_BASE,GCDB_HOME} all
			{ANY} handle, is_equal, hash_code,
					entity_at, start_date, end_date,
					as_of_date, set_as_of_date
		undefine
			is_equal
		redefine
			name_at
		end

feature {NONE} -- Implementation

	upcast: like context.security_type_template is
			-- convert to base
		do
			Result ?= Current
		end

feature -- GCDB Attributes and Relationships

	code: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

	is_bond: BOOLEAN is
			-- Yes for portfolio designated as bond portfolios
		do
			Result := boolean_attribute_value (10535, as_of_date)
		end

	is_equity: BOOLEAN is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := boolean_attribute_value (10651, as_of_date)
		end

	is_account_non_equity: BOOLEAN is
			-- Account that has at least one portfolio with an instrument type that has this field checked will be considered non equity accounts. Requested by Lucia for use by the fee forecaster.
		do
			Result := boolean_attribute_value (10676, as_of_date)
		end

	portfolios_by_instrument_type_history: ROSE_ENTITY_HISTORY[GCDB_PORTFOLIO] is
			-- history of instrument_type to portfolio by instrument_type
		do
			Result := context.portfolio_to_instrument_type.corelated_entity_intervals (upcast)
		end

	portfolios_by_instrument_type: ROSE_LINEAR_ARRAY[GCDB_PORTFOLIO] is
			-- instrument_type to portfolio by instrument_type (186)
		do
			Result := portfolios_by_instrument_type_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	-- relationship -- non_discretionaries_by_instrument_type -> 369 GCDB_NON_DISCRETIONARY -- 0 instrument_type to non_discretionary by instrument_type

	name_at (a_date: ROSE_DATE): STRING is
			-- name_at queries the unique code attribute
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

end -- GCDB_INSTRUMENT_TYPE
