note

	description:

		"Automagically Generated -- Empty Description in GCDB"

	keywords: "entity, gcdb, investment_region"
	author: "$Author: mk $"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #18 $"
	path: "$File: //rose/source/kernel/gcdb/generated/gcdb_investment_region_base.e $"

deferred class
	GCDB_INVESTMENT_REGION_BASE

inherit
	PERSISTENT_INVESTMENT_REGION
		export
			{GCDB_INVESTMENT_REGION_BASE,GCDB_HOME} all
		undefine
			make,
			context,
			name_at
		end
	GCDB_ENTITY
		export
			{GCDB_INVESTMENT_REGION_BASE,GCDB_HOME} all
			{ANY} handle, is_equal, hash_code,
					entity_at, start_date, end_date,
					as_of_date, set_as_of_date
		undefine
			is_equal
		redefine
			name_at
		end

feature {NONE} -- Implementation

	upcast: like context.investment_region_template is
			-- convert to base
		do
			Result ?= Current
		end

feature -- GCDB Attributes and Relationships

	code: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

	description: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10341, as_of_date)
		end

	-- relationship -- default_imc_trading -> 49 GCDB_IMC -- 692 Specified the default IMC doing trading of portfolio in this investment region. All overwrites of that rule should be set for each individual portfolio.

	portfolios_by_investment_region_history: ROSE_ENTITY_HISTORY[GCDB_PORTFOLIO] is
			-- history of investment_region to portfolio by investment_region
		do
			Result := context.portfolio_to_investment_region.corelated_entity_intervals (upcast)
		end

	portfolios_by_investment_region: ROSE_LINEAR_ARRAY[GCDB_PORTFOLIO] is
			-- investment_region to portfolio by investment_region (202)
		do
			Result := portfolios_by_investment_region_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	accounts_by_domicile_region_history: ROSE_ENTITY_HISTORY[GCDB_ACCOUNT] is
			-- history of investment_region to account by domicile_region
		do
			Result := context.account_to_domicile_region.corelated_entity_intervals (upcast)
		end

	accounts_by_domicile_region: ROSE_LINEAR_ARRAY[GCDB_ACCOUNT] is
			-- investment_region to account by domicile_region (185)
		do
			Result := accounts_by_domicile_region_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	products_by_investment_region_history: ROSE_ENTITY_HISTORY[GCDB_PRODUCT] is
			-- history of investment_region to product by investment_region
		do
			Result := context.composite_to_investment_region.corelated_entity_intervals (upcast)
		end

	products_by_investment_region: ROSE_LINEAR_ARRAY[GCDB_PRODUCT] is
			-- investment_region to product by investment_region (209)
		do
			Result := products_by_investment_region_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	countries_by_investment_region_history: ROSE_ENTITY_HISTORY[GCDB_COUNTRY] is
			-- history of investment_region to country by investment_region
		do
			Result := context.country_to_investment_region.corelated_entity_intervals (upcast)
		end

	countries_by_investment_region: ROSE_LINEAR_ARRAY[GCDB_COUNTRY] is
			-- investment_region to country by investment_region (10)
		do
			Result := countries_by_investment_region_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	-- relationship -- strategy_regions_by_investment_region -> 419 GCDB_STRATEGY_REGION -- 0 investment_region to strategy_region by investment_region

	-- relationship -- benchmark_return_definitions_by_investment_region -> 537 GCDB_BENCHMARK_RETURN_DEFINITION -- 0 investment_region to benchmark_return_definition by investment_region

	name_at (a_date: ROSE_DATE): STRING is
			-- name_at queries the unique code attribute
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

end -- GCDB_INVESTMENT_REGION
