note

	description:

		"Automagically Generated -- Empty Description in GCDB"

	keywords: "entity, gcdb, portfolio"
	author: "$Author: sm $"
	last_editor: "$Author: sm $"
	date: "$Date: 2013/04/26 $"
	revision: "$Revision: #26 $"
	path: "$File: //rose/source/kernel/gcdb/generated/gcdb_portfolio_base.e $"

deferred class
	GCDB_PORTFOLIO_BASE

inherit
	PERSISTENT_PORTFOLIO
		export
			{GCDB_PORTFOLIO_BASE,GCDB_HOME} all
		undefine
			make,
			context
		redefine
			name_at
		end
	GCDB_ENTITY
		export
			{GCDB_PORTFOLIO_BASE,GCDB_HOME} all
			{ANY} handle, is_equal, hash_code,
					entity_at, start_date, end_date,
					as_of_date, set_as_of_date
		undefine
			is_equal
		redefine
			name_at
		end

feature {NONE} -- Implementation

	upcast: like context.portfolio_template is
			-- convert to base
		do
			Result ?= Current
		end

feature -- GCDB Attributes and Relationships

	name: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (46, as_of_date)
		end

	investment_region_history: ROSE_ENTITY_HISTORY[GCDB_INVESTMENT_REGION] is
			-- history of Zone (C, E, J, U, O, W)
		do
			Result := context.portfolio_to_investment_region.related_entity_intervals (upcast)
		end

	investment_region: GCDB_INVESTMENT_REGION is
			-- Zone (C, E, J, U, O, W)
		do
			Result := investment_region_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	is_marketing_available: BOOLEAN is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := boolean_attribute_value (10113, as_of_date)
		end

	code: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

	account_history: ROSE_ENTITY_HISTORY[GCDB_ACCOUNT] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.portfolio_to_account.related_entity_intervals (upcast)
		end

	account: GCDB_ACCOUNT is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := account_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	imc_trading_history: ROSE_ENTITY_HISTORY[GCDB_IMC] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.portfolio_to_imc_trading.related_entity_intervals (upcast)
		end

	imc_trading: GCDB_IMC is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := imc_trading_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	imc_operations_history: ROSE_ENTITY_HISTORY[GCDB_IMC] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.portfolio_to_imc_operations.related_entity_intervals (upcast)
		end

	imc_operations: GCDB_IMC is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := imc_operations_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	imc_engineering_history: ROSE_ENTITY_HISTORY[GCDB_IMC] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.portfolio_to_imc_engineering.related_entity_intervals (upcast)
		end

	imc_engineering: GCDB_IMC is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := imc_engineering_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	benchmark_history: ROSE_ENTITY_HISTORY[GCDB_BENCHMARK] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.portfolio_to_benchmark.related_entity_intervals (upcast)
		end

	benchmark: GCDB_BENCHMARK is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := benchmark_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	is_created_by_reorganization: BOOLEAN is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := boolean_attribute_value (10134, as_of_date)
		end

	bank_code: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10137, as_of_date)
		end

	bank_agent_code: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10138, as_of_date)
		end

	report_timing_electronic: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10140, as_of_date)
		end

	report_timing_paper: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10141, as_of_date)
		end

	accounting_method: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10143, as_of_date)
		end

	is_lending_allowed: BOOLEAN is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := boolean_attribute_value (10144, as_of_date)
		end

	is_client_get_reports: BOOLEAN is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := boolean_attribute_value (10145, as_of_date)
		end

	is_short_sale_allowed: BOOLEAN is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := boolean_attribute_value (10148, as_of_date)
		end

	source_of_funds: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10226, as_of_date)
		end

	not_in_olap: STRING is
			-- Exclude some portfolio from the cube (fixed income and balanced)
		do
			Result := attribute_from_supplier_attribute_id_at (10270, as_of_date)
		end

	portfolio_engineer: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10271, as_of_date)
		end

	ops_person: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10272, as_of_date)
		end

	is_performance_hedged: BOOLEAN is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := boolean_attribute_value (10316, as_of_date)
		end

	is_in_axa_finance_reports: BOOLEAN is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := boolean_attribute_value (10330, as_of_date)
		end

	-- relationship -- composite_state -> 334 GCDB_COMPOSITE_MEMBERSHIP -- 337 GCDB doesn't have description for this attribute/relationship

	instrument_type_history: ROSE_ENTITY_HISTORY[GCDB_INSTRUMENT_TYPE] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.portfolio_to_instrument_type.related_entity_intervals (upcast)
		end

	instrument_type: GCDB_INSTRUMENT_TYPE is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := instrument_type_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	-- relationship -- restriction -> 367 GCDB_RESTRICTION -- 380 GCDB doesn't have description for this attribute/relationship

	-- relationship -- is_paying_fees -> 377 GCDB_IS_PAYING_FEES -- 381 GCDB doesn't have description for this attribute/relationship

	selection_universe_history: ROSE_ENTITY_HISTORY[GCDB_SELECTION_UNIVERSE] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.portfolio_to_selection_universe.related_entity_intervals (upcast)
		end

	selection_universe: GCDB_SELECTION_UNIVERSE is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := selection_universe_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	-- relationship -- holdret_universe_override -> 514 GCDB_HOLDRET_UNIVERSE -- 518 Should be populated only if the Holdret universe for this portfolio in the client_bogies_u.parm differs from the default holdret universe for the portfolio benchmark

	-- attribute -- perf_start: ROSE_DATE -- 536 Override for the default parf start date (the date of the first non deleted event)

	-- attribute -- bogies_z_start: ROSE_DATE -- 542 First date column in invest_z_a:client_bogies_z.parm

	restrict_fx_mt300s_history: ROSE_ENTITY_HISTORY[GCDB_CURRENCY] is
			-- history of Indicates that all FXs for this curency don't need mt300
		do
			Result := context.portfolio_to_mt300_fx_restricted_currency.related_entity_intervals (upcast)
		end

	restrict_fx_mt300s: ROSE_LINEAR_ARRAY[GCDB_CURRENCY] is
			-- Indicates that all FXs for this curency don't need mt300 (294)
		do
			Result := restrict_fx_mt300s_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	-- attribute -- suffix: STRING -- 557 Added to the account name to give a better description of this portfolio.

	composite_history: ROSE_ENTITY_HISTORY[GCDB_PRODUCT] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.portfolio_to_composite.related_entity_intervals (upcast)
		end

	composite: GCDB_PRODUCT is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := composite_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	reporting_attribution_model_history: ROSE_ENTITY_HISTORY[GCDB_REPORTING_ATTRIBUTION_MODEL] is
			-- history of The model used for performance attribution
		do
			Result := context.portfolio_to_reporting_attribution_model.related_entity_intervals (upcast)
		end

	reporting_attribution_model: GCDB_REPORTING_ATTRIBUTION_MODEL is
			-- The model used for performance attribution
		do
			Result := reporting_attribution_model_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	-- relationship -- product -> 154 GCDB_PRODUCT -- 575 GCDB doesn't have description for this attribute/relationship

	is_non_avp: BOOLEAN is
			-- Average price not allowed.
		do
			Result := boolean_attribute_value (583, as_of_date)
		end

	restrict_fx_mt304s_history: ROSE_ENTITY_HISTORY[GCDB_CURRENCY] is
			-- history of FXs involving currencies in this list will not result in generating mt304
		do
			Result := context.portfolio_to_mt304_fx_restricted_currency.related_entity_intervals (upcast)
		end

	restrict_fx_mt304s: ROSE_LINEAR_ARRAY[GCDB_CURRENCY] is
			-- FXs involving currencies in this list will not result in generating mt304 (324)
		do
			Result := restrict_fx_mt304s_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	not_in_quop: BOOLEAN is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := boolean_attribute_value (597, as_of_date)
		end

	-- attribute -- min_holding_period: STRING -- 598 Minimum allowed flip-flop period length in days

	-- attribute -- is_perf_inception_month_partial: EGCDB_TRISTATE -- 634 GCDB doesn't have description for this attribute/relationship

	-- relationship -- investment_sub_region -> 419 GCDB_STRATEGY_REGION -- 648 Narrow definition of the investment region.

	-- attribute -- process_unmatched_trades: EGCDB_TRISTATE -- 649 When set indicates that we should start trade processing \r\nbefore receiving trade matching conformation and that trade \r\nmatching conformation is not expected for this portfolio.

	-- attribute -- first_event_date: ROSE_DATE -- 763 First Event Date

	swift_recipients_by_portfolio_history: ROSE_ENTITY_HISTORY[GCDB_SWIFT_RECIPIENT] is
			-- history of portfolio to swift_recipient by portfolio
		do
			Result := context.swift_recipient_to_portfolio.corelated_entity_intervals (upcast)
		end

	swift_recipients_by_portfolio: ROSE_LINEAR_ARRAY[GCDB_SWIFT_RECIPIENT] is
			-- portfolio to swift_recipient by portfolio (152)
		do
			Result := swift_recipients_by_portfolio_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	asfa_recipients_by_portfolio_history: ROSE_ENTITY_HISTORY[GCDB_ASFA_RECIPIENT] is
			-- history of portfolio to asfa_recipient by portfolio
		do
			Result := context.asfa_recipient_to_portfolio.corelated_entity_intervals (upcast)
		end

	asfa_recipients_by_portfolio: ROSE_LINEAR_ARRAY[GCDB_ASFA_RECIPIENT] is
			-- portfolio to asfa_recipient by portfolio (135)
		do
			Result := asfa_recipients_by_portfolio_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	portfolio_groups_by_portfolio_history: ROSE_ENTITY_HISTORY[GCDB_PORTFOLIO_GROUP] is
			-- history of portfolio to portfolio_group by portfolio
		do
			Result := context.portfolio_group_member_to_portfolio.corelated_entity_intervals (upcast)
		end

	portfolio_groups_by_portfolio: ROSE_LINEAR_ARRAY[GCDB_PORTFOLIO_GROUP] is
			-- portfolio to portfolio_group by portfolio (148)
		do
			Result := portfolio_groups_by_portfolio_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	-- relationship -- portfolio_reporting_benchmarks_by_portfolio -> 478 GCDB_PORTFOLIO_REPORTING_BENCHMARK -- 0 portfolio to portfolio_reporting_benchmark by portfolio

	-- relationship -- weight_in_accounts_by_portfolio -> 496 GCDB_WEIGHT_IN_ACCOUNT -- 0 portfolio to weight_in_account by portfolio

	name_at (a_date: ROSE_DATE): STRING is
			-- name_at queries the unique code attribute
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

end -- GCDB_PORTFOLIO
