note

	description:

		"Automagically Generated -- Empty Description in GCDB"

	keywords: "entity, gcdb, portfolio_group"
	author: "$Author: mk $"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #19 $"
	path: "$File: //rose/source/kernel/gcdb/generated/gcdb_portfolio_group_base.e $"

deferred class
	GCDB_PORTFOLIO_GROUP_BASE

inherit
	PERSISTENT_PORTFOLIO_GROUP
		export
			{GCDB_PORTFOLIO_GROUP_BASE,GCDB_HOME} all
		undefine
			make,
			context,
			name_at
		end
	GCDB_ENTITY
		export
			{GCDB_PORTFOLIO_GROUP_BASE,GCDB_HOME} all
			{ANY} handle, is_equal, hash_code,
					entity_at, start_date, end_date,
					as_of_date, set_as_of_date
		undefine
			is_equal
		redefine
			name_at
		end

feature {NONE} -- Implementation

	upcast: like context.portfolio_group_template is
			-- convert to base
		do
			Result ?= Current
		end

feature -- GCDB Attributes and Relationships

	code: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

	name: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (46, as_of_date)
		end

	portfolios_history: ROSE_ENTITY_HISTORY[GCDB_PORTFOLIO] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.portfolio_group_member_to_portfolio.related_entity_intervals (upcast)
		end

	portfolios: ROSE_LINEAR_ARRAY[GCDB_PORTFOLIO] is
			-- GCDB doesn't have description for this attribute/relationship (148)
		do
			Result := portfolios_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	is_not_investment_type: BOOLEAN is
			-- Indicates that this portfolio group\r\nwill not be used for investment purposes.\r\nInvestment group of portfolios contains\r\na single T zone portfolio and any number\r\nof non T zone portfolios. The transfer from/to\r\nthe investment group should happen thru the\r\nT zone with 11/12 event types. The transfer\r\nto any other than T zone portfolio should\r\nhappen thry 41/42 event types between the \r\nzonal portfolio and the T zone.\r\n
		do
			Result := boolean_attribute_value (10288, as_of_date)
		end

	report_currency_history: ROSE_ENTITY_HISTORY[GCDB_CURRENCY] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.portfolio_group_to_reporting_currency.related_entity_intervals (upcast)
		end

	report_currency: GCDB_CURRENCY is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := report_currency_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	strategy_description: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (412, as_of_date)
		end

	swift_recon_start: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (413, as_of_date)
		end

	is_not_in_vms_perf: BOOLEAN is
			-- All the entries where this field is checked will be excluded from clientfile_t.parm
		do
			Result := boolean_attribute_value (424, as_of_date)
		end

	is_carve_out: BOOLEAN is
			-- If True indicates that this portfolio group defines subset of a global account
		do
			Result := boolean_attribute_value (491, as_of_date)
		end

	-- relationship -- composite_state -> 334 GCDB_COMPOSITE_MEMBERSHIP -- 580 GCDB doesn't have description for this attribute/relationship

	composite_history: ROSE_ENTITY_HISTORY[GCDB_PRODUCT] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.portfolio_group_to_composite.related_entity_intervals (upcast)
		end

	composite: GCDB_PRODUCT is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := composite_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	-- attribute -- is_perf_inception_month_partial: EGCDB_TRISTATE -- 636 GCDB doesn't have description for this attribute/relationship

	-- relationship -- portfolio_group_benchmarks_by_portfolio_group -> 415 GCDB_PORTFOLIO_GROUP_BENCHMARK -- 0 portfolio_group to portfolio_group_benchmark by portfolio_group

	-- relationship -- portfolio_group_reporting_benchmarks_by_portfolio_group -> 486 GCDB_PORTFOLIO_GROUP_REPORTING_BENCHMARK -- 0 portfolio_group to portfolio_group_reporting_benchmark by portfolio_group

	benchmarks_by_portfolio_group_history: ROSE_ENTITY_HISTORY[GCDB_BENCHMARK] is
			-- history of portfolio_group to benchmark by portfolio_group
		do
			Result := context.portfolio_group_to_benchmark.related_entity_intervals (upcast)
		end

	benchmarks_by_portfolio_group: ROSE_LINEAR_ARRAY[GCDB_BENCHMARK] is
			-- portfolio_group to benchmark by portfolio_group (190)
		do
			Result := benchmarks_by_portfolio_group_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	name_at (a_date: ROSE_DATE): STRING is
			-- name_at queries the unique code attribute
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

end -- GCDB_PORTFOLIO_GROUP
