indexing

	description:

		"GCDB Composite"

	keywords: "entity, gcdb, product"
	date: "$Date: 2009/09/21 $"
	sccid: "$Id: //rose/source/kernel/gcdb/generated/gcdb_product.e#18 $"

class GCDB_PRODUCT

inherit

	GCDB_PRODUCT_BASE
		redefine
			code, base_fee, perf_fee_net_alpha
		end

create

	make,
	make_anonymous

feature -- Access

	code: STRING is
			-- Unique code
		do
			Result := attribute_value_history (96).first.attribute_value
		end

	last_known_name: STRING is
			-- Last known descriptive name
		do
			if attribute_value_history (46).is_empty then
				Result := ""
			else
				Result := attribute_value_history (46).last.attribute_value
			end
		end

	base_fee: STRING is
			-- Highest fee in product.  Used in composite Net of Fee calculations.
		do
			if attribute_value_history (708).is_empty then
				Result := ""
			else
				Result := attribute_value_history (708).last.attribute_value
			end
		ensure then
			non_void_result: Result /= Void
		end

	perf_fee_net_alpha: STRING is
			-- percentage of net alpha used in performance fee calculation
		do
			if attribute_value_history (709).is_empty then
				Result := ""
			else
				Result := attribute_value_history (709).last.attribute_value
			end
		ensure then
			non_void_result: Result /= Void
		end

end -- GCDB_PRODUCT
