note

	description:

		"Automagically Generated -- Empty Description in GCDB"

	keywords: "entity, gcdb, product"
	author: "$Author: mk $"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #23 $"
	path: "$File: //rose/source/kernel/gcdb/generated/gcdb_product_base.e $"

deferred class
	GCDB_PRODUCT_BASE

inherit
	PERSISTENT_COMPOSITE
		export
			{GCDB_PRODUCT_BASE,GCDB_HOME} all
		undefine
			make,
			context,
			name_at
		end
	GCDB_ENTITY
		export
			{GCDB_PRODUCT_BASE,GCDB_HOME} all
			{ANY} handle, is_equal, hash_code,
					entity_at, start_date, end_date,
					as_of_date, set_as_of_date
		undefine
			is_equal
		redefine
			name_at
		end

feature {NONE} -- Implementation

	upcast: like context.composite_template is
			-- convert to base
		do
			Result ?= Current
		end

feature -- GCDB Attributes and Relationships

	code: STRING is
			-- unique product mnemonic
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

	name: STRING is
			-- name of the product
		do
			Result := attribute_from_supplier_attribute_id_at (46, as_of_date)
		end

	investment_region_history: ROSE_ENTITY_HISTORY[GCDB_INVESTMENT_REGION] is
			-- history of investment region for the constituents of the product
		do
			Result := context.composite_to_investment_region.related_entity_intervals (upcast)
		end

	investment_region: GCDB_INVESTMENT_REGION is
			-- investment region for the constituents of the product
		do
			Result := investment_region_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	investment_region_unique_code: STRING is
			-- A product mnemonic that is guaranteed to be unique within the investment region only. Used for backward compatibility.
		do
			Result := attribute_from_supplier_attribute_id_at (10158, as_of_date)
		end

	is_marketed: BOOLEAN is
			-- Indicated whether a product is an official product. Only official products show in AUM.
		do
			Result := boolean_attribute_value (10317, as_of_date)
		end

	is_global: BOOLEAN is
			-- If checked indicates that it aggregates accounts and not portfolios
		do
			Result := boolean_attribute_value (10326, as_of_date)
		end

	-- relationship -- representative_account -> 46 GCDB_ACCOUNT -- 433 Tracks an account which is representative for this product for a given period

	begin_date: ROSE_DATE is
			-- Begin date of the composite/product
		do
			Result := date_attribute_value (509, as_of_date)
		end

	close_date: ROSE_DATE is
			-- End date of the composite
		do
			Result := date_attribute_value (557, as_of_date)
		end

	product_constituents_history: ROSE_ENTITY_HISTORY[GCDB_PRODUCT] is
			-- history of Defines a product as a superset of other products
		do
			Result := context.composite_to_composite_constituent.related_entity_intervals (upcast)
		end

	product_constituents: ROSE_LINEAR_ARRAY[GCDB_PRODUCT] is
			-- Defines a product as a superset of other products (317)
		do
			Result := product_constituents_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	is_not_composite: BOOLEAN is
			-- When set indicates that the current is not used as composite
		do
			Result := boolean_attribute_value (10577, as_of_date)
		end

	is_not_product: BOOLEAN is
			-- When set indicates that the current is not used as product
		do
			Result := boolean_attribute_value (10578, as_of_date)
		end

	audit_currency_history: ROSE_ENTITY_HISTORY[GCDB_CURRENCY] is
			-- history of Audit Currency. An override over the Investment Region base currency.
		do
			Result := context.composite_to_audit_currency.related_entity_intervals (upcast)
		end

	audit_currency: GCDB_CURRENCY is
			-- Audit Currency. An override over the Investment Region base currency.
		do
			Result := audit_currency_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	-- relationship -- type -> 401 GCDB_STRATEGY_TYPE -- 599 GCDB doesn't have description for this attribute/relationship

	-- relationship -- region -> 419 GCDB_STRATEGY_REGION -- 600 GCDB doesn't have description for this attribute/relationship

	expected_alpha: STRING is
			-- Alpha targeted by this product/strategy. Source is GPM based on simulations?
		do
			Result := attribute_from_supplier_attribute_id_at (602, as_of_date)
		end

	expected_tracking_error: STRING is
			-- Expected tracking error for this product/strategy. Source is GPM based on simulations?
		do
			Result := attribute_from_supplier_attribute_id_at (603, as_of_date)
		end

	gips_examination: STRING is
			-- This will specify the year in which the Composite was "examined" by PwC.  Each year we get a list of composites examined (in addition to the firmwide verification).  We need to keep track of which composites were verified in which years, as well as to establish the list for the most recent audit year so we can run reports on them.
		do
			Result := attribute_from_supplier_attribute_id_at (10608, as_of_date)
		end

	-- relationship -- fee_type -> 704 GCDB_FEE_TYPE -- 706 management fee type

	is_model_fee: BOOLEAN is
			-- ask Kay about it
		do
			Result := boolean_attribute_value (10707, as_of_date)
		end

	base_fee: STRING is
			-- 	Base Fee (value: # from 0 up to 3 digits in basis pts)         i.e. 40 entered = 40bp or .40%
		do
			Result := attribute_from_supplier_attribute_id_at (708, as_of_date)
		end

	perf_fee_net_alpha: STRING is
			-- 	Perf Fee Net Alpha (value:  % from 0 up)                          i.e. 20 entered = 20% of net alpha or .20%
		do
			Result := attribute_from_supplier_attribute_id_at (709, as_of_date)
		end

	is_high_water_mark: BOOLEAN is
			-- ask Kay about that field
		do
			Result := boolean_attribute_value (10710, as_of_date)
		end

	-- relationship -- highest_fee_account -> 46 GCDB_ACCOUNT -- 711 GCDB doesn't have description for this attribute/relationship

	creation_date: ROSE_DATE is
			-- Composite creation date - when the composite is officially constructed.
		do
			Result := date_attribute_value (10712, as_of_date)
		end

	-- relationship -- portfolios_by_product -> 34 GCDB_PORTFOLIO -- 0 product to portfolio by product

	portfolios_by_composite_history: ROSE_ENTITY_HISTORY[GCDB_PORTFOLIO] is
			-- history of product to portfolio by composite
		do
			Result := context.portfolio_to_composite.corelated_entity_intervals (upcast)
		end

	portfolios_by_composite: ROSE_LINEAR_ARRAY[GCDB_PORTFOLIO] is
			-- product to portfolio by composite (293)
		do
			Result := portfolios_by_composite_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	-- relationship -- accounts_by_product -> 46 GCDB_ACCOUNT -- 0 product to account by product

	accounts_by_composite_history: ROSE_ENTITY_HISTORY[GCDB_ACCOUNT] is
			-- history of product to account by composite
		do
			Result := context.account_to_composite.corelated_entity_intervals (upcast)
		end

	accounts_by_composite: ROSE_LINEAR_ARRAY[GCDB_ACCOUNT] is
			-- product to account by composite (316)
		do
			Result := accounts_by_composite_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	product_by_product_constituent_history: ROSE_ENTITY_HISTORY[GCDB_PRODUCT] is
			-- history of product to product by product_constituent
		do
			Result := context.composite_to_composite_constituent.related_entity_intervals (upcast)
		end

	product_by_product_constituent: GCDB_PRODUCT is
			-- product to product by product_constituent
		do
			Result := product_by_product_constituent_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	portfolio_groups_by_composite_history: ROSE_ENTITY_HISTORY[GCDB_PORTFOLIO_GROUP] is
			-- history of product to portfolio_group by composite
		do
			Result := context.portfolio_group_to_composite.corelated_entity_intervals (upcast)
		end

	portfolio_groups_by_composite: ROSE_LINEAR_ARRAY[GCDB_PORTFOLIO_GROUP] is
			-- product to portfolio_group by composite (321)
		do
			Result := portfolio_groups_by_composite_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	-- relationship -- product_benchmarks_by_product -> 289 GCDB_PRODUCT_BENCHMARK -- 0 product to product_benchmark by product

	-- relationship -- product_reporting_benchmarks_by_product -> 592 GCDB_PRODUCT_REPORTING_BENCHMARK -- 0 product to product_reporting_benchmark by product

	-- relationship -- composite_perf_intervals_by_composite -> 715 GCDB_COMPOSITE_PERF_INTERVAL -- 0 product to composite_perf_interval by composite

	benchmarks_by_product_history: ROSE_ENTITY_HISTORY[GCDB_BENCHMARK] is
			-- history of product to benchmark by product
		do
			Result := context.benchmark_to_composite.corelated_entity_intervals (upcast)
		end

	benchmarks_by_product: ROSE_LINEAR_ARRAY[GCDB_BENCHMARK] is
			-- product to benchmark by product (136)
		do
			Result := benchmarks_by_product_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	name_at (a_date: ROSE_DATE): STRING is
			-- name_at queries the unique code attribute
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

end -- GCDB_PRODUCT
