note

	description:

		"Automagically Generated -- Empty Description in GCDB"

	keywords: "entity, gcdb, pset"
	author: "$Author: mk $"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #18 $"
	path: "$File: //rose/source/kernel/gcdb/generated/gcdb_pset_base.e $"

deferred class
	GCDB_PSET_BASE

inherit
	PERSISTENT_PSET
		export
			{GCDB_PSET_BASE,GCDB_HOME} all
		undefine
			make,
			context
		redefine
			name_at
		end

	GCDB_ENTITY
		export
			{GCDB_PSET_BASE,GCDB_HOME} all
			{ANY} handle, is_equal, hash_code, 
					entity_at, start_date, end_date, 
					as_of_date, set_as_of_date
		undefine
			is_equal
		redefine
			name_at
		end

feature {NONE} -- Implementation

	upcast: like context.pset_template is
			-- convert to base
		do
			Result ?= Current
		end

feature -- GCDB Attributes and Relationships

	code: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

	name: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (46, as_of_date)
		end

	eqty_bic: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10222, as_of_date)
		end

	bond_bic: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10223, as_of_date)
		end

	govt_bic: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10224, as_of_date)
		end

	cash_bic: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10225, as_of_date)
		end

	country_history: ROSE_ENTITY_HISTORY[GCDB_COUNTRY] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.pset_to_country.related_entity_intervals (upcast)
		end

	country: GCDB_COUNTRY is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := country_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	settlement_chains_by_pset_history: ROSE_ENTITY_HISTORY[GCDB_SETTLEMENT_CHAIN] is
			-- history of pset to settlement_chain by pset
		do
			Result := context.settlement_chain_to_pset.corelated_entity_intervals (upcast)
		end

	settlement_chains_by_pset: ROSE_LINEAR_ARRAY[GCDB_SETTLEMENT_CHAIN] is
			-- pset to settlement_chain by pset (151)
		do
			Result := settlement_chains_by_pset_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	bank_accounts_by_pset_history: ROSE_ENTITY_HISTORY[GCDB_BANK_ACCOUNT] is
			-- history of pset to bank_account by pset
		do
			Result := context.bank_account_to_pset.corelated_entity_intervals (upcast)
		end

	bank_accounts_by_pset: ROSE_LINEAR_ARRAY[GCDB_BANK_ACCOUNT] is
			-- pset to bank_account by pset (194)
		do
			Result := bank_accounts_by_pset_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	bank_swift_options_by_pset_history: ROSE_ENTITY_HISTORY[GCDB_BANK_SWIFT_OPTION] is
			-- history of pset to bank_swift_option by pset
		do
			Result := context.bank_swift_option_to_pset.corelated_entity_intervals (upcast)
		end

	bank_swift_options_by_pset: ROSE_LINEAR_ARRAY[GCDB_BANK_SWIFT_OPTION] is
			-- pset to bank_swift_option by pset (344)
		do
			Result := bank_swift_options_by_pset_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	name_at (a_date: ROSE_DATE): STRING is
			-- name_at queries the unique code attribute
		do
			Result := attribute_from_supplier_attribute_id_at (96, as_of_date)
		end

end -- GCDB_PSET