indexing
	description: "GCDB HOME Singleton"
	author: "it"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #2 $"

class
	GCDB_SHARED_HOME

feature -- Access

	singleton: GCDB_HOME is
			-- Singleton object
		do
			Result := singleton_cell.item
			if Result = Void then
				create Result.make
			end
		ensure
			singleton_created: singleton_created
			singleton_not_void: Result /= Void
		end

feature -- Status report

	singleton_created: BOOLEAN is
			-- Has singleton already been created?
		do
			Result := singleton_cell.item /= Void
		end

feature {NONE} -- Implementation

	singleton_cell: DS_CELL [GCDB_HOME] is
			-- Cell containing the singleton if already created
		once
			create Result.make (Void)
		ensure
			cell_not_void: Result /= Void
		end

end -- class GCDB_SHARED_HOME
