indexing
	description: "GCDB representation of a strategy"
	author: "Darin Peshev"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #5 $"
	archive: "$File: //rose/source/kernel/gcdb/generated/gcdb_strategy_type.e $"

class
	GCDB_STRATEGY_TYPE
inherit
	GCDB_STRATEGY_TYPE_BASE
		rename
			shorting_limit as shorting_limit_string
		export {NONE}
			shorting_limit_string
		end
create
	make_anonymous
create {RELATIONSHIP_HANDLER,CATEGORY_HANDLER}
	make

feature -- Basic operations

	shorting_limit: DOUBLE is
			-- Optimal debt to net position
		do
			Result := shorting_limit_string.to_double
		end

	is_long_short: BOOLEAN is
			-- True if an account is long short according to Anand's narrow definition
		do
			Result := shorting_limit = 1.0
		end

	is_limited_shorting: BOOLEAN is
			-- True if an account's optimal debt is less than 100% of the net position and is not long only account
		do
			Result := shorting_limit < 1.0 and shorting_limit > 0.0
		end

	is_long_only: BOOLEAN is
			-- True if account doesn't allow short positions
		do
			Result := shorting_limit = 0.0
		end
end
