note

	description:

		"Automagically Generated -- Empty Description in GCDB"

	keywords: "entity, gcdb, swift_recipient"
	author: "$Author: mk $"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #19 $"
	path: "$File: //rose/source/kernel/gcdb/generated/gcdb_swift_recipient_base.e $"

deferred class
	GCDB_SWIFT_RECIPIENT_BASE

inherit
	PERSISTENT_SWIFT_RECIPIENT
		export
			{GCDB_SWIFT_RECIPIENT_BASE,GCDB_HOME} all
		undefine
			make,
			context
		end
	GCDB_ENTITY
		export
			{GCDB_SWIFT_RECIPIENT_BASE,GCDB_HOME} all
			{ANY} handle, is_equal, hash_code, 
					entity_at, start_date, end_date, 
					as_of_date, set_as_of_date
		undefine
			is_equal
		end

feature {NONE} -- Implementation

	upcast: like context.swift_recipient_template is
			-- convert to base
		do
			Result ?= Current
		end

feature -- GCDB Attributes and Relationships

	account: STRING is
			-- Custodian account number for this \r\nportfolio and instrument type. \r\nThis number will be used\r\nin the swift message.
		do
			Result := attribute_from_supplier_attribute_id_at (10193, as_of_date)
		end

	is_active: BOOLEAN is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := boolean_attribute_value (10194, as_of_date)
		end

	portfolio_history: ROSE_ENTITY_HISTORY[GCDB_PORTFOLIO] is
			-- history of GCDB doesn't have description for this attribute/relationship
		do
			Result := context.swift_recipient_to_portfolio.related_entity_intervals (upcast)
		end

	portfolio: GCDB_PORTFOLIO is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := portfolio_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	needs_11a: BOOLEAN is
			-- True indicates that 11a tag should be used in the outgoing swift message if the trade is in currency marked as currency needing 11a for this account
		do
			Result := boolean_attribute_value (492, as_of_date)
		end

	is_custodian: BOOLEAN is
			-- Set for the relationships between account and custodian
		do
			Result := boolean_attribute_value (10655, as_of_date)
		end

	-- relationship -- counterparty -> 274 GCDB_BANK -- 678 Counterparty that will receive the swift messages. This field will replace Destination BIC field which is currently a plain text field.

	-- relationship -- instrument_types -> 679 GCDB_SWIFT_RECIPIENT_INSTRUMENT_TYPE -- 691 GCDB doesn't have description for this attribute/relationship

	-- relationship -- message_types -> 693 GCDB_SWIFT_RECIPIENT_MESSAGE_TYPE -- 697 GCDB doesn't have description for this attribute/relationship

	-- relationship -- from -> 274 GCDB_BANK -- 698 Sender of the generated swift messages.

end -- GCDB_SWIFT_RECIPIENT