note

	description:

		"Automagically Generated -- Empty Description in GCDB"

	keywords: "entity, gcdb, tax_type"
	author: "$Author: mk $"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #15 $"
	path: "$File: //rose/source/kernel/gcdb/generated/gcdb_tax_type_base.e $"

deferred class
	GCDB_TAX_TYPE_BASE

inherit
	PERSISTENT_TAX_TYPE
		export
			{GCDB_TAX_TYPE_BASE,GCDB_HOME} all
		undefine
			make,
			context
		end
	GCDB_ENTITY
		export
			{GCDB_TAX_TYPE_BASE,GCDB_HOME} all
			{ANY} handle, is_equal, hash_code, 
					entity_at, start_date, end_date, 
					as_of_date, set_as_of_date
		undefine
			is_equal
		end

feature {NONE} -- Implementation

	upcast: like context.tax_type_template is
			-- convert to base
		do
			Result ?= Current
		end

feature -- GCDB Attributes and Relationships

	code: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10444, as_of_date)
		end

	name: STRING is
			-- GCDB doesn't have description for this attribute/relationship
		do
			Result := attribute_from_supplier_attribute_id_at (10445, as_of_date)
		end

	preceding_tax_type_history: ROSE_ENTITY_HISTORY[GCDB_TAX_TYPE] is
			-- history of Tax after which current tax should be applied going from gross to net
		do
			Result := context.tax_type_to_preceding_tax_type.related_entity_intervals (upcast)
		end

	preceding_tax_type: GCDB_TAX_TYPE is
			-- Tax after which current tax should be applied going from gross to net
		do
			Result := preceding_tax_type_history.witness (as_of_date)
			set_entity_as_of_date (Result, as_of_date)
		end

	taxes_by_type_history: ROSE_ENTITY_HISTORY[GCDB_TAX] is
			-- history of tax_type to tax by type
		do
			Result := context.tax_to_tax_type.corelated_entity_intervals (upcast)
		end

	taxes_by_type: ROSE_LINEAR_ARRAY[GCDB_TAX] is
			-- tax_type to tax by type (266)
		do
			Result := taxes_by_type_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	country_taxes_by_type_history: ROSE_ENTITY_HISTORY[GCDB_COUNTRY_TAX] is
			-- history of tax_type to country_tax by type
		do
			Result := context.country_tax_to_tax_type.corelated_entity_intervals (upcast)
		end

	country_taxes_by_type: ROSE_LINEAR_ARRAY[GCDB_COUNTRY_TAX] is
			-- tax_type to country_tax by type (267)
		do
			Result := country_taxes_by_type_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

	tax_types_by_preceding_tax_type_history: ROSE_ENTITY_HISTORY[GCDB_TAX_TYPE] is
			-- history of tax_type to tax_type by preceding_tax_type
		do
			Result := context.tax_type_to_preceding_tax_type.related_entity_intervals (upcast)
		end

	tax_types_by_preceding_tax_type: ROSE_LINEAR_ARRAY[GCDB_TAX_TYPE] is
			-- tax_type to tax_type by preceding_tax_type (262)
		do
			Result := tax_types_by_preceding_tax_type_history.all_witnesses (as_of_date)
			set_entities_as_of_date (Result, as_of_date)
		end

end -- GCDB_TAX_TYPE