indexing

	description: "Skeleton for commands in GUI testing script language"

	author: "Colin Adams"
	last_editor: "$Author: c4 $"
	date: "$Date: 2009/05/20 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/infrastructure/framework/gui/script_interpreter/gui_script_command.e $"

class GUI_SCRIPT_COMMAND

inherit

	GUI_SCRIPT_INSTRUCTION

create {NONE}

	make
	
feature {NONE} -- Initialization

	make (a_name: like name) is
			-- Initialize `Current'.
		require
			a_name_not_void: a_name /= Void
		do
			name := a_name
			create arguments.make_empty
		ensure
			name_set: name = a_name
			argument_list_empty: arguments.is_empty
		end

feature -- Access

	name: STRING
			-- Name of command

	arguments: GUI_SCRIPT_ARGUMENT_LIST
			-- Actual arguments to command execution

feature -- Setting

	set_arguments (a_arguments: like arguments) is
			-- Set `arguments' to `a_arguments'.
		require
			a_arguments_not_void: a_arguments /= Void
		do
			arguments := a_arguments
		ensure
			arguments_set: arguments = a_arguments
		end

feature -- Basic operations
	
	execute (a_env: GUI_SCRIPT_ENVIRONMENT) is
			-- Execute `Current'.
		do
			check
				not_implemented: False
				-- descendants must implement
			end
		end

invariant

	name_not_void: name /= Void
	arguments_not_void: arguments /= Void

end
