indexing

	description: "Commands that drop a pebble onto drop targets in GUI testing script language"

	author: "Colin Adams"
	last_editor: "$Author: c4 $"
	date: "$Date: 2009/05/20 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/infrastructure/framework/gui/script_interpreter/gui_script_drop.e $"

class GUI_SCRIPT_DROP

inherit

	GUI_SCRIPT_COMMAND
		redefine
			execute
		end

create

	make

feature -- Basic operations
	
	execute (a_env: GUI_SCRIPT_ENVIRONMENT) is
			-- Execute `Current'.
		do
			if arguments.count /= 2 then
				set_error ("Drop requires precisely two arguments")
			elseif {l_ref: GUI_SCRIPT_VARIABLE_REFERENCE} arguments.item (1) then
				l_ref.evaluate (a_env)
				if l_ref.is_error then
					set_error (l_ref.last_error_message)
				elseif {l_target: EV_ABSTRACT_PICK_AND_DROPABLE} l_ref.value.target then
					if {l_ref2: GUI_SCRIPT_VARIABLE_REFERENCE} arguments.item (2) then
						l_ref2.evaluate (a_env)
						if l_ref2.is_error then
							set_error (l_ref2.last_error_message)
						else
							l_target.drop_actions.call ([l_ref2.value.target])
						end
					else
						set_error ("Drop only accepts a variable reference as second argument")
					end
				else
					set_error ("First variable reference passed to drop did not reference an EV_ABSTRACT_PICK_AND_DROPABLE")
				end
			else
				set_error ("Drop only accepts a variable reference to an EV_ABSTRACT_PICK_AND_DROPABLE as first argument")
			end
		end

end
