indexing

	description: "[
     Commands that fire actions on suitable widgets in GUI testing script language.

     The command takes one argument which is a variable reference to the widget
      whose actions should be run.

     This widget should be one of:
      EV_BUTTON
      EV_TOOL_BAR_BUTTON
      EV_MENU_ITEM
                ]"

	author: "Colin Adams"
	last_editor: "$Author: c4 $"
	date: "$Date: 2010/04/26 $"
	revision: "$Revision: #2 $"
	path: "$File: //rose/source/kernel/infrastructure/framework/gui/script_interpreter/gui_script_fire_actions.e $"

class GUI_SCRIPT_FIRE_ACTIONS

inherit

	GUI_SCRIPT_COMMAND
		redefine
			execute
		end

create

	make

feature -- Basic operations
	
	execute (a_env: GUI_SCRIPT_ENVIRONMENT) is
			-- Execute `Current'.
		do
			if arguments.count /= 1 then
				set_error ("Fire_actions requires precisely one argument")
			elseif {l_ref: GUI_SCRIPT_VARIABLE_REFERENCE} arguments.item (1) then
				l_ref.evaluate (a_env)
				if l_ref.is_error then
					set_error (l_ref.last_error_message)
				elseif {l_button: EV_BUTTON} l_ref.value.target then
					l_button.select_actions.call ([])
				elseif {l_tool_button: EV_TOOL_BAR_BUTTON} l_ref.value.target then
					l_tool_button.select_actions.call ([])
				elseif {l_menu_item: EV_MENU_ITEM} l_ref.value.target then
					l_menu_item.select_actions.call ([])
				else
					set_error ("Variable reference passed to fire_actions did not reference an EV_BUTTON, EV_TOOL_BAR_BUTTON or EV_MENU_ITEM")
				end
			else
				set_error ("Fire_actions only accepts a variable reference to an EV_BUTTON, EV_TOOL_BAR_BUTTON or EV_ITEM as an argument")
			end
		end

end
