indexing

	description: "Functions that return the first item from a suitable container in GUI testing script language"

	author: "Colin Adams"
	last_editor: "$Author: c4 $"
	date: "$Date: 2009/05/20 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/infrastructure/framework/gui/script_interpreter/gui_script_first.e $"

class GUI_SCRIPT_FIRST

inherit

	GUI_SCRIPT_FUNCTION_CALL

create

	make

feature {NONE} -- Initialization

	make is
			-- Initialize `Current'.
		do
			name := "first"
			function_agent := agent first
		end

feature {NONE} -- Implementation

	first: GUI_SCRIPT_TARGET is
			-- First item in `target.target' if it's an EV_WIDGET_LIST
		require
			target_not_void: target /= Void
		do
			if {l_list: EV_WIDGET_LIST} target.target then
				if not l_list.is_empty then
					create Result.make (l_list.first)
				end
			elseif {l_tool_list: EV_ITEM_LIST [EV_ITEM]} target.target then
				if not l_tool_list.is_empty then
					create Result.make (l_tool_list.first)
				end
			elseif {l_split: EV_SPLIT_AREA} target.target then
				create Result.make (l_split.first)
			end
		end

end

	
