indexing

	description: "Functions that return the last item from an EV_WIDGET_LIST in GUI testing script language"

	author: "Colin Adams"
	last_editor: "$Author: c4 $"
	date: "$Date: 2009/05/20 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/infrastructure/framework/gui/script_interpreter/gui_script_last.e $"

class GUI_SCRIPT_LAST

inherit

	GUI_SCRIPT_FUNCTION_CALL

create

	make

feature {NONE} -- Initialization

	make is
			-- Initialize `Current'.
		do
			name := "last"
			function_agent := agent last
		end

feature {NONE} -- Implementation

	last: GUI_SCRIPT_TARGET is
			-- Last item in `target.target' if it's an EV_WIDGET_LIST
		require
			target_not_void: target /= Void
		do
			if {l_list: EV_WIDGET_LIST} target.target then
				if not l_list.is_empty then
					create Result.make (l_list.last)
				end
			elseif {l_tool_list: EV_ITEM_LIST [EV_ITEM]} target.target then
				if not l_tool_list.is_empty then
					create Result.make (l_tool_list.last)
				end
			end
		end

end

	
