indexing

	description: "Commands that turn a grid toggle item or radio button on in GUI testing script language"

	author: "Colin Adams"
	last_editor: "$Author: c4 $"
	date: "$Date: 2009/06/15 $"
	revision: "$Revision: #2 $"
	path: "$File: //rose/source/kernel/infrastructure/framework/gui/script_interpreter/gui_script_select.e $"

class GUI_SCRIPT_SELECT

inherit

	GUI_SCRIPT_COMMAND
		redefine
			execute
		end

create

	make

feature -- Basic operations
	
	execute (a_env: GUI_SCRIPT_ENVIRONMENT) is
			-- Execute `Current'.
		do
			if arguments.count /= 1 then
				set_error ("Select requires precisely one argument")
			elseif {l_ref: GUI_SCRIPT_VARIABLE_REFERENCE} arguments.item (1) then
				l_ref.evaluate (a_env)
				if l_ref.is_error then
					set_error (l_ref.last_error_message)
				elseif {l_toggle: RP_DATA_GRID_TOGGLE_ITEM} l_ref.value.target then
					l_toggle.set_is_on (True)
				elseif {l_radio: RP_DATA_GRID_RADIO_ITEM} l_ref.value.target then
					l_radio.set_is_on (True)
				else
					set_error ("Variable reference passed to select did not reference an RP_DATA_GRID_TOGGLE_ITEM or RP_DATA_GRID_RADIO_ITEM")
				end
			else
				set_error ("Select only accepts a variable reference to an RP_DATA_GRID_TOGGLE_ITEM or RP_DATA_GRID_RADIO_ITEM")
			end
		end

end
