indexing

	description: "Commands that select an item from suitable widgets in GUI testing script language"

	author: "Colin Adams"
	last_editor: "$Author: c4 $"
	date: "$Date: 2009/05/20 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/infrastructure/framework/gui/script_interpreter/gui_script_select_item.e $"

class GUI_SCRIPT_SELECT_ITEM

inherit

	GUI_SCRIPT_COMMAND
		redefine
			execute
		end

create

	make

feature -- Basic operations
	
	execute (a_env: GUI_SCRIPT_ENVIRONMENT) is
			-- Execute `Current'.
		do
			if arguments.count /= 2 then
				set_error ("Select_item requires precisely two arguments")
			elseif {l_ref: GUI_SCRIPT_VARIABLE_REFERENCE} arguments.item (1) then
				l_ref.evaluate (a_env)
				if l_ref.is_error then
					set_error (l_ref.last_error_message)
				elseif {l_notebook: EV_NOTEBOOK} l_ref.value.target then
					if {l_ref2: GUI_SCRIPT_VARIABLE_REFERENCE} arguments.item (2) then
						l_ref2.evaluate (a_env)
						if l_ref2.is_error then
							set_error (l_ref2.last_error_message)
						elseif {l_widget: EV_WIDGET} l_ref2.value.target then
							if l_notebook.has (l_widget) then
								l_notebook.select_item (l_widget)
							else
								set_error ("Notebook does not contain referenced widget")
							end
						else
							set_error ("Second variable reference passed to select_item did not reference an EV_WIDGET")
						end
					else
						set_error ("Select_item only accepts a variable reference to an EV_WIDGET as second argument")
					end
				else
					set_error ("First variable reference passed to select_item did not reference an EV_NOTEBOOK")
				end
			else
				set_error ("Select_item only accepts a variable reference to an EV_NOTEBOOK as first argument")
			end
		end

end
