indexing

	description: "[
     Commands that select a row of an RP_DATA_GRID in GUI testing script language.

     The command takes two arguments:

     The first is a GUI_SCRIPT_VARIABLE_REFERENCE to the grid whose row is
      to be selected.
     The second is a GUI_SCRIPT_INTEGER of the index of the row to be selected.
                ]"

	author: "Colin Adams"
	last_editor: "$Author: c4 $"
	date: "$Date: 2010/04/26 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/infrastructure/framework/gui/script_interpreter/gui_script_select_row.e $"

class GUI_SCRIPT_SELECT_ROW

inherit

	GUI_SCRIPT_COMMAND
		redefine
			execute
		end

create

	make

feature -- Basic operations
	
	execute (a_env: GUI_SCRIPT_ENVIRONMENT) is
			-- Execute `Current'.
		do
			if arguments.count /= 2 then
				set_error ("Select_row requires precisely two arguments")
			elseif attached {GUI_SCRIPT_VARIABLE_REFERENCE} arguments.item (1) as l_ref then
				l_ref.evaluate (a_env)
				if l_ref.is_error then
					set_error (l_ref.last_error_message)
				elseif attached {RP_DATA_GRID [ANY]} l_ref.value.target as l_grid then
					if attached {GUI_SCRIPT_INTEGER} arguments.item (2) as l_integer then
						l_grid.select_row (l_integer.value.item)
					else
						set_error ("Select_row only accepts an integer as its second argument")
					end
				else
					set_error ("Variable reference passed to select_row did not reference an RP_DATA_GRID")
				end
			else
				set_error ("Select_row only accepts a variable reference to an RP_DATA_GRID as its first argument")
			end
		end

end
