indexing

	description: "Commands that set the position of an EV_SPLIT_AREA slider in GUI testing script language"

	author: "Colin Adams"
	last_editor: "$Author: zs $"
	date: "$Date: 2010/03/05 $"
	revision: "$Revision: #2 $"
	path: "$File: //rose/source/kernel/infrastructure/framework/gui/script_interpreter/gui_script_set_proportion.e $"

class GUI_SCRIPT_SET_PROPORTION

inherit

	GUI_SCRIPT_COMMAND
		redefine
			execute
		end

create

	make

feature -- Basic operations

	execute (a_env: GUI_SCRIPT_ENVIRONMENT) is
			-- Execute `Current'.
		do
			if arguments.count /= 2 then
				set_error ("Set_proportion requires precisely two arguments")
			elseif {l_ref: GUI_SCRIPT_VARIABLE_REFERENCE} arguments.item (1) then
				l_ref.evaluate (a_env)
				if l_ref.is_error then
					set_error (l_ref.last_error_message)
				elseif {l_target: EV_SPLIT_AREA} l_ref.value.target then
					if {l_ref2: GUI_SCRIPT_DOUBLE} arguments.item (2) then
						l_target.set_proportion (l_ref2.value.item.truncated_to_real)
					else
						set_error ("Set_proportion only accepts a double as second argument")
					end
				else
					set_error ("First variable reference passed to set_proportion did not reference an EV_SPLIT_AREA")
				end
			else
				set_error ("Set_proportion only accepts a variable reference to an EV_SPLIT_AREA as first argument")
			end
		end

end
