indexing

	description: "Commands that cause a grid column to be sorted"

	author: "Colin Adams"
	last_editor: "$Author: c4 $"
	date: "$Date: 2009/06/15 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/infrastructure/framework/gui/script_interpreter/gui_script_sort_grid_column.e $"

class GUI_SCRIPT_SORT_GRID_COLUMN

inherit

	GUI_SCRIPT_COMMAND
		redefine
			execute
		end

create

	make

feature -- Basic operations
	
	execute (a_env: GUI_SCRIPT_ENVIRONMENT) is
			-- Execute `Current'.
		local
			l_column, l_mouse_button: INTEGER
		do
			if arguments.count /= 3 then
				set_error ("Sort_grid_column requires precisely one argument")
			elseif {l_ref: GUI_SCRIPT_VARIABLE_REFERENCE} arguments.item (1) then
				l_ref.evaluate (a_env)
				if l_ref.is_error then
					set_error (l_ref.last_error_message)
				elseif {l_grid: RP_DATA_GRID [ANY]} l_ref.value.target then
					if {l_col: GUI_SCRIPT_INTEGER} arguments.item (2) then
						l_column := l_col.value.item
						if {l_button: GUI_SCRIPT_INTEGER} arguments.item (3) then
							l_mouse_button := l_button.value.item
							l_grid.header_node.sort_state_agent.call ([l_column, l_mouse_button])
						else
							set_error ("Sort_grid_column requires an integer as its third argument")
						end
					else
						set_error ("Sort_grid_column requires an integer as its second argument")
					end
				else
					set_error ("Variable reference passed to sort_grid_column did not reference an RP_DATA_GRID [ANY]")
				end
			else
				set_error ("Sort_grid_column requires a variable reference to an RP_DATA_GRID as its first argument")
			end
		end

end
