indexing

	description: "References to global variables in GUI testing script language"

	author: "Colin Adams"
	last_editor: "$Author: c4 $"
	date: "$Date: 2009/05/20 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/infrastructure/framework/gui/script_interpreter/gui_script_variable_reference.e $"

class GUI_SCRIPT_VARIABLE_REFERENCE

inherit

	GUI_SCRIPT_VALUE
		redefine
			value
		end

create

	make

feature {NONE} -- Initialization

	make (a_name: like name) is
			-- Initialize `Current'.
		require
			a_name_not_void: a_name /= Void
		do
			name := a_name
		ensure
			name_set: name = a_name
		end

feature -- Access

	name: STRING
			-- Name of variable

	value: GUI_SCRIPT_TARGET
			-- Widget referenced by `Current'

feature -- Basic operations
	
	evaluate (a_env: GUI_SCRIPT_ENVIRONMENT) is
			-- <Precursor>.
		do
			if a_env.has (name) then
				value := a_env.value (name)
			else
				set_error ("No binding for variable: " + name)
			end
		end

invariant

	name_not_void: name /= Void

end
