indexing

	description: "Commands that wait for a sepcified number of seconds in GUI testing script language"

	author: "Colin Adams"
	last_editor: "$Author: c4 $"
	date: "$Date: 2009/05/20 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/infrastructure/framework/gui/script_interpreter/gui_script_wait.e $"

class GUI_SCRIPT_WAIT

inherit

	GUI_SCRIPT_COMMAND
		redefine
			execute
		end

	ROSE_EXECUTION_ENVIRONMENT
		export {NONE} all end

create

	make

feature -- Basic operations
	
	execute (a_env: GUI_SCRIPT_ENVIRONMENT) is
			-- Execute `Current'.
		local
			l_seconds: INTEGER
		do
			if arguments.count /= 1 then
				set_error ("Wait requires exactly one argument (an integral number of seconds).")
			else
				if {l_integer: GUI_SCRIPT_INTEGER} arguments.item (1) then
					l_seconds := l_integer.value.item
					if l_seconds > 0 then
						sleep (l_seconds * 1_000)
					else
						set_error ("The argument for wait must be an integer.")
					end
				else
					set_error ("The argument for wait must be an integer.")
				end
			end
		end

end
