indexing

	description: "Functions that return the first window whose name starts with supplied argument in GUI testing script language"

	author: "Colin Adams"
	last_editor: "$Author: c4 $"
	date: "$Date: 2009/05/20 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/infrastructure/framework/gui/script_interpreter/gui_script_window_name_starting_with.e $"

class GUI_SCRIPT_WINDOW_NAME_STARTING_WITH

inherit

	GUI_SCRIPT_FUNCTION_CALL
		redefine
			copy_arguments
		end

create

	make

feature {NONE} -- Initialization

	make is
			-- Initialize `Current'.
		do
			name := "window_name_starting_with"
			function_agent := agent named_window
		end

feature -- Setting

	copy_arguments is
			-- Set values from `arguments' into `function_agent'.
		do
			if arguments.count = 1 then
				if {l_string: GUI_SCRIPT_STRING} arguments.item (1) then
					function_agent.set_operands ([l_string.value])
				else
					set_error ("Argument to window_name_starting_with must be a string.")
				end
			else
				set_error ("Window_name_starting_with requires precisely one argument.")
			end
		end
	
feature {NONE} -- Implementation

	named_window (a_prefix: STRING): GUI_SCRIPT_TARGET is
			-- First window whose title starts with `a_prefix'
		local
			l_windows: LINEAR [EV_WINDOW]
			l_window: EV_WINDOW
		do
			l_windows := environment.application.windows
			from
				l_windows.start
			until
				l_windows.after
			loop
				l_window := l_windows.item_for_iteration
				if l_window.title.is_valid_as_string_8 and then l_window.title.as_string_8.starts_with (a_prefix) then
					create Result.make (l_window)
					l_windows.finish
				end
				l_windows.forth
			end	
		end

end

	
