indexing
	description: "The matrix A|B"
	author: "Mark Howard"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #6 $"

class
	HORIZONTALLY_COMBINED_MATRIX
inherit
	ABSTRACT_READABLE_MATRIX
	redefine
		xtx
	end

create
	make, test
feature
	make (a_first : like first;a_second : like second) is
		require
			heights_match : a_first.height = a_second.height
		do
			first := a_first
			second := a_second
			height := first.height
			width := first.width + second.width
		end
	first : ABSTRACT_READABLE_MATRIX
	second : ABSTRACT_READABLE_MATRIX
	height : INTEGER
	width : INTEGER
	item alias "[]" (i,j : INTEGER) : DOUBLE is
		do
			if j <= first.width then
				Result := first [i,j]
			else
				Result := second [i,j - first.width]
			end
		end

feature
	xtx : SYMMETRIC_MATRIX is
		local
			l_x1tx1, l_x2tx2 : SYMMETRIC_MATRIX
			l_x1tx2 : MATRIX
		do
			create Result.make(width)
			l_x1tx1 := first.xtx
			l_x2tx2 := second.xtx
			l_x1tx2 := first.transpose_product(second)
			Result.put_symmetric_matrix(l_x1tx1, 1)
			Result.put_symmetric_matrix(l_x2tx2, first.width + 1)
			Result.put_matrix(l_x1tx2, 1, first.width + 1)
		end

	test is
		local
			l_m1, l_m2 : MATRIX
			l_cm : like Current
			l_xtx1, l_xtx2 : like xtx
		do
			create l_m1.make_from_array(<<<<1, 2>>,<<1, 2>>, <<1, 2>>>>)
			create l_m2.make_from_array(<<<<3>>,<<3>>, <<3>>>>)
			create l_cm.make(l_m1, l_m2)
			l_xtx1 := l_cm.xtx
			create l_xtx2.make_xtx(l_cm)
		end

end -- class COMBINED_MATRIX
