indexing
	description: "IDC Currency access"
	author: "Bruno Pradal"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #2 $"
	archive: "$File: //rose/source/kernel/market/idc_currency_market.e $"

class
	
	IDC_CURRENCY_MARKET
	
inherit
	
	SIGNATURE_TAGGED_CURRENCY_MARKET
	
	DOUBLE_MATH
		undefine
			is_equal
		end
	
feature
	
	source: STRING is "IDC"

	base_currency (a_date: ROSE_DATE): CURRENCY is
		once
			Result:=context.usd
		end

	is_valid_record (a_record: ROSE_VIRTUAL_RECORD[FOREX_SIGNATURE]) : BOOLEAN is
		do
			Result := a_record /= Void and then a_record.signature.bid > 0
		end

	actual_rate (a_record: ROSE_VIRTUAL_RECORD[FOREX_SIGNATURE]): DOUBLE is
		do
			if a_record.signature.ask > 0 then
				Result := 1 / sqrt(a_record.signature.bid * a_record.signature.ask)
			else
				Result := 1 / a_record.signature.bid
			end
		end

end


