indexing
	description: "EVENT_<Z>_A:EXCLUDING_RIGHTS_<Z>.PARM"

--     BRIMSYMBOL         EX-DATE    CLICODE            Description                Amount Raised per share  Paydate
-- ------------------    --------    --------    --------------------------------  -----------------------  --------	
-- 12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123
--          1         2         3         4         5         6         7         8         9        10        11

-- The Amount Raised and Pay date columns are present only for E zone Excluding

	author: "Portfolio Accounting Tech"
	last_editor: "$Author: it $"
	date: "$Date: 2009/10/08 $"
	revision: "$Revision: #3 $"
	archive: "$File: //rose/source/kernel/capital_actions/elections/including_excluding_rights_parm_file.e $"

class
	INCLUDING_EXCLUDING_RIGHTS_PARM_FILE

inherit
	ROSE_FORMATTED_TEXT_FILE [INCLUDING_EXCLUDING_RIGHTS_PARM_RECORD]

create
	make

feature -- Basic Operations

	parse is
			-- Parse file
		local
			l_format: ROSE_ROBUST_FIXED_FORMAT
		do
			if not parse_extra_columns then
				create l_format.make (<<
					[constants.string_type,          "brimsym",   1,  18],
					[constants.integer_32_type,      "ex_date",  23,  30],
					[constants.string_type,          "clicode",  35,  42],
					[constants.string_type,      "description",  47,  78]>>)
			else
				create l_format.make (<<
						[constants.string_type,              "brimsym",    1,   18],
						[constants.integer_32_type,          "ex_date",   23,   30],
						[constants.string_type,              "clicode",   35,   42],
						[constants.string_type,          "description",   47,   78],
						[constants.double_type, "cash_raise_per_share",   81,  103],
						[constants.integer_32_type,          "paydate",  106,  113]>>
						)
			end
			read_with_header_rows (name, l_format, 2)
		end

feature -- Access

	parse_extra_columns: BOOLEAN
		-- Should we try to parse "Amount raised per share", and "pay_date"
		-- on top of "brimsymbol", "ex-date", "clicode" and "description"

feature -- Status Setting

	set_parse_extra_columns is
			-- Set flag indicating the 'cash_raise_per_share' and 'paydate' columns should be parsed as well
		do
			parse_extra_columns := true
		ensure
			parse_extra_columns: parse_extra_columns
		end

feature {NONE} -- Implementation

	constants: ROSE_CONSTANT_VALUES is
			-- Constants, including basic types
		once
			create Result
		end

end
