indexing
	description: "Line in the EVENT_<Z>_A:EXCLUDING_RIGHTS_<Z>.PARM or EVENT_<Z>_A:INCLUDING_RIGHTS_<Z>.PARM file"
	author: ""
	last_editor: "$Author: sm $"
	date: "$Date: 2009/10/06 $"
	revision: "$Revision: #1 $"
	archive: "$File: //rose/source/kernel/capital_actions/elections/including_excluding_rights_parm_record.e $"

class
	INCLUDING_EXCLUDING_RIGHTS_PARM_RECORD

create
	default_create, make


feature {NONE} -- Initilization

	make (a_brimsym: like brimsym; a_ex_date: like ex_date; a_clicode: like clicode; a_description: like description; a_cash_raised_per_share: like cash_raised_per_share; a_pay_date: like pay_date) is
			-- Create with instrument, ex_date, portfolio
		require
			brimsym_not_void_or_empty: (a_brimsym /= Void) and then (not a_brimsym.is_empty)
			clicode_not_void_or_empty: (a_clicode /= Void) and then (not a_clicode.is_empty)
		do
			brimsym := a_brimsym
			ex_date := a_ex_date
			clicode := a_clicode
			description := a_description
			cash_raised_per_share := a_cash_raised_per_share
			pay_date := a_pay_date
		ensure
			brimsym_set: brimsym = a_brimsym
			ex_date_set: ex_date = a_ex_date
			clicode_set: clicode = a_clicode
			description_set: description = a_description
			cash_raised_per_share_set: cash_raised_per_share = a_cash_raised_per_share
			pay_date_set: pay_date = a_pay_date
		end

feature -- Access

	brimsym: STRING
		-- Brimsym

	ex_date: INTEGER
		-- Ex Date

	clicode: STRING
		-- Portfolio code

	description: STRING
		-- Description

	cash_raised_per_share: DOUBLE
		-- Amount of cash raised per share

	pay_date: INTEGER
		-- Payment date

end
