note

	description:

		"Index exchange rate record"

	author: "Mauricio Bustos"
	last_editor: "$Author: er $"
	date: "$Date: 2014/01/03 $"
	revision: "$Revision: #11 $"
	path: "$File: //rose/source/kernel/data/supplier_data/index_xrate_expression.e $"

class

	INDEX_XRATE_EXPRESSION

inherit

	DOUBLE_VALUED_EXPRESSION[XRATE_DATA_SIGNATURE]
		redefine
			double_value,
			value_in_market_currency,
			currency
		end
	ROSE_IEEE_UNDEFINED
		undefine default_create end

create

	make,
	default_create

feature  --Access

	value_in_market_currency(a_market : MARKET;a_currency : PERSISTENT_CURRENCY; a_target : XRATE_DATA_SIGNATURE; a_date : ROSE_DATE) : DOUBLE is
			--value in specific currency
		do
		end

	double_value(a_target : XRATE_DATA_SIGNATURE) : DOUBLE is
			-- <Precursor>
		local
			l_records : ROSE_LINEAR_ARRAY[ROSE_VIRTUAL_RECORD[XRATE_DATA_SIGNATURE]]
			l_cache : HASH_TABLE[ROSE_VIRTUAL_RECORD[XRATE_DATA_SIGNATURE],ROSE_DATE]
		do
			Result := ieee_math.qnan
			if a_target.data_manager /= Void then
				cache.search(a_target.entity)
				if not cache.found then
					l_records := a_target.records(<<a_target>>,"#target_entity_id.id = target_entity_id")
					create l_cache.make(100)
					from l_records.start until l_records.after loop
						l_cache.force(l_records.current_item.twin,create {ROSE_DATE}.make_ccyymmdd(l_records.current_item.signature.data_date.ccyymmdd))
						l_records.forth
					end
					cache.force(l_cache,a_target.entity)
				else
					l_cache := cache.found_item
				end
				if l_cache /= Void then
					l_cache.search(a_target.date)
					if l_cache.found then
						Result := l_cache.found_item.signature.spot_rate
					end
				end
			end
		end

	at (a_target : like expression_target) : DOUBLE is
		do
			Result := double_value(a_target)
		end

	currency(a_target : XRATE_DATA_SIGNATURE) : PERSISTENT_CURRENCY is
		do
		end

feature {NONE} -- Cache

	cache : HASH_TABLE[HASH_TABLE[ROSE_VIRTUAL_RECORD[XRATE_DATA_SIGNATURE],ROSE_DATE],ENTITY] is
			-- Cache for computed values
		once
			create Result.make(10)
		end

end



















