note

	description:

		"primitive industry object"

	keywords: "industry"
	author: "Mark Howard"
	last_editor: "$Author: er $"
	date: "$Date: 2013/06/18 $"
	revision: "$Revision: #33 $"
	path: "$File: //rose/source/kernel/investment_entities/industry.e $"
	storable_version: ""

class
	INDUSTRY

inherit
	INVESTMENT_ENTITY
		undefine
			name_identifier_key
		end
	PERSISTENT_INDUSTRY
		undefine
			context,
			make,
			make_context,
			name_identifier_key,
			debug_output
		end
create
	make,make_anonymous

feature -- Basic operation

	industry_id: INTEGER
	description : STRING is
			-- Industry description
		do
			Result := name_at(today)
		end
	register is
			-- Register this entity.
		local
			l_id : STRING
		do
			l_id := attribute_by_name ("OLD POSITIONAL ID", today)
			if l_id /= Void and then l_id.is_integer then
				industry_id := l_id.to_integer
			end
			name := description
		end
	name : STRING
	name_identifier_key : STRING 
			--Name of the identifier which names this entity
		once
			Result := "name"
		end

	similars : like industry_to_similars_group_history is
			-- Similars related to this industry
		do
			if similars_saved = Void then
				similars_saved := industry_to_similars_group_history
			end
			Result := similars_saved
		end

	sector : like context.sector_template is
			-- sector
		local
			l_similars_group : like context.similars_group_template
		do
			if sector_saved = Void then
				l_similars_group := something_related_by_industry_to_similars_group
				if l_similars_group /= Void then
					sector_saved := l_similars_group.something_corelated_by_sector_to_similars_group
				end
			end
			Result := sector_saved
		end

	economic_sector(a_group_name : STRING; a_date : ROSE_DATE) : like context.economic_sector_template is
			-- economic sector
		require
			valid_group_name : a_group_name /= Void
		local
			l_similars_group : like context.similars_group_template
		do
			l_similars_group := something_related_by_industry_to_similars_group
			if l_similars_group /= Void then
				Result := l_similars_group.economic_sector(a_group_name, a_date)
			end
		end

	max_industry_id: INTEGER is
			-- max value of old positional id for all industry entities
		local
			i: INTEGER
			l_industries: ROSE_LINEAR_ARRAY [like Current]
		once
			l_industries := handler.all_entities
			from i := l_industries.lower
			until i > l_industries.upper
			loop
				Result := Result.max (l_industries.item (i).industry_id)
				i := i + 1
			end
		end

feature {NONE} -- Implementation

	similars_saved : like industry_to_similars_group_history
	sector_saved : like context.sector_template

end -- class INDUSTRY
