note

	description:

		"The matrix U|A where U is a unit column and A is the input matrix"

	author: "Mark Howard"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/08/20 $"
	revision: "$Revision: #7 $"
	path: "$File: //rose/source/kernel/infrastructure/math/intercept_matrix.e $"

class
	INTERCEPT_MATRIX
inherit
	ABSTRACT_MATRIX
		rename
			make as abstract_matrix_make
		end

create
	make

feature {NONE}  --Creation

	make (a_matrix : MATRIX) is
			--Creation
		local
			l_names: ROSE_LINEAR_ARRAY[STRING]
			l_input_names: ROSE_LINEAR_ARRAY[STRING]
		do
			create l_names.make_from_array(<<"constant">>)
			if a_matrix.column_names /= void then
				create l_input_names.make_from_array(a_matrix.column_names)
			end
			matrix := a_matrix
			if l_input_names /= void then
				l_names.append_array (l_input_names)
				set_column_names(l_names)
			end
			width := matrix.width + 1
			height := matrix.height
		end

	abstract_matrix_make(a_height,a_width : INTEGER)
				--make empty
			do
				create matrix.make (a_height, a_width-1)
				make(matrix)
			end

feature --Access

	item alias "[]" (i,j : INTEGER) : DOUBLE is
		do
			if j = 1 then
				Result := 1
			else
				Result := matrix.item(i,j - 1)
			end
		end

	width : INTEGER
	height : INTEGER

feature --Update

	put(a_value : DOUBLE;i,j : INTEGER)
			--set the ith row, j-1 th column to a_value
		do
			matrix[i,j-1] := a_value
		end

feature {NONE} --Implementation

	matrix : MATRIX

end -- class INTERCEPT_MATRIX
