indexing
	description: "This parm file controls if a dividend is coded as a TXN 31 (vs 9 or 33)"
-- !  Dates are on a Settlement (Pay) date basis, start/end dates are inclusive
-- !
-- !         Non special dividend          ROC sweep
-- !                period                  period
-- !Clicode   STARTING  ENDING        STARTING  ENDING
-- !2345678***12345678**12345678******12345678**12345678
-- !-------   --------  --------      --------  --------
-- PIPE       20000501  99999999      20000501  20050531
-- BENTLEY    20001218  99999999      20001218  20050531
-- 1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890
--          1         2         3         4         5         6         7         8         9        10        11        12        13        14        15        16        17        18        19        20        21        22        23        24        25

	author: "Portfolio Accounting Tech (sm)"
	last_editor: "$Author: sm $"
	date: "$Date: 2009/10/30 $"
	revision: "$Revision: #1 $"
	archive: "$File: //rose/source/kernel/capital_actions/elections/invest_w_a_swept_accounts_parm_file.e $"

class
	INVEST_W_A_SWEPT_ACCOUNTS_PARM_FILE

inherit
	ROSE_ROBUST_FIXED_FORMATTED_TEXT_FILE [INVEST_W_A_SWEPT_ACCOUNTS_PARM_RECORD]

create
	make

feature -- Access

	format: ROSE_ROBUST_FIXED_FORMAT
			-- <Precursor>
		once
			create Result.make (<<
				[constants.string_type,               "clicode",   1,  8],
				[constants.integer_type, "non_special_starting",  12, 19],
				[constants.integer_type,   "non_special_ending", 22 , 29],
				[constants.integer_type,   "roc_sweep_starting", 36 , 43],
				[constants.integer_type,     "roc_sweep_ending", 46 , 53] >>)
		end

	header_lines_count: INTEGER is 8
		-- <Precursor>

end
