note

	description:

		"Line in the INVEST_W_A:SWEPT_ACCOUNTS.PARM file"

	author: "Sami Ben-Grine"
	last_editor: "$Author: it $"
	date: "$Date: 2011/03/04 $"
	revision: "$Revision: #4 $"
	path: "$File: //rose/source/kernel/capital_actions/elections/invest_w_a_swept_accounts_parm_record.e $"

class INVEST_W_A_SWEPT_ACCOUNTS_PARM_RECORD

inherit

	RP_PORTFOLIO_PARM_RECORD

feature -- Access

	non_special_starting: INTEGER
			-- Start date for non-special dividends (ccyymmdd)

	non_special_ending: INTEGER
			-- End date for non-special dividends (ccyymmdd)

	roc_sweep_starting: INTEGER
			-- Start date for swept ROC (ccyymmdd)

	roc_sweep_ending: INTEGER
			-- End date for swept ROC (ccyymmdd)

feature -- Status

	is_valid: BOOLEAN is
			-- <Precursor>
		do
			Result := string_not_void_or_empty (clicode)
			Result := Result and valid_ccyymmdd (non_special_starting) and valid_ccyymmdd (non_special_ending)
			Result := Result and non_special_starting <= non_special_ending
		ensure then
			valid_ordinary_dividend_sweep_dates: Result implies valid_ccyymmdd (non_special_starting) and valid_ccyymmdd (non_special_ending)
			ordinary_dividend_sweep_start_le_end: Result implies non_special_starting <= non_special_ending
		end

end
