note

	description:

		"persistent object for investment_region"

	keywords: "zone,entity,persistent"
	author: "Mark Howard"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #36 $"
	path: "$File: //rose/source/kernel/investment_entities/investment_region.e $"

class INVESTMENT_REGION
inherit
   INVESTMENT_ENTITY
   		redefine
   			zone
		end
	PERSISTENT_INVESTMENT_REGION
		undefine
			context,
			make,
			make_context,
			debug_output
		end
create
	make,make_anonymous

feature -- Miscellaneous

	register is
			-- Register this entity.
		local
			l_index, l_mnemonic_key: STRING
		do
			l_index := old_positional_id_key (Void)
			if l_index /= Void and then l_index.is_integer then
				index := l_index.to_integer
			end

			l_mnemonic_key := mnemonic_key (Void)
			if l_mnemonic_key /= Void then
				mnemonic := l_mnemonic_key.item(1)
			end

			name := name_key (Void)
		end

	zone : like context.zone_template is
		-- returns the zone by its mnemonic
	do
		Result := zone_by_mnemonic(mnemonic)
	end


	index : INTEGER
	set_index(a_value : like index) is
		-- set `index' to `a_value'
	do
		index := a_value
	end

	mnemonic : CHARACTER
	set_mnemonic(a_value : like mnemonic) is
		-- Set mnemonic
	do
		mnemonic := a_value
	end

	name : STRING

	set_name(a_value : like name) is
			-- Assign `a_value' to `name'.
		do
			name := a_value
		ensure
			name_set: name = a_value
		end

	rose_id : INTEGER
	set_rose_id(a_value : like rose_id) is
	do
		rose_id := a_value
	end

	entry_date : ROSE_DATE
	set_entry_date(a_value : like entry_date) is
	do
		entry_date := a_value
	end

	entry_author : STRING
	set_entry_author(a_value : like entry_author) is
	do
		entry_author := a_value
	end

	entry_replaced_date : ROSE_DATE
	set_entry_replaced_date(a_value : like entry_replaced_date) is
	do
		entry_replaced_date := a_value
	end

	comment : STRING
	set_comment(a_value : like comment) is
			--Comment setter
		do
			comment := a_value
		end

feature -- Access

	estimation_population(a_date : ROSE_DATE) : like context.estimation_population_template	is
		local
			l_history : like investment_region_to_estimation_population_history
		do
			l_history := investment_region_to_estimation_population_history
			if l_history /= Void then
				Result := l_history.witness(a_date)
			end
		end
end
