note

	description:

		"Listing holding"

	author: "mz"
	last_editor: "$Author: c4 $"
	date: "$Date: 2014/05/13 $"
	revision: "$Revision: #11 $"
	path: "$File: //rose/source/kernel/investment_entities/listing_holding.e $"

class LISTING_HOLDING

inherit

	HOLDING_INTERVAL [LISTING]

	ROSE_ACCESS
		export {NONE} all end

create

	make,
	make_from_record

feature {NONE} -- Initialization

	make_from_record(a_record : HOLDINGS_RECORD) is
			-- Initialize `Current' from `a_record'
		require
			a_record_not_void: a_record /= Void
			a_record_instrument_not_void: a_record.instrument /= Void
			a_record_exchange_not_void: a_record.exchange /= Void
		local
			l_brimsym : STRING
		do
			l_brimsym := a_record.instrument + a_record.exchange
			l_brimsym.to_upper
			entity := context.listing_by_brim_code(l_brimsym, a_record.applicable_from)
			if entity = Void then
				entity := context.listing_by_brim_code(l_brimsym, a_record.applicable_to)
			end
			make (entity, a_record.applicable_from, a_record.applicable_to, a_record.units)
			price := a_record.price
			if a_record.currency = Void and entity /= Void then
				currency := entity.currency (a_record.applicable_from)
			elseif a_record.currency /= Void then
				currency := context.currency_by_iso_code(a_record.currency, a_record.applicable_from)
			end
		end

feature -- Access

	price : DOUBLE
		-- Price

	currency : CURRENCY
		-- Currency of `price'

end
