indexing
	description: "Pointer to an INTEGER to pass on to C externals"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #4 $"
	archive: "$File: //rose/source/kernel/infrastructure/support/managed_integer.e $"

class
	MANAGED_INTEGER

inherit
	PLATFORM
		export
			{NONE} all
		redefine
			default_create
		end
	DEBUG_OUTPUT
		redefine
			default_create
		end

create
	default_create, set

convert
	set ({INTEGER}),
	value: {INTEGER},
	item: {POINTER}

feature {NONE} -- Initialization

	default_create is
		do
			create managed_pointer.make (integer_32_bytes)
		end

feature -- Access

	managed_pointer: MANAGED_POINTER
			-- Managed pointer to INTEGER

	value: INTEGER is
			-- INTEGER value pointed to
		do
			Result := managed_pointer.read_integer_32 (0)
		end

	item: POINTER is
			-- C pointer
		do
			Result := managed_pointer.item
		end

	debug_output: STRING is
		do
			Result := value.out
		end

feature -- Basic operations

	set (a_value: INTEGER) is
		do
			if managed_pointer = Void then
				default_create
			end
			managed_pointer.put_integer_32 (a_value, 0)
		end

end
