indexing
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #7 $"

class
	MAPPABLE_PARTITION_TREE[G -> COMPARABLE, H -> COMPARABLE]

inherit
	PARTITION_TREE[G, H]
		rename
			make as old_make,
			path as actual_path,
			leaf_record as actual_leaf_record,
			key_0_paths as actual_key_0_paths,
			key_1_paths as actual_key_1_paths,
			key_0_leaves as actual_key_0_leaves,
			key_1_leaves as actual_key_1_leaves
		end
	PARTITION_TREE[G, H]
		rename
			make as old_make
		redefine
			path,
			leaf_record,
			key_0_paths,
			key_1_paths,
			key_0_leaves,
			key_1_leaves
		select
			path,
			leaf_record,
			key_0_paths,
			key_1_paths,
			key_0_leaves,
			key_1_leaves
		end
	ACCESS_EXTERNALS

create
	make

feature

	make (a_map_0:HASH_TABLE[G, INTEGER]; a_map_1:HASH_TABLE[H, INTEGER];
		  a_item: PARTITION_TREE_RECORD[G,H]) is
		do
			key_0_map := a_map_0
			key_1_map := a_map_1
			old_make(a_item)
		end

	path(a_key_0: G; a_key_1: H): INTEGER is
		do
			Result := actual_path(translate_0(a_key_0), translate_1(a_key_1))
		end

	leaf_record(a_key_0: G; a_key_1: H): PARTITION_TREE_RECORD[G, H] is
		do
			Result := actual_leaf_record(translate_0(a_key_0), translate_1(a_key_1))
		end

	key_0_paths(a_key_0: G): ROSE_LINEAR_ARRAY[INTEGER] is
		do
			Result := actual_key_0_paths(translate_0(a_key_0))
		end

	key_1_paths(a_key_1: H): ROSE_LINEAR_ARRAY[INTEGER] is
		do
			Result := actual_key_1_paths(translate_1(a_key_1))
		end

	key_0_leaves(a_key_0: G): ROSE_LINEAR_ARRAY[PARTITION_TREE_RECORD[G, H]] is
		do
			Result := actual_key_0_leaves(translate_0(a_key_0))
		end

	key_1_leaves(a_key_1: H): ROSE_LINEAR_ARRAY[PARTITION_TREE_RECORD[G, H]] is
		do
			Result := actual_key_1_leaves(translate_1(a_key_1))
		end

feature {NONE}

	translate_0(a_key_0: G): G is
		local
			l_key_0 : INTEGER
			l_ref_0 : INTEGER_REF
		do
			if key_0_map /= Void then
				-- This is very bad.  The previous incarnation did a reverse assignment
				-- to an integer_ref.  The problem was that caused an inordinate amount of
				-- garbage collecting on VMS
				l_ref_0 ?= a_key_0
				if l_ref_0 /= void then
					l_key_0 := l_ref_0.item
				end
				Result := key_0_map.item(l_key_0)
				if Result = a_key_0.default then
					-- When key_0 is rxrf we generally map the rxrf to cxrf.  In order to have some expansion
					-- room for new (unmapped) rxrfs we return the rxrf if the cxrf is not found.  We tried
					-- very hard to make this use agents but we kept banging our heads against a brick wall.
					-- Currently the only user of this feature is 'market_data_z'.  Other users might need
					-- a different solution.  Lot's of luck!
					Result := a_key_0
				end
			else
				Result := a_key_0
			end
		end

	translate_1(a_key_1: H): H is
		local
			l_key: INTEGER_REF
		do
			if key_1_map /= Void then
				l_key ?= a_key_1
				Result := key_1_map.item(l_key.item)
			else
				Result := a_key_1
			end
		end

	key_0_map: HASH_TABLE[G, INTEGER]

	key_1_map: HASH_TABLE[H, INTEGER]

end
