note

	description:

		"Index market data"

	author: "Mauricio Bustos"
	last_editor: "$Author: mb $"
	date: "$Date: 2013/11/08 $"
	revision: "$Revision: #20 $"
	path: "$File: //rose/source/kernel/data/market/market_data_i.e $"

class MARKET_DATA_I

inherit

	MARKET_DATA_F_I
		redefine
			currency
		end

	ATTRIBUTES
		rename
			sedol as attributes_sedol,
			cusip as attributes_cusip,
			msci as attributes_msci,
			company_name as attributes_company_name
		end

create

	make

feature -- Access
	
	currency (a_rxrf: INTEGER; a_date: ROSE_DATE): CURRENCY is
			-- Currency for a_rxrf on a_date
		local
			l_market_index: MARKET_INDEX
			l_brimcode: STRING
			l_currency: CURRENCY
		do
			l_market_index := context.market_index_at (xrf_code (a_rxrf.out), a_date)
			if l_market_index /= Void then
				l_brimcode := l_market_index.brim_code_most_recent_key (a_date)
				l_currency := context.currency_by_iso_code (l_brimcode.substring (13, 15), Void)
				if l_currency /= Void then
					Result := l_currency
				end
			end
		end

	first_and_last: ARRAY [FIRST_AND_LAST] is
			-- First and last
		local
			l_ix_today, i, l_max_fxrf: INTEGER
			l_fl: FIRST_AND_LAST
			l_today: ROSE_DATE
		once
			l_max_fxrf := zone.max_market_index_xrf
			create l_today.make_today
			if l_today.rose_julian_day <= jul_indexes.upper then
				l_ix_today := jul_indexes.item (l_today.rose_julian_day)
			else
				l_ix_today := jul_indexes.item (jul_indexes.upper)
			end
			create l_fl.make (1, l_ix_today)
			create Result.make (1, l_max_fxrf)
			from
				i := 1
			until
				i > l_max_fxrf
			loop
				Result.put (l_fl, i)
				i := i + 1
			end
		end

end
