indexing
	description: "Abstraction of a memory model"
	author: "Pierre Nallet"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #6 $"

deferred class
	MEMORY_MODEL

feature -- Access

	id: INTEGER is
			-- Identification of this MEMORY_MODEL
		deferred
		end

	alloc (a_size: INTEGER): POINTER is
			-- Address of new allocated memory buffer with 'a_size' in bytes
		require
			valid_size: a_size > 0
		deferred
		end

feature -- Basic operations

	free (a_pointer: POINTER) is
			-- Free memory block pointed by 'a_pointer'.
		require
			valid_pointer: a_pointer /= default_pointer
		deferred
		end

end -- class MEMORY_MODEL
