note
	description: "Run PM test only if we have at least `minimum_runs' runs in the most recent instance"
	author: "Emmanuel Bouyer"
	last_editor: "$Author: e2 $"
	date: "$Date: 2014/04/08 $"
	revision: "$Revision: #2 $"
	path: "$File: //rose/source/kernel/pm/metric_test_condition_at_least.e $"

class
	METRIC_TEST_CONDITION_AT_LEAST

inherit
	METRIC_TEST_CONDITION

create
	make

feature {NONE} -- Initialization

	make (a_minimum_runs: INTEGER)
			-- Initialization for `Current'.
		require
			a_minimum_runs_positive: a_minimum_runs > 0
		do
			minimum_runs := a_minimum_runs
		ensure
			minimum_runs_set: minimum_runs = a_minimum_runs
		end

feature -- Access

	should_run_test (a_partition: PM_PROCESS_PARTITION): BOOLEAN
			-- Should we run the PM test?
		local
			l_runs: PM_INSTANCE_RUN_COLLECTION
		do
			l_runs := a_partition.most_recent_instance.runs
			Result := (l_runs.items.count - l_runs.in_progress.count) >= minimum_runs
		end

feature {NONE} -- Implementation

	minimum_runs: INTEGER
			-- Minimum number of runs for current instance

invariant
	minimum_runs_positive: minimum_runs > 0
end
