note
	description: "Run PM test only if we have exactly `number_of_runs' runs in the most recent instance"
	author: "Emmanuel Bouyer"
	last_editor: "$Author: e2 $"
	date: "$Date: 2014/04/08 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/pm/metric_test_condition_exactly.e $"

class
	METRIC_TEST_CONDITION_EXACTLY

inherit
	METRIC_TEST_CONDITION

create
	make

feature {NONE} -- Initialization

	make (a_number_of_runs: INTEGER)
			-- Initialization for `Current'.
		require
			a_number_of_runs_positive: a_number_of_runs > 0
		do
			number_of_runs := a_number_of_runs
		ensure
			number_of_runs_set: number_of_runs = a_number_of_runs
		end

feature -- Access

	should_run_test (a_partition: PM_PROCESS_PARTITION): BOOLEAN
			-- Should we run the PM test?
		local
			l_runs: PM_INSTANCE_RUN_COLLECTION
		do
			l_runs := a_partition.most_recent_instance.runs
			Result := (l_runs.items.count - l_runs.in_progress.count) = number_of_runs
		end

feature {NONE} -- Implementation

	number_of_runs: INTEGER
			-- Exact number of runs for current instance

invariant
	number_of_runs_positive: number_of_runs > 0
end
