note

	description: "[
		METRIC_TEST_RECORD
		
		Don't forget to add the feature `is_equal' back if you regenerate the class

		]"

	generator: "[
		Classifier -class_name="METRIC_TEST_RECORD"
	]"

	keywords: "classifier,database,record,generated"
	author: "Emmanuel Bouyer"
	last_editor: "$Author: e2 $"
	date: "$Date: 2014/04/08 $"
	revision: "$Revision: #3 $"
	path: "$File: //rose/source/kernel/pm/metric_test_record.e $"

class METRIC_TEST_RECORD

inherit

	IEEE_MATH
		export
			{NONE} all
		redefine
			is_equal
		end

	PREDICATE_RECORD
		redefine
			is_equal
		end

feature -- Access

	metric_type_id : INTEGER
			-- Database column `metric_type_id'

	metric_test_id : INTEGER
			-- Database column `metric_test_id'

	metric_test_version : INTEGER
			-- Database column `metric_test_version'

	partition : STRING
			-- Database column `partition'

	process : STRING
			-- Database column `process'

	user : STRING
			-- Database column `user'

	test_type : STRING
			-- Database column `test_type'

	condition : STRING
			-- Database column `condition'

	settings : STRING
			-- Database column `settings'

	name : STRING
			-- Database column `name'

	notify : STRING
			-- Database column `notify'

	enable_failure : INTEGER
			-- Database column `enable_failure'

	start_date : ROSE_DATE
			-- Database column `start_date'

	end_date : ROSE_DATE
			-- Database column `end_date'

	comments : STRING
			-- Database column `comments'

	use_sum: BOOLEAN
			-- Database column `use_sum'

feature -- Setting

	set_metric_type_id (a_value: like metric_type_id) is
			-- Set `metric_type_id' to `a_value'
		do
			metric_type_id := a_value
		ensure
			metric_type_id_assigned: metric_type_id = a_value
		end

	set_metric_test_id (a_value: like metric_test_id) is
			-- Set `metric_test_id' to `a_value'
		do
			metric_test_id := a_value
		ensure
			metric_test_id_assigned: metric_test_id = a_value
		end

	set_metric_test_version (a_value: like metric_test_version) is
			-- Set `metric_test_version' to `a_value'
		do
			metric_test_version := a_value
		ensure
			metric_test_version_assigned: metric_test_version = a_value
		end

	set_partition (a_value: like partition) is
			-- Set `partition' to `a_value'
		do
			partition := a_value
		ensure
			partition_assigned: partition = a_value
		end

	set_process (a_value: like process) is
			-- Set `process' to `a_value'
		do
			process := a_value
		ensure
			process_assigned: process = a_value
		end

	set_user (a_value: like user) is
			-- Set `user' to `a_value'
		do
			user := a_value
		ensure
			user_assigned: user = a_value
		end

	set_test_type (a_value: like test_type) is
			-- Set `test_type' to `a_value'
		do
			test_type := a_value
		ensure
			test_type_assigned: test_type = a_value
		end

	set_condition (a_value: like condition) is
			-- Set `condition' to `a_value'
		do
			condition := a_value
		ensure
			condition_assigned: condition = a_value
		end

	set_settings (a_value: like settings) is
			-- Set `settings' to `a_value'
		do
			settings := a_value
		ensure
			settings_assigned: settings = a_value
		end

	set_name (a_value: like name) is
			-- Set `name' to `a_value'
		do
			name := a_value
		ensure
			name_assigned: name = a_value
		end

	set_notify (a_value: like notify) is
			-- Set `notify' to `a_value'
		do
			notify := a_value
		ensure
			notify_assigned: notify = a_value
		end

	set_enable_failure (a_value: like enable_failure) is
			-- Set `enable_failure' to `a_value'
		do
			enable_failure := a_value
		ensure
			enable_failure_assigned: enable_failure = a_value
		end

	set_start_date (a_value: like start_date) is
			-- Set `start_date' to `a_value'
		do
			start_date := a_value
		ensure
			start_date_assigned: start_date = a_value
		end

	set_end_date (a_value: like end_date) is
			-- Set `end_date' to `a_value'
		do
			end_date := a_value
		ensure
			end_date_assigned: end_date = a_value
		end

	set_comments (a_value: like comments) is
			-- Set `comments' to `a_value'
		do
			comments := a_value
		ensure
			comments_assigned: comments = a_value
		end

	set_use_sum (a_value: like use_sum) is
			-- Set `use_sum' to `a_value'
		do
			use_sum := a_value
		ensure
			use_sum_assigned: use_sum = a_value
		end

feature {ANY} -- From PREDICATE_RECORD (read-only)

	statement_: STRING is "SELECT [metric_type_id],[metric_test_id],[metric_test_version],[partition],[process],[user],[test_type],[condition],[settings],[name],[notify],[enable_failure],[start_date],[end_date],[comments],[use_sum] FROM [dbo].[metric_test]"
			-- Selection statement for `Current'

	fields_: STRING is "metric_type_id,metric_test_id,metric_test_version,partition,process,user,test_type,condition,settings,name,notify,enable_failure,start_date,end_date,comments,use_sum"
			-- Fields in `Current'

feature {NONE} -- Not generated by the Classifier
-- Don't forget to add this feature back if you regenerate the class

	is_equal (a_other: like Current): BOOLEAN
			-- Is `Current' considered equal to `a_other'?
		do
			Result := metric_type_id ~ a_other.metric_type_id
			Result := Result and metric_test_id ~ a_other.metric_test_id
			Result := Result and metric_test_version ~ a_other.metric_test_version
			Result := Result and partition ~ a_other.partition
			Result := Result and process ~ a_other.process
			Result := Result and user ~ a_other.user
			Result := Result and test_type ~ a_other.test_type
			Result := Result and settings ~ a_other.settings
			Result := Result and name ~ a_other.name
			Result := Result and notify ~ a_other.notify
			Result := Result and enable_failure ~ a_other.enable_failure
			Result := Result and start_date ~ a_other.start_date
			Result := Result and end_date ~ a_other.end_date
			Result := Result and comments ~ a_other.comments
			Result := Result and condition ~ a_other.condition
			Result := Result and (use_sum = a_other.use_sum)
		end

end
