note

	description:

		"Representative for a mismatched unit"

	author: "Mark Howard"
	last_editor: "$Author: mk $"
	date: "$Date: 2013/06/04 $"
	revision: "$Revision: #9 $"
	path: "$File: //rose/source/kernel/math/mismatched_units.e $"

class
	MISMATCHED_UNITS

inherit
	RP_SERIALIZABLE
	ROSE_BASE_UNITS
		redefine
			has_matched_units,
			has_mismatched_units
		end

create
	make

feature -- Initialization

	make (a_left, a_right: ROSE_UNITS) 
			--Creation
		do
			name := "Mismatched Units ("
			if a_left = Void then
				name.append ("Void")
			else
				name.append (a_left.name)
			end
			name.append (",")
			if a_right = Void then
				name.append ("Void")
			else
				name.append (a_right.name)
			end
			name.append (")")
			create rational
			create scale.make(0,0)
			units_index_table.put (Current,0)
		end

	has_matched_units: BOOLEAN 
			-- Are we valid?
		do
			Result := False
		end

	has_mismatched_units: BOOLEAN 
			-- Are we invalid?  Perhaps should be not has_matched_units...don't remember original intent
		do
			Result := True
		end

end -- class MISMATCHED_UNITS
