indexing

	description: "MONTHLY_PERF_ROW"

	generator: "[
		Classifier -class_name="MONTHLY_PERF_ROW"
	]"

	keywords: "classifier,database,record,generated"
	last_editor: "$Author: it $"
	date: "$Date: 2013/07/17 $"
	revision: "$Revision: #5 $"
	path: "$File: //rose/source/Kernel/expert_system/perf/monthly_perf_row.e $"

class MONTHLY_PERF_ROW

inherit

	IEEE_MATH
		export {NONE} all end

	ANY

feature -- Access

	zone : STRING
			-- Database column `zone'

	portfolio : STRING
			-- Database column `portfolio'

	reporting_year : INTEGER
			-- Database column `reporting_year'

	reporting_month : INTEGER
			-- Database column `reporting_month'

	iso_fc : STRING
			-- Database column `iso_fc'

	fc_performance : DOUBLE
			-- Database column `fc_performance'

	fc_benchmark_performance : DOUBLE
			-- Database column `fc_benchmark_performance'

	fc_assetvalue : DOUBLE
			-- Database column `fc_assetvalue'

	partial_month: BOOLEAN
			-- Database column `partial_month'

	ccyymmdd: INTEGER
			-- Database column `ccyymmdd'

feature -- Output

	month: ROSE_MONTH is
			-- Month
		do
			create Result.make (reporting_year, reporting_month)
		ensure
			is_reporting_year_and_month: (Result.year = reporting_year) and (Result.month = reporting_month)
		end

feature -- Setting

	set_zone (a_value: like zone) is
			-- Set `zone' to `a_value'
		do
			zone := a_value
		ensure
			zone_assigned: zone = a_value
		end

	set_portfolio (a_value: like portfolio) is
			-- Set `portfolio' to `a_value'
		do
			portfolio := a_value
		ensure
			portfolio_assigned: portfolio = a_value
		end

	set_reporting_year (a_value: like reporting_year) is
			-- Set `reporting_year' to `a_value'
		do
			reporting_year := a_value
		ensure
			reporting_year_assigned: reporting_year = a_value
		end

	set_reporting_month (a_value: like reporting_month) is
			-- Set `reporting_month' to `a_value'
		do
			reporting_month := a_value
		ensure
			reporting_month_assigned: reporting_month = a_value
		end

	set_iso_fc (a_value: like iso_fc) is
			-- Set `iso_fc' to `a_value'
		do
			iso_fc := a_value
		ensure
			iso_fc_assigned: iso_fc = a_value
		end

	set_fc_performance (a_value: like fc_performance) is
			-- Set `fc_performance' to `a_value'
		do
			fc_performance := a_value
		ensure
			fc_performance_assigned_non_nan: not isnan (a_value) implies fc_performance = a_value
			fc_performance_assigned_nan: isnan (a_value) implies isnan (fc_performance)
		end

	set_fc_benchmark_performance (a_value: like fc_benchmark_performance) is
			-- Set `fc_benchmark_performance' to `a_value'
		do
			fc_benchmark_performance := a_value
		ensure
			fc_benchmark_performance_assigned_non_nan: not isnan (a_value) implies fc_benchmark_performance = a_value
			fc_benchmark_performance_assigned_nan: isnan (a_value) implies isnan (fc_benchmark_performance)
		end

	set_fc_assetvalue (a_value: like fc_assetvalue) is
			-- Set `fc_assetvalue' to `a_value'
		do
			fc_assetvalue := a_value
		ensure
			fc_assetvalue_assigned_non_nan: not isnan (a_value) implies fc_assetvalue = a_value
			fc_assetvalue_assigned_nan: isnan (a_value) implies isnan (fc_assetvalue)
		end
end
