indexing
	description: "The one and only MOVIE."
	author: "RJ"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #4 $"
	archive: "$File: //rose/source/kernel/infrastructure/movies/movie_aware.e $"

class
	MOVIE_AWARE

feature
	stop_movie is
	do
		movie.stop
	end

	start_movie_playback is
	do
		movie.make_playback
	end

	set_raise_if_after_for_sockets is
	do
		movie.set_raise_if_after_for_sockets
	end
	
	is_recording_movie: BOOLEAN is
			-- The caller may set the recording mode in one two ways:
			--	o Turn on the debug clause 'record_movie'.
			--	o Set the environment variable 'record_movie' to any value.
		local
			l_ee: EXECUTION_ENVIRONMENT
			l_env_var: STRING
		do
			debug("record_movie")
				Result := True
			end

			create l_ee
			l_env_var := l_ee.get("record_movie") 
			if l_env_var /= Void and then l_env_var.count > 0 then
				Result := True
			end
		end
		
	is_playing_movie: BOOLEAN is
			-- The caller may set 'l_playback_movie' in one two ways:
			--	o Turn on the debug clause 'playback_movie'.
			--	o Set the environment variable 'playback_movie' to any value.
		local
			l_ee: EXECUTION_ENVIRONMENT
			l_env_var: STRING
		do
			debug("playback_movie")
				Result := True
			end

			create l_ee
			l_env_var := l_ee.get("playback_movie") 
			if l_env_var /= Void and then l_env_var.count > 0 then
				Result := True
			end
		end
		
	movie: MOVIE is
	local
		l_record_movie: BOOLEAN
		l_playback_movie: BOOLEAN
	once
		debug("make_movies")
			l_record_movie := is_recording_movie
			l_playback_movie := is_playing_movie

			if l_record_movie and l_playback_movie
			then
				(create {EXCEPTIONS}).raise("Can't record and play movie at the same time.")
			end

			if l_record_movie
			then
				create Result.make_record
			elseif l_playback_movie
			then
				create Result.make_playback
			else
				create Result.make_none
			end
		end
	end

end
