indexing
	description: ""
	author: "RJ"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #3 $"
	archive: "$File: //rose/source/kernel/infrastructure/movies/movie_frame.e $"

class
	MOVIE_FRAME

feature
	set_camera_id(a_camera_id: INTEGER) is
	do
		camera_id := a_camera_id
	end

	set_frame_type_id(a_frame_type_id: INTEGER) is
	do
		frame_type_id := a_frame_type_id
	end

	set_sequence(a_sequence: INTEGER) is
	do
		sequence := a_sequence
	end

	set_frame_number(a_frame_number: INTEGER) is
	do
		frame_number := a_frame_number
	end

	set_time(a_time: ROSE_DATE) is
	do
		time := a_time
	end

	set_in_assertion(a_in_assertion: BOOLEAN) is
	do
		in_assertion := a_in_assertion
	end

	set_frame_data(a_frame_data: ANY) is
	do
		frame_data := a_frame_data
	end

	frame_data_as_boolean: BOOLEAN is
	local
		l_cell: CELL[BOOLEAN]
	do
		l_cell ?= frame_data
		if l_cell/=Void
		then
			Result := l_cell.item
		end
	end

	frame_data_as_integer: INTEGER is
	local
		l_cell: CELL[INTEGER]
	do
		l_cell ?= frame_data
		if l_cell/=Void
		then
			Result := l_cell.item
		end
	end

	frame_data_as_real: REAL is
	local
		l_cell: CELL[REAL]
	do
		l_cell ?= frame_data
		if l_cell/=Void
		then
			Result := l_cell.item
		end
	end

	frame_data_as_double: DOUBLE is
	local
		l_cell: CELL[DOUBLE]
	do
		l_cell ?= frame_data
		if l_cell/=Void
		then
			Result := l_cell.item
		end
	end

	frame_data_as_character: CHARACTER is
	local
		l_cell: CELL[CHARACTER]
	do
		l_cell ?= frame_data
		if l_cell/=Void
		then
			Result := l_cell.item
		end
	end

feature
	camera_id: INTEGER

	frame_data: ANY

	frame_number: INTEGER

	frame_size: INTEGER						-- This is not actually in the table.

	frame_type_id: INTEGER

	in_assertion: BOOLEAN

	playback_frame_size: INTEGER			-- This is not actually in the table.

	sequence: INTEGER

	sf: BOOLEAN

	time: ROSE_DATE

end
