indexing
	description: "A MANAGED_POINTER, but it uses a SPECIAL instead of a POINTER so it can be stored."
	author: "RJ"
	date: "$Date: 2010/03/10 $"
	revision: "$Revision: #4 $"
	archive: "$File: //rose/source/kernel/infrastructure/movies/movie_managed_pointer.e $"

class
	MOVIE_MANAGED_POINTER

inherit
	MANAGED_POINTER
		redefine
			dispose
		end

create
	make_from_managed_pointer

feature {NONE} -- Initialization

	make_from_managed_pointer (a_mp: MANAGED_POINTER) is
		local
			l_mp: MANAGED_POINTER
			l_pointer: POINTER
		do
			l_mp := Current	-- Cast Current as a MANAGED_POINTER.
			l_mp.copy (a_mp)
			-- Copy the data in the MANAGED_POINTER into our SPECIAL.
			create data.make_filled ('%U', a_mp.count)
			l_pointer := $data
			l_pointer.memory_copy (a_mp.item, a_mp.count)
			item := default_pointer	-- This is meaningless now.
		end

feature -- Access

	data: SPECIAL [CHARACTER]

feature -- Basic operations

	copy_to_managed_pointer(a_mp: MANAGED_POINTER) is
		do
			item := $data
			if a_mp.count /= data.count then
				(create {EXCEPTIONS}).raise ("Counts must match")
			end
			a_mp.copy (Current)
			item := default_pointer
		end

	dispose is
			-- Since we have set 'item' to NULL, we better not 'dispose'.
		do
		end

end
