indexing
	description: "A STREAM, but it uses a SPECIAL instead of a POINTER so it can be stored."
	author: "RJ"
	date: "$Date: 2010/03/10 $"
	revision: "$Revision: #6 $"
	archive: "$File: //rose/source/kernel/infrastructure/movies/movie_stream.e $"

class
	MOVIE_STREAM

inherit
	ROSE_STREAM
		redefine
			dispose
		end

create
	make_from_stream

feature {NONE} -- Initialization

	make_from_stream (a_stream: STREAM) is
		local
--			l_stream: STREAM
			l_rose_stream1: ROSE_STREAM
--			l_rose_stream2: ROSE_STREAM
			l_pointer: POINTER
		do
			--l_rose_stream1 ?= a_stream
			if l_rose_stream1 /= Void then
				-- It's a ROSE_STREAM (or a descendant, yikes!), copy it's attributes.
				--l_rose_stream2 := Current	-- Cast 'Current' as a ROSE_STREAM.
				--l_rose_stream2.copy(l_rose_stream1)
			else
				-- It's an ordinary STREAM, copy it's attributes.
				--l_stream := Current			-- Cast 'Current' as a STREAM.
				--l_stream.copy(a_stream)
				-- Extra attributes found only in ROSE_STREAM will be at their default values.
			end
			-- Copy the data in the STREAM into our SPECIAL.  It is assumed that 'object_stored_size'
			-- is the correct size since that is what the OLEDB classes use.
			create data.make_filled ('%U', a_stream.object_stored_size)
			l_pointer := $data
			l_pointer.memory_copy (a_stream.item, a_stream.object_stored_size)
			-- 'internal_buffer_access' is not in the DOTNET version.  This was 'belt and suspenders' anyway.
			--		internal_buffer_access := default_pointer	-- This is meaningless now.
		end

feature -- Access

	data: SPECIAL [CHARACTER]

	dispose is
			-- Since we have set 'internal_buffer_access' to NULL, we better not call 'close'.
		do
		end

end
