note
	description: "A HASHABLE that consists of an ARRAY of HASHABLE's."
	author: "Mark Howard"
	last_editor: "$Author: er $"
	date: "$Date: 2014/02/26 $"
	revision: "$Revision: #17 $"
	path: "$File: //rose/source/kernel/infrastructure/containers/multi_key.e $"
	storable_version: ""

class
	MULTI_KEY

inherit
	MULTI_KEYED
		redefine
			copy
		end

create
	make,
	make_from_multi_key

feature -- Initialization.
	make (a_array: ARRAY [HASHABLE]) is
		require
			valid_array: a_array /= Void
		do
			array := a_array
		end

	make_from_multi_key(a_other: like Current)
	-- This will create a copy of 'a_other'.  The objects making up the keys will be shared but
	-- the 'area' of the internal ARRAY will not.
	require
		valid_argument: a_other /= Void
	do
		copy(a_other)
	end

feature -- Status report.

	key_count: INTEGER is
		do
			Result := array.count
			if array.lower = 0 then
				Result := Result - 1
			end
		end

	hash_key (i: INTEGER): HASHABLE is
		do
			Result := array.item(i)
		end

	array: ARRAY [HASHABLE]

feature -- Element change.

	array_force (a_item: HASHABLE; i: INTEGER) is
		do
			array.force (a_item, i)
		end

feature -- Duplication.

	copy(a_other: like Current)
	-- This implementation guarantees that the two 'area's will not be shared.  Note that this
	-- is called by 'twin'.
	do
		make(a_other.array.twin)
	ensure then
		different_areas: array.area /= a_other.array.area
	end

end
