indexing
	author: "$Author: er $Mark Howard"
	date: "$Date: 2014/02/26 $"
	revision: "$Revision: #23 $"
	path: "$File: //rose/source/kernel/infrastructure/containers/multi_keyed.e $"
	
deferred class
	MULTI_KEYED
	
inherit
	HASHABLE
		redefine
			is_equal
		end
	NUMBER_THEORY
		redefine
			is_equal
		end
	
feature -- Deferred
	
	hash_key (i: INTEGER): HASHABLE is deferred end
	
	key_count: INTEGER is deferred end
	
feature
	
	hash_code: INTEGER is
		local
			i: INTEGER
			l_key: HASHABLE
			l_key_count: INTEGER
		do
			l_key_count := key_count	-- Speeds things up a fraction during the loop.
			from i := 1 until i > l_key_count
			loop
				l_key := hash_key(i)
				if l_key /= Void then
					Result := Result + l_key.hash_code * primes.item(i)
				end
				i := i + 1
			end
			Result := Result.hash_code	-- Removes the sign.
		end
	
	keys_equal (a_other: like Current): BOOLEAN is
		local
			i: INTEGER
			l_key_count: INTEGER
		do
			l_key_count := key_count	-- Speeds things up a fraction during the loop.
			Result := a_other.key_count = l_key_count
			from 
				i := 1 
			until 
				Result = False or else i > l_key_count
			loop
				Result := equal(hash_key(i), a_other.hash_key(i))
				i := i + 1
			end
		end
	
	is_equal (other: like Current): BOOLEAN is
		do
			if other /= Void then
				Result := keys_equal (other)
			end
		end
	
end










