indexing
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #3 $"
	path: "$File: //rose/source/kernel/infrastructure/containers/next_in_sequence.e $"

class
	NEXT_IN_SEQUENCE

create
	
	make
	
feature
	
	make(a_array : ARRAY[DOUBLE]) is
		local
			i, j : INTEGER
			l_data : ARRAY[DOUBLE]
			l_previous_moments, l_moments : ROSE_MOMENTS
		do
			array := a_array
			from i := 1 until i > a_array.count / 2 loop
				create l_data.make(i,array.count)
				from j := i + 1 until j > a_array.count loop
					l_data.put((a_array.item(j - i) - a_array.item(j)).abs,j)
					j := j + 1
				end
				create l_moments.make(l_data,Void)
				if l_previous_moments /= Void then
					confidence := confidence.max(l_previous_moments.mean / l_moments.mean)
				end
				if l_previous_moments = Void or else 
					l_moments.mean < l_previous_moments.mean then
					repeat_spot := i
					l_previous_moments := l_moments
				end
				i := i + 1
			end
		end
	
feature
	
	next_i_th(a_index : INTEGER) : DOUBLE is
		do
			Result := array.item(array.count + a_index - repeat_spot)
		end
	
	confidence : DOUBLE

feature {NONE} 
	
	repeat_spot : INTEGER
	array : ARRAY[DOUBLE]
	
end
