indexing

	description: "Exceptions for unimplemented features"

	author: "Colin Adams"
	last_editor: "$Author: er $"
	date: "$Date: 2013/03/07 $"
	revision: "$Revision: #3 $"
	path: "$File: //rose/source/kernel/infrastructure/support/exception/not_yet_implemented_exception.e $"

class NOT_YET_IMPLEMENTED_EXCEPTION

inherit
	ROSE_DEVELOPER_EXCEPTION
		redefine
			internal_meaning
		end

create

	make

feature {NONE} -- Initialization

	make (a_class, a_feature: STRING) is
			-- Initialize attributes.
		require
			a_class_not_void: a_class /= Void
			a_feature_not_void: a_feature /= Void
		do
			class_name := a_class
			feature_name := a_feature
		ensure
			class_name_set: class_name = a_class
			feature_name_set: feature_name = a_feature
		end

feature -- Access

	class_name: STRING
			-- Name of class in which non-implemented version of `feature_name' can be found

	feature_name: STRING
			-- Name of feature which is not implemented in `class_name'

feature {NONE} -- Access

	internal_meaning: STRING is
			-- <Precursor>
		do
			Result := "{" + class_name + "}." + feature_name + " has not yet been implemented."
		end

invariant

	class_name_not_void: class_name /= Void
	feature_name_not_void: feature_name /= Void

end

