note

	description: "NT_CASH"

	generator: "[
		Classifier -class_name="NT_CASH"
	]"

	keywords: "classifier,database,record,generated"
	author: "Sami Ben Grine"
	last_editor: "$Author: sm $"
	date: "$Date: 2013/06/26 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/expert_system/nt_cash.e $"

class NT_CASH

inherit

	IEEE_MATH
		export {NONE} all end

	ANY

feature -- Access

	global_investment_date : ROSE_DATE
			-- Database column `global_investment_date'

	update_mode : STRING
			-- Database column `update_mode'

	account_code : STRING
			-- Database column `account_code'

	accounting_date : ROSE_DATE
			-- Database column `accounting_date'

	iso_currency_code : STRING
			-- Database column `iso_currency_code'

	accounting_basis : STRING
			-- Database column `accounting_basis'

	cash_account_category : STRING
			-- Database column `cash_account_category'

	total_quantity : RP_DECIMAL
			-- Database column `total_quantity'

	errors : STRING
			-- Database column `errors'

	quantity_unavailable : RP_DECIMAL
			-- Database column `quantity_unavailable'

	market_value_amount : RP_DECIMAL
			-- Database column `market_value_amount'

	market_value_currency : STRING
			-- Database column `market_value_currency'

feature -- Setting

	set_global_investment_date (a_value: like global_investment_date) is
			-- Set `global_investment_date' to `a_value'
		do
			global_investment_date := a_value
		ensure
			global_investment_date_assigned: global_investment_date = a_value
		end

	set_update_mode (a_value: like update_mode) is
			-- Set `update_mode' to `a_value'
		do
			update_mode := a_value
		ensure
			update_mode_assigned: update_mode = a_value
		end

	set_account_code (a_value: like account_code) is
			-- Set `account_code' to `a_value'
		do
			account_code := a_value
		ensure
			account_code_assigned: account_code = a_value
		end

	set_accounting_date (a_value: like accounting_date) is
			-- Set `accounting_date' to `a_value'
		do
			accounting_date := a_value
		ensure
			accounting_date_assigned: accounting_date = a_value
		end

	set_iso_currency_code (a_value: like iso_currency_code) is
			-- Set `iso_currency_code' to `a_value'
		do
			iso_currency_code := a_value
		ensure
			iso_currency_code_assigned: iso_currency_code = a_value
		end

	set_accounting_basis (a_value: like accounting_basis) is
			-- Set `accounting_basis' to `a_value'
		do
			accounting_basis := a_value
		ensure
			accounting_basis_assigned: accounting_basis = a_value
		end

	set_cash_account_category (a_value: like cash_account_category) is
			-- Set `cash_account_category' to `a_value'
		do
			cash_account_category := a_value
		ensure
			cash_account_category_assigned: cash_account_category = a_value
		end

	set_total_quantity (a_value: like total_quantity) is
			-- Set `total_quantity' to `a_value'
		do
			total_quantity := a_value
		ensure
			total_quantity_assigned_non_nan: not isnan (a_value) implies total_quantity = a_value
			total_quantity_assigned_nan: isnan (a_value) implies isnan (total_quantity)
		end

	set_errors (a_value: like errors) is
			-- Set `errors' to `a_value'
		do
			errors := a_value
		ensure
			errors_assigned: errors = a_value
		end

	set_quantity_unavailable (a_value: like quantity_unavailable) is
			-- Set `quantity_unavailable' to `a_value'
		do
			quantity_unavailable := a_value
		ensure
			quantity_unavailable_assigned_non_nan: not isnan (a_value) implies quantity_unavailable = a_value
			quantity_unavailable_assigned_nan: isnan (a_value) implies isnan (quantity_unavailable)
		end

	set_market_value_amount (a_value: like market_value_amount) is
			-- Set `market_value_amount' to `a_value'
		do
			market_value_amount := a_value
		ensure
			market_value_amount_assigned_non_nan: not isnan (a_value) implies market_value_amount = a_value
			market_value_amount_assigned_nan: isnan (a_value) implies isnan (market_value_amount)
		end

	set_market_value_currency (a_value: like market_value_currency) is
			-- Set `market_value_currency' to `a_value'
		do
			market_value_currency := a_value
		ensure
			market_value_currency_assigned: market_value_currency = a_value
		end

end
