note

	description: "NT_PORTFOLIO_OPEN_FFX"

	generator: "[
		Classifier -class_name="NT_PORTFOLIO_OPEN_FFX"
	]"

	keywords: "classifier,database,record,generated"
	author: "Sami Ben Grine"
	last_editor: "$Author: sm $"
	date: "$Date: 2013/06/26 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/expert_system/nt_portfolio_open_ffx.e $"

class NT_PORTFOLIO_OPEN_FFX

inherit

	IEEE_MATH
		export {NONE} all end

	ANY

feature -- Access

	global_investment_date : ROSE_DATE
			-- Database column `global_investment_date'

	update_mode : STRING
			-- Database column `update_mode'

	buy_currency : STRING
			-- Database column `buy_currency'

	sell_currency : STRING
			-- Database column `sell_currency'

	contract_date : ROSE_DATE
			-- Database column `contract_date'

	investment_region : STRING
			-- Database column `investment_region'

	portfolio_code : STRING
			-- Database column `portfolio_code'

	settlement_date : ROSE_DATE
			-- Database column `settlement_date'

	sell_amount : RP_DECIMAL
			-- Database column `sell_amount'

	buy_amount : RP_DECIMAL
			-- Database column `buy_amount'

	broker : STRING
			-- Database column `broker'

	settlement_currency : STRING
			-- Database column `settlement_currency'

	errors : STRING
			-- Database column `errors'

	net_market_value : RP_DECIMAL
			-- Database column `net_market_value'

	net_currency : STRING
			-- Database column `net_currency'

	account_code : STRING
			-- Database column `account_code'

feature -- Setting

	set_global_investment_date (a_value: like global_investment_date) is
			-- Set `global_investment_date' to `a_value'
		do
			global_investment_date := a_value
		ensure
			global_investment_date_assigned: global_investment_date = a_value
		end

	set_update_mode (a_value: like update_mode) is
			-- Set `update_mode' to `a_value'
		do
			update_mode := a_value
		ensure
			update_mode_assigned: update_mode = a_value
		end

	set_buy_currency (a_value: like buy_currency) is
			-- Set `buy_currency' to `a_value'
		do
			buy_currency := a_value
		ensure
			buy_currency_assigned: buy_currency = a_value
		end

	set_sell_currency (a_value: like sell_currency) is
			-- Set `sell_currency' to `a_value'
		do
			sell_currency := a_value
		ensure
			sell_currency_assigned: sell_currency = a_value
		end

	set_contract_date (a_value: like contract_date) is
			-- Set `contract_date' to `a_value'
		do
			contract_date := a_value
		ensure
			contract_date_assigned: contract_date = a_value
		end

	set_investment_region (a_value: like investment_region) is
			-- Set `investment_region' to `a_value'
		do
			investment_region := a_value
		ensure
			investment_region_assigned: investment_region = a_value
		end

	set_portfolio_code (a_value: like portfolio_code) is
			-- Set `portfolio_code' to `a_value'
		do
			portfolio_code := a_value
		ensure
			portfolio_code_assigned: portfolio_code = a_value
		end

	set_settlement_date (a_value: like settlement_date) is
			-- Set `settlement_date' to `a_value'
		do
			settlement_date := a_value
		ensure
			settlement_date_assigned: settlement_date = a_value
		end

	set_sell_amount (a_value: like sell_amount) is
			-- Set `sell_amount' to `a_value'
		do
			sell_amount := a_value
		ensure
			sell_amount_assigned_non_nan: not isnan (a_value) implies sell_amount = a_value
			sell_amount_assigned_nan: isnan (a_value) implies isnan (sell_amount)
		end

	set_buy_amount (a_value: like buy_amount) is
			-- Set `buy_amount' to `a_value'
		do
			buy_amount := a_value
		ensure
			buy_amount_assigned_non_nan: not isnan (a_value) implies buy_amount = a_value
			buy_amount_assigned_nan: isnan (a_value) implies isnan (buy_amount)
		end

	set_broker (a_value: like broker) is
			-- Set `broker' to `a_value'
		do
			broker := a_value
		ensure
			broker_assigned: broker = a_value
		end

	set_settlement_currency (a_value: like settlement_currency) is
			-- Set `settlement_currency' to `a_value'
		do
			settlement_currency := a_value
		ensure
			settlement_currency_assigned: settlement_currency = a_value
		end

	set_errors (a_value: like errors) is
			-- Set `errors' to `a_value'
		do
			errors := a_value
		ensure
			errors_assigned: errors = a_value
		end

	set_net_market_value (a_value: like net_market_value) is
			-- Set `net_market_value' to `a_value'
		do
			net_market_value := a_value
		ensure
			net_market_value_assigned_non_nan: not isnan (a_value) implies net_market_value = a_value
			net_market_value_assigned_nan: isnan (a_value) implies isnan (net_market_value)
		end

	set_net_currency (a_value: like net_currency) is
			-- Set `net_currency' to `a_value'
		do
			net_currency := a_value
		ensure
			net_currency_assigned: net_currency = a_value
		end

	set_account_code (a_value: like account_code) is
			-- Set `account_code' to `a_value'
		do
			account_code := a_value
		ensure
			account_code_assigned: account_code = a_value
		end

end
