indexing
	description: "Objects which know how to factor 64 bit integers into primes"
	author: "Mark Howard"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #5 $"

class
	NUMBER_THEORY
feature
	primes : ROSE_PRIMES is
		once
			create Result.make(10000)
		end
	factor (a_integer : INTEGER_64) : ROSE_LINEAR_ARRAY[INTEGER] is
		local
			l_quotient : INTEGER_64
			i,l_prime : INTEGER
		do
			--note that to factor a number you only need to check for prime factors <= square root of it
			create Result.make_empty
			l_quotient := a_integer
			l_prime := 2 --just to start the test for l_prime * l_prime > l_quotient
			from until l_quotient <= primes.maximum_prime * primes.maximum_prime loop
				primes.double_upper_bound
			end
			from i := 1 until l_quotient = 1 or else i > primes.count or else l_prime * l_prime >= l_quotient loop
				from l_prime := primes.item(i) until l_quotient \\ l_prime /= 0 loop
					Result.extend(l_prime)
					l_quotient := l_quotient // l_prime
				end
				i := i + 1
			end
			if l_quotient > 1 then
				Result.extend(l_quotient.to_integer_32)
			end
		end
end -- class NUMBER_THEORY
