indexing
	description: "Hash table where the object is also the key"
	author : "Mark Howard"
	keywords : "hash,key,table"
	last_editor: "$Author: zs $"
	date: "$Date: 2010/04/08 $"
	revision: "$Revision: #7 $"
	archive: "$File: //rose/source/kernel/infrastructure/containers/object_table.e $"

class
	OBJECT_TABLE [G -> MULTI_KEYED]

inherit
	HASH_TABLE [G, MULTI_KEYED]
		rename
			put as hash_table_put
		redefine
			same_keys
		end

create
	make

feature --Redefinition

	same_keys (a_search_key, a_key: MULTI_KEYED): BOOLEAN
			-- Does `a_search_key' equal to `a_key'?
			--| Default implementation is using ~.
		do
			Result := a_search_key.keys_equal (a_key)
		end

	put (a_item: G) is
			-- Put 'a_item' in this hash table.
		require
			valid_key: valid_key (a_item)
		do
			hash_table_put (a_item, a_item)
		end

	has_keys (a_array: ARRAY [HASHABLE]): BOOLEAN is
			-- Does this hash table have key with components in 'a_array'?
		require
			valid_array: a_array /= Void
		local
			l_multi_key: MULTI_KEY
		do
			create l_multi_key.make (a_array)
			Result := has (l_multi_key)
		end

end
