indexing
	description: "Eiffel wrapper of IAccessor and IRowset."
	author: "PN"
	last_editor: "$Author: rj $"
	date: "$Date: 2010/09/07 $"
	revision: "$Revision: #15 $"
	path: "$File: //rose/source/kernel/infrastructure/persistence/windows/classic2/oledb_accessor_rowset.e $"

class
	OLEDB_ACCESSOR_ROWSET [ACCESSOR->OLEDB_ANY_ACCESSOR create make end,
			ROWSET->OLEDB_ANY_ROWSET create make end]

create

	make

feature -- Initialization.
	make is
		do
			close
			create accessor.make
			create rowset.make
			rowset.set_accessor (accessor)
		end

feature -- Basic operations.
	bind: INTEGER is
		local
			hr: INTEGER
		do
			if rowset.p=default_pointer
			then
				Result := -1
			else
				if accessor.haccessor /= DB_INVALID_HACCESSOR then
					hr := accessor.release_accessor (rowset.p)
					accessor.close
				end
				Result := accessor.Bind_Columns(rowset.p)
			end

			if Result >= 0 then
				rowset.bind_finished
			end
		end

	close
		local
			hr: INTEGER
		do
			if rowset /= Void
			then
				if rowset.exists
				then
					hr := accessor.release_accessor (rowset.p)
				end

				rowset.close
			end

			if accessor /= Void then
				accessor.close
			end
		end

feature {NONE} -- Externals.
	DB_INVALID_HACCESSOR: POINTER is
		external
			"C [macro <oledb.h>]"
		alias
			"DB_INVALID_HACCESSOR"
		end

feature -- Attrubutes.
	accessor: ACCESSOR			-- First generaic parameter, constrained to OLEDB_ANY_ACCESSOR.

	rowset: ROWSET				-- Second generaic parameter, constrained to OLEDB_ANY_ROWSET.

end
