indexing
	description: "Bulk rowset"
	author: "$Author: rj $"
	last_editor: "$Author: rj $"
	date: "$Date: 2014/09/05 $"
	revision: "$Revision: #15 $"
	path: "$File: //rose/source/kernel/infrastructure/persistence/windows/classic2/oledb_bulk_rowset.e $"

class
	OLEDB_BULK_ROWSET

inherit
	OLEDB_ROWSET
		redefine
			move_first,
			move_next,
			release_rows,
			make,
			close,
			bind_finished
		end
	OLEDB_SIZEOF

create

	make


feature -- Initialization

	make is
		do
			Precursor
			row_count := 1
		end

feature -- Operations

	close is
			-- Close the rowset
		do
			Precursor
			m_hr := 0
			if m_phRow /= default_pointer then
				free (m_phRow)
				m_phRow := default_pointer
			end
		end

	set_row_count (i: INTEGER) is
			-- Hmmm.  No callers!
		do
			row_count := i
		end

	release_rows: INTEGER is
			-- Frees allocated memory.
		do
			current_row_index := 0
			m_hRow := default_pointer
			Result := IRowset_ReleaseRows (p, current_row_count, m_phRow, default_pointer, default_pointer, default_pointer)
			current_row_count := 0
		end

	move_first: INTEGER is
		local
			hr: INTEGER
		do
			hr := release_rows
			current_row_index := row_count
			Result := irowset_restartposition (p, default_pointer)
			m_hr := 0
			if Result >= 0 then
				Result := move_next
			end
		end

	move_next: INTEGER is
		local
			l_pp: POINTER
			l_stop: BOOLEAN
			l_m_phRow: POINTER
			l_current_row_count: INTEGER_64		-- Actually, we need 32 or 64 depending on the platform.
			l_m_hrow: POINTER
		do
			if m_phRow = default_pointer then
				print ("Error")
			end
			current_row_index := current_row_index + 1
			if current_row_index >= current_row_count then
				if m_hr /= 0 then
					Result := m_hr
					l_stop := true
				else
					Result := Release_Rows
					l_m_phRow := m_phRow
					m_hr := IRowset_GetNextRows (p, default_pointer, 0, row_count, $l_current_row_count, $l_m_phRow)
					m_phRow := l_m_phRow
					current_row_count := l_current_row_count.to_integer
					if m_hr < 0 or current_row_count = 0 then
						Result := m_hr
						l_stop := True
					end
				end
			end
			if not l_stop then
				l_pp := m_phRow + (sizeof_hrow * current_row_index)
				memcpy ($l_m_hRow, l_pp, sizeof_hrow)
				m_hRow := l_m_hrow
				Result := get_data
			end
		end

	bind_finished is
		do
			current_row_count := 0
			current_row_index  := row_count
			--rows := default_pointer
			if (m_phRow /= default_pointer) then
				free (m_phRow)
				m_phRow := default_Pointer
			end
			m_phRow := calloc (row_count, sizeof_hrow)
		end

feature -- Access

	row_count: INTEGER
	current_row_count: INTEGER
	current_row_index: INTEGER
	m_hr: INTEGER
	m_phRow: POINTER

end
