indexing
	description: "Native interface for OLEDB command"
	author: "Pierre Nallet"
	last_editor: "$Author: rj $"
	date: "$Date: 2014/09/05 $"
	revision: "$Revision: #13 $"
	path: "$File: //rose/source/kernel/infrastructure/persistence/windows/classic2/oledb_command_interfaces.e $"

class
	OLEDB_COMMAND_INTERFACES

feature -- Access

	ICommandWithParameters_GetParameterInfo(This: POINTER; pcparams: POINTER; pdbparaminfo: POINTER; ppnamesbuffer: POINTER): INTEGER is
			-- Note that DB_UPARAMS is 32- or 64-bit depending on the platform.
		external
			"C [macro <oledb.h>](ICommandWithParameters*, DB_UPARAMS*, DBPARAMINFO**, OLECHAR**): EIF_INTEGER"
		alias
			"ICommandWithParameters_GetParameterInfo"
		end

	ICommandWithParameters_MapParameterNames(This:POINTER; Cparamnames: INTEGER; rgparamnames: POINTER; dbparamordinals: INTEGER): INTEGER is
			-- Note that DB_LPARAMS is 32- or 64-bit depending on the platform.
		external
			"C [macro <oledb.h>](ICommandWithParameters*, DB_UPARAMS, OLECHAR**, DB_LPARAMS*): EIF_INTEGER"
		alias
			"ICommandWithParameters_MapParameterNames"
		end

	ICommandWithParameters_SetParameterInfo (This: POINTER; cParams: POINTER; rgParamOrdinals: POINTER; rgParamBindInfo: POINTER): INTEGER is
			-- Note that DB_UPARAMS is 32- or 64-bit depending on the platform.
		external
			"C [macro <oledb.h>](ICommandWithParameters*, DB_UPARAMS, DB_UPARAMS*, DBPARAMBINDINFO*): EIF_INTEGER"
		alias
			"ICommandWithParameters_SetParameterInfo"
		end

	ICommand_Cancel(This: POINTER): INTEGER is
		external
			"C [macro <oledb.h>](ICommand*): EIF_INTEGER"
		alias
			"ICommand_Cancel"
		end

--	ICommand_Execute(This: POINTER; Punkouter: POINTER; riid: POINTER; pparams: POINTER; pcrowsaffected: POINTER; pprowset: POINTER): INTEGER is
--			-- 32-bit safe only.  The parameter 'pcrowsaffected' is either 32 or 64 bits depending on the platform.
--		external
--			"c blocking signature (ICommand*, IUnknown*, REFIID, DBPARAMS*, ULONG*, IUnknown**): EIF_INTEGER use <oledb.h>"
--		alias
--			"ICommand_Execute"
--		end

	ICommand_Execute2(This: POINTER; Punkouter: POINTER; riid: POINTER; pparams: POINTER; pcrowsaffected: TYPED_POINTER [INTEGER]; pprowset: POINTER; ret: TYPED_POINTER [INTEGER]) is
			-- 64/32-bit safe wrapper around ICommand_Execute.
		external
			"c blocking inline use <oledb.h>"
		alias
			"[
			{
				DBROWCOUNT l_rowcount = *(EIF_INTEGER *)$pcrowsaffected;
				*(EIF_INTEGER *) $ret = (EIF_INTEGER) ICommand_Execute (
					(ICommand*) $this,
					(IUnknown*) $punkouter,
					(REFIID) $riid,
					(DBPARAMS*) $pparams,
					(DBROWCOUNT *) &l_rowcount,
					(IUnknown**) $pprowset);
				*(EIF_INTEGER *) $pcrowsaffected = (EIF_INTEGER) l_rowcount;
			}
			]"
		end

	ICommandPrepare_Prepare(This: POINTER; cExpectedRuns: INTEGER): INTEGER is
		external
			"C [macro <oledb.h>](ICommandPrepare*, ULONG): EIF_INTEGER"
		alias
			"ICommandPrepare_Prepare"
		end

	ICommandPrepare_Unprepare(this: POINTER): INTEGER is
		external
			"C [macro <oledb.h>](ICommandPrepare*): EIF_INTEGER"
		alias
			"ICommandPrepare_Unprepare"
		end

	ICommandProperties_GetProperties (This: POINTER;cPropertyIDSets: INTEGER;  rgPropertyIDSets: POINTER; pcPropertySets: POINTER;
									  prgPropertySets: POINTER): INTEGER is
		external
			"C [macro <oledb.h>](ICommandProperties*, ULONG, DBPROPIDSET*, ULONG*, DBPROPSET**): EIF_INTEGER"
		alias
			"ICommandProperties_GetProperties"
		end

	ICommandProperties_SetProperties(This: POINTER; cProperties: INTEGER; rgPropertySets: POINTER): INTEGER is
		external
			"C [macro <oledb.h>](ICommandProperties*, ULONG, DBPROPSET*): EIF_INTEGER"
		alias
			"ICommandProperties_SetProperties"
		end

	ICommandText_GetCommandText(This: POINTER; pguidDialect: POINTER; ppwszCommand: POINTER): INTEGER is
		external
			"C [macro <oledb.h>](ICommandText*, GUID*, LPOLESTR*): EIF_INTEGER"
		alias
			"ICommandText_SetCommandText"
		end

	ICommandText_SetCommandText(This: POINTER; rguidDialect: POINTER; pwszCommand: POINTER): INTEGER is
		external
			"C [macro <oledb.h>](ICommandText*, REFGUID, LPCOLESTR): EIF_INTEGER"
		alias
			"ICommandText_SetCommandText"
		end

	IDBCreateCommand_CreateCommand(this: POINTER; punkout: POINTER; riid: POINTER; ppcommand: POINTER): INTEGER is
		external
			"C [macro <oledb.h>] (IDBCreateCommand*, IUnknown*, REFIID, IUnknown**): EIF_INTEGER"
		alias
			"IDBCreateCommand_CreateCommand"
		end

	IID_IDBCreateCommand: POINTER is
		external
			"C [macro <oledb.h>]"
		alias
			"&IID_IDBCreateCommand"
		end

	IID_ICommand: POINTER is
		external
			"C [macro <oledb.h>]"
		alias
			"&IID_ICommand"
		end

	IID_ICommandText: POINTER is
		external
			"C [macro <oledb.h>]"
		alias
			"&IID_ICommandText"
		end

	IID_ICommandWithParameters: POINTER is
		external
			"C [macro <oledb.h>]"
		alias
			"&IID_ICommandWithParameters"
		end

	IID_ICommandProperties: POINTER is
		external
			"C [macro <oledb.h>]"
		alias
			"&IID_ICommandProperties"
		end

	IID_ICommandPrepare: POINTER is
			-- iid for ICommandPrepare
		external
			"C [macro <oledb.h>]"
		alias
			"&IID_ICommandPrepare"
		end

	IID_IMultipleResults: POINTER is
			-- iid for IMultipleResults
		external
			"C [macro <oledb.h>]"
		alias
			"&IID_IMultipleResults"
		end

end
