indexing
	description: ""
	author: "Pierre Nallet"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #8 $"

class
	OLEDB_DBTIMESTAMP [MM -> MEMORY_MODEL create default_create end]

inherit
	COM_SMART_STRUCTURE [MM]

create
	make

feature -- Access

	is_equal_to (other: OLEDB_DBTIMESTAMP[MEMORY_MODEL]): BOOLEAN is
		require
			other_not_void: other /= Void
			other_exists: other.exists
			exists: exists
		do
			Result := memcmp (item, other.item, structure_size) = 0
		end

	structure_size: INTEGER is
		do
			Result := c_size_of_dbtimestamp
		end

feature -- Basic operations

	copy_from (other: OLEDB_DBTIMESTAMP [MEMORY_MODEL]) is
		require
			other_not_void: other /= Void
			other_exists: other.exists
			exists: exists
		do
			memcpy (item, other.item, structure_size)
		end

	c_size_of_dbtimestamp:INTEGER is  external "C [macro <oledbext.h>]" alias" sizeof(DBTIMESTAMP)"end
	c_dbtimestamp_set_year(struct:POINTER; a_value:INTEGER) is external "C [macro <oledbext.h>]" alias"c_dbtimestamp_set_year" end c_dbtimestamp_get_year(struct:POINTER):INTEGER is external "C [macro <oledbext.h>]" alias"c_dbtimestamp_get_year" end set_year(a_value:INTEGER) is do c_dbtimestamp_set_year(item, a_value) end get_year:INTEGER is do Result := c_dbtimestamp_get_year(item) end
	c_dbtimestamp_set_month(struct:POINTER; a_value:INTEGER) is external "C [macro <oledbext.h>]" alias"c_dbtimestamp_set_month" end c_dbtimestamp_get_month(struct:POINTER):INTEGER is external "C [macro <oledbext.h>]" alias"c_dbtimestamp_get_month" end set_month(a_value:INTEGER) is do c_dbtimestamp_set_month(item, a_value) end get_month:INTEGER is do Result := c_dbtimestamp_get_month(item) end
	c_dbtimestamp_set_day(struct:POINTER; a_value:INTEGER) is external "C [macro <oledbext.h>]" alias"c_dbtimestamp_set_day" end c_dbtimestamp_get_day(struct:POINTER):INTEGER is external "C [macro <oledbext.h>]" alias"c_dbtimestamp_get_day" end set_day(a_value:INTEGER) is do c_dbtimestamp_set_day(item, a_value) end get_day:INTEGER is do Result := c_dbtimestamp_get_day(item) end
	c_dbtimestamp_set_hour(struct:POINTER; a_value:INTEGER) is external "C [macro <oledbext.h>]" alias"c_dbtimestamp_set_hour" end c_dbtimestamp_get_hour(struct:POINTER):INTEGER is external "C [macro <oledbext.h>]" alias"c_dbtimestamp_get_hour" end set_hour(a_value:INTEGER) is do c_dbtimestamp_set_hour(item, a_value) end get_hour:INTEGER is do Result := c_dbtimestamp_get_hour(item) end
	c_dbtimestamp_set_minute(struct:POINTER; a_value:INTEGER) is external "C [macro <oledbext.h>]" alias"c_dbtimestamp_set_minute" end c_dbtimestamp_get_minute(struct:POINTER):INTEGER is external "C [macro <oledbext.h>]" alias"c_dbtimestamp_get_minute" end set_minute(a_value:INTEGER) is do c_dbtimestamp_set_minute(item, a_value) end get_minute:INTEGER is do Result := c_dbtimestamp_get_minute(item) end
	c_dbtimestamp_set_second(struct:POINTER; a_value:INTEGER) is external "C [macro <oledbext.h>]" alias"c_dbtimestamp_set_second" end c_dbtimestamp_get_second(struct:POINTER):INTEGER is external "C [macro <oledbext.h>]" alias"c_dbtimestamp_get_second" end set_second(a_value:INTEGER) is do c_dbtimestamp_set_second(item, a_value) end get_second:INTEGER is do Result := c_dbtimestamp_get_second(item) end
	c_dbtimestamp_set_fraction(struct:POINTER; a_value:INTEGER) is external "C [macro <oledbext.h>]" alias"c_dbtimestamp_set_fraction" end c_dbtimestamp_get_fraction(struct:POINTER):INTEGER is external "C [macro <oledbext.h>]" alias"c_dbtimestamp_get_fraction" end set_fraction(a_value:INTEGER) is do c_dbtimestamp_set_fraction(item, a_value) end get_fraction:INTEGER is do Result := c_dbtimestamp_get_fraction(item) end

end -- class OLEDB_DBTIMESTAMP
