indexing
	description: "IStream from HGLOBAL"
	author: "Pierre Nallet"
	last_editor: "$Author: nn $"
	date: "$Date: 2009/05/27 $"
	revision: "$Revision: #12 $"

class
	OLEDB_IN_MEMORY_SEQUENTIAL_STREAM

inherit
	OLEDB_SEQUENTIAL_STREAM

	COM_RUN_TIME
		export {NONE} all end
	MEMORY_FUNCTIONS
		export {NONE} all end
	OLEDB_GLOBAL_MEMORY
		export {NONE} all end
	OLEDB_GMEM_CONSTANTS
		export {NONE} all end

create
	make_by_pointer

feature {NONE} -- Initialization
	make_by_pointer(ptr: POINTER; size: INTEGER)
			-- Initialize `Current'.
		require
			ptr_not_default: ptr /= default_pointer
			size_non_negative: size >= 0
		local
			hglobal: POINTER
			ptrglobal: POINTER
			l_hr: INTEGER
		do
			hglobal := globalalloc(GPTR, size)
			ptrglobal:= globallock (hglobal)
			memcpy(ptrglobal, ptr, size)
			globalunlock(hglobal)
			l_hr := CreateStreamOnHGlobal(hglobal, WindowsTrue, $p)
			if l_hr < 0 then
				(create {EXCEPTIONS}).raise(
					"CreateStreamOnHGlobal failed")
			end
		end

feature {NONE} -- Externals
	CreateStreamOnHGlobal(
		hglobal: POINTER; fDeleteOnRelease: INTEGER; ppstm: POINTER):
		INTEGER
			-- http://msdn.microsoft.com/en-us/library/aa378980.aspx
		external
			"C blocking signature (HGLOBAL, BOOL, LPSTREAM): int use <windows.h>"
		alias
			"CreateStreamOnHGlobal"
		end

	WindowsTrue: INTEGER
			-- http://msdn.microsoft.com/en-us/library/aa378980.aspx
		external
			"C [macro <windows.h>]"
		alias
			"TRUE"
		end
end
