indexing
	description: "Used to handle BLOBs."
	author: "Pierre Nallet"
	last_editor: "$Author: rj $"
	date: "$Date: 2013/04/29 $"
	revision: "$Revision: #17 $"
	path: "$File: //rose/source/kernel/infrastructure/persistence/windows/classic/oledb_sequential_stream.e $"

class
	OLEDB_SEQUENTIAL_STREAM

inherit
	COM_SMART_UNKNOWN
	MAKESTR

create
	make,
	make_empty


feature -- Initialization

	make_empty is
		do
		end

	make (ptr: like p) is
		require
			valid_ptr: ptr /= default_pointer
		local
			i: INTEGER
		do
			i:= IUnknown_QueryInterface (ptr, iid_ISequentialStream, $p)
		end

	read (pv: POINTER; cb: INTEGER; pcbRead: POINTER): INTEGER is
		do
			Result := ISequentialStream_Read(p, pv, cb, pcbRead)
		end

	read_string: STRING
			-- Returns this stream's buffer as a STRING.
		local
			l_count: INTEGER
			l_hr: INTEGER
			l_total_count: INTEGER
			l_effective_count: INTEGER
			l_p1: POINTER
		do
			from
				l_count := 1024 * 1024	-- 1 MB.
				l_p1 := l_p1.memory_alloc (l_count)
				l_hr := read (l_p1, l_count, $l_effective_count)
				l_total_count := l_effective_count
			until
				l_effective_count < l_count
			loop
				l_count := l_total_count
				l_p1 := l_p1.memory_realloc(l_total_count + l_count)
				l_hr := read (l_p1 + l_total_count, l_count, $l_effective_count)
				l_total_count := l_total_count + l_effective_count
			end

			Result := makestr (l_p1, l_total_count)
			free (l_p1)
		end

	ISequentialStream_Read(This: POINTER; pv: POINTER; cb: INTEGER; pcbRead: POINTER): INTEGER is
		external
			"C [macro <oledb.h>] (ISequentialStream*, void *, ULONG, ULONG*): EIF_INTEGER"
		alias
			"ISequentialStream_Read"
		end

	ISequentialStream_Write(This: POINTER; pv: POINTER; cb: INTEGER; pcbWritten: POINTER): INTEGER is
		external
			"C [macro <oledb.h>] (ISequentialStream*, void *, ULONG, ULONG*): EIF_INTEGER"
		alias
			"ISequentialStream_Write"
		end

	IID_ISequentialStream: POINTER is
		external
			"C [macro <oledb.h>]"
		alias
			"&IID_ISequentialStream"
		end

end
