indexing
	description: "Objects that ...";
	author: "";
	date: "$Date: 2008/12/01 $";
	revision: "$Revision: #16 $"

class OLEDB_SESSION

inherit
	COM_SMART_UNKNOWN

	OLEDB_OPENROWSET_INTERFACE
	TRACEABLE
create 
	make, make_from_connect_string

feature -- Initialization

	make is do end

	
	make_from_connect_string (a_connect_string: STRING) is
		do
			set_connect_string (a_connect_string)
		end
	connect_string: STRING
	set_connect_string (a_connect_string: STRING) is
			-- 
		do
			connect_string := a_connect_string
		end
		
	open_connection: INTEGER is
			-- 
		local
			l_src: OLEDB_DATA_SOURCE
		do
			create l_src.open_from_initialization_string (connect_string)	
			Result := open (l_src)			
		end
		
		
	open (a_data_source: OLEDB_DATA_SOURCE): INTEGER is
		require
			a_data_source_not_void: a_data_source /= void;
			a_data_source_exists: a_data_source.exists
		local
			dbcreatesession: POINTER;
			hr: INTEGER
			l_p: POINTER
		do
			Result := a_data_source.query_interface (iid_idbcreatesession, $dbcreatesession);
			if Result>= 0 then
				l_p := p
				Result:= idbcreatesession_createsession (dbcreatesession, default_pointer, iid_iopenrowset, $l_p)
				p := l_p
				hr := iunknown_release (dbcreatesession)
			end
		end;
		
	commit: INTEGER is
		require
			exists: exists
		local
			l_ptransactionlocal: POINTER
			hr: INTEGER
		do
			Result := query_interface(IID_ITransactionLocal,  $l_ptransactionlocal)
			if Result >= 0 then
				Result := ITransaction_Commit(l_ptransactionlocal, 0, 0, 0)
				hr := IUnknown_release (l_ptransactionlocal)
			end
		end

	abort: INTEGER is
		require
			exists: exists
		local
			l_ptransactionlocal: POINTER
			hr: INTEGER
		do
			Result := query_interface(IID_ITransactionLocal,  $l_ptransactionlocal)
			if Result >= 0 then
				Result := ITransaction_Abort(l_ptransactionlocal, default_pointer, 0, 0)
				hr := IUnknown_release (l_ptransactionlocal)
			end
		end

	start_transaction (isoLevel: INTEGER; isoflags: INTEGER) : INTEGER is
		require
			exists: exists
		local
			l_ptransactionlocal: POINTER
			hr: INTEGER
		do
			Result := query_interface(IID_ITransactionLocal,  $l_ptransactionlocal)
			if Result >= 0 then
				Result := ITransactionLocal_starttransaction(l_ptransactionlocal, isoLevel, isoFlags, default_pointer, default_pointer)
				hr := IUnknown_release (l_ptransactionlocal)
			end
		end

	iid_idbcreatesession: POINTER is
		external
			"C [macro <oledb.h>]"
		alias
			"&IID_IDBCreateSession"
		end;

	idbcreatesession_createsession (this: POINTER; punkouter: POINTER; riid: POINTER; ppdbsession: POINTER): INTEGER is
		external
			"C [macro <oledb.h>] (IDBCreateSession*, IUnknown*, REFIID, IUnknown**): EIF_INTEGER"
		alias
			"IDBCreateSession_CreateSession"
		end;

	ITransaction_Commit(This: POINTER; fRetaining: INTEGER; grfTC,grfRM: INTEGER): INTEGER is
		external
			" C [macro <oledb.h>] (ITransaction*, BOOL, ULONG, ULONG): EIF_INTEGER"
		alias
			"ITransaction_Commit"
		end

	ITransaction_Abort(This: POINTER; pboidReason: POINTER; fRetaining,fAsync: INTEGER): INTEGER is
		external
			" C [macro <oledb.h>] (ITransaction*, BOID*, BOOL, BOOL): EIF_INTEGER"
		alias
			"ITransaction_Abort"
		end

			
	ITransaction_GetTransactionInfo(This: POINTER; pinfo: POINTER): INTEGER	is
		external
			"C [macro <oledb.h>] (ITransaction*, XACTTRANSINFO*): EIF_INTEGER"
		alias
			"ITransaction_GetTransactionInfo "
		end

ITransactionLocal_GetOptionsObject(This: POINTER; ppOptions: POINTER): INTEGER is
		external
			"C [macro <oledb.h>] (ITransactionLocal*, ITransactionOptions**): EIF_INTEGER"
		alias
			"ITransactionLocal_GetOptionsObject"
		end
ITransactionLocal_StartTransaction(This: POINTER; isoLevel: INTEGER; isoFlags: INTEGER; pOtherOptions: POINTER; pulTransactionLevel: POINTER): INTEGER is
		external
			" c[macro <oledb.h>](ITransactionLocal*,ISOLEVEL, ULONG, ISOLEVEL*, ULONG* )	: EIF_INTEGER"
		alias
			"ITransactionLocal_StartTransaction"
		end

	IID_ITransactionLocal: POINTER is
		external
			"C [macro <oledb.h>]"
		alias
			"&IID_ITransactionLocal"
		end

end -- class OLEDB_SESSION


