indexing
	description: "[
                  Class that provides interface for OLEDB simple commands.
				  Use this for low level OLEDB SQL statements.
				  ]"
	author: "Mark Howard"
	last_updater: "$Author: it $"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #8 $"
	path: "$File: //rose/source/kernel/infrastructure/persistence/windows/classic/oledb_simple_command.e $"

class
	OLEDB_SIMPLE_COMMAND[G -> OLEDB_DYNAMIC_ACCESSOR create make end, H -> OLEDB_ANY_ROWSET create make end]

inherit
	OLEDB_COMMAND [G, H]
	DATA_SERVER_SIMPLE_COMMAND
		redefine
			get_value,
			get_real_value,
			get_double_value,
			get_integer_value,
			get_string_value,
			get_uc_string_value
		end
	TRACEABLE
	
create
	default_create, 
	make_with_text
	
feature
	make_with_text (a_session: OLEDB_SESSION; a_command_text: STRING) is
		require
			valid_session: a_session /= Void
			valid_command: a_command_text /= Void
		local
			hr: INTEGER
		do
			hr := open (a_session, a_command_text, Void)
		end
	
feature
	move_first: INTEGER is
		local
			l_row: OLEDB_ROWSET
		do
			l_row ?= rowset
			Result := l_row.move_first
		end
	
	move_next: INTEGER is
		local
			l_row: OLEDB_ROWSET
		do
			l_row ?= rowset
			Result := l_row.move_next
			if Result = l_row.DB_S_ENDOFROWSET then
				Result := -1
			end
		end
	
feature
	get_value (i: INTEGER): POINTER is
		do
			if accessor.valid_column_index (i) then
				Result := accessor.get_value (i)
			end
		end
	
	get_real_value (i: INTEGER): REAL is
		do
			if accessor.column_valid_for_type (i, accessor.Dbtype_R4) then
				Result := accessor.get_real_value (i)
			end
		end
	
	get_double_value (i: INTEGER): DOUBLE is
		do
			if accessor.column_valid_for_type (i, accessor.Dbtype_R8) then
				Result := accessor.get_double_value (i)
			end
		end
	
	get_integer_value (i: INTEGER): INTEGER is
		do
			if accessor.column_valid_for_type (i, accessor.Dbtype_I4) then
				Result := accessor.get_integer_value (i)
			end
		end
	
	get_string_value (i: INTEGER): STRING is
		do
			if accessor.column_valid_for_type (i, accessor.Dbtype_Str) then
				Result := accessor.get_string_value (i)
			end
		end
	
	get_uc_string_value (i: INTEGER): UC_STRING is
		do
			if accessor.column_valid_for_type (i, accessor.Dbtype_Wstr) then
				Result := accessor.get_uc_string_value (i)
			end
		end

end 










