indexing
	description: "Used for capturing temp tables data (using oledb_fast_load)."
	author: "India Team"

deferred class
	OLEDB_SQL_SCRIPT_CAPTURE

inherit
	OLEDB_DBTYPE_CONSTANTS

	SQL_SCRIPT_CAPTURE
	
feature --Access
	map: ARRAY [INTEGER] is
		deferred
		end

	column_names: ARRAY [STRING] is
		deferred
		end

feature -- Access
	sql_capture_temp_table_column_names_and_data(a_table_name: STRING; a_any: ANY; a_accessor: OLEDB_DYNAMIC_ACCESSOR) is
		--Captures column names for insert statements.
	local
		i: INTEGER
		l_statement: STRING
		l_temp_table_name: STRING
	do
		l_temp_table_name := map_temp_table_name(a_table_name)
		create l_statement.make_from_string("insert into " + l_temp_table_name + " (")
		from i:= 1 until i > column_names.count loop
			if i > 1 then
				l_statement.append (",")
			end
			l_statement.append (column_names.item(i))
			i := i + 1
		end
		l_statement.append (") values (")
		l_statement.append (parameter_values (a_any, l_temp_table_name, a_accessor))
		l_statement.append (")%N")
		extend_to_sql_statements(l_statement)
	end

feature {NONE} -- Implementation
	parameter_values (a_any: ANY; a_table_name:STRING; a_accessor: OLEDB_DYNAMIC_ACCESSOR): STRING is
		-- Captures parameter values as comma separated data.
	local
		i: INTEGER
		l_column_info: OLEDB_COLUMN_INFO
		l_field_type: INTEGER
		l_any: ANY
		l_date_time: ROSE_DATE
	do
		Result := ""
		from i:= 1 until i > a_accessor.column_info.count loop
			if map.item(i) >= 0 then
				if Result.count > 0 then
					Result.append (",")
				end
				l_column_info := a_accessor.column_info.item(i-1)
				l_field_type := l_column_info.type

				if l_field_type = Dbtype_dbtimestamp then
					l_date_time ?= clone(internal3.field(map.item(i), a_any))
					Result.append(formatted_date(l_date_time))
				elseif l_field_type = Dbtype_str then
					l_any := clone(internal3.field(map.item(i), a_any))
					if l_any /= void then
						Result.append(single_quoted_string(l_any.out))
					else
						Result := "''"
					end
				else
					l_any := clone(internal3.field(map.item(i), a_any))
					Result.append(field_value(l_any, a_table_name, column_names.item(i)).out)
				end
			end
			i := i + 1
		end
	end
	
end -- OLEDB_SQL_SCRIPT_CAPTURE
