note
	description: "Ancestor of OLEDB_FAST_LOAD."
	author: "Pierre Nallet"
	last_editor: "$Author: rj $"
	date: "$Date: 2012/07/19 $"
	revision: "$Revision: #14 $"
	path: "$File: //rose/source/kernel/infrastructure/persistence/windows/classic/oledb_table.e $"

class
	OLEDB_TABLE [ACCESSOR-> OLEDB_ANY_ACCESSOR create make end,
				 ROWSET->OLEDB_ANY_ROWSET create make end]

inherit

	OLEDB_ACCESSOR_ROWSET [ACCESSOR, ROWSET]

	OLEDB_DBKIND_CONSTANTS

	COM_STRING_FUNCTIONS

	OLEDB_OPENROWSET_INTERFACE

create

	make

feature -- Initialization

	open (a_session: OLEDB_SESSION; a_name: STRING; a_property_set: OLEDB_PROPERTY_SET): INTEGER
			-- Opens the rowset.
		require
			a_session_not_void: a_session /= Void
			a_session_exists: a_session.exists
		local
			dbid: OLEDB_DBID [RUN_TIME_MEMORY_MODEL]
			prop_ptr: POINTER
			prop_count: INTEGER
			name_ptr: POINTER
			l_p: POINTER
		do
			temp_table_name := clone(a_name)
			create dbid.make
			name_ptr := string_to_widechar (a_name)
			dbid.set_pwszName(name_ptr)
			dbid.set_eKind(DBKIND_NAME);
			if a_property_set /= Void then
				prop_ptr := a_property_set.item
				prop_count := 1
			end
			rowset.release	-- Since 'a_rowset' may get reused (unlikely here), we must release the previous (if any) rowset.
			l_p := rowset.p
			Result := IOpenRowset_OpenRowset(a_session.p, default_pointer, dbid.item, default_pointer, rowset.get_iid,
				prop_count, prop_ptr, $l_p)
			rowset.set_pointer (l_p)
			free (name_ptr)
			if Result >= 0 then
				Result  := bind
			end
		end

feature -- Access
	temp_table_name: STRING

end
