indexing
	description: "OVERRIDE_DISTRIBUTIONS_<Z>.PARM file"

-- Brimsymbol         T  Ex Date  Clicode  Reason               Base Price    Pay Date Cash1xxxxx.xx   Cost_basis1       Shares1 Cash2xxxxx.xx   Cost_basis2      Shares2 Cash3xxxxx.xx Cost_basis3  Shares3 Cash4xxxxx.xx Cost_basis4  Shares4
-- ------------------*--*--------*--------*--------------------*-------------*--------*----------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- 1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890
--          1         2         3         4         5         6         7         8         9        10        11        12        13        14        15        16        17        18        19        20        21        22        23        24        25
-- FRE000039101...PAR 10 19960108 SUN      PECHINEY                   0.00000 19960108          0.00          0.00            0.          0.00     288154.49         1665.       271.20        271.20            0.          0.00          0.00            0.
-- GBE000007101...ISE 10 19991213 PIPE     BG SPIN OFF                0.00000 19991213          0.00    1026016.89       280888.89        0.00      46422.27        40000.         0.00      46261.20        40000.          0.00      46652.67        40000.

	author: "Portfolio Accounting Tech"
	last_editor: "$Author: it $"
	date: "$Date: 2009/10/08 $"
	revision: "$Revision: #3 $"
	archive: "$File: //rose/source/kernel/capital_actions/elections/override_distributions_parm_file.e $"

class
	OVERRIDE_DISTRIBUTIONS_PARM_FILE

inherit
	ROSE_FORMATTED_TEXT_FILE [OVERRIDE_DISTRIBUTIONS_PARM_RECORD]

create
	make

feature -- Basic Operations

	parse is
			-- Parse file
		local
			l_format: ROSE_ROBUST_FIXED_FORMAT
		do
			create l_format.make (<<
				[constants.string_type,          "brimsym",   1,  18],
				[constants.integer_32_type,         "type",  20,  21],
				[constants.integer_32_type,      "ex_date",  23,  30],
				[constants.string_type,          "clicode",  32,  39],
				[constants.string_type,           "reason",  41,  60],
				[constants.string_type,       "base_price",  62,  74],
				[constants.integer_32_type,     "pay_date",  76,  83],
				[constants.string_type,    "cash1xxxxx_xx",  85,  97], -- 14
				[constants.string_type,      "cost_basis1",  98, 111], -- 14
				[constants.string_type,          "shares1", 112, 127], -- 16
				[constants.string_type,    "cash2xxxxx_xx", 128, 139], -- 12
				[constants.string_type,      "cost_basis2", 140, 153], -- 14
				[constants.string_type,          "shares2", 154, 168], -- 15
				[constants.string_type,    "cash3xxxxx_xx", 169, 180], -- 12
				[constants.string_type,      "cost_basis3", 181, 194], -- 14
				[constants.string_type,          "shares3", 195, 210], -- 16
				[constants.string_type,    "cash4xxxxx_xx", 211, 222], -- 12
				[constants.string_type,      "cost_basis4", 223, 236], -- 14
				[constants.string_type,          "shares4", 237, 250]  -- 14
			>>)
			read_with_header_rows (name, l_format, 2)
		end

feature {NONE} -- Implementation

	constants: ROSE_CONSTANT_VALUES is
			-- Constants, including basic types
		once
			create Result
		end

end
