note

	description:

		"Currency Market implementing VMS logic for FX used for benchmark returns"

	id: "$Id: //rose/source/kernel/market/performance_legacy_benchmark_currency_market.e#5 $"
	author: "Ivan Tarnavsky"
	last_editor: "$Author: c4 $"
	date: "$Date: 2014/10/21 $"
	revision: "$Revision: #5 $"
	path: "$File: //rose/source/kernel/market/performance_legacy_benchmark_currency_market.e $"

class PERFORMANCE_LEGACY_BENCHMARK_CURRENCY_MARKET

inherit

	MARKET

	ROSE_LEGACY_UNDEFINED
		export {NONE} all end

feature -- Query

	exchange_rate_asof (a_fcu, a_bcu: CURRENCY; a_date: ROSE_DATE; a_asof: detachable ROSE_DATE): DOUBLE
			-- Exchange rate from `a_bcu' to `a_fcu' on `a_date';
			-- If `a_asof' is `Void' then our latest data is used.
		local
			l_date_iter, l_min_date: ROSE_DATE
		do
			if a_fcu = a_bcu or else a_fcu.is_equal (a_bcu) then
				Result := 1
			else
				Result := Undefined_double
				l_min_date := a_date.plus_n_date (-60)
				from
					create l_date_iter.make_ccyymmdd (a_date.ccyymmdd)
				until
					l_date_iter < l_min_date or is_defined_double (Result)
				loop
					Result := extel.exchange_rate_asof (a_fcu, a_bcu, l_date_iter, a_asof)
					if not is_defined_double (Result) then
						Result := idc.exchange_rate_asof (a_fcu, a_bcu, l_date_iter, a_asof)
					end
					l_date_iter := l_date_iter.previous_date
				end
			end
		end

feature {NONE} -- Implementation

	idc: IDC_CURRENCY_MARKET is
			-- IDC currency market
		once
			create Result
		end

	extel: EXTEL_CURRENCY_MARKET is
			-- Extel currency market
		once
			create Result
		end

end
