note

	description:

		"Investment issue entity."

	keywords: "Persistence, Issue"
	author: "David Stevens"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #19 $"
	path: "$File: //rose/source/kernel/entities/persistence/persistent_fund.e $"

class

	PERSISTENT_FUND

inherit
	ISSUER
		rename
			issuer_name_key as fund_name_key,
			issuer_name_most_recent_key as fund_name_most_recent_key
		end
	PERSISTENT_FUND_ACCESS
		redefine
			peer_anchor
		end

create

	make,make_anonymous

feature -- Basic operations

	fund_issues: ROSE_ENTITY_HISTORY[like context.fund_issue_template] 
			--Interval history of related fund_issue
		do
			Result := fund_to_fund_issue_history
		end

	is_defined : BOOLEAN is
			-- Does `Current' represent a real fund?
		do
			Result := handle /= 0
		end

	country (a_date : ROSE_DATE) : like context.country_template is
		do
			--Result := company_to_headquarter_country_history.witness(a_date)
		end

feature {NONE} -- Constants


	peer_anchor: PERSISTENT_FUND is do end
			-- Type returned by 'peer' function
	issue_template : PERSISTENT_FUND_ISSUE is do end

end
