note
	description: "Shared features for PERSISTENT_SERVER's and their clients."
	author: "Randy John"
	last_editor: "$Author: rj $"
	date: "$Date: 2015/03/25 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/persistence/databases/signature_tagged/persistent_server_common.e $"

class
	PERSISTENT_SERVER_COMMON

inherit
	EXCEPTIONS
		rename
			class_name as exception_class_name
		export
			{NONE} all
		end
	ANY

feature {NONE} -- Once/constants.

	k_none: STRING = "none"						-- Sent by the server to tell the client that security is not required.  If you change this,
												-- you must deploy clients and servers at the same time.  In other words - don't.

	security_monitor_command_explanation: STRING = "List the supported security systems."
												-- Explanation of 'security_monitor_command_name'.

	security_monitor_command_name: STRING = "LIST_SUPPORTED_SECURITY_SYSTEMS"
												-- This is the name of the custom monitor command that can be sent by the client to retrieve the supported security systems.
												-- If you change this, you must deploy clients and servers at the same time.  In other words - don't.

	security_monitor_command_header_response: STRING = "Supported SECURITY_SYSTEMS are:"
												-- This is first line returned in reponse to 'security_monitor_command_name'.  If you change this,
												-- you must deploy clients and servers at the same time.  In other words - don't.

	security_system_v2: PS_SECURITY_SYSTEM_V2
	-- One of the security systems that we support (server side).
	once
		check attached {PERSISTENT_SERVER} Current as al_persistent_server
		then
			create Result.make(al_persistent_server)
		end
	end

end
