note

	description:

		"Persistent task instance"

	author: "Mark Howard"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #10 $"
	path: "$File: //rose/source/kernel/entities/persistence/persistent_task_instance.e $"

class 
	PERSISTENT_TASK_INSTANCE

inherit
	PERSISTENT_TASK_INSTANCE_ACCESS

	PERSISTENT_TASK_COMMON
		undefine
			is_equal
		end

create 
	make,
	make_anonymous

feature -- Access

	related_tasks: ROSE_LINEAR_ARRAY [like Current]
			-- Related tasks
		local
			l_templates: ROSE_LINEAR_ARRAY [like context.task_template_template]
			l_template_history: ROSE_ENTITY_HISTORY [like context.task_template_template]
			l_instance_history: ROSE_ENTITY_HISTORY [like context.task_instance_template]
		do
			l_templates := context.task_template_to_task_instance.corelated_entities (Current)
			l_template_history := context.task_template_to_task_template.intervals_related_to_entities (l_templates)
			l_instance_history := context.task_template_to_task_instance.intervals_related_to_entities (l_template_history.witnesses_during (Void, Void))
			Result := l_instance_history.witnesses_during (Void, Void)
		end

	corelated_tasks: ROSE_LINEAR_ARRAY [like Current]
			-- Corelated tasks
		local
			l_templates: ROSE_LINEAR_ARRAY [like context.task_template_template]
			l_template_history: ROSE_ENTITY_HISTORY [like context.task_template_template]
			l_instance_history: ROSE_ENTITY_HISTORY [like context.task_instance_template]
		do
			l_templates := context.task_template_to_task_instance.corelated_entities (Current)
			l_template_history := context.task_template_to_task_template.intervals_corelated_to_entities (l_templates)
			l_instance_history := context.task_template_to_task_instance.intervals_related_to_entities (l_template_history.witnesses_during (Void, Void))
			Result := l_instance_history.witnesses_during (Void, Void)
			create Result.make_empty
		end

end -- class PERSISTENT_TASK_INSTANCE

