indexing
	description: "Query object to request the composite listings hash map"
	documentation: "[
	]"
	author: "Ueli Peter"
	last_editor: "$Author: upeter $"
	date: "$09-04-08 13:09$"
	revision: "$Revision: #5 $"
	path: "$File: //rose/source/kernel/entities/pes/pes_query_composites.e $"

class
	PES_QUERY_COMPOSITES

inherit
	ROSE_CS_QUERY

create
	make

feature {NONE} -- Creation

	make (a_context_id: like context_id) is
			-- Creation
		do
			context_id := a_context_id
		end

feature -- Attributes

	context_id: INTEGER

feature -- Basic operations

	execute_query (a_pes_server: PES_WORKER[PES_CONTEXT_AWARE]): PES_RESULT_COMPOSITES is
			-- execute recipe
		local
			l_context: ROSE_CONTEXT
			l_retried: BOOLEAN
		do
			if not l_retried then
				l_context ?= a_pes_server.context_from_id (context_id)
				if l_context = Void then
					raise ("unknown context")
				end
				create Result.make (query_id, l_context.composite_listings)
			end
		rescue
			create Result.make_exception (query_id, tag_name)
			l_retried := True
			retry
		end

	query_information: STRING is
			-- Returns informations about this query
		do
			Result := "PES_QUERY_COMPOSITES"
		end

end
