indexing
	description: "Query object to request an entity from the PES"
	documentation: "[
	]"
	author: "Ueli Peter"
	last_editor: "$Author: upeter $"
	date: "$09-04-08 13:09$"
	revision: "$Revision: #6 $"
	path: "$File: //rose/source/kernel/entities/pes/pes_query_entity.e $"

class
	PES_QUERY_ENTITY

inherit
	ROSE_CS_QUERY

create
	make

feature {NONE} -- Creation

	make (an_entity_id: like entity_id; a_category_id: like category_id; a_context_index: like context_index) is
			-- set values
		do
			entity_id := an_entity_id
			category_id := a_category_id
			context_index := a_context_index
		end

feature -- Access

	entity_id: INTEGER
		-- identifier for entity

	category_id: INTEGER
		-- identifier for category

	context_index: INTEGER
		-- index of context

feature -- Basic operations

	execute_query (a_pes_server: PES_WORKER[PES_CONTEXT_AWARE]): PES_RESULT_ENTITY is
			-- execute recipe
		local
			l_entity: ENTITY
			l_retried: BOOLEAN
		do
			if not l_retried then
				l_entity := a_pes_server.context_from_id(context_index).handler(category_id).entity (entity_id)
				create Result.make (query_id, l_entity)
			end
		rescue
			create Result.make_exception (query_id, tag_name)
			l_retried := True
			retry
		end

	query_information: STRING is
			-- Returns informations about this query
		do
			Result := "PES_QUERY_ENTITY"
		end

end
