indexing
	description: "Query the PES Servers state or execute a command"
	documentation: "[
	]"
	author: "Ueli Peter"
	last_editor: "$Author: upeter $"
	date: "$Date: 2009/01/12 $"
	revision: "$Revision: #7 $"
	path: "$File: //rose/source/kernel/entities/pes/pes_query_server_state.e $"

class
	PES_QUERY_SERVER_STATE

inherit
	ROSE_CS_QUERY

create
	make_db_version_request

feature {NONE} -- Creation

	make_db_version_request is
			-- Create a DB Version request
		do
			make (command_db_version)
		end

	make (a_type: INTEGER) is
			-- Creation
		do
			type := a_type
		end

feature -- Access

	type: INTEGER

	command_shutdown: INTEGER is 1
		-- shutdown command

	command_db_version: INTEGER is 2
		-- query the servers DB version

feature -- Basic operations

	execute_query (a_pes_server: PES_WORKER[PES_CONTEXT_AWARE]): PES_RESULT_SERVER_STATE is
			-- Query execution based on type
		local
			l_retried: BOOLEAN
		do
			if not l_retried then
				inspect type
				when command_shutdown then
					a_pes_server.shut_down
					create Result.make_with_message (query_id, "Server is shuting down!")
				when command_db_version then
					create Result.make_with_context_list (query_id, a_pes_server.db_versions)
				else
					create Result.make_exception (query_id, "Unknown query")
				end
			end
		rescue
			create Result.make_exception (query_id, tag_name)
			l_retried := True
			retry
		end

	query_information: STRING is
			-- Returns informations about this query
		do
			Result := "PES_QUERY_SERVER_STATE with type: " + type.out
		end

end

