indexing
	description: "replaces load_all_* calls in ZONE"
	documentation: "[
	]"
	author: "Ueli Peter"
	last_editor: "$Author: upeter $"
	date: "$Date: 2009/01/12 $"
	revision: "$Revision: #8 $"
	path: "$File: //rose/source/kernel/entities/pes_query_zone_loader.e $"
class
	PES_QUERY_ZONE_LOADER[G -> ENTITY]

inherit
	ROSE_CS_QUERY

create
	make

feature -- Creation

	make (a_context_index: like context_index) is
			-- set values
		do
			context_index := a_context_index
		end

feature -- Access

	mnemonic: CHARACTER
		-- menemonic of that zone

	context_index: INTEGER
		-- index of context

	companies: BOOLEAN
		-- are companies requested?

	securities: BOOLEAN
		-- securities requested?

	listings: BOOLEAN
		-- listings requested?

	government_issues: BOOLEAN
		-- government_issues requested?

	government_issuers: BOOLEAN
		-- government_issuers requested?

	government_issue_listings: BOOLEAN
		-- government_issue_listings requested?

	bonds: BOOLEAN
		-- bonds requested?

	bond_listing: BOOLEAN
		-- are bond_listings requested

	funds: BOOLEAN
		-- are funds requested?

	fund_issues: BOOLEAN
		-- are fund_issues_requested?

	fund_listings: BOOLEAN
		-- are fund_listings_requested?

	futures: BOOLEAN
		-- are futures requested?

	future_listings: BOOLEAN
		-- are future_listings requested?

	market_indexes: BOOLEAN
		-- are market indexes requested?

	market_index_listings: BOOLEAN
		-- are market listings requested?

feature -- Setters

	set_mnemonic (a_mnemonic: CHARACTER) is
		-- set `menemonic' to `a_mnemmonic'
		do
			mnemonic := a_mnemonic
		end

	set_context_index (a_context_index: INTEGER) is
		-- set `context_index' to `a_context_index'
		do
			context_index := a_context_index
		end

	set_companies (a_bol: BOOLEAN) is
			-- set `companies' to `a_bol'
		do
			companies := a_bol
		end

	set_securities (a_bol: BOOLEAN) is
			-- set `securities' to `a_securities'
		do
			securities := a_bol
		end

	set_listings (a_bol: BOOLEAN) is
			-- set `listings' to `a_listings'
		do
			listings := a_bol
		end

	set_government_issues (a_bol: BOOLEAN) is
			-- set `government_issues' to `a_bol'
		do
			government_issues := a_bol
		end

	set_government_issuers (a_bol: BOOLEAN) is
			-- set `government_issuers' to `a_bol'
		do
			government_issuers := a_bol
		end

	set_government_issue_listings (a_bol: BOOLEAN) is
			-- set `government_issue_listings ' to `a_bol'
		do
			government_issue_listings := a_bol
		end

	set_bonds (a_bol: BOOLEAN) is
			-- set `bonds' to `a_bol'
		do
			bonds := a_bol
		end


	set_bond_listing (a_bond_listing: BOOLEAN) is
		-- set `bond_listings' to `a_bond_listing'
		do
			bond_listing := a_bond_listing
		end

	set_funds (a_funds: BOOLEAN) is
		-- set `funds' to `a_funds'
		do
			funds := a_funds
		end

	set_fund_issues (a_fund_issues: BOOLEAN) is
		-- set `fund_issues' to `a_fund_issues'
		do
			fund_issues := a_fund_issues
		end

	set_fund_listings (a_fund_listings: BOOLEAN) is
		-- set `fund_listings' to `a_fund_listings'
		do
			fund_listings := a_fund_listings
		end

	set_futures (a_futures: BOOLEAN) is
		-- set `futures' to `a_futures'
		do
			futures := a_futures
		end

	set_future_listings (a_future_listings: BOOLEAN) is
		-- set `future_listings' to `a_future_listings'
		do
			future_listings := a_future_listings
		end

	set_market_indexes (a_market_indexes: BOOLEAN) is
		-- set `market_indexes' to `a_market_indexes'
		do
			market_indexes := a_market_indexes
		end

	set_market_index_listings (a_market_index_listings: BOOLEAN) is
		--set `market_index_listings' to `a_market_index_listings'
		do
			market_index_listings := a_market_index_listings
		end


feature -- Basic operations

	execute_query (a_pes_server: PES_WORKER[PES_CONTEXT_AWARE]): PES_RESULT_ZONE_LOADER[G] is
			-- get requested containers
		local
			l_zone: ZONE[LOCATION]
			l_rose_context: ROSE_CONTEXT
			l_retried: BOOLEAN
		do
			if not l_retried then
				l_rose_Context ?= a_pes_server.context_from_id(context_index)
				create Result.make (query_id, mnemonic, context_index)
				if l_rose_context /= void then
					l_zone := l_rose_Context.zone (mnemonic)
					if l_zone /= void then
						if companies and l_zone.all_companies_loaded then
							Result.set_table (l_zone.companies)
						end
						if bond_listing and l_zone.all_bond_listings_loaded then
							Result.set_table (l_zone.bond_listings)
						end
						if fund_issues and l_zone.all_fund_issues_loaded then
							Result.set_table (l_zone.fund_issues)
						end
						if fund_listings and l_zone.all_fund_listings_loaded then
							Result.set_table (l_zone.fund_listings)
						end
						if funds and l_zone.all_funds_loaded then
							Result.set_table (l_zone.funds)
						end
						if future_listings and l_zone.all_future_listings_loaded then
							Result.set_table (l_zone.future_listings)
						end
						if futures and l_zone.all_futures_loaded then
							Result.set_table (l_zone.futures)
						end
						if market_index_listings and l_zone.all_market_index_listings_loaded then
							Result.set_table (l_zone.market_index_listings)
						end
						if market_indexes and l_zone.all_market_indexes_loaded then
							Result.set_table (l_zone.market_indexes)
						end
						if securities and l_zone.all_securities_loaded then
							Result.set_table (l_zone.securities)
						end
						if listings  and l_zone.all_listings_loaded then
							Result.set_table (l_zone.listings)
						end
						if government_issues and l_zone.all_government_issuers_loaded then
							Result.set_table (l_zone.government_issues)
						end
						if government_issuers and l_zone.all_government_issuers_loaded then
							Result.set_table (l_zone.government_issuers)
						end
						if government_issue_listings and l_zone.all_government_issue_listings_loaded  then
							Result.set_table (l_zone.government_issue_listings )
						end
						if bonds and l_zone.all_bonds_loaded then
							Result.set_table (l_zone.bonds)
						end
						if Result.table = Void then
							Result.set_remote_exception ("Zone not loaded")
						end
					else
						Result.set_remote_exception ("Zone not found!")
					end
				end
			end
		rescue
			create Result.make_exception (query_id, tag_name)
			l_retried := True
			retry
		end

	query_information: STRING is
			-- Returns informations about this query
		do
			Result := "PES_QUERY_ZONE_LOADER for context: " + context_index.out
		end

end

