indexing
	description: "Result object for a call to {ENTITY_IDENTIFIER}.entity_list_from_identifier"
	author: "Jann Roeder"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #2 $"
	archive: "$File: //rose/source/kernel/entities/pes/pes_result_entity_list.e $"

class
	PES_RESULT_ENTITY_LIST

inherit
	ROSE_CS_RESULT
		redefine
			restore_result
		end

create
	make, make_exception

feature {NONE} -- Initialization

	make (a_query_id: INTEGER; a_entity_list: like entity_list) is
			-- Creation
		do
			query_id := a_query_id
			entity_list := a_entity_list
		end

feature -- Access

	entity_list: ROSE_LINEAR_ARRAY[ENTITY]

feature -- Operations

	restore_result (a_api: PES_CLIENT_API) is
			-- Restore references which were removed before sending
			-- and put all transmitted objects into their corresponding caches
		local
			l_i: INTEGER
			l_current_entity: ENTITY
		do
			from
				l_i := entity_list.lower
			until
				l_i > entity_list.upper
			loop
				l_current_entity := entity_list.item (l_i)
				l_current_entity.context.handler (l_current_entity.category_id).cache_entity (l_current_entity)

				l_i := l_i + 1
			end
		end

end
