note

	description:

		"Result object to send cached entities and identifiers to Client"

	author: "Ueli Peter"
	last_editor: "$Author: c4 $"
	date: "$Date: 2011/11/10 $"
	revision: "$Revision: #3 $"
	path: "$File: //rose/source/kernel/entities/pes/pes_result_load_category.e $"

class
	PES_RESULT_LOAD_CATEGORY

inherit
	ROSE_CS_RESULT
		redefine
			restore_result,
			prepare_result
		end

create
	make, make_exception

feature {NONE} -- Initialization

	make (an_id: INTEGER; a_identifiers: like identifiers; a_table_saved: like table_saved; a_entity_id_table_saved: like entity_id_table_saved) is
			-- Creation
		do
			query_id := an_id
			if a_identifiers /= Void then
				identifiers := a_identifiers.twin
			end
			if a_table_saved /= Void then
				table_saved := a_table_saved.twin
			end
			if a_entity_id_table_saved /= Void then
				entity_id_table_saved := a_entity_id_table_saved.twin
			end
		end

feature -- Access

	identifiers: HASH_TABLE [ENTITY_IDENTIFIER, INTEGER]
			-- Identifiers defined in this category

	table_saved: HASH_TABLE [ENTITY, INTEGER]
			-- entity table

	entity_id_table_saved: HASH_TABLE [ENTITY_ID_BASE, INTEGER]
			-- entity identifiers

feature -- Operations

	prepare_result is
			-- Set context on every identifier.
		do
			if identifiers /= Void then
				identifiers.linear_representation.do_all (agent set_context (void, ?))
			end
		end

	restore_result (a_api: PES_CLIENT_API) is
			-- Set context on every identifier.
		local
			l_stored_result: PES_STORED_REQUEST_CATEGORY_HANDLER
		do
			if identifiers /= Void then
				l_stored_result ?= a_api.requests.item (query_id)
				check
					valid_result: l_stored_result /= Void
				end
				identifiers.linear_representation.do_all (agent set_context (l_stored_result.category_handler.context, ?))
			end
			Precursor (a_api)
		end

feature {NONE} -- Implementation

	set_context (a_context: SUPPLIER_CONTEXT; a_identifier: ENTITY_IDENTIFIER) is
			-- set a_identifier.context
		do
			a_identifier.set_context (a_context)
		end

end


