indexing
	description: "Returns a String to the client"
	author: "Ueli Peter"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #4 $"
	archive: "$File: //rose/source/kernel/entities/pes/pes_result_server_state.e $"

class
	PES_RESULT_SERVER_STATE
inherit
	ROSE_CS_RESULT

create
	make_with_context_list, make_with_message, make_exception

feature {NONE} -- Creation

	make_with_context_list (a_id: INTEGER; a_contexts: like cached_contexts) is
			-- Create Result object for a list of cached contexts
		require
			contexts_not_void: a_contexts /= Void
		do
			cached_contexts := a_contexts
			query_id := a_id
		ensure
			contexts_set: cached_contexts /= Void and then cached_contexts.is_equal (a_contexts)
		end

	make_with_message (a_id: INTEGER; a_message: like message) is
			-- Create Result object with `a_message'
		require
			message_not_void: a_message /= Void
		do
			message := a_message
			query_id := a_id
		ensure
			message_set: message /= Void and then message.is_equal (a_message)
		end

feature -- Access

	cached_contexts: LIST[TUPLE[logical: STRING; path: STRING]]

	message: STRING

end
