indexing
	description: "Collection of metrics"
	author: "Zoran Simic"
	date: "$Date: 2009/07/30 $"
	revision: "$Revision: #3 $"

class
	PM_COLLECTION [G -> ANY create default_create end]

inherit
	PM_COMMON
		redefine
			is_equal
		end

feature -- Access

	items: ROSE_LINEAR_ARRAY [G]
	item (a_index: INTEGER): G is do if items.valid_index (a_index) then Result := items.item (a_index) end end
	lower: INTEGER is do Result := items.lower end
	upper: INTEGER is do Result := items.upper end
	count: INTEGER is do Result := items.count end
	is_empty: BOOLEAN is do Result := items.is_empty end
	first: G is do Result := items.first end
	last: G is do Result := items.last end

	is_equal (a_other: like Current): BOOLEAN is
			-- Is `a_other' attached to an object considered equal to current object?
		local
			i: INTEGER
		do
			Result := a_other /= Void and then count = a_other.count
			if count > 0 then
				from
					i := items.lower
				until
					not Result or else i > items.upper
				loop
					Result := equal (items.item (i),a_other.items.item (i))
					i := i + 1
				end
			end
		end

	out: STRING is
			-- New string containing terse printable representation of current object
		do
			Result := count.out + " items"
		end

feature {NONE} -- Implementation

	get_items (a_predicate: COLLECTING_PREDICATE [G]; a_args: ARRAY [ANY]) is
			-- load the items from the data source
		require
			predicate_not_void: a_predicate /= Void
			-- a_args_may_be_void: a_args = Void or a_args /= Void -- documentation only
		do
			create items.make_empty
			a_predicate.retrieve (Void,a_args)
			items := a_predicate.array
			if items = Void then
				create items.make_empty
			end
		ensure
			results_in_items: a_predicate.array.count = items.count
		end

invariant

	valid_items: items /= Void

end
