indexing
	description: "Common utility ancestor to process metrics classes"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #4 $"

deferred class
	PM_COMMON

inherit
	PM_AWARE
		export
			{NONE} all
		undefine
			out
		end
	DEBUG_OUTPUT
		undefine
			out
		end

feature -- Access

	debug_output: STRING is
			-- String that should be displayed in debugger to represent `Current'.
		do
			Result := out
		end
		
	pm_constants: PM_CONSTANTS is
			-- Constants for "PM_" classes
		do
			create Result
		ensure
			result_not_void: Result /= Void
		end

feature {NONE} -- Implementation

	get_last_identity: INTEGER is
		do
			Result := sql_query_integer (sql_last_identity,Void)
		end

	sql_query_integer (a_predicate: INTEGER_PREDICATE; a_args: ARRAY [ANY]): INTEGER is
		require
			a_predicate /= Void
		do
			if process_metrics.is_available then
				a_predicate.retrieve (Void,a_args)
				if a_predicate.array /= Void and then a_predicate.array.count /= 0 then
					Result := a_predicate.array.item (a_predicate.array.lower)
				end
			end
		end

	sql_last_identity: INTEGER_PREDICATE is
		once
			create Result.make (process_metrics.server, "SELECT CAST(@@IDENTITY as INT) as [ID]")
		end

end
