note

	description:

		"Result of a process metric test (failure)"

	author: "Mauricio Bustos"
	last_editor: "$Author: e2 $"
	date: "$Date: 2014/06/23 $"
	revision: "$Revision: #5 $"
	path: "$File: //rose/source/kernel/pm/pm_metric_test_result.e $"

class PM_METRIC_TEST_RESULT

create
	make

feature {NONE} -- Initialization

	make (a_message: STRING)
			-- Initializes current with `a_message' as message string
		require
			a_message_not_void: a_message /= Void
		do
			create message_string.make_from_string (a_message)
		ensure
			message_string_set: message_string ~ a_message
		end

feature -- Setting

	set_enable_process_failure (a_value: BOOLEAN)
			-- Sets `enable_process_failure' to `a_value'
		do
			enable_process_failure := a_value
		ensure
			enable_process_failure_set: enable_process_failure = a_value
		end

feature -- Access

	enable_process_failure: BOOLEAN
			-- Should we fail the process because of that result?

	message_string: STRING
			-- Explanation as of why the test failed

invariant
	message_string_not_void: message_string /= Void

end
