note

	description:

		"Definition of a metric type"

	author: "Zoran Simic"
	last_editor: "$Author: c4 $"
	date: "$Date: 2011/07/22 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/infrastructure/pm/pm_metric_type.e $"

class

	PM_METRIC_TYPE

inherit

	ANY
		redefine
			is_equal, out
		end

create

	default_create

feature -- Access

	metric_type_id: INTEGER
			-- Metric type id

	name: STRING
			-- Symbolic name of this metric type

	comment: STRING
			-- Comment of this metric type

	is_equal (other: like Current): BOOLEAN is
			-- Is `other' attached to an object considered
			-- equal to current object?
		do
			Result := metric_type_id = other.metric_type_id
		end

feature -- Output

	out: STRING is
			-- New string containing terse printable representation of current object
		do
			if name /= Void then
				Result := name
			else
				Result := "?"
			end
		end

end
