indexing
	description: "messages for portserver maintenance"
	author: "Ueli Peter"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #3 $"
	archive: "$File: //rose/source/kernel/infrastructure/network/port_server_command.e $"

class
	PORT_SERVER_COMMAND

inherit
	PORT_SERVER_MESSAGE

create
	make_from_message, make

feature -- Creation
	make_from_message (a_message: PORT_SERVER_MESSAGE) is
			-- use values from `a_message'
		do
			command_line := a_message.command_line
			machine := a_message.machine
			port := a_message.port
			rose_command := a_message.rose_command
			server_arguments := a_message.server_arguments
			user_id := a_message.user_id
			working_directory := a_message.working_directory
			executable := a_message.executable
		end

feature -- Access

	unregister_instance: BOOLEAN
		-- remove this instance from db and hashtables but let it stay alive

	spawn_passive: BOOLEAN
		-- server should spawn a new process but not advertise it to clients

	register_instance: BOOLEAN
		-- add this instance to DB and hash_tables

	process_id: INTEGER
		-- process id

	do_not_check_alive: BOOLEAN
		-- if true: do not check if running instance is alive

feature -- Basic operations

	set_do_not_check_alive (a_bol: BOOLEAN) is
			-- set `do_not_check_alive' to `a_bol'
		do
			do_not_check_alive := a_bol
		end

	set_unregister_instance (a_bol: BOOLEAN) is
			-- set `remove_instance' to `a_bol'
		do
			unregister_instance := a_bol
		end

	set_process_id (a_id: INTEGER) is
			-- 	set `process_id' tp `a_id'
		do
			process_id := a_id
		end

	set_spawn_passive (a_bol: BOOLEAN) is
			-- set `spawn_passive' to `a_port' and enable `a_bol'
		do
			spawn_passive := a_bol
		end

	set_register_instance (a_bol: BOOLEAN) is
			-- set `register_instance' to `a_port' and enable `a_bol'
		do
			register_instance := a_bol
		end



feature {NONE} -- Implementation

end
