indexing
	description: "Class representing a PROCESS_FLOWS context."
	author: "Julian Rogers"
	date: "$Date: 2009/08/11 $"
	last_review: "39510"
	revision: "$Revision: #6 $"
	archive: "$File: //rose/source/kernel/expert_system/process_flows_context.e $"

class
	PROCESS_FLOWS_CONTEXT
inherit
	ROSE_SUPPLIER_CONTEXT
		export {ANY}
			setup_attribute_types
		redefine
			make, entity_key_history
		end

create
	make

feature {NONE} -- Creation

	make (a_server: like server; a_name: STRING) is
			-- Create the context
		do
			Precursor {ROSE_SUPPLIER_CONTEXT} (a_server, a_name)
			task_template_accessor.cache_all_attributes
			all_cached := True
		end

	entity_key_history (a_entity: ENTITY;a_identifier: ENTITY_IDENTIFIER): ROSE_LINEAR_ARRAY [ENTITY_ATTRIBUTE_RECORD] is
			-- Return historical entity attribute records for identifier `a_identifier' for `a_entity'.
		do
			create Result.make_empty
			if not all_cached then
				key_predicate.set_container (Result)
				key_predicate.retrieve (Void,<<a_entity.category_id,a_identifier.handle,a_entity.handle>>)
			end
		end

	all_cached: BOOLEAN
		-- Are all entity attributes already cached? This speeds up loading of the server considerably
		-- as otherwise, each time we try to access an attribute that is not already cached, we end up going back to the database.

end
