indexing
	description: "Process manager"
	author: "Robert Bell"
	date: "$Date: 2009/07/22 $"
	revision: "$Revision: #15 $"

class
	PROCESS_MANAGER

feature -- Access

   name: STRING -- unique fullname of module
   mnemonic: STRING -- shortname, 8 bytes, unique
   parent: PROCESS_MANAGER
   operant_person: PERSON
   children: LIST[PROCESS_MANAGER]
   test_mode: BOOLEAN -- on snapshot prod data
   devel_mode: BOOLEAN -- on devel data
   snapshot_mode: BOOLEAN -- on snapshot database

   set_test_mode is
   		-- set mode to Test for non-degradational tests. Input data = production snapshot
     do
			test_mode := True
     end

   set_devel_mode is
   		-- set mode to devel. Input data may not be a snapshot from prod.
     do
			devel_mode := True
     end

   set_snapshot_mode is
   		-- set mode to devel. Input data may not be a snapshot from prod.
     do
			snapshot_mode := True
     end

    is_production_mode: BOOLEAN is
    		-- is this production mode?
    	do
    		Result := not devel_mode and not test_mode and not snapshot_mode
    	end


   notifier: NOTIFIER is
   		-- to log and email process messages
	once
	  create Result
	end

  arguments : ARGUMENTS is
	  once
		 create Result
	  end

   notify is
   		-- log or email process messages
      do
		 notifier.notify(name,arguments.argument(0))
      end

	terminate is
		-- terminate children and current process
      do
		 from children.start
		 until children.exhausted
		 loop
			children.item.terminate
			children.forth
		 end
		 terminate_me
      end

   clean_up is
   		-- to be redefined?
      do
      end

   exit is
   		--to be redefined?
      do
      end

   terminate_me is
   		-- terminate current process
      do
		 clean_up
		 notify
		 exit
      end

   traversal: TRAVERSAL_TYPE -- sequential,seq_restart,selective,
		 --choose_one_at_a_time,none

   response: INTEGER -- interactive, silent

   output_mode: INTEGER -- interactive(none), temporary, write

   current_user: STRING is
   		-- This should be global.env.user.login_id
	local
		env: EXECUTION_ENVIRONMENT
      once
	 		create env
	 		Result := env.get("USERNAME")
      end

end
