note

	description:

		"A collection of interval histories of listings associated with a portfolio."

	author: "Michael Zhang"
	last_editor: "$Author: it $"
	date: "$Date: 2014/01/22 $"
	revision: "$Revision: #11 $"
	path: "$File: //rose/source/kernel/investment_entities/production_holdings.e $"

class
	PRODUCTION_HOLDINGS

inherit
	LISTING_HOLDINGS

	ROSE_ACCESS
		undefine
			is_equal, copy
		end

	EVENT_ACCESS
		undefine
			is_equal, copy
		end
create
	make,
	make_empty,
	make_from_array,
	make_all,
	make_portfolio

feature {NONE} -- Initialization

	make_portfolio (a_zone : CHARACTER; a_name : STRING) is
			-- Initialize with holdings of portfolio with name `a_name' in `a_zone'.
		require
			valid_zone : ("UCEOJS").has_substring (a_zone.out.as_upper)
		local
			l_holdings_predicate : COLLECTING_PREDICATE[HOLDINGS_RECORD]
			l_records : ROSE_LINEAR_ARRAY[HOLDINGS_RECORD]
			l_holding : LISTING_HOLDING
		do
			make_empty
			portfolio_name := a_name
			l_holdings_predicate := holdings_predicates.item (a_zone)
			l_holdings_predicate.retrieve (Void, <<portfolio_name>>)
			l_records := l_holdings_predicate.array
			from l_records.start until l_records.off loop
				create l_holding.make_from_record (l_records.current_item)
				if l_holding.entity /= Void then
					add_holding (l_holding)
				end
				l_records.forth
			end
		end

end
