indexing
	author : "Tom Mead"
	description : ""
	keywords : ""
	
	
	
deferred class
	PROJECT
inherit
	ROSE_STORABLE
-- creation
--	make, retrieve_from_file
feature

	make is
			-- 
			deferred
			end
		
	display is
		--display view of project
		do
		end
	display_graph is
		--graph of project and precursor projects
		do
		end
	
	display_tasks is
		--list tasks and schedule
		do
		end
	update is
		do
		end
	
	is_finished: BOOLEAN
	set_finished is
		do
			is_finished:= True
		end
		
	project_leader: PERSON
	
	project_leader_name: STRING is
		do
			if project_leader /= Void then
				Result:= project_leader.name
			else
				Result:= "none"
			end		
		end
	
	assign_project_leader(a_person: PERSON) is
		do
			project_leader:= a_person
		end
		
	remove_project_leader is
		do
			project_leader:= Void
		end
	
	editors: HASH_TABLE[BOOLEAN,PERSON]
	-- list of people with write priveleges to project.  Project 
	-- leader by default
	is_writer(a_person: PERSON): BOOLEAN is
		do
		end
	has_precursors: BOOLEAN is
			-- 
		do
			Result:= precursor_projects /= Void and then precursor_projects.count > 0
		end
	has_dependents: BOOLEAN is
		do
			Result:= dependent_projects /= Void and then dependent_projects.count > 0
		end
	team: TEAM[PERSON] 
	
	delete_dependent_projects is
		do
			if dependent_projects /= Void then
				dependent_projects:= Void
			end
		end
	is_team_member(a_person: PERSON): BOOLEAN is
			-- 
			do
			end
			
	change_team is
		do
		end	
		
	set_completion_date(a_ccyymmdd: INTEGER)	 is
			-- 
			local
				l_date: ROSE_DATE
			do
				Create l_date.make_ccyymmdd(a_ccyymmdd)
				
				if completion_date_history /= Void then
					completion_date_history.extend(l_date)
				else
					create completion_date_history.make_empty
					completion_date_history.extend(l_date)
				end
			end

	completion_date_history: ROSE_LINEAR_ARRAY[ROSE_DATE]		
	
	completion_date: ROSE_DATE is
--		require
--			feasible: completion_date_hsitory.count > 0
		do
			if completion_date_history /= Void then
				Result:= completion_date_history.last	
			else
				create Result.make_undetermined
			end
		
		ensure			
		end
	revise_completion_date is
		do
		end
	
	days_remaining: INTEGER is
			-- days between now and current completion date
			local
				l_now: ROSE_DATE
			do
				create l_now.make_now
				Result := completion_date.diff_in_days(l_now)
			end

		
	
	name: STRING
	
	set_name(a_name: STRING) is
		do
			name:= a_name
		end
	
	classes: LIST[ROSE_CLASS]
	-- container of eiffel classes eminating from/required by? this project

--	tasks: ROSE_LINEAR_ARRAY[TASK]

	saved_tasks: ROSE_LINEAR_ARRAY[TASK]
	
	
	tasks: ROSE_LINEAR_ARRAY[TASK] is
		do
			if saved_tasks = Void then
				create saved_tasks.make_empty
				from task_table.start until task_table.off loop
					saved_tasks.extend(task_table.item_for_iteration)
					task_table.forth
				end
			end
			Result:= saved_tasks
		end
	
	task_table: HASH_TABLE[TASK, STRING]

--	fill_task_array is
--		do
--			create tasks.make_empty
--			from task_table.start until task_table.off loop
--				tasks.extend(task_table.item_for_iteration)
--			task_table.forth
--			end
--		end

--	fill_task_table is
--		local
--		do
--			if task_table = Void then
--				create task_table.make(20)
--			end
--			from tasks.start until tasks.off loop
--				task_table.put(tasks.current_item, tasks.current_item.name)
--				tasks.forth
--			end
--		end

	edit_task(a_task: TASK) is
			-- put task in task container
			do
				if task_table /= Void then
					task_table.search(a_task.name)
					if task_table.found then
						task_table.replace(a_task, a_task.name)
					end
				else
					print("task did not exist, cannot edit")
				end
				saved_tasks:= Void
			end


	add_task(a_task: TASK) is
			-- put task in task container
			do
				if task_table /= Void then
					task_table.put(a_task, a_task.name)
				else
					create task_table.make(20)
					task_table.put(a_task, a_task.name)
				end
			saved_tasks:= Void
			end
			
	remove_task(a_task: TASK) is
		-- remove task and reset saved_tasks to void so tasks will be repopulated
			do
				if task_table /= Void then
					task_table.search(a_task.name)
					if task_table.found then
						task_table.remove(a_task.name)
						saved_tasks:= Void
					else
						print("Trying to remove nonexistent task%N")
					end
				else
						print("No tasks to remove%N")
				end				

			end
		
	
	precursor_projects: ROSE_LINEAR_ARRAY[STRING]
	-- project can define and add/remove precursors but not dependents.  Dependent project must add precursor
	
	dependent_projects: ROSE_LINEAR_ARRAY[STRING]
	
	
	
	add_precursor_project(a_project: like Current) is
		deferred
		end
	
	remove_precursor_project(a_project: like Current) is
			-- 
			deferred
			end
		
	

		
	is_precursor_project(a_project: PROJECT) is
			-- 
			do
			end
	is_dependent_project(a_project: PROJECT) is
			-- 
			do
			end
			
	description: STRING
	
	set_description(a_description: STRING) is
		do
			description:= a_description
		end	
end
