class QUARTERLY_EXCHANGE_RATE
	-- Do NOT modify this file!
	-- Created by the CLASSIFIER:external_record_text on 04/17/2003 18:12:29.
inherit
	EXTERNAL_RECORD
		redefine
			display,
			write,
			read,
			record_length_,
			classifier_major_version_,
			classifier_minor_version_
		end
	C_ACCESS_SUPPORT
feature
	classifier_major_version_: INTEGER is 2
	classifier_minor_version_: INTEGER is 0

	rose_real_interpreter_: ROSE_VMS_REAL_INTERPRETER is
		once
			create Result
		end
	read is
		local
			i_: INTEGER
		do
			quarter := read_quarter
			if xrate = Void then create xrate.make(1,MCY_) end 
			from i_ := 1 until i_ > MCY_
			loop
				xrate.put(read_xrate(i_),i_)
				i_ := i_+1
			end
		end

	write is
		local
			i_: INTEGER
		do
			write_quarter(quarter)
			if xrate = Void then create xrate.make(1,MCY_) end 
			from i_ := 1 until i_ > MCY_
			loop
				write_xrate(xrate.item(i_),i_)
				i_ := i_+1
			end
		end

	record_length_: INTEGER is
		do
			Result := 4+4*(MCY_ - 1 + 1)
		end

	quarter : INTEGER
	read_quarter : INTEGER is
		do
			Result := integer_interpreter_.decode(pointer_ + (0),4)
		end
	write_quarter(a_value : INTEGER) is 
		do
			integer_interpreter_.encode(pointer_ + (0),a_value,4)
		end
	set_quarter(a_value : INTEGER) is 
		do
			quarter := a_value
		end

	xrate : ROSE_REAL_ARRAY
	read_xrate(an_index : INTEGER) : REAL is 
		do
			Result := rose_real_interpreter_.decode(pointer_ + (4+(an_index- 1)*4),4)
		end
	get_xrate_pointer : POINTER is 
		do
			Result := pointer_ + (4)
		end
	write_xrate(a_value : REAL;an_index : INTEGER) is 
		do
			rose_real_interpreter_.encode(pointer_ + (4+(an_index- 1)*4),a_value,4)
		end

	mcy_ : INTEGER is
		once
			Result := 90
		end

	display is
		local
			i_: INTEGER
		do
			print_all(<<"quarter"," : ",read_quarter,"%N">>)
			from i_ := 1 until i_ > MCY_
			loop
				print_all(<<"xrate(",i_,") : ", read_xrate(i_),"%N">>)
				i_ := i_+1
			end
		end
end

