indexing
	description: "Quarterly Exchange Rates"
	author: "Nelson Chui, Mark Howard"
	date: "$Date: 2009/10/09 $"
	revision: "$Revision: #7 $"
	archive: "$File: //rose/source/kernel/data/market/quarterly_exchange_rates.e $"

class QUARTERLY_EXCHANGE_RATES
	-- Do NOT modify this file!
	-- Created by the CLASSIFIER:external_record_text on 04/17/2003 18:12:29.
inherit
	EXTERNAL_RECORD
		redefine
			display,
			write,
			read,
			record_length_,
			classifier_major_version_,
			classifier_minor_version_
		end
	C_ACCESS_SUPPORT
feature -- External Record
	classifier_major_version_: INTEGER is 2
	classifier_minor_version_: INTEGER is 0

	read is
		local
			i_: INTEGER
		do
			if rates = Void then create rates.make (AIQL_,AIQH_) end
			from i_ := AIQL_ until i_ > AIQH_
			loop
				rates.put (read_rates (i_),i_)
				rates.item (i_).read
				i_ := i_+1
			end
		end

	write is
		local
			i_: INTEGER
		do
			from i_ := AIQL_ until i_ > AIQH_
			loop
				if rates.item (i_).pointer_=default_pointer
				then
					rates.item (i_).initialize_ (Current,0,4+4*(MCY_ - 1 + 1),AIQL_,AIQH_)
					rates.item (i_).set_i1_ (i_)
				end
				rates.item (i_).write
				i_ := i_+1
			end
		end

	record_length_: INTEGER is
		do
			Result := -12345*(AIQH_ - AIQL_ + 1)
		end

	return_rates_type_: QUARTERLY_EXCHANGE_RATE is
		do
			-- You don't call it, you say 'like return_XXX_type_'.
		end
	rates: ARRAY [like return_rates_type_]
	read_rates (an_index: INTEGER): like return_rates_type_ is
		do
			create Result
			Result.initialize_ (Current,0,4+4*(MCY_ - 1 + 1),AIQL_,AIQH_)
			Result.set_i1_ (an_index)
		end
	set_rates (a_value: like rates) is
			-- set rates
		do
			rates := a_value
		end

	aiql_ : INTEGER is
			-- AIQL_
		once
			Result := 25
		end

	aiqh_ : INTEGER is
			-- AIQH_
		once
			Result := 252 -- Ending December 2012
		end
	mcy_ : INTEGER is
			-- MCY_
		once
			Result := 90
		end
	display is
		local
			i_: INTEGER
		do
			from i_ := AIQL_ until i_ > AIQH_
			loop
				read_rates (i_).display
				i_ := i_+1
			end
		end
end

