indexing
	description: "Display info on current project instance from auto generated class"
	author: "Mauricio Bustos"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #3 $"

class
	RCMD_ABOUT_PROJECT_INSTANCE

inherit
	ROSE_COMMAND_GENERAL

feature -- Access

	id: STRING is "about_project_instance"
			-- Command id

	signature: STRING is "object_location:s"
			-- Argument signature of this command (defines valid parameters to be passed to the command)

feature -- Output

	help: STRING is
			-- Help on this command
"[
Display information about current application instance(name and version)
]"

feature {NONE} -- Implementation

	do_execute is
			-- Execute effectively the command.
		do
			if project_instance /= Void then
				if not Global.io_handler.has_output then
					Global.io_handler.set_output (create {ROSE_OUTCHANNEL_STANDARD}.make)
				end
				output ("system_name      : $1%N", <<project_instance.system_name>>)
				output ("owner            : $1%N", <<project_instance.owner>>)
				output ("source           : $1%N", <<project_instance.source>>)
				output ("machine          : $1%N", <<project_instance.machine>>)
				output ("estudio version  : $1%N", <<project_instance.eiffel_compiler_version>>)
				output ("timestamp        : $1%N", <<project_instance.timestamp>>)
				if parameters /= Void and parameters.value ("object_location") /= Void then
					Global.persist.store (project_instance, parameters.value ("object_location") + "\" + project_instance.system_name + ".rpi")
				end
			end
		end

	project_instance: ROSE_PROJECT_INSTANCE is
		once
			Result ?= Global.internal.new_instance_of (Global.internal.dynamic_type_from_string (Global.app.program_name.as_upper + "_PROJECT_INSTANCE"))
		end

end
