indexing
	description: "Aliased macro command"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #8 $"

class
	RCMD_ALIAS_MACRO

inherit
	ROSE_COMMAND_GENERAL
		redefine
			prepare, pre_execute, post_execute
		end

create
	make

feature {NONE} -- Initialization

	make (a_alias_name, a_signature: STRING) is
		require
			valid_alias: a_alias_name /= Void
			valid_signature: a_signature /= Void
		do
			id := a_alias_name
			signature := a_signature
			help := "Alias definition%NThis alias expands to: <" + signature + ">"
		end

feature -- Initialization

	prepare is
			-- Prepare the command for future execution
		do
			create parameters_signature.make (id,"*")
		end

feature -- Access

	id: STRING
			-- Command id

	signature: STRING
			-- Argument signature of this command (defines valid parameters to be passed to the command)
			-- Actual equivalent of this alias

feature -- Setting

	set_signature (a_value: STRING) is
			-- Change alias text to 'a_value'.
		do
			signature := a_value
		end

feature -- Output

	help: STRING
			-- Help on this command

feature {NONE} -- Implementation

	pre_execute is
			-- Pre-execution actions.
		do
		end

	do_execute is
			-- Execute effectively the command.
		do
			Global.commands.execute (
				Global.formatter.argumented (
					signature,
					Global.formatter.split_array (parameters.text,Global.convention.argument_separators,Global.convention.command_escapes,False)
				)
			)
		end

	post_execute is
			-- Post-execution actions.
		do
		end

end -- class RCMD_ALIAS_MACRO
