indexing
	description: "Die (exit application immediately) with an error code"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #3 $"

class
	RCMD_DIE

inherit
	ROSE_COMMAND_GENERAL

feature -- Access

	id: STRING is "die"
			-- Command id

	signature: STRING is "status_code=i message:s"
			-- Argument signature of this command (defines valid parameters to be passed to the command)

feature -- Output

	help: STRING is
			-- Help on this command
"[
Terminate application with a status code and eventually an error message
-status_code=<code>  Terminate application with given status <code>
-message=<message>   Signal error <message> while doing this
]"

feature {NONE} -- Implementation

	do_execute is
			-- Execute effectively the command.
		do
			error.die (parameters.integer ("status_code"),Global.app.program_name,parameters.value ("message"),Void)
		end

end -- class RCMD_DIE
