indexing
	description: "Display info on current IO configuration"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #4 $"

class
	RCMD_IO

inherit
	ROSE_COMMAND_GENERAL

feature -- Access

	id: STRING is "io"
			-- Command id

	signature: STRING is ""
			-- Argument signature of this command (defines valid parameters to be passed to the command)

feature -- Output

	help: STRING is
			-- Help on this command
"[
Display a list of all supported I/O channel types
]"

feature {NONE} -- Implementation

	do_execute is
			-- Execute effectively the command.
		do
			output_config (Global.io_handler.manager.input_channels)
			output_config (Global.io_handler.manager.output_channels)
		end

	output_config (a_manager: ROSE_SERVICE_MANAGER [ROSE_CHANNEL]) is
			-- Output config of 'a_manager'.
		local
			s: SEQUENCE [STRING]
		do
			output ("$1 defined channel types for $2: ",<<a_manager.count,a_manager.id>>)
			from
				s := a_manager.sorted_service_ids
				s.start
			until
				s.off
			loop
				output (s.item,Void)
				s.forth
				if not s.off then
					output (", ",Void)
				end
			end
			output ("%N",Void)
		end

end -- class RCMD_IO
