indexing
	description: "Browse objects dynamically"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #4 $"

class
	RCMD_OBJECT_BROWSER

inherit
	RCMD_WINDOW

feature -- Access

	id: STRING is "object_browser"
			-- Command id

	signature: STRING is "load:s"
			-- Argument signature of this command (defines valid parameters to be passed to the command)

	browser: ROSE_OBJECT_BROWSER

feature -- Status report

	is_unique: BOOLEAN is True
			-- Is this window unique for the whole application?

feature -- Output

	help: STRING is "Test suite for ROSE_COLORED_GRID"
			-- Help on this command

feature -- Basic operations

	check_prerequisites is
			-- Check that command's execution pre-requisites are met.
			-- Signal error if pre-requisistes are not met.
		do
			--| No prerequisites
		end

feature {NONE} -- Implementation

	do_execute is
			-- Execute effectively the command.
		do
			show
			if parameters.provided ("load") then
			end
			browser.add_listed_object ("Global",Global)
			browser.add_listed_object ("Gui",Gui)
		end

	initialize_window is
			-- Initialize 'window'.
		do
			window := Gui.factory.new_window ("Object Browser" , "magnify.ico", 450,350)
			Gui.factory.add_menu (window, True,Void)
			create browser.make (window)
		end

end
