indexing
	description: "Set a configuration value"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #3 $"

class
	RCMD_SET

inherit
	ROSE_COMMAND_GENERAL

feature -- Access

	id: STRING is "set"
			-- Command id

	signature: STRING is "key=s value:s"
		-- Argument signature of this command (defines valid parameters to be passed to the command)

feature -- Output

	help: STRING is
			-- Help on this command
"[
Set/display configuration values
-key=<key>     Display value of <key> in configuration
-value=<value> Set <key> to <value> in configuration
]"

feature {NONE} -- Implementation

	do_execute is
			-- Execute effectively the command.
		local
			l_key, l_value: STRING
		do
			l_key := parameters.value ("key")
			l_value := parameters.value ("value")
			if l_value /= Void then
				config.set (l_key,l_value)
			end
			output ("$1=$2%N",<<l_key,config.value (l_key)>>)
		end

end -- class RCMD_SET
