indexing
	description: "Sleep for a designated time amount"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #6 $"

class
	RCMD_SLEEP

inherit
	ROSE_COMMAND_GENERAL

feature -- Access

	id: STRING is "sleep"
			-- Command id

	signature: STRING is "absolute:i random:i"
		-- Argument signature of this command (defines valid parameters to be passed to the command)

feature -- Output

	help: STRING is
			-- Help on this command
"[
Sleep a given amount of time
-aboslute=<seconds> Sleep given number of seconds
-random=<seconds>   Sleep a random number of msec between 0 and <seconds>
]"

feature {NONE} -- Implementation

	do_execute is
			-- Execute effectively the command.
		local
			n: INTEGER
		do
			n := parameters.integer ("absolute")
			if n > 0 then
				trace ("Sleeping $1 seconds%N",<<n>>)
				Global.env.sleep (n*1000)
			end
			n := parameters.integer ("random")
			if n > 0 then
				n := random (n)*1000
				trace ("Sleeping $1 milliseconds%N",<<n>>)
				Global.env.sleep (n)
			end
		end

	random (n: INTEGER): INTEGER is
			-- Random integer between 0 and 'n'
		local
			t: TIME
		do
			if n > 0 then
				create t.make_now
				Result := t.seconds \\ (n+1)
			end
		end

end -- class RCMD_SLEEP
