indexing
	description: "Display application usage help"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #6 $"

class
	RCMD_USAGE

inherit
	ROSE_COMMAND_GENERAL

feature -- Access

	id: STRING is "usage"
			-- Command id

	signature: STRING is "cmd:s as_error:?"
		-- Argument signature of this command (defines valid parameters to be passed to the command)

feature -- Output

	help: STRING is
			-- Help on this command
"[
Display application usage
-cmd=<command> Display help on <command>
-as_error      General help on command usage signaled as an error message
no arguments:  Display general help on command usage
]"

feature {NONE} -- Implementation

	do_execute is
			-- Execute effectively the command.
		local
			l_command: ROSE_COMMAND
		do
			if parameters.provided ("cmd") then
				l_command := Global.commands.parsed_command (parameters.value ("cmd"))
				if l_command /= Void then
					output ("$1: <$2>%N$3%N",<<l_command.id,l_command.signature,l_command.help>>)
				end
			elseif parameters.boolean ("as_error") then
				error.signal (
					id,
					"$1%N$2%N%Nusage: $3 <commands>%NFor a list of available commands, use '$3 help'%N",
					<<	Global.app.name_version,
						Global.app.description,
						Global.app.program_name
					>>)
			else
				output ("$1%N$2%N",<<Global.app.name_version,Global.app.description>>)
				output ("%Nusage: $1 <commands>%NFor a list of available commands, use '$1 help'%N",<<Global.app.program_name>>)
			end
		end

end -- class RCMD_USAGE
