indexing
	description: "selection predicate for reference types"
	author: "David Schwartz (dz)"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #11 $"

deferred class
	REFERENCE_SELECTION_PREDICATE[G]

inherit
	GENERAL_SELECTION_PREDICATE[G]
		rename
			make as general_selection_predicate_make,
			make_explicit as make
		end
	-->>COPY_ABLE

feature
	forth is
			-- fetches the next record and stores the previous record
		require else
			True
		local
			l_triple: TRIPLE[G, BOOLEAN, BOOLEAN]
			l_after: BOOLEAN
		--	l_invoke_gc: CHARACTER_REF
		do
			if container /= Void then
				vessel := new_vessel
			else
				vessel := empty_vessel.standard_twin
			end

			if playback_movie
			then
				l_triple ?= cam.next_frame("forth").frame_data
				-- Potential problem.  The variable 'vessel' is supposed to be made by 'new_vessel'
				-- and then modified by 'facilitator.fetch(vessel)'.  Here we simply set
				-- 'vessel' to a new object.  Bug?  Time will tell.
				vessel := l_triple.first
				success := l_triple.second
				l_after := l_triple.third
				cam.compare_not_needed
			else
				--6/16/2000collection_off
				facilitator.fetch(vessel)
				--6/16/2000if needs_collecting then collection_on end
				success := facilitator.success
				l_after := facilitator.after
				debug("make_movies")
					if record_movie
					then
						create l_triple.make(vessel, success, l_after)
						cam.record_movie_frame("forth", l_triple)
					end
				end
			end

			if not l_after and success then
				index := index + 1
				item := vessel
				records_fetched := records_fetched + 1
				--6/16/2000if collecting
				--6/16/2000then
				-- Spur the garbage collector.  Since collection was off when facilitator.fetch was
				-- called, we perform a creation here while it is on.  If collection is
				-- off then there is no point.
				--6/16/2000	create l_invoke_gc
				--6/16/2000end
				--			if records_fetched \\ 65536 = 0 then
				--			   full_collect
				--			   full_coalesce
				--			end
			end
		end

	new_vessel : like empty_vessel is
		do
			Result := empty_vessel.standard_twin
		end

end
