indexing
	description: "Interface for return series type access"
	author: "Mauricio Bustos"
	last_editor: "$Author: it $"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #4 $"
	path: "$File: //rose/source/kernel/data/return_series.e $"

deferred class
	RETURN_SERIES
	
inherit
	ROSE_LEGACY_UNDEFINED

feature -- Access
	
  	total_return (a_currency: PERSISTENT_CURRENCY; a_start_date, a_end_date: ROSE_DATE): DOUBLE is
			-- Total return for a period
		require
			valid_dates: a_start_date /= Void and a_end_date /= Void
			meaningful_dates: a_start_date < a_end_date
  		do
			Result := constants.missing_double
  		end
	
  	price_return (a_currency: PERSISTENT_CURRENCY; a_start_date, a_end_date: ROSE_DATE): DOUBLE is
			-- Price level return for a period
		require
			valid_dates: a_start_date /= Void and a_end_date /= Void
			meaningful_dates: a_start_date < a_end_date
  		do
			Result := constants.missing_double
  		end
	
end




