indexing
	description: "Reuters2 price expression"
	author: "RJ"
	date: "$Date: 2009/01/09 $"
	revision: "$Revision: #9 $"
	path: "$Archive $"

class
	REUTERS2_PRICE_EXPRESSION

inherit
	SIGNATURE_TAGGED_EXPRESSION[REUTERS2_PRICE_TARGET]
		redefine
			value_in_market_currency,
			currency_anchor,
			double_value,
			real_value,
			make
		end

create
	make

feature -- Create
	make(a_variable_description: like variable_description) is
			-- create
		local
			l_units : STRING
		do
			Precursor(a_variable_description)
			if variable_description /= Void then
				l_units := variable_description.units
				if l_units /= Void and then l_units.substring_index("currency", 1) > 0 then
					has_currency_units := True
				end
			end
		end

feature -- Values

	currency_anchor: CURRENCY is
			-- Do not call this.  It's just here for anchored types.
		do
		end

	has_currency_units : BOOLEAN

	double_value(a_target : like expression_target) : DOUBLE is
			-- double value
		do
			Result := Precursor(a_target)
			if has_currency_units and then defined_double(Result) and then a_target.is_convert_currency then
				Result := Result / a_target.currency_convert_factor
			end
		end

	real_value(a_target : like expression_target) : REAL is
			-- real value
		do
			Result := Precursor(a_target)
			if has_currency_units and then defined_double(Result) and then a_target.is_convert_currency then
				Result := Result / a_target.currency_convert_factor
			end
		end

	value_in_market_currency(a_market: MARKET; a_to_currency: like currency_anchor; a_target: like expression_target; a_date: ROSE_DATE): DOUBLE is
			-- Converts the value of 'a_target' on 'a_date' into the currency of 'a_to_currency'.
			-- It looks like 'a_market' is a source of exchange rates.  If Void then the default source will be used.
--		local
--			l_currency : CURRENCY
--			l_unitied_value : ROSE_UNITIZED_VALUE[DOUBLE]
		do
			Result := Precursor(a_market, a_to_currency, a_target, a_date)

--
--			No need to call this conversion again, as value_in_currency will implicitly call double_value()			
--
--			if defined_double (Result) and then has_currency_units and then a_target.is_convert_currency then
--				Result := Result / a_target.currency_convert_factor
--			end

--		if a_target.is_GBp and equal(a_to_currency.iso, "GBP")
--		then
--			-- There is no exchange rate between GBp (pence) and GBP (pounds) so don't even try.
--			Result := double_value(a_target)
--			if defined_double(Result)
--			then
--				Result := Result / 100
--			end
--		else
--			Result := Precursor(a_market, a_to_currency, a_target, a_date)
--			if defined_double(Result) and then a_target.is_GBp
--			then
--				Result := Result * 0.01
--			end
--		end

		end

end
