note

	description:

		"Make reuters attribute_type_id's generally available."

	author: "Randy John"
	last_editor: "$Author: da $"
	date: "$Date: 2013/06/26 $"
	revision: "$Revision: #11 $"
	path: "$File: //rose/source/kernel/supplier_data/reuters_attribute_type_id_use.e $"

class

	REUTERS_ATTRIBUTE_TYPE_ID_USE

inherit

	REUTERS_ID_RETRIEVER

feature -- Access

	quote_id_type_id: INTEGER
			-- Attribute handle for quote_id.
		once
			Result := reuters_id.item (reuters_attribute_type_statement ("QUOTE ID"))
		ensure
			result_not_0: Result /= 0
		end

	ric_type_id: INTEGER
			-- Attribute handle for ric.
		once
			Result := reuters_id.item (reuters_attribute_type_statement ("RIC"))
		ensure
			result_not_0: Result /= 0
		end

	primary_trading_ric_type_id: INTEGER
			-- Attribute handle for primary_trading_ric.
		once
			Result := reuters_id.item (reuters_attribute_type_statement ("PRIMARY TRADING RIC"))
		ensure
			result_not_0: Result /= 0
		end

	sedol_type_id: INTEGER
			-- Attribute handle for sedol.
		once
			Result := reuters_id.item (reuters_attribute_type_statement ("SEDOL"))
		ensure
			result_not_0: Result /= 0
		end

	isin_type_id: INTEGER
			-- Attribute handle for isin.
		once
			Result := reuters_id.item (reuters_attribute_type_statement ("ISIN"))
		ensure
			result_not_0: Result /= 0
		end

	cusip_type_id: INTEGER
			-- Attribute handle for cusip.
		once
			Result := reuters_id.item (reuters_attribute_type_statement ("CUSIP"))
		ensure
			result_not_0: Result /= 0
		end

	mic_type_id: INTEGER
			-- Attribute handle for mic.
		once
			Result := reuters_id.item (reuters_attribute_type_statement ("MIC"))
		ensure
			result_not_0: Result /= 0
		end

	opol_type_id: INTEGER
			-- Attribute handle for opol.
		once
			Result := reuters_id.item (reuters_attribute_type_statement ("OPOL"))
		ensure
			result_not_0: Result /= 0
		end

	is_asset_active_flag_type_id: INTEGER
			-- Attribute handle for is_asset_active_flag.
		once
			Result := reuters_id.item (reuters_attribute_type_statement ("IS ASSET ACTIVE FLAG"))
		ensure
			result_not_0: Result /= 0
		end

	is_primary_issue_flag_type_id: INTEGER
			-- Attribute handle for is_primary_issue_flag.
		once
			Result := reuters_id.item (reuters_attribute_type_statement ("IS PRIMARY ISSUE FLAG"))
		ensure
			result_not_0: Result /= 0
		end

	issuer_name_type_id: INTEGER
			-- Attribute handle for issuer_name.
		once
			Result := reuters_id.item (reuters_attribute_type_statement ("ISSUER NAME"))
		ensure
			result_not_0: Result /= 0
		end

	security_description_type_id: INTEGER
			-- Attribute handle for security_description.
		once
			Result := reuters_id.item (reuters_attribute_type_statement ("SECURITY DESCRIPTION"))
		ensure
			result_not_0: Result /= 0
		end

	exchange_code_type_id: INTEGER
			-- Attribute handle for exchange_code.
		once
			Result := reuters_id.item (reuters_attribute_type_statement ("EXCHANGE CODE"))
		ensure
			result_not_0: Result /= 0
		end

	exchange_description_type_id: INTEGER
			-- Attribute handle for exchange_description.
		once
			Result := reuters_id.item (reuters_attribute_type_statement ("EXCHANGE DESCRIPTION"))
		ensure
			result_not_0: Result /= 0
		end

	exchange_country_code_type_id: INTEGER
			-- Attribute handle for exchange_country_code.
		once
			Result := reuters_id.item (reuters_attribute_type_statement ("EXCHANGE COUNTRY CODE"))
		ensure
			result_not_0: Result /= 0
		end

	exchange_country_code_description_type_id: INTEGER
			-- Attribute handle for exchange_country_code_description.
		once
			Result := reuters_id.item (reuters_attribute_type_statement ("EXCHANGE COUNTRY CODE DESCRIPTION"))
		ensure
			result_not_0: Result /= 0
		end

feature {NONE} -- Implementation

	reuters_attribute_type_statement (a_value: STRING): STRING is
			-- Statement to select attribute handle for `a_value'.
		require
			a_value_not_void: a_value /= Void
		do
			Result := "select attribute_type_id from attribute_type where name = '"
			Result.append (a_value)
			Result.append ("'")
		end

end
