indexing
   
   description: "Reuters entity."
   status: "Development"
   author: "Randy John"
   date: "$Date: 2008/12/01 $"
   revision: "$Revision: #11 $"
   
class
   
   REUTERS_ENTITY
   
inherit
   
   SUPPLIER_ENTITY
      redefine
	 case_sensitive
      end
   
create
   
   default_create,
   make,
   make_empty,
   make_from_database,
   make_from_attribute,
   make_from_attribute_calling,
   make_from_attribute_set,
   make_from_historical_attribute,
   make_start,
   attempt_make_from_attribute
   
feature {SUPPLIER_ENTITY_CACHE,SUPPLIER_ENTITY_RELATIONSHIP_CACHE} -- Implementation
   
   server : ENTITY_SERVER[REUTERS_ENTITY] is
      once
	 create Result.make(data_server)
      end
   
   data_server: SQL_DATA_SERVER is
      once
	 Result := servers.reuters_server
      end
   
   case_sensitive: BOOLEAN is
	 -- For instance, RIC's ACA.M and ACa.M.
      once
	 Result := True
      end
   
   supplier_product_id: INTEGER is
      once
	 Result := servers.reuters_supplier_product_id
      end
   
end -- class REUTERS_ENTITY
