note

	description:

		"Retuers Listing"

	author: "Michael Zhang"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #20 $"
	path: "$File: //rose/source/kernel/supplier_data/reuters_price_listing.e $"

class
	REUTERS_PRICE_LISTING

inherit
	SUPPLIER_LISTING
		undefine
			ur_targets,
			ur_price_target
		end
	REUTERS_AWARE
create
	make,
	make_anonymous

feature -- Access

	ur_price_target : REUTERS2_PRICE_TARGET is
			-- ur price target
		once
			create Result
		end

	ur_price_target2 : REUTERS2_PRICE_TARGET is
			-- ur price target2
		once
			create Result
		end

	ur_targets : ROSE_LINEAR_ARRAY[ROSE_ENTITY_DATE[REUTERS_PRICE_LISTING]] is
			-- ur targets
		once
			create Result.make_empty
			Result.extend(ur_price_target)
			Result.extend(ur_price_target2)
		end

feature -- States

	is_consolidated(a_date : ROSE_DATE) : BOOLEAN is
			-- is consolidated
		local
			l_ex_string : STRING
			l_ex_code : INTEGER
		do
			l_ex_string := exchange_code(a_date)
			if l_ex_string /= Void and then l_ex_string.is_integer then
				l_ex_code := l_ex_string.to_integer
				-- regional unconsolidated exchange in US
				if l_ex_code <= 8 then
					Result := False
				else
					Result := True
				end
			else
				Result := True
			end
		end

	exchange_code(a_date : ROSE_DATE) : STRING is
			-- exchange code
		do
			Result := attribute_by_name ("EXCHANGE CODE", a_date)
			if Result /= Void then
				Result.prune_all(' ')
			end
		end

feature -- Price report

	price_report: REUTERS_PRICE_REPORT is
			-- Price report
		once
			create Result.make
		end

end
