indexing
	description: "Reuters Price Report"
	author: "Michael Zhang"
	date: "$Date: 2008/12/01 $"
	path: "$File: //rose/source/kernel/supplier_data/reuters_price_report.e $"
	revision: "$Revision: #15 $"

class
	REUTERS_PRICE_REPORT

inherit
	ROSE_SIGNATURE_TAGGED_REPORT[REUTERS_PRICE_LISTING, REUTERS2_PRICE_TARGET]
		rename
			make as simple_signature_report_make
		redefine
			double_item
		end
	REUTERS_AWARE
		rename
			context as reuters_context
		end
	ROSE_AWARE
		rename
			context as rose_context
		end
create
	make, test

feature -- Access
	make is
			-- make
		do
			simple_signature_report_make("price_data_set","price_data_set")
		end

	entity_id(a_target : like ur_target) : INTEGER is
			-- entity id
		do
			if a_target /= Void then
				Result := a_target.entity_id
			end
		end

	double_item(a_expression : like expression_template; a_target : like ur_target) : DOUBLE is
			-- double item
		do
			Result := Precursor(a_expression, a_target)
			if not valid_double(Result) then
				Result := constants.missing_double
			end
		end

	valid_double(a_double : DOUBLE) : BOOLEAN is
			-- valid double
		do
			if (not constants.defined_double(a_double)) or (constants.defined_double(a_double) and then a_double = 0) then
				Result := False
			else
				Result := True
			end
		end
feature -- test
	test(a_size : INTEGER) is
			-- test
		local
		--	l_server : ROSE_CONTEXT_SERVER
			l_context : REUTERS_CONTEXT
			l_rose_context : ROSE_CONTEXT
			l_rose_entities, l_entities : ROSE_LINEAR_ARRAY[ENTITY]
			l_entity : ENTITY
			l_zone : ZONE[LOCATION]
			i : INTEGER
			l_targets : like targets
			l_array : like double_array
			l_matrix : MATRIX
		do
			make
		--	create l_server
			l_rose_context ?= rose_context --l_server.context_from_name("ROSE ENTITY FOREGROUND")
			l_context ?= reuters_context --l_server.context_from_name("REUTERS")

			l_zone := l_rose_context.u_zone
			create l_rose_entities.make(1, a_size)
			from i := 1 until i > a_size loop
				l_entity := l_zone.listing(i)
				l_rose_entities.put(l_entity, i)
				i := i + 1
			end

			l_entities := l_context.listing_accessor.transformation(l_rose_entities)
--			set_entity_neighborhood(l_entities)

--			l_targets := targets(l_entities.item(1))
			l_array := double_series(l_targets, "close")
			l_matrix := double_matrix(l_targets)
		end

feature -- Implementation
	entity_from_id(a_entity_id : INTEGER) : like entity_anchor is
			-- entity from id
		do
			Result ?= ur_target.context.handler(3).entity(a_entity_id)
		end
end
