indexing
	description: "Reuters signature tagged record"
	author: "RJ"
	date: "$Date: 2009/03/06 $"

class
	REUTERS_SIGNATURE_RECORD

inherit
	ROSE_SIGNATURE_RECORD[LISTING]
		redefine
			data_manager,
			context,
			data_fields_string_,
			new_variable_template
		end

create
	default_create
create {REUTERS_SIGNATURE_RECORD}
	rose_entity_date_make
feature  --Properties
	entity_id: INTEGER

	currency_id: INTEGER

	period_end_date: ROSE_DATE

	periodicity_id: INTEGER

	value_description_id: INTEGER

feature  --Field names
	-- This is only the uniquely identifying fields.
	fields_: STRING is "entity_id,period_end_date,periodicity_id,value_description_id"
--	fields_: STRING is "entity_id,currency_id,period_end_date,periodicity_id,value_description_id"

	data_fields_string_: STRING is "currency_id"

feature  --Property setting
	set_entity_id(a_value: like entity_id) is
	do
		entity_id := a_value
	end

	set_currency_id(a_value: like currency_id) is
	do
		currency_id := a_value
	end

	set_period_end_date(a_value: like period_end_date) is
	do
		period_end_date := a_value
	end

	set_periodicity_id(a_value: like periodicity_id) is
	do
		periodicity_id := a_value
	end

	set_value_description_id(a_value: like value_description_id) is
	do
		value_description_id := a_value
	end

	context: REUTERS_CONTEXT is
			-- Reuters context
	once
		create Result.make
	end

	context_name : STRING is
	do
		exceptions.raise("Not implemented.")
	end
	exceptions : EXCEPTIONS is
		once
			create Result
		end

	expression_tag : STRING is "listing"

	restriction_statement : STRING is "#entity_id.id = entity_id and #period_end_date.id = period_end_date and #periodicity_id.id = periodicity_id"

	set_data_manager(a_data_manager: SIGNATURE_TAGGED_ITEM_DATABASE[REUTERS_SIGNATURE_RECORD]):
		SIGNATURE_TAGGED_ITEM_DATABASE[REUTERS_SIGNATURE_RECORD]is
	once
		if a_data_manager/=Void
		then
			Result := a_data_manager
		else
			create Result.make("", servers.reuters_server)
		end
	end

	new_variable_template : SIGNATURE_TAGGED_EXPRESSION[REUTERS_SIGNATURE_RECORD] is
		--template
		do end


	data_manager : SIGNATURE_TAGGED_ITEM_DATABASE[REUTERS_SIGNATURE_RECORD] is
	once
		Result := set_data_manager(Void)
	end
end
