indexing
	description : "This class handles the RMDAT listing mappings found in the legacy system"
	author : "Mauricio Bustos"
	date: "$Date: 2009/10/01 $"
	revision: "$Revision: #7 $"
	path : "$File: //rose/source/kernel/data/market/rmdat_listing_map.e $"

class

	RMDAT_LISTING_MAP

feature

	mapped_listing(a_listing : LISTING) : LISTING is
		local
			l_listing_map : HASH_TABLE[INTEGER,INTEGER]
		do
			l_listing_map := listing_map(a_listing.context)
			l_listing_map.search(a_listing.handle)
			if l_listing_map.found then
				if l_listing_map.found_item.is_equal (a_listing.handle) then
					print("Handle:"+a_listing.handle.out + " is mapped to itself%N")
				else
					Result ?= a_listing.context.entity_at(a_listing.context.listing_category_id,l_listing_map.found_item)
				end
			end
		end

feature {NONE}

	listing_maps : HASH_TABLE[HASH_TABLE[INTEGER,INTEGER],STRING] is
		once
			create Result.make(10)
		end

	listing_map(a_context : ROSE_CONTEXT) : HASH_TABLE[INTEGER,INTEGER] is
		do
			listing_maps.search(a_context.name)
			if not listing_maps.found then
				create Result.make(10)
				listing_map_selection(a_context.server,"9413O","15200U").apply(agent handle_maps(?,Result),Void,Void)
				listing_map_selection(a_context.server,"10380O","15414U").apply(agent handle_maps(?,Result),Void,Void)
				nvd_selection(a_context.server).apply(agent handle_maps(?,Result),Void,Void)
				listing_maps.force(Result,a_context.name)
			else
				Result := listing_maps.found_item
			end
		end

	handle_maps(a_row : STRING; a_map : HASH_TABLE[INTEGER,INTEGER]) is
		local
			l_delimited : ROSE_DELIMITED_TEXT
		do
			create l_delimited.make(a_row,'|')
			a_map.force(l_delimited.item(2).to_integer,l_delimited.item(1).to_integer)
		end

	listing_map_selection(a_server : SQL_DATA_SERVER; a_from, a_to : STRING) : STRING_PREDICATE is
		do
			create Result.make(a_server,"select cast(a.entity_id as varchar) + '|' + cast(b.entity_id as varchar) as map from entity_attribute a, entity_attribute b where " +
							   "a.category_id = 3 and a.attribute_value = '" + a_from + "' and " +
							   "b.category_id = 3 and b.attribute_value = '" + a_to + "'" + " and a.entity_id <> b.entity_id")
		end

	nvd_selection(a_server : SQL_DATA_SERVER) : STRING_PREDICATE is
		do
			create Result.make(a_server,"select cast(a.entity_id as varchar) + '|' + cast(b.entity_id as varchar) as map from entity_attribute a, entity_attribute b where " +
							   "a.category_id = 3 and a.attribute_value like '%%NVD%%' and " +
							   "b.category_id = 3 and b.attribute_value = substring(a.attribute_value,1,9) + '091...' + substring(a.attribute_value,16,18)")
		end

end







