indexing
	description: "Application information"
	author: "Zoran Simic"
	archive: "$File: //rose/source/kernel/infrastructure/framework/application/rose_application_variables.e $"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #5 $"

class
	ROSE_APPLICATION_VARIABLES

create {ROSE_APPLICATION}
	make

feature {NONE} -- Initialization

	make is
			-- Identify current application running.
		do
			create hash.make (0)
		end

feature -- Access

	hash: HASH_TABLE [STRING, STRING]
			-- Symbolic application variables

	value (a_key: STRING): STRING is
		do
			Result := hash.item (a_key)
		end

feature -- Basic operations

	set (a_key, a_value: STRING) is
		do
			if a_key /= Void then
				a_key.left_adjust
				a_key.right_adjust
				a_key.to_lower
				hash.force (a_value, a_key)
			end
		end

end
