note

	description:

		"Bond records."

	author: "mk"
	last_editor: "$Author: er $"
	date: "$Date: 2014/03/24 $"
	revision: "$Revision: #7 $"
	path: "$File: //rose/source/kernel/investment_entities/rose_bond_record.e $"

class
	ROSE_BOND_RECORD

inherit
	ROSE_ENTITY_DATE[BOND]
		redefine
			date
		end

create
	make,default_create,make_from_record

feature -- Basic operations

	bond_server : SQL_DATA_SERVER is
		-- server
		once
			;(create {EXCEPTIONS}).raise ("VMS is no longer supported")
		end
	bond_reader : COLLECTING_PREDICATE[RDB_BOND_RECORD] is
		-- bond reader
		once
			create Result.make(bond_server,"select * from bondp where rxrf = ? and marketday <= ? order by marketday desc limit to 1 row")
		end
	bond_targets : ROSE_LINEAR_ARRAY[ROSE_BOND_RECORD] is
		-- bond records
		local
			l_records : ROSE_LINEAR_ARRAY[RDB_BOND_RECORD]
			l_target : like Current
		do
			create Result.make_empty
			bond_reader.retrieve(void,<<rxrf,ccyymmdd>>)
			l_records := bond_reader.array
			from l_records.start until l_records.off loop
				create l_target.make_from_record(l_records.current_item)
				Result.extend(l_target)
				l_records.forth
			end
		end
	date : ROSE_DATE
		-- date
	make_from_record(a_record : RDB_BOND_RECORD) is
		-- create bond from record
		do
			create record.make(a_record)
			create date.make_ccyymmdd(a_record.marketday)
		end
	record : BOND_PRICE_RECORD
		-- record
	last_record (a_rxrf : INTEGER;a_date : ROSE_DATE) : ROSE_BOND_RECORD is
		--last
		local
			l_ccyymmdd : INTEGER
			l_records : like bond_targets
		do
			l_ccyymmdd := a_date.ccyymmdd
			if rxrf /= a_rxrf or a_date.ccyymmdd /= ccyymmdd then
				rxrf := a_rxrf
				ccyymmdd := l_ccyymmdd
				l_records := bond_targets
				if l_records /= void and then not l_records.is_empty then
					Result := l_records.first
				end
			end
		end
	last_record_saved : ROSE_BOND_RECORD
		-- last record saved
	rxrf : INTEGER
		-- rxrf
	ccyymmdd : INTEGER
		-- ccyymmdd
	set_rxrf (a_rxrf : INTEGER) is
		-- set rxrf
		do
			rxrf := a_rxrf
		end
	set_ccyymmdd (a_ccyymmdd : INTEGER) is
		-- set ccyymmdd
		do
			ccyymmdd := a_ccyymmdd
		end
end -- class ROSE_BOND_RECORD
