indexing
	description: "";
	date: "$Date: 2008/12/01 $";
	revision: "$Revision: #10 $"

class
	ROSE_CALENDAR

create
	make

feature {NONE} -- Implementation

	make (a_marked_date: ROSE_DATE) is
		do
			create marked_date.make_today
			set (a_marked_date)
		end

feature -- Access

	marked_date: ROSE_DATE

	julian_month: INTEGER is
		do
			Result := marked_date.julian_month
		end

	quarter_begin_julian_month: INTEGER is
		do
			Result := marked_date.quarter_beginning_month
		end

	quarter_end_julian_month: INTEGER is
		do
			Result := marked_date.quarter_ending_month
		end

	start_of_julian_month (a_month: INTEGER): ROSE_DATE is
		do
			create Result.make ((1950 + (a_month - 1)// 12),(a_month - 1) \\ 12 + 1, 1)
		end

	end_of_julian_month (a_month: INTEGER): ROSE_DATE is
		do
		   Result := start_of_julian_month(a_month)
		   Result.set_to_end_of_month
		end

feature -- Basic operations

	set (a_marked_date: ROSE_DATE) is
		require
			a_marked_date /= Void
		do
			marked_date.set_date (a_marked_date.year, a_marked_date.month, a_marked_date.day)
		end

	set_julian_month (a_month: INTEGER) is
		do
			marked_date.make((1950 + (a_month - 1) // 12),(a_month - 1) \\ 12 + 1, 1)
		end

	add_n_days (a_days: INTEGER) is
		do
			marked_date.add_n_days(a_days)
		end

	add_n_months (a_months: INTEGER) is
		do
			marked_date.add_n_months(a_months)
		end

end
