note
	description: "Features implementing date conventions in rose capact context"
	author: "Broos Nemanic"
	last_editor: "$Author: it $"
	date: "$Date: 2014/02/24 $"
	revision: "$Revision: #2 $"
	path: "$File: //rose/source/kernel/capital_actions/rose_capact_date_use.e $"

deferred class
	ROSE_CAPACT_DATE_USE

inherit

	SHARED_TODAY

feature -- Validity.
	safe_date_from_ccyymmdd (a_date: INTEGER): ROSE_DATE
			-- Always returns a valid (possibly unavailable) date.
		do
			if today.is_valid_ccyymmdd_date (a_date.out) then
				create Result.make_ccyymmdd (a_date)
			else
				create Result.make_unavailable
			end
		ensure
			result_not_void: Result /= Void
			unavailable_on_invalid_input: (not today.is_valid_ccyymmdd_date (a_date.out)) implies Result.is_unavailable
			available_otherwise: today.is_valid_ccyymmdd_date (a_date.out) implies Result.is_available
		end

end
