indexing
	description: "Signature for override of rose complex capital actions (ska. options)"
	author: "Srilatha Singh"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #9 $"
	archive: "$File: //rose/source/kernel/capital_actions/rose_capact_option_override_signature.e $"

class
	ROSE_CAPACT_OPTION_OVERRIDE_SIGNATURE

inherit
	ROSE_SIGNATURE_RECORD[ENTITY]
	redefine
		data_fields_string_,
		is_valid
	select
		is_equal
	end
	OVERRIDE_AUDIT_FIELDS
	rename
		is_equal as ovrrd_audit_is_equal,
		user_id as user_name, set_user_id as set_user_name
	end
create
	default_create,make_from_option_signature

feature -- creation

	make_from_option_signature (a_sig: CAPACT_OPTION_SIGNATURE_RECORD) is
			-- make from signature of overriden option
		do
			listing_id := a_sig.listing_id
			instrument_id := a_sig.instrument_id
			market_id := a_sig.market_id
			exdate := a_sig.exdate
			option_number := a_sig.option_number
		end


feature -- Access

	listing_id : INTEGER
	set_listing_id (a_value: like listing_id) is
		do
			listing_id := a_value
		end

	exdate : INTEGER
	set_exdate (a_value: like exdate) is
	do
		exdate := a_value
	end

	option_number : INTEGER
	set_option_number (a_value: like option_number) is
	do
		option_number := a_value
	end

	option_expression : STRING
	set_option_expression (a_value: like option_expression) is
	do
		option_expression := a_value
	end

	status_code : STRING
	set_status_code (a_value: like status_code) is
	do
		status_code := a_value
	end

	instrument_id : INTEGER
	set_instrument_id (a_value: like instrument_id) is
	do
		instrument_id := a_value
	end

	market_id : INTEGER
	set_market_id (a_value: like market_id) is
	do
		market_id := a_value
	end


--	override_type_id: INTEGER
--	set_override_type_id(a_value: like override_type_id) is
--	do
--		override_type_id := a_value
--	end

	end_date:ROSE_DATE
	set_end_date(a_value: like end_date) is
	do
		end_date := a_value
	end

--	user_name:STRING
--	set_user_name(a_value: like user_name) is
--	do
--		user_name := a_value
--	end

--	entry_date:ROSE_DATE
--	set_entry_date(a_value: like entry_date) is
--	do
--		entry_date := a_value
--	end

	is_valid:BOOLEAN
	set_is_valid(a_is_valid:BOOLEAN) is
	do
		is_valid := a_is_valid
	end

--	comment:STRING
--	set_comment(a_value :like comment) is
--	do
--		comment := a_value
--	end


feature -- Basic operations

	set_entity_id(a_value:INTEGER) is
		do
			listing_id := a_value
		end


	expression_tag:STRING is
		do
			Result := "listing"
		end

--	fields_:STRING is "instrument_id,market_id,exdate,option_number"
	fields_: STRING is "listing_id,exdate,option_number"

	data_fields_string_:STRING is "option_expression,status_code,override_type_id,instrument_id,market_id,end_date,user_name,entry_date,is_valid"

--	signature_statement: STRING is "#instrument_id.id = instrument_id and #market_id.id = market_id and #exdate.id = exdate and #option_number.id = option_number"
	signature_statement: STRING is "#listing_id.id = listing_id and #exdate.id = exdate and #option_number.id = option_number"

--	restriction_statement:STRING is "#market_id.id = market_id and #instrument_id.id = instrument_id"
	restriction_statement : STRING is "#listing_id.id = listing_id"

--	key_tuple:TUPLE is
--		do
--			Result := [instrument_id,market_id,exdate,option_number]
--		end
	key_tuple:TUPLE is
		do
			Result := [listing_id,exdate,option_number]
		end

	context_name:STRING is "ROSE"


feature {NONE} -- Implementation

end
