indexing
	description: "2D Point for ROSE_CHART_*"
	author: "Urs Doenni"
	last_editor: "$Author: it $"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #7 $"
	archive: "$File: //rose/source/kernel/infrastructure/widgets/charts/rose_chart_2d_point.e $"
	
class
	ROSE_CHART_2D_POINT
	
inherit
	ROSE_CHART_POINT
		redefine
			values,
			labels,
			get_data_array,
			get_data_description,
			set_color
		end
	
	create
	make,
	make_with_labels
	
feature -- Access
	
	values: TUPLE[x: like x; y: like y]
			-- Position values
	labels: TUPLE[x: ANY; y: ANY]
			-- Labels for x and y values
	
	x: DOUBLE is
			-- returns x value
		do
			Result := values.x
		end
	
	y: DOUBLE is
			-- returns y value
		do
			Result := values.y
		end
	
feature -- Element change
	
	set_x_y (a_x: like x; a_y: like y) is
			-- set x and y
		do
			values.x := a_x
			values.y := a_y
			
			is_set := True
			
			change_actions.call ([Current])
		end
	
	set_x (a_x: like x) is
			-- set x
		do
			values.x := a_x
			
			is_set := True
			
			change_actions.call ([Current])
		end
	
	set_y (a_y: like y) is
			-- set y
		do
			values.y := a_y
			
			is_set := True
			
			change_actions.call ([Current])
		end
	
	set_x_label (a_x: ANY) is
			-- set x label
		do
			labels.x := a_x
		end
	
	set_y_label (a_y: ANY) is
			-- set y label
		do
			labels.y := a_y
		end
	
	set_color (a_value: like color) is
			-- set color
		do
			Precursor (a_value)
			is_set := True
			change_actions.call ([Current])
		end
	
	get_data_array: ARRAY[STRING] is
			-- returns all data to this point as array of strings
		local
			l_x, l_y, l_x_label, l_y_label: STRING
		do
			create Result.make (1, 4)
			if labels /= void and then labels.x /= void then
				l_x_label := labels.x.out
			else
				l_x_label := ""
			end
			if labels /= void and then labels.y /= void then
				l_y_label := labels.y.out
			else
				l_y_label := ""
			end
			if x /= void then
				l_x := x.out
			else
				l_x := ""
			end
			if y /= void then
				l_y := y.out
			else
				l_y := ""
			end
			Result := <<l_x_label, l_x, l_y_label, l_y>>
		end
	
	get_data_description: ARRAY[STRING]	is
			-- returns a description to the data in get_data_array
		do
			create Result.make (1, 4)
			Result := <<"X-Label", "X-Value", "Y-Label", "Y-Value">>
		end
	
end
