indexing
	description: "Display definition for chart widget"
	author: "Zoran Simic"
	date: "$Date: 2014/12/02 $"
	revision: "$Revision: #6 $"

deferred class
	ROSE_CHART_CONSTANTS

inherit
	ROSE_SHARED_GLOBAL_GUI
		export
			{NONE} all
		end
	ROSE_IEEE_UNDEFINED
		export
			{NONE} all
		end
	DEBUG_OUTPUT

feature -- Access

	projected_x (a_x, a_origin, a_scale: DOUBLE): INTEGER is
			-- Projected `a_x' with `a_origin' and `a_scale'
		do
			Result := ((a_x - a_origin) * a_scale).truncated_to_integer
		end

	projected_y (a_y, a_origin, a_scale: DOUBLE): INTEGER is
			-- Projected `a_y' with `a_origin' and `a_scale'
		do
			Result := (- (a_y - a_origin) * a_scale).truncated_to_integer
		end

	reverse_projected_x (a_value: INTEGER; a_origin, a_scale: DOUBLE): DOUBLE is
			-- Reverse projection of x value `a_value' with `a_origin' and `a_scale'
		do
			Result := a_value / a_scale + a_origin
		end

	reverse_projected_y (a_value: INTEGER; a_origin, a_scale: DOUBLE): DOUBLE is
			-- Reverse projection of y value `a_value' with `a_origin' and `a_scale'
		do
			Result := - a_value / a_scale + a_origin
		end

	feature -- Constants for legend positioning

		position_manual: INTEGER is 0
			-- Argument for set_legend_position

		position_top: INTEGER is 1
			-- Argument for set_legend_position

		position_right: INTEGER is 2
			-- Argument for set_legend_position

		position_bottom: INTEGER is 3
			-- Argument for set_legend_position

		position_left: INTEGER is 4
			-- Argument for set_legend_position

		align_left, align_top: INTEGER is 1
			-- Argument for set_legend_alignment

		align_center: INTEGER is 2
			-- Argument for set_legend_alignment

		align_right, align_bottom: INTEGER is 3
			-- Argument for set_legend_alignment

end
