indexing
	description: "Text used in the legend of the ROSE_CHART_* system, with drop-support"
	author: "Urs Doenni"
	date: "$Date: 2009/11/05 $"
	revision: "$Revision: #3 $"
	archive: "$File: //rose/source/kernel/infrastructure/widgets/charts/rose_chart_ev_model_text.e $"

class
	ROSE_CHART_EV_MODEL_TEXT

inherit
	EV_MODEL_TEXT
		redefine
			make_with_text, drop_actions
		end

create
	make_with_text

feature {NONE} -- Initialization

	make_with_text (a_text: STRING) is
			-- Make with 'a_text'
		local
			l_text: EV_MODEL_TEXT
		do
			Precursor {EV_MODEL_TEXT} (a_text)
			create l_text
			draw_id := l_text.draw_id
		end

feature -- Access

	drop_actions: EV_PND_ACTION_SEQUENCE
			-- Actions to take when pick and drop transport drops on `Current'.
		do
			if drop_actions_i /= Void then
				Result := drop_actions_i
			else
				Result := Precursor
			end
		end

feature -- Basic operations

	set_drop_actions (a_drop_actions: like drop_actions) is
			-- Set 'drop_actions' of this widget to be linked with 'a_drop_actions'
		do
			drop_actions_i := a_drop_actions
		end

feature {NONE} -- Implementation

	drop_actions_i: like drop_actions
			-- Drop-actions

end
