indexing
	description: "Chart events"
	author: "Zoran Simic"
	date: "$Date: 2009/11/13 $"
	revision: "$Revision: #7 $"

class
	ROSE_CHART_EVENTS

inherit
	ROSE_GRAPHICS_EVENTS
		redefine
			make
		end

create
	make

feature {NONE} -- Initialization

	make is
			-- Creation procedure
		do
			create hover
			create click
			create double_click
		end

feature -- Access

	hover: ROSE_EVENT_TYPE [TUPLE [BOOLEAN, ROSE_CHART_RENDER_PLOT[ROSE_CHART_POINT]]]
			-- Fired whenever mouse is hovered in or out of a plot
			-- (the boolean indicates whether user is hovering in or out of that plot)

	click: ROSE_EVENT_TYPE [TUPLE [INTEGER, ROSE_CHART_RENDER_POINT[ROSE_CHART_POINT]]]
			-- Fired whenever user clicks on a point

	double_click: ROSE_EVENT_TYPE [TUPLE [INTEGER, ROSE_CHART_RENDER_POINT[ROSE_CHART_POINT]]]
			-- Fired whenever user double-clicks on a point

	pebble_function: FUNCTION [ANY, TUPLE [ROSE_CHART_RENDER_POINT [ROSE_CHART_POINT]], ANY]
			-- Optional pebble function to allow users to pick items from the legend

feature -- Basic operations

	set_pebble_function (a_pebble_function: like pebble_function) is
			-- Set 'pebble_function'.
		do
			pebble_function := a_pebble_function
		end

end
