indexing
	description: "Coordinate system preferences dialog"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #4 $"

class
	ROSE_CHART_SETTINGS_CS

inherit
	EV_HORIZONTAL_BOX
	ROSE_SHARED_GLOBAL_GUI
		undefine
			default_create, copy, is_equal
		end

create
	make

feature {NONE} -- Initialization

	make (a_container: EV_CONTAINER; a_system: like system) is
		local
			l_frame: EV_FRAME
			l_box, l_hbox: EV_BOX
		do
			system := a_system
			default_create
			Gui.factory.set_box_defaults (a_container,Current,4,4)

			--font
			l_frame := Gui.factory.new_frame (Current, "Font",0,0)
			l_box := Gui.factory.new_vbox (l_frame,4,4)
			l_hbox := Gui.factory.new_hbox (l_box,0,4)
			cb_font_size := Gui.factory.new_check_button (l_hbox, False, "Size", agent activate_widgets,1)
			t_font_size := Gui.factory.new_text_field (l_hbox,Void,Void,Void,-40)

			-- Axes
			create x_axis.make (Current,"X axis")
			create y_axis.make (Current,"Y axis")
		end

feature -- Access

	system: ROSE_CHART_COORDINATE_SYSTEM[ROSE_CHART_POINT]

feature -- Basic operations

	refresh is
		do
			Gui.enable_sensitive (Current,system.plots.count > 0)
			x_axis.refresh (system.x_axis)
			y_axis.refresh (system.y_axis)
		end

	apply is
		local
			l_fs : INTEGER
			l_s : STRING
			l_font : EV_FONT
		do
			l_s := t_font_size.text
			if l_s /= Void and then l_s.is_integer then
				l_fs := l_s.to_integer
				l_font := Gui.rep.fonts.new_screen_font (False,False, l_fs.max(11))
				x_axis.axis.display.settings.set_axis_font (l_font)
--				y_axis.axis.display.settings.set_axis_font (l_font)
				x_axis.axis.display.legend.set_font(l_font)
			end
			x_axis.apply
			y_axis.apply
			system.state.set_needs_projection
		end

feature {NONE} -- Implementation
	t_font_size : EV_TEXT_FIELD
	cb_font_size : EV_CHECK_BUTTON

	x_axis, y_axis: ROSE_CHART_SETTINGS_AXIS

	activate_widgets is
		do
			if t_font_size /= Void and then cb_font_size /= Void then
				Gui.enable_sensitive (t_font_size,cb_font_size.is_selected)
			end
		end
end -- class ROSE_CHART_SETTINGS_CS
