indexing
	description: "State for the ROSE_CHART_* system"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #3 $"

class
	ROSE_CHART_STATE

inherit
	ROSE_GRAPHICS_STATE
		redefine
			reset, set_needs_all, update_from
		end

create
	default_create, make

feature -- Access

	needs_coordination: BOOLEAN
			-- Coordinate system was changed, given coordinates need to be recalculated

	needs_rendering: BOOLEAN
			-- Figures need to be created

feature -- Basic operations

	reset is
			-- Reset state.
		do
			Precursor
			needs_coordination := False
			needs_rendering := False
		end

	set_needs_coordination is
		do
			needs_coordination := True
			set_needs_projection
		end

	set_needs_rendering is
		do
			needs_rendering := True
			set_needs_projection
		end

	set_needs_all is
		do
			needs_coordination := True
			needs_rendering := True
			Precursor
		end

feature {ROSE_GRAPHICS_STATE} -- Implementation

	update_from (a_other: like Current) is
		do
			Precursor (a_other)
			needs_coordination := needs_coordination or else a_other.needs_coordination
			needs_rendering := needs_rendering or else a_other.needs_rendering
		end

end -- class ROSE_CHART_STATE
