note

	description:

		"Common features of files."

	author: "RJ"
	last_editor: "$Author: mk $"
	date: "$Date: 2011/05/03 $"
	revision: "$Revision: #12 $"
	path: "$File: //rose/source/kernel/infrastructure/text/classic/rose_common_file.e $"

deferred class ROSE_COMMON_FILE

inherit

	STRING_HANDLER

feature -- Access

	rose_default_last_string_size: INTEGER is 256

	is_closed: BOOLEAN is
			-- Placeholder until defined - probably by FILE.
		deferred
		end

	off: BOOLEAN is
			-- Placeholder until defined - probably by FILE.
		deferred
		end

	last_string: STRING is
			-- Placeholder until defined - probably by FILE.
		deferred
		end

	exists: BOOLEAN is
			-- Placeholder until defined - probably by FILE.
		deferred
		end

	count: INTEGER is
			-- Placeholder until defined - probably by FILE.
		deferred
		end

	file_pointer: POINTER is
			-- Placeholder until defined - probably by FILE.
		deferred
		end

	end_of_file: BOOLEAN is
			-- Placeholder until defined - probably by FILE.
		deferred
		end

feature -- Basic operations

	open_read is
			-- Placeholder until defined - probably by FILE.
		deferred
		end

	readstream, read_stream (a_nb_char: INTEGER) is
		deferred
		end

	close is
			-- Placeholder until defined - probably by FILE.
		deferred
		end

feature {NONE} -- Implementation

	rose_create_last_string (a_min_size: INTEGER) is
			-- Create a new instance of `last_string' with at least `a_min_size'
			-- bytes as the capacity.
		require
			last_string_void: last_string = Void
			a_min_size_non_negative: a_min_size >= 0
		deferred
		ensure
			last_string_not_void: last_string /= Void
			capacity_set: last_string.capacity >= a_min_size
		end


end
