indexing
	description: "Scanner for CFG configuration files"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #5 $"

class
	ROSE_CONFIGURATION_CFG_SCANNER

inherit
	YY_COMPRESSED_SCANNER_SKELETON
		rename
			make as make_compressed_scanner_skeleton,
			reset as reset_compressed_scanner_skeleton,
			output as yy_scanner_output
		end

	ROSE_CONFIGURATION_CFG_TOKENS
		export {NONE} all end

create
	make_cfg_scanner


feature {NONE} -- Initialization

	make_cfg_scanner is
			-- Create a new Eiffel scanner.
		do
			make_with_buffer (Empty_buffer)
			create cfg_buffer.make (Initial_buffer_size)
			line_number := 1
		end

feature -- Initialization

	reset is
			-- Reset scanner before scanning next input.
		do
			reset_compressed_scanner_skeleton
			line_number := 1
			cfg_buffer.wipe_out
		end

feature -- Access

	line_number: INTEGER
			-- Current line number


feature -- Status report

	valid_start_condition (sc: INTEGER): BOOLEAN is
			-- Is `sc' a valid start condition?
		do
			Result := (INITIAL <= sc and sc <= IN_STR)
		end

feature {NONE} -- Implementation

	yy_build_tables is
			-- Build scanner tables.
		do
			yy_nxt := yy_nxt_template
			yy_chk := yy_chk_template
			yy_base := yy_base_template
			yy_def := yy_def_template
			yy_ec := yy_ec_template
			yy_meta := yy_meta_template
			yy_accept := yy_accept_template
		end

	yy_execute_action (yy_act: INTEGER) is
			-- Execute semantic action.
		do
if yy_act <= 22 then
if yy_act <= 11 then
if yy_act <= 6 then
if yy_act <= 3 then
if yy_act <= 2 then
if yy_act = 1 then
--|#line 58 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 58")
end
last_indentation := text		-- Separators are kept for saving purposes
else
--|#line 60 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 60")
end
last_token := CFG_END_ENTRY
end
else
--|#line 61 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 61")
end

			last_token := CFG_END_ENTRY
			line_number := line_number + 1
			last_indentation := Void
		
end
else
if yy_act <= 5 then
if yy_act = 4 then
--|#line 67 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 67")
end

			last_token := CFG_COMMENT
			if last_indentation = Void then
				last_string_value := text
			else
				last_string_value := last_indentation
				last_string_value.append (text)
			end
		
else
--|#line 77 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 77")
end

			last_token := CFG_COMMENT
			if last_indentation = Void then
				last_string_value := text
			else
				last_string_value := last_indentation
				last_string_value.append (text)
			end
		
end
else
--|#line 87 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 87")
end
last_token := CFG_TRY
end
end
else
if yy_act <= 9 then
if yy_act <= 8 then
if yy_act = 7 then
--|#line 88 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 88")
end
last_token := CFG_INCLUDE	last_string_value := text.as_lower
else
--|#line 90 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 90")
end
		--|"
			last_token := CFG_KEY
			last_string_value := text
		
end
else
--|#line 95 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 95")
end

			last_token := CFG_VALUE
			last_string_value := text_substring (2, text_count - 1)
		
end
else
if yy_act = 10 then
--|#line 100 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 100")
end
		--|"
			last_token := CFG_VALUE
			last_string_value := text_substring (2, text_count - 1)
		
else
--|#line 104 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 104")
end

			if text_count > 1 then
				cfg_buffer.append_string (text_substring (2, text_count))
			end
			set_start_condition (IN_STR)
		
end
end
end
else
if yy_act <= 17 then
if yy_act <= 14 then
if yy_act <= 13 then
if yy_act = 12 then
--|#line 110 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 110")
end
cfg_buffer.append_string (text)			--| "
else
--|#line 111 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 111")
end
cfg_buffer.append_character ('%A')
end
else
--|#line 112 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 112")
end
cfg_buffer.append_character ('%B')
end
else
if yy_act <= 16 then
if yy_act = 15 then
--|#line 113 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 113")
end
cfg_buffer.append_character ('%C')
else
--|#line 114 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 114")
end
cfg_buffer.append_character ('%D')
end
else
--|#line 115 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 115")
end
cfg_buffer.append_character ('%F')
end
end
else
if yy_act <= 20 then
if yy_act <= 19 then
if yy_act = 18 then
--|#line 116 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 116")
end
cfg_buffer.append_character ('%H')
else
--|#line 117 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 117")
end
cfg_buffer.append_character ('%L')
end
else
--|#line 118 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 118")
end
cfg_buffer.append_character ('%N')
end
else
if yy_act = 21 then
--|#line 119 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 119")
end
cfg_buffer.append_character ('%Q')
else
--|#line 120 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 120")
end
cfg_buffer.append_character ('%R')
end
end
end
end
else
if yy_act <= 33 then
if yy_act <= 28 then
if yy_act <= 25 then
if yy_act <= 24 then
if yy_act = 23 then
--|#line 121 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 121")
end
cfg_buffer.append_character ('%S')
else
--|#line 122 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 122")
end
cfg_buffer.append_character ('%T')
end
else
--|#line 123 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 123")
end
cfg_buffer.append_character ('%U')
end
else
if yy_act <= 27 then
if yy_act = 26 then
--|#line 124 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 124")
end
cfg_buffer.append_character ('%V')
else
--|#line 125 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 125")
end
cfg_buffer.append_character ('%%')
end
else
--|#line 126 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 126")
end
cfg_buffer.append_character ('%'')
end
end
else
if yy_act <= 31 then
if yy_act <= 30 then
if yy_act = 29 then
--|#line 127 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 127")
end
cfg_buffer.append_character ('%"')		--| "
else
--|#line 128 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 128")
end
cfg_buffer.append_character ('%(')
end
else
--|#line 129 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 129")
end
cfg_buffer.append_character ('%)')
end
else
if yy_act = 32 then
--|#line 130 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 130")
end
cfg_buffer.append_character ('%<')
else
--|#line 131 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 131")
end
cfg_buffer.append_character ('%>')
end
end
end
else
if yy_act <= 38 then
if yy_act <= 36 then
if yy_act <= 35 then
if yy_act = 34 then
--|#line 132 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 132")
end

			code_ := text_substring (3, text_count - 1).to_integer
			if (code_ > Platform.Maximum_character_code) then
				last_token := CFG_ERROR
				set_start_condition (INITIAL)
			else
				cfg_buffer.append_character (INTEGER_.to_character (code_))
			end
		
else
--|#line 141 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 141")
end
line_number := line_number + 1
end
else
--|#line 142 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 142")
end

			last_token := CFG_VALUE
			if text_count > 1 then
				cfg_buffer.append_string (text_substring (1, text_count - 1))
			end
			last_string_value := clone (cfg_buffer)
			cfg_buffer.wipe_out
			set_start_condition (INITIAL)
		
end
else
if yy_act = 37 then
--|#line 151 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 151")
end
cfg_buffer.append_character (text_item (2))
else
--|#line 152 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 152")
end
	--| Catch-all rules (no backing up)
			last_token := CFG_ERROR
			set_start_condition (INITIAL)
		
end
end
else
if yy_act <= 41 then
if yy_act <= 40 then
if yy_act = 39 then
--|#line 153 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 153")
end
	--| Catch-all rules (no backing up)
			last_token := CFG_ERROR
			set_start_condition (INITIAL)
		
else
--|#line 154 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 154")
end
	--| Catch-all rules (no backing up)
			last_token := CFG_ERROR
			set_start_condition (INITIAL)
		
end
else
	yy_end := yy_end - 1
--|#line 160 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 160")
end

			last_token := CFG_EOF
			--| terminate
		
end
else
if yy_act = 42 then
--|#line 168 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 168")
end
last_token := text_item (1).code
else
--|#line 0 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 0")
end
last_token := yyError_token
fatal_error ("scanner jammed")
end
end
end
end
end
			yy_set_beginning_of_line
		end

	yy_execute_eof_action (yy_sc: INTEGER) is
			-- Execute EOF semantic action.
		do
			inspect yy_sc
when 0 then
--|#line 0 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 0")
end

			last_token := CFG_EOF
			--| terminate
		
when 1 then
--|#line 0 "rose_configuration_cfg_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rose_configuration_cfg_scanner.l' at line 0")
end
	--| Catch-all rules (no backing up)
			last_token := CFG_ERROR
			set_start_condition (INITIAL)
		
			else
				terminate
			end
		end

feature {NONE} -- Table templates

	yy_nxt_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,   74,    7,    8,    9,   74,   10,   11,   65,   38,
			   12,   38,   74,   13,   66,   14,   14,   19,   20,   21,
			   19,   20,   21,   65,   38,   70,   67,   22,   74,   74,
			   22,   74,   74,   74,   73,   15,   72,   74,   74,   16,
			    7,    8,    9,   71,   10,   11,   69,   68,   12,   67,
			   35,   13,   64,   14,   14,   63,   62,   61,   25,   17,
			   23,   35,   33,   32,   31,   29,   25,   23,   74,   74,
			   74,   74,   74,   15,   74,   74,   74,   16,   27,   74,
			   27,   74,   27,   28,   74,   74,   27,   74,   74,   27,
			   74,   27,   27,   36,   37,   38,   39,   40,   36,   41,

			   42,   43,   36,   44,   36,   36,   45,   36,   46,   47,
			   48,   49,   50,   36,   51,   52,   53,   54,   55,   56,
			   57,   58,   59,   60,   36,   36,   36,   36,   36,   36,
			   36,   36,   36,   36,   27,   74,   27,   74,   27,   28,
			   74,   74,   27,   74,   74,   27,   74,   27,   27,    6,
			    6,    6,    6,    6,    6,    6,    6,    6,   18,   18,
			   18,   18,   18,   18,   18,   18,   18,   24,   24,   74,
			   74,   24,   24,   24,   24,   24,   26,   26,   74,   26,
			   26,   26,   26,   26,   26,   30,   30,   74,   30,   30,
			   30,   30,   30,   30,   34,   34,   74,   74,   34,   34,

			   34,   34,   34,   27,   27,   74,   27,   27,   27,   27,
			   27,   27,   29,   29,   74,   29,   29,   29,   29,   29,
			   29,    5,   74,   74,   74,   74,   74,   74,   74,   74,
			   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
			   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
			   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
			   74,   74,   74, yy_Dummy>>)
		end

	yy_chk_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    0,    1,    1,    1,    0,    1,    1,   37,   37,
			    1,   38,    0,    1,   38,    1,    1,    3,    3,    3,
			    4,    4,    4,   65,   65,   67,   67,   77,    0,    0,
			   77,    0,    0,    0,   72,    1,   71,    0,    0,    1,
			    2,    2,    2,   68,    2,    2,   64,   62,    2,   44,
			   34,    2,   33,    2,    2,   32,   31,   27,   24,    2,
			   23,   18,   17,   16,   15,   12,    9,    7,    5,    0,
			    0,    0,    0,    2,    0,    0,    0,    2,   11,    0,
			   11,    0,   11,   11,    0,    0,   11,    0,    0,   11,
			    0,   11,   11,   21,   21,   21,   21,   21,   21,   21,

			   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
			   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
			   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
			   21,   21,   21,   21,   26,    0,   26,    0,   26,   26,
			    0,    0,   26,    0,    0,   26,    0,   26,   26,   75,
			   75,   75,   75,   75,   75,   75,   75,   75,   76,   76,
			   76,   76,   76,   76,   76,   76,   76,   78,   78,    0,
			    0,   78,   78,   78,   78,   78,   79,   79,    0,   79,
			   79,   79,   79,   79,   79,   80,   80,    0,   80,   80,
			   80,   80,   80,   80,   81,   81,    0,    0,   81,   81,

			   81,   81,   81,   82,   82,    0,   82,   82,   82,   82,
			   82,   82,   83,   83,    0,   83,   83,   83,   83,   83,
			   83,   74,   74,   74,   74,   74,   74,   74,   74,   74,
			   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
			   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
			   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
			   74,   74,   74, yy_Dummy>>)
		end

	yy_base_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    0,   38,   14,   17,   68,    0,   65,  221,   62,
			  221,   76,   55,    0,  221,   27,   25,   37,   57,  221,
			  221,   92,    0,   58,   54,  221,  132,   50,    0,    0,
			    0,   24,   14,   32,   46,  221,  221,    6,    9,  221,
			  221,  221,  221,  221,   37,  221,  221,  221,  221,  221,
			  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
			  221,  221,   11,    0,   43,   21,  221,   14,    3,  221,
			  221,    3,    0,    0,  221,  148,  157,   26,  166,  175,
			  184,  193,  202,  211, yy_Dummy>>)
		end

	yy_def_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,   75,   75,   76,   76,   74,   77,   74,   74,   78,
			   74,   79,   74,   80,   74,   77,   77,   77,   81,   74,
			   74,   74,   77,   74,   78,   74,   79,   82,   77,   83,
			   80,   77,   77,   77,   81,   74,   74,   74,   74,   74,
			   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
			   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
			   74,   74,   77,   77,   77,   74,   74,   74,   77,   74,
			   74,   77,   77,   77,    0,   74,   74,   74,   74,   74,
			   74,   74,   74,   74, yy_Dummy>>)
		end

	yy_ec_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    2,
			    3,    1,    1,    2,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    2,    1,    4,    1,    1,    5,    6,    7,
			    8,    9,    1,    1,    1,   10,    1,   11,   12,   12,
			   12,   12,   12,   12,   12,   12,   12,   12,    1,   13,
			   14,   15,   16,    1,    1,   17,   18,   19,   20,   21,
			   22,    1,   23,    1,    1,    1,   24,    1,   25,    1,
			    1,   26,   27,   28,   29,   30,   31,    1,    1,    1,
			    1,   15,    1,   15,    1,    1,    1,    1,    1,   32,

			   33,   34,    1,    1,    1,   35,    1,    1,   36,    1,
			   37,    1,    1,    1,   38,    1,   39,   40,    1,    1,
			    1,   41,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1, yy_Dummy>>)
		end

	yy_meta_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    1,    2,    3,    2,    4,    5,    1,    1,    1,
			    6,    1,    1,    7,    1,    8,    9,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1, yy_Dummy>>)
		end

	yy_accept_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    0,    0,    0,    0,   44,    8,    1,    3,   11,
			    2,    8,   42,    4,   42,    8,    8,    8,   12,   38,
			   36,   38,    8,    1,   11,   10,    8,    0,    8,    5,
			    4,    8,    8,    8,   12,   36,   37,   37,   39,   29,
			   27,   28,   30,   31,   37,   32,   33,   13,   14,   15,
			   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,
			   26,    9,    8,    6,    8,    0,   35,   40,    8,   41,
			   34,    8,    8,    7,    0, yy_Dummy>>)
		end

feature {NONE} -- Constants

	yyJam_base: INTEGER is 221
			-- Position in `yy_nxt'/`yy_chk' tables
			-- where default jam table starts

	yyJam_state: INTEGER is 74
			-- State id corresponding to jam state

	yyTemplate_mark: INTEGER is 75
			-- Mark between normal states and templates

	yyNull_equiv_class: INTEGER is 1
			-- Equivalence code for NULL character

	yyReject_used: BOOLEAN is false
			-- Is `reject' called?

	yyVariable_trail_context: BOOLEAN is false
			-- Is there a regular expression with
			-- both leading and trailing parts having
			-- variable length?

	yyReject_or_variable_trail_context: BOOLEAN is false
			-- Is `reject' called or is there a
			-- regular expression with both leading
			-- and trailing parts having variable length?

	yyNb_rules: INTEGER is 43
			-- Number of rules

	yyEnd_of_buffer: INTEGER is 44
			-- End of buffer rule code

	yyLine_used: BOOLEAN is false
			-- Are line and column numbers used?

	yyPosition_used: BOOLEAN is false
			-- Is `position' used?

	INITIAL: INTEGER is 0
	IN_STR: INTEGER is 1
			-- Start condition codes

feature -- User-defined features



feature {NONE} -- Implementation

	cfg_buffer: STRING
			-- Buffer for lexical tokens

	code_: INTEGER
			-- Attribute used as temporary integer

	last_indentation: STRING
		-- Keep indentation to save back config almost as read

feature {NONE} -- Constants

	Initial_buffer_size: INTEGER is 256
				-- Initial size for `cfg_buffer'

end -- class ROSE_CONFIGURATION_CFG_SCANNER
