indexing
	description: "Abstract of a configuration type handler"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #4 $"

deferred class ROSE_CONFIGURATION_HANDLER

inherit
	ROSE_SHARED_GLOBAL

feature -- Access

	id: STRING is
			-- Handler type id
		deferred
		end

feature -- Basic operations

	import (a_node: ROSE_CONFIGURATION_NODE; a_path: STRING; a_included: BOOLEAN): STRING is
			-- Import configuration from 'a_path' to 'a_node'.
			-- 'a_included' indicates whether the file is part of an include directive or not
			-- Returns effective resolved path
		require
			valid_root: a_node /= Void
			valid_path: a_path /= Void
		deferred
		end

	interpret (a_node: ROSE_CONFIGURATION_NODE; a_buffer: STRING) is
			-- Interpret configuration from 'a_buffer' to 'a_node'.
		require
			valid_root: a_node /= Void
			valid_buffer: a_buffer /= Void
		do
		end

	save (a_node: ROSE_CONFIGURATION_NODE; a_path: STRING) is
			-- Export 'a_node' to 'a_path'.
			-- Only (modified or not included) nodes are saved.
		require
			valid_root: a_node /= Void
			valid_path: a_path /= Void
		deferred
		end

	flat_export (a_node: ROSE_CONFIGURATION_NODE; a_path: STRING) is
			-- Export all nodes from 'a_node' to 'a_path'.
			-- All value nodes are exported, include directives and comments are not
		require
			valid_root: a_node /= Void
			valid_path: a_path /= Void
		deferred
		end

end
