indexing
	description: "Configuration handler for XML files"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #7 $"

class ROSE_CONFIGURATION_HANDLER_XML

inherit
	ROSE_CONFIGURATION_HANDLER

feature -- Access

	id: STRING is "xml"
		-- Handler type id

feature -- Basic operations

	import (a_node: ROSE_CONFIGURATION_NODE; a_path: STRING; a_included: BOOLEAN): STRING is
			-- Import configuration from 'a_path' to 'a_node'.
			-- 'a_included' indicates whether the file is part of an include directive or not
			-- Returns effective resolved path
		do
			Result := Global.app.configs.get_file (a_path)
			error.signal (id,"Import function not implemented",Void)
		end

	save (a_node: ROSE_CONFIGURATION_NODE; a_path: STRING) is
			-- Export 'a_node' to 'a_path'.
			-- Only (modified or not included) nodes are saved.
		do
			error.signal (id,"Save function not implemented",Void)
		end

	flat_export (a_node: ROSE_CONFIGURATION_NODE; a_path: STRING) is
			-- Export all nodes from 'a_node' to 'a_path'.
			-- All value nodes are exported, include directives and comments are not
		do
			error.signal (id,"Export function not implemented",Void)
		end

end
