indexing
	description: "TCP Server Command for CS (most of the command is in ROSE_CS_SERVER_THREAD)"
	documentation: "[
	]"
	author: "Ueli Peter"
	last_editor: "Ueli Peter"
	date: "$Date: 2009/01/19 $"
class
	ROSE_CS_PERSISTENT_SERVER_COMMAND

inherit
	PERSISTENT_SERVER_COMMAND
		redefine
			execute,
			perform_maintenance,
			default_create
		end

	EXCEPTIONS
		export
			{NONE} all
		undefine
			default_create
		end

create
	make_command

feature {NONE} -- Initialization

	default_create is
			-- Init
		do
			Precursor
		end

feature -- Access

	cs: ROSE_CS

feature -- Basic operations

	execute (a_any: ANY) is
			-- just check for expired
		do
			if server_thread.expired then
				expired := true
			end
		end

	perform_maintenance is
			-- set expired when server is in shut down state
		do
			if cs.get_state = {ROSE_CS}.state_shuting_down then
				expired := true
			end
		end

	set_cs_and_launch_thread (a_cs: ROSE_CS) is
			-- set `cs' to `a_cs'
			-- we need to start a new thread for every command because
			-- the server handles large queries and we don't want
			-- it to block for a long time
		local
			l_user: STRING
		do
			cs := a_cs
			if user_name /= Void then
				l_user := user_name
			else
				l_user := ""
			end
			if machine /= Void then
				l_user := l_user + "@" + machine_name
			end
			create server_thread.make_command (outflow, a_cs,  l_user)
			server_thread.launch
		end

	set_expired (a_bol: BOOLEAN) is
			-- connection is broken
			do
				expired := true
			end

	server_thread: ROSE_CS_SERVER_THREAD
			-- thread which is executed for this command

end
