indexing
	description: "Query object to send to Cache Server"
	documentation: "[
			IMPORTANT: If you write a descendant of this class, you need to add an attribute of its type to the class PES_QUERIES
	]"
	author: "Ueli Peter"
	last_editor: "$Author: jroeder $"
	date: "$Date: 2009/01/19 $"

deferred class
	ROSE_CS_QUERY

inherit
	EXCEPTIONS
	redefine
		out
	end

feature -- Access

	query_id: INTEGER
		-- id unique on client side

feature -- Basic operations

	execute_query (a_worker: ROSE_CS_WORKER): ROSE_CS_RESULT is
			-- execute query on `a_pes_server' and reurn result
		deferred
		ensure
			result_not_void: Result /= Void
		end

	set_query_id (a_id: like query_id) is
			-- Set `query_id' to `a_id'
		do
			query_id := a_id
		ensure
			query_id_set: query_id = a_id
		end

	set_userinformation (a_userinfo: STRING) is
			-- set `user_information' to `a_userinfo'
		do
			user_information := a_userinfo
		end

	out: STRING
		-- redefine out
		do
			Result := user_information + " : " + query_information
		end

feature {NONE} -- Implementation

	user_information: STRING

	query_information: STRING is
			-- Returns informations about this query
		deferred
		ensure
			result_not_void: Result /= Void
		end

end
