indexing
	description: "Result object to send to Client"
	documentation: "[
	]"
	author: "Ueli Peter"
	last_editor: "$Author: it $"
	date: "$Date: 2008/12/01 $"

class
	ROSE_CS_RESULT

inherit
	EXCEPTIONS

create
	make_exception

feature {NONE} -- Initialization

	make_exception (an_id: INTEGER; a_exception: STRING) is
			-- Use this creation feature if an exception occurs
		do
			query_id := an_id
			remote_exception_text := a_exception
			remote_exception := True
		end

feature -- Access

	query_id: INTEGER
		-- id unique on client side

	remote_exception: BOOLEAN
		-- Did an exception occur while processing the request on th server ?
		-- In that case the result is not valid.

	remote_exception_text: STRING
		-- Exception String of the remote exception

feature -- Basic operations

	prepare_result is
			-- remove references which are not needed
		do
		end

	restore_result (a_api: ROSE_CS_CLIENT_API) is
			-- Restore references which were removed before sending
			-- and put all transmitted objects into their corresponding caches
		require
			no_exception: not remote_exception
		do
			-- Remove request from stored requests hash table
			a_api.requests.remove_thread_safe (query_id)
		ensure
			request_removed: not a_api.requests.has (query_id)
		end

	set_query_id (a_id: like query_id) is
			-- Set `query_id' to `a_id'
		do
			query_id := a_id
		ensure
			query_id_set: query_id = a_id
		end

	set_remote_exception (a_string: STRING) is
			-- Set `remote_exception' to True and set `remote_exception_text'
		do
			remote_exception := True
			remote_exception_text := a_string
		ensure
			remote_excpetion_set: remote_exception
			text_correct: a_string = remote_exception_text
		end

	unset_remote_exception is
			-- Clear remote exception
		do
			remote_exception := False
			remote_exception_text := Void
		ensure
			remote_excpetion_not_set: not remote_exception
			text_not_set: remote_exception_text = Void
		end

end
