indexing
	description: "Array of rose date (time)"
	author: ""
	date: "$Date: 2009/02/12 $"
	revision: "$Revision: #7 $"
	archive: "$File: //rose/source/kernel/infrastructure/datetime/rose_date_array.e $"

class
	ROSE_DATE_ARRAY[reference G -> ROSE_DATE]

inherit
	ROSE_LINEAR_ARRAY[G]

create
	make, make_from_array
create {ROSE_DATE_ARRAY}
	make_empty

feature  --Display
	display : ROSE_LINEAR_ARRAY[STRING] is
		--array of display strings
		local
			i : INTEGER
			l_date : ROSE_DATE
		do
			create Result.make(1, count)
			from i := lower until i > upper loop
				l_date := item(i)
				if l_date /= Void then
					Result.put(l_date.display,i)
				end
				i := i + 1
			end
		ensure then
			nonvoid : Result /= void
		end
	ccyymmdd_strings : ROSE_LINEAR_ARRAY[STRING] is
		-- to string representation
		local
			i : INTEGER
		do
			create Result.make(1, count)
			from i := 1 until i > count loop
				Result[i] := item(lower + i - 1).ccyymmdd.out
				i := i + 1
			end
		end

	ccyymm_strings : ROSE_LINEAR_ARRAY[STRING] is
			-- ccyymm strings
		local
			i : INTEGER
		do
			create Result.make(1, count)
			from i := 1 until i > count loop
				Result[i] := item(lower + i - 1).ccyymm.out
				i := i + 1
			end
		end

	double_array : ROSE_LINEAR_ARRAY[DOUBLE] is
			-- double representation of dates
			-- (as defined by ROSE_DATE.to_double)
		local
			i : INTEGER
		do
			create Result.make(1, count)
			from i := 1 until i > count loop
				Result[i] := item(lower + i - 1).to_double
				i := i + 1
			end
		end

	vector : VECTOR is
			-- vector
		local
			l_array : like double_array
		do
			l_array := double_array
			if l_array /= Void then
				create Result.make_from_array(l_array)
			end
		end

feature -- Access
	monthend_array : ROSE_INDEXED_ARRAY[G, INTEGER] is
		-- subarray of monthend only dates
		local
			i, l_ix, l_ccyymm : INTEGER
			l_date : G
		do
			create Result.make_empty
			from i := lower until i > upper loop
				l_date := item(i)
				l_ccyymm := l_date.ccyymm
				l_ix := Result.index_at (l_ccyymm)
				if l_ix > 0 then
					if Result.item(l_ix).ccyymmdd < l_date.ccyymmdd then
						Result.linear_put (l_date, l_ix)
					end
				else
					Result.extend (l_date, l_ccyymm)
				end
				i := i + 1
			end
		end

end
