indexing
	description: "Conversion routines, handy when accessing DBs"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #3 $"

class
	ROSE_DB_CONVERSION_SERVICE

feature -- Access

	date_time_to_time (a_time: ROSE_DATE): ROSE_TIME is
			-- 'a_time.time' if 'a_time' represents a valid time object
			-- Void otherwise
		do
			if a_time /= Void then
				Result := a_time.time
			end
		end

	significant_date_time (a_date_time: ROSE_DATE): ROSE_DATE is
			-- 'a_date_time' if 'a_date_time' represents a valid date/time object
			-- Void otherwise
		do
			if a_date_time /= Void and then a_date_time.year < 3000 then
				Result := a_date_time
			end
		end

	date_time_to_duration (a_time: ROSE_DATE): TIME_DURATION is
			-- Convert 'a_time' to a duration
		do
			if a_time /= Void then
				create Result.make (a_time.hour,a_time.minute,a_time.second)
			end
		end

end -- class ROSE_DB_CONVERSION_SERVICE
