indexing
	description: "Date field implemented with a date-time picker control"
	author: "Zoran Simic"
	date: "$Date: 2013/04/24 $"
	revision: "$Revision: #11 $"
    path: "$File: //rose/source/kernel/infrastructure/windows/classic/rose_ev_date_field_imp.e $"

class
	ROSE_EV_DATE_FIELD_IMP

inherit
	DATE_TIME_PICKER_CONTROL
		rename
			make as wel_make,
			parent as wel_parent,
			set_parent as wel_set_parent,
			font as wel_font,
			set_font as wel_set_font,
			shown as is_displayed,
			destroy as wel_destroy,
			item as wel_item,
			enabled as is_sensitive,
			width as wel_width,
			height as wel_height,
			x as x_position,
			y as y_position,
			move as wel_move,
			resize as wel_resize,
			move_and_resize as wel_move_and_resize,
			on_desactivate as wel_on_desactivate,
			has_capture as wel_has_capture
		undefine
			set_width,
			set_height,
			on_left_button_down,
			on_middle_button_down,
			on_right_button_down,
			on_left_button_up,
			on_middle_button_up,
			on_right_button_up,
			on_left_button_double_click,
			on_middle_button_double_click,
			on_right_button_double_click,
			on_mouse_move,
			on_mouse_wheel,
			on_key_up,
			on_set_cursor,
			on_set_focus,
			on_kill_focus,
			on_key_down,
			on_char,
			on_getdlgcode,
			show,
			hide,
			on_size,
			x_position,
			y_position,
			on_sys_key_down,
			on_sys_key_up,
			default_process_message,
			on_wm_dropfiles
  		redefine
			on_dtn_datetimechange,
			on_dtn_dropdown,
			on_dtn_closeup
		end
	EV_PRIMITIVE_IMP
		redefine
			interface,
			make
		end
	EV_FONTABLE_IMP
		redefine
			interface,
			set_font
		end

create
	make

feature {NONE} -- Initialization

	old_make (an_interface: like interface) is
			-- Create `Current' with interface `an_interface'.
		do
		end

	make is
           -- Initialize `Current'.
		do
			common_controls_dll.do_nothing
			wel_make (default_parent, 0, 0, 80, 20, 0)
			Precursor
			set_font (create {EV_FONT})
		end

feature -- Basic operations

	set_font (a_font: EV_FONT) is
			-- Make `a_font' new font of `Current'.
		do
			Precursor (a_font)
			set_minimum_width (a_font.string_width (k_dummy_date) + 28)
			set_minimum_height (a_font.height + a_font.descent + 9)
		end

feature {NONE} -- Feature that should be directly implemented by externals

	k_dummy_date: STRING is "00/00/0000"

	common_controls_dll: WEL_COMMON_CONTROLS_DLL is
			-- Common controls dll
		once
			create Result.make
		end

	on_dtn_datetimechange (info: WEL_NM_DATE_TIME_CHANGE) is
		do
			Precursor (info)
		 	if not is_dropped_down then
				interface.change_actions.call ([])
			end
		end

	on_dtn_dropdown (info:WEL_NMHDR) is
			-- Drop down message received from windows with information contained in `info'.
		do
			Precursor (info)
			datetime_on_dropdown := interface.selected_date_time
		end

	on_dtn_closeup (info:WEL_NMHDR) is
		-- Close up message received from windows with information contained in `info'.
		do
			Precursor (info)
			if not interface.selected_date_time.is_equal (datetime_on_dropdown) then
				interface.change_actions.call ([])
			end
			datetime_on_dropdown := Void
		end

feature {NONE} -- Implementation

	datetime_on_dropdown: ROSE_DATE

	is_dropped_down: BOOLEAN is
			-- Is the date selector currently dropped down?
		do
			Result := datetime_on_dropdown /= Void
		end

feature {EV_ANY, EV_ANY_I} -- Implementation

	interface: ROSE_EV_DATE_FIELD

end
