indexing
	description: "Custom version of EV_GRID providing a few additional facilities."
	author: ""
	date: "$Date: 2013/04/24 $"
	revision: "$Revision: #9 $"
	archive: "$File: //rose/source/kernel/infrastructure/widgets/grid/rose_ev_grid.e $"

class
	ROSE_EV_GRID
inherit
	EV_GRID
		redefine
			create_implementation,
			implementation
		end

feature -- Access

	enable_capture_light is
			-- `enable_capture' but forced to use the real windows capture, not the
			-- WEL_HOOK heavy capture. This is necessary to work around a bug in the heavy capture where
			-- if you call `enable_capture' with the left mouse button down, move the mouse out of your window
			-- and then release the left mouse button, the capture ends.
		do
			implementation.enable_capture_light
		end

	disable_capture_light is
			-- `disable_capture' but forced to use the real windows capture, not the
			-- WEL_HOOK heavy capture. This is necessary to work around a bug in the heavy capture where
			-- if you call `enable_capture' with the left mouse button down, move the mouse out of your window
			-- and then release the left mouse button, the capture ends.
		do
			implementation.disable_capture_light
		end

	has_capture_light: BOOLEAN is
			-- Is a light capture executing on `Current'?
		do
			Result := implementation.has_capture_light
		end

	disable_tabable_to is
			-- Make `is_tabable_to' `False'.
		require
			not_destroyed: not is_destroyed
		do
			implementation.disable_tabable_to
		end

	viewable_row_count: INTEGER is
			-- Total number of rows viewable in `Current'.
		do
			if implementation.uses_row_offsets then
				Result := implementation.computed_visible_row_count
			else
				Result := row_count
			end
		ensure
			result_non_negative: Result >= 0
		end

feature {NONE} -- Implementation

	create_implementation is
			-- Create implementation object.
		do
			create {ROSE_EV_GRID_IMP} implementation.make
		end

feature {RP_DATA_GRID, RP_GRID_NODE, EV_ANY, EV_ANY_I} -- Implementation

	implementation: attached ROSE_EV_GRID_IMP
		-- Implementation object for `Current'.

end
