indexing
	description: ""
	author: ""
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #7 $"
	archive: "$File: //rose/source/kernel/infrastructure/widgets/grid/rose_ev_grid_drawer_i.e $"

class
	ROSE_EV_GRID_DRAWER_I
inherit
	EV_GRID_DRAWER_I
		redefine
			redraw_area_in_drawable_coordinates_wrapper
		end

create
	make_with_grid

feature -- Access
	is_redrawing : BOOLEAN

	redraw_finished_action : PROCEDURE [ANY, TUPLE]

	redraw_started_action : PROCEDURE [ANY, TUPLE]

feature -- Basic operations
	set_redraw_finished_action (a_action : PROCEDURE [ANY, TUPLE]) is
		do
			redraw_finished_action := a_action
		end

	set_redraw_started_action (a_action : PROCEDURE [ANY, TUPLE]) is
		do
			redraw_started_action := a_action
		end

	redraw_area_in_drawable_coordinates_wrapper (an_x, a_y, a_width, a_height: INTEGER) is
		do
			grid.perform_vertical_computation
			grid.perform_horizontal_computation
				-- We must force the re-computation as within `redraw_started_action', we re-compute the
				-- widget positions.

			if redraw_started_action /= Void then
				redraw_started_action.call ([])
			end
			is_redrawing := True
			precursor (an_x, a_y, a_width, a_height)
			is_redrawing := False
			if redraw_finished_action /= Void then
				redraw_finished_action.call ([])
			end
		end

feature {NONE} -- Implementation

end
