indexing
	description: "EiffelVision Font repository"
	notice: "This class groups convenience fonctions for handling Fonts"
	author: "Zoran Simic"
	date: "$Date: 2009/03/31 $"
	revision: "$Revision: #4 $"

class
	ROSE_EV_REPOSITORY_FONTS

inherit
	EV_FONT_CONSTANTS

feature -- Access

	new_roman_font (a_bold, a_italic: BOOLEAN; a_height: INTEGER): EV_FONT is
			-- Roman font
		do
			Result := new_font (a_bold,a_italic,a_height)
			Result.set_family (Family_roman)
		end

	new_screen_font (a_bold, a_italic: BOOLEAN; a_height: INTEGER): EV_FONT is
			-- Screen font
		do
			Result := new_font (a_bold,a_italic,a_height)
			Result.set_family (Family_screen)
		end

	new_modern_font (a_bold, a_italic: BOOLEAN; a_height: INTEGER): EV_FONT is
			-- Modern font
		do
			Result := new_font (a_bold,a_italic,a_height)
			Result.set_family (Family_modern)
		end

	new_typewriter_font (a_bold, a_italic: BOOLEAN; a_height: INTEGER): EV_FONT is
			-- Typewriter font
		do
			Result := new_font (a_bold,a_italic,a_height)
			Result.set_family (Family_typewriter)
		end

	new_font (a_bold, a_italic: BOOLEAN; a_height: INTEGER): EV_FONT is
			-- New font with default family.
		local
			l_weight: INTEGER
			l_shape: INTEGER
		do
			if a_bold then
				l_weight := weight_bold
			else
				l_weight := weight_regular
			end
			if a_italic then
				l_shape := shape_italic
			else
				l_shape := shape_regular
			end
			create Result.make_with_values (Family_sans,l_weight,l_shape,a_height)
		end

end
