indexing
	description: "EiffelVision pixmap repository"
	notice: "This class groups various icons/pixmaps fro convenience"
	author: "Zoran Simic"
	date: "$Date: 2009/03/31 $"
	revision: "$Revision: #9 $"

class
	ROSE_EV_REPOSITORY_PIXMAPS

inherit
	ROSE_SHARED_GLOBAL_GUI
	EV_STOCK_PIXMAPS

feature -- Pixmaps

	pixmap_by_name (a_name: STRING): EV_PIXMAP is
			-- Pixmap with 'a_name' (looked up in associated delivery)
		do
			Result := Gui.factory.new_pixmap (a_name)
		end

	alpha_pixmap: EV_PIXMAP is
			-- Icon representing an greek alpha letter
		once
			Result := Gui.factory.new_pixmap_from_file ("icon_class_header_color.ico")
		end

	attribute_pixmap: EV_PIXMAP is
			-- Icon representing an entity attribute
		once
			Result := Gui.factory.new_pixmap_from_file ("icon_attribute_symbol.ico")
		end

	back_pixmap: EV_PIXMAP is
			-- Icon representing a 'go back' action (left pointing arrow)
		once
			Result := Gui.factory.new_pixmap_from_file ("icon_back_color.ico")
		end

	forth_pixmap: EV_PIXMAP is
			-- Icon representing a 'go forth' action (right pointing arrow)
		once
			Result := Gui.factory.new_pixmap_from_file ("icon_forth_color.ico")
		end

	history_pixmap: EV_PIXMAP is
			-- Icon representing 'history' view (small analog clock)
		once
			Result := Gui.factory.new_pixmap_from_file ("icon_history_color.ico")
		end

	info_pixmap: EV_PIXMAP is
			-- Icon representing 'get information' (lowercase 'i')
		once
			Result := Gui.factory.new_pixmap_from_file ("icon_system_info_color.ico")
		end

feature -- Icons

	cursor_by_name (a_name: STRING): EV_POINTER_STYLE is
			-- Mouse pointer from icon with 'a_name'
		do
			create Result.make_with_pixmap (gui.factory.new_pixmap (a_name), 0, 0)
		end

	alpha_cursor: EV_POINTER_STYLE is
			-- Mouse pointer with a greek alpha letter
		once
			Result := Gui.factory.new_cursor_from_file ("icon_class_header_color.ico")
		end

	attribute_cursor: EV_POINTER_STYLE is
			-- Entity attribute cursor
		once
			Result := Gui.factory.new_cursor_from_file ("icon_attribute_symbol.ico")
		end

	back_cursor: EV_POINTER_STYLE is
			-- "Go back" cursor
		once
			Result := Gui.factory.new_cursor_from_file ("icon_back_color.ico")
		end

	forth_cursor: EV_POINTER_STYLE is
			-- "Go forth" cursor
		once
			Result := Gui.factory.new_cursor_from_file ("icon_forth_color.ico")
		end

	history_cursor: EV_POINTER_STYLE is
			-- History cursor
		once
			Result := Gui.factory.new_cursor_from_file ("icon_history_color.ico")
		end

	info_cursor: EV_POINTER_STYLE is
			-- More info mouse cursor
		once
			Result := Gui.factory.new_cursor_from_file ("icon_system_info_color.ico")
		end

	hand_cursor: EV_CURSOR is
			-- Mouse cursor representing a hand
		local
			l_pixmap: EV_PIXMAP
		do
			l_pixmap := Gui.factory.new_pixmap_from_file ("hand.ico")
			if l_pixmap = Void then
				Result := Standard_cursor
			else
				create Result.make_with_pixmap (l_pixmap,11,4)
			end
		end

end
