indexing
	description: "Window with title"
	author: "RJ"
	date: "$Date: 2013/04/24 $"
	revision: "$Revision: #4 $"
	archive: "$File: //rose/source/portable/system/windows/rose_ev_titled_window.e $"

class
	ROSE_EV_TITLED_WINDOW

inherit
	EV_TITLED_WINDOW
		redefine
			implementation,
			create_implementation
		select
			default_create,
			copy
		end
	ROSE_SHARED_GLOBAL_GUI
		rename
			default_create as rsgg_default_create,
			copy as rsgg_copy
		end
	MEMORY_FUNCTIONS
		rename
			free as mf_free
		undefine
			default_create,
			copy
		end

create
	default_create,
	make_with_title

feature
	destroy_default_shell_notify_icon is
	local
		l_result: INTEGER
	do
		if notify_icon_data/=Void
		then
			l_result := shell_notifyicon(NIM_DELETE, notify_icon_data.item)
		end
	end

	show_default_shell_notify_icon is
	local
		l_result: INTEGER
--		l_icon: WEL_ICON
	do
		if notify_icon_data=Void
		then
			close_request_actions.extend(agent destroy_default_shell_notify_icon)
			create notify_icon_data.make(sizeof_notifyicondata)
			notify_icon_data.put_integer_32(sizeof_notifyicondata, 0)			-- cbSize
			notify_icon_data.put_integer_32(pointer_to_integer(implementation.wel_item), 4)	-- hWnd
			notify_icon_data.put_integer_32(0, 8)								-- uID
--			notify_icon_data.put_integer_32(NIF_ICON | NIF_STATE, 12)			-- uFlags
			notify_icon_data.put_integer_32(NIF_ICON, 12)						-- uFlags
			notify_icon_data.put_integer_32(0, 16)								-- uCallbackMessage
			notify_icon_data.put_pointer(implementation.current_icon_pixmap.item, 20)
																			-- hIcon
--			create l_icon.make_by_file("\\rmatsb\Production\tools\projects\data_platform\entity_browser.ico")
--			notify_icon_data.put_integer_32(pointer_to_integer(l_icon.item), 20)-- hIcon
--			notify_icon_data.put_integer_32(0, 24)								-- szTip
--			notify_icon_data.put_integer_32(0, ??)								-- dwState
--			notify_icon_data.put_integer_32(0, ??)								-- dwStateMask
		end

		l_result := shell_notifyicon(NIM_ADD, notify_icon_data.item)
	end

feature {EV_ANY, EV_ANY_I} -- Implementation

	implementation: ROSE_EV_TITLED_WINDOW_IMP
		-- Implementation
	create_implementation is
	do
		create {ROSE_EV_TITLED_WINDOW_IMP}implementation.make
	end

feature {NONE}		-- Used by Shell_Notifyicon.
	shell_notifyicon(a_message: INTEGER; a_notifyicondata: POINTER): INTEGER is
	external
		"C [macro <shellapi.h>]"
	alias
		"Shell_NotifyIcon"
	end

	NIM_ADD: INTEGER is
	external
		"C [macro <shellapi.h>]"
	alias
		"NIM_ADD"
	end

	NIM_DELETE: INTEGER is
	external
		"C [macro <shellapi.h>]"
	alias
		"NIM_DELETE"
	end

	NIM_MODIFY: INTEGER is
	external
		"C [macro <shellapi.h>]"
	alias
		"NIM_MODIFY"
	end

	NIM_SETFOCUS: INTEGER is
	external
		"C [macro <shellapi.h>]"
	alias
		"NIM_SETFOCUS"
	end

	NIM_SETVERSION: INTEGER is
	external
		"C [macro <shellapi.h>]"
	alias
		"NIM_SETVERSION"
	end

feature {NONE}		-- Used by uFlags in NOTIFYICONDATA.
	sizeof_notifyicondata: INTEGER is
	external
		"C [macro <shellapi.h>]"
	alias
		"sizeof(NOTIFYICONDATA)"
--		"NOTIFYICONDATA_V2_SIZE"
	end

	NIF_ICON: INTEGER is
	external
		"C [macro <shellapi.h>]"
	alias
		"NIF_ICON"
	end

	NIF_MESSAGE: INTEGER is
	external
		"C [macro <shellapi.h>]"
	alias
		"NIF_MESSAGE"
	end

	NIF_TIP: INTEGER is
	external
		"C [macro <shellapi.h>]"
	alias
		"NIF_TIP"
	end

	NIF_STATE: INTEGER is
	external
		"C [macro <shellapi.h>]"
	alias
		"NIF_STATE"
	end

	NIF_INFO: INTEGER is
	external
		"C [macro <shellapi.h>]"
	alias
		"NIF_INFO"
	end

--	NIF_GUID: INTEGER is
--	external
--		"C [macro <shellapi.h>]"
--	alias
--		"NIF_GUID"
--	end

feature {NONE}		-- Used by dwState in NOTIFYICONDATA.
	NIS_HIDDEN: INTEGER is
	external
		"C [macro <shellapi.h>]"
	alias
		"NIS_HIDDEN"
	end

	NIS_SHAREDICON: INTEGER is
	external
		"C [macro <shellapi.h>]"
	alias
		"NIS_SHAREDICON"
	end


feature {NONE}
	notify_icon_data: MANAGED_POINTER

end
