note
	description: "Exception translator (default: no exception trace, just failing routine)"
	author: "Zoran Simic"
	last_editor: "$Author: zs $"
	date: "$Date: 2011/05/13 $"
	revision: "$Revision: #6 $"
	path: "$File: //rose/source/kernel/infrastructure/framework/error/rose_exception_translator.e $"

class
	ROSE_EXCEPTION_TRANSLATOR

feature -- Output

	last_exception_explanation (a_include_trace: BOOLEAN): attached STRING
			-- Info on last exception
		do
			create Result.make_empty
			Result.append_string (formatter.argumented (
				"Eiffel call '$1.$2' failed, tag: '$3'",
				<<	exceptions.class_name,
					exceptions.recipient_name,
					exceptions.tag_name
				>>))
			if a_include_trace then
				Result.append_string ("%NTrace:%N")
				Result.append_string (exceptions.exception_trace)
			end
		end

	formatter: attached ROSE_FORMATTING_SERVICE
			-- Formatting utility routines
		once
			create Result
		end

	exceptions: attached EXCEPTIONS
			-- Eiffel exceptions
		once
			create Result
		end

end
