indexing
	description: "Scanner for ROSE_EXPRESSION_NODE-s"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #13 $"

class ROSE_EXPRESSION_SCANNER

inherit
	YY_COMPRESSED_SCANNER_SKELETON
		rename
			make as make_compressed_scanner_skeleton,
			reset as reset_compressed_scanner_skeleton,
			output as yy_scanner_output
		end

	ROSE_EXPRESSION_TOKENS
		export {NONE} all end

create
	make_rose_expression_scanner

feature {NONE} -- Initialization

	make_rose_expression_scanner is
			-- Create a new Rose expression-node scanner.
		do
			make_with_buffer (Empty_buffer)
			create lexical_buffer.make (Init_lexical_buffer_size)
			line_number := 1
		end

feature -- Initialization

	reset is
			-- Reset scanner before scanning next input.
		do
			reset_compressed_scanner_skeleton
			line_number := 1
			lexical_buffer.wipe_out
		end

feature -- Access

	line_number: INTEGER
			-- Current line number


feature -- Status report

	valid_start_condition (sc: INTEGER): BOOLEAN is
			-- Is `sc' a valid start condition?
		do
			Result := (INITIAL <= sc and sc <= IN_STR)
		end

feature {NONE} -- Implementation

	yy_build_tables is
			-- Build scanner tables.
		do
			yy_nxt ?= yy_nxt_template
			yy_chk ?= yy_chk_template
			yy_base ?= yy_base_template
			yy_def ?= yy_def_template
			yy_ec ?= yy_ec_template
			yy_meta ?= yy_meta_template
			yy_accept ?= yy_accept_template
		end

	yy_execute_action (yy_act: INTEGER) is
			-- Execute semantic action.
		do
if yy_act <= 40 then
if yy_act <= 20 then
if yy_act <= 10 then
if yy_act <= 5 then
if yy_act <= 3 then
if yy_act <= 2 then
if yy_act = 1 then
--|#line 56 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 56")
end
-- Separators ignored
else
--|#line 57 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 57")
end
-- Comments ignored
end
else
--|#line 59 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 59")
end
line_number := line_number + 1
end
else
if yy_act = 4 then
--|#line 62 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 62")
end
last_token := RE_FALSE
else
--|#line 63 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 63")
end
last_token := RE_TRUE
end
end
else
if yy_act <= 8 then
if yy_act <= 7 then
if yy_act = 6 then
--|#line 66 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 66")
end
last_token := RE_ABS
else
--|#line 67 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 67")
end
last_token := RE_AND
end
else
--|#line 68 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 68")
end
last_token := RE_DIV
end
else
if yy_act = 9 then
--|#line 69 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 69")
end
last_token := RE_DIV
else
--|#line 70 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 70")
end
last_token := RE_IMPLIES
end
end
end
else
if yy_act <= 15 then
if yy_act <= 13 then
if yy_act <= 12 then
if yy_act = 11 then
--|#line 71 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 71")
end
last_token := RE_LOG
else
--|#line 72 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 72")
end
last_token := RE_MOD
end
else
--|#line 73 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 73")
end
last_token := RE_OR
end
else
if yy_act = 14 then
--|#line 74 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 74")
end
last_token := RE_XOR
else
--|#line 75 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 75")
end
last_token := RE_NOT
end
end
else
if yy_act <= 18 then
if yy_act <= 17 then
if yy_act = 16 then
--|#line 76 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 76")
end
last_token := RE_LE
else
--|#line 77 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 77")
end
last_token := RE_GE
end
else
--|#line 78 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 78")
end
last_token := RE_NE
end
else
if yy_act = 19 then
--|#line 79 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 79")
end
last_token := RE_NE
else
--|#line 80 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 80")
end
last_token := RE_RELATIVE_DELTA
end
end
end
end
else
if yy_act <= 30 then
if yy_act <= 25 then
if yy_act <= 23 then
if yy_act <= 22 then
if yy_act = 21 then
	yy_end := yy_end - 1
--|#line 83 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 83")
end

						last_token := RE_DOUBLE
						last_string_value := text
					
else
--|#line 84 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 84")
end

						last_token := RE_DOUBLE
						last_string_value := text
					
end
else
--|#line 85 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 85")
end

						last_token := RE_DOUBLE
						last_string_value := text
					
end
else
if yy_act = 24 then
--|#line 91 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 91")
end

						last_token := RE_INTEGER
						last_string_value := text
					
else
--|#line 97 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 97")
end
last_token := RE_CHARACTER; last_string_value := text_substring (2,2)
end
end
else
if yy_act <= 28 then
if yy_act <= 27 then
if yy_act = 26 then
--|#line 98 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 98")
end
last_token := RE_CHARACTER; last_string_value := "%A"
else
--|#line 99 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 99")
end
last_token := RE_CHARACTER; last_string_value := "%B"
end
else
--|#line 100 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 100")
end
last_token := RE_CHARACTER; last_string_value := "%C"
end
else
if yy_act = 29 then
--|#line 101 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 101")
end
last_token := RE_CHARACTER; last_string_value := "%D"
else
--|#line 102 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 102")
end
last_token := RE_CHARACTER; last_string_value := "%F"
end
end
end
else
if yy_act <= 35 then
if yy_act <= 33 then
if yy_act <= 32 then
if yy_act = 31 then
--|#line 103 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 103")
end
last_token := RE_CHARACTER; last_string_value := "%H"
else
--|#line 104 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 104")
end
last_token := RE_CHARACTER; last_string_value := "%L"
end
else
--|#line 105 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 105")
end
last_token := RE_CHARACTER; last_string_value := "%N"
end
else
if yy_act = 34 then
--|#line 106 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 106")
end
last_token := RE_CHARACTER; last_string_value := "%Q"
else
--|#line 107 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 107")
end
last_token := RE_CHARACTER; last_string_value := "%R"
end
end
else
if yy_act <= 38 then
if yy_act <= 37 then
if yy_act = 36 then
--|#line 108 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 108")
end
last_token := RE_CHARACTER; last_string_value := "%S"
else
--|#line 109 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 109")
end
last_token := RE_CHARACTER; last_string_value := "%T"
end
else
--|#line 110 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 110")
end
last_token := RE_CHARACTER; last_string_value := "%U"
end
else
if yy_act = 39 then
--|#line 111 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 111")
end
last_token := RE_CHARACTER; last_string_value := "%V"
else
--|#line 112 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 112")
end
last_token := RE_CHARACTER; last_string_value := "%%"
end
end
end
end
end
else
if yy_act <= 60 then
if yy_act <= 50 then
if yy_act <= 45 then
if yy_act <= 43 then
if yy_act <= 42 then
if yy_act = 41 then
--|#line 113 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 113")
end
last_token := RE_CHARACTER; last_string_value := "%'"
else
--|#line 114 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 114")
end
last_token := RE_CHARACTER; last_string_value := "%""
end
else
--|#line 115 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 115")
end
last_token := RE_CHARACTER; last_string_value := "%("
end
else
if yy_act = 44 then
--|#line 116 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 116")
end
last_token := RE_CHARACTER; last_string_value := "%)"
else
--|#line 117 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 117")
end
last_token := RE_CHARACTER; last_string_value := "%<"
end
end
else
if yy_act <= 48 then
if yy_act <= 47 then
if yy_act = 46 then
--|#line 118 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 118")
end
last_token := RE_CHARACTER; last_string_value := "%>"
else
--|#line 121 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 121")
end
		--"
			last_token := RE_STRING
			last_string_value := text_substring (2, text_count - 1)
		
end
else
--|#line 125 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 125")
end

			if text_count > 1 then
				lexical_buffer.append_string (text_substring (2, text_count))
			end
			set_start_condition (IN_STR)
		
end
else
if yy_act = 49 then
--|#line 131 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 131")
end
lexical_buffer.append_string (text)		--"
else
--|#line 132 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 132")
end
lexical_buffer.append_character ('%A')
end
end
end
else
if yy_act <= 55 then
if yy_act <= 53 then
if yy_act <= 52 then
if yy_act = 51 then
--|#line 133 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 133")
end
lexical_buffer.append_character ('%B')
else
--|#line 134 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 134")
end
lexical_buffer.append_character ('%C')
end
else
--|#line 135 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 135")
end
lexical_buffer.append_character ('%D')
end
else
if yy_act = 54 then
--|#line 136 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 136")
end
lexical_buffer.append_character ('%F')
else
--|#line 137 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 137")
end
lexical_buffer.append_character ('%H')
end
end
else
if yy_act <= 58 then
if yy_act <= 57 then
if yy_act = 56 then
--|#line 138 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 138")
end
lexical_buffer.append_character ('%L')
else
--|#line 139 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 139")
end
lexical_buffer.append_character ('%N')
end
else
--|#line 140 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 140")
end
lexical_buffer.append_character ('%Q')
end
else
if yy_act = 59 then
--|#line 141 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 141")
end
lexical_buffer.append_character ('%R')
else
--|#line 142 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 142")
end
lexical_buffer.append_character ('%S')
end
end
end
end
else
if yy_act <= 70 then
if yy_act <= 65 then
if yy_act <= 63 then
if yy_act <= 62 then
if yy_act = 61 then
--|#line 143 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 143")
end
lexical_buffer.append_character ('%T')
else
--|#line 144 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 144")
end
lexical_buffer.append_character ('%U')
end
else
--|#line 145 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 145")
end
lexical_buffer.append_character ('%V')
end
else
if yy_act = 64 then
--|#line 146 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 146")
end
lexical_buffer.append_character ('%%')
else
--|#line 147 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 147")
end
lexical_buffer.append_character ('%'')
end
end
else
if yy_act <= 68 then
if yy_act <= 67 then
if yy_act = 66 then
--|#line 148 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 148")
end
lexical_buffer.append_character ('%"')		--"
else
--|#line 149 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 149")
end
lexical_buffer.append_character ('%(')
end
else
--|#line 150 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 150")
end
lexical_buffer.append_character ('%)')
end
else
if yy_act = 69 then
--|#line 151 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 151")
end
lexical_buffer.append_character ('%<')
else
--|#line 152 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 152")
end
lexical_buffer.append_character ('%>')
end
end
end
else
if yy_act <= 75 then
if yy_act <= 73 then
if yy_act <= 72 then
if yy_act = 71 then
--|#line 153 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 153")
end
line_number := line_number + 1
else
--|#line 154 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 154")
end

			last_token := RE_STRING
			if text_count > 1 then
				lexical_buffer.append_string (text_substring (1, text_count - 1))
			end
			last_string_value := clone (lexical_buffer)
			lexical_buffer.wipe_out
			set_start_condition (INITIAL)
		
end
else
--|#line 163 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 163")
end
lexical_buffer.append_character (text_item (2))
end
else
if yy_act = 74 then
--|#line 164 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 164")
end
	--| Catch-all rules (no backing up)
			last_token := RE_ERROR
			set_start_condition (INITIAL)
		
else
--|#line 165 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 165")
end
	--| Catch-all rules (no backing up)
			last_token := RE_ERROR
			set_start_condition (INITIAL)
		
end
end
else
if yy_act <= 77 then
if yy_act = 76 then
--|#line 166 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 166")
end
	--| Catch-all rules (no backing up)
			last_token := RE_ERROR
			set_start_condition (INITIAL)
		
else
--|#line 173 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 173")
end
last_token := RE_IDENTIFIER; last_string_value := text
end
else
if yy_act = 78 then
--|#line 179 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 179")
end
last_token := text_item (1).code
else
--|#line 0 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 0")
end
last_token := yyError_token
fatal_error ("scanner jammed")
end
end
end
end
end
end
		end

	yy_execute_eof_action (yy_sc: INTEGER) is
			-- Execute EOF semantic action.
		do
			inspect yy_sc
when 0 then
--|#line 0 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 0")
end

			last_token := RE_EOF
			--| terminate
		
when 1 then
--|#line 0 "..\..\External\parsing\rose_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_expression_scanner.l' at line 0")
end
	--| Catch-all rules (no backing up)
			last_token := RE_ERROR
			set_start_condition (INITIAL)
		
			else
				terminate
			end
		end

feature {NONE} -- Table templates

	yy_nxt_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    6,    7,    8,    9,   10,    6,   11,    6,    6,
			    6,   12,   13,   14,   15,   16,    6,   17,   18,   19,
			   19,   20,   19,   21,   19,   19,   22,   19,   23,   24,
			   25,   26,   19,   19,   19,   19,   27,   19,   19,   28,
			   18,   19,   20,   19,   21,   23,   25,   19,   19,   27,
			   19,   19,    6,    6,   30,   31,   49,   32,   30,   31,
			   41,   32,   43,   42,   44,   45,   46,   50,   52,   57,
			   43,   58,   44,  113,  115,  120,  121,   64,   49,  123,
			   64,  124,   57,   50,   58,  157,  113,  115,  120,  121,
			   52,   62,   63,   64,   65,   62,   66,   67,   68,   69,

			   62,   62,   62,   70,   62,   71,   62,   72,   73,   74,
			   75,   76,   62,   77,   62,   78,   62,   62,   79,   62,
			   80,   62,   62,   81,   82,   83,   84,   85,   86,   62,
			   62,   62,   62,   62,   62,   62,   62,   62,   62,   62,
			   62,   62,   62,   62,   88,  114,   89,   90,   91,   92,
			  116,  119,  123,   64,   40,   93,  111,   94,   95,   96,
			   97,   98,  109,   99,  112,  100,  114,  116,  101,  122,
			  102,  111,  119,  103,  104,  105,  106,  107,  108,  149,
			  147,  147,  122,  109,  148,  112,  150,  150,  152,  153,
			  151,  154,  155,  125,  156,  156,  160,  161,  157,  157,

			  149,  152,   48,   48,   48,  159,  153,  158,  151,   37,
			  161,   37,  154,   37,   37,   37,   37,  160,   29,   29,
			   29,   29,   29,   29,   29,   29,   34,  151,  148,   34,
			   34,   34,   34,   34,   60,  148,  146,   60,   60,   60,
			   60,   60,   39,  145,   39,   39,   39,   39,   39,   39,
			  110,  110,  110,  110,  144,  110,  110,  110,  143,  142,
			  141,  140,  139,  138,  137,  136,  135,  134,  133,  132,
			  131,  130,  129,  128,  127,  126,  125,   61,  118,  117,
			   87,   35,   33,   61,   59,   56,   55,   54,   53,   51,
			   47,   40,   39,   38,   36,   35,   33,  162,    5,  162,

			  162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
			  162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
			  162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
			  162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
			  162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
			  162,  162>>)
		end

	yy_chk_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    3,    3,   18,    3,    4,    4,
			   14,    4,   15,   14,   15,   16,   16,   18,   21,   26,
			   44,   27,   44,   49,   51,   56,   58,   64,   18,   63,
			   63,   64,   26,   18,   27,  157,   49,   51,   56,   58,
			   21,   32,   32,   32,   32,   32,   32,   32,   32,   32,

			   32,   32,   32,   32,   32,   32,   32,   32,   32,   32,
			   32,   32,   32,   32,   32,   32,   32,   32,   32,   32,
			   32,   32,   32,   32,   32,   32,   32,   32,   32,   32,
			   32,   32,   32,   32,   32,   32,   32,   32,   32,   32,
			   32,   32,   32,   32,   38,   50,   38,   38,   38,   38,
			   52,   55,  123,  123,   40,   38,   43,   38,   38,   38,
			   38,   38,   40,   38,   43,   38,   50,   52,   38,   59,
			   38,  111,   55,   38,   38,   38,   38,   38,   38,  111,
			  109,  109,   59,   40,  109,   43,  112,  112,  116,  117,
			  112,  121,  125,  125,  149,  149,  159,  160,  149,  156,

			  111,  116,  166,  166,  166,  153,  117,  152,  151,  165,
			  160,  165,  121,  165,  165,  165,  165,  159,  163,  163,
			  163,  163,  163,  163,  163,  163,  164,  150,  148,  164,
			  164,  164,  164,  164,  167,  147,  108,  167,  167,  167,
			  167,  167,  168,  107,  168,  168,  168,  168,  168,  168,
			  169,  169,  169,  169,  106,  169,  169,  169,  105,  104,
			  103,  102,  101,  100,   99,   98,   97,   96,   95,   94,
			   93,   92,   91,   90,   89,   88,   70,   60,   54,   53,
			   37,   34,   33,   29,   28,   25,   24,   23,   22,   20,
			   17,   13,   12,   11,   10,    9,    7,    5,  162,  162,

			  162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
			  162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
			  162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
			  162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
			  162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
			  162,  162>>)
		end

	yy_base_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    0,    0,   51,   55,  297,  298,  294,  298,  291,
			  241,  287,  281,  277,   47,   50,   49,  274,   37,    0,
			  263,   50,  259,  256,  255,  254,   35,   37,  253,  279,
			  298,  298,   90,  280,  277,  298,  298,  273,  140,    0,
			  140,  298,  298,  142,   58,  298,  298,  298,    0,   38,
			  124,   36,  122,  247,  254,  130,   39,    0,   39,  135,
			  273,  298,  298,   77,   75,  298,  298,  298,  298,  298,
			  262,  298,  298,  298,  298,  298,  298,  298,  298,  298,
			  298,  298,  298,  298,  298,  298,  298,  298,  268,  267,
			  266,  265,  264,  263,  262,  261,  260,  259,  258,  257,

			  256,  255,  254,  253,  252,  251,  247,  236,  229,  170,
			  298,  157,  176,    0,    0,    0,  153,  161,    0,    0,
			    0,  169,    0,  150,  298,  179,  298,  298,  298,  298,
			  298,  298,  298,  298,  298,  298,  298,  298,  298,  298,
			  298,  298,  298,  298,  298,  298,  298,  221,  214,  184,
			  213,  194,  164,  179,    0,  298,  185,   71,    0,  174,
			  162,    0,  298,  217,  225,  208,  196,  233,  241,  249>>)
		end

	yy_def_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,  162,    1,  163,  163,  162,  162,  162,  162,  164,
			  162,  165,  162,  162,  162,  162,  162,  162,  166,  166,
			  166,  166,  166,  166,  166,  166,  166,  166,  166,  167,
			  162,  162,  162,  162,  164,  162,  162,  162,  162,  168,
			  162,  162,  162,  169,  162,  162,  162,  162,  166,  166,
			  166,  166,  166,  166,  166,  166,  166,  166,  166,  166,
			  167,  162,  162,  162,  162,  162,  162,  162,  162,  162,
			  162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
			  162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
			  162,  162,  162,  162,  162,  162,  162,  162,  162,  162,

			  162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
			  162,  162,  162,  166,  166,  166,  166,  166,  166,  166,
			  166,  166,  166,  162,  162,  162,  162,  162,  162,  162,
			  162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
			  162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
			  162,  162,  166,  166,  166,  162,  162,  162,  166,  166,
			  166,  166,    0,  162,  162,  162,  162,  162,  162,  162>>)
		end

	yy_ec_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    2,
			    3,    1,    1,    2,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    2,    1,    4,    5,    1,    6,    1,    7,
			    8,    9,    1,   10,    1,   11,   12,   13,   14,   14,
			   14,   14,   14,   14,   14,   14,   14,   14,    1,    1,
			   15,   16,   17,    1,    1,   18,   19,   20,   21,   22,
			   23,   24,   25,   26,   27,   27,   28,   29,   30,   31,
			   32,   33,   34,   35,   36,   37,   38,   27,   39,   27,
			   27,    1,    1,    1,    1,   27,    1,   40,   41,   27,

			   42,   43,   44,   24,   27,   26,   27,   27,   45,   29,
			   46,   31,   32,   27,   47,   48,   49,   50,   51,   27,
			   39,   27,   27,    1,   52,    1,   53,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1>>)
		end

	yy_meta_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    2,    1,    1,    3,    4,    1,    1,
			    1,    1,    5,    1,    6,    1,    1,    1,    6,    6,
			    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
			    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
			    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
			    6,    7,    8,    1>>)
		end

	yy_accept_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    0,    0,    0,    0,   80,   78,    1,    3,   48,
			   78,   78,   78,   78,   78,   24,   78,   78,   77,   77,
			   77,   77,   77,   77,   77,   77,   77,   77,   77,   49,
			   74,   72,   74,    1,   48,   47,   20,    0,    0,    2,
			   23,    9,   19,    0,   24,   16,   18,   17,   77,   77,
			   77,   77,   77,   77,   77,   77,   77,   13,   77,   77,
			   49,   72,   73,   73,   75,   66,   64,   65,   67,   68,
			   73,   69,   70,   50,   51,   52,   53,   54,   55,   56,
			   57,   58,   59,   60,   61,   62,   63,   25,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			   21,   23,   21,    6,    7,    8,   77,   77,   11,   12,
			   15,   77,   14,    0,   71,   76,   42,   40,   41,   43,
			   44,   45,   46,   26,   27,   28,   29,   30,   31,   32,
			   33,   34,   35,   36,   37,   38,   39,    0,   23,    0,
			    0,   22,   77,   77,    5,   76,    0,   22,    4,   77,
			   77,   10,    0>>)
		end

feature {NONE} -- Constants

	yyJam_base: INTEGER is 298
			-- Position in `yy_nxt'/`yy_chk' tables
			-- where default jam table starts

	yyJam_state: INTEGER is 162
			-- State id corresponding to jam state

	yyTemplate_mark: INTEGER is 163
			-- Mark between normal states and templates

	yyNull_equiv_class: INTEGER is 1
			-- Equivalence code for NULL character

	yyReject_used: BOOLEAN is false
			-- Is `reject' called?

	yyVariable_trail_context: BOOLEAN is false
			-- Is there a regular expression with
			-- both leading and trailing parts having
			-- variable length?

	yyReject_or_variable_trail_context: BOOLEAN is false
			-- Is `reject' called or is there a
			-- regular expression with both leading
			-- and trailing parts having variable length?

	yyNb_rules: INTEGER is 79
			-- Number of rules

	yyEnd_of_buffer: INTEGER is 80
			-- End of buffer rule code

	yyLine_used: BOOLEAN is false
			-- Are line and column numbers used?

	yyPosition_used: BOOLEAN is false
			-- Is `position' used?

	INITIAL: INTEGER is 0
	IN_STR: INTEGER is 1
			-- Start condition codes

feature -- User-defined features



feature {NONE} -- Implementation

	lexical_buffer: STRING
			-- Buffer for lexical tokens

	code_: INTEGER
			-- Attribute used as temporary integer

	last_indentation: STRING
		-- Keep indentation to save back config almost as read

feature {NONE} -- Constants

	Init_lexical_buffer_size: INTEGER is 256
				-- Initial size for `lexical_buffer'

end -- class ROSE_EXPRESSION_SCANNER
