indexing
	description : "[
		Represents a format where the columns have fixed widths
		]"
	author : "Mark Howard"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #4 $"

class
	ROSE_FIXED_FORMAT
inherit
	ROSE_FORMAT
create
	make
feature
	make (a_format : ARRAY[TUPLE[INTEGER,STRING,INTEGER,INTEGER]]) is
		local
			i : INTEGER
			l_string : STRING
			l_info : TEXT_COLUMN_INFO
		do
			set_number_of_columns(a_format.count)
			from i := 1 until i > a_format.count loop
				l_string ?= a_format.item(i).item(2)
				l_string.to_lower
				create l_info.make(a_format.item(i).integer_item(1),
						l_string,
						a_format.item(i).integer_item(3),
						a_format.item(i).integer_item(4))
				column_info.put(l_info,i)
				column_name_info.put(i,l_string)
				i := i + 1
			end
		end
	substring (a_string : STRING;i : INTEGER) : STRING is
		local
			l_info : TEXT_COLUMN_INFO
		do
			l_info := column_info.item(i)
			if l_info /= void then
				Result := a_string.substring(l_info.first,l_info.second)
			end
		end
end -- class ROSE_FIXED_FORMAT
