indexing
	description: "[
				 This expression is merely a shell around an expression and an operator.
				 The intention is to allow an expression to be tagged with some information
				 defined by the descendant.  This is currently used in the cube to distinguish
				 between various flavors of data.  Valuation_data vs. valuation_fiscal_data.
				 Consolidated vs. Parent.  Etc.  Look at the descendants for more information.
				 ]"
	author: "RJ"
	last_editor: "$Author: it $"
	date: "$Date: 2014/03/14 $"
	revision: "$Revision: #12 $"
	path: "$File: //rose/source/Kernel/math/rose_identity_expression.e $"

class
	ROSE_IDENTITY_EXPRESSION[reference G]

inherit
	ROSE_UNARY_EXPRESSION[G]
		undefine
			internal_generated_real,
			internal_generated_integer,
			internal_generated_string,
			internal_generated_date,
			internal_generated_double,
			generated_unitized_value,
			boolean_value,
			string_value,
			computed_string,
			computed_boolean,
			computed_units,
			display_string,
			double_using_agent
		redefine
			make,
			sub_expressions
		end
	ROSE_EXPRESSION[G]
		rename
			make as rose_expression_make
		undefine					-- Any 'redefine' that is added to ROSE_UNARY_EXPRESSION may need to be added here.
			sub_expressions,
			component_expressions,
			units,
			computed_double,
			computed_real,
			computed_integer,
			is_defined_real,
			is_defined_double,
			value_in_market_currency,
			is_flow,
			generated_value_in_market_currency,
			nominal_units
		end

create
	make

feature {NONE} -- Initialization.

	make(a_left: like left; a_operator: like operator) is
			--creation
		do
			Precursor(a_left, a_operator)
			variable_index := a_left.variable_index
			variable_description := a_left.variable_description
		end

feature -- Access.

	sub_expressions: ROSE_LINEAR_ARRAY[ROSE_EXPRESSION[like expression_target]] is
			-- The result is an array of all sub-expressions that this expression is made from.
			-- The caveat is that any variables will not be listed naked.  They will be
			-- a ROSE_IDENTITY_EXPRESSION.
		do
			if left.variable_index/=0
			then
				 create Result.make(1, 1)
				 Result[1] := Current
			else
				Result := Precursor{ROSE_UNARY_EXPRESSION}

				from
					Result.start
				until
					Result.off
				loop
					if Result.current_item.variable_index/=0
					then
						 Result[Result.index] := create {ROSE_IDENTITY_EXPRESSION[like expression_target]}.make(Result[Result.index], operator)
					end

					Result.forth
				end
			end
		end

end
