indexing
	description: "Preferred handling of undefined values on windows"
	author: "Mark Howard"
	last_editor: "$Author: mk $"
	date: "$Date: 2011/02/15 $"
	revision: "$Revision: #15 $"
	path: "$File: //rose/source/kernel/infrastructure/math/rose_ieee_undefined.e $"

class ROSE_IEEE_UNDEFINED

inherit
	IEEE_MATH
	ROSE_UNDEFINED

feature  -- Access

	is_defined_integer (a_value: INTEGER): BOOLEAN is
			-- is `a_value' defined with respect to legacy or windows?
		do
		   Result := a_value /= undefined_integer and then not constants.is_null_integer (a_value)
		end

	undefined_value: REAL is
			-- Undefined REAL value
		once
			Result := Qnan_real_32
		end

	undefined_real: REAL is
			-- Undefined REAL value
		once
			Result := Qnan_real_32
		end

	undefined_double: DOUBLE is
			-- Unknown DOUBLE value; no more of this -999. nonsense
		once
			Result := Qnan
		end

	undefined_integer: INTEGER is
			-- Undefined INTEGER
		once
   			Result := -2147483645
		end
	legacy_undefined_integer: INTEGER is
			-- Undefined INTEGER used by legacy systems
		once
   			Result := constants.missing_integer
		end

end
