indexing
	description: "Input channel for Eiffel Vision console"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #4 $"

class ROSE_INCHANNEL_EV

inherit
	ROSE_INCHANNEL
		redefine
			new_representative
		end

create
	make

feature {NONE} -- Initialization

	make is
			-- Create a default EV channel.
		do
			is_interactive := True
		end

feature -- Access

	id: STRING is "ev_console"
			-- Channel type id

	new_representative: like Current is
			-- New independent version of Current service.
			-- If you want this service to be shared (unique instance used for the whole system),
			-- return Current (no clone)
		do
			Result := Current
		end

	medium: FILE
			-- Dummy medium

	ask (a_question: STRING): STRING is
			-- Ask 'a_question' on this channel
			-- Void when input is exhausted
		local
			l_gui: ROSE_SHARED_GLOBAL_GUI
		do
			create l_gui
			Result := l_gui.gui.console.ask (a_question)
		end

feature -- Status report

	is_open: BOOLEAN is True
			-- Is this channel open ?
			--| Always True when launched properly using ROSE_PILOT_GUI

feature -- Output

	help: STRING is "Output to Eiffel Vision console"
			-- Help on this command

feature {NONE} -- Implementation

	do_open is
			-- Open effectively this channel with 'parameters'.
		do
			--| Do nothing
		end

	do_close is
			-- Close effectively this channel.
		do
			--| Do nothing
		end

end -- class ROSE_INCHANNEL_EV
