note

	description:

		"ancestor for any class wishing to access rose persistent objects"

	keywords: "entities,persistence"
	author: "Mark Howard"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #23 $"
	path: "$File: //rose/source/kernel/investment_entities/rose_investment_entities.e $"

deferred class
	ROSE_INVESTMENT_ENTITIES

inherit
	ROSE_CONSTANTS
	DATABASE_SERVER
	ROSE_IDENTIFIERS
	ROSE_ID_USER

feature  --Access
	current_currency (a_identifier : like context.entity_identifier_template;a_key : STRING) : CURRENCY is
			--current currency from identifier
		do
			Result := context.currency_accessor.entity_from_identifier(a_key,void,a_identifier)
		end
	global_companies : ROSE_LINEAR_ARRAY[like context.company_template] is
			--All companies globally
		do
			create Result.make_empty
		end
	global_securities : ROSE_LINEAR_ARRAY[like context.security_template]
			--All securities from this context
		do
			create Result.make_empty
		end
	global_listings : ROSE_LINEAR_ARRAY[like context.listing_template] is
		do
			create Result.make_empty
		end

	global_countries : ROSE_LINEAR[like context.country_template] is
			-- All countries in this context
		do
			Result := context.country_accessor.all_entities
		end

	all_industries : ROSE_LINEAR[like context.industry_template] is
			-- All industries in this context
		do
			Result := context.industry_accessor.all_entities
		end


	zone_count : INTEGER is 8
	u_zone : like context.zone_template is do Result := context.u_zone end
	e_zone : like context.zone_template is do Result := context.e_zone end
	c_zone : like context.zone_template is do Result := context.c_zone end
	j_zone : like context.zone_template is do Result := context.j_zone end
	o_zone : like context.zone_template is do Result := context.o_zone end
	s_zone : like context.zone_template is do Result := context.s_zone end
	t_zone : like context.zone_template is do Result := context.t_zone end
	i_zone : like context.zone_template is do Result := context.i_zone end

	ur_company : like context.company_template
		do
			Result := context.company_accessor.ur_entity
		end
	ur_security : like context.security_template
		do
			Result := context.security_accessor.ur_entity
		end
	ur_listing : like context.listing_template
		do
			Result := context.listing_accessor.ur_entity
		end

	ur_bond : like context.bond_template
		do
			Result := context.bond_accessor.ur_entity
		end
	ur_country : like context.country_template
		do
			Result := context.country_accessor.ur_entity
		end
	ur_currency : like context.currency_template
		do
			Result := context.currency_accessor.ur_entity
		end
	ur_market_index_listing : like context.market_index_listing_template
		do
			Result := context.market_index_listing_accessor.ur_entity
		end
	ur_market_index: like context.market_index_template
		do
			Result := context.market_index_accessor.ur_entity
		end
	ur_future_listing : like context.future_listing_template
		do
			Result := context.future_listing_accessor.ur_entity
		end
	ur_future : like context.future_template
		do
			Result := context.future_accessor.ur_entity
		end
	ur_fund_listing : like context.fund_listing_template
		do
			Result := context.fund_listing_accessor.ur_entity
		end
	ur_fund_issue : like context.fund_issue_template
		do
			Result := context.fund_issue_accessor.ur_entity
		end
	ur_fund : like context.fund_template
		do
			Result := context.fund_accessor.ur_entity
		end
	ur_bond_listing : like context.bond_listing_template
		do
			Result := context.bond_listing_accessor.ur_entity
		end
	ur_government_issue_listing : like context.government_issue_listing_template
		do
			Result := context.government_issue_listing_accessor.ur_entity
		end
	ur_government_issuer : like context.government_issuer_template
		do
			Result := context.government_issuer_accessor.ur_entity
		end
	ur_government_issue : like context.government_issue_template
		do
			Result := context.government_issue_accessor.ur_entity
		end

	zones : ROSE_LINEAR[like context.zone_template] is
		do
			Result := context.all_zones
		ensure
			zone_count_matches : Result.count = zone_count
		end

	context : ROSE_CONTEXT is
		deferred
		end

end








