note

	description:

		"Mapping between ELOGGER severities and ROSE_IO_CONVETION verbosities"

	author: "Colin Adams"
	last_editor: "$Author: c4 $"
	date: "$Date: 2014/07/16 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/infrastructure/framework/application/rose_io_verbosity.e $"

class ROSE_IO_VERBOSITY

inherit

	ELOG_SEVERITY_CONSTANTS
		
feature -- Access

	verbosity_from_severity (a_level: INTEGER_8): INTEGER
			-- Mapping of ELOGGER severity level to Rosenberg I/O framework verbosity
		do
			if a_level > Warning_int then
				Result := {ROSE_IO_CONVENTION}.v_error
			elseif a_level > Harmless_int then
				Result := {ROSE_IO_CONVENTION}.v_warning
			elseif a_level > Information_int  then
				Result := {ROSE_IO_CONVENTION}.v_log
			elseif a_level > Debug_int then
				Result := {ROSE_IO_CONVENTION}.v_output
			else
				Result := {ROSE_IO_CONVENTION}.v_trace
			end
		ensure
			verbosity_in_range: Result >= {ROSE_IO_CONVENTION}.minimum_verbosity and Result <= {ROSE_IO_CONVENTION}.maximum_verbosity			
		end
	
end
