indexing
	description: "Definitions of undefined values which match legacy VMS"
	author: "Mark Howard"
	last_editor: "$Author: zs $"
	date: "$Date: 2010/04/08 $"
	revision: "$Revision: #15 $"
	path: "$File: //rose/source/kernel/infrastructure/math/rose_legacy_undefined.e $"

class ROSE_LEGACY_UNDEFINED

inherit
	ROSE_UNDEFINED

feature  --Access

	is_defined_integer (a_value: INTEGER): BOOLEAN is
			-- is `a_value' defined with respect to legacy or windows?
		do
			Result := a_value /= undefined_integer and then not constants.is_null_integer (a_value)
		end

	undefined_value: REAL is
			-- Undefined REAL value
		once
			Result := {REAL_32}-999.
		end

	undefined_real: REAL is
			-- Undefined REAL value
		once
			Result := {REAL_32}-999.
		end

	undefined_double: DOUBLE is
			-- unknown DOUBLE value used in legacy
		once
			Result := -999.
		end

	undefined_integer: INTEGER is
		once
			Result := -999
		end

end
