indexing
	description: "Standard legend where icons are identified by INTEGERs"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #10 $"

class
	ROSE_LEGEND_STANDARD

inherit
	ROSE_LEGEND [TUPLE [INTEGER,INTEGER]]
	ROSE_SHARED_GLOBAL_GUI
		undefine
			default_create
		end

create
	make

feature -- Initialization

	make (a_title: STRING) is
		do
			default_create
			set_title (a_title)
			reset
		end

feature -- Access

	icon (a_id: TUPLE [INTEGER,INTEGER]): EV_MODEL_ATOMIC is
			-- Icon corresponding to 'a_id', return a new object each time
			-- Do not return cloned objects, as this does not work with EV_MODELs
		local
			l_shape_id, l_color_id: INTEGER
			l_color: EV_COLOR
		do
			l_shape_id := a_id.integer_item (1)
			l_color_id := a_id.integer_item (2)
			l_color := palette.color (l_color_id)
			l_shape_id := l_shape_id \\ 7
			if l_shape_id = 1 then
				Result := new_ellipse (l_color)
			elseif l_shape_id = 2 then
				Result := new_triangle (l_color,-1)
			elseif l_shape_id = 3 then
				Result := new_triangle (l_color,1)
			elseif l_shape_id = 4 then
				Result := new_rectangle (l_color)
			elseif l_shape_id = 5 then
				Result := new_diamond (l_color)
			elseif l_shape_id = 6 then
				Result := new_pixmap ("excel_small.ico")
			else
				Result := new_rectangle (l_color)
			end
		end

end
