indexing
	description: "ROSE_MULTI_COLUMN_LIST cell representative"
	author: "Mark Howard"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #18 $"

class
	ROSE_LIST_ITEM

inherit
	STRING_32
		rename
			make as string_make
		end

create
	make, make_colored, make_text,string_make, make_string_32

convert
	make_text ({STRING}),
	make_string_32 ({STRING_32}),
	to_string_8: {STRING}

feature -- Initialization

	make (a_text: ANY; a_foreground_color, a_background_color: EV_COLOR; a_pixmap: EV_PIXMAP; a_widget: ROSE_CELL_WIDGET) is
		do
			set_text (a_text)
			foreground_color := a_foreground_color
			background_color := a_background_color
			pixmap := a_pixmap
			widget := a_widget
		end

	make_colored (a_text: ANY; a_foreground_color: EV_COLOR) is
		do
			make (a_text,a_foreground_color,Void,Void,Void)
		end

	make_text (a_text: ANY) is
		do
			make (a_text,Void,Void,Void,Void)
		end

	make_string_32 (a_text: STRING_32) is
		do
			make (a_text,Void,Void,Void,Void)
		end

feature -- Access

	font : EV_FONT
			-- Font used to show 'text'

	text: STRING
			-- Cell text

	foreground_color: EV_COLOR
			-- Foreground color for the text

	background_color: EV_COLOR
			-- Backgound color for the cell

	pixmap: EV_PIXMAP
			-- Associated pixmap to this cell

	widget: ROSE_CELL_WIDGET
			-- Associated widget to this cell

	data: ANY
			-- Associated data

feature -- Basic operations

	set_font (a_font : EV_FONT) is
		do
			font := a_font
		end

	set_text (a_text: ANY) is
		do
			data := a_text
			if a_text /= Void then
				text := a_text.out
			else
				text := ""
			end
			make_from_string (text)
		end

	set_foreground_color (a_color: EV_COLOR) is
		do
			foreground_color := a_color
		end

	set_background_color (a_color: EV_COLOR) is
		do
			background_color := a_color
		end

	set_pixmap (a_pixmap: like pixmap) is
		do
			pixmap := a_pixmap
		end

	set_widget (a_widget: like widget) is
		do
			widget := a_widget
		end

	set_data (a_data: ANY) is
		do
			data := a_data
		end

end -- class ROSE_LIST_ITEM
