note

	description:

		"ROSE_ENTITY_DATE with LISTING as the entity"

	author: "Mark Howard"
	last_editor: "$Author: mk $"
	date: "$Date: 2011/05/03 $"
	revision: "$Revision: #14 $"
	path: "$File: //rose/source/kernel/data/market/rose_listing_date.e $"

class
	ROSE_LISTING_DATE

inherit
	ROSE_ENTITY_DATE[LISTING]
		undefine
			context
		redefine
			new_variable,
			expression_tag,
			context_name,
			anchor,
			expressions,
			expressions_anchor,
			expression_target
		end

	ROSE_AWARE

create
	make,default_create

feature -- Access

	expressions : like expressions_anchor is
			--expressions for this class
		do
			Result ?= expressions_table.item(internal_type)
			if Result = Void then
				create Result.make_from_descriptions(context.variable_descriptions(expression_tag),agent new_variable,context.mappings_from_descriptions(context.variable_descriptions(expression_tag)))
				expressions_table.put(Result,internal_type)
			end
		end

	new_variable (a_variable_description : VARIABLE_DESCRIPTION_RECORD) : ROSE_MARKET_VARIABLE is
			-- New variable with 'a_varialble_description'
  		do
			create Result.make(a_variable_description)
  		end

	load_target_cache(a_entities : ROSE_LINEAR_ARRAY[like entity]) is
			-- Load target cache
		local
			l_targets : like entity_targets
			l_entity : like entity
		do
			if a_entities /= Void then
				from a_entities.start until a_entities.off loop
					l_entity := a_entities.current_item
					l_targets := entity_targets_imp(l_entity)
					target_cache.force(l_targets, l_entity.handle)
					a_entities.forth
				end
			end
		end

	entity_targets(a_entity : like ENTITY) : ROSE_LINEAR_ARRAY[like anchor] is
		do
			if a_entity /= Void then
				Result := entity_targets_imp(a_entity)
			end
		end

	target_cache : ROSE_VOLATILE_CACHE[ROSE_LINEAR_ARRAY[ROSE_LISTING_DATE], INTEGER] is
		once
			create Result.make(500, 5000)
		end

	currency : CURRENCY is
		do
			Result := entity.rmdat_currency(date)
		end

	expression_tag : STRING is "market"

	context_name : STRING is "RESEARCH"

	anchor : ROSE_LISTING_DATE is do end

feature {NONE}  --Implementation

	entity_targets_imp(a_entity : like ENTITY) : ROSE_LINEAR_ARRAY[like anchor] is
		local
			i : INTEGER
			l_dates : ROSE_LINEAR_ARRAY[like date]
			l_date : like date
			l_target : like anchor
		do
			if a_entity /= Void then
				l_dates := a_entity.available_market_dates
				if l_dates /= Void and then l_dates.count > 0 then
					create Result.make(1, l_dates.count)
					from i:= 1 until i > l_dates.count loop
						l_date := l_dates.item(i)
						create l_target.make(a_entity, l_date)
						Result.put(l_target, i)
						i := i + 1
					end
				end
			end
		end

feature -- Templates

	expressions_anchor : ENTITY_VARIABLES [ROSE_LISTING_DATE] is
			-- Template
		do
		end

	expression_target : ROSE_EXPRESSION[ROSE_LISTING_DATE] is
			-- Template
		do
		end

end
