note

	description:

		"ROSE_MARKET_VARIABLE"

	author: "Michael Zhang"
	last_editor: "$Author: er $"
	date: "$Date: 2014/01/03 $"
	revision: "$Revision: #19 $"
	path: "$File: //rose/source/kernel/data/market/rose_market_variable.e $"

class
	ROSE_MARKET_VARIABLE

inherit
	DOUBLE_VALUED_EXPRESSION[ROSE_LISTING_DATE]
		redefine
			make,
			string_value
		end
	ROSE_LEGACY_UNDEFINED
		undefine
			default_create
		end

create
	make

feature  -- create
	make (a_description : like variable_description) is
	-- create object
		do
			Precursor(a_description)
			if a_description.name.is_equal("unadjusted_closing_price") then
				action := Agent unadjusted_closing_action
			elseif a_description.name.is_equal("unadjusted_open") then
				action := Agent unadjusted_open_action
			elseif a_description.name.is_equal("unadjusted_high") then
				action := Agent unadjusted_high_action
			elseif a_description.name.is_equal("unadjusted_low") then
				action := Agent unadjusted_low_action
			elseif a_description.name.is_equal("unadjusted_bid") then
				action := Agent unadjusted_bid_action
			elseif a_description.name.is_equal("unadjusted_ask") then
				action := Agent unadjusted_ask_action
			elseif a_description.name.is_equal("closing_price") then
				action := Agent close_action
			elseif a_description.name.is_equal("opening_price") then
				action := Agent open_action
			elseif a_description.name.is_equal("high_price") then
				action := Agent high_action
			elseif a_description.name.is_equal("low_price") then
				action := Agent low_action
			elseif a_description.name.is_equal("ask_price") then
				action := Agent ask_action
			elseif a_description.name.is_equal("bid_price") then
				action := Agent bid_action
			elseif a_description.name.is_equal("unadjusted_volume") then
				action := Agent unadjusted_volume_action
			elseif a_description.name.is_equal("volume") then
				action := Agent volume_action
			elseif a_description.name.is_equal("last_price") then
				action := Agent last_action
			elseif a_description.name.is_equal("adjustment_factor") then
				action := Agent adjustment_action
			elseif a_description.name.is_equal("currency_iso") then
				type := string_type
			end
		end
	action : FUNCTION[ANY,TUPLE[like expression_target],DOUBLE]

	unadjusted_closing_action (a_target : like expression_target) : DOUBLE is
			-- get unadjusted closing action value
		do
			Result := a_target.entity.unadjusted_closing_price(a_target.date)
		end

	close_action (a_target : like expression_target) : DOUBLE is
			-- get close action value
		do
			Result := a_target.entity.closing_price(a_target.date)
		end

	unadjusted_open_action (a_target : like expression_target) : DOUBLE is
			-- get unadjusted open action value
		do
			Result := a_target.entity.unadjusted_open(a_target.date)
		end

	open_action (a_target : like expression_target) : DOUBLE is
			-- get open action value
		do
			Result := a_target.entity.opening_price(a_target.date)
		end

	unadjusted_high_action (a_target : like expression_target) : DOUBLE is
		-- get unadjusted high action value
		do
			Result := a_target.entity.unadjusted_high(a_target.date)
		end

	high_action (a_target : like expression_target) : DOUBLE is
		-- get high action value
		do
			Result := a_target.entity.high_ask(a_target.date)
		end

	unadjusted_low_action (a_target : like expression_target) : DOUBLE is
		-- get unadjusted low action avalue
		do
			Result := a_target.entity.unadjusted_low(a_target.date)
		end

	low_action (a_target : like expression_target) : DOUBLE is
		-- get low action avalue
		do
			Result := a_target.entity.low_bid(a_target.date)
		end

	unadjusted_bid_action (a_target : like expression_target) : DOUBLE is
		-- get unadjusted bid action vlaue
		do
			Result := a_target.entity.unadjusted_bid(a_target.date)
		end

	bid_action (a_target : like expression_target) : DOUBLE is
		-- get bid action vlaue
		do
			Result := a_target.entity.bid(a_target.date)
		end

	unadjusted_ask_action (a_target : like expression_target) : DOUBLE is
		-- get unadjusted ask action value
		do
			Result := a_target.entity.unadjusted_ask(a_target.date)
		end

	ask_action (a_target : like expression_target) : DOUBLE is
		-- get ask action value
		do
			Result := a_target.entity.ask(a_target.date)
		end

	unadjusted_volume_action (a_target : like expression_target) : DOUBLE is
		-- get unadjustiment valueme action value
		do
			Result := a_target.entity.unadjusted_volume(a_target.date)
		end

	volume_action (a_target : like expression_target) : DOUBLE is
		-- get volume action value
		do
			Result := a_target.entity.volume(a_target.date)
		end

	last_action (a_target : like expression_target) : DOUBLE is
		-- get last action value
		do
			Result := a_target.entity.last_price(a_target.date)
		end
	adjustment_action(a_target : like expression_target) : DOUBLE is
	-- get adjustiment action value
		do
			Result := a_target.entity.adjustment(a_target.date)
		end
	currency (a_target : like expression_target) : CURRENCY is
	-- get curcency
		do
--			Result := a_target.entity.currency(a_target.date)
			Result := a_target.currency
		end

	at (a_target : like expression_target) : DOUBLE is
	-- value at a target
		do
			if action /= Void then
				if a_target /= Void then
					Result := action.item([a_target])
				end
			end
		end

	string_value(a_target : like expression_target) : STRING is
	-- string value
		local
			l_currency : CURRENCY
		do
			if action = Void and variable_description.name.is_equal("currency_iso") then
				l_currency := a_target.entity.rmdat_currency(a_target.date)
				if l_currency /= Void then
					Result := l_currency.iso_code_key(a_target.date)
				end
			end
		end

end

