note
	description: "Handles NATURAL_32 fields for EXTERNAL_RECORD."
	author: "Randy John"
	last_editor: "$Author: rj $"
	date: "$Date: 2014/06/19 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/infrastructure/translation/rose_natural_32_interpreter.e $"

class
	ROSE_NATURAL_32_INTERPRETER

inherit
	ROSE_EXTERNAL_INTERPRETER[NATURAL_32]

feature -- Basic operations.

	decode(a_pointer: POINTER; a_byte_count: INTEGER): NATURAL_32
	-- Decode the 4 bytes at 'a_pointer' as a NATURAL_32 ('a_byte_count' is ignored).
	do
		Result := dereference_natural_32(a_pointer)
	end

	encode(a_target: POINTER; a_source: NATURAL_32; a_count: INTEGER)
	-- Store (encode) 'a_source' at 'a_target'.  It's silly, but you must correctly specify 'a_count' as 4.
	do
		a_target.memory_copy($a_source, a_count)
	end

end
