note

	description:

		"Negation functional on ROSE_EXPRESSION"

	author: "Mark Howard"
	last_editor: "$Author: it $"
	date: "$Date: 2013/04/12 $"
	revision: "$Revision: #21 $"
	path: "$File: //rose/source/kernel/math/rose_negative_operator.e $"

class
	ROSE_NEGATIVE_OPERATOR[reference G]
inherit
	ROSE_UNARY_OPERATOR[G]
		redefine
			generated_unitized_value
		end

	ROSE_IEEE_UNDEFINED

create
	make
feature  --access
	nominal_units (a_left,a_right : ROSE_UNITS) : ROSE_UNITS is
			-- <Precursor>
		do
			Result := a_left
		end
	real_value (a_left : ROSE_EXPRESSION[G];a_g : G) : REAL is
			-- <Precursor>
		local
			l_value : REAL
		do
			l_value := a_left.real_value(a_g)
			if a_left.is_defined_real (l_value) then
				Result := -l_value
			else
				Result := a_left.undefined_real
			end
		end
	double_value (a_left : ROSE_EXPRESSION[G];a_g : G) : DOUBLE is
			-- <Precursor>
		local
			l_value : DOUBLE
		do
			l_value := a_left.double_value(a_g)
			if is_defined_double (l_value) then
				Result := -l_value
			else
				Result := undefined_double
			end
		end
	integer_value (a_left : ROSE_EXPRESSION[G];a_g : G) : INTEGER is
			-- <Precursor>
		local
			l_value : INTEGER
		do
			l_value := a_left.integer_value(a_g)
			if a_left.is_defined_integer (l_value) then
				Result := -l_value
			else
				Result := a_left.undefined_integer
			end
		end
	boolean_value (a_left : ROSE_EXPRESSION[G];a_g : G) : BOOLEAN is
			-- <Precursor>
		do
			Result := not a_left.boolean_value(a_g)
		end
	character_value (a_left : ROSE_EXPRESSION[G];a_g : G) : CHARACTER is
			-- <Precursor>
		do
		end
	string_value (a_left: ROSE_EXPRESSION[G];a_g : G) : STRING is
			-- <Precursor>
		do
		end
	date_value (a_left : ROSE_EXPRESSION[G];a_g : G) : ROSE_DATE is
			-- <Precursor>
		do
		end
	date_time_value (a_left : ROSE_EXPRESSION[G];a_g : G) : ROSE_DATE is
			-- <Precursor>
		do
		end
	value_in_market_currency (a_left : ROSE_EXPRESSION[G];a_market : MARKET;a_currency : PERSISTENT_CURRENCY;a_entity : G;a_date : ROSE_DATE) : DOUBLE is
			-- <Precursor>
		local
			l_value : DOUBLE
		do
			l_value := a_left.value_in_market_currency(a_market,a_currency,a_entity,a_date)
			if is_defined_double (l_value) then
				Result := -l_value
			else
				Result := undefined_double
			end
		end
	computed_units (a_left : ROSE_UNITS) : ROSE_UNITS is
			-- <Precursor>
		do
			Result := a_left
		end
	units_in_currency (a_left : ROSE_EXPRESSION[G];a_currency : PERSISTENT_CURRENCY;a_entity : G) : ROSE_UNITS is
			-- <Precursor>
		do
			Result := a_left.units_in_currency(a_currency,a_entity)
		end
	computed_double(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : DOUBLE is
			-- <Precursor>
		local
			l_value: DOUBLE
		do
			l_value := a_left.computed_double(a_g,a_agent)
			if is_defined_double (l_value) then
				Result := -l_value
			else
				Result := undefined_double
			end
		end
	computed_real(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : REAL is
			-- <Precursor>
		local
			l_value: REAL
		do
			l_value := a_left.computed_real(a_g,a_agent)
			if a_left.is_defined_real (l_value) then
				Result := -l_value
			else
				Result := a_left.undefined_real
			end
		end
	computed_integer(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : INTEGER is
			-- <Precursor>
		local
			l_value: INTEGER
		do
			l_value := a_left.computed_integer(a_g,a_agent)
			if a_left.is_defined_integer (l_value) then
				Result := -l_value
			else
				Result := a_left.undefined_integer
			end
		end
	computed_boolean(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : BOOLEAN is
			-- <Precursor>
		do
		end
	computed_string(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : STRING is
			-- <Precursor>
		do
		end
	computed_value(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : ANY  is
			-- <Precursor>
		do
		end
	generated_double(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : DOUBLE is
			-- <Precursor>
		local
			l_value: DOUBLE
		do
			l_value := a_left.generated_double(a_g,a_agent)
			if is_defined_double (l_value) then
				Result := -l_value
			else
				Result := undefined_double
			end
		end
	generated_unitized_value(a_left: ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : DATED_UNITIZED_VALUE[DOUBLE] is
			-- <Precursor>
		do
			create Result.make_with_units(generated_double (a_left, a_g, a_agent), nominal_units(a_left.generated_unitized_value (a_g, a_agent).units, Void))
		end
	generated_real(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : REAL is
			-- <Precursor>
		local
			l_value: REAL
		do
			l_value := a_left.generated_real(a_g,a_agent)
			if a_left.is_defined_real (l_value) then
				Result := -l_value
			else
				Result := a_left.undefined_real
			end
		end
	generated_integer(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : INTEGER is
			-- <Precursor>
		local
			l_value: INTEGER
		do
			l_value := a_left.generated_integer(a_g,a_agent)
			if a_left.is_defined_integer (l_value) then
				Result := -l_value
			else
				Result := a_left.undefined_integer
			end
		end
	generated_boolean(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : BOOLEAN is
			-- <Precursor>
		do
		end
	generated_string(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : STRING is
			-- <Precursor>
		do
		end
	generated_date(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : ROSE_DATE is
			-- <Precursor>
		do
		end
end
