indexing
	description: "ARRAY [ANY] Object Browser"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #5 $"

class
	ROSE_OBJECT_BROWSER_HANDLER_ARRAY

inherit
	ROSE_OBJECT_BROWSER_HANDLER

create
	make

feature -- Initialization

	make is
		do
			icon := Gui.factory.new_pixmap ("ob_array.ico")
		end

feature -- Access

	widget (a_object: ANY): EV_WIDGET is
			-- Specific widget representation of 'a_object'
			-- Void if type of 'a_object' is not handled
		local
			aa: ARRAY [ANY]
			ai: ARRAY [INTEGER]
			ai8: ARRAY [INTEGER_8]
			ai16: ARRAY [INTEGER_16]
			ai64: ARRAY [INTEGER_64]
			ac: ARRAY [CHARACTER]
			ab: ARRAY [BOOLEAN]
			ad: ARRAY [DOUBLE]
			ar: ARRAY [REAL]
			ap: ARRAY [POINTER]
			l_list: EV_MULTI_COLUMN_LIST
			l_row: EV_MULTI_COLUMN_LIST_ROW
			i: INTEGER
		do
			aa ?= a_object
			ai ?= a_object
			ai8 ?= a_object
			ai16 ?= a_object
			ai64 ?= a_object
			ac ?= a_object
			ab ?= a_object
			ad ?= a_object
			ar ?= a_object
			ap ?= a_object
			if aa /= Void then
				create l_list
				l_list.set_column_titles (<<"Item","Value">>)
				l_list.set_column_widths (<<60,300>>)
				from
					i := aa.lower
				until
					i > aa.upper
				loop
					create l_row
					l_row.extend (i.out)
					l_row.extend (object_representation (aa.item (i),Void,Void,Void))
					l_row.set_data (aa.item (i))
					l_list.extend (l_row)
					i := i + 1
				end
				Result := l_list
			end
		end

feature -- Status report

	is_handled (a_object: ANY): BOOLEAN is
			-- Is 'a_object' handled by this handler?
		local
			l_array: ARRAY [ANY]
		do
			l_array ?= a_object
			Result := l_array /= Void
		end

feature {NONE} -- Implementation

	array_any (a_array: ARRAY [ANY]): EV_WIDGET is
		do
		end

end -- class ROSE_OBJECT_BROWSER_HANDLER_ARRAY
