indexing
	description: "HASH_TABLE [ANY,COMPARABLE] Object Browser"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #7 $"

class
	ROSE_OBJECT_BROWSER_HANDLER_HASH

inherit
	ROSE_OBJECT_BROWSER_HANDLER

create
	make

feature -- Initialization

	make is
		do
			icon := Gui.factory.new_pixmap ("ob_hash.ico")
		end

feature -- Access

	widget (a_object: ANY): EV_WIDGET is
			-- Specific widget representation of 'a_object'
			-- Void if type of 'a_object' is not handled
		local
			l_hash: HASH_TABLE [ANY,HASHABLE]
			l_grid: RP_DATA_GRID[ANY]
		do
			l_hash ?= a_object
			if l_hash /= Void then
				l_grid := Gui.factory.new_grid (Void,<<["Key",300],["Value",300]>>,Void,0,0)
				from
					l_hash.start
				until
					l_hash.off
				loop
					l_grid.extend(Gui.factory.new_grid_node (
						Void,
						<<	object_representation (l_hash.key_for_iteration,Void,Void,Void),
							object_representation (l_hash.item_for_iteration,Void,Void,Void) >>,
						l_hash.item_for_iteration))
					l_hash.forth
				end
				Result := l_grid
			end
		end

feature -- Status report

	is_handled (a_object: ANY): BOOLEAN is
			-- Is 'a_object' handled by this handler?
		local
			l_hash: HASH_TABLE [ANY,HASHABLE]
		do
			l_hash ?= a_object
			Result := l_hash /= Void
		end

end -- class ROSE_OBJECT_BROWSER_HANDLER_HASH
