indexing
	description: "Browse objects dynamically - tree-view and context view"
	author: "Zoran Simic"
	date: "$Date: 2014/02/26 $"
	revision: "$Revision: #7 $"

class
	ROSE_OBJECT_BROWSER_RELATION

inherit
	EV_VERTICAL_BOX
	ROSE_OBJECT_BROWSER_MANAGER
		undefine
			default_create, is_equal, copy
		end

create
	make

feature -- Initialization

	make (a_container: EV_CONTAINER; a_relation: like relation) is
		require
			valid_relation: a_relation /= Void
		local
			l_widget: EV_WIDGET
		do
			default_create
			relation := a_relation
			l_widget := Gui.factory.new_label (Current,"Drop an object here to see it's related objects",1)
			l_widget.set_foreground_color (Gui.rep.colors.Dark_green)
			l_widget.drop_actions.extend (agent show_object)
			l_widget := Gui.factory.new_label (Current,"Warning: this may result in a lengthy operation...",1)
			l_widget.set_foreground_color (Gui.rep.colors.Dark_red)
			l_widget.drop_actions.extend (agent show_object)
			info := Gui.factory.new_label (Current,Void,1)
			mgrid := Gui.factory.new_grid (Current,<<["Related object",400]>>,Void,0,0)
			Gui.factory.enbox_and_size_simple (Current,a_container,0)
			drop_actions.extend (agent show_object)
			info.drop_actions.extend (agent show_object)
			mgrid.drop_actions.extend (agent show_object)
		end

feature -- Access

	relation: FUNCTION [ANY,TUPLE [ANY],SPECIAL [ANY]]

	related: SPECIAL [ANY]

feature -- Basic operations

	show_object (a_object: ANY) is
		local
			i: INTEGER
		do
			related := relation.item ([a_object])
			mgrid.clear
			if related /= Void then
				from
					i := 0
				until
					i >= related.count
				loop
					mgrid.extend (Gui.factory.new_grid_node (Void,<<object_representation (related.item (i),Void,Void,Void)>>,related.item (i)))
					mgrid.last_row.set_pebble_agent(agent get_data(?))
					i := i + 1
				end
				info.set_text (object_representation (a_object,Void,Void,Void) + "%N" + related.count.out + " related objects")
			end
		end

feature {NONE} -- Implementation

	info: EV_LABEL
	mgrid: RP_DATA_GRID[ANY]
	
	get_data (a_node: RP_GRID_NODE[ANY]): ANY is
			-- Return the data from a node
		do
			Result := a_node.data
		end
		

end -- class ROSE_OBJECT_BROWSER_RELATION
