indexing
	description: "Browse objects dynamically"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #3 $"

class
	ROSE_OBJECT_BROWSER_TREE

inherit
	EV_TREE
	ROSE_OBJECT_BROWSER_TREE_PROCESSOR
		undefine
			default_create, is_equal, copy
		end
	ROSE_OBSERVABLE
		undefine
			default_create, is_equal, copy
		end

create
	make

feature -- Initialization

	make (a_container: EV_CONTAINER) is
		do
			default_create
			select_actions.extend (agent notify_observers)
			Gui.factory.enbox_and_size_simple (Current,a_container,0)
			drop_actions.extend (agent add_object)
			key_release_actions.extend (agent on_key)
		end

feature -- Access

	selected_object: ANY is
			-- Currently selected object in the tree-view
		local
			l_node: EV_TREE_NODE
		do
			l_node := selected_item
			if l_node /= Void then
				Result := l_node.data
			end
		end

feature -- Basic operations

	show_object (a_object: ANY) is
			-- Show 'a_object' in the tree-view, remove all previously shown objects
		do
			wipe_out
			add_object (a_object)
		end

	add_object (a_object: ANY) is
			-- Add 'a_object' in this tree.
		local
			l_tree_node: EV_TREE_NODE
		do
			l_tree_node := node (a_object)
			extend (l_tree_node)
			if l_tree_node.is_expandable then
				l_tree_node.expand
			end
			if l_tree_node.is_selectable then
				l_tree_node.enable_select
			end
		end

feature {NONE} -- Implementation

	on_key (a_key: EV_KEY) is
		local
			l_node: EV_TREE_NODE
		do
			if a_key /= Void and then a_key.code = Gui.rep.keys.Key_delete then
				l_node := selected_item
			end
			if l_node /= Void then
				if l_node.parent = Current then
					prune (l_node)
				end
			end
			notify_observers
		end

end -- class ROSE_OBJECT_BROWSER_TREE_NODE
