indexing
	description: "Browse objects dynamically"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #7 $"

class
	ROSE_OBJECT_BROWSER_TREE_NODE

inherit
	EV_DYNAMIC_TREE_ITEM
	ROSE_OBJECT_BROWSER_TREE_PROCESSOR
		undefine
			default_create, is_equal, copy
		end
	ROSE_OBJECT_BROWSER_MANAGER
		undefine
			default_create, is_equal, copy
		end

create
	make, make_named, make_with_text_only

feature -- Initialization

	make (a_object: ANY) is
		do
			make_named (Void,a_object)
		end

	make_named (a_name: STRING; a_object: ANY) is
		local
			l_handler: ROSE_OBJECT_BROWSER_HANDLER
			l_string: STRING
		do
			default_create
			data := a_object
			if a_object /= Void then
				set_pebble (a_object)
			end
			l_handler := get_handler (a_object)
			set_pixmap (l_handler.icon)
			set_accept_cursor (create {EV_CURSOR}.make_with_pixmap (l_handler.icon, 0, 0))
			l_string ?= a_object
			set_text (object_representation (a_object,a_name,Void,l_string))
			set_subtree_function (agent subnodes (a_object))
		end
		
	make_with_text_only (a_text: STRING; a_object: ANY) is
		local
			l_handler: ROSE_OBJECT_BROWSER_HANDLER
		do
			default_create
			data := a_object
			if a_object /= Void then
				set_pebble (a_object)
			end
			l_handler := get_handler (a_object)
			set_pixmap (l_handler.icon)
			set_accept_cursor (create {EV_CURSOR}.make_with_pixmap (l_handler.icon, 0, 0))
			set_text (a_text)
			set_subtree_function (agent subnodes (a_object))
		end		

end -- class ROSE_OBJECT_BROWSER_TREE_NODE
