indexing
	description: "Node representing a SPECIAL [G], where G is expanded"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #4 $"

class
	ROSE_OBJECT_BROWSER_TREE_NODE_SPECIAL [G]

inherit
	EV_DYNAMIC_TREE_ITEM
	ROSE_OBJECT_BROWSER_MANAGER
		undefine
			default_create, is_equal, copy
		end

create
	make

feature -- Initialization

	make (a_special: SPECIAL [G]; a_name, a_type: STRING; a_pixmap: EV_PIXMAP) is
		do
			make_with_function(Agent sub_nodes(a_special, a_name, a_type, a_pixmap))
			data := a_special
			set_pixmap (pix_special)
			set_text (object_representation (a_special,a_name,Void,Void))
		end

	sub_nodes (a_special: SPECIAL [G]; a_name, a_type: STRING; a_pixmap: EV_PIXMAP) : ROSE_LINEAR_ARRAY[EV_TREE_NODE] is
		local
			i, n: INTEGER
			l_item: EV_TREE_ITEM
		do
			create Result.make_empty
			from
				i := 0
				n := a_special.count.min (maximum_items.item)
			until
				i >= n
			loop
				create l_item.make_with_text (object_representation (Void,a_name,a_type,a_special.item (i).out))
				if a_pixmap /= Void then
					l_item.set_pixmap (a_pixmap)
				end
				Result.extend (l_item)
				i := i + 1
			end
		end

feature {NONE} -- Implementation

	pix_special: EV_PIXMAP is once Result := Gui.factory.new_pixmap ("ob_special.ico") end

end -- class ROSE_OBJECT_BROWSER_TREE_NODE_SPECIAL
