indexing
	description: "Node representing a SPECIAL [ANY]"
	author: "Zoran Simic"
	date: "$Date: 2014/02/26 $"
	revision: "$Revision: #6 $"

class
	ROSE_OBJECT_BROWSER_TREE_NODE_SPECIAL_ANY

inherit
	EV_DYNAMIC_TREE_ITEM
	ROSE_OBJECT_BROWSER_MANAGER
		undefine
			default_create, is_equal, copy
		end

create
	make

feature -- Initialization

	make (a_special: SPECIAL [ANY]; a_name: STRING) is
		do
			make_with_function(Agent sub_nodes(a_special, a_name))
			data := a_special
			set_pixmap (pix_special)
			set_text (object_representation (a_special,a_name,Void,Void))
			set_pebble (a_special)
		end

	sub_nodes (a_special: SPECIAL [ANY]; a_name: STRING) : ROSE_LINEAR_ARRAY[EV_TREE_NODE] is
		local
			i, n: INTEGER
			l_item: EV_TREE_ITEM
		do
			create Result.make_empty
			from
				i := 0
				n := a_special.count.min (maximum_items.item)
			until
				i >= n
			loop
				if a_special.item (i) = Void then
					create l_item.make_with_text (object_representation (Void,i.out,Void,Void))
					l_item.set_pixmap (pix_void)
					Result.extend (l_item)
				else
					Result.extend (create {ROSE_OBJECT_BROWSER_TREE_NODE}.make_named (i.out,a_special.item (i)))
				end
				i := i + 1
			end
		end

feature {NONE} -- Implementation

	pix_special: EV_PIXMAP is once Result := Gui.factory.new_pixmap ("ob_special.ico") end
	pix_void: EV_PIXMAP is once Result := Gui.factory.new_pixmap ("ob_void.ico") end

end -- class ROSE_OBJECT_BROWSER_TREE_NODE_SPECIAL_ANY
