indexing
	description: "Null channel"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #4 $"

class ROSE_OUTCHANNEL_NULL

inherit
	ROSE_OUTCHANNEL
		redefine
			new_representative
		end

feature -- Access

	id: STRING is "null"
			-- Channel type id

	new_representative: like Current is
			-- New independent version of Current service.
			-- If you want this service to be shared (unique instance used for the whole system),
			-- return Current (no clone)
		do
			Result := Current
		end

feature -- Status report

	is_open: BOOLEAN is True
			-- Is this channel open ?

feature -- Basic operations

	output_message (a_level: INTEGER; a_message: STRING) is
			-- Output 'a_message' with 'a_level' on this channel.
		do
			--| Do nothing
		end

	flush is
			-- Flush this channel.
		do
		end

feature -- Output

	help: STRING is "Consume all output silently"
			-- Help on this command

feature {NONE} -- Implementation

	do_open is
			-- Open effectively this channel with 'parameters'.
		do
			parameters := Void
		end

	do_close is
			-- Close effectively this channel.
		do
		end

end -- class ROSE_OUTCHANNEL_NULL
