note

	description:

		"Unary + functional on ROSE_EXPRESSION"

	author: "Mark Howard"
	last_editor: "$Author: mk $"
	date: "$Date: 2011/02/15 $"
	revision: "$Revision: #19 $"
	path: "$File: //rose/source/kernel/math/rose_positive_operator.e $"

class
	ROSE_POSITIVE_OPERATOR[reference G]
inherit
	ROSE_UNARY_OPERATOR[G]
create
	make
feature --Access
	nominal_units (a_left,a_right : ROSE_UNITS) : ROSE_UNITS is
			--nominal units
		do
			Result := a_left
		end
	real_value (a_left : ROSE_EXPRESSION[G];a_g : G) : REAL is
		do
			Result := a_left.real_value(a_g)
		end
	double_value (a_left : ROSE_EXPRESSION[G];a_g : G) : DOUBLE is
			--returned double value
		do
			Result := a_left.double_value(a_g)
		end
	integer_value (a_left : ROSE_EXPRESSION[G];a_g : G) : INTEGER is
		do
			Result := a_left.integer_value(a_g)
		end
	boolean_value (a_left : ROSE_EXPRESSION[G];a_g : G) : BOOLEAN is
			-- Boolean value
		do
			Result := a_left.boolean_value(a_g)
		end
	character_value (a_left : ROSE_EXPRESSION[G];a_g : G) : CHARACTER is
			-- Character value
		do
		end
	string_value (a_left: ROSE_EXPRESSION[G];a_g : G) : STRING is
		do
		end
	date_value (a_left : ROSE_EXPRESSION[G];a_g : G) : ROSE_DATE is
		do
		end
	date_time_value (a_left : ROSE_EXPRESSION[G];a_g : G) : ROSE_DATE is
		do
		end
	value_in_market_currency (a_left : ROSE_EXPRESSION[G];a_market : MARKET;a_currency : PERSISTENT_CURRENCY;a_entity : G;a_date : ROSE_DATE) : DOUBLE is
		do
			Result := a_left.value_in_market_currency(a_market,a_currency,a_entity,a_date)
		end
	computed_units (a_left : ROSE_UNITS) : ROSE_UNITS is
			-- Computed units
		do
			Result := a_left
		end
	units_in_currency (a_left : ROSE_EXPRESSION[G];a_currency : PERSISTENT_CURRENCY;a_entity : G) : ROSE_UNITS is
		do
			Result := a_left.units_in_currency(a_currency,a_entity)
		end
	computed_double(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : DOUBLE is
		do
			Result := a_left.computed_double(a_g,a_agent)
		end
	computed_real(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : REAL is
		do
			Result := a_left.computed_real(a_g,a_agent)
		end
	computed_integer(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : INTEGER is
		do
			Result := a_left.computed_integer(a_g,a_agent)
		end
	computed_boolean(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : BOOLEAN is
		do
			Result := a_left.computed_boolean(a_g,a_agent)
		end
	computed_string(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : STRING is
		do
		end
	computed_value(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : ANY is
		do
		end
	generated_double(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : DOUBLE is
		do
			Result := a_left.generated_double(a_g,a_agent)
		end
	generated_real(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : REAL is
		do
			Result := a_left.generated_real(a_g,a_agent)
		end
	generated_integer(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : INTEGER is
		do
			Result := a_left.generated_integer(a_g,a_agent)
		end
	generated_string(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : STRING is
		do
			Result := a_left.generated_string(a_g,a_agent)
		end
	generated_date(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : ROSE_DATE is
		do
			Result := a_left.generated_date(a_g,a_agent)
		end
end
