indexing
	description: "Price override signature"
	author: "Michael Zhang"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #6 $"

class
	ROSE_PRICE_OVERRIDE_SIGNATURE

inherit
	ROSE_PRICE_SIGNATURE
	redefine
		data_fields_string_,
		new_variable
	end

create
	make, make_from_signature, default_create

feature -- creation
	make_from_signature(a_signature : ROSE_PRICE_SIGNATURE) is
			-- make from signature
		do
			entity_id:= a_signature.entity_id
			price_date:= a_signature.price_date
			value_description_id := a_signature.value_description_id
			currency_id:= a_signature.currency_id
			end_current_date := constants.maximum_date_time

			ask := a_signature.ask
			bid := a_signature.bid
			close := a_signature.close
			high := a_signature.high
			low := a_signature.low
			open := a_signature.open
			volume := a_signature.volume

			source := a_signature.source
		end

	set_user_and_update_time is
			-- set update info
		do
			create update_time.make_now
			user_id := framework.Global.app.user.full_login
		end

feature -- extra data fields
	user_id : STRING
	set_user_id(a_id : STRING) is
			-- set user id
		do
			user_id := a_id
		end

	update_time : ROSE_DATE
	set_update_time(a_time : like update_time) is
			-- set update time
		do
			update_time := a_time
		end

	comment : STRING
	set_comment(a_comment : STRING) is
			-- set comment
		do
			comment := a_comment
		end

feature -- misc
	data_fields_string_ : STRING is "open,close,high,low,bid,ask,volume,source,currency_id,user_id,update_time,comment"
	framework : ROSE_SHARED_GLOBAL is
			-- framework
		once create Result end

	new_variable(a_variable_description : VARIABLE_DESCRIPTION_RECORD) : SIGNATURE_TAGGED_EXPRESSION[like Current] is
			-- new variable
		do
			create Result.make(a_variable_description)
		end
end
