note

	description:

		"price variable"

	author: "Michael Zhang"
	last_editor: "$Author: er $"
	date: "$Date: 2014/01/03 $"
	revision: "$Revision: #7 $"
	path: "$File: //rose/source/kernel/data/reports/rose_price_variable.e $"

class
	ROSE_PRICE_VARIABLE

inherit
	SIGNATURE_TAGGED_EXPRESSION[ROSE_PRICE_SIGNATURE]
		redefine
			make,
			double_value,
			currency
		end

create
	make

feature  --Initialization
	make (a_description : like variable_description) is
			--creation
		do
			Precursor(a_description)
			if a_description.name.is_equal("closing_price") then
				id := 1
			elseif a_description.name.is_equal("opening_price") then
				id := 2
			elseif a_description.name.is_equal("high_price") then
				id := 3
			elseif a_description.name.is_equal("low_price") then
				id := 4
			elseif a_description.name.is_equal("ask_price") then
				id := 5
			elseif a_description.name.is_equal("bid_price") then
				id := 6
			elseif a_description.name.is_equal("volume") then
				id := 7
			end
		end
feature --Access
	double_value (a_target : like expression_target) : DOUBLE is
			--computed value
		do
			if a_target /= Void then
				inspect id
				when 1 then Result := a_target.close
				when 2 then Result := a_target.open
				when 3 then Result := a_target.high
				when 4 then Result := a_target.low
				when 5 then Result := a_target.ask
				when 6 then Result := a_target.bid
				when 7 then Result := a_target.volume
				else
				end
			end
		end

	currency (a_target : like expression_target) : PERSISTENT_CURRENCY is
			-- <Precursor>
		do
			if a_target /= Void then
				Result := a_target.currency
			end
		end
feature {NONE}  --Implementation
	id : INTEGER
end
