indexing
	description: "Generates all primes less than a given number"
	author: "Mark Howard"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #5 $"

class
	ROSE_PRIMES
inherit
	ROSE_LINEAR_ARRAY[INTEGER]
		rename 
			make as rose_linear_array_make
		redefine
			less_than
		end
create
	make,make_empty,make_from_array,rose_linear_array_make
feature 
	make (a_upper_bound : INTEGER) is
		local
			l_composites : ROSE_LINEAR_ARRAY[INTEGER]
			i,j : INTEGER
		do
			upper_bound := a_upper_bound
			make_empty
			create l_composites.make(1,a_upper_bound)
			from i := 2 until i > a_upper_bound loop
				if l_composites.item(i) = 0 then
					from j := 2 until j > a_upper_bound // i loop
						l_composites.put(j * i,j*i)
						j := j + 1
					end
				end
				i := i + 1
			end
			from i := 2 until i > a_upper_bound loop
				if l_composites.item(i) = 0 then
					extend(i)
				end
				i := i + 1
			end			
		end
	index_of_prime (a_prime : INTEGER) : INTEGER is
		do
			binary_search (a_prime)
			Result := found_index
		end
	upper_bound : INTEGER
	maximum_prime : INTEGER is
		do
			Result := last
		end
	double_upper_bound is
		do
			make(upper_bound * 2)
		end
	less_than (i,j : INTEGER) : BOOLEAN is
		do
			Result := i < j
		end
end -- class ROSE_PRIMES
