indexing

	description: "Row of widgets whose width is a fixed proportion of enclosing widget"

	author: "Franck Arnaud"
	last_editor: "$Author: it $"
	team: "RC_London"
	revision: "$Revision: #2 $"
	date: "$Date: 2008/12/01 $"
	path: "$File: //rose/source/kernel/infrastructure/widgets/rose_proportional_horizontal_box.e $"

class ROSE_PROPORTIONAL_HORIZONTAL_BOX

inherit
	ROSE_PROPORTIONAL_VERTICAL_BOX
		redefine
			resize_widget
		end

create
	default_create

feature {NONE} -- Sizing

	resize_widget (a_width, a_height: INTEGER; a_x: CELL [INTEGER]; a_widget: EV_WIDGET; a_index: INTEGER)
			-- Resize one widget (in the horizontal direction).
		local
			l_width: INTEGER
		do
			l_width := a_width * weights.item (a_index) // total_weights
				-- Apply
			set_item_position_and_size (a_widget, a_x.item, 0, l_width, a_height)
				-- Set next y position
			a_x.put (a_x.item + l_width)
		end

end
