note

	description:

		"Division functional on ROSE_EXPRESSION"

	author: "Mark Howard"
	last_editor: "$Author: er $"
	date: "$Date: 2013/06/18 $"
	revision: "$Revision: #18 $"
	path: "$File: //rose/source/kernel/math/rose_ratio_operator.e $"
	storable_version: ""

class
	ROSE_RATIO_OPERATOR[reference G]
inherit
	RP_SERIALIZABLE
	ROSE_NUMERIC_BINARY_OPERATOR[G]

create
	make
feature --Access
	nominal_units (a_left,a_right : ROSE_UNITS) : ROSE_UNITS is
		do
			Result := a_left / a_right
		end
	computed_units (a_left,a_right : ROSE_UNITS) : ROSE_UNITS is
			--units from units of left and right
		do
			Result := a_left / a_right
		end
	units_in_currency (a_left,a_right : ROSE_EXPRESSION[G];a_currency : PERSISTENT_CURRENCY;a_entity : G) : ROSE_UNITS is
			--units in currency
		do
			Result := a_left.units_in_currency(a_currency,a_entity) / a_right.units_in_currency(a_currency,a_entity)
		end
	unitized_value(a_left,a_right : ROSE_UNITIZED_VALUE[DOUBLE]) : ROSE_UNITIZED_VALUE[DOUBLE]
		do
			if a_right.value /= 0 then
				create Result.make_with_units(a_left.value / a_right.value,a_left.units / a_right.units)
			else
				create Result.make_with_units(undefined_double,a_left.units / a_right.units)
			end
		end
feature {NONE} --Implementation
	double_computation(a_left, a_right: ROSE_EXPRESSION [G]; a_left_value, a_right_value : DOUBLE) : DOUBLE is
			-- <Precursor>
		do
			Result := undefined_double
			if is_defined_double (a_left_value) and (a_right_value /~ 0.0 and then is_defined_double (a_right_value)) then
				Result := a_left_value / a_right_value
			end
		end
	decimal_computation(a_left, a_right: ROSE_EXPRESSION [G]; a_left_value, a_right_value : RP_DECIMAL) : RP_DECIMAL is
		do
			if a_left_value.is_defined and a_right_value.is_defined then
				Result := a_left_value / a_right_value
			else
				create Result.make_undefined
			end
		end
	real_computation(a_left, a_right: ROSE_EXPRESSION [G]; a_left_value, a_right_value : REAL) : REAL is
		do
			Result := undefined_real
			if is_defined_real (a_left_value) and (a_right_value /= 0 and then is_defined_real (a_right_value)) then
				Result := a_left_value / a_right_value
			end
		end
	integer_computation(a_left, a_right: ROSE_EXPRESSION [G]; a_left_value, a_right_value : INTEGER) : INTEGER is
		do
			Result := undefined_integer
			if is_defined_integer (a_left_value) and (a_right_value /= 0 and then is_defined_integer (a_right_value)) then
				Result := a_left_value // a_right_value
			end
		end
	string_computation(a_left, a_right: ROSE_EXPRESSION [G]; a_left_value, a_right_value : STRING) : STRING is
		do
		end
	boolean_computation(a_left, a_right: ROSE_EXPRESSION [G]; a_left_value, a_right_value : BOOLEAN) : BOOLEAN is
		do
		end
	date_computation(a_left, a_right: ROSE_EXPRESSION [G]; a_left_value, a_right_value : ROSE_DATE) : ROSE_DATE is
		do
		end
end
