indexing
	description: "Scanner for entity recipe transformations"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #5 $"

class ROSE_RECIPE_SCANNER

inherit
	YY_COMPRESSED_SCANNER_SKELETON
		rename
			make as make_compressed_scanner_skeleton,
			reset as reset_compressed_scanner_skeleton,
			output as yy_scanner_output
		end

	ROSE_RECIPE_TOKENS
		export {NONE} all end

create
	make_rose_recipe_scanner

feature {NONE} -- Initialization

	make_rose_recipe_scanner is
			-- Create a new Rose recipe scanner.
		do
			make_with_buffer (Empty_buffer)
			create lexical_buffer.make (Init_lexical_buffer_size)
		end

feature -- Initialization

	reset is
			-- Reset scanner before scanning next input.
		do
			reset_compressed_scanner_skeleton
			lexical_buffer.wipe_out
		end


feature -- Status report

	valid_start_condition (sc: INTEGER): BOOLEAN is
			-- Is `sc' a valid start condition?
		do
			Result := (INITIAL <= sc and sc <= IN_STR)
		end

feature {NONE} -- Implementation

	yy_build_tables is
			-- Build scanner tables.
		do
			yy_nxt := yy_nxt_template
			yy_chk := yy_chk_template
			yy_base := yy_base_template
			yy_def := yy_def_template
			yy_ec := yy_ec_template
			yy_meta := yy_meta_template
			yy_accept := yy_accept_template
		end

	yy_execute_action (yy_act: INTEGER) is
			-- Execute semantic action.
		do
if yy_act <= 21 then
if yy_act <= 11 then
if yy_act <= 6 then
if yy_act <= 3 then
if yy_act <= 2 then
if yy_act = 1 then
yy_set_line_column
--|#line 50 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 50")
end
-- Separators ignored
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 51 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 51")
end
-- Comments ignored
end
else
	yy_column := yy_column + 6
--|#line 54 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 54")
end
last_token := RR_RECIPE
end
else
if yy_act <= 5 then
if yy_act = 4 then
	yy_column := yy_column + 11
--|#line 55 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 55")
end
last_token := RR_DESCRIPTION
else
	yy_column := yy_column + 14
--|#line 56 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 56")
end
last_token := RR_TRANSFORMATION
end
else
	yy_column := yy_column + 12
--|#line 57 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 57")
end
last_token := RR_RELATIONSHIP
end
end
else
if yy_act <= 9 then
if yy_act <= 8 then
if yy_act = 7 then
	yy_column := yy_column + 14
--|#line 58 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 58")
end
last_token := RR_CORELATIONSHIP
else
	yy_column := yy_column + 4
--|#line 59 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 59")
end
last_token := RR_PEER
end
else
	yy_column := yy_column + 9
--|#line 60 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 60")
end
last_token := RR_ATTRIBUTE
end
else
if yy_act = 10 then
	yy_column := yy_column + 7
--|#line 61 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 61")
end
last_token := RR_DISPLAY
else
	yy_column := yy_column + 6
--|#line 62 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 62")
end
last_token := RR_FILTER
end
end
end
else
if yy_act <= 16 then
if yy_act <= 14 then
if yy_act <= 13 then
if yy_act = 12 then
	yy_column := yy_column + 3
--|#line 63 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 63")
end
last_token := RR_ASK
else
	yy_column := yy_column + 3
--|#line 64 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 64")
end
last_token := RR_END
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 67 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 67")
end

						last_token := RR_INTEGER
						last_integer_value := text.to_integer

end
else
if yy_act = 15 then
	yy_column := yy_column + 10
--|#line 73 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 73")
end

						last_token := RR_DATE
						last_rose_date_value := create {ROSE_DATE}.make_ccyymmdd (text_substring (2,text_count-1).to_integer)

else
yy_set_line_column
--|#line 79 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 79")
end
		--"
			last_token := RR_STRING
			last_string_value := text_substring (2, text_count - 1)

end
end
else
if yy_act <= 19 then
if yy_act <= 18 then
if yy_act = 17 then
yy_set_line_column
--|#line 83 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 83")
end
		--"
			if text_count > 1 then
				lexical_buffer.append_string (text_substring (2, text_count))
			end
			set_start_condition (IN_STR)

else
yy_set_line_column
--|#line 89 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 89")
end
lexical_buffer.append_string (text)	--"
end
else
	yy_column := yy_column + 2
--|#line 90 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 90")
end
lexical_buffer.append_character ('%A')
end
else
if yy_act = 20 then
	yy_column := yy_column + 2
--|#line 91 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 91")
end
lexical_buffer.append_character ('%B')
else
	yy_column := yy_column + 2
--|#line 92 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 92")
end
lexical_buffer.append_character ('%C')
end
end
end
end
else
if yy_act <= 32 then
if yy_act <= 27 then
if yy_act <= 24 then
if yy_act <= 23 then
if yy_act = 22 then
	yy_column := yy_column + 2
--|#line 93 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 93")
end
lexical_buffer.append_character ('%D')
else
	yy_column := yy_column + 2
--|#line 94 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 94")
end
lexical_buffer.append_character ('%F')
end
else
	yy_column := yy_column + 2
--|#line 95 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 95")
end
lexical_buffer.append_character ('%H')
end
else
if yy_act <= 26 then
if yy_act = 25 then
	yy_column := yy_column + 2
--|#line 96 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 96")
end
lexical_buffer.append_character ('%L')
else
	yy_column := yy_column + 2
--|#line 97 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 97")
end
lexical_buffer.append_character ('%N')
end
else
	yy_column := yy_column + 2
--|#line 98 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 98")
end
lexical_buffer.append_character ('%Q')
end
end
else
if yy_act <= 30 then
if yy_act <= 29 then
if yy_act = 28 then
	yy_column := yy_column + 2
--|#line 99 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 99")
end
lexical_buffer.append_character ('%R')
else
	yy_column := yy_column + 2
--|#line 100 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 100")
end
lexical_buffer.append_character ('%S')
end
else
	yy_column := yy_column + 2
--|#line 101 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 101")
end
lexical_buffer.append_character ('%T')
end
else
if yy_act = 31 then
	yy_column := yy_column + 2
--|#line 102 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 102")
end
lexical_buffer.append_character ('%U')
else
	yy_column := yy_column + 2
--|#line 103 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 103")
end
lexical_buffer.append_character ('%V')
end
end
end
else
if yy_act <= 37 then
if yy_act <= 35 then
if yy_act <= 34 then
if yy_act = 33 then
	yy_column := yy_column + 2
--|#line 104 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 104")
end
lexical_buffer.append_character ('%%')
else
	yy_column := yy_column + 2
--|#line 105 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 105")
end
lexical_buffer.append_character ('%'')
end
else
	yy_column := yy_column + 2
--|#line 106 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 106")
end
lexical_buffer.append_character ('%"')		--"
end
else
if yy_act = 36 then
	yy_column := yy_column + 2
--|#line 107 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 107")
end
lexical_buffer.append_character ('%(')
else
	yy_column := yy_column + 2
--|#line 108 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 108")
end
lexical_buffer.append_character ('%)')
end
end
else
if yy_act <= 40 then
if yy_act <= 39 then
if yy_act = 38 then
	yy_column := yy_column + 2
--|#line 109 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 109")
end
lexical_buffer.append_character ('%<')
else
	yy_column := yy_column + 2
--|#line 110 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 110")
end
lexical_buffer.append_character ('%>')
end
else
yy_set_line_column
--|#line 111 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 111")
end

			last_token := RR_STRING
			if text_count > 1 then
				lexical_buffer.append_string (text_substring (1, text_count - 1))
			end
			last_string_value := clone (lexical_buffer)
			lexical_buffer.wipe_out
			set_start_condition (INITIAL)

end
else
if yy_act = 41 then
	yy_column := yy_column + 1
--|#line 130 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 130")
end
last_token := text_item (1).code
else
yy_set_line_column
--|#line 0 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 0")
end
last_token := yyError_token
fatal_error ("scanner jammed")
end
end
end
end
end
		end

	yy_execute_eof_action (yy_sc: INTEGER) is
			-- Execute EOF semantic action.
		do
			inspect yy_sc
when 0 then
--|#line 0 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 0")
end

			last_token := RR_EOF
			--| terminate

when 1 then
--|#line 0 ".\rose_recipe_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '.\rose_recipe_scanner.l' at line 0")
end
	--| Catch-all rules (no backing up)
			last_token := RR_EOF
			set_start_condition (INITIAL)

			else
				terminate
			end
		end

feature {NONE} -- Table templates

	yy_nxt_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    6,    7,    8,    9,    6,   10,    6,    6,   11,
			   12,    6,    6,   13,    6,   14,   15,   16,   17,    6,
			    6,    6,    6,    6,    6,    6,   18,    6,   19,    6,
			   20,    6,    6,    6,   13,    6,   14,   15,   16,   17,
			    6,    6,    6,   19,    6,   20,    6,   22,   23,   22,
			   23,   24,   24,   24,   24,   28,   29,   30,   31,   33,
			   35,   37,   34,   38,   41,   24,   24,  138,   67,   25,
			   25,   79,   30,   31,   39,   68,   69,   71,   35,   41,
			   33,   79,   37,   67,   40,   44,   45,   46,   47,   48,
			   68,   69,   49,   50,   51,   52,   53,   54,   71,   55,

			   56,   70,   72,   57,   73,   58,   74,   75,   59,   60,
			   61,   62,   63,   64,   76,   74,   70,   78,   80,   82,
			  137,   72,   75,   83,   85,   73,   75,   74,   86,   89,
			   91,  136,   78,   92,   82,   76,   74,   90,   83,   80,
			   94,   75,   95,   97,   98,   85,   86,  100,   89,   91,
			  104,  101,   90,  135,   92,   94,  119,   95,  106,  107,
			  113,  115,  116,  117,   97,   98,  101,  122,  100,  125,
			  127,  104,  128,  106,  107,  113,  115,  119,  117,  129,
			  116,  130,  122,  132,  133,  139,  134,  125,   21,   21,
			   21,  127,  131,  128,  129,   42,   42,  126,  132,  130,

			   28,  124,   28,  139,  123,  133,  121,  120,  118,  114,
			  112,  111,  110,  109,  108,  105,  103,  102,   99,   96,
			   93,   88,   87,   84,   81,   77,   43,   66,   29,   65,
			   26,   43,   36,   32,   29,   27,   26,  140,    5,  140,
			  140,  140,  140,  140,  140,  140,  140,  140,  140,  140,
			  140,  140,  140,  140,  140,  140,  140,  140,  140,  140,
			  140,  140,  140,  140,  140,  140,  140,  140,  140,  140,
			  140,  140,  140,  140,  140,  140,  140,  140,  140,  140,
			  140,  140,  140,  140,  140, yy_Dummy>>)
		end

	yy_chk_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    3,    3,    4,
			    4,    7,    7,    8,    8,   11,   11,   13,   13,   15,
			   16,   18,   15,   19,   20,   24,   24,  136,   31,  142,
			  142,   68,   13,   13,   19,   32,   33,   35,   16,   20,
			   15,   68,   18,   31,   19,   23,   23,   23,   23,   23,
			   32,   33,   23,   23,   23,   23,   23,   23,   35,   23,

			   23,   34,   36,   23,   37,   23,   38,   39,   23,   23,
			   23,   23,   23,   23,   41,   40,   34,   67,   69,   72,
			  135,   36,   40,   73,   75,   37,   39,   38,   76,   79,
			   81,  133,   67,   82,   72,   41,   40,   80,   73,   69,
			   85,   40,   86,   88,   89,   75,   76,   91,   79,   81,
			   95,   92,   80,  132,   82,   85,  113,   86,   97,   98,
			  106,  108,  110,  111,   88,   89,   92,  116,   91,  120,
			  122,   95,  123,   97,   98,  106,  108,  113,  111,  125,
			  110,  126,  116,  128,  129,  137,  131,  120,  141,  141,
			  141,  122,  127,  123,  125,  143,  143,  121,  128,  126,

			  144,  118,  144,  137,  117,  129,  115,  114,  112,  107,
			  105,  104,  103,  100,   99,   96,   94,   93,   90,   87,
			   84,   78,   77,   74,   70,   65,   42,   30,   29,   27,
			   25,   21,   17,   14,   12,   10,    9,    5,  140,  140,
			  140,  140,  140,  140,  140,  140,  140,  140,  140,  140,
			  140,  140,  140,  140,  140,  140,  140,  140,  140,  140,
			  140,  140,  140,  140,  140,  140,  140,  140,  140,  140,
			  140,  140,  140,  140,  140,  140,  140,  140,  140,  140,
			  140,  140,  140,  140,  140, yy_Dummy>>)
		end

	yy_base_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    0,    0,   43,   45,  237,  238,   49,   51,  232,
			  225,   46,  224,   28,  208,   42,   36,  212,   44,   46,
			   36,  227,  238,   81,   63,  226,  238,  219,    0,  218,
			  206,   38,   47,   47,   72,   61,   80,   87,   91,   85,
			  100,  101,  222,  238,  238,  238,  238,  238,  238,  238,
			  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
			  238,  238,  238,  238,  238,  215,  238,   89,   43,  103,
			  198,  238,   89,   95,  203,  111,  104,  212,  201,  107,
			  109,  108,  116,  238,  194,  110,  113,  209,  129,  131,
			  198,  134,  123,  179,  196,  132,  205,  127,  129,  188,

			  180,  238,  238,  187,  186,  200,  130,  189,  131,  238,
			  138,  135,  198,  139,  182,  186,  138,  181,  195,  238,
			  145,  172,  151,  159,  238,  150,  157,  172,  153,  165,
			  238,  160,  133,  111,  238,   95,   41,  161,  238,  238,
			  238,  187,   68,  194,  199, yy_Dummy>>)
		end

	yy_def_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,  140,    1,  141,  141,  140,  140,  140,  140,  142,
			  140,  140,  140,  140,  140,  140,  140,  140,  140,  140,
			  140,  143,  140,  140,  140,  142,  140,  140,  144,  140,
			  140,  140,  140,  140,  140,  140,  140,  140,  140,  140,
			  140,  140,  143,  140,  140,  140,  140,  140,  140,  140,
			  140,  140,  140,  140,  140,  140,  140,  140,  140,  140,
			  140,  140,  140,  140,  140,  140,  140,  140,  140,  140,
			  140,  140,  140,  140,  140,  140,  140,  140,  140,  140,
			  140,  140,  140,  140,  140,  140,  140,  140,  140,  140,
			  140,  140,  140,  140,  140,  140,  140,  140,  140,  140,

			  140,  140,  140,  140,  140,  140,  140,  140,  140,  140,
			  140,  140,  140,  140,  140,  140,  140,  140,  140,  140,
			  140,  140,  140,  140,  140,  140,  140,  140,  140,  140,
			  140,  140,  140,  140,  140,  140,  140,  140,  140,  140,
			    0,  140,  140,  140,  140, yy_Dummy>>)
		end

	yy_ec_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    2,
			    3,    1,    1,    2,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    2,    1,    4,    1,    1,    5,    1,    6,
			    7,    8,    1,    1,    1,    9,    1,    1,   10,   10,
			   10,   10,   10,   10,   10,   10,   10,   10,    1,    1,
			   11,    1,   12,    1,    1,   13,   14,   15,   16,   17,
			   18,    1,   19,   20,    1,   21,   22,   23,   24,   25,
			   26,   27,   28,   29,   30,   31,   32,    1,    1,   33,
			    1,    1,    1,    1,    1,    1,    1,   34,   35,   36,

			   37,   38,   39,    1,   40,   20,    1,   21,   41,   23,
			   42,   25,   26,    1,   43,   44,   45,   46,    1,    1,
			    1,   33,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1, yy_Dummy>>)
		end

	yy_meta_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    2,    1,    3,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1, yy_Dummy>>)
		end

	yy_accept_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    0,    0,    0,    0,   43,   41,    1,    1,   17,
			   41,   41,   14,   41,   41,   41,   41,   41,   41,   41,
			   41,   18,   42,   42,    1,   17,   16,    0,    2,   14,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,   18,   40,   35,   33,   34,   36,   37,   38,
			   39,   19,   20,   21,   22,   23,   24,   25,   26,   27,
			   28,   29,   30,   31,   32,    0,   12,    0,    0,    0,
			    0,   13,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    8,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

			    0,   11,    3,    0,    0,    0,    0,    0,    0,   10,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    9,
			    0,    0,    0,    0,   15,    0,    0,    0,    0,    0,
			    4,    0,    0,    0,    6,    0,    0,    0,    7,    5,
			    0, yy_Dummy>>)
		end

feature {NONE} -- Constants

	yyJam_base: INTEGER is 238
			-- Position in `yy_nxt'/`yy_chk' tables
			-- where default jam table starts

	yyJam_state: INTEGER is 140
			-- State id corresponding to jam state

	yyTemplate_mark: INTEGER is 141
			-- Mark between normal states and templates

	yyNull_equiv_class: INTEGER is 1
			-- Equivalence code for NULL character

	yyReject_used: BOOLEAN is false
			-- Is `reject' called?

	yyVariable_trail_context: BOOLEAN is false
			-- Is there a regular expression with
			-- both leading and trailing parts having
			-- variable length?

	yyReject_or_variable_trail_context: BOOLEAN is false
			-- Is `reject' called or is there a
			-- regular expression with both leading
			-- and trailing parts having variable length?

	yyNb_rules: INTEGER is 42
			-- Number of rules

	yyEnd_of_buffer: INTEGER is 43
			-- End of buffer rule code

	yyLine_used: BOOLEAN is true
			-- Are line and column numbers used?

	yyPosition_used: BOOLEAN is false
			-- Is `position' used?

	INITIAL: INTEGER is 0
	IN_STR: INTEGER is 1
			-- Start condition codes

feature -- User-defined features



feature {NONE} -- Implementation

	lexical_buffer: STRING
			-- Buffer for lexical tokens

	code_: INTEGER
			-- Attribute used as temporary integer

	last_indentation: STRING
		-- Keep indentation to save back config almost as read

feature {NONE} -- Constants

	Init_lexical_buffer_size: INTEGER is 256
				-- Initial size for `lexical_buffer'

end
