indexing

	description: "Parser token codes"
	generator: "geyacc version 3.3"

class ROSE_RECIPE_TOKENS

inherit

	YY_PARSER_TOKENS

feature -- Last values

	last_any_value: ANY
	last_integer_value: INTEGER
	last_rose_date_value: ROSE_DATE
	last_string_value: STRING

feature -- Access

	token_name (a_token: INTEGER): STRING is
			-- Name of token `a_token'
		do
			inspect a_token
			when 0 then
				Result := "EOF token"
			when -1 then
				Result := "Error token"
			when RR_INTEGER then
				Result := "RR_INTEGER"
			when RR_DATE then
				Result := "RR_DATE"
			when RR_STRING then
				Result := "RR_STRING"
			when RR_RECIPE then
				Result := "RR_RECIPE"
			when RR_DESCRIPTION then
				Result := "RR_DESCRIPTION"
			when RR_TRANSFORMATION then
				Result := "RR_TRANSFORMATION"
			when RR_DISPLAY then
				Result := "RR_DISPLAY"
			when RR_FILTER then
				Result := "RR_FILTER"
			when RR_CONSTRAINT then
				Result := "RR_CONSTRAINT"
			when RR_ASK then
				Result := "RR_ASK"
			when RR_END then
				Result := "RR_END"
			when RR_RELATIONSHIP then
				Result := "RR_RELATIONSHIP"
			when RR_CORELATIONSHIP then
				Result := "RR_CORELATIONSHIP"
			when RR_PEER then
				Result := "RR_PEER"
			when RR_ATTRIBUTE then
				Result := "RR_ATTRIBUTE"
			when RR_EOF then
				Result := "RR_EOF"
			else
				Result := yy_character_token_name (a_token)
			end
		end

feature -- Token codes

	RR_INTEGER: INTEGER is 258
	RR_DATE: INTEGER is 259
	RR_STRING: INTEGER is 260
	RR_RECIPE: INTEGER is 261
	RR_DESCRIPTION: INTEGER is 262
	RR_TRANSFORMATION: INTEGER is 263
	RR_DISPLAY: INTEGER is 264
	RR_FILTER: INTEGER is 265
	RR_CONSTRAINT: INTEGER is 266
	RR_ASK: INTEGER is 267
	RR_END: INTEGER is 268
	RR_RELATIONSHIP: INTEGER is 269
	RR_CORELATIONSHIP: INTEGER is 270
	RR_PEER: INTEGER is 271
	RR_ATTRIBUTE: INTEGER is 272
	RR_EOF: INTEGER is 273

end
