indexing
	description: "Recipe related utility functions"
	author: "Jann Roeder"
	date: "$Date: 2009/08/24 $"
	revision: "$Revision: #6 $"
	archive: "$File: //rose/source/kernel/entities/transformation/rose_recipe_utils.e $"

class
	ROSE_RECIPE_UTILS

inherit
	ROSE_SHARED_GLOBAL

	CONTEXT_ANCHOR

feature -- Access

	context_server: CONTEXT_SERVER is
			-- Object used to determine which contexts are available
		once
			create Result
		end

feature -- Basic operations

	category_handler (a_path: STRING): CATEGORY_HANDLER [like context_anchor,ENTITY] is
			-- Category handler corresponding to 'a_path'
			-- 'a_path' is of the form "[SUPPLIER]category"
		local
			l_pair: PAIR [STRING,STRING]
			l_source_context: like context_anchor
		do
			Result := context_server.category_from_full_name (a_path)
				-- [sm]:  do we need this??
			if False then
				if a_path /= Void and then a_path.count > 4 then
					l_pair := Global.formatter.split_enclosed (a_path,'[',']',Void)
				end
				if l_pair = Void or else not is_void_or_empty (l_pair.first) or else not is_void_or_empty (l_pair.second) then
					l_pair := Void
				end
				if l_pair /= Void then
					l_source_context := context_server.context_from_name (l_pair.first)
					if l_source_context /= Void then
						Result := l_source_context.category_handler_from_name (l_pair.second)
					end
				end
			end
		end

feature {NONE} -- Implementation

	is_void_or_empty (a_string: STRING): BOOLEAN is
			-- Is `a_string' valid ?
		do
			Result := a_string /= Void and then not a_string.is_empty
		ensure
			not_void_or_empty: Result = (a_string /= Void and then not a_string.is_empty)
		end

end
