note

	description:

		"Relation binary operator"

	author: "Michael Zhang"
	last_editor: "$Author: mk $"
	date: "$Date: 2011/02/15 $"
	revision: "$Revision: #11 $"
	path: "$File: //rose/source/kernel/math/rose_relation_binary_operator.e $"

deferred class
	ROSE_RELATION_BINARY_OPERATOR[reference G]

inherit
	ROSE_BINARY_OPERATOR[G]
		redefine
			commutative
		end
feature  --Access
	nominal_units (a_left,a_right : ROSE_UNITS) : ROSE_UNITS is
			--nominal units
		do
			Result := pure_units
		end
	real_value (a_left,a_right : ROSE_EXPRESSION[G];a_g : G) : REAL is
			--returned real value
		do
		end
	double_value (a_left,a_right : ROSE_EXPRESSION[G];a_g : G) : DOUBLE is
			--returned double value
		do
		end
	decimal_value (a_left,a_right : ROSE_EXPRESSION[G];a_g : G) : RP_DECIMAL is
		do
		end
	integer_value (a_left,a_right : ROSE_EXPRESSION[G];a_g : G) : INTEGER is
		do
		end

	character_value (a_left,a_right : ROSE_EXPRESSION[G];a_g : G) : CHARACTER is
			-- Character value
		do
		end
	string_value (a_left,a_right : ROSE_EXPRESSION[G];a_g : G) : STRING is
		do
		end
	date_value (a_left,a_right : ROSE_EXPRESSION[G];a_g : G) : ROSE_DATE is
		do
		end
	date_time_value (a_left,a_right : ROSE_EXPRESSION[G];a_g : G) : ROSE_DATE is
		do
		end
	value_in_market_currency (a_left,a_right : ROSE_EXPRESSION[G];a_market : MARKET;a_currency : PERSISTENT_CURRENCY;a_entity : G;a_date : ROSE_DATE) : DOUBLE is
		do
		end
	unitized_value(a_left,a_right : ROSE_UNITIZED_VALUE[DOUBLE]) : ROSE_UNITIZED_VALUE[DOUBLE]
		do
		end
	computed_units (a_left,a_right : ROSE_UNITS) : ROSE_UNITS is
			--computed units
		do
			if a_left ~ a_right then
				Result := pure_units
			else
				create {MISMATCHED_UNITS} Result.make(a_left,a_right)
			end
		end
	units_in_currency (a_left,a_right : ROSE_EXPRESSION[G];a_currency : PERSISTENT_CURRENCY;a_entity : G) : ROSE_UNITS is
		do
			Result := units(a_left,a_right,a_entity)
		end

	commutative : BOOLEAN is True
			-- Commutative?

feature  --computed
	computed_double(a_left,a_right : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : DOUBLE is
		do
		end
	computed_real(a_left,a_right : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : REAL is
		do
		end
	computed_integer(a_left,a_right : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : INTEGER is
		do
		end
	computed_string(a_left,a_right : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : STRING is
		do
		end
	computed_value(a_left,a_right : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : ANY is
		do
		end

	computed_universe_double(a_left,a_right : ROSE_EXPRESSION[G]; a_g : UNIVERSE_TARGET[G]; a_agent : like access_agent_template) : DOUBLE is
		do
		end
	computed_universe_real(a_left,a_right : ROSE_EXPRESSION[G]; a_g : UNIVERSE_TARGET[G]; a_agent : like access_agent_template) : REAL is
		do
		end
	computed_universe_integer(a_left,a_right : ROSE_EXPRESSION[G]; a_g : UNIVERSE_TARGET[G]; a_agent : like access_agent_template) : INTEGER is
		do
		end
	computed_universe_string(a_left,a_right : ROSE_EXPRESSION[G]; a_g : UNIVERSE_TARGET[G]; a_agent : like access_agent_template) : STRING is
		do
		end
	computed_universe_date(a_left,a_right : ROSE_EXPRESSION[G]; a_g : UNIVERSE_TARGET[G]; a_agent : like access_agent_template) : ROSE_DATE is
		do
		end
feature  --generated
	generated_double(a_left,a_right : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : DOUBLE is
		do
		end
	generated_real(a_left,a_right : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : REAL is
		do
		end
	generated_integer(a_left,a_right : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : INTEGER is
		do
		end
	generated_string(a_left,a_right : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : STRING is
		do
		end
	generated_date(a_left,a_right : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : ROSE_DATE is
		do
		end

end
