note

	description:

		"Operator representing |a-b| / a + |a-b| / b"

	author: "Mark Howard"
	last_editor: "$Author: it $"
	date: "$Date: 2013/04/12 $"
	revision: "$Revision: #15 $"
	path: "$File: //rose/source/kernel/math/rose_relative_delta_operator.e $"

class
	ROSE_RELATIVE_DELTA_OPERATOR[reference G]
inherit
	ROSE_NUMERIC_BINARY_OPERATOR[G]
create
	make
feature  --Access
	nominal_units (a_left,a_right : ROSE_UNITS) : ROSE_UNITS is
			-- <Precursor>
		do
			Result := a_left + a_right
		end
	computed_units (a_left,a_right : ROSE_UNITS) : ROSE_UNITS is
			-- <Precursor>
		do
			Result := pure_units
		end
	units_in_currency (a_left,a_right : ROSE_EXPRESSION[G];a_currency : PERSISTENT_CURRENCY;a_entity : G) : ROSE_UNITS is
			-- <Precursor>
		do
			Result := pure_units
		end

	unitized_value(a_left,a_right : ROSE_UNITIZED_VALUE[DOUBLE]) : ROSE_UNITIZED_VALUE[DOUBLE]
			-- <Precursor>
		do
			if a_left.value /= 0 and then a_right.value /= 0 then
				create Result.make_with_units(((a_left.value - a_right.value).abs / a_left.value) + ((a_left.value - a_right.value).abs / a_right.value),pure_units)
			else
				create Result.make_with_units(maximum_integer,pure_units)
			end
		end
feature {NONE} --implementation
	double_computation(a_left, a_right: ROSE_EXPRESSION [G]; a_left_value, a_right_value : DOUBLE) : DOUBLE is
			-- <Precursor>
		do
			Result := undefined_double
			if is_defined_double (a_left_value) and is_defined_double (a_right_value) then
				Result := ((a_left_value - a_right_value).abs / a_left_value) + ((a_left_value - a_right_value).abs / a_right_value)
			end
		end
	decimal_computation(a_left, a_right: ROSE_EXPRESSION [G]; a_left_value, a_right_value : RP_DECIMAL) : RP_DECIMAL is
			-- <Precursor>
		do
			if a_left_value.is_defined and a_right_value.is_defined then
				Result := ((a_left_value - a_right_value).abs / a_left_value) + ((a_left_value - a_right_value).abs / a_right_value)
			else
				create Result.make_undefined
			end
		end
	real_computation(a_left, a_right: ROSE_EXPRESSION [G]; a_left_value, a_right_value : REAL) : REAL is
			-- <Precursor>
		do
			Result := undefined_real
			if is_defined_real (a_left_value) and is_defined_real (a_right_value) then
				Result := ((a_left_value - a_right_value).abs / a_left_value) + ((a_left_value - a_right_value).abs / a_right_value)
			end
		end
	integer_computation(a_left, a_right: ROSE_EXPRESSION [G]; a_left_value, a_right_value : INTEGER) : INTEGER is
			-- <Precursor>
		do
		end
	string_computation(a_left, a_right: ROSE_EXPRESSION [G]; a_left_value, a_right_value : STRING) : STRING is
			-- <Precursor>
		do
		end
	boolean_computation(a_left, a_right: ROSE_EXPRESSION [G]; a_left_value, a_right_value : BOOLEAN) : BOOLEAN is
			-- <Precursor>
		do
		end
	date_computation(a_left, a_right: ROSE_EXPRESSION [G]; a_left_value, a_right_value : ROSE_DATE) : ROSE_DATE is
			-- <Precursor>
		do
		end
end


