indexing
	description: "Info dialog with a rich-text widget"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #5 $"

class
	ROSE_RICH_TEXT_DIALOG

inherit
	ROSE_DIALOG
		redefine
			initialize, setup_main_box, on_show_dialog
		end

feature {NONE} -- Initialization

	initialize is
			-- Called by 'default_create'.
		do
			Precursor
			set_title ("Information")
			set_icon ("info.ico")
		end

	setup_main_box is
			-- Called by 'default_create'.
		do
			create text.make (main_box)
			text.disable_edit
		end

feature -- Access

	text: ROSE_RICH_TEXT
			-- Rich-text widget showing the colored info text

feature -- Basic operations

	flush_buffer is do text.flush_buffer end
	remove_text is do text.remove_text end
	append (a_text: STRING; a_color: EV_COLOR) is do text.append (a_text,a_color) end
	append_bold (a_text: STRING; a_color: EV_COLOR) is do text.append_bold (a_text,a_color) end
	set_word_wrap (a_on: BOOLEAN) is do text.set_word_wrap (a_on) end
	set_font (a_font: EV_FONT) is do text.set_font (a_font) end

feature {NONE} -- Implementation

	on_show_dialog is
			-- Called when the dialog is actually shown.
		do
--			text.scroll_at_beginning
			Precursor
		end

end
