indexing
	description: "Supports for RTF string formatting in ROSE_RICH_TEXT"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #2 $"

class
	ROSE_RICH_TEXT_RTF

feature -- Basic operations

	set_rtf_text (a_widget: ROSE_RICH_TEXT; a_text: STRING) is
			-- Display `a_text' in RTF format.
		require
			a_widget /= Void and then a_text /= Void
		local
			l_wel_rich_edit: WEL_RICH_EDIT
			l_stream: WEL_RICH_EDIT_BUFFER_LOADER
		do
			l_wel_rich_edit ?= a_widget.implementation
			if l_wel_rich_edit /= Void then
				l_wel_rich_edit.set_text ("")
				create l_stream.make (a_text)
				l_wel_rich_edit.insert_rtf_stream_in (l_stream)
			end
		end

	rtf_text (a_widget: ROSE_RICH_TEXT): STRING is
		require
			a_widget /= Void
		local
			l_wel_rich_edit: WEL_RICH_EDIT
			l_stream: WEL_RICH_EDIT_BUFFER_SAVER
		do
			l_wel_rich_edit ?= a_widget.implementation
			if l_wel_rich_edit /= Void then
				create l_stream.make
				l_wel_rich_edit.rtf_stream_out (l_stream)
				Result := l_stream.text
			end
		end

	save_rtf (a_widget: ROSE_RICH_TEXT; a_filename: STRING) is
		require
			a_widget /= Void and then a_filename /= Void
		local
			l_wel_rich_edit: WEL_RICH_EDIT
			l_stream: WEL_RICH_EDIT_FILE_SAVER
			l_file: RAW_FILE
			retried: BOOLEAN
		do
			if not retried then
				l_wel_rich_edit ?= a_widget.implementation
				if l_wel_rich_edit /= Void then
					create l_file.make_open_write (a_filename)
					create l_stream.make (l_file)
					l_wel_rich_edit.rtf_stream_out (l_stream)
				end
			end
		rescue
			if not retried then
				retried := True
				retry
			end
		end

end
