indexing
	description: "Serialization constants"
	notice: "rose_serializer.dtd"
	author: "Zoran Simic"
	date: "$Date: 2010/12/08 $"
	revision: "$Revision: #11 $"

class
	ROSE_SERIALIZATION_CONSTANTS

inherit
	ROSE_SHARED_GLOBAL
		export
			{NONE} all
		end
	INTERNAL
		export
			{NONE} all
		end
	ANY

feature -- Constants

	k_xml_header: STRING is "<?xml version='1.0' encoding='ISO-8859-1'?>%N"		-- Constant
	k_serialized: STRING is "serialized"			-- Constant
	k_types: STRING is "types"						-- Constant

	k_name: STRING is "n"							-- Constant
	k_value: STRING is "v"							-- Constant
	k_type: STRING is "t"							-- Constant
	k_id: STRING is "i"								-- Constant

	k_object: STRING is "a"							-- Constant
	k_reference: STRING is "f"						-- Constant
	k_string: STRING is "s"							-- Constant
	k_int8: STRING is "i1"							-- Constant
	k_int16: STRING is "i2"							-- Constant
	k_int32: STRING is "i"							-- Constant
	k_int64: STRING is "i8"							-- Constant
	k_natural8: STRING is "n1"						-- Constant
	k_natural16: STRING is "n2"						-- Constant
	k_natural32: STRING is "n4"						-- Constant
	k_natural64: STRING is "n8"						-- Constant
	k_double: STRING is "d"							-- Constant
	k_real: STRING is "r"							-- Constant
	k_character: STRING is "c"						-- Constant
	k_character32: STRING is "C"					-- Constant
	k_boolean: STRING is "b"						-- Constant
	k_expanded: STRING is "e"						-- Constant

	arg_type: STRING is " t=%""						-- Constant
	arg_name: STRING is " n=%""						-- Constant
	arg_value: STRING is " v=%""					-- Constant
	arg_id: STRING is " i=%""						-- Constant

	markup_start: STRING is "<"						-- Constant
	markup_endtag_start: STRING is "</"				-- Constant
	markup_end: STRING is ">"						-- Constant
	markup_end_line: STRING is ">%N"				-- Constant
	markup_empty_end: STRING is "/>%N"				-- Constant
	markup_quote: STRING is "%""					-- Constant
	markup_ampersand: STRING is "&"					-- Constant
	markup_newline: STRING is "%N"					-- Constant

	markup_quote_escaped: STRING is "&quot;"		-- Constant
	markup_start_escaped: STRING is "&lt;"			-- Constant
	markup_end_escaped: STRING is "&gt;"			-- Constant
	markup_ampersand_escaped: STRING is "&amp;"		-- Constant
	markup_newline_escaped: STRING is "&_newline_;"	-- Constant

	k_revision: STRING is "1"						-- Constant

	specific_int8: ROSE_SERIALIZER_SPECIFIC [INTEGER_8] is once create Result.make (1,"x1") end
	specific_int16: ROSE_SERIALIZER_SPECIFIC [INTEGER_16] is once create Result.make (2,"x2") end
	specific_int32: ROSE_SERIALIZER_SPECIFIC [INTEGER] is once create Result.make (4,"xi") end
	specific_int64: ROSE_SERIALIZER_SPECIFIC [INTEGER_64] is once create Result.make (8,"x8") end
	specific_natural8: ROSE_SERIALIZER_SPECIFIC [NATURAL_8] is once create Result.make (1,"N1") end
	specific_natural16: ROSE_SERIALIZER_SPECIFIC [NATURAL_16] is once create Result.make (2,"N2") end
	specific_natural32: ROSE_SERIALIZER_SPECIFIC [NATURAL_32] is once create Result.make (4,"N4") end
	specific_natural64: ROSE_SERIALIZER_SPECIFIC [NATURAL_64] is once create Result.make (8,"N8") end
	specific_char: ROSE_SERIALIZER_SPECIFIC [CHARACTER] is once create Result.make (1,"xc") end
	specific_char32: ROSE_SERIALIZER_SPECIFIC [CHARACTER_32] is once create Result.make (4,"xC") end
	specific_bool: ROSE_SERIALIZER_SPECIFIC [BOOLEAN] is once create Result.make (1,"xb") end
	specific_double: ROSE_SERIALIZER_SPECIFIC [DOUBLE] is once create Result.make (8,"xd") end
	specific_real: ROSE_SERIALIZER_SPECIFIC [REAL] is once create Result.make (4,"xr") end
	specific_any: ROSE_SERIALIZER_SPECIFIC [ANY] is once create Result.make (4,"xa") end
			-- All above are used to handle specific basic types

	memory: MEMORY is
		once
			create Result
		end

end
