indexing
	description: "Conventionnaly defined service"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #7 $"

deferred class
	ROSE_SERVICE

inherit
	ROSE_IDENTIFIED [STRING]

	ROSE_SHARED_GLOBAL

	DEBUG_OUTPUT

	ANY

feature -- Access

	new_representative: like Current is
			-- New independent version of Current service.
			-- If you want this service to be shared (unique instance used for the whole system),
			-- return Current (no clone)
		do
			Result := clone (Current)
		end

feature -- Status report

	is_open: BOOLEAN is
			-- Is this service currently open?
		deferred
		end

feature -- Basic operations

	open (a_path: STRING) is
			-- Open this service for 'a_path', 'a_path' is service specific.
		deferred
		ensure
			error_signaled_if_not_open: not is_open implies error.signaled
		end

	close is
			-- Close this service.
		deferred
		end

feature -- Output

	help: STRING is
			-- Help on this service
		deferred
		end

	representation: STRING is
			-- Representation of this service
		deferred
		ensure
			valid: Result /= Void
		end

	debug_output: STRING is
			-- String that should be displayed in debugger to represent `Current'.
		do
			Result := representation
		end

end -- class ROSE_SERVICE
