indexing
	description: "Shared DB server pool"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #6 $"
	
class
	ROSE_SHARED_DATABASE_POOL
	
inherit
	ROSE_SHARED_GLOBAL
	
feature -- Access
	
	pool: ROSE_DATABASE_POOL is
			-- Shared DB pool
		do
			if should_use_non_shared_pool.item then
				Result := non_shared_pool
			else
				Result := shared_pool
			end
		end
	
	use_non_shared_pool is
			-- If True, then this thread will not share any database connections with other threads.
			-- Most programs should NOT use this.  It was put in place for use by MOVIE's.
		do
			should_use_non_shared_pool.put(True)
		end
	
feature {NONE}
	shared_pool: ROSE_DATABASE_POOL is
        indexing
			once_status : global
		once
			create Result.make
		end
	
	non_shared_pool: ROSE_DATABASE_POOL is
		once
			create Result.make
		end
	
	should_use_non_shared_pool: CELL[BOOLEAN] is
		once
			create Result.put(False)
		end

end
