indexing
	description: "Singleton pattern to return a factory to give ELOG loggers"
	author: "Emmanuel Bouyer"
	last_editor: "$Author: e2 $"
	date: "$Date: 2010/02/15 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/infrastructure/logging/rose_dependant/rose_shared_logger_factory.e $"

class ROSE_SHARED_LOGGER_FACTORY

feature -- Access

	logger_factory: ELOG_LOGGER_FACTORY [FILE]
			-- Factory to return loggers
		do
			Result := shared_logger_factory.item
		ensure
			logger_factory_not_void: Result /= Void
		end

feature -- Setting

	set_logger_factory (a_logger_factory: like logger_factory)
			-- Sets logger_factory to `a_logger_factory'
		require
			a_logger_factory_not_void: a_logger_factory /= Void
		do
			shared_logger_factory.replace (a_logger_factory)
		ensure
			logger_factory_set: logger_factory = a_logger_factory
		end

feature {NONE} -- Implementation

	shared_logger_factory: CELL [ELOG_LOGGER_FACTORY [FILE]]
			-- Cell to share logger factory between different components
		indexing
			once_status: global
		once
			create Result.put (create {ELOG_LOGGER_FACTORY [ROSE_FILE]}.make)
		ensure
			shared_logger_factory_not_void: Result /= Void
			logger_factory_not_void: Result.item /= Void
		end

end
