indexing
	description: "Simple command - one that does not require a dedicated descendent of ROSE_COMMAND"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #4 $"

class
	ROSE_SIMPLE_COMMAND

inherit
	ROSE_COMMAND

create
	make

feature {NONE} -- Initialization

	make (a_id, a_signature, a_help: STRING; a_agent: PROCEDURE [ANY,TUPLE [ROSE_COMMAND_PARAMETERS]]) is
		do
			id := a_id
			signature := a_signature
			help := a_help
			callback := a_agent
		end

feature -- Access

	id: STRING

	signature: STRING
			-- Argument signature of this command (defines valid parameters to be passed to the command)
			-- See ROSE_COMMAND_PARAMETERS_SIGNATURE.make for info

	callback: PROCEDURE [ANY,TUPLE [ROSE_COMMAND_PARAMETERS]]

feature -- Basic operations

	check_prerequisites is
			-- Check that command's execution pre-requisites are met.
			-- Signal error if pre-requisistes are not met.
		do
			if callback = Void then
				error.signal (id,"Internal error: invalid agent provided",Void)
			end
		end

feature -- Output

	help: STRING
			-- Help on this command

feature {NONE} -- Implementation

	do_execute is
			-- Execute effectively the command.
		do
			callback.call ([parameters])
		end

end -- class ROSE_SIMPLE_COMMAND
