indexing
	description: "[
		Provides a mechanism for storing doubles by name and comparing the values with another snapshot
		]"
	author: "Mark Howard"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #5 $"

deferred class
	ROSE_SNAPSHOT[G] 

inherit
	HASH_TABLE[G, STRING]
		rename
			make as hash_table_make
		end


feature
	make_empty(a_equality_agent: FUNCTION[ANY, TUPLE[G, G], BOOLEAN]) is
		do
			equality_agent ?= a_equality_agent
			hash_table_make(5)
		end

	make(a_array: ARRAY[TUPLE[STRING, G]];
		 a_equality_agent: FUNCTION[ANY, TUPLE[G, G], BOOLEAN]) is
		deferred
		end

	compare_current(a_other: like Current): BOOLEAN is
		do
			Result := equality_agent.item([item_for_iteration, a_other.value_at(key_for_iteration)])
		end

	current_value : G is
		do
			if item_for_iteration /= void then
				Result := item_for_iteration
			end
		end
--	current_tolerance : DOUBLE is
--		do
--			if item_for_iteration /= void then
--				Result := item_for_iteration.double_item(2)
--			end
--		end
	value_at (a_string : STRING): G is
		do
			Result := item(a_string)
		end
--	tolerance_at (a_string : STRING) : DOUBLE is
--		local
--			l_tuple : TUPLE[DOUBLE,DOUBLE]
--		do
--			l_tuple := item(a_string)
--			if l_tuple /= void then
--				Result := l_tuple.double_item(2)
--			end
--		end

feature {NONE}

feature {NONE}
	equality_agent: FUNCTION[ANY, TUPLE[G, G], BOOLEAN]

end
