note

	description:

		"Facilities for accessing standardized colors."

	author: "Mark Howard"
	last_editor: "$Author: c4 $"
	date: "$Date: 2013/03/28 $"
	revision: "$Revision: #13 $"
	path: "$File: //rose/source/kernel/infrastructure/widgets/rose_stock_colors.e $"

class
	ROSE_STOCK_COLORS

inherit
	EV_STOCK_COLORS

feature -- Access

	suning_pink: EV_COLOR is
			-- Specified by Suning for use in DEI/SmartBeta GUIs
		once
			create Result.make_with_8_bit_rgb (241, 153, 178)
		ensure
			suning_pink_not_void: Result /= Void
		end


	light_red: EV_COLOR is
			-- Light red
		once
			create Result.make_with_8_bit_rgb (255, 230, 230)
		end

	light_green: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (230, 255, 230)
		end

	brown: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb(166,42,0)
		end

	orange: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb(255,128,42)
		end

	rose: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb(133,99,99)
		end

	light_blue: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (230, 230, 255)
		end

	light_gray: EV_COLOR is
			-- Light gray
		once
			create Result.make_with_8_bit_rgb (230, 230, 230)
		ensure
			light_gray_not_void: Result /= Void
		end

	very_light_gray: EV_COLOR is
			-- Light gray
		once
			create Result.make_with_8_bit_rgb (242, 242, 242)
		ensure
			light_gray_not_void: Result /= Void
		end

feature -- colors from .Net DRAWING_COLOR

    alice__blue: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (240, 248, 255)
        end

    antique_white: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (250, 235, 215)
        end

    aqua: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (0, 255, 255)
        end

    aquamarine: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (127, 255, 212)
        end

    azure: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (240, 255, 255)
        end

    beige: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (245, 245, 220)
        end

    bisque: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 228, 196)
        end

    blanched_almond: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 235, 205)
        end

    blue_violet: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (138, 43, 226)
        end

    burly_wood: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (222, 184, 135)
        end

    cadet_blue: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (95, 158, 160)
        end

    chartreuse: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (127, 255, 0)
        end

    chocolate: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (210, 105, 30)
        end

    coral: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 127, 80)
        end

    cornflower_blue: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (100, 149, 237)
        end

    cornsilk: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 248, 220)
        end

    crimson: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (220, 20, 60)
        end

    dark_goldenrod: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (184, 134, 11)
        end

    dark_khaki: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (189, 183, 107)
        end

    dark_olive_green: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (85, 107, 47)
        end

    dark_orange: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 140, 0)
        end

    dark_orchid: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (153, 50, 204)
        end

    dark_salmon: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (233, 150, 122)
        end

    dark_seagreen: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (143, 188, 139)
        end

    dark_slate_blue: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (72, 61, 139)
        end

    dark_slate_gray: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (47, 79, 79)
        end

    dark_turquoise: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (0, 206, 209)
        end

    dark_violet: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (148, 0, 211)
        end

    deep_pink: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 20, 147)
        end

    deep_sky_blue: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (0, 191, 255)
        end

    dim_gray: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (105, 105, 105)
        end

    dodger_blue: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (30, 144, 255)
        end

    firebrick: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (178, 34, 34)
        end

    floral_white: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 250, 240)
        end

    forest_green: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (34, 139, 34)
        end

    fuchsia: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 0, 255)
        end

    gainsboro: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (220, 220, 220)
        end

    ghost_white: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (248, 248, 255)
        end

    gold: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 215, 0)
        end

    goldenrod: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (218, 165, 32)
        end

    green_yellow: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (173, 255, 47)
        end

    honeydew: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (240, 255, 240)
        end

    hot_pink: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 105, 180)
        end

    indian_red: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (205, 92, 92)
        end

    indigo: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (75, 0, 130)
        end

    ivory: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 255, 240)
        end

    khaki: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (240, 230, 140)
        end

    lavender: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (230, 230, 250)
        end

    lavender_blush: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 240, 245)
        end

    lawn_green: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (124, 252, 0)
        end

    lemon_chiffon: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 250, 205)
        end

    light_coral: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (240, 128, 128)
        end

    light_cyan: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (224, 255, 255)
        end

    light_goldenrod_yellow: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (250, 250, 210)
        end

    light_pink: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 182, 193)
        end

    light_salmon: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 160, 122)
        end

    light_seagreen: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (32, 178, 170)
        end

    light_skyblue: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (135, 206, 250)
        end

    light_slate_gray: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (119, 136, 153)
        end

    light_steel_blue: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (176, 196, 222)
        end

    light_yellow: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 255, 224)
        end

    lime: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (0, 255, 0)
        end

    lime_green: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (50, 205, 50)
        end

    linen: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (250, 240, 230)
        end

    maroon: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (128, 0, 0)
        end

    medium_aquamarine: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (102, 205, 170)
        end

    medium_blue: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (0, 0, 205)
        end

    medium_orchid: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (186, 85, 211)
        end

    medium_purple: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (147, 112, 219)
        end

    medium_seagreen: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (60, 179, 113)
        end

    medium_slate_blue: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (123, 104, 238)
        end

    medium_spring_green: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (0, 250, 154)
        end

    medium_turquoise: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (72, 209, 204)
        end

    medium_violet_red: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (199, 21, 133)
        end

    midnight_blue: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (25, 25, 112)
        end

    mint_cream: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (245, 255, 250)
        end

    misty_rose: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 228, 225)
        end

    moccasin: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 228, 181)
        end

    navajo_white: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 222, 173)
        end

    navy: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (0, 0, 128)
        end

    old_lace: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (253, 245, 230)
        end

    olive: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (128, 128, 0)
        end

    olive_drab: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (107, 142, 35)
        end

    orange_red: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 69, 0)
        end

    orchid: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (218, 112, 214)
        end

    pale_goldenrod: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (238, 232, 170)
        end

    pale_green: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (152, 251, 152)
        end

    pale_turquoise: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (175, 238, 238)
        end

    pale_violet_red: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (219, 112, 147)
        end

    papaya_whip: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 239, 213)
        end

    peach_puff: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 218, 185)
        end

    peru: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (205, 133, 63)
        end

    pink: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 192, 203)
        end

    plum: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (221, 160, 221)
        end

    powder_blue: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (176, 224, 230)
        end

    purple: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (128, 0, 128)
        end

    rosy_brown: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (188, 143, 143)
        end

    royal_blue: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (65, 105, 225)
        end

    saddle_brown: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (139, 69, 19)
        end

    salmon: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (250, 128, 114)
        end

    sandy_brown: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (244, 164, 96)
        end

    sea_green: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (46, 139, 87)
        end

    sea_shell: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 245, 238)
        end

    sienna: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (160, 82, 45)
        end

    silver: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (192, 192, 192)
        end

    sky_blue: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (135, 206, 235)
        end

    slate_blue: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (106, 90, 205)
        end

    slate_gray: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (112, 128, 144)
        end

    snow: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 250, 250)
        end

    spring_green: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (0, 255, 127)
        end

    steel_blue: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (70, 130, 180)
        end

    tan: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (210, 180, 140)
        end

    teal: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (0, 128, 128)
        end

    thistle: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (216, 191, 216)
        end

    tomato: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255, 99, 71)
        end

    turquoise: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (64, 224, 208)
        end

    violet: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (238, 130, 238)
        end

    wheat: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (245, 222, 179)
        end

    white_smoke: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (245, 245, 245)
        end

    yellow_green: EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (154, 205, 50)
        end

feature -- Operations

	color (i: INTEGER): EV_COLOR is
		do
			Result := saved_colors.safe_item (i)
			if Result = Void then
				create Result.make_with_8_bit_rgb (i * 197 \\ 256, i * 229 \\ 256, i * 307 \\ 256)
				saved_colors.force (Result, i)
			end
		end

	next: EV_COLOR is
		do
			if color_list.off then
				color_list.start
			end
			Result := color_list.item
			color_list.forth
		end

feature {NONE} -- Implementation

	saved_colors: ROSE_LINEAR_ARRAY[EV_COLOR] is
		once
			create Result.make_empty
		end

	color_list: LINKED_LIST [EV_COLOR] is
		once
			create Result.make
			Result.force (black)
			Result.force (blue)
			Result.force (dark_blue)
			Result.force (dark_cyan)
			Result.force (dark_gray)
			Result.force (green)
			Result.force (dark_green)
			Result.force (dark_yellow)
			Result.force (gray)
			Result.force (red)
			Result.force (dark_red)
			Result.force (magenta)
			Result.force (dark_magenta)
			Result.force (brown)
			Result.force (orange)
			Result.force (rose)
			Result.force (light_red)
			Result.force (light_green)
			Result.force (light_gray)
			Result.force (very_light_gray)
			-- adding the drawing colors
            Result.force (alice__blue)
            Result.force (antique_white)
            Result.force (aqua)
            Result.force (aquamarine)
            Result.force (azure)
            Result.force (beige)
            Result.force (bisque)
            Result.force (blanched_almond)
            Result.force (blue_violet)
            Result.force (burly_wood)
            Result.force (cadet_blue)
            Result.force (chartreuse)
            Result.force (chocolate)
            Result.force (coral)
            Result.force (cornflower_blue)
            Result.force (cornsilk)
            Result.force (crimson)
            Result.force (dark_goldenrod)
            Result.force (dark_khaki)
            Result.force (dark_olive_green)
            Result.force (dark_orange)
            Result.force (dark_orchid)
            Result.force (dark_salmon)
            Result.force (dark_seagreen)
            Result.force (dark_slate_blue)
            Result.force (dark_slate_gray)
            Result.force (dark_turquoise)
            Result.force (dark_violet)
            Result.force (deep_pink)
            Result.force (deep_sky_blue)
            Result.force (dim_gray)
            Result.force (dodger_blue)
            Result.force (firebrick)
            Result.force (floral_white)
            Result.force (forest_green)
            Result.force (fuchsia)
            Result.force (gainsboro)
            Result.force (ghost_white)
            Result.force (gold)
            Result.force (goldenrod)
            Result.force (green_yellow)
            Result.force (honeydew)
            Result.force (hot_pink)
            Result.force (indian_red)
            Result.force (indigo)
            Result.force (ivory)
            Result.force (khaki)
            Result.force (lavender)
            Result.force (lavender_blush)
            Result.force (lawn_green)
            Result.force (lemon_chiffon)
            Result.force (light_coral)
            Result.force (light_cyan)
            Result.force (light_goldenrod_yellow)
            Result.force (light_pink)
            Result.force (light_salmon)
            Result.force (light_seagreen)
            Result.force (light_skyblue)
            Result.force (light_slate_gray)
            Result.force (light_steel_blue)
            Result.force (light_yellow)
            Result.force (lime)
            Result.force (lime_green)
            Result.force (linen)
            Result.force (maroon)
            Result.force (medium_aquamarine)
            Result.force (medium_blue)
            Result.force (medium_orchid)
            Result.force (medium_purple)
            Result.force (medium_seagreen)
            Result.force (medium_slate_blue)
            Result.force (medium_spring_green)
            Result.force (medium_turquoise)
            Result.force (medium_violet_red)
            Result.force (midnight_blue)
            Result.force (mint_cream)
            Result.force (misty_rose)
            Result.force (moccasin)
            Result.force (navajo_white)
            Result.force (navy)
            Result.force (old_lace)
            Result.force (olive)
            Result.force (olive_drab)
            Result.force (orange_red)
            Result.force (orchid)
            Result.force (pale_goldenrod)
            Result.force (pale_green)
            Result.force (pale_turquoise)
            Result.force (pale_violet_red)
            Result.force (papaya_whip)
            Result.force (peach_puff)
            Result.force (peru)
            Result.force (pink)
            Result.force (plum)
            Result.force (powder_blue)
            Result.force (purple)
            Result.force (rosy_brown)
            Result.force (royal_blue)
            Result.force (saddle_brown)
            Result.force (salmon)
            Result.force (sandy_brown)
            Result.force (sea_green)
            Result.force (sea_shell)
            Result.force (sienna)
            Result.force (silver)
            Result.force (sky_blue)
            Result.force (slate_blue)
            Result.force (slate_gray)
            Result.force (snow)
            Result.force (spring_green)
            Result.force (steel_blue)
            Result.force (tan)
            Result.force (teal)
            Result.force (thistle)
            Result.force (tomato)
            Result.force (turquoise)
            Result.force (violet)
            Result.force (wheat)
            Result.force (white_smoke)
            Result.force (yellow_green)
		end

end
