indexing

	description: "[
                  Temporary STRING_GENERAL-aware replacements for Gobo routines
                  ]"

	author: "Colin Adams"
	last_editor: "$Author: it $"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #2 $"
	path: "$File: //rose/source/kernel/infrastructure/support/rose_string_routines.e $"

class ROSE_STRING_ROUTINES

inherit

	ANY

	KL_IMPORTED_INTEGER_ROUTINES
		export {NONE} all end

	KL_IMPORTED_ANY_ROUTINES
		export {NONE} all end

	UC_IMPORTED_UTF16_ROUTINES
		export {NONE} all end

	UC_IMPORTED_UNICODE_ROUTINES
		export {NONE} all end


feature -- Conversion

	to_utf16_le (a_string: STRING_GENERAL): STRING_8 is
			-- New STRING made up of bytes corresponding to
			-- the UTF-16LE representation of `a_string'
		require
			a_string_not_void: a_string /= Void
		local
			i, l_num, l_code, l_high, l_low, l_surrogate: INTEGER_32
			l_uc_string: UC_STRING
		do
			l_uc_string ?= a_string
			if l_uc_string /= Void then
				Result := l_uc_string.to_utf16_le
			else
				l_num := a_string.count
				create Result.make (l_num)
				from i := 1 until i > l_num loop
					l_code := a_string.code (i).to_integer_32
					if unicode.is_bmp_code (l_code) then
						l_high := l_code // 256
						l_low := l_code \\ 256
						Result.append_character (INTEGER_.to_character (l_low))
						Result.append_character (INTEGER_.to_character (l_high))
					else
						l_surrogate := utf16.supplementary_to_high_surrogate (l_code)
						l_high := l_surrogate // 256
						l_low := l_surrogate \\ 256
						Result.append_character (INTEGER_.to_character (l_low))
						Result.append_character (INTEGER_.to_character (l_high))
						l_surrogate := utf16.supplementary_to_low_surrogate (l_code)
						l_high := l_surrogate // 256
						l_low := l_surrogate \\ 256
						Result.append_character (INTEGER_.to_character (l_low))
						Result.append_character (INTEGER_.to_character (l_high))
					end
					i := i + 1
				end
			end
		ensure
			to_utf16_le_not_void: Result /= Void
			string_type: ANY_.same_types (Result, "")
			valid_utf16: utf16.valid_utf16 (utf16.bom_le + Result)
		end

end
