indexing
	description: "Inclusion of extra services for the system"
	notice: "[
		DB services. Require Persistence classes to be compiled with the system.
	]"
	author: "Zoran Simic"
	date: "$Date: 2009/10/01 $"
	revision: "$Revision: #6 $"

class
	ROSE_SYSTEM_DEPENDENCY_GUI

inherit
	ROSE_SYSTEM_DEPENDENCY
	ROSE_SHARED_GLOBAL_GUI

feature {NONE} -- Implementation

	register is
			-- Register actual dependencies.
		local
			l_error_reporter: ROSE_OUTCHANNEL_EV_ERROR_REPORTER
			l_console: ROSE_OUTCHANNEL_EV
		do
			Gui.do_nothing
			Global.io_handler.manager.add_input (create {ROSE_INCHANNEL_EV}.make)
			create l_error_reporter.make
			create l_console.make
			Global.io_handler.manager.add_output (l_error_reporter)
			Global.io_handler.manager.add_output (l_console)
			Global.io_handler.set_output (l_console)
			Global.io_handler.manager.add_output (create {ROSE_OUTCHANNEL_EV_MONITOR}.make)
			error.add_broadcast (l_error_reporter)
			Global.io_handler.set_output (l_console)
				--| GUI related commands and overrides
			Global.commands.add_command (Global.commands.gui_category,Gui.console)
			Global.commands.add_command (Global.commands.gui_category,Gui.error_reporter)
			Global.commands.add_command (Global.commands.gui_category,Gui.monitor)
			Global.commands.add_command (Global.commands.gui_category,Gui.quit)
			Global.commands.add_command (Global.commands.gui_category,create {RCMD_EV_ABOUT})
			Global.commands.add_command (Global.commands.gui_category,create {RCMD_CONFIG_BROWSER})
			Global.commands.add_command (Global.commands.gui_category,create {RCMD_EV_SHOW})
			Global.commands.add_command (Global.commands.gui_category,create {RCMD_OBJECT_BROWSER})
			Global.commands.set_alias ("console","ev_console")
			Global.app.set_default_command_line ("config_browser -cmd")
		end

end
