note

	description:

		"General dated argument for expressions"

	author: "Mark Howard"
	last_editor: "$Author: it $"
	date: "$Date: 2013/02/20 $"
	revision: "$Revision: #30 $"
	path: "$File: //rose/source/kernel/targets/rose_target.e $"

deferred class ROSE_TARGET [G]

inherit

	ROSE_EXPRESSION_TARGET
		redefine
			expression_target,
			expressions_anchor,
			anchor,
			report_anchor
		end

	RP_HASHABLE

feature -- Access

	item: detachable G is
			-- Item for this target
		do
		end

	date: ROSE_DATE is
			-- Date for this target
		deferred
		end

	keys_equal (a_other: RP_HASHABLE): BOOLEAN is
			-- <Precursor>
		do
			Result := attached {like Current} a_other as l_other and then (item ~ l_other.item and date ~ l_other.date)
		end

	map_name: STRING is
			-- Map name
		do
		end

	target_name: STRING is
			--generator
		do
			Result := generator
		end

	version(a_date : ROSE_DATE) : like Current
			--version of this target on 'a_date'
		deferred
		end
feature -- Display

	display_string: STRING is
			-- Display string
		do
			Result := ""
		end

	consolidation: CHARACTER is
			-- level of consolidation: P for parent, C for consolidated, default value %U for not specified
		do
		end

feature -- Status

	is_parent_report: BOOLEAN is
			-- Is from parent reports?
		do
			Result := consolidation.as_upper = 'P'
		ensure
			definition: Result = (consolidation.as_upper = 'P')
		end

	is_consolidated_report: BOOLEAN is
			-- Is from consolidated reports?
		do
			Result := consolidation.as_upper = 'C'
		ensure
			definition: Result = (consolidation.as_upper = 'C')
		end

feature {NONE} --Templates

	report_anchor: ROSE_REPORT [ROSE_TARGET [G]] is
			-- Template
		do
		end

	computed_expression_target: ROSE_EXPRESSION [ROSE_TARGET [G]] is
			-- Expressions appropriate to be computed
		do
		end

	anchor: ROSE_TARGET [G] is
			-- Anchor
		do
		end

	expressions_anchor: ENTITY_VARIABLES [ROSE_TARGET [G]] is
			-- Expressions anchor
		do
		end

	expression_target: ROSE_EXPRESSION [ROSE_TARGET [G]] is
			-- Expression target anchor
		do
		end

	access_control_anchor: GENERIC_ACCESS_CONTROL_AGENT is
			-- Access control anchor
		do
		end

end
