note
	description: "Peer transformation (transform entities from one supplier to another)"
	author: "Zoran Simic"
	last_editor: "$Author: zs $"
	date: "$Date: 2011/05/27 $"
	revision: "$Revision: #9 $"
	path: "$File: //rose/source/kernel/entities/transformation/rose_transformation_peer.e $"

class
	ROSE_TRANSFORMATION_PEER

inherit
	ROSE_TRANSFORMATION

create
	default_create,
	make

feature {NONE} -- Initialization

	make (a_source, a_target: STRING; a_parent: INTEGER)
			-- Make with 'a_source', 'a_target' and 'a_parent'
		do
			make_transformation (a_source, a_target, a_parent)
		end

feature -- Access

	help: STRING =
			-- Help on this transformation
"[
Get the equivalent entites for another supplier
Example: Get companies in ROSE from it's equivalents in IBES
]"

feature {NONE} -- Implementation

	implementor_problem: STRING
			-- Problem with current transformation (Void if valid)
		do
			if source_category.category_id /= target_category.category_id then
				Result := "Source and target category ids do not match"
			end
		end

	specific_attributes: STRING
			-- Specific transformation attributes for 'representation'
		do
			Result := ""
		end

	actual_transformed (a_entity: ENTITY): ROSE_LINEAR_ARRAY [ENTITY]
			-- Actual transformation of 'a_entity' ('a_entity' has been checked to be valid)
		do
			Result := target_category.peers (a_entity, Void)
		end

feature {ROSE_TRANSFORMATION_LIST} -- Implementation

	specific_image (a_chains: ROSE_ENTITY_CHAINS; a_start, a_end: ROSE_DATE; a_range: HASH_TABLE [ENTITY, ENTITY]): ROSE_ENTITY_CHAINS
			-- This is only needed to bridge between old ROSE_ENTITY_CHAINS approach and ROSE_RECIPE
		do
			Result := a_chains.peers (target_category.context, parent + 1, a_start, a_end, a_range)
		end

end
