note
	description: "Date constraints for a transformation"
	author: "Zoran Simic"
	last_editor: "$Author: zs $"
	date: "$Date: 2011/05/27 $"
	revision: "$Revision: #5 $"
	path: "$File: //rose/source/kernel/entities/transformation/rose_transformation_setting_constraint.e $"

class
	ROSE_TRANSFORMATION_SETTING_CONSTRAINT

inherit
	ROSE_SHARED_GLOBAL
	DEBUG_OUTPUT

create
	make, default_create

feature -- Initialization

	make, set (a_start_date, a_end_date: ROSE_DATE)
			-- Make with 'a_start_date' and 'a_end_date'
		do
			start_date := a_start_date
			end_date := a_end_date
		end

feature -- Access

	start_date: ROSE_DATE		-- Start date for constraint
	end_date: ROSE_DATE			-- End date for constraint

	representation: attached STRING
			-- Textual representation of this constraint, suitable for the recipe parser
		do
			if start_date /= Void then
				create Result.make (20)
				Result.append ("%T%Tconstraint ")
				Result.append (start_date.ccyymmdd.out)
				if end_date /= Void then
					Result.extend (',')
					Result.extend (' ')
					Result.append (end_date.ccyymmdd.out)
				end
				Result.extend ('%N')
			else
				create Result.make_empty
			end
		end

	debug_output: STRING
			-- String that should be displayed in debugger to represent `Current'.
		do
			Result := representation
		end

feature -- Basic operations

	set_from_other (a_other: like Current)
			-- Set from 'a_other'
		do
			if a_other /= Void then
				start_date := a_other.start_date
				end_date := a_other.end_date
			else
				start_date := Void
				end_date := Void
			end
		end

end
