note

	description:

		"Unary operator where the resulting expression has the same signature as the argument"

	author: "Mark Howard"
	last_editor: "$Author: mk $"
	date: "$Date: 2011/05/03 $"
	revision: "$Revision: #33 $"
	path: "$File: //rose/source/kernel/math/rose_unary_operator.e $"

deferred class
	ROSE_UNARY_OPERATOR[reference G]
inherit
	GENERIC_UNARY_OPERATOR[G,G]
		redefine
			access_agent_template,
			value_in_currency
		end
feature -- Access
	real_value (a_left : ROSE_EXPRESSION[G];a_g : G) : REAL is
			-- Real value
		deferred
		end
	double_value (a_left : ROSE_EXPRESSION[G];a_g : G) : DOUBLE is
			--returned double value
		deferred
		end
	integer_value (a_left : ROSE_EXPRESSION[G];a_g : G) : INTEGER is
			--returned integer value
		deferred
		end

	string_value (a_left : ROSE_EXPRESSION[G];a_g : G) : STRING is
			--STRING value
		deferred
		end

	value_in_market_currency (a_left : ROSE_EXPRESSION[G];a_market : MARKET;a_currency : PERSISTENT_CURRENCY;a_entity : G;a_date : ROSE_DATE) : DOUBLE is
				-- For operating on expressions in currency.
		deferred
		end
	value_in_currency (a_left : ROSE_EXPRESSION[G]; a_currency: like currency_anchor; a_g : G; a_date : ROSE_DATE) : DOUBLE is
				-- The same implementation as in expressions.
				-- Same as inherited from GENERIC_UNARY_OPERATOR but required so that a_g can be of G type.
		do
			Result := value_in_market_currency(a_left, Void, a_currency, a_g, a_date)
		end
	units (a_left : ROSE_EXPRESSION[G];a_entity : G) : ROSE_UNITS is
			--default units computed from the underlying expression and the target
		do
			Result := computed_units(a_left.units(a_entity))
		end
	units_in_currency (a_left : ROSE_EXPRESSION[G];a_currency : PERSISTENT_CURRENCY;a_entity : G) : ROSE_UNITS is
		deferred
		end
	computed_double(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : DOUBLE is
		deferred
		end
	computed_real(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : REAL is
			-- Computed real
		deferred
		end
	computed_integer(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : INTEGER is
		deferred
		end
	computed_boolean(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : BOOLEAN is
			-- Computed boolean
		deferred
		end
	computed_string(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : STRING is
		deferred
		end
feature  --Generated values
	generated_double(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : DOUBLE is
		deferred
		end
	generated_real(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : REAL is
		deferred
		end
	generated_integer(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : INTEGER is
		deferred
		end
	generated_string(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : STRING is
		deferred
		end
	generated_date(a_left : ROSE_EXPRESSION[G]; a_g : G; a_agent : like access_agent_template) : ROSE_DATE is
		deferred
		end
feature  --Templates
	access_agent_template : GENERIC_ACCESS_CONTROL_AGENT is
			--template
		do  end
end
