indexing
	description: "Ancestor for undefined handling ... ie. ROSE_LEGACY_UNDEFINED and ROSE_IEEE_UNDEFINED"
	author: "Mark Howard"
	last_editor: "$Author: dz $"
	date: "$Date: 2009/08/10 $"
	revision: "$Revision: #4 $"
	path: "$File: //rose/source/kernel/infrastructure/math/rose_undefined.e $"

deferred class ROSE_UNDEFINED

inherit
	ROSE_CONSTANTS

feature --Access

	is_defined_integer(a_value: INTEGER): BOOLEAN is
		--is a_value the signaling value for undefined?
		deferred
		end
	undefined_value : REAL is
		--preferred undefined value
		deferred
		end
	undefined_real : REAL is
		--preferred undefined real
		deferred
		end
	undefined_double : DOUBLE is
		--preferred undefined double
		deferred
		end
	undefined_integer : INTEGER is
		--preferred undefined integer
		deferred
		end

	defined_real, defined_real_value (a_value: REAL): REAL
			-- `a_value' if not undefined_real, else undefined_real
		do
			if is_defined_real (a_value) then
				Result := a_value
			else
				Result := undefined_real
			end
		end

	defined_double_value (a_value: DOUBLE): DOUBLE
			-- `a_value' if not undefined_double, else undefined_double
			-- should be named `defined_double' but that is currently used for something else
		do
			if is_defined_double (a_value) then
				Result := a_value
			else
				Result := undefined_double
			end
		ensure
			defined_value_equals_result: is_defined_double (a_value) implies Result = a_value
			result_undefined_if_value_undefined: (not is_defined_double (a_value)) implies (not is_defined_double (Result))
		end

invariant
	dummy : True

end -- class ROSE_UNDEFINED
