indexing
	description: "Scanner for ROSE_UNITS"
	author: "Zoran Simic"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #9 $"

class ROSE_UNITS_SCANNER

inherit
	YY_COMPRESSED_SCANNER_SKELETON
		rename
			make as make_compressed_scanner_skeleton,
			reset as reset_compressed_scanner_skeleton,
			output as yy_scanner_output
		end

	ROSE_UNITS_TOKENS
		export {NONE} all end

create
	make_rose_units_scanner

feature {NONE} -- Initialization

	make_rose_units_scanner is
			-- Create a new Rose units scanner.
		do
			make_with_buffer (Empty_buffer)
			line_number := 1
		end

feature -- Initialization

	reset is
			-- Reset scanner before scanning next input.
		do
			reset_compressed_scanner_skeleton
			line_number := 1
		end

feature -- Access

	line_number: INTEGER
			-- Current line number


feature -- Status report

	valid_start_condition (sc: INTEGER): BOOLEAN is
			-- Is `sc' a valid start condition?
		do
			Result := (sc = INITIAL)
		end

feature {NONE} -- Implementation

	yy_build_tables is
			-- Build scanner tables.
		do
			yy_nxt := yy_nxt_template
			yy_chk := yy_chk_template
			yy_base := yy_base_template
			yy_def := yy_def_template
			yy_ec := yy_ec_template
			yy_meta := yy_meta_template
			yy_accept := yy_accept_template
		end

	yy_execute_action (yy_act: INTEGER) is
			-- Execute semantic action.
		do
if yy_act <= 3 then
if yy_act <= 2 then
if yy_act = 1 then
--|#line 53 "..\..\External\parsing\rose_units_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_units_scanner.l' at line 53")
end
-- Separators ignored
else
--|#line 54 "..\..\External\parsing\rose_units_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_units_scanner.l' at line 54")
end
line_number := line_number + 1
end
else
--|#line 61 "..\..\External\parsing\rose_units_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_units_scanner.l' at line 61")
end
last_token := RU_IDENTIFIER; last_string_value := text
end
else
if yy_act <= 5 then
if yy_act = 4 then
--|#line 63 "..\..\External\parsing\rose_units_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_units_scanner.l' at line 63")
end
last_token := RU_INTEGER; last_string_value := text
else
--|#line 69 "..\..\External\parsing\rose_units_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_units_scanner.l' at line 69")
end
last_token := text_item (1).code
end
else
--|#line 0 "..\..\External\parsing\rose_units_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_units_scanner.l' at line 0")
end
last_token := yyError_token
fatal_error ("scanner jammed")
end
end
		end

	yy_execute_eof_action (yy_sc: INTEGER) is
			-- Execute EOF semantic action.
		do
			inspect yy_sc
when 0 then
--|#line 0 "..\..\External\parsing\rose_units_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rose_units_scanner.l' at line 0")
end

			last_token := RU_EOF
			--| terminate
		
			else
				terminate
			end
		end

feature {NONE} -- Table templates

	yy_nxt_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    4,    5,    6,    7,    8,   11,   11,   10,    9,
			   12,    3,   12,   12,   12,   12,   12, yy_Dummy>>)
		end

	yy_chk_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,   15,   15,   14,   13,
			    3,   12,   12,   12,   12,   12,   12, yy_Dummy>>)
		end

	yy_base_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    0,    0,   10,   11,    0,   11,    0,    0,    0,
			    0,    0,   11,    7,    5,    3, yy_Dummy>>)
		end

	yy_def_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,   12,    1,   12,   12,   13,   12,   14,   15,   13,
			   14,   15,    0,   12,   12,   12, yy_Dummy>>)
		end

	yy_ec_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    2,
			    3,    1,    1,    2,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    2,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    4,    4,
			    4,    4,    4,    4,    4,    4,    4,    4,    1,    1,
			    1,    1,    1,    1,    1,    5,    5,    5,    5,    5,
			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			    5,    1,    1,    1,    1,    5,    1,    5,    5,    5,

			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			    5,    5,    5,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1, yy_Dummy>>)
		end

	yy_meta_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    1,    2,    1,    3,    4, yy_Dummy>>)
		end

	yy_accept_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    0,    0,    7,    5,    1,    2,    4,    3,    1,
			    4,    3,    0, yy_Dummy>>)
		end

feature {NONE} -- Constants

	yyJam_base: INTEGER is 11
			-- Position in `yy_nxt'/`yy_chk' tables
			-- where default jam table starts

	yyJam_state: INTEGER is 12
			-- State id corresponding to jam state

	yyTemplate_mark: INTEGER is 13
			-- Mark between normal states and templates

	yyNull_equiv_class: INTEGER is 1
			-- Equivalence code for NULL character

	yyReject_used: BOOLEAN is false
			-- Is `reject' called?

	yyVariable_trail_context: BOOLEAN is false
			-- Is there a regular expression with
			-- both leading and trailing parts having
			-- variable length?

	yyReject_or_variable_trail_context: BOOLEAN is false
			-- Is `reject' called or is there a
			-- regular expression with both leading
			-- and trailing parts having variable length?

	yyNb_rules: INTEGER is 6
			-- Number of rules

	yyEnd_of_buffer: INTEGER is 7
			-- End of buffer rule code

	yyLine_used: BOOLEAN is false
			-- Are line and column numbers used?

	yyPosition_used: BOOLEAN is false
			-- Is `position' used?

	INITIAL: INTEGER is 0
			-- Start condition codes

feature -- User-defined features



end -- class ROSE_UNITS_SCANNER
