indexing
	description : "[
		Class for interpreting VMS doubles on other platforms
		]"
	author : "Mark Howard"
	date: "$Date: 2008/12/01 $";
	revision: "$Revision: #11 $"

class
   ROSE_VMS_DOUBLE_INTERPRETER

inherit
	ROSE_DOUBLE_INTERPRETER
	    undefine
	    	dereference_real,
	    	dereference_double
	    redefine
	    	encode,
	    	decode
	    end
	VMS_FLOAT

feature

	encode (a_target : POINTER; a_source : DOUBLE; a_count : INTEGER) is
			-- encode Eiffel DOUBLE as native double float for use by platform-specific
			-- external software (VMS: D_float)
		require else
		    correct_size: a_count = sizeof_double
		do
		    double_to_VMS_D_FLOAT (a_source, a_target)
		end

    decode (a_pointer : POINTER; a_byte_count : INTEGER) : DOUBLE is
			-- decode platform-specific native single float (VMS: D_float)
			-- to Eiffel DOUBLE
		do
			Result := double_from_VMS_D_FLOAT (a_pointer)
		end

end -- class ROSE_VMS_DOUBLE_INTERPRETER

