indexing
	description : "[
		Class for interpreting VMS reals on other platforms
		]"
	author : "Mark Howard"
	date: "$Date: 2008/12/01 $";
	revision: "$Revision: #8 $"

class
	ROSE_VMS_REAL_INTERPRETER

inherit
	ROSE_REAL_INTERPRETER
	    undefine
	    	dereference_real,
	    	dereference_double
	    redefine
	    	encode,
	    	decode
	    end
	VMS_FLOAT

feature

	encode (a_target : POINTER; a_source : REAL; a_count : INTEGER) is
			-- encode Eiffel REAL as native single float for use by platform-specific
			-- external software (VMS: F_float)
		do
		    real_to_VMS_F_FLOAT (a_source, a_target)
		end

	decode (a_pointer : POINTER; a_byte_count : INTEGER) : REAL is
			-- decode platform-specific native single float (VMS: F_float)
			-- to Eiffel REAL
		do
			Result := real_from_VMS_F_FLOAT (a_pointer)
		end

end -- class ROSE_VMS_REAL_INTERPRETER
