note

	description:

		"Set undefined values to zero on ROSE_EXPRESSION"

	author: "Venugopal Koneru"
	last_editor: "$Author: it $"
	date: "$Date: 2013/11/18 $"
	revision: "$Revision: #9 $"
	path: "$File: //rose/source/kernel/math/rose_zero_if_undefined_operator.e $"

class ROSE_ZERO_IF_UNDEFINED_OPERATOR [reference G]

inherit

	ROSE_FUNCTION_OPERATOR[G]

	MISMATCH_CORRECTOR
		redefine
			correct_mismatch
		end

create

	make_zero_if_undefined

feature {NONE} -- Initialization

	make_zero_if_undefined is
			-- Initialize `Current'
		do
			make_with_function (agent zero_if_undefined (?, ?, ?), "zero_if_ua")
		end

feature {NONE} -- Implementation

	zero_if_undefined (a_value: DOUBLE; a_g: G; a_expr: ROSE_EXPRESSION[G]): DOUBLE is
			-- Zero when `a_value' is undefined
		do
			if is_defined_double (a_value) then
				Result := a_value
			end
		ensure
			a_value_when_defined: is_defined_double (a_value) implies Result ~ a_value
			zero_otherwise: (not is_defined_double (a_value)) implies Result ~ 0.0
		end

	correct_mismatch is
			-- <Precursor>
		do
			-- do nothing
		end

end
