indexing

	description:

		"Provides bond prices retrieved from legacy PRICE_RECORD"

	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #3 $"

class RP_AXAROSENBERG_CORPORATE_BOND_MARKET_DATA_SOURCE

inherit

	RP_MARKET_DATA_SOURCE_LAST_RECORD_SEARCH [RP_CORPORATE_BOND]

	ROSE_AWARE
		export {NONE} all end

create

	make

feature {NONE} -- Initialization

	make (a_reference_system: like reference_system) is
			-- Initialize `Current'
		require
			reference_system_not_void: a_reference_system /= Void
		do
			reference_system := a_reference_system
		ensure
			reference_system_set: reference_system = a_reference_system
		end

feature -- Access

	reference_system: RP_REFERENCE_SYSTEM

feature -- Query

	snapshot (a_instrument: RP_CORPORATE_BOND; a_date: ROSE_DATE): RP_MARKET_DATA_RECORD is
			-- Market data for `a_instrument' on `a_date'.
		local
			l_bond: BOND
			l_data: PRICE_RECORD
		do
			l_bond := context.bond_accessor.entity (a_instrument.entity_id)
			if l_bond /= Void then
				l_data := l_bond.price_record (a_date)
				if l_data /= Void then
					create {RP_LISTING_MARKET_DATA} Result.make_with_legacy_price_record (reference_system, a_instrument, l_data)
				end
			end
		end

end
