indexing

	description:

		"RMDAT Market Data Source"

	date: "$Date: 2009/10/01 $"
	revision: "$Revision: #19 $"

class RP_AXAROSENBERG_MARKET_DATA_SOURCE

inherit

	RP_MARKET_DATA_SOURCE_LAST_RECORD_SEARCH [RP_STOCK]

	ROSE_AWARE
		export {NONE} all end

create

	make

feature {NONE} -- Initialization

	make (a_ref_system: like reference_system) is
			-- Initialize `Current'.
		do
			reference_system := a_ref_system
		end

feature -- Query

	reference_system: RP_REFERENCE_SYSTEM
			-- Reference system.

	snapshot (a_stock: RP_STOCK; a_date: ROSE_DATE): RP_LISTING_MARKET_DATA is
			-- Market data for `a_stock' on `a_date'.
		local
			l_listing: LISTING
			l_price_record: RMDAT_PRICE_RECORD
		do
			if a_stock.xrf_plus_zone > 0 then
				l_listing := context.listing_accessor.entity (a_stock.entity_id)
--				l_listing := context.listing_from_brim_code (a_stock.brimsym, a_date)
				if l_listing /= Void then
					l_price_record := l_listing.price_record (a_date)
					if l_price_record /= Void then
						Result := create {RP_LISTING_MARKET_DATA}.make_with_legacy_price_record (reference_system, a_stock, l_price_record)
					end
				end
			end
		end

end
