indexing

	description:

		"Default T-Bills Market Data Source"

	date: "$Date: 2009/04/14 $"
	fileid: "$Id: //rose/source/kernel/expert_system/mds/rp_axarosenberg_tbill_market_data_source.e#1 $"

class RP_AXAROSENBERG_TBILL_MARKET_DATA_SOURCE

inherit

	RP_MARKET_DATA_SOURCE_LAST_RECORD_SEARCH [RP_GOVERNMENT_BOND]

	ROSE_AWARE
		export {NONE} all end

create

	make

feature {NONE} -- Initialization

	make (a_ref_system: like reference_system) is
			-- Initialize `Current'.
		do
			reference_system := a_ref_system
		end

feature -- Query

	reference_system: RP_REFERENCE_SYSTEM
			-- Reference system.

	snapshot (a_instrument: RP_GOVERNMENT_BOND; a_date: ROSE_DATE): RP_LISTING_MARKET_DATA is
			-- Market data for `a_stock' on `a_date'.
		local
			l_tbill: GOVERNMENT_ISSUE
			l_price_record: RMDAT_PRICE_RECORD
			l_listing: LISTING
		do
			if a_instrument.entity_id > 0 then
				l_tbill := context.government_issue_accessor.entity (a_instrument.entity_id)
				if l_tbill /= Void then
					l_price_record := l_tbill.price_record (a_date)
					if l_price_record /= Void then
						Result := create {RP_LISTING_MARKET_DATA}.make_with_legacy_price_record (reference_system, a_instrument, l_price_record)
					end
				else
					l_listing := context.listing_accessor.entity (a_instrument.entity_id)
					if l_listing /= Void then
						l_price_record := l_listing.price_record (a_date)
						if l_price_record /= Void then
							Result := create {RP_LISTING_MARKET_DATA}.make_with_legacy_price_record (reference_system, a_instrument, l_price_record)
						end
					end
				end
			end
		end

end
