indexing

	description:

		"Bank entity"

	date: "$Date: 2009/04/03 $"
	revision: "$Revision: #8 $"

class RP_BANK

inherit

	RP_PARTY
		rename
			code as bic
		end

create {RP_REFERENCE_SYSTEM}

	make_with_bic,
	make_from_gcdb_bank

feature {NONE} -- Initialization

	make_with_bic (a_bic: like bic) is
			-- Initialize `Current'
		require
			non_void_bic: a_bic /= Void
		do
			bic := a_bic
			name := bic
		ensure
			non_void_bic: bic /= Void
			non_void_name: name /= Void
		end

	make_from_gcdb_bank (a_gcdb_bank: GCDB_BANK) is
			-- Initialize `Current' with information from `a_gcdb_bank'
		require
			non_void_gcbd_bank: a_gcdb_bank /= Void
		do
			bic := a_gcdb_bank.bic
			name := a_gcdb_bank.bic
		ensure
			non_void_bic: bic /= Void
			non_void_name: name /= Void
		end

feature -- Query

	bic: STRING
			-- Bank identification code

	name: STRING
			-- Name

	instrument_control: RP_INSTRUMENT_CONTROL is
			-- Instrument control
		do
			if saved_instrument_control = Void then
				create saved_instrument_control.make_with_owner (Current)
			end
			Result := saved_instrument_control
		end

feature {NONE} -- Implementation

	saved_instrument_control: like instrument_control
			-- Cached instrument control

invariant

	non_void_bic: bic /= Void
	non_void_name: name /= Void

end
