note

	description:

		"Transfer of cash to short-term depository account"

	author: "Ivan Tarnavsky"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #6 $"
	path: "$File: //rose/source/kernel/expert_system/aflows/rp_bank_transfer.e $"

class
	RP_BANK_TRANSFER

inherit
	RP_PORTFOLIO_CONTRACT
		rename
			make as make_portfolio_contract
		end

create
	make

feature {NONE} -- Initialization

	make (
		a_system: like generating_system;
		a_event_date: like agreement_time;
		a_identifier: like identifier;
		a_portfolio: like portfolio;
		a_settle_date: like agreement_time;
		a_cash_effect_with_sign: RP_QUANTITY;
		a_secondary_cash_effect: RP_QUANTITY;
		a_custody: RP_CUSTODY) is
				-- Create
			require
				a_system_not_void: a_system /= Void
				a_event_date_not_void: a_event_date /= Void
				a_identifier_not_void: a_identifier /= Void
				a_portfolio_not_void: a_portfolio /= Void
				a_settle_date_not_void: a_settle_date /= Void
				a_cash_effect_with_sign_not_void: a_cash_effect_with_sign /= Void
				a_secondary_cash_effect_not_void: a_secondary_cash_effect /= Void
				a_custody_not_void: a_custody /= Void
			do
				make_portfolio_contract (a_system, a_event_date, a_identifier, a_portfolio)
				add_flow (transfer_flow_type,
					a_portfolio.client_instrument_control,
					a_portfolio.instrument_control (a_custody),
					a_event_date,
					a_settle_date,
					a_cash_effect_with_sign,
					a_event_date, 0, Void)
				add_flow (
					transfer_flow_type,
					a_portfolio.client_instrument_control,
					a_portfolio.instrument_control (a_custody),
					a_event_date,
					a_settle_date,
					a_secondary_cash_effect,
					a_event_date, 0, Void)
			end

feature -- Basic Operations

	process (a_processor: RP_CONTRACT_PROCESSOR) is
			-- <Precursor>
		do
			a_processor.process_bank_transfer (Current)
		end

end
