note

	description:

		"Broker Entity"

	author: "mk"
	last_editor: "$Author: c4 $"
	date: "$Date: 2015/04/09 $"
	revision: "$Revision: #18 $"
	path: "$File: //rose/source/kernel/expert_system/rp_broker.e $"

class RP_BROKER

inherit

	RP_PARTY

	RP_UNKNOWN_CUSTODY_AWARE
		export
			{NONE} all
		undefine
			is_equal
		end

	RP_UNSPECIFIED_LOCATION_AWARE
		export
			{NONE} all
		undefine
			is_equal
		end

	RP_UNKNOWN_MANAGEMENT_AWARE
		export
			{NONE} all
		undefine
			is_equal
		end

	DEBUG_OUTPUT
		undefine
			is_equal
		end

create {RP_REFERENCE_SYSTEM}

	make

feature {NONE} -- Initialization

	make (a_reference_system: like reference_system; a_broker_code: like code) is
			-- Initialize `Current'
		require
			ref_exist: a_reference_system /= Void
		do
			reference_system := a_reference_system
			if a_broker_code = Void or else a_broker_code.is_empty then
				code := "Unknown"
				name := code
				is_unknown := True
			else
				code := a_broker_code
				name := code
			end
			owner := Current
		end

feature -- Access

	owner: RP_PARTY
			-- Owner

	code: STRING
			-- Unique identifier.

	name: STRING
			-- Descriptive name.

	is_unknown: BOOLEAN
			-- Is `Current' the unknown instance?

	instrument_control: RP_INSTRUMENT_CONTROL is
			-- Instument control for broker accounts
		do
			if saved_instrument_control = Void then
				create saved_instrument_control.make_with_owner (Current)
			end
			Result := saved_instrument_control
		ensure
			non_void_result: Result /= Void
		end

	debug_output: STRING is
			-- <Precursor>
		do
			Result := code
		end

feature {NONE} -- Implementation

	saved_instrument_control: like instrument_control
			-- Cached instrument control

	reference_system: RP_REFERENCE_SYSTEM
			-- Reference system

end
