indexing

	description:

		"Contract with a broker as counter-party"

	date: "$Date: 2010/07/19 $"
	sccid: "$Id: //rose/source/kernel/expert_system/rp_brokerage_contract.e#9 $"

deferred class RP_BROKERAGE_CONTRACT

inherit

	RP_PORTFOLIO_CONTRACT
		rename
			executing_counterparty as broker,
			make as make_portfolio_contract
		redefine
			broker
		end

feature {NONE} -- Initialization

	make (a_trading_system: like generating_system; a_agreement_time: like agreement_time; a_identifier: like identifier; a_portfolio: like portfolio; a_broker: like broker) is
			-- Create a portfolio contract with broker
		require
			gtrading_system_not_void: a_trading_system /= Void
			agreement_time_not_void: a_agreement_time /= Void
			identifier_not_void: a_identifier /= Void
			portfolio_not_void: a_portfolio /= Void
			broker_not_void: a_broker /= Void
		do
			make_portfolio_contract (a_trading_system, a_agreement_time, a_identifier, a_portfolio)
			broker := a_broker
		ensure
			trading_system_set: generating_system = a_trading_system
			agreement_time_set: agreement_time = a_agreement_time
			identifier_set: identifier = a_identifier
			portfolio_set: portfolio = a_portfolio
			broker_set: broker = a_broker
		end

feature -- Access

	broker: RP_BROKER
			-- Counterparty.

invariant

	broker_not_void: broker /= Void

end
