note

	description:

		"BUY contract"

	author: "Mark Howard"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #23 $"
	path: "$File: //rose/source/kernel/contracts/trades/rp_buy.e $"

class RP_BUY

inherit

	RP_LISTED_TRADE
		redefine
			add_exchange_flows
		end

create

	make

feature {NONE} -- Initialization

	set_type is
			-- Set type
		do
			is_buy := True
		end

feature -- Basic Operations

	process (a_processor: RP_CONTRACT_PROCESSOR) is
			-- <Precursor>
		do
			a_processor.process_buy (Current)
		end

feature {NONE} -- Implementation

	add_exchange_flows (a_quantity: like traded_quantity; a_gross_monies: like gross_quantity; a_net_monies: like net_quantity; a_contracted_ownership_time, a_contracted_settlement_time: ROSE_DATE; a_custody: RP_CUSTODY) is
			-- <Precursor>
		do
			add_flow (quantity_flow_type, broker.instrument_control, portfolio.instrument_control (a_custody), a_contracted_ownership_time, a_contracted_settlement_time, a_quantity, a_contracted_ownership_time, 0, a_net_monies)
			add_flow (gross_monies_flow_type, portfolio.instrument_control (a_custody), broker.instrument_control, a_contracted_ownership_time, a_contracted_settlement_time, a_gross_monies, a_contracted_ownership_time, 0, a_gross_monies)
		end

invariant
		-- gross and net names have been swapped
	gross_is_net_plus_comm_plus_fee: net_quantity.abs ~ (gross_quantity + commission + fee)
	is_buy: is_buy
end
