indexing
	description: "Calendar Lookup"
	date: "$Date: 2009/02/06 $"
	fileid: "$Id: //rose/source/kernel/expert_system/ref/rp_calendar.e#4 $"

deferred class RP_CALENDAR

feature -- Query

	is_work_day (a_date: ROSE_DATE): BOOLEAN is
			-- Is `a_date' work dat?
		require
			date_not_void: a_date /= Void
		deferred
		end

	ith_work_day_after (a_date: ROSE_DATE; a_days: INTEGER): ROSE_DATE is
			-- Work date which is `a_days' after `a_date'
		require
			date_not_void: a_date /= Void
			positive_days: a_days >= 0
		deferred
		end

	ith_work_day_before (a_date: ROSE_DATE; a_days: INTEGER): ROSE_DATE is
			-- Work date which is `a_days' before `a_date'
		require
			date_not_void: a_date /= Void
			positive_days: a_days >= 0
		deferred
		end

	last_work_day (a_date: ROSE_DATE): ROSE_DATE is
			-- Work date on or before `a_date'
		require
			date_not_void: a_date /= Void
		deferred
		end

	next_work_day (a_date: ROSE_DATE): ROSE_DATE is
			-- Work day on or after `a_date'
		require
			date_not_void: a_date /= Void
		deferred
		end

end
