note

	description:

		"Cash swept contract"

	author: "Mark Howard"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #12 $"
	path: "$File: //rose/source/kernel/contracts/custodian/rp_cash_swept.e $"

deferred class RP_CASH_SWEPT [G -> RP_PORTFOLIO_CONTRACT]

inherit

	RP_CUSTODIAN_CONTRACT

feature -- Access

	sweeping_from: G
			-- Source of sweeping

feature {NONE} -- Initialization

	make (a_contract: G; a_quantity: RP_QUANTITY; a_value: RP_MONIES; a_event_date, a_settle_date: ROSE_DATE;
		a_portfolio: like portfolio; a_identifier: like identifier;
		a_system: like generating_system; a_custody: RP_CUSTODY) is
			-- Create
		require
			a_contract_not_void: a_contract /= Void
			a_quantity_not_void: a_quantity /= Void
			a_value_not_void: a_value /= Void
			a_event_date_not_void: a_event_date /= Void
			a_settle_date_not_void: a_settle_date /= Void
			a_portfolio_not_void: a_portfolio /= Void
			a_identifier_not_void: a_identifier /= Void
			a_system_not_void: a_system /= Void
			a_custody_not_void: a_custody /= Void
		do
			sweeping_from := a_contract
				-- Contract
			make_portfolio_contract (a_system, a_event_date, a_identifier, a_portfolio)
				-- Flows
			add_flow (withdrawal_flow_type, a_portfolio.instrument_control (a_custody), unknown_instrument_control, a_event_date, a_settle_date, a_quantity, a_event_date, 0, a_value)
		end

end
