indexing
	description: "Notification that an object changed"
	author: "Portfolio Accounting Tech (it)"
	date: "$Date: 2010/01/26 $"
	revision: "$Revision: #4 $"

deferred class
	RP_CHANGE_MESSAGE[G->RP_EVENT_SOURCE]

feature {NONE} -- Initialization

	make (a_new : like new_g;a_old : like old_g) is
			-- Create with 'a_new' and 'a_old'
		do
			new_g := a_new
			old_g := a_old
		end

feature -- Access

	new_g : G
		-- New version of the object

	old_g : G
		-- Old version of the object

feature -- Basic Operations

	dispatch (a_manager: RP_INVESTMENT_MANAGER) is
			-- Dispatch message to 'a_manager'
		require
			manager_not_void: a_manager /= Void
		do
		end

feature -- Status Report

	is_deletion : BOOLEAN is
			-- Was the 'old' object attached to a reference and the new one is not?
		do
			Result := old_g /= void and then new_g = void
		end

	is_change : BOOLEAN is
			-- Are both 'old' and 'new' object attached?
		do
			Result := old_g /= void and then new_g /= void
		end

	is_addition : BOOLEAN is
			-- Was the 'old' object not attached whereas the 'new' one is?
		do
			Result := old_g = void and then new_g /= void
		end

invariant
	old_g /= void or new_g /= void

end
