note

	description:

		"Client contribution contract"

	author: "Mark Howard"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #15 $"
	path: "$File: //rose/source/kernel/expert_system/rp_client_contribution.e $"

class RP_CLIENT_CONTRIBUTION

inherit

	RP_CLIENT_CONTRACT

create {RP_GEDB_EVENT_TO_CONTRACT_CONVERTER}

	make_portfolio_contract,
	make_legacy_contribution

create

	make_contribution,
	make_inkind

feature {NONE} -- Initialization

	make_contribution (a_system: like generating_system; a_portfolio: RP_PORTFOLIO;
		a_contract_date, a_settle_date: ROSE_DATE; a_quantity: RP_QUANTITY;
		a_cost: RP_LEGACY_COST; a_custody: RP_CUSTODY) is
			-- Create client contribution
		require
			a_system_not_void: a_system /= Void
			a_portfolio_not_void: a_portfolio /= Void
			a_contract_date_not_void: a_contract_date /= Void
			a_settle_date_not_void: a_settle_date /= Void
			a_quantity_not_void: a_quantity /= Void
			a_cost_not_void: a_cost /= Void
			a_custody_not_void: a_custody /= Void
		do
			make_portfolio_contract (a_system, a_contract_date, a_quantity.instrument.brimsym, a_portfolio)
			populate_flow (contribution_flow_type, a_portfolio, a_contract_date, a_settle_date, a_quantity, a_cost, a_custody)
		end

	make_legacy_contribution (a_system: like generating_system; a_portfolio: RP_PORTFOLIO;
		a_identifier: like identifier; a_contract_date, a_settle_date: ROSE_DATE;
		a_quantity: RP_QUANTITY; a_value: RP_MONIES; a_custody: RP_CUSTODY) is
			-- Create client contribution
			-- FIXME: this looks very specific - is the cost not specified at all?
		require
			a_system_not_void: a_system /= Void
			a_portfolio_not_void: a_portfolio /= Void
			a_identifier_not_void: a_identifier /= Void
			a_contract_date_not_void: a_contract_date /= Void
			a_settle_date_not_void: a_settle_date /= Void
			a_quantity_not_void: a_quantity /= Void
			a_value_not_void: a_value /= Void
			a_custody_not_void: a_custody /= Void
		local
			l_external_holding: RP_EXTERNAL_HOLDING
		do
			make_portfolio_contract (a_system, a_contract_date, a_identifier, a_portfolio)
			create l_external_holding.make (a_quantity, a_value, Void)
			add_external_holding_flow (contribution_flow_type, a_contract_date, a_settle_date, l_external_holding, portfolio.client_instrument_control, portfolio.instrument_control (a_custody))
		end

	make_inkind (a_system: like generating_system; a_portfolio: RP_PORTFOLIO;
		a_contract_date, a_settle_date: ROSE_DATE; a_quantity: RP_QUANTITY;
		a_cost: RP_LEGACY_COST; a_custody: RP_CUSTODY) is
			-- Create inkind
		require
			a_system_not_void: a_system /= Void
			a_portfolio_not_void: a_portfolio /= Void
			a_contract_date_not_void: a_contract_date /= Void
			a_settle_date_not_void: a_settle_date /= Void
			a_quantity_not_void: a_quantity /= Void
			a_cost_not_void: a_cost /= Void
			a_custody_not_void: a_custody /= Void
		do
			make_portfolio_contract (a_system, a_contract_date, a_quantity.instrument.brimsym, a_portfolio)
			populate_flow (inkind_flow_type, a_portfolio, a_contract_date, a_settle_date, a_quantity, a_cost, a_custody)
		end

feature -- Basic Operations

	process (a_processor: RP_CONTRACT_PROCESSOR) is
			-- <Precursor>
		do
			a_processor.process_client_contribution (Current)
		end

feature {NONE} -- Implementation

	populate_flow (a_flow_type: RP_FLOW_TYPE; a_portfolio: RP_PORTFOLIO; a_contract_date, a_settle_date: ROSE_DATE;
		a_quantity: RP_QUANTITY; a_cost: RP_LEGACY_COST; a_custody: RP_CUSTODY) is
			-- Add flow
		local
			l_external_holding: RP_EXTERNAL_HOLDING
		do
			create l_external_holding.make (a_quantity, a_cost.quantity, a_cost)
				-- quantity, value, cost
			add_external_holding_flow (a_flow_type, a_contract_date, a_settle_date, l_external_holding, a_portfolio.client_instrument_control, a_portfolio.instrument_control (a_custody))
		end

end
