note

	description:

		"Client System"

	author: "Mark Howard"
	last_editor: "$Author: c4 $"
	date: "$Date: 2015/04/09 $"
	revision: "$Revision: #12 $"
	path: "$File: //rose/source/kernel/expert_system/rp_client_system.e $"

class RP_CLIENT_SYSTEM

inherit

	RP_UNKNOWN_PARTY_AWARE
		export {NONE} all end

	RP_CONTRACT_SYSTEM

	RP_MESSAGE_FACTORY [RP_CLIENT_MESSAGE]

create

	make

feature -- Factory methods

	new_client_contribution (a_portfolio: RP_PORTFOLIO; a_contract_date, a_settle_date: ROSE_DATE;
		a_quantity: RP_QUANTITY; a_cost: RP_LEGACY_COST; a_custody: RP_CUSTODY): !RP_CLIENT_CONTRIBUTION is
			-- Create new client contribution
		require
			a_portfolio_not_void: a_portfolio /= Void
			a_contract_date_not_void: a_contract_date /= Void
			a_settle_date_not_void: a_settle_date /= Void
			a_quantity_not_void: a_quantity /= Void
			a_cost_not_void: a_cost /= Void
			a_custody_not_void: a_custody /= Void
		do
			create Result.make_contribution (Current, a_portfolio, a_contract_date, a_settle_date, a_quantity, a_cost, a_custody)
		end

	new_inkind (a_portfolio: RP_PORTFOLIO; a_contract_date, a_settle_date: ROSE_DATE;
		a_quantity: RP_QUANTITY; a_cost: RP_LEGACY_COST; a_custody: RP_CUSTODY): !RP_CLIENT_CONTRIBUTION is
			-- Create new inkind
		require
			a_portfolio_not_void: a_portfolio /= Void
			a_contract_date_not_void: a_contract_date /= Void
			a_settle_date_not_void: a_settle_date /= Void
			a_quantity_not_void: a_quantity /= Void
			a_cost_not_void: a_cost /= Void
			a_custody_not_void: a_custody /= Void
		do
			create Result.make_inkind (Current, a_portfolio, a_contract_date, a_settle_date, a_quantity, a_cost, a_custody)
		end

	new_client_withdrawal (a_portfolio: RP_PORTFOLIO; a_contract_date, a_settle_date: ROSE_DATE;
		a_quantity: RP_QUANTITY; a_cost: RP_LEGACY_COST; a_custody: RP_CUSTODY): !RP_CLIENT_WITHDRAWAL is
			-- Create new client withdrawal
		require
			a_portfolio_not_void: a_portfolio /= Void
			a_contract_date_not_void: a_contract_date /= Void
			a_settle_date_not_void: a_settle_date /= Void
			a_quantity_not_void: a_quantity /= Void
			a_cost_not_void: a_cost /= Void
			a_custody_not_void: a_custody /= Void
		do
			create Result.make_withdrawal (Current, a_portfolio, a_contract_date, a_settle_date, a_quantity, a_cost, a_custody)
		end

	new_outkind (a_portfolio: RP_PORTFOLIO; a_contract_date, a_settle_date: ROSE_DATE;
		a_quantity: RP_QUANTITY; a_cost: RP_LEGACY_COST; a_custody: RP_CUSTODY): !RP_CLIENT_WITHDRAWAL is
			-- Create new outkind
		require
			a_portfolio_not_void: a_portfolio /= Void
			a_contract_date_not_void: a_contract_date /= Void
			a_settle_date_not_void: a_settle_date /= Void
			a_quantity_not_void: a_quantity /= Void
			a_cost_not_void: a_cost /= Void
			a_custody_not_void: a_custody /= Void
		do
			create Result.make_outkind (Current, a_portfolio, a_contract_date, a_settle_date, a_quantity, a_cost, a_custody)
		end

feature -- Basic Operations

	next_message: RP_CLIENT_MESSAGE is
			-- Next message
		do
			-- to_be_implemented ("")
		end

end
