note

	description:

		"Client withdrawal"

	author: "Mark Howard"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #17 $"
	path: "$File: //rose/source/kernel/expert_system/rp_client_withdrawal.e $"

class RP_CLIENT_WITHDRAWAL

inherit

	RP_CLIENT_CONTRACT

create {RP_GEDB_EVENT_TO_CONTRACT_CONVERTER}

	make_portfolio_contract

create

	make_withdrawal,
	make_outkind

feature {NONE} -- Constuctor

	make_withdrawal (a_system: like generating_system; a_portfolio: RP_PORTFOLIO;
		a_contract_date, a_settle_date: ROSE_DATE; a_quantity: RP_QUANTITY;
		a_cost: RP_LEGACY_COST; a_custody: RP_CUSTODY) is
			-- Create client withdrawal
		require
			a_system_not_void: a_system /= Void
			a_portfolio_not_void: a_portfolio /= Void
			a_contract_date_not_void: a_contract_date /= Void
			a_settle_date_not_void: a_settle_date /= Void
			a_quantity_not_void: a_quantity /= Void
			a_cost_not_void: a_cost /= Void
			a_custody_not_void: a_custody /= Void
			positive_quantity: a_quantity.amount >= 0
		do
			make_portfolio_contract (a_system, a_contract_date, a_quantity.instrument.brimsym, a_portfolio)
			populate_flow (withdrawal_flow_type, a_portfolio, a_contract_date, a_settle_date, -a_quantity, a_cost, a_custody)
		end

	make_outkind (a_system: like generating_system; a_portfolio: RP_PORTFOLIO;
		a_contract_date, a_settle_date: ROSE_DATE; a_quantity: RP_QUANTITY;
		a_cost: RP_LEGACY_COST; a_custody: RP_CUSTODY) is
			-- Create outkind
		require
			a_system_not_void: a_system /= Void
			a_portfolio_not_void: a_portfolio /= Void
			a_contract_date_not_void: a_contract_date /= Void
			a_settle_date_not_void: a_settle_date /= Void
			a_quantity_not_void: a_quantity /= Void
			a_cost_not_void: a_cost /= Void
			a_custody_not_void: a_custody /= Void
			positive_quantity: a_quantity.amount >= 0
		do
			make_portfolio_contract (a_system, a_contract_date, a_quantity.instrument.brimsym, a_portfolio)
			populate_flow (outkind_flow_type, a_portfolio, a_contract_date, a_settle_date, -a_quantity, a_cost, a_custody)
		end

feature -- Basic Operations

	process (a_processor: RP_CONTRACT_PROCESSOR) is
			-- <Precursor>
		do
			a_processor.process_client_withdrawal (Current)
		end

feature {NONE} -- Implementation

	populate_flow (a_flow_type: RP_FLOW_TYPE; a_portfolio: RP_PORTFOLIO; a_contract_date, a_settle_date: ROSE_DATE; a_quantity: RP_QUANTITY; a_cost: RP_LEGACY_COST; a_custody: RP_CUSTODY) is
			-- Add flow
		local
			l_external_holding: RP_EXTERNAL_HOLDING
		do
			create l_external_holding.make (a_quantity, a_cost.quantity, a_cost)
			add_external_holding_flow (a_flow_type, a_contract_date, a_settle_date, l_external_holding, a_portfolio.client_instrument_control, a_portfolio.instrument_control (a_custody))
		end

end
