indexing
	description: "Company"
	author: "Portfolio Accounting Tech (sm)"
	last_editor: "$Author: er $"
	date: "$Date: 2014/02/26 $"
	revision: "$Revision: #3 $"
	archive: "$File: //rose/source/kernel/expert_system/rp_company.e $"

class
	RP_COMPANY

create
	make

feature {NONE} -- Initialization

	make (a_reference_system: like reference_system; a_company: like company) is
			-- Create from 'a_company'
		require
			reference_system_not_void: a_reference_system /= Void
			company_not_void: a_company /= Void
		do
			reference_system := a_reference_system
			company := a_company
		ensure
			reference_system_set: reference_system = a_reference_system
			company_set: company = a_company
		end

feature -- Access

	name_at (a_date: ROSE_DATE): STRING is
			-- Name
		local
			l_str: STRING
			l_list: LIST [STRING]
		do
			create Result.make_empty
			l_str := company.name_at (a_date)
			if l_str /= Void then
				l_list := l_str.split (' ')
				if l_list /= Void then
					from
						l_list.start
					until
						l_list.after
					loop
						l_str := l_list.item_for_iteration
							-- First character of each word in upper case
							-- Other characters in lower case
						if l_str /= Void and then l_str.count >= 1 then
							Result.append (l_str.substring (1, 1).as_upper)
							if l_str.count > 1 then
								Result.append (l_str.substring (2, l_str.count).as_lower)
							end
						end
							-- Words separated by a blank
						Result.append (" ")
						l_list.forth
					end
				end
			end
		end

--	country_of_incorporation (a_date: ROSE_DATE): RP_COUNTRY is
--			-- Country of incorporation
--		do
--		
--		
--			-- 	create Result.make_with_country (reference_system, company.company_to_incorporation_country_history.witness (a_date))
--		end

feature {NONE} -- Implementation

	reference_system: RP_REFERENCE_SYSTEM
		-- Reference system

	company: PERSISTENT_COMPANY
		-- Company

invariant

	reference_system_not_void: reference_system /= Void
	company_not_void: company /= Void

end
