indexing

	description:

		"Processor of RP_CONTRACT descendants"

	date: "$Date: 2010/07/21 $"
	sccid: "$Id: //rose/source/kernel/expert_system/cost/rp_contract_processor.e#3 $"

class RP_CONTRACT_PROCESSOR

inherit

	ANY

	ROSE_SHARED_GLOBAL
		export {NONE} all end

feature -- Basic Operations

	process_contracts (a_contracts: ARRAY [RP_CONTRACT]) is
			-- Process all contracts in 'a_contracts'
		local
			i: INTEGER
			l_start, l_stop: DT_TIME
			l_total_start, l_total_stop: DT_TIME
		do
			if a_contracts /= Void then
				from
					i := 1
					debug ("rp_contract_processor")
						print_timestamped ("Begin contract processing%N")
						l_start := utc_system_clock.time_now
						l_total_start := l_start
					end
				until
					i > a_contracts.count
				loop
					process (a_contracts.item (i))
					debug ("rp_contract_processor")
						print (".")
						if i \\ 200 = 0 then
							l_stop := utc_system_clock.time_now
							print (i.out + "[" + (l_stop.duration (l_start).millisecond_count / 200).truncated_to_integer.out + "ms]")
							l_start := l_stop
						end
					end
					i := i + 1
				end
				debug ("rp_contract_processor")
					l_total_stop := utc_system_clock.time_now
					print_timestamped ("Done["+ (l_total_stop.duration (l_total_start).millisecond_count / 1000).truncated_to_integer.out + "s]%N")
				end
			end
		end

	process (a_contract: RP_CONTRACT) is
			-- Process 'a_contract'
		do
			if a_contract /= Void then
				a_contract.process (Current)
			end
		end

feature {RP_CONTRACT} -- Basic operations

	process_tender (a_tender: RP_TENDER) is
			-- Process 'a_tender'
		do
		end

	process_stock_bonus (a_stock_bonus: RP_STOCK_BONUS) is
			-- Process 'a_stock_bonus'
		do
		end

	process_split (a_split: RP_SPLIT) is
			-- Process 'a_split'
		do
		end

	process_rights (a_rights: RP_RIGHTS) is
			-- Process 'a_rights'
		do
		end

	process_return_of_capital (a_roc: RP_RETURN_OF_CAPITAL) is
			-- Process 'a_roc'
		do
		end

	process_redenomination (a_redenomination: RP_REDENOMINATION) is
			-- Process 'a_redenomination'
		do
		end

	process_portfolio_corporate_action_compound_contract (a_portfolio_corporate_action_compound_contract: RP_PORTFOLIO_CORPORATE_ACTION_COMPOUND_CONTRACT) is
			-- Process 'a_portfolio_corporate_action_compound_contract'
		do
		end

	process_dividend (a_dividend: RP_DIVIDEND) is
			-- Process 'a_dividend'
		do
		end

	process_delivery (a_delivery: RP_DELIVERY) is
			-- Process 'a_delivery'
		do
		end

	process_distribution (a_distribution: RP_DISTRIBUTION) is
			-- Process 'a_distribution'
		do
		end

	process_delivery_distribution (a_delivery_distribution: RP_DELIVERY_DISTRIBUTION) is
			-- Process 'a_delivery_distribution'
		do
		end

	process_income_unrelated (a_income_unrelated: RP_INCOME_UNRELATED) is
			-- Process 'a_income_unrelated'
		do
		end

	process_income (a_income: RP_INCOME) is
			-- Process 'a_income'
		do
		end

	process_expense_unrelated (a_expense_unrelated: RP_EXPENSE_UNRELATED) is
			-- Process 'a_expense_unrelated'
		do
		end

	process_expense (a_expense: RP_EXPENSE) is
			-- Process 'a_expense'
		do
		end

	process_fixed_deposit_transfer (a_fixed_deposit_transfer: RP_FIXED_DEPOSIT_TRANSFER) is
			-- Process 'a_fixed_deposit_transfer'
		do
		end

	process_mark_to_market (a_mark_to_market: RP_MARK_TO_MARKET) is
			-- Process 'a_mark_to_market'
		do
		end

	process_interest (a_interest: RP_INTEREST) is
			-- Process 'a_interest'
		do
		end

	process_inlieu (a_inlieu: RP_INLIEU) is
			-- Process 'a_inlieu'
		do
		end

	process_dividend_reinvestment (a_dividend_reinvestment: RP_DIVIDEND_REINVESTMENT) is
			-- Process 'a_dividend_reinvestment'
		do
		end

	process_cash_swept_from_interest (a_cash_swept_from_interest: RP_CASH_SWEPT_FROM_INTEREST) is
			-- Process 'a_cash_swept_from_interest'
		do
		end

	process_cash_swept_from_income (a_cash_swept_from_income: RP_CASH_SWEPT_FROM_INCOME) is
			-- Process 'a_cash_swept_from_income'
		do
		end

	process_cash_swept_from_dividend (a_cash_swept_from_dividend: RP_CASH_SWEPT_FROM_DIVIDEND) is
			-- Process 'a_cash_swept_from_dividend'
		do
		end

	process_collateral (a_collateral: RP_COLLATERAL) is
			-- Process 'a_collateral'
		do
		end

	process_client_withdrawal (a_client_withdrawal: RP_CLIENT_WITHDRAWAL) is
			-- Process 'a_client_withdrawal'
		do
		end

	process_client_contribution (a_client_contribution: RP_CLIENT_CONTRIBUTION) is
			-- Process 'a_client_contribution'
		do
		end

	process_cash_zonal_tranfer (a_cash_zonal_tranfer: RP_CASH_ZONAL_TRANSFER) is
			-- Process 'a_cash_zonal_transfer'
		do
		end

	process_short (a_short: RP_SHORT) is
			-- Process 'a_short'
		do
		end

	process_sell (a_sell: RP_SELL) is
			-- Process 'a_sell'
		do
		end

	process_buy (a_buy: RP_BUY) is
			-- Process 'a_buy'
		do
		end

	process_cover (a_cover: RP_COVER) is
			-- Process 'a_cover'
		do
		end

	process_intraday_sell_to_adjust_gl (a_intraday_sell_to_adjust_gl: RP_INTRA_DAY_SELL_TO_ADJUST_GL) is
			-- Process 'a_intraday_sell_to_adjust_gl'
		do
		end

	process_fx (a_fx: RP_FX) is
			-- Process 'a_fx'
		do
		end

	process_ffx_open (a_ffx_open: RP_FFX_OPEN) is
			-- Process 'a_ffx_open'
		do
		end

	process_ffx_close (a_ffx_close: RP_FFX_CLOSE) is
			-- Process 'a_ffx_close'
		do
		end

	process_futures_short (a_futures_short: RP_FUTURES_SHORT) is
			-- Process 'a_futures_short'
		do
		end

	process_futures_sell (a_futures_sell: RP_FUTURES_SELL) is
			-- Process 'a_futures_sell'
		do
		end

	process_futures_cover (a_futures_cover: RP_FUTURES_COVER) is
			-- Process 'a_futures_cover'
		do
		end

	process_futures_buy (a_futures_buy: RP_FUTURES_BUY) is
			-- Process 'a_futures_buy'
		do
		end

	process_ffx_gain_loss (a_ffx_gain_loss: RP_FFX_GAIN_LOSS) is
			-- Process 'a_ffx_gain_loss'
		do
		end

	process_bank_transfer (a_bank_transfer: RP_BANK_TRANSFER) is
			-- Process 'a_bank_transfer'
		do
		end

	process_income_unrelated_adjustment (a_income_unrelated_adjustment: RP_INCOME_UNRELATED_ADJUSTMENT) is
			-- Process 'a_income_unrelated_adjustment'
		do
		end

	process_income_adjustment (a_income_adjustment: RP_INCOME_ADJUSTMENT) is
			-- Process 'a_income_adjustment'
		do
		end

	process_expense_unrelated_adjustment (a_expense_unrelated_adjustment: RP_EXPENSE_UNRELATED_ADJUSTMENT) is
			-- Process 'a_expense_unrelated_adjustment'
		do
		end

	process_expense_adjustment (a_expense_adjustment: RP_EXPENSE_ADJUSTMENT) is
			-- Process 'a_expense_adjustment'
		do
		end

	process_dividend_tax_refund (a_dividend_tax_refund: RP_DIVIDEND_TAX_REFUND) is
			-- Process 'a_dividend_tax_refund'
		do
		end

	process_credit_default_swap_payment (a_credit_default_swap_payment: CREDIT_DEFAULT_SWAP_PAYMENT) is
			-- Process 'a_credit_default_swap_payment'
		do
		end

feature {NONE} -- Implementation

	utc_system_clock: DT_UTC_SYSTEM_CLOCK
			-- UTC system clock
		once
			create Result.make
		ensure
			utc_system_clock_not_void: Result /= Void
		end

end
