note

	description:

		"Bonus in other capact to contract generator"

	author: "Xavier Ragot"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #9 $"
	path: "$File: //rose/source/Kernel/capital_actions/elections/rp_corporate_action_election_bonus_in_other.e $"

class RP_CORPORATE_ACTION_ELECTION_BONUS_IN_OTHER

inherit

	RP_CORPORATE_ACTION_ELECTION [CAPACT_BONUS_IN_OTHER_EXPRESSION, RP_STOCK_DIVIDEND]

create

	make

feature -- Access

	contract (a_idate: ROSE_DATE; a_portfolio: RP_PORTFOLIO; a_holding: RP_QUANTITY): RP_STOCK_DIVIDEND is
			-- <Precursor>
		local
			l_new_shares: RP_QUANTITY
			l_bonus_in_other: like bonus_in_other
		do
			if not a_holding.amount.is_zero then
				if (capact.other_entity /= Void) and then (capact.other_entity.brim_code (event_date (a_portfolio)) /= Void) then
					l_bonus_in_other := bonus_in_other
					if l_bonus_in_other = Void then
						l_bonus_in_other := a_holding.instrument.quantity (0)
					end
						-- create a bonus in same
					l_new_shares := l_bonus_in_other.instrument.quantity (a_holding.amount * l_bonus_in_other.amount)
					create {RP_STOCK_DIVIDEND} Result.make (l_new_shares, a_holding, event_date (a_portfolio), settle_date (a_portfolio), a_portfolio, unique_identifier, processing_system, unknown_custody)
				else
					manager.log_minor ("*** ERROR processing " + generator + " " + a_holding.instrument.brimsym + " on " + capact.exdate.ccyymmdd.out)
					(create {EXCEPTIONS}).raise ("*** ERROR processing " + generator + " " + a_holding.instrument.brimsym + " on " + capact.exdate.ccyymmdd.out)
				end
			end
		end

feature {NONE} -- Implementation

	bonus_in_other: RP_QUANTITY is
			-- Bonus in other instrument
		do
			if (other_instrument /= Void) and then (other_instrument.brimsym /= Void) then
				Result := capact.bonus (manager.reference_system)
			end
		end

	other_instrument: RP_INSTRUMENT is
			-- Other instrument
		do
			Result := capact.other_instrument (manager.reference_system)
		end

end
