note

	description:

		"Bonus in same capact to contract generator"

	author: "Xavier Ragot"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #10 $"
	path: "$File: //rose/source/Kernel/capital_actions/elections/rp_corporate_action_election_bonus_in_same.e $"

class RP_CORPORATE_ACTION_ELECTION_BONUS_IN_SAME

inherit
	RP_CORPORATE_ACTION_ELECTION [CAPACT_BONUS_IN_SAME_EXPRESSION, RP_STOCK_DIVIDEND]

create

	make

feature -- Access

	contract (a_idate: ROSE_DATE; a_portfolio: RP_PORTFOLIO; a_holding: RP_QUANTITY): RP_STOCK_DIVIDEND is
			-- action of this corporate action on the portfolio
		local
			l_new_shares: RP_QUANTITY
			l_decimal: RP_DECIMAL
			l_bonus_in_same: like bonus
		do
				-- FIXME: this is probably handled in the distributions
			if not a_holding.amount.is_zero then
					-- create a bonus in same
				l_bonus_in_same := bonus (a_holding.instrument)
				l_decimal := a_holding.amount * l_bonus_in_same.amount
				if a_portfolio.zone.is_united_states then
					l_decimal := l_decimal.rounded (2)
						-- side effect of storage in the event files
				else
					l_decimal := l_decimal.truncated
				end
				l_new_shares := l_bonus_in_same.instrument.quantity (l_decimal)
				create {RP_STOCK_DIVIDEND} Result.make (l_new_shares, a_holding, event_date (a_portfolio), event_date (a_portfolio), a_portfolio, unique_identifier, processing_system, unknown_custody)
			end
		end

feature -- Access

	bonus (a_instrument: RP_INSTRUMENT): RP_QUANTITY is
			-- Bonus from capact 'delta_new_shares'
		require
			instrument_not_void: a_instrument /= Void
		do
			Result := a_instrument.quantity (capact.delta_new_shares)
		end

end
