note

	description:

		"Cash distribution capact to contract generator"

	author: "Xavier Ragot"
	last_editor: "$Author: er $"
	date: "$Date: 2013/01/30 $"
	revision: "$Revision: #12 $"
	path: "$File: //rose/source/Kernel/capital_actions/elections/rp_corporate_action_election_cash_distribution.e $"

class RP_CORPORATE_ACTION_ELECTION_CASH_DISTRIBUTION

inherit

	RP_CORPORATE_ACTION_ELECTION [CAPACT_LEGACY_DISTRIBUTION_EXPRESSION, RP_DISTRIBUTION]
		redefine
			make
		end

create

	make

feature {NONE} -- Initialization
	-- FIXME: this is a hack for Simulations because we don't have a source for CAPACT

	make (a_processing_system: like processing_system; a_capact: like capact) is
			-- <Precursor>
		do
			Precursor (a_processing_system, a_capact)
			units := capact.child_units
			currency := capact.child_cash
		end

feature -- Access

	contract (a_idate: ROSE_DATE; a_portfolio: RP_PORTFOLIO; a_holding: RP_QUANTITY): RP_DISTRIBUTION is
			-- <Precursor>
		local
			l_cash_effect: RP_MONIES
			l_cash_distribution_per_share: RP_MONIES
			l_perf_effect: RP_MONIES
		do
			if not a_holding.amount.is_zero then
					-- cash_effect is shares * distribution/share
				check
					child_is_cash: capact.child_is_cash
				end
				l_cash_distribution_per_share := cash_distribution_per_share (a_holding.instrument)
					-- Cash effect
				l_cash_effect := l_cash_distribution_per_share.currency.monies (a_holding.amount * l_cash_distribution_per_share.amount)
				round (a_portfolio.zone.is_japan, l_cash_effect)
					-- PerfEffect/Value/Cost
					-- FIXME: PerfEffect can be overriden by distibutions override
				l_perf_effect := l_cash_effect.currency.monies (l_cash_effect.amount * capact.legacy_basis_prop)
				round (a_portfolio.zone.is_japan, l_perf_effect)
				create Result.make_long_position (a_holding, l_cash_effect, l_perf_effect, event_date (a_portfolio), settle_date (a_portfolio), a_portfolio, unique_identifier, processing_system, unknown_custody)
			end
		end

feature -- Access

	units: RP_DECIMAL
			-- Units

	currency: CURRENCY
			-- Currency

feature {NONE} -- Implementation

	round (a_japan: BOOLEAN; d: RP_MONIES) is
			-- Round `d'
		do
			if a_japan then
				if not (d.amount - d.amount.truncated).abs.is_zero then
					d.round (0)
				end
			else
				d.round (2)
			end
		end

	cash_distribution_per_share (a_instrument: RP_INSTRUMENT): RP_MONIES is
			-- Cash distribution per share
		do
			Result := child_cash_currency (a_instrument).monies (units)
		end

	child_cash_currency (a_instrument: RP_INSTRUMENT): RP_CURRENCY is
			-- Currency
		do
			Result := rp_currency_inferred (reference_system, a_instrument, iso_from_currency (currency))
		end

feature {NONE} -- Change

	set_units (a_units: like units) is
			-- Set 'units' to 'a_units'
		do
			units := a_units
		ensure
			units_set: units.is_equal (a_units)
		end

	set_currency (a_currency: like currency) is
			-- Set 'currency' like 'a_currency'
		do
			currency := a_currency
		ensure
			currency_set: currency.is_equal (a_currency)
		end

end
