note

	description:

		"Delivery capact to contract generator"

	author: "Xavier Ragot"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #13 $"
	path: "$File: //rose/source/Kernel/capital_actions/elections/rp_corporate_action_election_delivery.e $"

class RP_CORPORATE_ACTION_ELECTION_DELIVERY

inherit

	RP_CORPORATE_ACTION_ELECTION [CAPACT_LEGACY_DISTRIBUTION_EXPRESSION, RP_DELIVERY]

create

	make

feature -- Access

	contract (a_idate: ROSE_DATE; a_portfolio: RP_PORTFOLIO; a_holding: RP_QUANTITY): RP_DELIVERY is
			-- <Precursor>
		local
			l_perf_effect: RP_MONIES
		do
			if not a_holding.amount.is_zero then
					-- perf_effect is shares * distribution/share
				check
					child_is_parent: capact.child_is_parent
				end
				l_perf_effect := perf_effect (a_holding.instrument)
				l_perf_effect := l_perf_effect.currency.monies (a_holding.amount * l_perf_effect.amount)
				if a_holding.amount >= 0 then
					create Result.make_long_position (a_holding, a_holding, l_perf_effect, event_date (a_portfolio), settle_date (a_portfolio), a_portfolio, unique_identifier, processing_system, unknown_custody)
				else
					create Result.make_short_position (a_holding, a_holding, l_perf_effect, event_date (a_portfolio), settle_date (a_portfolio), a_portfolio, unique_identifier, processing_system, unknown_custody)
				end
			end
		end

feature {NONE} -- Implementation

	units_distribution_per_share (a_instrument: RP_INSTRUMENT): RP_QUANTITY is
			-- Units distribution per share
		do
			Result := a_instrument.quantity (capact.child_units)
		end

	perf_effect (a_instrument: RP_INSTRUMENT): RP_MONIES is
			-- Perf effect
		do
			Result := perf_effect_currency (a_instrument).monies (capact.legacy_basis_price)
		end

	perf_effect_currency (a_instrument: RP_INSTRUMENT): RP_CURRENCY is
			-- Perf effect currency
		do
			Result := rp_currency_inferred (reference_system, a_instrument, capact.legacy_basis_currency)
		end

end
