note

	description:

		"Stock dividend capact to contract generator"

	author: "Xavier Ragot"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #11 $"
	path: "$File: //rose/source/Kernel/capital_actions/elections/rp_corporate_action_election_stock_div.e $"

class RP_CORPORATE_ACTION_ELECTION_STOCK_DIV

inherit

	RP_CORPORATE_ACTION_ELECTION [CAPACT_STOCK_DIVIDEND_EXPRESSION, RP_DIVIDEND]

	RP_ROUNDING_DISTRIBUTIONS_AWARE
		export {NONE} all end

	RP_OVERRIDE_DISTRIBUTIONS_AWARE
		export {NONE} all end

create

	make

feature -- Access

	contract (a_idate: ROSE_DATE; a_portfolio: RP_PORTFOLIO; a_holding: RP_QUANTITY): RP_DIVIDEND is
			-- <Precursor>
		local
			l_shares_held, l_shares_increment: RP_DECIMAL
			l_rounding: RP_ROUNDING_DISTRIBUTIONS_PARM
			l_contract_units, l_contract_units_based: RP_DECIMAL
			l_contract_index: INTEGER
			l_contract_settle_date, l_contract_event_date: ROSE_DATE
			l_override: RP_OVERRIDE_DISTRIBUTIONS_PARM
		do
				-- See the splits for a more detailed explanation about how this is computed
			if a_holding.amount.abs >= 1 then
					-- Retrieve old shares
				l_shares_held := a_holding.amount
				l_shares_increment := (capact.adjustment_factor - 1) * l_shares_held
				if a_portfolio.zone.is_japan then
					l_shares_increment := l_shares_increment.rounded (2)
				end
				l_rounding := rounding_distributions.rounding (a_portfolio.zone, a_idate, a_holding.instrument)
				if l_rounding /= Void then
					l_contract_units := l_rounding.round (l_shares_increment)
				else
					l_shares_increment := l_shares_increment.truncated
					l_contract_units := l_shares_increment
				end
					-- Set values for the new flows
				l_contract_units := l_shares_increment
				l_contract_units_based := l_shares_held
					-- Set contract index (UID)
					-- FIXME: this needs to be a sequence number for legacy events - doesn't have to be generated here
				l_contract_index := 0
				l_contract_event_date := a_idate
				l_contract_settle_date := a_idate
					-- Handle overrides
				l_override := override_distribution (a_portfolio.zone, a_holding.instrument.brimsym, split_event_type_4, a_idate, a_portfolio.code)
				if (l_override /= Void) and then (not l_override.shares1.is_zero) and then (l_override.cost_basis1.is_zero) then
					l_shares_increment := l_override.shares1
					l_contract_units := l_override.shares1.rounded (0) + l_shares_held
					l_contract_units_based := l_shares_held
				end
					-- Force to empty - this will override the old split
				if (l_override /= Void) and then (l_override.shares1.is_zero) and then (l_override.cost_basis1.is_zero) then
					l_contract_units := 0
				end
				create {RP_STOCK_DIVIDEND} Result.make (a_holding.instrument.quantity (l_contract_units), a_holding.instrument.quantity (l_contract_units_based), l_contract_event_date, l_contract_settle_date, a_portfolio, unique_identifier, processing_system, unknown_custody)
			end
		end

end
