note

	description:

		"Units distribution capact to contract generator"

	author: "Xavier Ragot"
	last_editor: "$Author: e2 $"
	date: "$Date: 2012/02/23 $"
	revision: "$Revision: #14 $"
	path: "$File: //rose/source/Kernel/capital_actions/elections/rp_corporate_action_election_units_distribution.e $"

class RP_CORPORATE_ACTION_ELECTION_UNITS_DISTRIBUTION

inherit

	RP_CORPORATE_ACTION_ELECTION [CAPACT_LEGACY_DISTRIBUTION_EXPRESSION, RP_DISTRIBUTION]

create

	make

feature -- Access

	contract (a_idate: ROSE_DATE; a_portfolio: RP_PORTFOLIO; a_holding: RP_QUANTITY): RP_DISTRIBUTION is
			-- <Precursor>
		local
			l_perf_effect: RP_MONIES
			l_new_units: RP_QUANTITY
			l_units_distribution_per_share: like units_distribution_per_share
		do
			if not a_holding.amount.is_zero then
					-- create a distribution
					-- perf_effect is shares * distribution/share
				l_perf_effect := perf_effect (a_holding.instrument)
				l_units_distribution_per_share := units_distribution_per_share
				l_perf_effect := l_perf_effect.currency.monies (a_holding.amount * l_units_distribution_per_share.amount * l_perf_effect.amount)
				l_new_units := l_units_distribution_per_share.instrument.quantity (l_units_distribution_per_share.amount * a_holding.amount)
				if a_portfolio.zone.is_canada then
					l_new_units.round (0)
				elseif a_portfolio.zone.is_south_america then
					l_new_units.truncate
				end
				if (a_holding.amount >= 0) then
					create Result.make_long_position (a_holding, l_new_units, l_perf_effect, event_date (a_portfolio), settle_date_without_work_day_enforcement (a_portfolio), a_portfolio, unique_identifier, processing_system, unknown_custody)
				else
					create Result.make_short_position (a_holding, l_new_units, l_perf_effect, event_date (a_portfolio), settle_date_without_work_day_enforcement (a_portfolio), a_portfolio, unique_identifier, processing_system, unknown_custody)
				end
			end
		end

	child_instrument: RP_INSTRUMENT is
			-- Child instrument
		do
			Result := reference_system.instrument_from_brimsym (brimsym_from_listing (capact.child_instrument, capact.exdate))
		end

feature {NONE} -- Implementation

	units_distribution_per_share: RP_QUANTITY is
			-- Units distribution per share
		do
			Result := child_instrument.quantity (capact.child_units)
		end

	perf_effect (a_instrument: RP_INSTRUMENT): RP_MONIES is
			-- Perf effect
		do
			Result := perf_effect_currency (a_instrument).monies (capact.legacy_basis_price)
		end

	perf_effect_currency (a_instrument: RP_INSTRUMENT): RP_CURRENCY is
			-- Perf effect currency
		do
			Result := rp_currency_inferred (reference_system, a_instrument, capact.legacy_basis_currency)
		end

end
