indexing

	description:

		"Currency forward instrument"

	date: "$Date: 2010/07/19 $"
	sccid: "$Id: //rose/source/kernel/expert_system/aflows/rp_currency_forward.e#15 $"

class RP_CURRENCY_FORWARD

inherit

	RP_FORWARD [RP_CURRENCY]
		rename
			underlying as currency
		redefine
			is_forward
		end

create {RP_REFERENCE_SYSTEM}

	make

feature {NONE} -- Initialization

	make (a_brimsym: like brimsym; a_currency: RP_CURRENCY; a_settlement_date: ROSE_DATE) is
			-- Initialize `Current'.
		require
			non_void_args: a_brimsym /= Void and a_currency /= Void and a_settlement_date /= Void
		local
			l_date_units: ROSE_DATE_UNITS
		do
			currency := a_currency
			settlement_date := a_settlement_date
			l_date_units := currency.units_environment.date_units (settlement_date)
			rose_units := currency.units / l_date_units
			brimsym := a_brimsym
			name := brimsym
		end

feature -- Access

	brimsym: STRING
			-- BRIMSYM identifier.

	settlement_date: ROSE_DATE
			-- Was declared in RP_CURRENCY_FORWARD as synonym of `trade_date'.

	name: STRING
			-- Descriptive name.

	holding_value_in_currency (a_holding: RP_HOLDING; a_valuator: RP_HOLDING_VALUATOR; a_currency: RP_CURRENCY; a_date: ROSE_DATE; a_bucket: STRING): RP_MONIES is
			-- Value of `a_holding' on `a_date' in `a_currency' as computed by `a_valuator'
		do
			Result := a_valuator.forward_value_in_currency (a_holding, a_currency, a_date, a_bucket)
		end

	country_of_issue (a_ref_system: RP_REFERENCE_SYSTEM; a_date: ROSE_DATE): RP_COUNTRY is
			-- Country of issue
		do
			Result := currency.country_of_issue (a_ref_system, a_date)
		end

	is_forward: BOOLEAN is
			-- is it forward
		do
			Result := True
		end

end -- class RP_CURRENCY_FORWARD
