indexing

	description:

		"Future currency (the cash side in a futures contract)"

	date: "$Date: 2010/07/19 $"
	revision: "$Revision: #8 $"

class RP_CURRENCY_FUTURE

inherit

	RP_FUTURE [RP_CURRENCY]
		rename
			underlying as currency
		end

create {RP_REFERENCE_SYSTEM}

	make

feature {NONE} -- Initialization

	make (a_brimsym: like brimsym; a_currency: like currency; a_contract_size: like contract_size; a_maturity_date: like maturity_date; a_future_symbol: STRING) is
			-- Initialize `Current'.
		require
			non_void_args: a_currency /= Void
		do
			currency := a_currency
			maturity_date := a_maturity_date
			rose_units := currency.units / currency.units_environment.date_units (maturity_date)
			brimsym := a_brimsym
			contract_size := a_contract_size
			name := brimsym
		end

feature -- Access

	name: STRING
			-- name

	brimsym: STRING
			-- brimsym

feature {NONE} -- Implementation

	holding_value_in_currency (a_holding: RP_HOLDING; a_valuator: RP_HOLDING_VALUATOR; a_currency: RP_CURRENCY; a_date: ROSE_DATE; a_bucket: STRING): RP_MONIES is
			-- Value of `a_holding' on `a_date' in `a_currency' as computed by `a_valuator'
		do
			Result := a_valuator.currency_future_value_in_currency (a_holding, a_currency, a_date, a_bucket)
		end

	country_of_issue (a_ref: RP_REFERENCE_SYSTEM; a_date: ROSE_DATE): RP_COUNTRY is
			-- country
		do
			Result := a_ref.country_from_iso_code (name.substring (2, 3))
		end

end
