indexing
	description: "[
		Identified account with a custodian
		This could represent a regular custodian account but also the fact that the client did an outkind of the shares.
		In that case the custodian would be unknown.
		]"
	author: "Sami Ben Grine"
	last_editor: "$Author: sm $"
	date: "$Date: 2009/04/22 $"
	revision: "$Revision: #1 $"
	archive: "$File: //rose/source/kernel/expert_system/rp_custodial_account.e $"

class
	RP_CUSTODIAL_ACCOUNT

inherit

	RP_ACCOUNT

create

	make

feature {NONE} -- Initialization

	make (a_custodian: like custodian; a_code: like code) is
			-- Create 'Current' with 'a_custodian' and 'a_code' identifier
		require
			non_void_args: a_custodian /= Void and a_code /= Void
		do
			custodian := a_custodian
			code := a_code
		ensure
			custodian_set: custodian = a_custodian
			account_set: code = a_code
		end

feature -- Access

	custodian: RP_PARTY
		-- Custodian

	code: STRING
		-- Account identifier

feature -- Change

	set_code (a_code: like code) is
			-- <Precursor>
		do
			code := a_code
		end


invariant

	non_void_custodian: custodian /= Void
	non_void_code: code /= Void

end
