note

	description:

		"Relationship between custodian and something under custody"

	author: "Ivan Tarnavsky"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #7 $"
	path: "$File: //rose/source/kernel/expert_system/rp_custody.e $"

class RP_CUSTODY

inherit

	HASHABLE
		redefine
			is_equal
		end

create

	make

feature {NONE} -- Initialization

	make (a_custodian: like custodian; a_account: like account) is
			-- Create 'Current' with 'a_custodian' and 'a_account'
		require
			a_custodian_not_void: a_custodian /= Void
			a_account_not_void: a_account /= Void
		do
			custodian := a_custodian
			account := a_account
		ensure
			custodian_set: custodian = a_custodian
			account_set: account = a_account
		end

feature -- Hash

	hash_code: INTEGER is
			-- <Precusor>
		local
			l_key: STRING
		do
			l_key := custodian.code + account.code + account.custodian.code
			if custodian.name /= Void then
				l_key.append (custodian.name)
			end
			if account.custodian.name /= Void then
				l_key.append (account.custodian.name)
			end
			Result := l_key.hash_code
		end

feature -- Equality tester

	is_equal (a_other: like Current): BOOLEAN is
			-- Equality tester
		do
			Result := custodian ~ a_other.custodian and
				account ~ a_other.account
		end
feature -- Access

	custodian: RP_PARTY
			-- Custodian/guardian

	account: RP_CUSTODIAL_ACCOUNT
			-- Account at the custodian

invariant

	custodian_not_void: custodian /= Void
	account_not_void: account /= Void

end
