indexing
	description: "Data-grid cell"
	author: "Mark Howard"
	date: "$Date: 2009/03/31 $"
	revision: "$Revision: #4 $"

class
	RP_DATA_GRID_CELL [G]

inherit
	COMPARABLE
		redefine
			is_equal
		end

create
	make

feature {NONE} -- Implementation

	make (a_data: like data; a_node: like node; a_string: like string; a_item: like item) is
			-- Creation procedure.
		do
			data := a_data
			node := a_node
			string := a_string
			item := a_item
		end

feature -- Access

	data: ANY
	node: RP_GRID_NODE[G]
	string: STRING
	item: EV_GRID_ITEM
	matches_filter: BOOLEAN

	infix "<" (a_other: like Current): BOOLEAN is
			-- Is current object less than `other'?
		local
			l_label,l_other_label: EV_GRID_LABEL_ITEM
			l_comparable,l_other_comparable: COMPARABLE
		do
			if matches_filter /= a_other.matches_filter then
				Result := matches_filter
			else
				l_label ?= item
				l_other_label ?= a_other.item
				l_comparable ?= data
				l_other_comparable ?= a_other.data
				if l_label /= Void and l_other_label /= Void then
					if l_label.text /= Void and l_other_label.text /= Void then
						if l_label.text < l_other_label.text then
							Result := True
						elseif l_label.text.is_equal (l_other_label.text) then
							if l_label.pixmap = void and l_other_label.pixmap /= Void then
								Result := True
							end
						end
					elseif l_label.text = Void then
						if l_other_label.text /= Void  then
							Result := True
						else
							if l_label.pixmap = void and l_other_label.pixmap /= Void then
								Result := True
							end
						end
					end
				elseif l_comparable /= Void and then l_other_comparable /= Void and then l_comparable.same_type (l_other_comparable) then
						if l_comparable < l_other_comparable then
							Result := True
						end
				elseif string < a_other.string then
					Result := True
				end
			end
		end

	is_equal (a_other: like Current): BOOLEAN is
			-- Is `a_other' attached to an object considered equal to current object?
		local
			l_label, l_other_label: EV_GRID_LABEL_ITEM
		do
			Result := Precursor (a_other)
			if Result then
				l_label ?= item
				l_other_label ?= a_other.item
				if l_label /= Void and then l_other_label /= Void and then l_label.pixmap /= Void and then l_other_label.pixmap /= Void then
					if l_label.pixmap /= l_other_label.pixmap then
						Result := False
					end
				end
			end
		end

feature -- Basic operations

	set_matches_filter (a_value: BOOLEAN) is
			-- Set 'matches_filter'.
		do
			matches_filter := a_value
		end

end
