indexing
	description: "Objects that represent data grid combo items."
	author: "Julian Rogers"
	date: "$Date: 2013/04/24 $"
	revision: "$Revision: #12 $"

class
	RP_DATA_GRID_COMBO_ITEM

inherit
	RP_DATA_GRID_ITEM
		undefine
			create_interface_objects,
			is_tab_navigatable
		redefine
			initialize,
			implementation
		end
	EV_GRID_COMBO_ITEM
		redefine
			initialize,
			implementation,
			make_with_text
		end

create
	default_create,
	make_from_ev_grid_item,
	make_with_text

feature {NONE} -- Initialization

	initialize is
		do
			Precursor {EV_GRID_COMBO_ITEM}
			select_actions.extend (agent set_key_press_agent)
		end

	make_with_text (a_text: attached STRING) is
		do
			default_create
			set_text (a_text)
		end

	make_from_ev_grid_item (a_item : EV_GRID_ITEM) is
		local
			l_combo : EV_GRID_COMBO_ITEM
		do
			default_create
			l_combo ?= a_item
			if l_combo /= Void then
				if l_combo.text /= Void then
					set_text (l_combo.text)
				end
				if l_combo.item_strings /= Void then
					set_item_strings (l_combo.item_strings)
				end
			end
		end

feature -- Access

	is_editable: BOOLEAN is True
			-- Is this item editable?

	retrieve_widget is
		do
		end

feature {NONE} -- Implementation

	set_key_press_agent is
		local
			l_combo : EV_COMBO_BOX
		do
			l_combo ?= gui.ev_application.focused_widget
			if l_combo /= Void then
				l_combo.key_press_actions.extend (agent key_press_to_grid (?))
				l_combo.set_background_color (create {EV_COLOR}.make_with_8_bit_rgb (222,255,222))
				l_combo.select_all
			end
		end

	key_press_to_grid (a_key : EV_KEY) is
		local
			l_row : RP_GRID_NODE [ANY]
		do
			l_row ?= row.data
			l_row.grid.handle_key_press (a_key)
		end

feature {EV_ANY, EV_ANY_I} -- Implementation

	implementation: attached EV_GRID_LABEL_ITEM_I

end
