indexing
	description: ""
	author: ""
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #18 $"
	archive: "$File: //rose/source/kernel/infrastructure/widgets/grid/rp_data_grid_filter_gui.e $"

class
	RP_DATA_GRID_FILTER_GUI [G]

inherit
	EV_VERTICAL_BOX
		rename
			height as ev_vertical_box_height
		redefine
			set_focus
		end
	RP_DATA_GRID_ACCESS
		undefine
			default_create, copy, is_equal
		end

create
	make

feature {RP_DATA_GRID_ACCESS} -- Initialization

	make (a_column : INTEGER;a_node : RP_GRID_TITLE_NODE [G];a_container : EV_CONTAINER) is
		local
			l_node: RP_GRID_NODE [G]
			l_nodes: ROSE_LINEAR_ARRAY [RP_GRID_NODE [G]]
		do
			default_create
			focus_in_actions.extend (agent set_is_editing (False))
			set_background_color (white)
			column := a_column
			title_node := a_node
			container := a_container
			create filter_button.make_with_text ("Filter")
			filter_button.set_background_color (lt_green)
			filter_button.align_text_left
			filter_button.pointer_button_press_actions.extend (agent on_filter_button_click)
			create regex_field.make_with_text (regex_string)
			regex_field.pointer_button_press_actions.start
			regex_field.return_actions.extend (agent filter)
			create l_nodes.make_empty
			create l_node.make_from_array (<<filter_button>>)
			l_nodes.extend (l_node)
			create l_node.make_from_array (<<regex_field>>)
			l_nodes.extend (l_node)
			create controls.make (<<>>, l_nodes)
			controls.set_is_header_shown (False)
			controls.key_press_actions.extend (agent handle_key_press)

			controls.focus_in_actions.extend (agent set_is_editing (False))
			extend (controls)
			disable_item_expand (controls)
		end

	on_filter_button_click (a_x,a_y,a_button: INTEGER; a_x_tilt,a_y_tilt,a_pressure: DOUBLE; a_screen_x,a_screen_y: INTEGER)	is
		do
			filter
		end
	on_select_label_click (a_x,a_y,a_button: INTEGER; a_x_tilt,a_y_tilt,a_pressure: DOUBLE; a_screen_x,a_screen_y: INTEGER)	is
		do
			show_items
		end
	set_is_editing (a_bool : BOOLEAN) is
		do
			is_editing := a_bool
		end

	filter_from_item_select  is--(a_x,a_y,a_button: INTEGER; a_x_tilt,a_y_tilt,a_pressure: DOUBLE; a_screen_x,a_screen_y: INTEGER) is
		do
			if not gui.ev_application.ctrl_pressed then
				filter
			end
		end


	filter is
		local
			l_array : ROSE_LINEAR_ARRAY [RP_DATA_GRID_CELL [G]]
			l_selected : ROSE_LINEAR_ARRAY [RP_DATA_GRID_ITEM]
			l_grid: RP_DATA_GRID [G]
		do
			if regex_string.is_equal (regex_field.text) then
				regex_field.set_text ("")
			end
			if title_node.grid.is_title_grid then
				l_grid := title_node.grid.parent_grid
			else
				l_grid := title_node.grid
			end
			if regex_field.text /= Void and then regex_field.text.count > 0 then
				title_node.set_regular_expression(regex_field.text)
				title_node.update_sort_states_on_click (column)
				title_node.sort
			elseif items_grid /= Void and then not items_grid.selected_nodes.is_empty then
				l_selected := selected_items
				create l_array.make_empty
				from l_selected.start until l_selected.off loop
					l_array.extend (l_grid.item_info_object (l_selected.current_item))
					l_selected.forth
				end
				l_grid.set_items_to_filter_on (l_array)
				title_node.update_sort_states_on_click (column)
				title_node.sort
			end
			if not is_destroyed and not container.is_destroyed then
				container.destroy
			end
			l_grid.items_to_filter_on.wipe_out
			l_grid.set_regex_string ("")
		end

	set_heights is
		do
			items_grid.set_minimum_height (items_grid.total_row_height)
			controls.set_minimum_height (controls.total_row_height)
			set_minimum_height (items_grid.height + controls.height)
		end

	height : INTEGER is
		do
			Result := controls.total_row_height + items_grid.total_row_height
		end


	selected_items : ROSE_LINEAR_ARRAY [RP_DATA_GRID_ITEM] is
		local
			i : INTEGER
			l_row : RP_GRID_NODE [G]
			l_nodes : ARRAYED_LIST [RP_GRID_NODE [G]]
		do
			l_nodes := items_grid.selected_nodes
			create Result.make_empty
			from i := 1 until i > l_nodes.count loop
				l_row := l_nodes.i_th (i)
				Result.extend (l_row.i_th (1))
				i := i + 1
			end

		end
	clear_items_grid_selection is
		do
			if items_grid /= Void then
				items_grid.remove_selection
			end
		end

	show_items is
		local
			i, j : INTEGER
			l_rows : ARRAY [ARRAY [ANY]]
			l_row, l_prev_row : RP_GRID_NODE [G]
			l_items : ARRAY [ANY]
			l_item,l_last_any,l_any : ANY
			l_text : STRING
			l_containable : EV_CONTAINABLE
			l_textable : EV_TEXTABLE
			l_label_item,l_new_label_item : EV_GRID_LABEL_ITEM
			l_ev_row : EV_GRID_ROW
			l_label, l_prev_label : EV_GRID_LABEL_ITEM
			l_last_text: STRING
			l_grid_node: RP_GRID_NODE [G]
			l_row_lower, l_row_upper: INTEGER
			l_grid: RP_DATA_GRID [G]
		do
			if items_grid = Void then
				create l_rows.make (1,0)
				create l_items.make (1,0)
				l_items.compare_objects
				title_node.update_sort_states_on_click (column)
				title_node.sort
				l_last_any := "Void"
				if title_node.grid.is_title_grid then
					l_grid := title_node.grid.parent_grid
					l_row_lower := 1
					l_row_upper := l_grid.row_count
				else
					l_row_lower := title_node.index + 1
					l_row_upper := l_row_lower + title_node.parent_row.subrow_count_recursive - 2
					l_grid := title_node.grid
				end
			from i := l_row_lower until i > l_row_upper loop
					l_row := l_grid.row (i).twin
					l_ev_row := l_grid.row (i).row
					l_row.saved_items_wipe_out -- this forces l_row.i_th to create a new RP_DATA_GRID_ITEM from its display function array
					l_item := l_row.i_th (column)
					if l_item /= void then
						l_any := l_row.i_th (column).data
					else
						l_any := "Void"
					end
					l_containable ?= l_item
					if l_containable /= Void then
						l_textable ?= l_item
						l_label_item ?= l_item
						if l_textable /= Void and then l_textable.text /= Void then
							l_item := l_textable.text
						elseif l_label_item /= Void then
							if l_label_item.text /= Void then
								l_text := l_label_item.text
							else
								l_text := ""
							end
							create l_new_label_item.make_with_text (l_text)
							if l_label_item.pixmap /= Void then
								l_new_label_item.set_pixmap (l_label_item.pixmap)
							end
							l_item := l_new_label_item
						else
							l_item := l_item.out
						end
						if l_item = Void then
							l_item := ""
						end
						if l_item = Void then
							l_item := "Void"
						end
						l_items.force (l_item,l_items.count + 1)
						l_rows.force (<<l_item>>,l_rows.count + 1)
						l_last_any := l_any
					end
					i := i + 1 + l_row.subrow_count_recursive
				end
				create items_grid.make (<<>>, <<>>)
				items_grid.set_is_header_shown (False)
				items_grid.key_press_actions.extend (agent handle_key_press)

				items_grid.enable_multiple_row_selection
				from i := 1 until i > l_rows.count loop
					create l_grid_node.make_from_array (l_rows.item (i))
					l_label ?= l_grid_node.i_th (1)
					if l_last_text = Void or else not l_label.text.is_equal (l_last_text) then
						items_grid.extend (l_grid_node)
						l_last_text := l_label.text
					end
					i := i + 1
				end
				items_grid.focus_in_actions.extend (agent set_is_editing (False))
				from i := 1 until i > items_grid.row_count loop
					items_grid.row (i).select_actions.extend (agent reset_regex_field)
					items_grid.row (i).i_th (1).select_actions.extend (agent filter_from_item_select)
					items_grid.row (i).select_actions.extend (agent filter_from_item_select)
					i := i + 1
				end
				items_grid.set_column_width ((0.8 * container.width).truncated_to_integer,1)
				from j := items_grid.row_count until j < 2 loop
					l_row := items_grid.row (j)
					l_prev_row := items_grid.row (j - 1)
					l_label ?= l_row.i_th (1)
					l_prev_label ?= l_prev_row.i_th (1)
					if l_label /= Void and l_prev_label /= Void then
						if (l_label.text /= Void and l_prev_label.text /= Void) and then l_label.text.is_equal (l_prev_label.text) then
							if l_label.pixmap = l_prev_label.pixmap then
								items_grid.remove_row (l_row)
							end
						end
					end
					j := j - 1
				end
				extend (items_grid)
			end
		end
	reset_regex_field is
		do
			regex_field.set_text ("RegEx")
		end

	virtual_height : INTEGER is
			-- total height of widgets including virtual height of grid
		local
			l_grid : RP_DATA_GRID [G]
		do
			from start until off loop
				l_grid ?= item
				if l_grid /= Void  then
					Result := Result + l_grid.virtual_height --+ l_grid.header.height
				else
					Result := Result + item.height
				end
				forth
			end
		end

	set_focus is
			-- Grab keyboard focus.
		do
			controls.set_focus
		end

	filter_button : RP_DATA_GRID_LABEL_ITEM
	regex_field : RP_DATA_GRID_EDITABLE_ITEM
	items_grid : RP_DATA_GRID [G]
	title_node : RP_GRID_TITLE_NODE [G]
	container : EV_CONTAINER
	column : INTEGER
	controls : RP_DATA_GRID [G]
	is_editing : BOOLEAN
	white : EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (255,255,255)
		end
	lt_green : EV_COLOR is
		once
			create Result.make_with_8_bit_rgb (200,255,200)
		end

	regex_string : STRING is
		once
			Result := "RegEx"
		end

feature -- Basic operations

feature {NONE} -- Implementation

	handle_key_press (a_key: EV_KEY) is
			-- Respond to a key press of key `a_key' from one of the two grids
			-- comprising this GUI.
		require
			a_key_not_void: a_key /= Void
		local
			a_window: EV_WINDOW
		do
			if a_key.code = (create {EV_KEY_CONSTANTS}).key_escape then
				a_window := gui.parent_window (Current)
				if a_window /= Void then
					a_window.destroy
				end
			end
		end

end
