indexing
	description: ""
	author: ""
	date: "$Date: 2013/04/24 $"
	revision: "$Revision: #18 $"

class
	RP_DATA_GRID_LABEL_ITEM

inherit
	RP_DATA_GRID_ITEM
		undefine
			create_interface_objects
		redefine
			implementation
		end
	EV_GRID_LABEL_ITEM
		redefine
			implementation,
			initialize,
			is_in_default_state
		end

create
	default_create,
	make_from_ev_grid_item,
	make_with_text

feature {NONE} -- Initialization

	initialize is
			-- Initialize `Current'.
		do
			Precursor {EV_GRID_LABEL_ITEM}
				-- This right hand border enables right justified
				-- items to look like they are separated slightly from the
				-- edge of the column.
			set_right_border (2)
		end


	make_from_ev_grid_item (a_item : EV_GRID_ITEM) is
		local
			l_item : EV_GRID_LABEL_ITEM
		do
			default_create
			l_item ?= a_item
			if l_item /= Void then
				if l_item.text /= Void then
					set_text (l_item.text)
				end
				if l_item.pixmap /= Void then
					set_pixmap (l_item.pixmap)
				end
				data := l_item.data
				if l_item.layout_procedure /= void then
					set_layout_procedure (l_item.layout_procedure)
				end
			end
		end

feature -- Access

	is_editable: BOOLEAN is
			-- Is this item editable?
		do
			Result := False
		end

	retrieve_widget is
		do
		end

	is_in_default_state: BOOLEAN is
			-- Is `Current' in its default state?
		do
			Result := not is_selected and foreground_color = Void and background_color = Void and tooltip = Void and text.is_empty and pixmap = Void and
				left_border = 2 and right_border = 2 and top_border = 0 and bottom_border = 0
				and spacing = 2 and is_left_aligned and is_vertically_center_aligned and is_full_select_enabled
		end

feature {RP_GRID_TITLE_NODE, RP_DATA_GRID} -- Implementation

	set_sort_pixmap (a_pixmap: EV_PIXMAP) is
			-- Assign `a_pixmap' to `sort_pixmap' for display in sorted columns.
		require
			a_pixmap_not_void: a_pixmap /= Void
		do
			sort_pixmap := a_pixmap
		ensure
			sort_pixmap_set: sort_pixmap = a_pixmap
		end

	sort_pixmap: EV_PIXMAP
		-- Pixmap displayed to indicate sorted status.

feature {EV_ANY, EV_ANY_I} -- Implementation

	implementation: attached EV_GRID_LABEL_ITEM_I

end
