note

	description:

		"Delivery contract"

	author: "Ivan Tarnavsky"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #15 $"
	path: "$File: //rose/source/kernel/expert_system/rp_delivery.e $"

class RP_DELIVERY

inherit

	RP_PORTFOLIO_CORPORATE_ACTION_CONTRACT

create

	make_long_position,
	make_short_position

feature {NONE} -- Initialization

	make_long_position (a_units_base, a_quantity: RP_QUANTITY; a_value: RP_MONIES;
		a_event_date, a_settle_date: ROSE_DATE; a_portfolio: like portfolio; a_identifier: like identifier;
		a_system: like generating_system; a_custody: RP_CUSTODY) is
			-- create RP_DELIVERY
		require
			a_units_base_not_void: a_units_base /= Void
			a_quantity_not_void: a_quantity /= Void
			a_value_not_void: a_value /= Void
			a_event_date_not_void: a_event_date /= Void
			a_settle_date_not_void: a_settle_date /= Void
			a_portfolio_not_void: a_portfolio /= Void
			a_identifier_not_void: a_identifier /= Void
			a_system_not_void: a_system /= Void
			a_custody_not_void: a_custody /= Void
		do
				-- Contract
			make_capital_action (a_system, a_event_date, a_identifier, a_portfolio, a_units_base, a_settle_date)
				-- Flows: units go out
			add_flow (delivery_flow_type, portfolio.instrument_control (a_custody), unknown_instrument_control, a_event_date, a_settle_date, a_quantity.abs, a_event_date, 0, -a_value.abs)
		end

	make_short_position (a_units_base, a_quantity: RP_QUANTITY; a_value: RP_MONIES;
		a_event_date, a_settle_date: ROSE_DATE; a_portfolio: like portfolio; a_identifier: like identifier;
		a_system: like generating_system; a_custody: RP_CUSTODY) is
			-- create RP_DELIVERY
		require
			a_units_base_not_void: a_units_base /= Void
			a_quantity_not_void: a_quantity /= Void
			a_value_not_void: a_value /= Void
			a_event_date_not_void: a_event_date /= Void
			a_settle_date_not_void: a_settle_date /= Void
			a_portfolio_not_void: a_portfolio /= Void
			a_identifier_not_void: a_identifier /= Void
			a_system_not_void: a_system /= Void
			a_custody_not_void: a_custody /= Void
		do
				-- Contract
			make_capital_action (a_system, a_event_date, a_identifier, a_portfolio, a_units_base, a_settle_date)
				-- Flows: units come in
				-- As we do not have a long and short sides here
				-- we do the "net" effect of delivery of short position
				-- new flow types need to be added as well to model
				-- reality
			add_flow (delivery_flow_type, unknown_instrument_control, portfolio.instrument_control (a_custody), a_event_date, a_settle_date, a_quantity.abs, a_event_date, 0, a_value.abs)
		end

feature -- Basic Operations

	process (a_processor: RP_CONTRACT_PROCESSOR) is
			-- <Precursor>
		do
			a_processor.process_delivery (Current)
		end

end
