indexing

	description:
	"[
		Single contract for legacy Delivery (shares out) / Distribution (shares in).
	]"

	date: "$Date: 2010/03/02 $"
	sccid: "$Id: //rose/source/kernel/expert_system/rp_delivery_distribution.e#5 $"

class RP_DELIVERY_DISTRIBUTION

inherit

	RP_DELIVERY
		rename
			make_long_position as make_delivery_long,
			make_short_position as make_delivery_short
		undefine
			process
		end

	RP_DISTRIBUTION
		rename
			make_long_position as make_distribution_long,
			make_short_position as make_distribution_short
		undefine
			process
		end

create

	make_from_delivery_distribution

feature {NONE} -- Initialization

	make_from_delivery_distribution (a_delivery: RP_DELIVERY; a_distribution: RP_DISTRIBUTION) is
			-- Create from 'a_delivery' and 'a_distribution'
		require
			delivery_not_void: a_delivery /= Void
			distribution_not_void: a_distribution /= Void
		do
			make_from_other (a_delivery)
			flows.append_array (a_distribution.flows)
		end

feature -- Basic Operations

	process (a_processor: RP_CONTRACT_PROCESSOR) is
			-- <Precursor>
		do
			a_processor.process_delivery_distribution (Current)
		end

end
