note

	description:

		"Dividend contract"

	author: "Mark Howard"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/02/02 $"
	revision: "$Revision: #28 $"
	path: "$File: //rose/source/kernel/expert_system/rp_dividend.e $"

deferred class RP_DIVIDEND

inherit

	RP_PORTFOLIO_CORPORATE_ACTION_CONTRACT
		redefine
			is_dividend,
			as_dividend
		end

	RP_SWEPT_CONTRACT [RP_DIVIDEND]
		undefine
			is_equal
		end

feature -- Access

	instrument: RP_INSTRUMENT is
			-- Instrument for the dividend
		do
			Result := flows.first.instrument
		ensure
			instrument_not_void: Result /= Void
		end

feature -- Convert

	as_dividend: RP_DIVIDEND is
			-- Conversion to RP_DIVIDEND instance
			-- This is used by the custodian system to generate the cash swept
		do
			Result := Current
		end

feature -- Status Report

	is_dividend: BOOLEAN is
			-- Is `Current' a dividend?
		do
			Result := True
		end

feature -- Basic Operations

	process (a_processor: RP_CONTRACT_PROCESSOR) is
			-- <Precursor>
		do
			a_processor.process_dividend (Current)
		end

invariant
	at_least_one_flow: flows.count >= 1
end
