note

	description:

		"Re-invested dividend"

	author: "Ivan Tarnavsky"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #9 $"
	path: "$File: //rose/source/kernel/expert_system/aflows/rp_dividend_reinvestment.e $"

class RP_DIVIDEND_REINVESTMENT

inherit

	RP_CUSTODIAN_CONTRACT

create  {RP_GEDB_DIVIDEND_REINVESTED_CONVERTER, TS_TEST_CASE}

	make

feature {NONE} -- Initialization

	make (a_units: RP_QUANTITY; a_cash_effect_with_sign: RP_MONIES; a_event_date, a_settle_date: ROSE_DATE;
		a_portfolio: like portfolio; a_identifier: like identifier;
		a_system: like generating_system; a_custody: RP_CUSTODY) is
			-- Create reinvested dividend contract
		require
			a_units_not_void: a_units /= Void
			a_cash_effect_with_sign_not_void: a_cash_effect_with_sign /= Void
			a_event_date_not_void: a_event_date /= Void
			a_settle_date_not_void: a_settle_date /= Void
			a_portfolio_not_void: a_portfolio /= Void
			a_identifier_not_void: a_identifier /= Void
			a_system_not_void: a_system /= Void
			a_custody_not_void: a_custody /= Void
		do
				-- Contract
			make_portfolio_contract (a_system, a_event_date, a_identifier, a_portfolio)
				-- Flows
				-- "buy" `a_units' (i.e reinvest the received cash dividend into the dividend issuing stock)
			add_flow (dividend_reinvestment_quantity_flow_type, unknown_instrument_control, portfolio.instrument_control (a_custody), a_event_date, a_settle_date, a_units, a_event_date, 0, -a_cash_effect_with_sign)
				-- in exhange for `a_cash_effect' monies
			add_flow (dividend_reinvestment_money_flow_type, unknown_instrument_control, a_portfolio.instrument_control (a_custody), a_event_date, a_settle_date, a_cash_effect_with_sign, a_event_date, 0, -a_cash_effect_with_sign)
		ensure
			flows_not_void: flows /= Void
			has_two_flows: flows.count = 2
		end

feature -- Basic Operations

	process (a_processor: RP_CONTRACT_PROCESSOR) is
			-- <Precursor>
		do
			a_processor.process_dividend_reinvestment (Current)
		end

end
