note

	description:

		"Specializationof AVL tree allowing access to node value and key as well as"

	storable_version: ""
	author: "Ivan Tarnavsky"
	last_editor: "$Author: c4 $"
	date: "$Date: 2015/04/07 $"
	revision: "$Revision: #5 $"
	path: "$File: //rose/source/kernel/expert_system/mds/rp_equity_market_data_tree.e $"

class RP_EQUITY_MARKET_DATA_TREE [G, K]

inherit

	DS_AVL_TREE [G, K]

create

	make

feature -- Search

	node_key (a_node: like root_node): K is
			-- `a_node's key
		require
			non_void_node: a_node /= Void
		do
			Result := a_node.key
		end

	node_item (a_node: like root_node): G is
			-- `a_node's item
		require
			non_void_node: a_node /= Void
		do
			Result := a_node.item
		end

	search_not_less (a_key: K; a_predicate: PREDICATE [ANY, TUPLE [G]]): like root_node is
			-- Search for node with the maximum key which is not less than `a_key' and satisfies `a_predicate'
			-- That is the key in the tree that is closest to `a_key' from the left
		require
			non_void_key: a_key /= Void
		local
			l_node: like root_node
		do
			from
				l_node := root_node
			until
				l_node = Void
			loop
				if key_comparator.less_than (a_key, l_node.key) then
					l_node := l_node.left_child
				else
					if a_predicate = Void or else a_predicate.item ([l_node.item]) then
						Result := l_node
					end
					l_node := l_node.right_child
				end
			end
		end

end
