indexing

	description:
	"[
		Event type constants
		The descriptions are taken from Michael's Excel spreadsheet 'event use by zone'
		]"
	author: "[
		wj/bgum
		Michael Gacsaly
		Portfolio Accounting Tech
		]"
	last_editor: "$Author: it $"
	date: "$Date: 2010/05/14 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/expert_system/legacy/rp_event_type_constants.e $"
	documentation: ""
	keywords: ""

class RP_EVENT_TYPE_CONSTANTS

create

	default_create

feature -- Constants

	buy_event_type_1: INTEGER_32 is 1
			-- Purchase of security (purchase of long shares of an instrument)

	sell_event_type_2: INTEGER_32 is 2
			-- Sale of securities (sales of long shares of an instrument)

	inkind_event_type_3: INTEGER_32 is 3
			-- Inkind transfer (contribution from the from the client in the form of non-cash instrument)

	split_event_type_4: INTEGER_32 is 4
			-- Stock split (adjustment of shares held due to a forward (more shares) or reverse split (less shares))

	stock_dividend_event_type_5: INTEGER_32 is 5
			-- Stock dividend (dividend paid in stock)

	stock_distribution_event_type_6: INTEGER_32 is 6
			-- Stock distribution (shares of an instrument gained during a reorganization)

	dividend_reinvestment_event_type_7: INTEGER_32 is 7
			-- Dividend reinvestment (shares of an instrument gained through reinvestment of a cash dividend)
			-- Aka DRIP

	inlieu_event_type_8: INTEGER_32 is 8
			-- Partial sale of securities (the sale or cover of shares to balance rounding of a capital action)

	dividend_event_type_9: INTEGER_32 is 9
			-- Dividend (dividend paid in cash)

	delivery_event_type_10: INTEGER_32 is 10
			-- Delivery of a security (shares of an instrument given up during a reorganization)

	contribution_event_type_11: INTEGER_32 is 11
			-- Contribution (contribution from the client in cash)

	withdrawal_event_type_12: INTEGER_32 is 12
			-- Withdrawal (withdrawal by the client in cash)

	interest_event_type_13: INTEGER_32 is 13
			-- Interest (interest received)

	income_event_type_14: INTEGER_32 is 14
			-- Miscellaneous income (other investment related income received)

	expense_event_type_15: INTEGER_32 is 15
			-- Miscellaneous expense (investment related expenses paid)

	unrelated_income_event_type_16: INTEGER_32 is 16
			-- Unrelated income (other income unrelated to investment)

	unrelated_expense_event_type_17: INTEGER_32 is 17
			-- Unrelated expense (expenses unrelated to investment)

	cash_distribution_event_type_18: INTEGER_32 is 18
			-- Cash distribution (cash distribution received as part of a reorganization)

	package_trade_event_type_19: INTEGER_32 is 19
			-- !Obsolete! Package trade (package trade)

	dividend_adjustment_event_type_20: INTEGER_32 is 20
			-- Dividend adjustment (dividend tax withholding refund)

	short_event_type_21: INTEGER_32 is 21
			-- Short sale of a security (sale of borrowed shares of an instrument)

	cover_event_type_22: INTEGER_32 is 22
			-- Cover of a short sale (purchase of shares to cover borrowed shares)

	outkind_event_type_23: INTEGER_32 is 23
			-- Outkind transfer (withdrawal of shares of an instrument)

	cash_transfer_event_type_24: INTEGER_32 is 24
			-- Cash transfer (transfer annd optional currency conversion of cash)

	bhedge_event_type_25: INTEGER_32 is 25
			-- Forex forward contract (open forward currency hedge for B class share-holders)

	bclose_event_type_26: INTEGER_32 is 26
			-- Close fx forward contract (close forward currency hedge for B class share-holders)

	forward_event_type_27: INTEGER_32 is 27
			-- Forex forward contract (open forward currency hedge for A class share-holders)

	fclose_event_type_28: INTEGER_32 is 28
			-- Closed FX Forward contract (close forward currency heldge for A class share-holders)

	short_dividend_event_type_29: INTEGER_32 is 29
			-- !Obsolete! short dividends ()

	tender_event_type_30: INTEGER_32 is 30
			-- Cash payment from tender offer (sell shares of an instrument through a tender offer)

	dividend_withdrawn_event_type_31: INTEGER_32 is 31
			-- Dividends swept from account (dividend paid in cash and withdrawn)

	income_withdrawn_event_type_32: INTEGER_32 is 32
			-- Income swept from account (other investment related income received with tax withheld)

	dividend_taxed_event_type_33: INTEGER_32 is 33
			-- Dividend net of withholding tax (dividend paid in cash iwth tax withheld)

	mark_to_market_event_type_34: INTEGER_32 is 34
			-- Mark to market on securities (cash transfer to blance Mark-To-Market for futures contracts)

	right_event_type_35: INTEGER_32 is 35
			-- Rights issues (shares received as a result of a rights offering)

	lending_event_type_36: INTEGER_32 is 36
			-- !Obsolete! Stock lending (instrument lent or returned)

	collateral_event_type_37: INTEGER_32 is 37
			-- Declare holding is used a collateral for future contract

	breal_event_type_38: INTEGER_32 is 38
			-- Hedge gain/loss (realized gain or loss on forward currency contract for B class share-holder)

	freal_event_type_39: INTEGER_32 is 39
			-- Hedge gain/loss (realized gain or loss on forward currency contract for A class share-holder)

	cash_trn_event_type_40: INTEGER_32 is 40
			-- Forex spot trade (currency conversion spot trade)

	internal_cash_contribution_event_type_41: INTEGER_32 is 41
			-- Internal cash transfer contribution (transfer in of cash between of portfolios within an account)

	internal_cash_withdrawal_event_type_42: INTEGER_32 is 42
			-- Internal cash transfer withdrawal (transfer out of cash between portfolios within an account)

	redenomination_event_type_43: INTEGER_32 is 43
			-- Currency redenomination (change of denomination currency for a holding (adjusting cost))

	fixed_deposit_event_type_44: INTEGER_32 is 44
			-- Deposit/withdrawal from a fixed deposit (transfer of cash to/from a fixed deposit)

	fixed_deposit_interest_event_type_45: INTEGER_32 is 45
			-- Accrual interest from fixed deposit (accrued interest received on a bond holding)

	coupon_payment_event_type_46: INTEGER_32 is 46
			-- Coupon payment (coupon payment received on a bond holding)

	bank_transfer_event_type_47: INTEGER_32 is 47
			-- Cash transfer between banks (transfer of cash between banks)

	management_fee_event_type_48: INTEGER_32 is 48
			-- Management fee (management fee paid)

	received_event_type_49: INTEGER_32 is 49
			-- Inkind of a receivable (contration of an instrument which is a receivable)

	swap_event_type_50: INTEGER_32 is 50
			-- Swap	(interest rate swap)

	tmploan_event_type_51: INTEGER_32 is 51
			-- Internal loan transfer (transfer of cash related to a temporary loan)

	realgl_event_type_52, max_event_type: INTEGER_32 is 52
			-- Intraday sell to adjust gain/loss (realize gain loss through a virtual sell/buy)

feature -- Status

	is_valid_event_type (a_event_type: INTEGER): BOOLEAN is
			-- determine if a_event_type is valid event type
		do
			Result := a_event_type >= 1 and a_event_type <= max_event_type
				-- need better way to determine ranges
		end

	is_valid_trade_type (a_event_type: INTEGER): BOOLEAN is
			-- determine if a_event_type represents buy, sell, short, cover
		do
			Result := (a_event_type = buy_event_type_1) or (a_event_type = sell_event_type_2) or (a_event_type = cover_event_type_22) or (a_event_type = short_event_type_21)
		end

end
