note

	description:

		"Adjustment to expense"

	author: "Ivan Tarnavsky"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #7 $"
	path: "$File: //rose/source/kernel/expert_system/aflows/rp_expense_adjustment.e $"

class RP_EXPENSE_ADJUSTMENT

inherit

	RP_ADJUSTMENT_LEGACY_CONTRACT

create

	make

feature {NONE} -- Initialization

	make (a_quantity: RP_QUANTITY; a_value: RP_MONIES; a_event_date, a_settle_date: ROSE_DATE;
		a_portfolio: like portfolio; a_identifier: like identifier;
		a_system: like generating_system; a_custody: RP_CUSTODY) is
			-- Create
		require
			a_quantity_not_void: a_quantity /= Void
			a_value_not_void: a_value /= Void
			a_event_date_not_void: a_event_date /= Void
			a_settle_date_not_void: a_settle_date /= Void
			a_portfolio_not_void: a_portfolio /= Void
			a_identifier_not_void: a_identifier /= Void
			a_system_not_void: a_system /= Void
			a_custody_not_void: a_custody /= Void
		do
				-- Contract
			make_portfolio_contract (a_system, a_event_date, a_identifier, a_portfolio)
				-- Flows
			add_flow (expense_adjustment_flow_type, unknown_instrument_control, portfolio.instrument_control (a_custody), a_event_date, a_settle_date, a_quantity, a_event_date, 0, a_value)
		end

feature -- Basic Operations

	process (a_processor: RP_CONTRACT_PROCESSOR) is
			-- <Precursor>
		do
			a_processor.process_expense_adjustment (Current)
		end

end
