indexing

	description:
	"[
		Agreement to exchange currencies in the future (aka hedge) at a price determined today.		
		No actual money is exchanged when the contracts is open
		The contract will have two flows:
		1/ flow for the currency leaving the portfolio (RP_FORWARD [RP_CURRENCY]) - the price is discounted to the present date to know its value
		2/ flow for the currency coming back in the portfolio (RP_FORWARD [RP_CURRENCY]) - the price is discounted to the present date to know its value
		Unlike future contracts, the currency forwards are not standardized.
		At the maturity date, a RG/L is posted to the acocunt - nothing happens in between
		
		More info here:http://en.wikipedia.org/wiki/Forward_contract
		]"
	date: "$Date: 2010/07/19 $"
	sccid: "$Id: //rose/source/kernel/expert_system/aflows/rp_ffx.e#8 $"

deferred class RP_FFX

inherit

	RP_FX
		undefine
			process
		redefine
			is_foreign_exchange_trade,
			is_foreign_exchange_hedge
		end

feature -- Status Report

	is_foreign_exchange_trade: BOOLEAN is
			-- Is this a contract for a foreign exchange trade?
		once
			Result := False
		end

	is_foreign_exchange_hedge: BOOLEAN is
			-- Is this a contract for a foreign exchange hedge
		once
			Result := True
		end

end
