note

	description:

		"Realized Forward FX Gain or Loss"

	author: "gy"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #7 $"
	path: "$File: //rose/source/kernel/expert_system/aflows/rp_ffx_gain_loss.e $"

class RP_FFX_GAIN_LOSS

inherit

	RP_BROKERAGE_CONTRACT
		rename
			make as make_brokerage_contract
		end

create

	make

feature {NONE} -- Initialization

	make (a_trading_system: like generating_system; a_broker: like broker; a_event_date: like agreement_time;
		a_settle_date: like agreement_time; a_portfolio: like portfolio; a_identifier: like identifier;
		a_traded_quantity: RP_QUANTITY; a_gross_monies: RP_MONIES; a_custody: RP_CUSTODY) is
			-- Create
		require
			a_trading_system_not_void: a_trading_system /= Void
			a_broker_not_void: a_broker /= Void
			a_event_date_not_void: a_event_date /= Void
			a_settle_date_not_void: a_settle_date /= Void
			a_portfolio_not_void: a_portfolio /= Void
			a_identifier_not_void: a_identifier /= Void
			a_traded_quantity_not_void: a_traded_quantity /= Void
			a_gross_monies_not_void: a_gross_monies /= Void
			a_custody_not_void: a_custody /= Void
		do
			make_brokerage_contract (a_trading_system, a_event_date, a_identifier, a_portfolio, a_broker)
			add_flow (ffx_gain_loss_flow_type, a_broker.instrument_control, a_portfolio.instrument_control (a_custody), a_event_date, a_settle_date, a_traded_quantity, a_event_date, 0, a_gross_monies)
		end

feature -- Basic Operations

	process (a_processor: RP_CONTRACT_PROCESSOR) is
			-- <Precursor>
		do
			a_processor.process_ffx_gain_loss (Current)
		end

end
