note

	description:

		"Transfer between fixed deposit bank accounts"

	author: "Ivan Tarnavsky"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #7 $"
	path: "$File: //rose/source/kernel/expert_system/aflows/rp_fixed_deposit_transfer.e $"

class RP_FIXED_DEPOSIT_TRANSFER

inherit

	RP_PORTFOLIO_CONTRACT
		rename
			make as make_portfolio_contract
		end

create

	make

feature {NONE} -- Implementation

	make (a_quantity: RP_MONIES; a_instrument: RP_INSTRUMENT; a_event_date, a_settle_date: ROSE_DATE;
		a_portfolio: like portfolio; a_identifier: like identifier; a_system: like generating_system;
		a_custody: RP_CUSTODY) is
			-- Create
		require
			a_quantity_not_void: a_quantity /= Void
			a_instrument_not_void: a_instrument /= Void
			a_event_date_not_void: a_event_date /= Void
			a_settle_date_not_void: a_settle_date /= Void
			a_portfolio_not_void: a_portfolio /= Void
			a_identifier_not_void: a_identifier /= Void
			a_system_not_void: a_system /= Void
			a_custody_not_void: a_custody /= Void
		local
			l_fixed_deposit: RP_QUANTITY
		do
				-- Contract
			make_portfolio_contract (a_system, a_event_date, a_identifier, a_portfolio)
				-- Flows
			l_fixed_deposit := a_instrument.quantity (a_quantity.abs.amount)
			if a_quantity.amount < 0 then
					-- deposit to the short-term account
				add_flow (gross_monies_flow_type, a_portfolio.instrument_control (a_custody), unknown_instrument_control, a_event_date, a_settle_date, a_quantity.abs, a_event_date, 0, Void)
					-- we receive a qty of the fixed deposit
				add_flow (quantity_flow_type, unknown_instrument_control, a_portfolio.instrument_control (a_custody), a_event_date, a_settle_date, l_fixed_deposit, a_event_date, 0, a_quantity.abs)
			else
					-- liquidation of the short-term account
				add_flow (gross_monies_flow_type, unknown_instrument_control, a_portfolio.instrument_control (a_custody), a_event_date, a_settle_date, a_quantity.abs, a_event_date, 0, Void)
					-- we receive a qty of the fixed deposit
				add_flow (quantity_flow_type, a_portfolio.instrument_control (a_custody), unknown_instrument_control, a_event_date, a_settle_date, l_fixed_deposit, a_event_date, 0, a_quantity.abs)
			end
		end

feature -- Basic Operations

	process (a_processor: RP_CONTRACT_PROCESSOR) is
			-- <Precursor>
		do
			a_processor.process_fixed_deposit_transfer (Current)
		end

end
