indexing

	description:

		"Flow Type Enumeration"

	date: "$Date: 2010/07/19 $"
	sccid: "$Id: //rose/source/kernel/expert_system/aflows/rp_flow_type.e#4 $"

class RP_FLOW_TYPE

inherit

	DEBUG_OUTPUT
		undefine
			is_equal
		end

	HASHABLE
		undefine
			is_equal
		end

	ANY
		redefine
			is_equal
		end

create {RP_FLOW_TYPE_AWARE}

	make_as_quantity_flow,
	make_as_gross_monies_flow,
	make_as_fungible_conversion_flow,
	make_as_tax_flow,
	make_as_commission_flow,
	make_as_exchange_fee_flow,
	make_as_stamp_duty_flow,
	make_as_borrow_flow,
	make_as_return_flow,
	make_as_dividend_flow,
	make_as_split_flow,
	make_as_transfer_flow,
	make_as_delivery_flow,
	make_as_distribution_flow,
	make_as_debt_reduction_flow,
	make_as_debt_payment_flow,
	make_as_stock_bonus_flow,
	make_as_interest_flow,
	make_as_income_flow,
	make_as_income_adjustment_flow,
	make_as_income_unrelated_flow,
	make_as_income_unrelated_adjustment_flow,
	make_as_expense_flow,
	make_as_expense_adjustment_flow,
	make_as_expense_unrelated_flow,
	make_as_expense_unrelated_adjustment_flow,
	make_as_ffx_gain_loss_flow,
	make_as_dividend_withholding_country_tax_flow,
	make_as_dividend_withholding_nrs_tax_flow,
	make_as_dividend_tax_refund_flow,
	make_as_tender_flow,
	make_as_stock_dividend_flow,
	make_as_inkind_flow,
	make_as_outkind_flow,
	make_as_mark_to_market_flow,
	make_as_dividend_reinvestment_quantity_flow,
	make_as_dividend_reinvestment_money_flow,
	make_as_rights_exercise_quantity_flow,
	make_as_rights_exercise_money_flow,
	make_as_ffx_open_flow,
	make_as_ffx_close_flow,
	make_as_fixed_deposit_transfer_flow,
	make_as_redenomination_flow,
	make_as_quantity_intraday_sell_flow,
	make_as_gross_monies_intraday_sell_flow,
	make_as_withdrawal_flow,
	make_as_contribution_flow,
	make_as_intrazonal_withdrawal_flow,
	make_as_intrazonal_contribution_flow

feature {NONE} -- Initialization

	make_as_quantity_flow is
			-- Initialize as quantity_flow
		do
			type := c_quantity_flow
		ensure
			type_is_quantity_flow: is_quantity_flow
		end

	make_as_gross_monies_flow is
			-- Initialize as gross_monies_flow
		do
			type := c_gross_monies_flow
		ensure
			type_is_gross_monies_flow: is_gross_monies_flow
		end

	make_as_fungible_conversion_flow is
			-- Initialize as fungible_conversion_flow
		do
			type := c_fungible_conversion_flow
		ensure
			type_is_fungible_conversion_flow: is_fungible_conversion_flow
		end

	make_as_tax_flow is
			-- Initialize as tax_flow
		do
			type := c_tax_flow
		ensure
			type_is_tax_flow: is_tax_flow
		end

	make_as_commission_flow is
			-- Initialize as commission_flow
		do
			type := c_commission_flow
		ensure
			type_is_commission_flow: is_commission_flow
		end

	make_as_exchange_fee_flow is
			-- Initialize as exchange_fee_flow
		do
			type := c_exchange_fee_flow
		ensure
			type_is_exchange_fee_flow: is_exchange_fee_flow
		end

	make_as_stamp_duty_flow is
			-- Initialize as stamp_duty_flow
		do
			type := c_stamp_duty_flow
		ensure
			type_is_stamp_duty_flow: is_stamp_duty_flow
		end

	make_as_borrow_flow is
			-- Initialize as borrow_flow
		do
			type := c_borrow_flow
		ensure
			type_is_borrow_flow: is_borrow_flow
		end

	make_as_return_flow is
			-- Initialize as return_flow
		do
			type := c_return_flow
		ensure
			type_is_return_flow: is_return_flow
		end

	make_as_dividend_flow is
			-- Initialize as dividend_flow
		do
			type := c_dividend_flow
		ensure
			type_is_dividend_flow: is_dividend_flow
		end

	make_as_split_flow is
			-- Initialize as split_flow
		do
			type := c_split_flow
		ensure
			type_is_split_flow: is_split_flow
		end

	make_as_transfer_flow is
			-- Initialize as transfer_flow
		do
			type := c_transfer_flow
		ensure
			type_is_transfer_flow: is_transfer_flow
		end

	make_as_delivery_flow is
			-- Initialize as delivery_flow
		do
			type := c_delivery_flow
		ensure
			type_is_delivery_flow: is_delivery_flow
		end

	make_as_distribution_flow is
			-- Initialize as distribution_flow
		do
			type := c_distribution_flow
		ensure
			type_is_distribution_flow: is_distribution_flow
		end

	make_as_debt_reduction_flow is
			-- Initialize as debt_reduction_flow
		do
			type := c_debt_reduction_flow
		ensure
			type_is_debt_reduction_flow: is_debt_reduction_flow
		end

	make_as_debt_payment_flow is
			-- Initialize as debt_payment_flow
		do
			type := c_debt_payment_flow
		ensure
			type_is_debt_payment_flow: is_debt_payment_flow
		end

	make_as_stock_bonus_flow is
			-- Initialize as stock_bonus_flow
		do
			type := c_stock_bonus_flow
		ensure
			type_is_stock_bonus_flow: is_stock_bonus_flow
		end

	make_as_interest_flow is
			-- Initialize as interest_flow
		do
			type := c_interest_flow
		ensure
			type_is_interest_flow: is_interest_flow
		end

	make_as_income_flow is
			-- Initialize as income_flow
		do
			type := c_income_flow
		ensure
			type_is_income_flow: is_income_flow
		end

	make_as_income_adjustment_flow is
			-- Initialize as income_adjustment_flow
		do
			type := c_income_adjustment_flow
		ensure
			type_is_income_adjustment_flow: is_income_adjustment_flow
		end

	make_as_income_unrelated_flow is
			-- Initialize as income_unrelated_flow
		do
			type := c_income_unrelated_flow
		ensure
			type_is_income_unrelated_flow: is_income_unrelated_flow
		end

	make_as_income_unrelated_adjustment_flow is
			-- Initialize as income_unrelated_adjustment_flow
		do
			type := c_income_unrelated_adjustment_flow
		ensure
			type_is_income_unrelated_adjustment_flow: is_income_unrelated_adjustment_flow
		end

	make_as_expense_flow is
			-- Initialize as expense_flow
		do
			type := c_expense_flow
		ensure
			type_is_expense_flow: is_expense_flow
		end

	make_as_expense_adjustment_flow is
			-- Initialize as expense_adjustment_flow
		do
			type := c_expense_adjustment_flow
		ensure
			type_is_expense_adjustment_flow: is_expense_adjustment_flow
		end

	make_as_expense_unrelated_flow is
			-- Initialize as expense_unrelated_flow
		do
			type := c_expense_unrelated_flow
		ensure
			type_is_expense_unrelated_flow: is_expense_unrelated_flow
		end

	make_as_expense_unrelated_adjustment_flow is
			-- Initialize as expense_unrelated_adjustment_flow
		do
			type := c_expense_unrelated_adjustment_flow
		ensure
			type_is_expense_unrelated_adjustment_flow: is_expense_unrelated_adjustment_flow
		end

	make_as_ffx_gain_loss_flow is
			-- Initialize as ffx_gain_loss_flow
		do
			type := c_ffx_gain_loss_flow
		ensure
			type_is_ffx_gain_loss_flow: is_ffx_gain_loss_flow
		end

	make_as_dividend_withholding_country_tax_flow is
			-- Initialize as dividend_withholding_country_tax_flow
		do
			type := c_dividend_withholding_country_tax_flow
		ensure
			type_is_dividend_withholding_country_tax_flow: is_dividend_withholding_country_tax_flow
		end

	make_as_dividend_withholding_nrs_tax_flow is
			-- Initialize as dividend_withholding_nrs_tax_flow
		do
			type := c_dividend_withholding_nrs_tax_flow
		ensure
			type_is_dividend_withholding_nrs_tax_flow: is_dividend_withholding_nrs_tax_flow
		end

	make_as_dividend_tax_refund_flow is
			-- Initialize as dividend_tax_refund_flow
		do
			type := c_dividend_tax_refund_flow
		ensure
			type_is_dividend_tax_refund_flow: is_dividend_tax_refund_flow
		end

	make_as_tender_flow is
			-- Initialize as tender_flow
		do
			type := c_tender_flow
		ensure
			type_is_tender_flow: is_tender_flow
		end

	make_as_stock_dividend_flow is
			-- Initialize as stock_dividend_flow
		do
			type := c_stock_dividend_flow
		ensure
			type_is_stock_dividend_flow: is_stock_dividend_flow
		end

	make_as_inkind_flow is
			-- Initialize as inkind_flow
		do
			type := c_inkind_flow
		ensure
			type_is_inkind_flow: is_inkind_flow
		end

	make_as_outkind_flow is
			-- Initialize as outkind_flow
		do
			type := c_outkind_flow
		ensure
			type_is_outkind_flow: is_outkind_flow
		end

	make_as_mark_to_market_flow is
			-- Initialize as mark_to_market_flow
		do
			type := c_mark_to_market_flow
		ensure
			type_is_mark_to_market_flow: is_mark_to_market_flow
		end

	make_as_dividend_reinvestment_quantity_flow is
			-- Initialize as dividend_reinvestment_quantity_flow
		do
			type := c_dividend_reinvestment_quantity_flow
		ensure
			type_is_dividend_reinvestment_quantity_flow: is_dividend_reinvestment_quantity_flow
		end

	make_as_dividend_reinvestment_money_flow is
			-- Initialize as dividend_reinvestment_money_flow
		do
			type := c_dividend_reinvestment_money_flow
		ensure
			type_is_dividend_reinvestment_money_flow: is_dividend_reinvestment_money_flow
		end

	make_as_rights_exercise_quantity_flow is
			-- Initialize as rights_exercise_quantity_flow
		do
			type := c_rights_exercise_quantity_flow
		ensure
			type_is_rights_exercise_quantity_flow: is_rights_exercise_quantity_flow
		end

	make_as_rights_exercise_money_flow is
			-- Initialize as rights_exercise_money_flow
		do
			type := c_rights_exercise_money_flow
		ensure
			type_is_rights_exercise_money_flow: is_rights_exercise_money_flow
		end

	make_as_ffx_open_flow is
			-- Initialize as ffx_open_flow
		do
			type := c_ffx_open_flow
		ensure
			type_is_ffx_open_flow: is_ffx_open_flow
		end

	make_as_ffx_close_flow is
			-- Initialize as ffx_close_flow
		do
			type := c_ffx_close_flow
		ensure
			type_is_ffx_close_flow: is_ffx_close_flow
		end

	make_as_fixed_deposit_transfer_flow is
			-- Initialize as fixed_deposit_transfer_flow
		do
			type := c_fixed_deposit_transfer_flow
		ensure
			type_is_fixed_deposit_transfer_flow: is_fixed_deposit_transfer_flow
		end

	make_as_redenomination_flow is
			-- Initialize as redenomination_flow
		do
			type := c_redenomination_flow
		ensure
			type_is_redenomination_flow: is_redenomination_flow
		end

	make_as_quantity_intraday_sell_flow is
			-- Initialize as quantity_intraday_sell_flow
		do
			type := c_quantity_intraday_sell_flow
		ensure
			type_is_quantity_intraday_sell_flow: is_quantity_intraday_sell_flow
		end

	make_as_gross_monies_intraday_sell_flow is
			-- Initialize as gross_monies_intraday_sell_flow
		do
			type := c_gross_monies_intraday_sell_flow
		ensure
			type_is_gross_monies_intraday_sell_flow: is_gross_monies_intraday_sell_flow
		end

	make_as_withdrawal_flow is
			-- Initialize as withdrawal_flow
		do
			type := c_withdrawal_flow
		ensure
			type_is_withdrawal_flow: is_withdrawal_flow
		end

	make_as_contribution_flow is
			-- Initialize as contribution_flow
		do
			type := c_contribution_flow
		ensure
			type_is_contribution_flow: is_contribution_flow
		end

	make_as_intrazonal_withdrawal_flow is
			-- Initialize as withdrawal_flow
		do
			type := c_intrazonal_withdrawal_flow
		ensure
			type_is_intrazonal_withdrawal_flow: is_intrazonal_withdrawal_flow
		end

	make_as_intrazonal_contribution_flow is
			-- Initialize as contribution_flow
		do
			type := c_intrazonal_contribution_flow
		ensure
			type_is_intrazonal_contribution_flow: is_intrazonal_contribution_flow
		end

feature -- Comparison

	hash_code: INTEGER is
			-- Hash code is ordinal
		do
			Result := type
		end

	is_equal (a_other: like Current): BOOLEAN is
			-- Is `other' attached to an object considered
			-- equal to current object?
		do
			Result := a_other /= Void and then type = a_other.type
		end

feature -- predicates

	is_quantity_flow: BOOLEAN is
			-- Is `Current' quantity_flow
		do
			Result := (type = c_quantity_flow)
		end

	is_gross_monies_flow: BOOLEAN is
			-- Is `Current' gross_monies_flow
		do
			Result := (type = c_gross_monies_flow)
		end

	is_fungible_conversion_flow: BOOLEAN is
			-- Is `Current' fungible_conversion_flow
		do
			Result := (type = c_fungible_conversion_flow)
		end

	is_tax_flow: BOOLEAN is
			-- Is `Current' tax_flow
		do
			Result := (type = c_tax_flow)
		end

	is_commission_flow: BOOLEAN is
			-- Is `Current' commission_flow
		do
			Result := (type = c_commission_flow)
		end

	is_exchange_fee_flow: BOOLEAN is
			-- Is `Current' exchange_fee_flow
		do
			Result := (type = c_exchange_fee_flow)
		end

	is_stamp_duty_flow: BOOLEAN is
			-- Is `Current' stamp_duty_flow
		do
			Result := (type = c_stamp_duty_flow)
		end

	is_borrow_flow: BOOLEAN is
			-- Is `Current' borrow_flow
		do
			Result := (type = c_borrow_flow)
		end

	is_return_flow: BOOLEAN is
			-- Is `Current' return_flow
		do
			Result := (type = c_return_flow)
		end

	is_dividend_flow: BOOLEAN is
			-- Is `Current' dividend_flow
		do
			Result := (type = c_dividend_flow)
		end

	is_split_flow: BOOLEAN is
			-- Is `Current' split_flow
		do
			Result := (type = c_split_flow)
		end

	is_transfer_flow: BOOLEAN is
			-- Is `Current' transfer_flow
		do
			Result := (type = c_transfer_flow)
		end

	is_delivery_flow: BOOLEAN is
			-- Is `Current' delivery_flow
		do
			Result := (type = c_delivery_flow)
		end

	is_distribution_flow: BOOLEAN is
			-- Is `Current' distribution_flow
		do
			Result := (type = c_distribution_flow)
		end

	is_debt_reduction_flow: BOOLEAN is
			-- Is `Current' debt_reduction_flow
		do
			Result := (type = c_debt_reduction_flow)
		end

	is_debt_payment_flow: BOOLEAN is
			-- Is `Current' debt_payment_flow
		do
			Result := (type = c_debt_payment_flow)
		end

	is_stock_bonus_flow: BOOLEAN is
			-- Is `Current' stock_bonus_flow
		do
			Result := (type = c_stock_bonus_flow)
		end

	is_interest_flow: BOOLEAN is
			-- Is `Current' interest_flow
		do
			Result := (type = c_interest_flow)
		end

	is_income_flow: BOOLEAN is
			-- Is `Current' income_flow
		do
			Result := (type = c_income_flow)
		end

	is_income_adjustment_flow: BOOLEAN is
			-- Is `Current' income_adjustment_flow
		do
			Result := (type = c_income_adjustment_flow)
		end

	is_income_unrelated_flow: BOOLEAN is
			-- Is `Current' income_unrelated_flow
		do
			Result := (type = c_income_unrelated_flow)
		end

	is_income_unrelated_adjustment_flow: BOOLEAN is
			-- Is `Current' income_unrelated_adjustment_flow
		do
			Result := (type = c_income_unrelated_adjustment_flow)
		end

	is_expense_flow: BOOLEAN is
			-- Is `Current' expense_flow
		do
			Result := (type = c_expense_flow)
		end

	is_expense_adjustment_flow: BOOLEAN is
			-- Is `Current' expense_adjustment_flow
		do
			Result := (type = c_expense_adjustment_flow)
		end

	is_expense_unrelated_flow: BOOLEAN is
			-- Is `Current' expense_unrelated_flow
		do
			Result := (type = c_expense_unrelated_flow)
		end

	is_expense_unrelated_adjustment_flow: BOOLEAN is
			-- Is `Current' expense_unrelated_adjustment_flow
		do
			Result := (type = c_expense_unrelated_adjustment_flow)
		end

	is_ffx_gain_loss_flow: BOOLEAN is
			-- Is `Current' ffx_gain_loss_flow
		do
			Result := (type = c_ffx_gain_loss_flow)
		end

	is_dividend_withholding_country_tax_flow: BOOLEAN is
			-- Is `Current' dividend_withholding_country_tax_flow
		do
			Result := (type = c_dividend_withholding_country_tax_flow)
		end

	is_dividend_withholding_nrs_tax_flow: BOOLEAN is
			-- Is `Current' dividend_withholding_nrs_tax_flow
		do
			Result := (type = c_dividend_withholding_nrs_tax_flow)
		end

	is_dividend_tax_refund_flow: BOOLEAN is
			-- Is `Current' dividend_tax_refund_flow
		do
			Result := (type = c_dividend_tax_refund_flow)
		end

	is_tender_flow: BOOLEAN is
			-- Is `Current' tender_flow
		do
			Result := (type = c_tender_flow)
		end

	is_stock_dividend_flow: BOOLEAN is
			-- Is `Current' stock_dividend_flow
		do
			Result := (type = c_stock_dividend_flow)
		end

	is_inkind_flow: BOOLEAN is
			-- Is `Current' inkind_flow
		do
			Result := (type = c_inkind_flow)
		end

	is_outkind_flow: BOOLEAN is
			-- Is `Current' outkind_flow
		do
			Result := (type = c_outkind_flow)
		end

	is_mark_to_market_flow: BOOLEAN is
			-- Is `Current' mark_to_market_flow
		do
			Result := (type = c_mark_to_market_flow)
		end

	is_dividend_reinvestment_quantity_flow: BOOLEAN is
			-- Is `Current' dividend_reinvestment_quantity_flow
		do
			Result := (type = c_dividend_reinvestment_quantity_flow)
		end

	is_dividend_reinvestment_money_flow: BOOLEAN is
			-- Is `Current' dividend_reinvestment_money_flow
		do
			Result := (type = c_dividend_reinvestment_money_flow)
		end

	is_rights_exercise_quantity_flow: BOOLEAN is
			-- Is `Current' rights_exercise_quantity_flow
		do
			Result := (type = c_rights_exercise_quantity_flow)
		end

	is_rights_exercise_money_flow: BOOLEAN is
			-- Is `Current' rights_exercise_money_flow
		do
			Result := (type = c_rights_exercise_money_flow)
		end

	is_ffx_open_flow: BOOLEAN is
			-- Is `Current' ffx_open_flow
		do
			Result := (type = c_ffx_open_flow)
		end

	is_ffx_close_flow: BOOLEAN is
			-- Is `Current' ffx_close_flow
		do
			Result := (type = c_ffx_close_flow)
		end

	is_fixed_deposit_transfer_flow: BOOLEAN is
			-- Is `Current' fixed_deposit_transfer_flow
		do
			Result := (type = c_fixed_deposit_transfer_flow)
		end

	is_redenomination_flow: BOOLEAN is
			-- Is `Current' redenomination_flow
		do
			Result := (type = c_redenomination_flow)
		end

	is_quantity_intraday_sell_flow: BOOLEAN is
			-- Is `Current' quantity_intraday_sell_flow
		do
			Result := (type = c_quantity_intraday_sell_flow)
		end

	is_gross_monies_intraday_sell_flow: BOOLEAN is
			-- Is `Current' gross_monies_intraday_sell_flow
		do
			Result := (type = c_gross_monies_intraday_sell_flow)
		end

	is_withdrawal_flow: BOOLEAN is
			-- Is `Current' withdrawal_flow
		do
			Result := (type = c_withdrawal_flow)
		end

	is_contribution_flow: BOOLEAN is
			-- Is `Current' contribution_flow
		do
			Result := (type = c_contribution_flow)
		end

	is_intrazonal_withdrawal_flow: BOOLEAN is
			-- Is `Current' intrazonal_withdrawal_flow
		do
			Result := (type = c_intrazonal_withdrawal_flow)
		end

	is_intrazonal_contribution_flow: BOOLEAN is
			-- Is `Current' intrazonal_contribution_flow
		do
			Result := (type = c_intrazonal_contribution_flow)
		end

feature -- output

	debug_output: STRING is
			-- Debug output
		do
			Result := as_string
		end

	as_string: STRING is
			-- String represenation
		do
			inspect type
			when c_quantity_flow then
				Result := "quantity_flow"
			when c_gross_monies_flow then
				Result := "gross_monies_flow"
			when c_fungible_conversion_flow then
				Result := "fungible_conversion_flow"
			when c_tax_flow then
				Result := "tax_flow"
			when c_commission_flow then
				Result := "commission_flow"
			when c_exchange_fee_flow then
				Result := "exchange_fee_flow"
			when c_stamp_duty_flow then
				Result := "stamp_duty_flow"
			when c_borrow_flow then
				Result := "borrow_flow"
			when c_return_flow then
				Result := "return_flow"
			when c_dividend_flow then
				Result := "dividend_flow"
			when c_split_flow then
				Result := "split_flow"
			when c_transfer_flow then
				Result := "transfer_flow"
			when c_delivery_flow then
				Result := "delivery_flow"
			when c_distribution_flow then
				Result := "distribution_flow"
			when c_debt_reduction_flow then
				Result := "debt_reduction_flow"
			when c_debt_payment_flow then
				Result := "debt_payment_flow"
			when c_stock_bonus_flow then
				Result := "stock_bonus_flow"
			when c_interest_flow then
				Result := "interest_flow"
			when c_income_flow then
				Result := "income_flow"
			when c_income_adjustment_flow then
				Result := "income_adjustment_flow"
			when c_income_unrelated_flow then
				Result := "income_unrelated_flow"
			when c_income_unrelated_adjustment_flow then
				Result := "income_unrelated_adjustment_flow"
			when c_expense_flow then
				Result := "expense_flow"
			when c_expense_adjustment_flow then
				Result := "expense_adjustment_flow"
			when c_expense_unrelated_flow then
				Result := "expense_unrelated_flow"
			when c_expense_unrelated_adjustment_flow then
				Result := "expense_unrelated_adjustment_flow"
			when c_ffx_gain_loss_flow then
				Result := "ffx_gain_loss_flow"
			when c_dividend_withholding_country_tax_flow then
				Result := "dividend_withholding_country_tax_flow"
			when c_dividend_withholding_nrs_tax_flow then
				Result := "dividend_withholding_nrs_tax_flow"
			when c_dividend_tax_refund_flow then
				Result := "dividend_tax_refund_flow"
			when c_tender_flow then
				Result := "tender_flow"
			when c_stock_dividend_flow then
				Result := "stock_dividend_flow"
			when c_inkind_flow then
				Result := "inkind_flow"
			when c_outkind_flow then
				Result := "outkind_flow"
			when c_mark_to_market_flow then
				Result := "mark_to_market_flow"
			when c_dividend_reinvestment_quantity_flow then
				Result := "dividend_reinvestment_quantity_flow"
			when c_dividend_reinvestment_money_flow then
				Result := "dividend_reinvestment_money_flow"
			when c_rights_exercise_quantity_flow then
				Result := "rights_exercise_quantity_flow"
			when c_rights_exercise_money_flow then
				Result := "rights_exercise_money_flow"
			when c_ffx_open_flow then
				Result := "ffx_open_flow"
			when c_ffx_close_flow then
				Result := "ffx_close_flow"
			when c_fixed_deposit_transfer_flow then
				Result := "fixed_deposit_transfer_flow"
			when c_redenomination_flow then
				Result := "redenomination_flow"
			when c_quantity_intraday_sell_flow then
				Result := "quantity_intraday_sell_flow"
			when c_gross_monies_intraday_sell_flow then
				Result := "gross_monies_intraday_sell_flow"
			when c_withdrawal_flow then
				Result := "withdrawal_flow"
			when c_contribution_flow then
				Result := "contribution_flow"
			when c_intrazonal_withdrawal_flow then
				Result := "intrazonal_withdrawal_flow"
			when c_intrazonal_contribution_flow then
				Result := "intrazonal_contribution_flow"
			end
		end

feature {RP_FLOW} -- Visitor Pattern

	process (a_visitor: RP_FLOW_VISITOR; a_value: RP_FLOW) is
			-- Visit `a_value' with `a_visitor'
		require
			non_void_arguments: a_visitor /= Void and a_value /= Void
		do
			inspect type
			when c_quantity_flow then
				a_visitor.process_quantity (a_value)
			when c_gross_monies_flow then
				a_visitor.process_gross_monies (a_value)
			when c_fungible_conversion_flow then
				a_visitor.process_fungible_conversion (a_value)
			when c_tax_flow then
				a_visitor.process_tax (a_value)
			when c_commission_flow then
				a_visitor.process_commission (a_value)
			when c_exchange_fee_flow then
				a_visitor.process_exchange_fee (a_value)
			when c_stamp_duty_flow then
				a_visitor.process_stamp_duty (a_value)
			when c_borrow_flow then
				a_visitor.process_borrow (a_value)
			when c_return_flow then
				a_visitor.process_return (a_value)
			when c_dividend_flow then
				a_visitor.process_dividend (a_value)
			when c_split_flow then
				a_visitor.process_split (a_value)
			when c_transfer_flow then
				a_visitor.process_transfer (a_value)
			when c_delivery_flow then
				a_visitor.process_delivery (a_value)
			when c_distribution_flow then
				a_visitor.process_distribution (a_value)
			when c_debt_reduction_flow then
				a_visitor.process_debt_reduction (a_value)
			when c_debt_payment_flow then
				a_visitor.process_debt_payment (a_value)
			when c_stock_bonus_flow then
				a_visitor.process_stock_bonus (a_value)
			when c_interest_flow then
				a_visitor.process_interest (a_value)
			when c_income_flow then
				a_visitor.process_income (a_value)
			when c_income_adjustment_flow then
				a_visitor.process_income_adjustment (a_value)
			when c_income_unrelated_flow then
				a_visitor.process_income_unrelated (a_value)
			when c_income_unrelated_adjustment_flow then
				a_visitor.process_income_unrelated_adjustment (a_value)
			when c_expense_flow then
				a_visitor.process_expense (a_value)
			when c_expense_adjustment_flow then
				a_visitor.process_expense_adjustment (a_value)
			when c_expense_unrelated_flow then
				a_visitor.process_expense_unrelated (a_value)
			when c_expense_unrelated_adjustment_flow then
				a_visitor.process_expense_unrelated_adjustment (a_value)
			when c_ffx_gain_loss_flow then
				a_visitor.process_ffx_gain_loss (a_value)
			when c_dividend_withholding_country_tax_flow then
				a_visitor.process_dividend_withholding_country_tax (a_value)
			when c_dividend_withholding_nrs_tax_flow then
				a_visitor.process_dividend_withholding_nrs_tax (a_value)
			when c_dividend_tax_refund_flow then
				a_visitor.process_dividend_tax_refund (a_value)
			when c_tender_flow then
				a_visitor.process_tender (a_value)
			when c_stock_dividend_flow then
				a_visitor.process_stock_dividend (a_value)
			when c_inkind_flow then
				a_visitor.process_inkind (a_value)
			when c_outkind_flow then
				a_visitor.process_outkind (a_value)
			when c_mark_to_market_flow then
				a_visitor.process_mark_to_market (a_value)
			when c_dividend_reinvestment_quantity_flow then
				a_visitor.process_dividend_reinvestment_quantity (a_value)
			when c_dividend_reinvestment_money_flow then
				a_visitor.process_dividend_reinvestment_money (a_value)
			when c_rights_exercise_quantity_flow then
				a_visitor.process_rights_exercise_quantity (a_value)
			when c_rights_exercise_money_flow then
				a_visitor.process_rights_exercise_money (a_value)
			when c_ffx_open_flow then
				a_visitor.process_ffx_open (a_value)
			when c_ffx_close_flow then
				a_visitor.process_ffx_close (a_value)
			when c_fixed_deposit_transfer_flow then
				a_visitor.process_fixed_deposit_transfer (a_value)
			when c_redenomination_flow then
				a_visitor.process_redenomination (a_value)
			when c_quantity_intraday_sell_flow then
				a_visitor.process_quantity_intraday_sell (a_value)
			when c_gross_monies_intraday_sell_flow then
				a_visitor.process_gross_monies_intraday_sell (a_value)
			when c_withdrawal_flow then
				a_visitor.process_withdrawal (a_value)
			when c_contribution_flow then
				a_visitor.process_contribution (a_value)
			when c_intrazonal_withdrawal_flow then
				a_visitor.process_intrazonal_withdrawal (a_value)
			when c_intrazonal_contribution_flow then
				a_visitor.process_intrazonal_contribution (a_value)
			end
		end

feature {RP_FLOW_TYPE} -- Implementation

	type: INTEGER
			-- ordinal number

	c_quantity_flow: INTEGER is 1
			-- quantity_flow ordinal

	c_gross_monies_flow: INTEGER is 2
			-- gross_monies_flow ordinal

	c_fungible_conversion_flow: INTEGER is 3
			-- fungible_conversion_flow ordinal

	c_tax_flow: INTEGER is 4
			-- tax_flow ordinal

	c_commission_flow: INTEGER is 5
			-- commission_flow ordinal

	c_exchange_fee_flow: INTEGER is 6
			-- exchange_fee_flow ordinal

	c_stamp_duty_flow: INTEGER is 7
			-- stamp_duty_flow ordinal

	c_borrow_flow: INTEGER is 8
			-- borrow_flow ordinal

	c_return_flow: INTEGER is 9
			-- return_flow ordinal

	c_dividend_flow: INTEGER is 10
			-- dividend_flow ordinal

	c_split_flow: INTEGER is 11
			-- split_flow ordinal

	c_transfer_flow: INTEGER is 12
			-- transfer_flow ordinal

	c_delivery_flow: INTEGER is 13
			-- delivery_flow ordinal

	c_distribution_flow: INTEGER is 14
			-- distribution_flow ordinal

	c_debt_reduction_flow: INTEGER is 15
			-- debt_reduction_flow ordinal

	c_debt_payment_flow: INTEGER is 16
			-- debt_payment_flow ordinal

	c_stock_bonus_flow: INTEGER is 17
			-- stock_bonus_flow ordinal

	c_interest_flow: INTEGER is 18
			-- interest_flow ordinal

	c_income_flow: INTEGER is 19
			-- income_flow ordinal

	c_income_adjustment_flow: INTEGER is 20
			-- income_adjustment_flow ordinal

	c_income_unrelated_flow: INTEGER is 21
			-- income_unrelated_flow ordinal

	c_income_unrelated_adjustment_flow: INTEGER is 22
			-- income_unrelated_adjustment_flow ordinal

	c_expense_flow: INTEGER is 23
			-- expense_flow ordinal

	c_expense_adjustment_flow: INTEGER is 24
			-- expense_adjustment_flow ordinal

	c_expense_unrelated_flow: INTEGER is 25
			-- expense_unrelated_flow ordinal

	c_expense_unrelated_adjustment_flow: INTEGER is 26
			-- expense_unrelated_adjustment_flow ordinal

	c_ffx_gain_loss_flow: INTEGER is 27
			-- ffx_gain_loss_flow ordinal

	c_dividend_withholding_country_tax_flow: INTEGER is 28
			-- dividend_withholding_country_tax_flow ordinal

	c_dividend_withholding_nrs_tax_flow: INTEGER is 29
			-- dividend_withholding_nrs_tax_flow ordinal

	c_dividend_tax_refund_flow: INTEGER is 30
			-- dividend_tax_refund_flow ordinal

	c_tender_flow: INTEGER is 31
			-- tender_flow ordinal

	c_stock_dividend_flow: INTEGER is 32
			-- stock_dividend_flow ordinal

	c_inkind_flow: INTEGER is 33
			-- inkind_flow ordinal

	c_outkind_flow: INTEGER is 34
			-- outkind_flow ordinal

	c_mark_to_market_flow: INTEGER is 35
			-- mark_to_market_flow ordinal

	c_dividend_reinvestment_quantity_flow: INTEGER is 36
			-- dividend_reinvestment_quantity_flow ordinal

	c_dividend_reinvestment_money_flow: INTEGER is 37
			-- dividend_reinvestment_money_flow ordinal

	c_rights_exercise_quantity_flow: INTEGER is 38
			-- rights_exercise_quantity_flow ordinal

	c_rights_exercise_money_flow: INTEGER is 39
			-- rights_exercise_money_flow ordinal

	c_ffx_open_flow: INTEGER is 40
			-- ffx_open_flow ordinal

	c_ffx_close_flow: INTEGER is 41
			-- ffx_close_flow ordinal

	c_fixed_deposit_transfer_flow: INTEGER is 42
			-- fixed_deposit_transfer_flow ordinal

	c_redenomination_flow: INTEGER is 43
			-- redenomination_flow ordinal

	c_quantity_intraday_sell_flow: INTEGER is 44
			-- quantity_intraday_sell_flow ordinal

	c_gross_monies_intraday_sell_flow: INTEGER is 45
			-- gross_monies_intraday_sell_flow ordinal

	c_withdrawal_flow: INTEGER is 46
			-- withdrawal_flow ordinal

	c_contribution_flow: INTEGER is 47
			-- contribution_flow ordinal

	c_intrazonal_withdrawal_flow: INTEGER is 48
			-- intrazonal withdrawal_flow ordinal

	c_intrazonal_contribution_flow: INTEGER is 49
			-- intrazonal contribution_flow ordinal

feature -- Status Report

	is_monies_flow: BOOLEAN is
			-- Is this flow for a quantity of currency?
		do
			Result := is_gross_monies_flow or else is_tax_flow or else is_commission_flow or else is_exchange_fee_flow or else is_stamp_duty_flow or else is_dividend_flow or else is_transfer_flow or else is_distribution_flow or else is_debt_reduction_flow or else is_debt_payment_flow or else is_interest_flow or else is_income_flow or else is_income_adjustment_flow or else is_income_unrelated_flow or else is_income_unrelated_adjustment_flow or else is_expense_flow or else is_expense_adjustment_flow or else is_expense_unrelated_flow or else is_expense_unrelated_adjustment_flow or else is_ffx_gain_loss_flow or else is_dividend_withholding_country_tax_flow or else is_dividend_withholding_nrs_tax_flow or else is_dividend_tax_refund_flow or else is_mark_to_market_flow or else is_dividend_reinvestment_money_flow or else is_rights_exercise_money_flow or else is_fixed_deposit_transfer_flow or else is_gross_monies_intraday_sell_flow or else is_withdrawal_flow or else is_contribution_flow or else is_intrazonal_withdrawal_flow or else is_intrazonal_contribution_flow
		end

end
