indexing
	description: "Utilities around RP_FLOWs"
	author: "Portfolio Accounting Tech (sm)"
	last_editor: "$Author: sm $"
	date: "$Date: 2010/01/26 $"
	revision: "$Revision: #1 $"
	archive: "$File: //rose/source/kernel/expert_system/rp_flow_utils.e $"

class
	RP_FLOW_UTILS

feature -- Access

	trade_date_agent: !FUNCTION [ANY, TUPLE [RP_FLOW], ROSE_DATE] is
			-- Trade date from flow agent
		once
			Result := agent trade_date
		end

	trade_date (a_flow: RP_FLOW): ROSE_DATE is
			-- Trade date from `a_flow'
		require
			non_void_flow: a_flow /= Void
		do
			Result := a_flow.contracted_ownership_time
		ensure
			non_void_date: Result /= Void
		end

	settle_date_agent: !FUNCTION [ANY, TUPLE [RP_FLOW], ROSE_DATE] is
			-- Settle date from flow agent
		once
			Result := agent settle_date
		end

	settle_date (a_flow: RP_FLOW): ROSE_DATE is
			-- Settle date from `a_flow'
		require
			non_void_flow: a_flow /= Void
		do
			Result := a_flow.contracted_settlement_time
		ensure
			non_void_date: Result /= Void
		end

end
