indexing

	description:

		"Visitor Pattern for RP_FLOW"

	date: "$Date: 2010/07/19 $"
	sccid: "$Id: //rose/source/kernel/expert_system/aflows/rp_flow_visitor.e#4 $"

deferred class RP_FLOW_VISITOR

inherit

	ANY

feature {RP_FLOW_TYPE} -- Processing

	process_quantity (v: RP_FLOW) is
			-- Process quantity_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_quantity_flow
		deferred
		end

	process_gross_monies (v: RP_FLOW) is
			-- Process gross_monies_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_gross_monies_flow
		deferred
		end

	process_fungible_conversion (v: RP_FLOW) is
			-- Process fungible_conversion_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_fungible_conversion_flow
		deferred
		end

	process_tax (v: RP_FLOW) is
			-- Process tax_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_tax_flow
		deferred
		end

	process_commission (v: RP_FLOW) is
			-- Process commission_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_commission_flow
		deferred
		end

	process_exchange_fee (v: RP_FLOW) is
			-- Process exchange_fee_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_exchange_fee_flow
		deferred
		end

	process_stamp_duty (v: RP_FLOW) is
			-- Process stamp_duty_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_stamp_duty_flow
		deferred
		end

	process_borrow (v: RP_FLOW) is
			-- Process borrow_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_borrow_flow
		deferred
		end

	process_return (v: RP_FLOW) is
			-- Process return_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_return_flow
		deferred
		end

	process_dividend (v: RP_FLOW) is
			-- Process dividend_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_dividend_flow
		deferred
		end

	process_split (v: RP_FLOW) is
			-- Process split_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_split_flow
		deferred
		end

	process_transfer (v: RP_FLOW) is
			-- Process transfer_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_transfer_flow
		deferred
		end

	process_delivery (v: RP_FLOW) is
			-- Process delivery_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_delivery_flow
		deferred
		end

	process_distribution (v: RP_FLOW) is
			-- Process distribution_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_distribution_flow
		deferred
		end

	process_debt_reduction (v: RP_FLOW) is
			-- Process debt_reduction_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_debt_reduction_flow
		deferred
		end

	process_debt_payment (v: RP_FLOW) is
			-- Process debt_payment_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_debt_payment_flow
		deferred
		end

	process_stock_bonus (v: RP_FLOW) is
			-- Process stock_bonus_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_stock_bonus_flow
		deferred
		end

	process_interest (v: RP_FLOW) is
			-- Process interest_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_interest_flow
		deferred
		end

	process_income (v: RP_FLOW) is
			-- Process income_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_income_flow
		deferred
		end

	process_income_adjustment (v: RP_FLOW) is
			-- Process income_adjustment_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_income_adjustment_flow
		deferred
		end

	process_income_unrelated (v: RP_FLOW) is
			-- Process income_unrelated_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_income_unrelated_flow
		deferred
		end

	process_income_unrelated_adjustment (v: RP_FLOW) is
			-- Process income_unrelated_adjustment_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_income_unrelated_adjustment_flow
		deferred
		end

	process_expense (v: RP_FLOW) is
			-- Process expense_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_expense_flow
		deferred
		end

	process_expense_adjustment (v: RP_FLOW) is
			-- Process expense_adjustment_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_expense_adjustment_flow
		deferred
		end

	process_expense_unrelated (v: RP_FLOW) is
			-- Process expense_unrelated_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_expense_unrelated_flow
		deferred
		end

	process_expense_unrelated_adjustment (v: RP_FLOW) is
			-- Process expense_unrelated_adjustment_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_expense_unrelated_adjustment_flow
		deferred
		end

	process_ffx_gain_loss (v: RP_FLOW) is
			-- Process ffx_gain_loss_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_ffx_gain_loss_flow
		deferred
		end

	process_dividend_withholding_country_tax (v: RP_FLOW) is
			-- Process dividend_withholding_country_tax_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_dividend_withholding_country_tax_flow
		deferred
		end

	process_dividend_withholding_nrs_tax (v: RP_FLOW) is
			-- Process dividend_withholding_nrs_tax_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_dividend_withholding_nrs_tax_flow
		deferred
		end

	process_dividend_tax_refund (v: RP_FLOW) is
			-- Process dividend_tax_refund_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_dividend_tax_refund_flow
		deferred
		end

	process_tender (v: RP_FLOW) is
			-- Process tender_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_tender_flow
		deferred
		end

	process_stock_dividend (v: RP_FLOW) is
			-- Process stock_dividend_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_stock_dividend_flow
		deferred
		end

	process_inkind (v: RP_FLOW) is
			-- Process inkind_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_inkind_flow
		deferred
		end

	process_outkind (v: RP_FLOW) is
			-- Process outkind_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_outkind_flow
		deferred
		end

	process_mark_to_market (v: RP_FLOW) is
			-- Process mark_to_market_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_mark_to_market_flow
		deferred
		end

	process_dividend_reinvestment_quantity (v: RP_FLOW) is
			-- Process dividend_reinvestment_quantity_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_dividend_reinvestment_quantity_flow
		deferred
		end

	process_dividend_reinvestment_money (v: RP_FLOW) is
			-- Process dividend_reinvestment_money_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_dividend_reinvestment_money_flow
		deferred
		end

	process_rights_exercise_quantity (v: RP_FLOW) is
			-- Process rights_exercise_quantity_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_rights_exercise_quantity_flow
		deferred
		end

	process_rights_exercise_money (v: RP_FLOW) is
			-- Process rights_exercise_money_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_rights_exercise_money_flow
		deferred
		end

	process_ffx_open (v: RP_FLOW) is
			-- Process ffx_open_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_ffx_open_flow
		deferred
		end

	process_ffx_close (v: RP_FLOW) is
			-- Process ffx_close_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_ffx_close_flow
		deferred
		end

	process_fixed_deposit_transfer (v: RP_FLOW) is
			-- Process fixed_deposit_transfer_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_fixed_deposit_transfer_flow
		deferred
		end

	process_redenomination (v: RP_FLOW) is
			-- Process redenomination_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_redenomination_flow
		deferred
		end

	process_quantity_intraday_sell (v: RP_FLOW) is
			-- Process quantity_intraday_sell_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_quantity_intraday_sell_flow
		deferred
		end

	process_gross_monies_intraday_sell (v: RP_FLOW) is
			-- Process gross_monies_intraday_sell_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_gross_monies_intraday_sell_flow
		deferred
		end

	process_withdrawal (v: RP_FLOW) is
			-- Process withdrawal_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_withdrawal_flow
		deferred
		end

	process_contribution (v: RP_FLOW) is
			-- Process contribution_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_contribution_flow
		deferred
		end

	process_intrazonal_withdrawal (v: RP_FLOW) is
			-- Process intrazonal_withdrawal_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_intrazonal_withdrawal_flow
		deferred
		end

	process_intrazonal_contribution (v: RP_FLOW) is
			-- Process intrazonal_contribution_flow
		require
			non_void_argument: v /= Void
			correct_type: v.type.is_intrazonal_contribution_flow
		deferred
		end

end
