indexing

	description:

		"A Future"

	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #17 $"

deferred class RP_FUTURE [G -> RP_INSTRUMENT]

inherit

	RP_DERIVATIVE [G]
		redefine
			is_future
		end

feature -- Access

	maturity_date: ROSE_DATE
			-- Maturity date

	contract_size: INTEGER
			-- Minimum lot size

feature -- Status

	is_future: BOOLEAN is
			-- `Current' is future
		do
			Result := True
		end

feature {NONE} -- Implementation

	maturity_date_from_date_and_brimsym_month (a_date: ROSE_DATE; a_month: CHARACTER): ROSE_DATE is
			-- Decode the maturity date from brimsym encoded month
		local
			l_month: INTEGER
		do
			inspect a_month
			when '1', '2', '3', '4', '5', '6', '7', '8', '9' then
				l_month := a_month.code - ('0').code
			when 'O' then
				l_month := 10
			when 'N' then
				l_month := 11
			when 'D' then
				l_month := 12
			end
			from
				Result := a_date
			until
				Result.month = l_month
			loop
				Result := Result.month_end
				Result := Result.next_date
			end
			Result := Result.month_end
		end

invariant

	non_void_maturity_date: maturity_date /= Void
	positive_contract_size: contract_size > 0

end
