note

	description:
	"[
		Exchange of instruments in future - those contracts are exchange traded
		Ex: an index future will have two flows:
		1/ flow for the index (RP_FUTURE [RP_INDEX]) - a price is available for the future
		2/ flow for the cash (RP_FUTURE [RP_CURRENCY] - a value is computed for the cash
		No actual exchange happens at the maturity date e.g. we don't receive the underlying instruments of the index; the exchange will post a RG/L using the cash instrument
		The underlying instruments are marked to market (unlike forward) and the RG/L is posted to the account
		
		More info at: http://en.wikipedia.org/wiki/Future_Contract
	]"
	author: "gy"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #10 $"
	path: "$File: //rose/source/kernel/expert_system/aflows/rp_futures_trade.e $"

deferred class RP_FUTURES_TRADE

inherit

	RP_TRADE
		redefine
			make,
			add_commission_and_fees
		end

feature {NONE} -- Initialization

	make (a_system: like generating_system; a_broker: like broker; a_event_date: like agreement_time; a_settle_date: like agreement_time; a_portfolio: like portfolio; a_identifier: like identifier; a_commission: like commission; a_fee: like fee; a_traded_quantity: like traded_quantity; a_gross_quantity: like gross_quantity; a_net_quantity: like net_quantity; a_custody: RP_CUSTODY) is
			-- create a future
		do
				-- contract make stuff
			Precursor (a_system, a_broker, a_event_date, a_settle_date, a_portfolio, a_identifier, a_commission, a_fee, a_traded_quantity, a_gross_quantity, a_net_quantity, a_custody)
			set_type
		end

	set_type is
			-- Set sub-type (Buy, Sell, ...) - this routine is used during creation
		deferred
		end

	add_commission_and_fees (a_custody: RP_CUSTODY) is
			-- <Precursor>
		do
			if portfolio.zone.is_orient then
					-- XXX Only O zone has commission and fees
					-- XXX for futures trades
				Precursor (a_custody)
			end
		end

end
