note

	description:

		"FX trade contract"

	author: "Mark Howard"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #34 $"
	path: "$File: //rose/source/kernel/expert_system/rp_fx.e $"

class RP_FX

inherit

	RP_TRADE
		redefine
			is_foreign_exchange_trade,
			as_foreign_exchange_contract
		end

create

	make

feature {NONE} -- Initialization

	add_exchange_flows (a_quantity: like traded_quantity; a_gross_monies: like gross_quantity; a_net_monies: like net_quantity; a_contracted_ownership_time, a_contracted_settlement_time: ROSE_DATE; a_custody: RP_CUSTODY) is
			-- <Precursor>
		do
			if a_quantity.amount.sign = a_gross_monies.amount.sign then
				add_flow (quantity_flow_type, portfolio.instrument_control (a_custody), broker.instrument_control, a_contracted_ownership_time, a_contracted_settlement_time, a_quantity, a_contracted_ownership_time, 0, -a_quantity)
			else
				add_flow (quantity_flow_type, broker.instrument_control, portfolio.instrument_control (a_custody), a_contracted_ownership_time, a_contracted_settlement_time, a_quantity, a_contracted_ownership_time, 0, a_quantity)
			end
			add_flow (gross_monies_flow_type, broker.instrument_control, portfolio.instrument_control (a_custody), a_contracted_ownership_time, a_contracted_settlement_time, a_gross_monies, a_contracted_ownership_time, 0, a_gross_monies)
		end

feature -- Status Report

	is_foreign_exchange_trade: BOOLEAN is
			-- Is this a contract for a foreign exchange trade?
		once
			Result := True
		end

feature -- Basic Operations

	process (a_processor: RP_CONTRACT_PROCESSOR) is
			-- <Precursor>
		do
			a_processor.process_fx (Current)
		end

feature -- Convert

	as_foreign_exchange_contract: like Current is
			-- This object as a foreign exchange contract
		do
			Result := Current
		end

end
