note

	description:

		"Convert GEDB event to Contracts and Flows"

	author: "Portfolio Accounting Tech"
	last_editor: "$Author: e2 $"
	date: "$Date: 2012/04/17 $"
	revision: "$Revision: #4 $"
	path: "$File: //rose/source/Kernel/expert_system/legacy/contracts/rp_gedb_bank_transfer_converter.e $"

class
	RP_GEDB_BANK_TRANSFER_CONVERTER

inherit
	RP_GEDB_EVENT_TO_CONTRACT_SIMPLE_CONVERTER [RP_GEDB_BANK_TRANSFER, RP_BANK_TRANSFER]

create
	make

feature -- Access

	contract: !RP_BANK_TRANSFER is
			-- <Precursor>
		local
			l_settle_date: ROSE_DATE
		do
			if event.is_divfx then
				l_settle_date := system.manager.legacy.adjusted_cash_dividend_settle_date (settle_date,
					portfolio,
					instrument.country_of_issue (system.manager.reference_system, event_date),
					event.currency,
					event.units_base.sign > -1)
			else
				l_settle_date := settle_date
			end
			create Result.make (
				system,
				event_date,
				identifier,
				portfolio,
				l_settle_date,
				cash_effect_with_sign,
				secondary_cash_effect,
				custody)
		end

end
