note

	description:
	"[
		Cash zonal transfer converter
		
					... snip ...
		           IF(LT .EQ. JXZONE .OR. LT .EQ. JCASHTRN .OR. LT .EQ. 47)THEN
		              CALL RETURN_CURRENCY(IZONE,LT,EVENT.RIEMSYM(1:5),JC,IB)
					... snip ...
		           ELSE IF(LT .EQ. JXZONE) THEN
		              IF(JC_BASE .EQ. JC)THEN
		                 CASHTRANS(JC)=CASHTRANS(JC)+EVENT.CASH_IMPACT
		              ELSE
		                 CASHTRANS(IB)=CASHTRANS(IB)+EVENT.PERF_VALUE
		              END IF
					... snip ...
		
					For event type 24 in GEDB
		
						cash_effect = CASH_IMPACT
						secondary_cash_effect = PERF_VALUE
						
					This is really an FX + transfer
	]"
	author: "gy"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #5 $"
	path: "$File: //rose/source/kernel/expert_system/legacy/contracts/rp_gedb_cash_zonal_transfer_converter.e $"

class RP_GEDB_CASH_ZONAL_TRANSFER_CONVERTER

inherit

	RP_GEDB_EVENT_TO_CONTRACT_SIMPLE_CONVERTER [RP_GEDB_CASH_ZONAL_TRANSFER, RP_CASH_ZONAL_TRANSFER]

create

	make

feature -- Access

	contract: !RP_CASH_ZONAL_TRANSFER is
			-- <Precursor>
		local
			l_base_currency: RP_CURRENCY
			l_converted_amount: RP_MONIES
			l_transferred_amount: RP_MONIES
		do
			if portfolio.code.is_equal ("STAR") or portfolio.code.is_equal ("JFUNDW") then
					-- XXX hard code US as base currency for STAR and JFUNDW
					-- FIXME investigate why
				l_base_currency := system.manager.reference_system.currency_from_iso_code ("USD")
			else
				l_base_currency := portfolio.base_currency (event_date)
			end
			if l_base_currency.is_same (event.currency) then
				l_converted_amount := cash_effect_with_sign
				l_transferred_amount := secondary_cash_effect
			else
				system.manager.log_debug (identifier + " base:" + l_base_currency.name + " event:" + event.currency.name)
				l_converted_amount := secondary_cash_effect
				l_transferred_amount := cash_effect_with_sign
			end
			if l_converted_amount.amount.sign < 0 then
				create Result.make_intrazonal_withdrawal_with_fx (system, event_date, identifier, portfolio, settle_date, l_converted_amount, l_transferred_amount, custody)
			else
				create Result.make_intrazonal_contribution_with_fx (system, event_date, identifier, portfolio, settle_date, -l_converted_amount, -l_transferred_amount, custody)
			end
		end

end
