note

	description:

		"Convert GEDB event to Contracts and Flows"

	author: "Sami Ben-Grine"
	last_editor: "$Author: e2 $"
	date: "$Date: 2012/02/23 $"
	revision: "$Revision: #6 $"
	path: "$File: //rose/source/Kernel/expert_system/legacy/contracts/rp_gedb_distribution_converter.e $"

class RP_GEDB_DISTRIBUTION_CONVERTER

inherit

	RP_GEDB_EVENT_TO_CONTRACT_SIMPLE_CONVERTER [RP_GEDB_DISTRIBUTION, RP_DISTRIBUTION]
	RP_AXAROSENBERG_AWARE
		export
			{NONE} all
		end
	KL_SHARED_EXCEPTIONS
		export
			{NONE} all
		end
create

	make

feature -- Access

	contract: !RP_DISTRIBUTION is
			-- <Precursor>
		local
			l_cost: RP_MONIES
			l_key: MULTI_KEY
			l_costs: DS_HASH_TABLE [RP_MONIES, MULTI_KEY]
		do
			if manager.accounting.is_forwarding_contracts_to_cost_accounting_system then
				if attached {RP_STOCK} instrument as l_stock then
					create l_key.make (<<portfolio, event_date, l_stock.uid, units_base.amount.abs>>)
					l_costs := manager.corporate_action_system.distribution_costs
					l_costs.search (l_key)
					if l_costs.found then
						l_cost := l_costs.found_item
					else
						exceptions.raise ("Could not find distribution corresponding to event " + event.debug_output)
					end
				end
			else
				l_cost := performance_effect_with_sign
			end

			if units.amount < 0 then
				create Result.make_short_position (units_base, units, l_cost, event_date, settle_date, portfolio, identifier, system, custody)
			else
				create Result.make_long_position (units_base, units, l_cost, event_date, settle_date, portfolio, identifier, system, custody)
			end
		end

end
