note

	description:

		"Convert GEDB event to Contracts and Flows"

	author: "Sami Ben-Grine"
	last_editor: "$Author: e2 $"
	date: "$Date: 2012/04/17 $"
	revision: "$Revision: #18 $"
	path: "$File: //rose/source/Kernel/expert_system/legacy/contracts/rp_gedb_dividend_net_of_withholding_tax_converter.e $"

class RP_GEDB_DIVIDEND_NET_OF_WITHHOLDING_TAX_CONVERTER

inherit

	RP_GEDB_EVENT_TO_CONTRACT_SIMPLE_CONVERTER [RP_GEDB_DIVIDEND_NET_OF_WITHHOLDING_TAX, RP_CASH_DIVIDEND]

	RP_GEDB_DIVIDEND_WITHHOLDING_TAX_GROSS_UP

create

	make

feature -- Access

	contract: attached RP_CASH_DIVIDEND is
			-- <Precursor>
		local
			l_gross_and_tax: TUPLE [gross: RP_MONIES; tax: RP_MONIES]
			l_settle_date: ROSE_DATE
		do
			l_gross_and_tax := process_dividend_net_of_withholding_tax (event)
			l_settle_date := system.manager.legacy.adjusted_cash_dividend_settle_date (settle_date,
				portfolio,
				instrument.country_of_issue (system.manager.reference_system, event_date),
				event.currency,
				event.units_base.sign > -1)
			create Result.make (units_base, l_gross_and_tax.gross, l_gross_and_tax.tax, event_date, l_settle_date, portfolio, identifier, system, settle_date, custody)
		end

end
