note

	description:

		"Convert GEDB event to Contracts and Flows"

	author: "Portfolio Accounting Tech"
	last_editor: "$Author: e2 $"
	date: "$Date: 2012/04/17 $"
	revision: "$Revision: #6 $"
	path: "$File: //rose/source/Kernel/expert_system/legacy/contracts/rp_gedb_dividend_tax_refund_converter.e $"

class
	RP_GEDB_DIVIDEND_TAX_REFUND_CONVERTER

inherit
	RP_GEDB_EVENT_TO_CONTRACT_SIMPLE_CONVERTER [RP_GEDB_DIVIDEND_TAX_REFUND, RP_DIVIDEND_TAX_REFUND]

create
	make

feature -- Access

	contract: !RP_DIVIDEND_TAX_REFUND is
			-- <Precursor>
		local
			l_settle_date: ROSE_DATE
		do
			if event.is_divfx or event.is_REIT then
				l_settle_date := settle_date
			else
				l_settle_date := system.manager.legacy.adjusted_cash_dividend_settle_date (settle_date,
					portfolio,
					instrument.country_of_issue (system.manager.reference_system, event_date),
					event.currency,
					event.units_base.sign > -1)
			end
			create Result.make (
				cash_effect_with_sign,
				event_date,
				l_settle_date,
				portfolio,
				identifier,
				system,
				custody)
		end

end
