indexing

	description:

		"Currency Forward GEDB event"

	author: ""
	last_editor: "$Author: it $"
	date: "$Date: 2010/07/19 $"
	revision: "$Revision: #4 $"
	archive: "$File: //rose/source/Kernel/expert_system/aflows/rp_gedb_ffx.e $"

deferred class RP_GEDB_FFX

inherit

	RP_GEDB_FX
		undefine
			contract
		redefine
			traded_quantity,
			gross_quantity
		end

feature -- Access

	traded_quantity: RP_QUANTITY is
			-- Qty received.
		local
			l_instrument: RP_CURRENCY_FORWARD
		do
			if saved_traded_quantity = Void then
				l_instrument := manager.reference_system.currency_forward (secondary_currency, settle_date)
				saved_traded_quantity := l_instrument.quantity (record.secondary_cash_effect)
			end
			Result := saved_traded_quantity
		end

	gross_quantity: RP_QUANTITY is
			-- Qty given.
		local
			l_instrument: RP_CURRENCY_FORWARD
		do
			if saved_gross_quantity = Void then
				l_instrument := manager.reference_system.currency_forward (currency, settle_date)
				saved_gross_quantity := l_instrument.quantity (record.cash_effect)
			end
			Result := saved_gross_quantity
		end

feature -- Implementation

	saved_traded_quantity: RP_QUANTITY
			-- Saved traded quantity

	saved_gross_quantity: RP_QUANTITY
			-- Saved gross quantity

end
