note

	description:

		"GEDB futures sell event"

	author: "Ivan Tarnavsky"
	last_editor: "$Author: it $"
	date: "$Date: 2011/01/19 $"
	revision: "$Revision: #13 $"
	sccid: "$Id: //rose/source/kernel/expert_system/aflows/rp_gedb_futures_sell.e#13 $"

class RP_GEDB_FUTURES_SELL

inherit

	RP_GEDB_FUTURES_TRADE

create {RP_GEDB_EVENT_FACTORY}

	make

feature -- Access

	contract: !RP_PORTFOLIO_CONTRACT is
			-- Create event contracts.
		do
			Result := manager.legacy.futures_sell (Current)
		end

	gross_quantity: RP_QUANTITY is
			-- gross amount before fees and commissions
		local
			l_units: RP_DECIMAL
			l_future_history, l_ccy_history: RP_HOLDING_HISTORY
			l_future_interval, l_ccy_interval: RP_HOLDING_INTERVAL
			l_index_future: RP_INDEX_FUTURE
			l_ccy_future: RP_CURRENCY_FUTURE
		do
			if portfolio.zone.is_united_states then
				Result := currency.monies (performance_effect_with_sign.amount.abs)
			else
				l_index_future ?= instrument
				l_ccy_future := manager.reference_system.currency_future (currency, l_index_future.maturity_date, l_index_future.brimsym.substring (6, 8))
				l_future_history := manager.accounting.portfolio_holdings_for (portfolio, instrument)
				if l_future_history /= Void then
					l_future_interval := l_future_history.witness_interval (event_date)
					l_ccy_history := manager.accounting.portfolio_holdings_for (portfolio, l_ccy_future)
					l_ccy_interval := l_ccy_history.witness_interval (event_date)
					l_units := l_ccy_interval.quantity.amount * units.amount / l_future_interval.quantity.amount
				else
					l_units := units.amount
				end
				Result := l_ccy_future.quantity (l_units.abs.rounded (0))
			end
		end

	net_quantity: RP_MONIES is
			-- net amount
		do
			Result := cash_effect_with_sign
		end

invariant

	is_sell_event_type_2: is_sell_event_type_2

end
