indexing

	description:

		"GEDB futures short"

	date: "$Date: 2010/07/19 $"
	sccid: "$Id: //rose/source/kernel/expert_system/aflows/rp_gedb_futures_short.e#9 $"

class RP_GEDB_FUTURES_SHORT

inherit

	RP_GEDB_FUTURES_TRADE

create {RP_GEDB_EVENT_FACTORY}

	make

feature -- Access

	contract: !RP_PORTFOLIO_CONTRACT is
			-- Create event contracts.
		do
			Result := manager.legacy.futures_short (Current)
		end

	gross_quantity: RP_QUANTITY is
			-- gross amount before fees and commissions
		local
			l_units: RP_QUANTITY
			l_index_future: RP_INDEX_FUTURE
			l_ccy_future: RP_CURRENCY_FUTURE
		do
			if portfolio.zone.is_united_states then
				Result := currency.monies (performance_effect_with_sign.amount.abs)
			else
				l_index_future ?= instrument
				l_ccy_future := manager.reference_system.currency_future (currency, l_index_future.maturity_date, l_index_future.brimsym.substring (6, 8))
				l_units := performance_effect_with_sign.abs - fee - commission
				Result := l_ccy_future.quantity (l_units.amount).abs
			end
		end

	net_quantity: RP_MONIES is
			-- net amount
		do
			Result := cash_effect_with_sign
		end

invariant

	is_short_event_type_21: is_short_event_type_21

end
