indexing

	description:

		"Event type 24 and 40 GEDB record"

	date: "$Date: 2010/07/19 $"
	sccid: "$Id: //rose/source/kernel/expert_system/aflows/rp_gedb_fx.e#19 $"

class RP_GEDB_FX

inherit

	RP_GEDB_TRADE
		redefine
			instrument
		end

create {RP_GEDB_EVENT_FACTORY}

	make

feature -- Access

	instrument: RP_INSTRUMENT is
			-- instrument for this fx
		do
			if instrument_saved = Void then
				instrument_saved := manager.reference_system.currency_from_iso_code (record.secondary_currency)
			end
			Result := instrument_saved
		end

	traded_quantity: RP_QUANTITY is
			-- shares or units traded
		do
			Result := secondary_cash_effect
		end

	gross_quantity: RP_QUANTITY is
			-- gross amount before fees and commissions
		do
			Result := cash_effect_with_sign
		end

	net_quantity: RP_MONIES is
			-- net amount
		do
			Result := cash_effect_with_sign
		end

feature {NONE} -- Implementation

	contract: !RP_PORTFOLIO_CONTRACT is
			-- Create event contracts.
		do
			Result := manager.legacy.fx (Current)
		end

invariant

	is_cash_trn_event_type_40: is_cash_trn_event_type_40

end
