note

	description:

		"Convert GEDB event to Contracts and Flows"

	author: "Portfolio Accounting Tech"
	last_editor: "$Author: e2 $"
	date: "$Date: 2012/04/17 $"
	revision: "$Revision: #3 $"
	path: "$File: //rose/source/Kernel/expert_system/legacy/contracts/rp_gedb_fx_converter.e $"

class
	RP_GEDB_FX_CONVERTER [G -> RP_GEDB_FX, H -> RP_FX create make end]

inherit
	RP_GEDB_TRADE_CONVERTER [G, H]
		redefine
			contract
		end

create
	make

feature -- Access

	contract: !H is
			-- Contract
		local
			l_settle_date: ROSE_DATE
		do
			if event.is_divfx then
				l_settle_date := system.manager.legacy.adjusted_cash_dividend_settle_date (settle_date,
					portfolio,
					instrument.country_of_issue (system.manager.reference_system, event_date),
					event.currency,
					event.units_base.sign > -1)
			else
				l_settle_date := settle_date
			end
			create Result.make (system, broker, event_date, l_settle_date, portfolio, identifier, commission, fee, event.traded_quantity, event.gross_quantity, event.net_quantity, custody)
		end
end
