note

	description:

		"Convert GEDB event to Contracts and Flows"

	author: "Portfolio Accounting Tech"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #5 $"
	path: "$File: //rose/source/Kernel/expert_system/legacy/contracts/rp_gedb_inkind_converter.e $"

class
	RP_GEDB_INKIND_CONVERTER

inherit
	RP_GEDB_EVENT_TO_CONTRACT_SIMPLE_CONVERTER [RP_GEDB_INKIND, RP_CLIENT_CONTRIBUTION]

create
	make

feature -- Access

	contract: !RP_CLIENT_CONTRIBUTION is
			-- <Precursor>
		local
			l_quantity: RP_QUANTITY
			l_fixed_deposit: RP_FIXED_DEPOSIT
			l_external_holding: RP_EXTERNAL_HOLDING
		do
			create Result.make_portfolio_contract (system, event_date, identifier, portfolio)
			l_fixed_deposit ?= instrument
			if l_fixed_deposit /= Void then
				l_quantity := instrument.quantity (performance_effect_with_sign.amount)
			else
				l_quantity := units
			end
			if portfolio.zone.is_united_states then
				create l_external_holding.make (l_quantity, performance_effect_with_sign, Void)
			else
				if performance_effect_with_sign.amount.abs.is_zero  then
					create l_external_holding.make (l_quantity, cash_effect_with_sign.abs, Void)
				else
					create l_external_holding.make (l_quantity, performance_effect_with_sign.abs, Void)
				end
			end
			Result.add_external_holding_flow (inkind_flow_type, event_date, settle_date,
				l_external_holding, portfolio.client_instrument_control, portfolio.instrument_control (custody))
		end

end
