note

	description:

		"Convert GEDB event to Contracts and Flows"

	author: "Portfolio Accounting Tech"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #4 $"
	path: "$File: //rose/source/Kernel/expert_system/legacy/contracts/rp_gedb_outkind_converter.e $"

class
	RP_GEDB_OUTKIND_CONVERTER

inherit
	RP_GEDB_EVENT_TO_CONTRACT_SIMPLE_CONVERTER [RP_GEDB_OUTKIND, RP_CLIENT_WITHDRAWAL]

create
	make

feature -- Access

	contract: !RP_CLIENT_WITHDRAWAL is
			-- <Precursor>
		local
			l_quantity: RP_QUANTITY
			l_external_holding: RP_EXTERNAL_HOLDING
		do
			create Result.make_portfolio_contract (system, event_date, identifier, portfolio)
			refactoring.fixme ("implement cost")
			l_quantity := instrument.quantity (-units.amount)
				-- The sign of the unit is different in event file and gedb
			if portfolio.zone.is_united_states then
				create l_external_holding.make (l_quantity, performance_effect_with_sign, Void)
			else
				create l_external_holding.make (l_quantity, performance_effect_with_sign.abs, Void)
			end
			Result.add_external_holding_flow (outkind_flow_type, event_date, settle_date, l_external_holding,
				portfolio.instrument_control (custody), portfolio.client_instrument_control)
		end

end
