note

	description:

		"Converter for GEDB ROC to contract"

	author: "Sami Ben-Grine"
	last_editor: "$Author: e2 $"
	date: "$Date: 2012/04/17 $"
	revision: "$Revision: #9 $"
	path: "$File: //rose/source/Kernel/expert_system/legacy/contracts/rp_gedb_return_of_capital_converter.e $"

class RP_GEDB_RETURN_OF_CAPITAL_CONVERTER

inherit

	RP_GEDB_EVENT_TO_CONTRACT_SIMPLE_CONVERTER [RP_GEDB_RETURN_OF_CAPITAL, RP_RETURN_OF_CAPITAL]

	RP_GEDB_DIVIDEND_WITHHOLDING_TAX_GROSS_UP

create

	make

feature -- Access

	contract: !RP_RETURN_OF_CAPITAL is
			-- <Precursor>
		local
			l_gross_and_tax: TUPLE [gross: RP_MONIES; tax: RP_MONIES]
			l_settle_date: ROSE_DATE
		do
			if event.is_dividend_event_type_9 then
				l_gross_and_tax := [event.cash_effect_with_sign, Void]
			else
				l_gross_and_tax := process_dividend_net_of_withholding_tax (event)
			end
			l_settle_date := system.manager.legacy.adjusted_cash_dividend_settle_date (settle_date,
				portfolio,
				instrument.country_of_issue (system.manager.reference_system, event_date),
				event.currency,
				event.units_base.sign > -1)
			create Result.make (units_base, l_gross_and_tax.gross, l_gross_and_tax.tax, event_date, l_settle_date, portfolio, identifier, system, custody)
		end

end
