indexing

	description:

		"Doubly-linked list of DailyReturns for global product (composite)"

	date: "$Date: 2009/02/23 $"
	revision: "$Revision: #3 $"

class RP_GLOBAL_PRODUCT_DAILY_RETURNS

inherit

	RP_PRODUCT_DAILY_RETURNS [RP_GLOBAL_PRODUCT, RP_INVESTMENT_ACCOUNT]

create

	make

feature {NONE} -- Implementation

	retrieve_components is
			-- Retrieve list of distinct accounts
		do
			create components.make_equal (17)
			product.investment_accounts.do_all (agent add_account (?))
		end

	add_account (a_interval: RP_INVESTMENT_ACCOUNT_HISTORY_INTERVAL) is
			-- Add portfolio from `a_interval' to `accounts'
		do
			components.force (a_interval.investment_account)
		end

	membership_start_date: ROSE_DATE is
			-- Membership start date
		do
			Result := product.investment_accounts.min_start_date
		end

	membership_end_date: ROSE_DATE is
			-- Membership end date
		do
			Result := product.investment_accounts.max_end_date
		end

	component_name (a_component: RP_INVESTMENT_ACCOUNT): STRING is
			-- Name of `a_component'
		do
			Result := a_component.name
		end

end
