indexing

	description:

		"Government bond"

	date: "$Date: 2010/02/22 $"
	revision: "$Revision: #9 $"

class RP_GOVERNMENT_BOND

inherit

	RP_BOND
		redefine
			uid
		end

create {RP_REFERENCE_SYSTEM}

	make_with_government_issue,
	make_from_listing

feature {NONE} -- Initialization

	make_from_listing (a_brimsym: STRING; a_listing: LISTING) is
			-- Initialize `Current' from `a_listing'
		require
			non_void_args: a_brimsym /= Void and a_listing /= Void
		do
			uid := a_listing.uid
			name := "(" + a_brimsym + ")"
			rose_units := share_units (a_listing)
			brimsym := a_brimsym
			rxrf := a_listing.xrf_code
			zone_mnemonic := a_listing.zone_mnemonic
			entity_id := a_listing.handle
		end

	make_with_government_issue (a_government_issue: GOVERNMENT_ISSUE; a_brimsym: STRING) is
			-- Intialize `Current' from `a_government_issue'
		require
			non_void_args: a_government_issue /= Void and a_brimsym /= Void
		do
			uid := a_government_issue.uid
			name := "(" + a_brimsym + ")"
			rose_units := share_units (a_government_issue)
			brimsym := a_brimsym
			rxrf := a_government_issue.rxrf
			zone_mnemonic := a_government_issue.zone_mnemonic
			entity_id := a_government_issue.handle
		end

feature -- Access

	uid: INTEGER_64
			-- Unique identifier

	zone_mnemonic: CHARACTER
			-- Zone menmonic

	entity_id: INTEGER
			-- Unique Entity id

	rxrf: INTEGER
			-- RXRF

	brimsym: STRING
			-- Brimsym.

feature {NONE} -- Implementation

	name: STRING
			-- Name of the instrument

	country_of_issue (a_ref_system: RP_REFERENCE_SYSTEM; a_date: ROSE_DATE): RP_COUNTRY is
			-- The country of issue for this instrument
		do
			Result := a_ref_system.country_from_iso_code (brimsym.substring (1, 2))
		end

	holding_value_in_currency (a_holding: RP_HOLDING; a_valuator: RP_HOLDING_VALUATOR; a_currency: RP_CURRENCY; a_date: ROSE_DATE; a_bucket:STRING): RP_MONIES is
			-- Value of `a_holding' on `a_date' in `a_currency' as computed by `a_valuator'
		do
			Result := a_valuator.government_bond_value_in_currency (a_holding, a_currency, a_date, a_bucket)
		end

end
