indexing
	description: "Objects which have the notion of multiple rows with associated titles."
	author: ""
	date: "$Date: 2009/03/20 $"
	revision: "$Revision: #5 $"
	archive: "$File: //rose/source/kernel/infrastructure/widgets/grid/rp_grid.e $"

deferred class
	RP_GRID[G]
inherit
	EV_CELL
		rename
			extend as ev_cell_extend
		end
feature {NONE} -- Initialization

	make (a_titles : ARRAY [STRING_GENERAL];a_nodes : ARRAY[RP_GRID_NODE[G]]) is
			-- Create `Current' with titles `a_titles' and fill with `a_nodes'.
		require
			all_nodes_not_void: a_nodes /= Void implies not a_nodes.has (Void)
		deferred
		end

feature -- Status report

	titles : ARRAY[STRING_32]
		-- All titles displayed in `Current'.

	row_count: INTEGER is
			-- Number of rows in Current.
		require
			not_destroyed: not is_destroyed
		deferred
		ensure
			result_not_negative: Result >= 0
		end

feature -- Status setting

	extend(a_node : RP_GRID_NODE[G]) is
			-- Extend with node `a_node'.
		require
			a_node_not_void: a_node /= Void
		deferred
		ensure
			node_inserted: a_node.grid = Current
			row_count_increased: row_count = old row_count + 1
		end

end
