indexing
	description: "HASH_TABLE which uses keys_equal from RP_HASHABLE instead of is_equal to determine key equality"
	author: "Mark Howard"
	last_editor: "$Author: zs $"
	date: "$Date: 2010/04/08 $"
	revision: "$Revision: #2 $"
	archive: "$File: //rose/source/kernel/infrastructure/math/rp_hash_table.e $"

class
	RP_HASH_TABLE [G, K -> RP_HASHABLE]

inherit
	HASH_TABLE [G, K]
		redefine
			same_keys
		end

create
	make

feature --Redefinition

	same_keys (a_search_key, a_key: K): BOOLEAN
			-- Does `a_search_key' equal to `a_key'?
			--| Default implementation is using ~.
		do
			Result := a_search_key.keys_equal (a_key)
		end

end
