indexing

	description:

		"Holding in an instument"

	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #18 $"

class RP_HOLDING

inherit

	DEBUG_OUTPUT

create

	make

feature {NONE} -- Initialization

	make (a_quantity: like quantity; a_control: like control) is
			-- Initialize `Current'.
		require
			non_void_quantity: a_quantity /= Void
			control_not_void: a_control /= Void
		do
			quantity := a_quantity
			control := a_control
		ensure
			quantity_set: quantity = a_quantity
			control_set: control = a_control
		end

feature -- Access

	quantity: RP_QUANTITY
			-- Quantity held

	control: RP_INSTRUMENT_CONTROL
			-- Holding instrument control

feature -- Output

	debug_output: STRING is
			-- Debug information
		do
			create Result.make_empty
			if quantity /= Void then
				Result.append (quantity.debug_output)
			end
			Result.append_character (' ')
			if control /= Void then
				Result.append (control.debug_output)
			end
		end

invariant

	quantity_not_void: quantity /= Void
	control_not_void: control /= Void

end -- class RP_HOLDING
