indexing

	description:

		"Factory class for Holding Valuators"

	date: "$Date: 2010/04/13 $"
	sccid: "$Id: //rose/source/kernel/expert_system/valuators/rp_holding_valuator_factory.e#3 $"

deferred class RP_HOLDING_VALUATOR_FACTORY

feature -- Factory methods

	portfolio_holding_valuator (a_portfolio: RP_PORTFOLIO): RP_HOLDING_VALUATOR is
			-- Create valuator for `a_portfolio'
		require
			non_void_portfolio: a_portfolio /= Void
		deferred
		ensure
			non_void_valuator: Result /= Void
		end

	portfolio_holding_valuator_with_internal_prices (a_portfolio: RP_PORTFOLIO; a_internal_prices: PAIR [STRING, DS_HASH_TABLE [RP_PERFORMANCE_DAILY_VALUES, ROSE_DATE]]): RP_HOLDING_VALUATOR is
			-- Create valuator for `a_portfolio'
		require
			non_void_portfolio: a_portfolio /= Void
		deferred
		ensure
			non_void_valuator: Result /= Void
		end

	equity_pricing_algorithm (a_portfolio: RP_PORTFOLIO): RP_PRICING_ALGORITHM [RP_STOCK] is
			-- `a_portfolio' specific stock pricing algorithm
		require
			non_void_portfolio: a_portfolio /= Void
		deferred
		ensure
			non_void_pricing_algorith: Result /= Void
		end

end
