indexing
	description: "Entry in the rights overrides"
	author: "Portfolio Accounting Tech"
	last_editor: "$Author: bn $"
	date: "$Date: 2014/02/19 $"
	revision: "$Revision: #2 $"
	path: "$File: //rose/source/kernel/capital_actions/elections/rp_including_excluding_rights_parm.e $"

class
	RP_INCLUDING_EXCLUDING_RIGHTS_PARM

inherit

	RP_EVENT_TYPE_CONSTANTS
		export {NONE} all end

	DEBUG_OUTPUT

	ROSE_CAPACT_DATE_USE

create
	make

feature {NONE} -- Initialization

	make (a_record: INCLUDING_EXCLUDING_RIGHTS_PARM_RECORD)
		-- Create from 'a_record'
		require
			record_not_void: a_record /= Void
			valid_clicode: (a_record.clicode /= Void) and then (not a_record.clicode.is_empty)
		do
			create brimsym.make_from_string (a_record.brimsym)
			brimsym.prune_all_trailing (' ')
			ex_date := safe_date_from_ccyymmdd (a_record.ex_date)
			create clicode.make_from_string (a_record.clicode)
			clicode.prune_all_trailing (' ')
			create description.make_from_string (a_record.description)
			description.prune_all_trailing (' ')
			create cash_raised_per_share.make_from_double (a_record.cash_raised_per_share)
			pay_date := safe_date_from_ccyymmdd (a_record.pay_date)
		end

feature -- Access

	brimsym: !STRING
		-- Brimsym

	ex_date: !ROSE_DATE
		-- Ex Date

	clicode: !STRING
		-- Portfolio code

	description: STRING
		-- Description

	cash_raised_per_share: !RP_DECIMAL
		-- Cash raised per share

	pay_date: ROSE_DATE
		-- Payment date


feature -- Output

	debug_output: STRING is
			-- <Precursor>
		do
			create Result.make_empty
			Result.Append (brimsym); Result.append ("|")
			Result.Append (ex_date.out); Result.append ("|")
			Result.Append (clicode.out); Result.Append ("|")
			Result.Append (description.out); Result.Append ("|")
			Result.Append (cash_raised_per_share.out); Result.Append ("|")
			Result.Append (pay_date.out);
		end

end
