indexing

	description:

		"Index Future"

	date: "$Date: 2010/02/26 $"
	fileid: "$Id: //rose/source/kernel/expert_system/rp_index_future.e#18 $"

class RP_INDEX_FUTURE

inherit

	RP_FUTURE [RP_INDEX]
		rename
			underlying as index
		redefine
			valid_underlying
		end

	ROSE_UNITS_ENVIRONMENT
		export
			{NONE} all
		undefine
			is_equal
		end

create

	make

feature {NONE} -- Initialization

	make (a_future: FUTURE; a_brimsym: like brimsym; a_date: ROSE_DATE; a_index: like index) is
			-- Initialize `Current'
		require
			non_void_args: a_future /= Void and a_brimsym /= Void and a_date /= Void
		do
			index := a_index
			maturity_date := maturity_date_from_date_and_brimsym_month (a_date, a_brimsym.item (9))
			entity_id := a_future.handle
			brimsym := a_brimsym
			rose_units := share_units (a_future) / date_units (maturity_date)
			if a_future.lot_size_most_recent_key (a_date) /= Void and then a_future.lot_size_most_recent_key (a_date).is_integer then
				contract_size := a_future.lot_size_most_recent_key (a_date).to_integer
			else
				contract_size := 1
			end
			name := brimsym
		end

feature -- Query

	entity_id: INTEGER
			-- Underlying entity id

	name: STRING
			-- Descriptive name.

	brimsym: STRING
			-- Brimsym

	valid_underlying: BOOLEAN is
			-- <Precursor>
		do
			Result := entity_id /= 0
		end

feature {NONE} -- Implementation

	holding_value_in_currency (a_holding: RP_HOLDING; a_valuator: RP_HOLDING_VALUATOR; a_currency: RP_CURRENCY; a_date: ROSE_DATE; a_bucket: STRING): RP_MONIES is
			-- Value of `a_holding' on `a_date' in `a_currency' as computed by `a_valuator'
		do
			Result := a_valuator.index_future_value_in_currency (a_holding, a_currency, a_date, a_bucket)
		end

	country_of_issue (a_ref: RP_REFERENCE_SYSTEM; a_date: ROSE_DATE): RP_COUNTRY is
			-- country
		do
			Result := a_ref.country_from_iso_code (brimsym.substring (1, 2))
		end

end
