indexing

	description:

		"Index Futures Market data source"

	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #4 $"

class RP_INDEX_FUTURE_MARKET_DATA_SOURCE

inherit

	RP_MARKET_DATA_SOURCE_LAST_RECORD_SEARCH [RP_INDEX_FUTURE]

	ROSE_AWARE
		export {NONE} all end

	ROSE_CONSTANTS
		export {NONE} all end

create

	make

feature {NONE} -- Initialization

	make (a_reference_system: like reference_system) is
			-- Initialize `Current'
		require
			non_void_args: a_reference_system /= Void
		do
			reference_system := a_reference_system
		ensure
			reference_system_set: reference_system = a_reference_system
		end

feature -- Query

	snapshot (a_future: RP_INDEX_FUTURE; a_date: ROSE_DATE): RP_MARKET_DATA_RECORD is
			-- Market data for `a_future' on `a_date'.
		local
			l_future: FUTURE
			l_price_record: RMDAT_PRICE_RECORD
		do
			l_future := context.future_accessor.entity (a_future.entity_id)
			if l_future /= Void then
				l_price_record := l_future.price_record (a_date)
				if l_price_record /= Void then
					Result := create {RP_LISTING_MARKET_DATA}.make_with_legacy_price_record (reference_system, a_future, l_price_record)
				end
			end
		end

feature {NONE} -- Implementation

	reference_system: RP_REFERENCE_SYSTEM
			-- Reference system

end
