note

	description:

		"Short side Inlieu"

	author: "Ivan Tarnavsky"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #3 $"
	path: "$File: //rose/source/kernel/contracts/trades/rp_inlieu_short.e $"

class RP_INLIEU_SHORT

inherit

	RP_INLIEU

create

	make

feature -- Access

	is_long_side: BOOLEAN is False
			-- <Precursor>

feature {NONE} -- Implementation

	add_inlieu_flows (a_portfolio: RP_PORTFOLIO; a_broker: RP_BROKER; a_quantity: RP_QUANTITY; a_gross_monies, a_net_monies: RP_MONIES; a_event_date, a_settle_date: ROSE_DATE; a_custody: RP_CUSTODY) is
			-- <Precursor>
		do
			add_flow (quantity_flow_type, a_broker.instrument_control, a_portfolio.instrument_control (a_custody), a_event_date, a_settle_date, a_quantity, a_event_date, 0, a_net_monies)
			add_flow (return_flow_type, a_portfolio.instrument_control (a_custody), a_portfolio.prime_broker.instrument_control, a_event_date, a_settle_date, a_quantity, a_event_date, 0, a_net_monies)
			add_flow (return_flow_type, a_portfolio.instrument_control (a_custody), a_portfolio.prime_broker.instrument_control, a_event_date, a_settle_date, -a_quantity, a_event_date, 0, -a_net_monies)
			add_flow (gross_monies_flow_type, a_portfolio.instrument_control (a_custody), a_broker.instrument_control, a_event_date, a_settle_date, a_gross_monies, a_event_date, 0, a_gross_monies)
		ensure then
			four_flows_added: flows.count = 4 + old flows.count
		end

end
