note

	description:

		"Interest paid"

	author: "Ivan Tarnavsky"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #12 $"
	path: "$File: //rose/source/kernel/expert_system/rp_interest.e $"

class RP_INTEREST

inherit

	RP_CUSTODIAN_CONTRACT
		redefine
			is_interest,
			as_interest
		end

	RP_SWEPT_CONTRACT [RP_INTEREST]
		undefine
			is_equal
		end

create

	make

feature {NONE} -- Initialization

	make (a_quantity: RP_QUANTITY; a_event_date, a_settle_date: ROSE_DATE; a_portfolio: like portfolio;
		a_identifier: like identifier; a_system: like generating_system; a_custody: RP_CUSTODY) is
			-- Create
		require
			a_quantity_not_void: a_quantity /= Void
			a_event_date_not_void: a_event_date /= Void
			a_settle_date_not_void: a_settle_date /= Void
			a_portfolio_not_void: a_portfolio /= Void
			a_identifier_not_void: a_identifier /= Void
			a_system_not_void: a_system /= Void
			a_custody_not_void: a_custody /= Void
		do
				-- Contract
			make_portfolio_contract (a_system, a_event_date, a_identifier, a_portfolio)
				-- Flows
			add_flow (interest_flow_type, unknown_instrument_control, a_portfolio.instrument_control (a_custody), a_event_date, a_settle_date, a_quantity, a_event_date, 0, Void)
			custody := a_custody
		ensure
			custody_set: custody = a_custody
		end

feature -- Basic Operations

	process (a_processor: RP_CONTRACT_PROCESSOR) is
			-- <Precursor>
		do
			a_processor.process_interest (Current)
		end

feature -- Status Report

	is_interest: BOOLEAN is
			-- Is `Current' a interest?
		do
			Result := True
		end

feature -- Conversion

	as_interest: RP_INTEREST is
			-- `Current' as interest
		do
			Result := Current
		end

feature {RP_CUSTODIAN_SYSTEM} -- Access

	custody: RP_CUSTODY
			-- Who has custody of the interest?

invariant
	custody_set: custody /= Void
end
