indexing

	description:

		"Date interval with an entity and decimal weight"

	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #2 $"

deferred class RP_INTERVAL [G]

feature {NONE} -- Initialization

	make (a_entity: like entity; a_start_date: like start_date; a_end_date: like end_date; a_weight: like weight) is
			-- Initialize `Current'
		require
			non_void_entity: a_entity /= Void
			non_void_weight: a_weight /= Void
			non_void_start_date: a_start_date /= Void
			non_void_end_date: a_end_date /= Void
			consistent_dates: a_start_date <= a_end_date
		do
			entity := a_entity
			start_date := a_start_date
			end_date := a_end_date
			weight := a_weight
		ensure
			entity_set: entity = a_entity
			start_date_set: start_date = a_start_date
			end_date_set: end_date = a_end_date
			weight_set: weight = a_weight
		end

feature -- Access

	entity: G
			-- Entity

	weight: RP_DECIMAL
			-- Weight

	start_date: ROSE_DATE
			-- Start datetime (included)

	end_date: ROSE_DATE
			-- End datetime (excluded)

feature -- Query

	brackets (a_date: ROSE_DATE): BOOLEAN is
			-- Is `a_date' inside the interval?
		require
			non_void_date: a_date /= Void
		deferred
		end

invariant

	non_void_entity: entity /= Void
	non_void_weight: weight /= Void
	non_void_start_date: start_date /= Void
	non_void_end_date: end_date /= Void
	consistent_dates: start_date <= end_date

end
