indexing

	description:

		"Investment management company"

	date: "$Date: 2009/04/03 $"
	revision: "$Revision: #11 $"

deferred class RP_INVESTMENT_MANAGEMENT_COMPANY

inherit

	RP_PARTY

feature -- Status report

	is_unknown: BOOLEAN is
			-- Is `Current' an unknown IMC?
		do
			-- No!
		end

feature -- Taskflow

	take_on_account (a_account: RP_INVESTMENT_ACCOUNT) is
			-- Initiatte account take-on on `a_account'.
		require
			acct_exists: a_account /= Void
		do
			-- DO NOTHING
			-- LET DESCENDANTS DECIDE WHAT TO DO
		end

feature -- Access

	name: STRING is
			-- Descriptive name.
		do
			if gcdb_imc /= Void then
				Result := gcdb_imc.name
			else
				Result := "Unknown"
			end
		end

	code: STRING is
			-- Unique code.
		do
			if gcdb_imc /= Void then
				Result := gcdb_imc.code
			else
				Result := "Unknown"
			end
		end

	location: RP_COUNTRY is
			-- Country where office is physically situated
		deferred
		ensure
			result_not_void: Result /= Void
		end

feature {NONE} -- Implementation

	gcdb_imc: GCDB_IMC
			-- Underlying gcdb entity.

	make_with_gcdb_imc (a_imc: GCDB_IMC) is
			-- Initialize `Current'.
		do
			gcdb_imc := a_imc
		end

	reference_system: RP_REFERENCE_SYSTEM
			-- reference system which created `Current'

invariant

	code_not_void: code /= Void
	reference_system_not_void: reference_system /= Void

end
