note
	description: "Abstraction for Investment Manager"
	author: "Unknown"
	last_editor: "$Author: sm $"
	date: "$Date: 2013/06/27 $"
	revision: "$Revision: #29 $"
	path: "$File: //rose/source/kernel/expert_system/rp_investment_manager.e $"

deferred class RP_INVESTMENT_MANAGER

inherit

	RP_ELOG_CLIENT

	ANY

feature -- Access

	accounting: like accounting_system_template is
			-- portfolio accounting system for investment manager
		do
			if manager.accounting_saved = Void then
				manager.new_accounting
			end
			Result := manager.accounting_saved
		ensure
			non_void_result: Result /= Void
		end

	adjustment_system: RP_ADJUSTMENT_SYSTEM is
			-- adjustment system for investment manager
		do
			if manager.adjustment_system_saved = Void then
				manager.new_adjustment_system
			end
			Result := manager.adjustment_system_saved
		ensure
			non_void_result: Result /= Void
		end

	brokers: RP_BROKER_SYSTEM is
			-- broker system for investment manager
		do
			if manager.brokers_saved = Void then
				manager.new_brokers
			end
			Result := manager.brokers_saved
		ensure
			non_void_result: Result /= Void
		end

	client_services: RP_CLIENT_SERVICES is
			-- client services system for investment manager
		do
			if manager.client_services_saved = Void then
				manager.new_client_services
			end
			Result := manager.client_services_saved
		ensure
			non_void_result: Result /= Void
		end

	client_system: RP_CLIENT_SYSTEM is
			-- client system for investment manager
		do
			if manager.client_system_saved = Void then
				manager.new_client_system
			end
			Result := manager.client_system_saved
		ensure
			non_void_result: Result /= Void
		end

	compliance_system: RP_COMPLIANCE_SYSTEM is
			-- compliance system for investment manager
		do
			if manager.compliance_system_saved = Void then
				manager.new_compliance_system
			end
			Result := manager.compliance_system_saved
		ensure
			non_void_result: Result /= Void
		end

	corporate_action_election_system: like corporate_action_election_system_template is
			-- Portfolio options selection for corporate action
		do
			if manager.corporate_action_election_system_saved = Void then
				manager.new_corporate_action_election_system
			end
			Result := manager.corporate_action_election_system_saved
		ensure
			non_void_result: Result /= Void
		end

	corporate_action_processing_system: like corporate_action_processing_template is
			-- Corporate Action generator
		do
			if manager.corporate_action_processing_system_saved = Void then
				manager.new_corporate_action_processing_system
			end
			Result := manager.corporate_action_processing_system_saved
		ensure
			non_void_result: Result /= Void
		end

	corporate_action_system: like corporate_action_template is
			-- corporate action system for investment manager
		do
			if manager.corporate_action_system_saved = Void then
				manager.new_corporate_action_system
			end
			Result := manager.corporate_action_system_saved
		ensure
			non_void_result: Result /= Void
		end

	custodian_system: RP_CUSTODIAN_SYSTEM is
			-- custodian system for investment manager
		do
			if manager.custodian_system_saved = Void then
				manager.new_custodian_system
			end
			Result := manager.custodian_system_saved
		ensure
			non_void_result: Result /= Void
		end

	financial_system: RP_FINANCIAL_SYSTEM is
			-- financial system for investment manager
		do
			if manager.financial_system_saved = Void then
				manager.new_financial_system
			end
			Result := manager.financial_system_saved
		ensure
			non_void_result: Result /= Void
		end

	legacy: RP_LEGACY_SYSTEM is
			-- legacy system for investment manager
		do
			if manager.legacy_system_saved = Void then
				manager.new_legacy_system
			end
			Result := manager.legacy_system_saved
		ensure
			non_void_result: Result /= Void
		end

	marketing: RP_MARKETING is
			-- marketing system for investment manager
		do
			if manager.marketing_saved = Void then
				manager.new_marketing
			end
			Result := manager.marketing_saved
		ensure
			non_void_result: Result /= Void
		end

	market_system: RP_MARKET_SYSTEM is
			-- market system for investment manager
		do
			if manager.market_system_saved = Void then
				manager.new_market_system
			end
			Result := manager.market_system_saved
		ensure
			non_void_result: Result /= Void
		end

	model_system: RP_MODEL_SYSTEM is
			-- system for managing model info
		do
			if model_system_saved = Void then
				create model_system_saved.make (Current)
			end
			Result := model_system_saved
		ensure
			non_void_result: Result /= Void
		end

	order_management_system: RP_ORDER_MANAGEMENT_SYSTEM is
			-- order management system for investment manager
		do
			if manager.oms_saved = Void then
				manager.new_oms
			end
			Result := manager.oms_saved
		ensure
			non_void_result: Result /= Void
		end

	end_of_day_nav: RP_END_OF_DAY_NAV is
			-- End of day NAV
		once
			create Result
		end

	beginning_of_day_positions: RP_POSITIONS_SYSTEM is
			-- Positions where accounting date means the beginning of day
		do
			if manager.beginning_of_day_positions_system_saved = Void then
				manager.new_beginning_of_day_positions_system
			end
			Result := manager.beginning_of_day_positions_system_saved
		ensure
			non_void_result: Result /= Void
		end

	end_of_day_positions: RP_END_OF_DAY_POSITIONS is
			-- Positions where accounting date means end of day
		do
			if manager.end_of_day_positions_system_saved = Void then
				manager.new_end_of_day_positions_system
			end
			Result := manager.end_of_day_positions_system_saved
		ensure
			non_void_result: Result /= Void
		end

	performance_system: RP_PERFORMANCE_SYSTEM is
			-- performance system for investment manager
		do
			if manager.performance_system_saved = Void then
				manager.new_performance_system
			end
			Result := manager.performance_system_saved
		ensure
			non_void_result: Result /= Void
		end

	personnel: RP_HUMAN_RESOURCES_SYSTEM is
			-- human resources system for investment manager
		do
			if manager.personnel_saved = Void then
				manager.new_personnel
			end
			Result := manager.personnel_saved
		ensure
			non_void_result: Result /= Void
		end

	portfolio_engineering: RP_PORTFOLIO_ENGINEERING_SYSTEM is
			-- portfolio engineering system for investment manager
		do
			if manager.portfolio_engineering_saved = Void then
				manager.new_portfolio_engineering
			end
			Result := manager.portfolio_engineering_saved
		ensure
			non_void_result: Result /= Void
		end

	portfolio_system: like portfolio_system_template is
			-- Portfolio system
		do
			if manager.portfolio_system_saved = Void then
				manager.new_portfolio_system
			end
			Result := manager.portfolio_system_saved
		end

	recommendation_system: like recommendation_system_template is
			-- recommendation system for investment manager
		do
			if manager.recommendation_system_saved = Void then
				manager.new_recommendation_system
			end
			Result := manager.recommendation_system_saved
		ensure
			non_void_result: Result /= Void
		end

	reference_system: like reference_system_template is
			-- reference system for investment manager
		do
			if manager.reference_system_saved = Void then
				manager.new_reference_system
			end
			Result := manager.reference_system_saved
		ensure
			non_void_result: Result /= Void
		end

	reporting: RP_REPORTING_SYSTEM is
			-- reporting system for investment manager
		do
			if manager.reporting_saved = Void then
				manager.new_reporting
			end
			Result := manager.reporting_saved
		ensure
			non_void_result: Result /= Void
		end

	trading: like trading_template is
			-- trading system for investment manager
		do
			if manager.trading_saved = Void then
				manager.new_trading
			end
			Result := manager.trading_saved
		ensure
			non_void_result: Result /= Void
		end

	cost_accounting_system: like cost_accounting_system_template is
			-- Cost accounting system
		do
			if manager.cost_accounting_system_saved = Void then
				manager.new_cost_accounting_system
			end
			Result := manager.cost_accounting_system_saved
		ensure
			non_void_result: Result /= Void
		end

feature -- Basic Operations

	post (a_contract: RP_PORTFOLIO_CONTRACT) is
			-- create msg from a_contract and dispatch it to 'a_manager'
		local
			l_msg: RP_PORTFOLIO_MESSAGE
		do
			if a_contract /= Void then
				create l_msg.make (a_contract, Void)
				l_msg.dispatch (Current)
			end
		end

feature {RP_INVESTMENT_MANAGER} -- Implementation

	manager: RP_INVESTMENT_MANAGER is
			-- rp_investment_manager to be implemented by descendant
		deferred
		end

	accounting_saved: like accounting
			-- Saved instance

	new_accounting is
			-- Create new instance
		do
			create accounting_saved.make (Current)
		end

	adjustment_system_saved: like adjustment_system
			-- Saved instance

	new_adjustment_system is
			-- Create new instance
		do
			create adjustment_system_saved.make (Current)
		end

	brokers_saved: like brokers
			-- Saved instance

	new_brokers is
			-- Create new instance
		do
			create brokers_saved.make (Current)
		end

	client_services_saved: like client_services
			-- Saved instance

	new_client_services is
			-- Create new instance
		do
			create client_services_saved.make (Current)
		end

	client_system_saved: like client_system
			-- Saved instance

	new_client_system is
			-- Create new instance
		do
			create client_system_saved.make (Current)
		end

	compliance_system_saved: like compliance_system
			-- Saved instance

	new_compliance_system is
			-- Create new instance
		do
			create compliance_system_saved.make (Current)
		end

	corporate_action_election_system_saved: like corporate_action_election_system
			-- Saved instance

	new_corporate_action_election_system is
			-- Create new instance
		do
			create corporate_action_election_system_saved.make (Current)
		end

	corporate_action_processing_system_saved: like corporate_action_processing_system
			-- Saved instance

	new_corporate_action_processing_system is
			-- Create new instance
		do
			create corporate_action_processing_system_saved.make (Current)
		end

	corporate_action_system_saved: like corporate_action_system
			-- Saved instance

	new_corporate_action_system is
			-- Create new instance
		do
			create corporate_action_system_saved.make (Current)
		end

	custodian_system_saved: like custodian_system
			-- Saved instance

	new_custodian_system is
			-- Create new instance
		do
			create custodian_system_saved.make (Current)
		end

	financial_system_saved: like financial_system
			-- Saved instance

	new_financial_system is
			-- Create new instance
		do
			create financial_system_saved.make (Current)
		end

	legacy_system_saved: like legacy
			-- Saved instance

	new_legacy_system is
			-- Create new instance
		do
			create legacy_system_saved.make (Current)
		end

	marketing_saved: like marketing
			-- Saved instance

	new_marketing is
			-- Create new instance
		do
			create marketing_saved.make (Current)
		end

	market_system_saved: like market_system
			-- Saved instance

	new_market_system is
			-- Create new instance
		do
			create market_system_saved.make (Current)
		end

	oms_saved: like order_management_system
			-- Saved instance

	new_oms is
			-- Create new instance
		do
			create oms_saved.make (Current)
		end

	personnel_saved: like personnel
			-- Saved instance

	new_personnel is
			-- Create new instance
		do
			create personnel_saved.make (Current)
		end

	performance_system_saved: like performance_system
			-- Saved instance

	new_performance_system is
			-- Create new instance
		do
			create performance_system_saved.make (Current)
		end

	portfolio_engineering_saved: like portfolio_engineering
			-- Saved instance

	new_portfolio_engineering is
			-- Create new instance
		do
			create portfolio_engineering_saved.make (Current)
		end

	portfolio_system_saved: like portfolio_system
			-- Saved instance

	new_portfolio_system is
			-- Create new instance
		do
			create portfolio_system_saved.make (Current)
		end

	beginning_of_day_positions_system_saved: RP_BEGINNING_OF_DAY_POSITIONS
			-- Saved instance

	new_beginning_of_day_positions_system is
			-- Create new instance
		do
			create beginning_of_day_positions_system_saved.make (create {RP_POSITIONS_SYSTEM_IMPLEMENTATION})
		ensure
			beginning_of_day_positions_system_saved_not_void: beginning_of_day_positions_system_saved /= Void
		end

	end_of_day_positions_system_saved: RP_END_OF_DAY_POSITIONS
			-- Saved instance

	new_end_of_day_positions_system is
			-- Create new instance
		do
			create end_of_day_positions_system_saved.make (create {RP_POSITIONS_SYSTEM_IMPLEMENTATION})
		ensure
			end_of_day_positions_system_saved_not_void: end_of_day_positions_system_saved /= Void
		end

	recommendation_system_saved: like recommendation_system
			-- Saved instance

	new_recommendation_system is
			-- Create new instance
		do
			create recommendation_system_saved.make (Current)
		end

	reference_system_saved: like reference_system
			-- Saved instance

	new_reference_system is
			-- Create new instance
		do
			create reference_system_saved.make
		end

	reporting_saved: like reporting
			-- Saved instance

	new_reporting is
			-- Create new instance
		do
			create reporting_saved.make (Current)
		end

	trading_saved: like trading
			-- Saved instance

	new_trading is
			-- Create new instance
		do
			create trading_saved.make (Current)
		end

	model_system_saved: like model_system
			-- Saved instance

	cost_accounting_system_saved: like cost_accounting_system
			-- Saved instance

	new_cost_accounting_system is
			-- Create new instance
		do
			create cost_accounting_system_saved.make (Current)
		end

feature {NONE} -- Templates

	accounting_system_template: RP_ACCOUNTING_SYSTEM is
			-- template
		do
		end

	trading_template: RP_TRADING_SYSTEM is
			-- template
		do
		end

	corporate_action_template: RP_CORPORATE_ACTION_SYSTEM is
			-- template
		do
		end

	corporate_action_processing_template: RP_CORPORATE_ACTION_PROCESSING_SYSTEM is
			-- template
		do
		end

	recommendation_system_template: RP_RECOMMENDATION_SYSTEM is
			-- template
		do
		end

	reference_system_template: RP_REFERENCE_SYSTEM is
			-- template
		do
		end

	corporate_action_processing_system_template: RP_CORPORATE_ACTION_PROCESSING_SYSTEM is
			-- Template
		do
		end

	corporate_action_election_system_template: RP_CORPORATE_ACTION_ELECTION_SYSTEM is
			-- Template
		do
		end

	portfolio_system_template: RP_PORTFOLIO_SYSTEM is
			-- Template
		do
		end

	cost_accounting_system_template: RP_COST_ACCOUNTING_SYSTEM is
			-- template
		do
		end

end
