note

	description:

		"Currency market as implementd in VMS%'s performance programs"

	id: "$Id: //rose/source/kernel/expert_system/legacy/rp_legacy_perf_fx.e#5 $"
	author: "Ivan Tarnavsky"
	last_editor: "$Author: c4 $"
	date: "$Date: 2014/10/21 $"
	revision: "$Revision: #5 $"
	path: "$File: //rose/source/kernel/expert_system/legacy/rp_legacy_perf_fx.e $"

class RP_LEGACY_PERF_FX

inherit

	MARKET

	ROSE_LEGACY_UNDEFINED
		export {NONE} all end

feature -- Query

	exchange_rate_asof (a_fcu, a_bcu: CURRENCY; a_date: ROSE_DATE; a_asof: detachable ROSE_DATE): DOUBLE
			-- Spot rate from `a_bcu' to `a_fcu' on `a_date', as of `a_asof';
			-- If `a_asof' is `Void' then our latest data is used.
		local
			l_date_iter, l_min_date: ROSE_DATE
			l_source: MARKET
		do
			if a_fcu = a_bcu or else a_fcu.is_equal (a_bcu) then
				Result := 1
			else
				Result := Undefined_double
				create l_min_date.make_ccyymmdd (a_date.ccyymmdd)
				l_min_date := l_min_date.plus_n_date (-60)
				if ((a_bcu.iso.is_equal ("USD") and a_fcu.iso.is_equal ("CAD")) or (a_bcu.iso.is_equal ("CAD") and a_fcu.iso.is_equal ("USD"))) and a_date.ccyymmdd >= 1995_05_01 and a_date.ccyymmdd < 1995_08_01 then
					l_source := extel
				elseif ((a_bcu.iso.is_equal ("USD") and a_fcu.iso.is_equal ("GBP")) or (a_bcu.iso.is_equal ("GBP") and a_fcu.iso.is_equal ("USD"))) and a_date.ccyymmdd >= 1995_05_01 and a_date.ccyymmdd < 1995_08_01 then
					l_source := extel
				elseif ((a_bcu.iso.is_equal ("USD") and a_fcu.iso.is_equal ("JPY")) or (a_bcu.iso.is_equal ("JPY") and a_fcu.iso.is_equal ("USD"))) and a_date.ccyymmdd >= 1995_05_01 and a_date.ccyymmdd < 1995_08_01 then
					l_source := extel
				else
					l_source := default_fx
				end
				from
					create l_date_iter.make_ccyymmdd (a_date.ccyymmdd)
				until
					l_date_iter < l_min_date or is_defined_double (Result)
				loop
					Result := l_source.exchange_rate_asof (a_fcu, a_bcu, l_date_iter, a_asof)
					l_date_iter := l_date_iter.previous_date
				end
			end
		end

feature {NONE} -- Implementation

	default_fx: AXA_ROSENBERG_DEFAULT_MARKET is
			-- Default AXAR currency market
		once
			create Result
		end

	extel: EXTEL_CURRENCY_MARKET is
			-- EXTEL currency market
		once
			create Result
		end

end
