note

	description:

		"Trade of a listed security - this should be merged with RP_EQUITY_TRADE"

	author: "Sami Ben-Grine"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #6 $"
	path: "$File: //rose/source/Kernel/expert_system/rp_listed_trade.e $"

deferred class RP_LISTED_TRADE

inherit

	RP_TRADE
		redefine
			make,
			gross_quantity, net_quantity
		end

feature {NONE} -- Initialization

	make (a_system: like generating_system; a_broker: like broker; a_event_date: like agreement_time; a_settle_date: like agreement_time; a_portfolio: like portfolio; a_identifier: like identifier; a_commission: like commission; a_fee: like fee; a_traded_quantity, a_gross_quantity, a_net_quantity: RP_QUANTITY; a_custody: RP_CUSTODY) is
			-- create listed trade
		do
				-- contract make stuff
			Precursor (a_system, a_broker, a_event_date, a_settle_date, a_portfolio, a_identifier, a_commission, a_fee, a_traded_quantity, a_gross_quantity, a_net_quantity, a_custody)
			set_type
		end

	set_type is
			-- Set side and side type
		deferred
		end

feature -- Access

	gross_quantity: RP_MONIES
			-- Second instrument quantity

	net_quantity: RP_MONIES
			-- Net amount of `gross_quantity'

invariant
	same_currency_for_gross_and_net_quantity: gross_quantity.currency ~ net_quantity.currency
	same_currency_for_net_and_fee: net_quantity.currency ~ fee.currency

end
