indexing

	description:

		"Unique relationship between a party and something being managed by the party"

	date: "$Date: 2009/04/22 $"
	fileid: "$Id: //rose/source/kernel/expert_system/rp_management.e#6 $"

class RP_MANAGEMENT

inherit

	ANY
		redefine
			is_equal
		end

create

	make

feature {NONE} -- Initialization

	make (a_manager: like manager; a_account: like account) is
			-- Initialize `Current'
		require
			non_void_args: a_manager /= Void and a_account /= Void
		do
			manager := a_manager
			account := a_account
		ensure
			manager_set: manager = a_manager
			account_set: account = a_account
		end

feature -- access

	manager: RP_PARTY
			-- Manager

	account: RP_ACCOUNT
			-- Account

	is_equal (a_other: like Current): BOOLEAN is
			-- <Precursor>
		do
			Result := manager.is_equal (a_other.manager) and account.is_equal (a_other.account)
		end

invariant

	manager_not_void: manager /= Void
	account_not_void: account /= Void

end
