note

	description:

		"Futures Mark to market contract"

	author: "gy"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #8 $"
	path: "$File: //rose/source/kernel/expert_system/aflows/rp_mark_to_market.e $"

class RP_MARK_TO_MARKET

inherit

	RP_CUSTODIAN_CONTRACT

create

	make

feature {NONE} -- Initialization

	make (a_quantity: RP_QUANTITY; a_event_date, a_settle_date: ROSE_DATE; a_portfolio: like portfolio;
		a_identifier: like identifier; a_system: like generating_system; a_custody: RP_CUSTODY) is
			-- Create
		require
			a_quantity_not_void: a_quantity /= Void
			a_event_date_not_void: a_event_date /= Void
			a_settle_date_not_void: a_settle_date /= Void
			a_portfolio_not_void: a_portfolio /= Void
			a_identifier_not_void: a_identifier /= Void
			a_system_not_void: a_system /= Void
			a_custody_not_void: a_custody /= Void
		local
			l_next_market_day: ROSE_DATE
		do
				-- Contract
			make_portfolio_contract (a_system, a_event_date, a_identifier, a_portfolio)
				-- Flows
			add_flow (mark_to_market_flow_type, unknown_instrument_control, a_portfolio.instrument_control (a_custody), a_event_date, a_settle_date, a_quantity, a_event_date, 0, Void)
			if portfolio.zone.is_united_states then
					-- As U zone uses NET value MTM we need to remove the value on the next
					-- day so that the value of the portfolio is adjusted with the next day's
					-- MTM instead of accumulating the MTM values
				l_next_market_day := a_portfolio.zone.legacy_perf_calendar.ith_work_day_after (a_event_date, 1)
				add_flow (mark_to_market_flow_type, a_portfolio.instrument_control (a_custody), unknown_instrument_control, l_next_market_day, l_next_market_day, a_quantity, l_next_market_day, 0, Void)
			end
		end

feature -- Basic Operations

	process (a_processor: RP_CONTRACT_PROCESSOR) is
			-- <Precursor>
		do
			a_processor.process_mark_to_market (Current)
		end

end
