indexing

	description:

		"Enumeration of Market Data Fields"

	date: "$Date: 2009/06/16 $"
	fileid: "$Id: //rose/source/kernel/expert_system/mds/rp_market_data_field.e#4 $"

class RP_MARKET_DATA_FIELD

inherit

	DEBUG_OUTPUT
		undefine
			is_equal,
			out
		end

	HASHABLE
		undefine
			is_equal,
			out
		end

	ANY
		redefine
			is_equal,
			out
		end

create {RP_MARKET_DATA_FIELD_AWARE}

	make_as_adjustment,
	make_as_unadjusted_bid,
	make_as_unadjusted_ask,
	make_as_unadjusted_low,
	make_as_unadjusted_high,
	make_as_unadjusted_close,
	make_as_volume,
	make_as_currency,
	make_as_civ_fund_class_nav,
	make_as_civ_fund_class_capital_balance,
	make_as_civ_fund_class_expense_balance,
	make_as_civ_fund_class_revenue_balance,
	make_as_civ_fund_class_shares,
	make_as_civ_fund_shares_activity

feature {RP_MARKET_DATA_FIELD_AWARE} -- Initialization

	make_as_adjustment is
			-- adjustment
		do
			type := c_adjustment
		end

	make_as_unadjusted_bid is
			-- unadjusted_bid
		do
			type := c_unadjusted_bid
		end

	make_as_unadjusted_ask is
			-- unadjusted_ask
		do
			type := c_unadjusted_ask
		end

	make_as_unadjusted_low is
			-- unadjusted_low
		do
			type := c_unadjusted_low
		end

	make_as_unadjusted_high is
			-- unadjusted_high
		do
			type := c_unadjusted_high
		end

	make_as_unadjusted_close is
			-- unadjusted_close
		do
			type := c_unadjusted_close
		end

	make_as_volume is
			-- volume
		do
			type := c_volume
		end

	make_as_currency is
			-- currency
		do
			type := c_currency
		end

	make_as_civ_fund_class_nav is
			-- civ_fund_class_nav
		do
			type := c_civ_fund_class_nav
		end

	make_as_civ_fund_class_capital_balance is
			-- civ_fund_class_capital_balance
		do
			type := c_civ_fund_class_capital_balance
		end

	make_as_civ_fund_class_expense_balance is
			-- civ_fund_class_expense_balance
		do
			type := c_civ_fund_class_expense_balance
		end

	make_as_civ_fund_class_revenue_balance is
			-- civ_fund_class_revenue_balance
		do
			type := c_civ_fund_class_revenue_balance
		end

	make_as_civ_fund_class_shares is
			-- civ_fund_class_shares
		do
			type := c_civ_fund_class_shares
		end

	make_as_civ_fund_shares_activity is
			-- Make as `c_civ_fund_shares_activity' instance
		do
			type := c_civ_fund_shares_activity
		end

feature -- comparison

	hash_code: INTEGER is
		do
			Result := type
		end

	is_equal (a_other: like Current): BOOLEAN is
		do
			Result := a_other /= Void and then type = a_other.type
		end

feature -- predicates

	is_adjustment: BOOLEAN is
		do
			Result := (type = c_adjustment)
		end

	is_unadjusted_bid: BOOLEAN is
		do
			Result := (type = c_unadjusted_bid)
		end

	is_unadjusted_ask: BOOLEAN is
		do
			Result := (type = c_unadjusted_ask)
		end

	is_unadjusted_low: BOOLEAN is
		do
			Result := (type = c_unadjusted_low)
		end

	is_unadjusted_high: BOOLEAN is
		do
			Result := (type = c_unadjusted_high)
		end

	is_unadjusted_close: BOOLEAN is
		do
			Result := (type = c_unadjusted_close)
		end

	is_volume: BOOLEAN is
		do
			Result := (type = c_volume)
		end

	is_currency: BOOLEAN is
		do
			Result := (type = c_currency)
		end

	is_civ_fund_class_nav: BOOLEAN is
		do
			Result := (type = c_civ_fund_class_nav)
		end

	is_civ_fund_class_capital_balance: BOOLEAN is
		do
			Result := (type = c_civ_fund_class_capital_balance)
		end

	is_civ_fund_class_expense_balance: BOOLEAN is
		do
			Result := (type = c_civ_fund_class_expense_balance)
		end

	is_civ_fund_class_revenue_balance: BOOLEAN is
		do
			Result := (type = c_civ_fund_class_revenue_balance)
		end

	is_civ_fund_class_shares: BOOLEAN is
		do
			Result := (type = c_civ_fund_class_shares)
		end

	is_civ_fund_shares_activity: BOOLEAN is
		do
			Result := (type = c_civ_fund_shares_activity)
		end

feature -- output

	debug_output: STRING is
		do
			Result := out
		end

	out: STRING is
		do
			inspect type
			when c_adjustment then
				Result := "adjustment"
			when c_unadjusted_bid then
				Result := "unadjusted_bid"
			when c_unadjusted_ask then
				Result := "unadjusted_ask"
			when c_unadjusted_low then
				Result := "unadjusted_low"
			when c_unadjusted_high then
				Result := "unadjusted_high"
			when c_unadjusted_close then
				Result := "unadjusted_close"
			when c_volume then
				Result := "volume"
			when c_currency then
				Result := "currency"
			when c_civ_fund_class_nav then
				Result := "civ_fund_class_nav"
			when c_civ_fund_class_capital_balance then
				Result := "civ_fund_class_capital_balance"
			when c_civ_fund_class_expense_balance then
				Result := "civ_fund_class_expense_balance"
			when c_civ_fund_class_revenue_balance then
				Result := "civ_fund_class_revenue_balance"
			when c_civ_fund_class_shares then
				Result := "civ_fund_class_shares"
			when c_civ_fund_shares_activity then
				Result := "civ_fund_shares_activity"
			end
		end

feature {RP_MARKET_DATA_FIELD} -- Implementation

	type: INTEGER
			-- state

	c_adjustment: INTEGER is 1
			-- adjustment

	c_unadjusted_bid: INTEGER is 2
			-- unadjusted_bid

	c_unadjusted_ask: INTEGER is 3
			-- unadjusted_ask

	c_unadjusted_low: INTEGER is 4
			-- unadjusted_low

	c_unadjusted_high: INTEGER is 5
			-- unadjusted_high

	c_unadjusted_close: INTEGER is 6
			-- unadjusted_close

	c_volume: INTEGER is 7
			-- volume

	c_currency: INTEGER is 8
			-- currency

	c_civ_fund_class_nav: INTEGER is 9
			-- civ_fund_class_nav

	c_civ_fund_class_capital_balance: INTEGER is 10
			-- civ_fund_class_capital_balance

	c_civ_fund_class_expense_balance: INTEGER is 11
			-- civ_fund_class_expense_balance

	c_civ_fund_class_revenue_balance: INTEGER is 12
			-- civ_fund_class_revenue_balance

	c_civ_fund_class_shares: INTEGER is 13
			-- civ_fund_class_shares

	c_civ_fund_shares_activity: INTEGER is 14
			-- civ_fund_shares_activity

end
