indexing

	description:

		"Market Data Source"

	last_editor: "$Author: nw $"
	date: "$Date: 2010/03/12 $"
	revision: "$Revision: #15 $"
	archive: "$File: //rose/source/kernel/expert_system/rp_market_data_source.e $"

deferred class RP_MARKET_DATA_SOURCE [G -> RP_INSTRUMENT]

inherit

	RP_MARKET_DATA_FIELD_AWARE

feature -- Query

	snapshot (a_instrument: G; a_date: ROSE_DATE): RP_MARKET_DATA_RECORD is
			-- Market data for `a_instrument' on `a_date'.
		require
			instrument_not_void: a_instrument /= Void
			date_not_void: a_date /= Void
		deferred
		ensure
			result_may_be_void_if_no_record_found: True
		end

	last_record_with_valid_field (a_instrument: G; a_date: ROSE_DATE; a_field: RP_MARKET_DATA_FIELD): RP_MARKET_DATA_RECORD is
			-- Last record as of `a_date' for `a_instrument' with valid `a_field'
		require
			instrument_not_void: a_instrument /= Void
			date_not_void: a_date /= Void
			field_not_void: a_field /= Void
		deferred
		ensure
			result_may_be_void_if_no_record_found: True
		end

end
