indexing

	description:

		"Market System"

	date: "$Date: 2010/03/12 $"
	revision: "$Revision: #14 $"

class RP_MARKET_SYSTEM

inherit

	RP_INVESTMENT_MANAGER_CLIENT

create {RP_INVESTMENT_MANAGER}

	make

feature -- Query

	insert_equity_market_data_source (a_mkt_dta_src: RP_MARKET_DATA_SOURCE [RP_STOCK]) is
			-- Insert market data source
		do
			equity.insert (a_mkt_dta_src, 1)
		end

	insert_government_bonds_market_data_source (a_mkt_dta_src: RP_MARKET_DATA_SOURCE [RP_GOVERNMENT_BOND]) is
			-- Insert market data source
		do
			tbill.insert (a_mkt_dta_src, 1)
		end

	insert_pool_fund_market_data_source (a_mkt_dta_src: RP_MARKET_DATA_SOURCE [RP_POOL_FUND]) is
			-- Insert market data source
		do
			fund.insert (a_mkt_dta_src, 1)
		end

	insert_currency_market_data_source (a_mkt_dta_src: RP_CURRENCY_MARKET_DATA_SOURCE) is
			-- Insert currency market data source
		do
			fx.insert (a_mkt_dta_src, 1)
		end

	equities_market_data_sources: ARRAY [RP_MARKET_DATA_SOURCE [RP_STOCK]] is
			-- List of all equities market data sources
		do
			Result := equity
		ensure
			non_void_result: Result /= Void
		end

	government_bonds_market_data_sources: ARRAY [RP_MARKET_DATA_SOURCE [RP_GOVERNMENT_BOND]] is
			-- List of all equities market data sources
		do
			Result := tbill
		ensure
			non_void_result: Result /= Void
		end

	pool_fund_market_data_sources: ARRAY [RP_MARKET_DATA_SOURCE [RP_POOL_FUND]] is
			-- List of all equities market data sources
		do
			Result := fund
		ensure
			non_void_result: Result /= Void
		end

	index_futures_market_data_sources: ARRAY [RP_MARKET_DATA_SOURCE [RP_INDEX_FUTURE]] is
			-- List of all index_futures market data sources
		do
			Result := index_futures
		ensure
			non_void_result: Result /= Void
		end

	currency_market_data_sources: ARRAY [RP_CURRENCY_MARKET_DATA_SOURCE] is
			-- List of all equities market data sources
		do
			Result := fx
		ensure
			non_void_result: Result /= Void
		end

feature {NONE} -- Implementation

	equity: ROSE_LINEAR_ARRAY [RP_MARKET_DATA_SOURCE [RP_STOCK]] is
			-- Equity market data sources
		once
			create Result.make_empty
			Result.extend (create {RP_AXAROSENBERG_MARKET_DATA_SOURCE}.make (manager.reference_system))
		end

	tbill: ROSE_LINEAR_ARRAY [RP_MARKET_DATA_SOURCE [RP_GOVERNMENT_BOND]] is
			-- Government bonds data sources
		once
			create Result.make_empty
			Result.extend (create {RP_AXAROSENBERG_TBILL_MARKET_DATA_SOURCE}.make (manager.reference_system))
		end

	fund: ROSE_LINEAR_ARRAY [RP_MARKET_DATA_SOURCE [RP_POOL_FUND]] is
			-- Pool fund market data sources
		once
			create Result.make_empty
			Result.extend (create {RP_CADB_POOL_FUND_MARKET_DATA_SOURCE}.make (manager.reference_system))
		end

	index_futures: ROSE_LINEAR_ARRAY [RP_MARKET_DATA_SOURCE [RP_INDEX_FUTURE]] is
			-- Equity market data sources
		once
			create Result.make_empty
			Result.extend (create {RP_INDEX_FUTURE_MARKET_DATA_SOURCE}.make (manager.reference_system))
		end

	fx: ROSE_LINEAR_ARRAY [RP_CURRENCY_MARKET_DATA_SOURCE] is
			-- Currency market data sources
		once
			create Result.make_empty
			Result.extend (create {RP_AXAROSENBERG_CURRENCY_MARKET_DATA_SOURCE}.make (manager.reference_system))
		end

end -- class RP_MARKET_SYSTEM
