indexing
	description: "Entry for a Corporate Action result override"
	author: "Portfolio Accounting Tech"
	last_editor: "$Author: bn $"
	date: "$Date: 2014/02/19 $"
	revision: "$Revision: #5 $"
	path: "$File: //rose/source/kernel/capital_actions/elections/rp_override_distributions_parm.e $"

class
	RP_OVERRIDE_DISTRIBUTIONS_PARM

inherit

	RP_EVENT_TYPE_CONSTANTS
		export {NONE} all end

	DEBUG_OUTPUT

	ROSE_CAPACT_DATE_USE

create
	make

feature {NONE} -- Initialization

	make (a_record: OVERRIDE_DISTRIBUTIONS_PARM_RECORD)
		-- Create from 'a_record'
		require
			record_not_void: a_record /= Void
			valid_type: is_valid_event_type (a_record.type)
			valid_clicode: (a_record.clicode /= Void) and then (not a_record.clicode.is_empty)
		do
			create brimsym.make_from_string (a_record.brimsym)
			brimsym.prune_all_trailing (' ')
			type := a_record.type
			ex_date := safe_date_from_ccyymmdd (a_record.ex_date)
			create clicode.make_from_string (a_record.clicode)
			clicode.prune_all_trailing (' ')
			create reason.make_from_string (a_record.reason)
			create base_price.make_from_string (a_record.base_price)
			pay_date := safe_date_from_ccyymmdd (a_record.pay_date)

			create cash1xxxxx_xx.make_from_string (a_record.cash1xxxxx_xx)
			create cost_basis1.make_from_string (a_record.cost_basis1)
			create shares1.make_from_string (a_record.shares1)

			create cash2xxxxx_xx.make_from_string (a_record.cash2xxxxx_xx)
			create cost_basis2.make_from_string (a_record.cost_basis2)
			create shares2.make_from_string (a_record.shares2)

			create cash3xxxxx_xx.make_from_string (a_record.cash3xxxxx_xx)
			create cost_basis3.make_from_string (a_record.cost_basis3)
			create shares3.make_from_string (a_record.shares3)

			create cash4xxxxx_xx.make_from_string (a_record.cash4xxxxx_xx)
			create cost_basis4.make_from_string (a_record.cost_basis4)
			create shares4.make_from_string (a_record.shares4)
		end

feature -- Access

	brimsym: !STRING
		-- Brimsym

	type: INTEGER
		-- Event type

	ex_date: !ROSE_DATE
		-- Ex Date

	clicode: !STRING
		-- Portfolio code

	reason: STRING
		-- Reason

	base_price: !RP_DECIMAL
		-- Base price

	pay_date: !ROSE_DATE
		-- Pay Date

	cash1xxxxx_xx: !RP_DECIMAL
		-- Cash 1

	cost_basis1: !RP_DECIMAL
		-- Cost basis 1

	shares1: !RP_DECIMAL
		-- Shares 1

	cash2xxxxx_xx: !RP_DECIMAL
		-- Cash 2

	cost_basis2: !RP_DECIMAL
		-- Cost basis 2

	shares2: !RP_DECIMAL
		-- Shares 2

	cash3xxxxx_xx: !RP_DECIMAL
		-- Cash 3

	cost_basis3: !RP_DECIMAL
		-- Cost basis 3

	shares3: !RP_DECIMAL
		-- Shares 3

	cash4xxxxx_xx: !RP_DECIMAL
		-- Cash 4

	cost_basis4: !RP_DECIMAL
		-- Cost basis 4

	shares4: !RP_DECIMAL
		-- Shares 4

feature -- Output

	debug_output: STRING is
			-- <Precursor>
		do
			create Result.make_empty
			Result.Append (brimsym); Result.append ("|")
			Result.Append (type.out); Result.append ("|")
			Result.Append (ex_date.out); Result.append ("|")
			Result.Append (clicode.out); Result.Append ("|")
			Result.Append (reason.out); Result.Append ("|")
			Result.Append (base_price.out); Result.Append ("|")
			Result.Append (pay_date.out); Result.Append ("|")
			Result.Append (cash1xxxxx_xx.out); Result.Append ("|")
			Result.Append (cost_basis1.out); Result.Append ("|")
			Result.Append (shares1.out); Result.Append ("|")
			Result.Append (cash2xxxxx_xx.out); Result.Append ("|")
			Result.Append (cost_basis2.out); Result.Append ("|")
			Result.Append (shares2.out); Result.Append ("|")
			Result.Append (cash3xxxxx_xx.out); Result.Append ("|")
			Result.Append (cost_basis3.out); Result.Append ("|")
			Result.Append (shares3.out); Result.Append ("|")
			Result.Append (cash4xxxxx_xx.out); Result.Append ("|")
			Result.Append (cost_basis4.out); Result.Append ("|")
			Result.Append (shares4.out); Result.Append ("|")
		end


end
