indexing

	description:

		"Daily Returns"

	date: "$Date: 2010/03/01 $"
	sccid: "$Id: //rose/source/kernel/expert_system/perf/rp_performance_daily_return.e#10 $"

class RP_PERFORMANCE_DAILY_RETURN

inherit

	RP_DAILY_RETURN
		rename
			make as make_dr
		redefine
			update_return
		end

create

	make

feature {NONE} -- Initialization

	make (a_dailyvalues: like dailyvalues; a_nominator, a_denominator, a_cash_flows: RP_PERFORMANCE_AFFECTING_CASH_FLOWS) is
			-- Initialize `Current'
		require
			non_void_dailyvalues: a_dailyvalues /= Void
			non_void_adj_value: a_cash_flows /= Void
		do
			dailyvalues := a_dailyvalues
			make_dr (a_dailyvalues.perf_date, a_dailyvalues.currency, a_nominator.value (dailyvalues).amount, 1)
			value_lag := a_denominator.value (dailyvalues).amount
			cash_flows := a_cash_flows.value (dailyvalues).amount
		end

feature -- Access

	dailyvalues: RP_PERFORMANCE_DAILY_VALUES
			-- Underlying daily values

	value_lag: RP_DECIMAL
			-- Portfolio value lag

	cash_flows: RP_DECIMAL
			-- Sum of performance affecting cash flows

feature {NONE} -- Implementatin

	update_return is
			-- Recompute `return'
		do
			if prev = Void then
				return := 1.0
					-- First day 0%
			elseif not prev.value_lag.is_zero then
				return := (value - cash_flows) / prev.value_lag
			else
				return := 1.0
					-- Otherwise 0%
			end
		end

end
