indexing

	description:

		"Collection of daily returns"

	date: "$Date: 2010/03/01 $"
	sccid: "$Id: //rose/source/kernel/expert_system/perf/rp_performance_daily_returns.e#5 $"

class RP_PERFORMANCE_DAILY_RETURNS

inherit

	RP_DAILY_RETURNS
		rename
			make as make_dr
		end

create

	make

feature {NONE} -- Initialization

	make (a_code: STRING; a_numerator: like numerator; a_denominator: like denominator; a_cash_flows: like cash_flows) is
			-- Initialize `Current'
		require
			non_void_args: a_code /= Void and a_cash_flows /= Void and a_numerator /= Void and a_denominator /= Void
		do
			numerator := a_numerator
			denominator := a_denominator
			cash_flows := a_cash_flows
			make_dr (a_code)
		ensure
			numerator_set: numerator = a_numerator
			denominator_set: denominator = a_denominator
			cash_flows_set: cash_flows = a_cash_flows
		end

feature -- Basic operations

	add_dailyvalues (a_dailyvalue: RP_PERFORMANCE_DAILY_VALUES) is
			-- Add `a_dailyvalue' and compute dailyretun
		require
			valid_new_date: valid_new_date (a_dailyvalue.perf_date)
		local
			l_new: RP_PERFORMANCE_DAILY_RETURN
		do
			create l_new.make (a_dailyvalue, numerator, denominator, cash_flows)
			expand (l_new)
		end

feature {NONE} -- Implementation

	numerator: RP_PERFORMANCE_AFFECTING_CASH_FLOWS
			-- Numerator value

	denominator: RP_PERFORMANCE_AFFECTING_CASH_FLOWS
			-- Denominator value

	cash_flows: RP_PERFORMANCE_AFFECTING_CASH_FLOWS
			-- Cash flow agent

end
