indexing

	description:

		"JOHNE specific pricing algorithm"

	date: "$Date: 2010/04/30 $"
	fileid: "$Id: //rose/source/Kernel/expert_system/valuators/rp_performance_johne_stock_pricing_algorithm.e#4 $"

class RP_PERFORMANCE_JOHNE_STOCK_PRICING_ALGORITHM

inherit

	RP_PERFORMANCE_EZONE_STOCK_PRICING_ALGORITHM
		redefine
			stock_market_price,
			lookback_range
		end

create

	make_with_trade_price

feature {NONE} -- Impementation

	lookback_range: INTEGER is 30
			-- Max days to look back.

	stock_market_price (a_instrument: RP_STOCK; a_date: ROSE_DATE; a_calendar: RP_CALENDAR): RP_PRICE is
			-- Retrieve market price for `a_listing' on `a_date'
		local
			l_listing_market_data: RP_MARKET_DATA_RECORD
		do
			l_listing_market_data := market_data_source.snapshot (a_instrument, a_date)
			if l_listing_market_data /= Void and then (l_listing_market_data.has_adjustment_factor and then l_listing_market_data.adjustment_factor > 0) then
				if l_listing_market_data.has_close and then l_listing_market_data.unadjusted_close.price > 0 then
					Result := l_listing_market_data.unadjusted_close
				elseif l_listing_market_data.has_bid and then l_listing_market_data.unadjusted_bid.price > 0 then
					Result := l_listing_market_data.unadjusted_bid
				end
				if Result = Void or not l_listing_market_data.has_volume or l_listing_market_data.has_volume and then l_listing_market_data.volume < 0 then
					if l_listing_market_data.has_ask and l_listing_market_data.has_bid then
						Result := a_instrument.price_in_currency ((l_listing_market_data.unadjusted_ask.price + l_listing_market_data.unadjusted_bid.price) / 2, l_listing_market_data.unadjusted_ask.currency, l_listing_market_data.unadjusted_ask.date)
					else
						Result := retrieve_last_stock_price (l_listing_market_data.adjustment_factor, a_instrument, a_date, a_calendar)
					end
				end
			else
				l_listing_market_data := price_lookback (market_data_source, a_instrument, a_date, lookback_range, a_calendar, agent has_adjustment_factor)
				if l_listing_market_data /= Void then
					Result := retrieve_last_stock_price (l_listing_market_data.adjustment_factor, a_instrument, a_date, a_calendar)
				end
			end
		end

end
