indexing

	description:

		"U zone specific pool fund pricing algorithm"

	date: "$Date: 2010/04/30 $"
	fileid: "$Id: //rose/source/kernel/expert_system/valuators/rp_performance_uzone_pool_fund_pricing_algorithm.e#4 $"

class RP_PERFORMANCE_UZONE_POOL_FUND_PRICING_ALGORITHM

inherit

	RP_POOL_FUND_PRICING_ALGORITHM
		redefine
			decrement_date,
			price,
			use_nav_first
		end

create

	make

feature -- Access

	internal_prices: PAIR [STRING, DS_HASH_TABLE [RP_PERFORMANCE_DAILY_VALUES, ROSE_DATE]]
		-- Internal Prices

	set_internal_prices (v: like internal_prices) is
			-- Set `internal_prices'
		do
			internal_prices := v
		ensure
			internal_prices_set: internal_prices = v
		end

	price (a_fund: RP_POOL_FUND; a_date: ROSE_DATE): RP_PRICE is
			-- Price of `a_fund' on `a_date' in units of RP_CURRENCY
		local
			l_dv: RP_PERFORMANCE_DAILY_VALUES
		do
			if internal_prices /= Void then
				if a_fund.brimsym.is_equal (internal_prices.first) then
					internal_prices.second.search (a_date)
					if internal_prices.second.found then
						l_dv := internal_prices.second.found_item
						Result := a_fund.price_in_currency (l_dv.portfolio_value.amount, l_dv.portfolio_value.currency, a_date)
						Result.set_source ("INT")
					end
				else
					Result := Precursor (a_fund, a_date)
				end
			else
				Result := Precursor (a_fund, a_date)
			end
		end

feature {NONE} -- Implementation

	use_nav_first: BOOLEAN is
			-- Precursor
		do
			Result := False
		end

	decrement_date (a_calendar: RP_CALENDAR; a_date: ROSE_DATE): ROSE_DATE is
			-- Previous date to `a_date'
		do
				-- Default is market days
				-- U zone uses calendar days
			Result := a_date.previous_date
		end

end
