indexing

	description:

		"Contracts created by corporate actions processing system"

	date: "$Date: 2010/03/05 $"
	sccid: "$Id: //rose/source/kernel/expert_system/rp_portfolio_corporate_action_contract.e#12 $"

deferred class RP_PORTFOLIO_CORPORATE_ACTION_CONTRACT

inherit

	RP_PORTFOLIO_CONTRACT
		rename
			make as make_p_contract
		end

feature {NONE} -- Initialization

	make_capital_action (a_generating_system: like generating_system; a_agreement_time: like agreement_time; a_identifier: like identifier; a_portfolio: like portfolio; a_units_base: like units_base; a_settle_date: like settle_date) is
			-- Initialize `Current'
		require
			generating_system_not_void: a_generating_system /= Void
			agreement_time_not_void: a_agreement_time /= Void
			identifier_not_void: a_identifier /= Void
			portfolio_not_void: a_portfolio /= Void
			units_base_not_void: a_units_base /= Void
			settle_date_not_void: a_settle_date /= Void
		do
			units_base := a_units_base
			settle_date := a_settle_date
			make_p_contract (a_generating_system, a_agreement_time, a_identifier, a_portfolio)
		ensure
			units_base_set: units_base = a_units_base
			settle_date_set: settle_date = a_settle_date
		end

feature -- Access

	units_base: RP_QUANTITY
			-- Underlying holding

	settle_date: ROSE_DATE
			-- Settlement date

feature {NONE} -- Copy

	make_from_other (a_other: RP_PORTFOLIO_CORPORATE_ACTION_CONTRACT) is
			-- Copy from another delivery
		require
			other_not_void: a_other /= Void
		do
			make_capital_action (a_other.generating_system, a_other.agreement_time, a_other.identifier, a_other.portfolio, a_other.units_base, a_other.settle_date)
			from
				a_other.flows.start
			until
				a_other.flows.after
			loop
				flows.extend (a_other.flows.item_for_iteration)
				a_other.flows.forth
			end
		end

invariant

	units_base_not_void: units_base /= Void
	settle_date_not_void: settle_date /= Void

end
