indexing

	description: "Portfolio history"

	date: "$Date: 2009/10/22 $"
	sccid: "$Id: //rose/source/kernel/expert_system/rp_portfolio_history.e#7 $"

class RP_PORTFOLIO_HISTORY

inherit

	ROSE_INTERVAL_HISTORY[RP_PORTFOLIO, RP_PORTFOLIO_HISTORY_INTERVAL]
		redefine
			coalesce
		end

create

	make_empty

feature -- Basic Operations

	coalesce is
			-- Coalesce intervals with same weight and same item that are overlapping
		local
			i, j: INTEGER
			a, b: RP_PORTFOLIO_HISTORY_INTERVAL
			l_coleasced, l_found: BOOLEAN
		do
			sort_by_start_date
			from
				i := 1
			until
				i > count
			loop
				a := item (i)
				from
					j := i + 1
					l_found := False
					l_coleasced := False
				until
					j > count or l_found
				loop
					b := item (j)
					if a.portfolio.is_equal (b.portfolio) then
						l_found := True
						if a.weight = b.weight then
							if b.brackets (a.end_date) then
								a.set_end_date (b.end_date)
								a.set_message (a.message + "/" + b.message)
								remove_i_th (j)
								l_coleasced := True
							elseif a.brackets (b.end_date) or else (a.end_is_unbounded and b.end_is_unbounded) or else (a.end_date.is_equal (b.end_date)) then
								a.set_message (a.message + "/" + b.message)
								remove_i_th (j)
								l_coleasced := True
							end
						end
					end
					j := j + 1
				end
				if not l_coleasced then
					i := i + 1
				end
			end
		end

end
