note

	description:

		"[
		
		Parameter for a portfolio referencing a record in a Parm file. 
		This has just the portfolio name and the record
		Uses Decorator pattern

		]"

	author: "Sami Ben-Grine"
	last_editor: "$Author: it $"
	date: "$Date: 2011/03/04 $"
	revision: "$Revision: #4 $"
	path: "$File: //rose/source/kernel/expert_system/aflows/rp_portfolio_parm.e $"

deferred class RP_PORTFOLIO_PARM [R -> RP_PORTFOLIO_PARM_RECORD]

inherit

	RP_PORTFOLIO_PARM_RECORD

	DEBUG_OUTPUT

feature {NONE} -- Initialization

	make (a_record: like record) is
			-- Create with `a_record'
		require
			record_not_void: a_record /= Void
			valid_record: a_record.is_valid
		do
			create clicode.make_from_string (a_record.clicode.as_upper)
			clicode.prune_all (' ')
			clicode.prune_all ('%T')
			clicode.prune_all ('%U')
			record := a_record
		ensure
			record_set: record = a_record
		end

feature -- Status

	is_valid: BOOLEAN is
			-- <Precursor>
		do
			Result := record.is_valid
		end

feature {NONE} -- Implementation

	record: R
			-- Original record in the input parm file

invariant

	record_not_void: record /= Void
	record_is_valid: record.is_valid
	clicode_not_void_or_emtpy: string_not_void_or_empty (clicode)
	clicode_is_upper_case: clicode ~ clicode.as_upper

end
