note

	description:

		"One line of a parm file for a portfolio. The minimum is to have the client name but the descendants should have more fields."

	author: "Sami Ben-Grine"
	last_editor: "$Author: it $"
	date: "$Date: 2011/03/04 $"
	revision: "$Revision: #3 $"
	path: "$File: //rose/source/kernel/expert_system/aflows/rp_portfolio_parm_record.e $"

deferred class RP_PORTFOLIO_PARM_RECORD

feature -- Access

	clicode: STRING
			-- Portfolio code

feature -- Status

	is_valid: BOOLEAN is
			-- Is this valid record?
		deferred
		ensure
			clicode_not_void_or_empty: Result implies string_not_void_or_empty (clicode)
		end

	string_not_void_or_empty (a_string: STRING): BOOLEAN is
			-- Is `a_string' not Void and not empty?
		do
			Result := a_string /= Void and then a_string.occurrences (' ') + a_string.occurrences ('%T') + a_string.occurrences ('%U') < a_string.count
		ensure
			definition: Result implies a_string /= Void and then a_string.occurrences (' ') + a_string.occurrences ('%T') + a_string.occurrences ('%U') < a_string.count
		end

	min_date: INTEGER is 19850101
			-- Minimum date (ccyymmdd)

	max_date: INTEGER is 99999999
			-- Maximum date (ccyymmdd)

	valid_ccyymmdd (a_ccyymmdd: INTEGER): BOOLEAN is
			-- Is `a_ccyymmdd' in valid range?
		do
			Result := min_date <= a_ccyymmdd and a_ccyymmdd <= max_date
		ensure
			definition: Result implies min_date <= a_ccyymmdd and a_ccyymmdd <= max_date
		end

end
