indexing

	description: "Position"

	author: "it"
	last_editor: "$Author: it $"
	date: "$Date: 2010/09/06 $"
	sccid: "$Id"

class RP_POSITION

inherit

	RP_CLOSED_OPEN_INTERVAL [RP_INSTRUMENT]
		rename
			make as make_interval,
			entity as instrument,
			weight as position
		end

create {RP_POSITIONS}

	make_default,
	make

feature {NONE} -- Initialization

	make_default (a_instrument: RP_INSTRUMENT) is
			-- Initialize default position of zero units from the dawn of time till the end of the universe
		require
			non_void_instrument: a_instrument /= Void
		do
			make_interval (a_instrument, create {ROSE_DATE}.make_min_date, create {ROSE_DATE}.make_max_date, create {RP_DECIMAL}.make_zero)
			create flows.make_default
		end

	make (a_flow: RP_FLOW; a_start_date: like start_date; a_existing_position: RP_POSITION) is
			-- Initialize `Current' from `a_flow' and with `a_start_date' and `a_end_date'
		require
			flow_not_void: a_flow /= Void
			start_date_not_void: a_start_date /= Void
			existing_position_not_void: a_existing_position /= Void
		do
			make_interval (a_flow.instrument, a_start_date, a_existing_position.end_date, a_existing_position.position)
			create flows.make_default
			adjust_with (a_flow)
		end

feature -- Access

	flows: DS_LINKED_LIST [RP_FLOW]
			-- Position adjustment flows

feature {RP_POSITIONS} -- Update

	plus (a_flow: RP_FLOW) is
			-- Add quantity of `a_flow' to `position'
		do
			position := position + a_flow.signed_quantity.amount
		end

	adjust_with (a_flow: RP_FLOW) is
			-- Add `a_flow' and adjust position
		require
			flow_not_void: a_flow /= Void
			same_instrument: a_flow.instrument.is_equal (flows.first.instrument)
		do
			plus (a_flow)
			flows.force_last (a_flow)
		end

	close_on (a_date: like end_date) is
			-- Set `end_date' to `a_date'
		require
			date_non_void: a_date /= Void
		do
			end_date := a_date
		ensure
			end_date_set: end_date = a_date
		end

invariant

	flows_not_void: flows /= Void

end
