indexing

	description:

		"Price Override Market Data Record"

	date: "$Date: 2010/04/30 $"
	revision: "$Revision: #8 $"

class RP_PRICE_OVERRIDE_MARKET_DATA_RECORD

inherit

	RP_MARKET_DATA_RECORD

	IEEE_MATH
		export {NONE} all end

create

	make

feature {NONE} -- Initialization

	make (a_date: like date; a_close_price: like close_price) is
			-- Initialize `Current'.
		do
			date := a_date
			close_price := a_close_price
		end

feature -- Access

	date: ROSE_DATE
			-- Record date

	has (a_field: RP_MARKET_DATA_FIELD): BOOLEAN is
			-- Does `Current' have `a_field'?
		do
			if a_field.is_unadjusted_close then
				Result := True
			end
		end

	decimal_field (a_field: RP_MARKET_DATA_FIELD): RP_DECIMAL is
			-- Decimal value of `a_field'.
		do
			Result := Void
				-- No decimal fields
		end

	monies_field (a_field: RP_MARKET_DATA_FIELD): RP_MONIES is
			-- Value of `a_field' as monies.
		do
			Result := Void
				-- No money fields
		end

	price_field (a_field: RP_MARKET_DATA_FIELD): RP_PRICE is
			-- Value of `a_field'
		do
			if a_field.is_unadjusted_close then
				Result := close_price
			end
		end

feature {NONE} -- Implementation

	close_price: RP_PRICE
			-- Close price

end
