note

	description:

		"Redenomination"

	author: "gy"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #9 $"
	path: "$File: //rose/source/kernel/expert_system/aflows/rp_redenomination.e $"

class RP_REDENOMINATION

inherit

	RP_PORTFOLIO_CORPORATE_ACTION_CONTRACT

create

	make

feature {NONE} -- Constructor

	make (a_quantity: RP_QUANTITY; a_value: RP_MONIES; a_event_date, a_settle_date: ROSE_DATE;
		a_portfolio: like portfolio; a_identifier: like identifier;
		a_system: like generating_system; a_custody: RP_CUSTODY) is
			-- Create
		require
			a_quantity_not_void: a_quantity /= Void
			a_value_not_void: a_value /= Void
			a_event_date_not_void: a_event_date /= Void
			a_settle_date_not_void: a_settle_date /= Void
			a_portfolio_not_void: a_portfolio /= Void
			a_identifier_not_void: a_identifier /= Void
			a_system_not_void: a_system /= Void
			a_custody_not_void: a_custody /= Void
		do
				-- Contract
			make_capital_action (a_system, a_event_date, a_identifier, a_portfolio, a_quantity, a_settle_date)
				-- Flows
			add_flow (redenomination_flow_type, a_portfolio.instrument_control (a_custody), unknown_instrument_control, a_event_date, a_settle_date, a_quantity, a_event_date, 0, Void)
			add_flow (redenomination_flow_type, unknown_instrument_control, a_portfolio.instrument_control (a_custody), a_event_date, a_settle_date, a_quantity, a_event_date, 0, a_value)
		end

feature -- Basic Operations

	process (a_processor: RP_CONTRACT_PROCESSOR) is
			-- <Precursor>
		do
			a_processor.process_redenomination (Current)
		end

end
