note

	description:

		"Return of Capital (Cash)"

	author: "Sami Ben-Grine"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #8 $"
	path: "$File: //rose/source/Kernel/expert_system/rp_return_of_capital.e $"

class RP_RETURN_OF_CAPITAL

inherit

	RP_PORTFOLIO_CORPORATE_ACTION_CONTRACT

create

	make

feature {NONE} -- Initialization

	make (a_units_base: like units_base; a_gross, a_tax: RP_MONIES; a_event_date, a_settle_date: ROSE_DATE;
		a_portfolio: like portfolio; a_identifier: like identifier;
		a_system: like generating_system; a_custody: RP_CUSTODY) is
			-- Create a dividend for a_portfolio on a_date
		require
			units_base_not_void: a_units_base /= Void
			gross_not_void: a_gross /= Void
			event_date_not_void: a_event_date /= Void
			settle_date_not_void: a_settle_date /= Void
			portfolio_not_void: a_portfolio /= Void
			identifier_not_void: a_identifier /= Void
			system_not_void: a_system /= Void
			a_custody_not_void: a_custody /= Void
		local
			l_tax_man: RP_INSTRUMENT_CONTROL
		do
				-- Contract
			make_capital_action (a_system, a_event_date, a_identifier, a_portfolio, a_units_base, a_settle_date)
				-- Flows
			add_flow (dividend_flow_type, unknown_instrument_control, portfolio.instrument_control (a_custody), a_event_date, a_settle_date, a_gross, a_event_date, 0, a_gross)
			if a_tax /= Void and then not a_tax.amount.is_zero then
				l_tax_man := units_base.instrument.country_of_issue (a_system.manager.reference_system, a_event_date).government_tax_authority
					--	create dividend_tax flow
				add_flow (dividend_withholding_country_tax_flow_type, portfolio.instrument_control (a_custody), l_tax_man, a_event_date, a_settle_date, a_tax, a_event_date, 0, a_tax)
			end
		end

feature -- Basic Operations

	process (a_processor: RP_CONTRACT_PROCESSOR) is
			-- <Precursor>
		do
			a_processor.process_return_of_capital (Current)
		end

end
