indexing
	description: "Access to rounding overrides"
	author: "Portfolio Accounting Tech"
	last_editor: "$Author: sm $"
	date: "$Date: 2009/09/23 $"
	revision: "$Revision: #1 $"
	archive: "$File: //rose/source/kernel/capital_actions/elections/rp_rounding_distributions.e $"

class
	RP_ROUNDING_DISTRIBUTIONS

create
	make

feature {NONE} -- Initialization

	make is
			-- Create table
		do
			create cache.make (0)

			-- This is a sample for testing

			-- FIXME: read file or database
		end

feature -- Access

	rounding (a_zone: RP_ZONE; a_date: ROSE_DATE; a_instrument: RP_INSTRUMENT): RP_ROUNDING_DISTRIBUTIONS_PARM is
			-- Rounding method
		require
			zone_not_void: a_zone /= Void
			date_not_void: a_date /= Void
			instrument_not_void: a_instrument /= Void
		local
			l_key: STRING
		do
			l_key := key (a_zone, a_date, a_instrument)
			if cache.has (l_key) then
				Result := cache.item (l_key)
			end
		ensure
			correct_rounding: (Result /= Void) implies (Result.zone_code = a_zone.code.item (1) and Result.ex_date.is_equal (a_date) and Result.brimsym.is_equal (a_instrument.brimsym))
		end

feature {NONE} -- Implementation

	key (a_zone: RP_ZONE; a_date: ROSE_DATE; a_instrument: RP_INSTRUMENT): STRING is
			-- Key for 'a_zone', 'a_date' and 'a_instrument'
		require
			zone_not_void: a_zone /= Void
			date_not_void: a_date /= Void
			instrument_not_void: a_instrument /= Void
		do
			Result := a_zone.code.out+"|"+a_date.ccyymmdd.out+"|"+a_instrument.brimsym
		ensure
			not_void: Result /= Void
		end

	cache: HASH_TABLE [RP_ROUNDING_DISTRIBUTIONS_PARM, STRING]
		-- Cache

end
