note

	description:

		"Sell contract"

	author: "Mark Howard"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #25 $"
	path: "$File: //rose/source/kernel/contracts/trades/rp_sell.e $"

class RP_SELL

inherit

	RP_LISTED_TRADE
		redefine
			add_exchange_flows
		end

create

	make

feature {NONE} -- Initialization

	set_type is
			-- Set type
		do
			is_sell := True
		end

feature -- Basic Operations

	process (a_processor: RP_CONTRACT_PROCESSOR) is
			-- <Precursor>
		do
			a_processor.process_sell (Current)
		end

feature {RP_TRADING_SYSTEM} -- Implementation

	add_exchange_flows (a_quantity: like traded_quantity; a_gross_monies: like gross_quantity; a_net_monies: like net_quantity; a_contracted_ownership_time, a_contracted_settlement_time: ROSE_DATE; a_custody: RP_CUSTODY) is
			-- <Precursor>
		do
			add_flow (quantity_flow_type, portfolio.instrument_control (a_custody), broker.instrument_control, a_contracted_ownership_time, a_contracted_settlement_time, a_quantity.abs, a_contracted_ownership_time, 0, a_net_monies)
			add_flow (gross_monies_flow_type, broker.instrument_control, portfolio.instrument_control (a_custody), a_contracted_ownership_time, a_contracted_settlement_time, a_gross_monies.abs, a_contracted_ownership_time, 0, a_gross_monies)
		end

invariant
	gross_is_net_and_comm_and_fee: gross_quantity ~ (net_quantity + commission + fee)
	is_sell: is_sell
end
