note

	description:

		"Short trade contract"

	author: "Mark Howard"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #24 $"
	path: "$File: //rose/source/kernel/expert_system/rp_short.e $"

class RP_SHORT

inherit

	RP_LISTED_TRADE
		redefine
			add_exchange_flows
		end

create

	make

feature {NONE} -- Initialization

	set_type is
			-- Set type
		do
			is_short := True
		end

feature -- Basic Operations

	process (a_processor: RP_CONTRACT_PROCESSOR) is
			-- <Precursor>
		do
			a_processor.process_short (Current)
		end

feature {NONE} -- Implementation

	add_exchange_flows (a_quantity: like traded_quantity; a_gross_monies: like gross_quantity; a_net_monies: like net_quantity; a_contracted_ownership_time, a_contracted_settlement_time: ROSE_DATE; a_custody: RP_CUSTODY) is
			-- <Precursor>
		do
			add_flow (borrow_flow_type, portfolio.prime_broker.instrument_control, portfolio.instrument_control (a_custody), a_contracted_ownership_time, a_contracted_settlement_time, -a_quantity, a_contracted_ownership_time, 0, -a_net_monies)
			add_flow (borrow_flow_type, portfolio.prime_broker.instrument_control, portfolio.instrument_control (a_custody), a_contracted_ownership_time, a_contracted_settlement_time, a_quantity, a_contracted_ownership_time, 0, a_net_monies)
			add_flow (quantity_flow_type, portfolio.instrument_control (a_custody), broker.instrument_control, a_contracted_ownership_time, a_contracted_settlement_time, a_quantity, a_contracted_ownership_time, 0, a_net_monies)
			add_flow (gross_monies_flow_type, broker.instrument_control, portfolio.instrument_control (a_custody), a_contracted_ownership_time, a_contracted_settlement_time, a_gross_monies, a_contracted_ownership_time, 0, a_gross_monies)
		end

invariant
	gross_is_net_and_comm_and_fee: gross_quantity ~ (net_quantity + commission + fee)
	is_short: is_short
end
