indexing
	description: "A Stock"
	author: "Ivan Tarnavsky"
	last_editor: "$Author: sm $"
	date: "$Date: 2011/06/23 $"
	revision: "$Revision: #24 $"
	path: "$File: //rose/source/kernel/expert_system/rp_stock.e $"

class RP_STOCK

inherit

	RP_SECURITY
		redefine
			is_equity,
			is_adr
		end

create {RP_REFERENCE_SYSTEM}

	make

create {RP_SIMULATION, RP_PORTFOLIO_SYSTEM_SIMULATION, RP_CORPORATE_ACTION_SYSTEM_SIMULATION}

	make_from_security

feature -- Query

	handle: INTEGER is
			-- Handle
		do
			Result := listing.handle
		end

	holding_value_in_currency (a_holding: RP_HOLDING; a_valuator: RP_HOLDING_VALUATOR; a_currency: RP_CURRENCY; a_date: ROSE_DATE; a_bucket: STRING): RP_MONIES is
			-- Value of `a_holding' on `a_date' in `a_currency' as computed by `a_valuator'
		do
			Result := a_valuator.stock_value_in_currency (a_holding, a_currency, a_date, a_bucket)
		end

	country_of_issue (a_ref_system: RP_REFERENCE_SYSTEM; a_date: ROSE_DATE): RP_COUNTRY is
			-- Country of issue.
		do
			Result := a_ref_system.country_from_iso_code (brimsym.substring (1, 2))
		end

	zone: RP_ZONE is
			-- Zone
		do
			Result := reference_system.investment_region_by_code(zone_mnemonic.out)
		end

feature -- Status Report

	is_equity: BOOLEAN is
			-- is equity?
		do
			Result := True
		end

	is_adr: BOOLEAN is
			-- is adr?
		do
			Result := brimsym.has_substring ("ADR")
		end

end
