note

	description:

		"Stock bonus"

	author: "Mark Howard"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #15 $"
	path: "$File: //rose/source/kernel/expert_system/rp_stock_bonus.e $"

class RP_STOCK_BONUS

inherit

	RP_PORTFOLIO_CORPORATE_ACTION_CONTRACT

create

	make_stock_bonus

feature {NONE} -- Initialization

	make_stock_bonus (a_units, a_units_base: RP_QUANTITY; a_event_date, a_settle_date: ROSE_DATE;
		a_portfolio: like portfolio; a_identifier: like identifier;
		a_system: like generating_system; a_custody: RP_CUSTODY) is
			-- create a stock bonus for a_portfolio on a_date
		require
			a_units_not_void: a_units /= Void
			a_units_base_not_void: a_units_base /= Void
			a_event_date_not_void: a_event_date /= Void
			a_settle_date_not_void: a_settle_date /= Void
			a_portfolio_not_void: a_portfolio /= Void
			a_identifier_not_void: a_identifier /= Void
			a_system_not_void: a_system /= Void
			a_custody_not_void: a_custody /= Void
		do
				-- Contract
			make_capital_action (a_system, a_event_date, a_identifier, a_portfolio, a_units_base, a_settle_date)
				-- Flows
			add_flow (stock_bonus_flow_type, unknown_instrument_control, portfolio.instrument_control (a_custody), a_event_date, a_settle_date, a_units, a_event_date, 0, Void)
		end

feature -- Basic Operations

	process (a_processor: RP_CONTRACT_PROCESSOR) is
			-- <Precursor>
		do
			a_processor.process_stock_bonus (Current)
		end

end
