note

	description:

		"Stock dividend contract"

	author: "Julian Rogers"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #3 $"
	path: "$File: //rose/source/kernel/expert_system/rp_stock_dividend.e $"

class RP_STOCK_DIVIDEND

inherit
	RP_DIVIDEND

create
	make

feature {NONE} -- Initialization

		make (a_units, a_units_base: RP_QUANTITY; a_event_date, a_settle_date: ROSE_DATE;
			a_portfolio: like portfolio; a_identifier: like identifier;
			a_system: like generating_system; a_custody: RP_CUSTODY) is
			-- Create a dividend for a_portfolio on a_date
		require
			a_units_not_void: a_units /= Void
			a_units_base_not_void: a_units_base /= Void
			a_event_date_not_void: a_event_date /= Void
			a_settle_date_not_void: a_settle_date /= Void
			a_portfolio_not_void: a_portfolio /= Void
			a_system_not_void: a_system /= Void
			a_units_base_not_null: not a_units_base.amount.is_zero
			a_custody_not_void: a_custody /= Void
		do
				-- Contract
			make_capital_action (a_system, a_event_date, a_identifier, a_portfolio, a_units_base, a_settle_date)
				-- Flows
			add_flow (stock_dividend_flow_type, unknown_instrument_control, portfolio.instrument_control (a_custody), a_event_date, a_settle_date, a_units, a_event_date, 0, Void)
			payment_factor := (a_units_base.amount.abs + a_units.amount.abs) / a_units_base.amount.abs
		ensure
			flows_count_is_one: flows.count = 1
		end

feature -- Access

	payment_factor: RP_DECIMAL
		-- New total shares over original shares.

invariant
	payment_factor_set: payment_factor /= Void and then payment_factor.is_defined
	payment_factor_greater_than_one: payment_factor >= 1

end
