indexing
	description: "Strategy Description"
	author: "it"
	date: "$Date: 2009/02/12 $"
	revision: "$Revision: #5 $"
	archive: "$File: //rose/source/kernel/expert_system/rp_strategy.e $"

class	RP_STRATEGY

create {RP_REFERENCE_SYSTEM}

	make

feature {NONE} -- Initialization

	make (a_strategy: GCDB_STRATEGY_TYPE) is
			-- Create public RP_STRATEGY based on GCDB classification for `a_strategy'.
		do
			if a_strategy = Void then
				is_unknown := True
				code := Code_unknown_constant
				stock_capitalization := Code_unknown_constant
			else
				code := a_strategy.code
				stock_capitalization := a_strategy.stock_capitalization
				is_long_short := a_strategy.is_long_short
				is_limited_long_short := a_strategy.is_limited_shorting
			end
		end

feature -- Access

	is_unknown: BOOLEAN
			-- Strategy is of unknown type

	code: STRING
			-- Strategy code

	stock_capitalization: STRING
			-- Stock capitalisation

	is_long_short: BOOLEAN
			-- Is underlying strategy long-short (i.e. effectively market-neutral strategy)?

	is_limited_long_short: BOOLEAN
			-- Is underlying strategy a limited shorting strategy (e.g. 130/30)


feature {NONE} -- Constants

	Code_unknown_constant: STRING is "Unknown"
			-- Placeholder for unknown strategy

invariant

	valid_code: code /= Void
	consistent_unknown_instance: is_unknown implies code.is_equal (Code_unknown_constant)

end
