note

	description:

		"PARM file wirh information by clicode"

	author: "Sami Ben-Grine"
	last_editor: "$Author: it $"
	date: "$Date: 2011/03/04 $"
	revision: "$Revision: #5 $"
	path: "$File: //rose/source/kernel/capital_actions/elections/rp_swept_accounts.e $"

deferred class RP_SWEPT_ACCOUNTS [H -> RP_PORTFOLIO_PARM_RECORD, G -> RP_PORTFOLIO_PARM [H] create make end]

inherit

	ROSE_SHARED_GLOBAL
		export {NONE} all end

	RP_EVENT_TYPE_CONSTANTS
		export {NONE} all end

	ANY

feature {NONE} -- Initialization

	make_from_windows_share (a_zone: like zone) is
			-- Create for `a_zone'
		require
			is_valid_zone: is_valid_zone (a_zone)
		do
			zone := a_zone
			parse_from_windows_share
		ensure
			zone_set: zone ~ a_zone
		end

feature -- Access

	item (a_clicode: STRING): G is
			-- Entry for `a_clicode'
			-- Returns Void if entry not found
		require
			a_clicode_not_void: a_clicode /= Void
		local
			l_key: STRING
		do
			l_key := a_clicode.as_upper
			l_key.prune_all (' ')
			l_key.prune_all ('%T')
			l_key.prune_all ('%U')
			entries.search (l_key)
			if entries.found then
				Result := entries.found_item
			end
		end

	windows_filename: STRING is
			-- Filename for this zone
		do
			Result := windows_path + "\" + windows_zonal_filename
		ensure
			filename_not_void: Result /= Void
		end

	windows_path: STRING is
			-- Windows file path
		do
			Result := global.hardcoded_path ("\\axaros.com\shares\ProdData_NT\PortfolioAccounting\ParmFiles")
		ensure
			path_not_void: Result /= Void
		end

	windows_zonal_filename: !STRING is
			-- File name for the zone
		deferred
		ensure
			result_not_void_or_empty: Result /= Void and then not Result.is_empty
		end

	zone: RP_ZONE
			-- Zone

feature -- Status Report

	is_valid_zone (a_zone: like zone): BOOLEAN is
			-- Is 'a_zone' valid for getting the settings?
		deferred
		ensure
			noze_not_void: Result implies a_zone /= Void
		end

feature {NONE} -- Implementation

	entries: DS_HASH_TABLE [G, STRING]
			-- Entries

	file: ROSE_ROBUST_FIXED_FORMATTED_TEXT_FILE [H] is
			-- File
		deferred
		ensure
			non_void_result: Result /= Void
		end

	parse_from_windows_share is
			-- Parse `file' and populate internal table
		local
			l_zone_file: like file
			l_array: ROSE_LINEAR_ARRAY [H]
			l_parm: G
			i: INTEGER
			l_h: H
		do
			create entries.make_equal (17)
			l_zone_file := file
			if l_zone_file.exists then
				l_zone_file.read_with_format
				l_array := l_zone_file.array
				from
					i := l_array.lower
				until
					i > l_array.upper
				loop
					l_h := l_array.item (i)
					if l_h.is_valid then
						create l_parm.make (l_h)
						if not entries.has (l_parm.clicode) then
							entries.force (l_parm, l_parm.clicode)
							check
								available: item (l_parm.clicode) /= Void and then item (l_parm.clicode).is_equal (l_parm)
							end
						end
					end
					i := i + 1
				end
			else
				(create {EXCEPTIONS}).raise (l_zone_file.name + " does not exist")
			end
		end

invariant

	is_valid_zone: is_valid_zone (zone)

end
