indexing
	description: "Object that has an associated swept contract"
	author: "Portfolio Accounting Tech (sm)"
	last_editor: "$Author: sm $"
	date: "$Date: 2010/02/19 $"
	revision: "$Revision: #2 $"
	archive: "$File: //rose/source/kernel/expert_system/rp_swept_contract.e $"

deferred class
	RP_SWEPT_CONTRACT [G->RP_PORTFOLIO_CONTRACT]

feature -- Access

	sweep_contract: RP_CASH_SWEPT [G]
		-- Cash out of the portfolio

feature -- Status Report

	is_swept: BOOLEAN is
		-- Is there a RP_CASH_SWEPT transaction associated to that dividend
		do
			Result := sweep_contract /= Void
		ensure
			contract_associated_to_current: Result = (sweep_contract /= Void)
		end

feature -- Change

	set_sweep_contract (a_sweep_contract: like sweep_contract) is
			-- Set 'sweep_contract' to 'a_sweep_contract'
			-- This should happen only once for a contract
		require
			sweep_contract_void: sweep_contract = Void
			new_sweep_contract_not_void: a_sweep_contract /= Void
		do
			sweep_contract := a_sweep_contract
		ensure
			sweep_contract_set: sweep_contract = a_sweep_contract
		end

end
