note

	description:

		"Tender"

	author: "Ivan Tarnavsky"
	last_editor: "$Author: e2 $"
	date: "$Date: 2011/11/29 $"
	revision: "$Revision: #8 $"
	path: "$File: //rose/source/kernel/expert_system/aflows/rp_tender.e $"

class RP_TENDER

inherit

	RP_PORTFOLIO_CORPORATE_ACTION_CONTRACT

create

	make

feature {NONE} -- Initialization

	make (a_delivered_shares: RP_QUANTITY; a_value_of_delivered_shares: RP_MONIES; a_received_cash: RP_QUANTITY;
		a_value_of_received_cash: RP_MONIES; a_event_date, a_settle_date: ROSE_DATE;
		a_portfolio: like portfolio; a_identifier: like identifier;
		a_system: like generating_system; a_custody: RP_CUSTODY) is
			-- Create
		require
			a_delivered_shares_not_void: a_delivered_shares /= Void
			a_value_of_delivered_shares_not_void: a_value_of_delivered_shares /= Void
			a_received_cash_not_void: a_received_cash /= Void
			a_value_of_received_cash_not_void: a_value_of_received_cash /= Void
			a_event_date_not_void: a_event_date /= Void
			a_settle_date_not_void: a_settle_date /= Void
			a_portfolio_not_void: a_portfolio /= Void
			a_identifier_not_void: a_identifier /= Void
			a_system_not_void: a_system /= Void
			a_custody_not_void: a_custody /= Void
		do
				-- Contract
			make_capital_action (a_system, a_event_date, a_identifier, a_portfolio, a_delivered_shares, a_settle_date)
				-- Flows
			add_flow (tender_flow_type, unknown_instrument_control, portfolio.instrument_control (a_custody), a_event_date, a_settle_date, a_delivered_shares, a_event_date, 0, a_value_of_delivered_shares)
			add_flow (tender_flow_type, unknown_instrument_control, portfolio.instrument_control (a_custody), a_event_date, a_settle_date, a_received_cash, a_event_date, 0, a_value_of_received_cash)
		end

feature -- Basic Operations

	process (a_processor: RP_CONTRACT_PROCESSOR) is
			-- <Precursor>
		do
			a_processor.process_tender (Current)
		end

end
