note
	description: "Abstraction for a collection of nodes with a header"
	author: "Mark Howard"
	last_editor: "$Author: er $"
	date: "$Date: 2013/04/24 $"
	revision: "$Revision: #10 $"
	path: "$File: //rose/source/kernel/infrastructure/widgets/grid/rp_titled_nodes.e $"

class
	RP_TITLED_NODES [G]

inherit
	ARRAYED_LIST [RP_GRID_NODE [G]]
		rename
			make as arrayed_list_make,
--			make_empty as arrayed_list_make_empty,
			make_from_array as arrayed_list_make_from_array
		end
create
	make, make_empty, make_from_array, make_filled, make_simple

create {RP_TITLED_NODES}
	arrayed_list_make

feature -- Initialization

	make_empty (a_titles: like titles)
			-- Make with only the header
		do
			arrayed_list_make (0)
			set_titles (a_titles)
		end

	make_simple (a_titles: ARRAY [ANY])
			-- Create from an arbitrary list, for example a list of strings for the titles
		local
			l_titles: like titles
		do
			create l_titles.make (a_titles)
			make_empty (l_titles)
		end

	make (a_titles: like titles; a_lower, a_upper: INTEGER)
			-- Make empty with titles
		do
			arrayed_list_make (a_upper - a_lower + 1)
			set_titles (a_titles)
		end

	make_from_array (a_titles: like titles; a_array: ARRAY [RP_GRID_NODE [G]])
			-- Make with titles and members
		do
			set_titles (a_titles)
			arrayed_list_make_from_array (a_array)
		end

feature -- Access

	titles: RP_GRID_TITLE_NODE [G]
			-- Node displaying titles and exposing sort function

feature -- Basic Operations

	set_titles (a_titles: like titles)
			-- Set 'titles'.
		do
			titles := a_titles
		end

	append_nodes (a_nodes: LINEAR [RP_GRID_NODE [G]])
			-- Add `a_rows' to `Current'
		local
			i: INTEGER
			l_array: ROSE_LINEAR_ARRAY [RP_GRID_NODE [G]]
		do
			create l_array.make_from_linear (a_nodes)
			from i := 1 until i > l_array.count loop
				extend (l_array [i])
				i := i + 1
			end
		end

end
