indexing

	description:

		"J zone specific valuator"

	date: "$Date: 2010/04/30 $"
	fileid: "$Id: //rose/source/kernel/expert_system/valuators/rp_valuator_jzone_default.e#2 $"

class RP_VALUATOR_JZONE_DEFAULT

inherit

	RP_HOLDING_VALUATOR_AXAR_DEFAULT
		redefine
			index_future_value_in_currency,
			currency_future_value_in_currency
		end

create

	make

feature {NONE} -- Implementation

	index_future_value_in_currency (a_holding: RP_HOLDING; a_currency: RP_CURRENCY; a_date: ROSE_DATE; a_bucket: STRING): RP_MONIES is
			-- Value of `a_holding' in `a_currency' on `a_date'.
		local
			l_fx_rate, l_value: RP_DECIMAL
			l_price: RP_PRICE
			l_index_future: RP_INDEX_FUTURE
		do
			Result := a_currency.monies (0)
			l_index_future ?= a_holding.quantity.instrument
			if l_index_future /= Void then
					-- XXX Why are SSI futures not valued?
				if not l_index_future.brimsym.has_substring ("SSI") then
					l_value := a_holding.quantity.amount
					if not l_value.is_zero then
						l_price := index_future_pricing_algorithm.price (l_index_future, a_date)
						if l_price /= Void then
							l_fx_rate := fx_rate (l_price.currency, a_currency, a_date)
							l_value := l_value * l_price.price * l_fx_rate * l_index_future.contract_size
							Result := a_currency.monies (l_value)
								-- report back the price timex contract size for compatibility
							log_price (portfolio (a_holding), l_price.instrument.price_in_currency (l_price.price * l_index_future.contract_size, l_price.currency, a_date), a_holding.quantity, a_date, a_bucket)
						else
							log_no_price (portfolio (a_holding), a_holding.quantity, a_date, a_bucket)
						end
					end
				end
			end
		end

	currency_future_value_in_currency (a_holding: RP_HOLDING; a_currency: RP_CURRENCY; a_date: ROSE_DATE; a_bucket: STRING): RP_MONIES is
			-- Value of `a_holding' in `a_currency' on `a_date'.
		local
			l_fx_rate: RP_DECIMAL
			l_value: RP_DECIMAL
			l_currency_future: RP_CURRENCY_FUTURE
			l_price: RP_PRICE
		do
			Result := a_currency.monies (0)
			l_currency_future ?= a_holding.quantity.instrument
			if l_currency_future /= Void then
				if not a_holding.quantity.instrument.brimsym.has_substring ("SSI") then
					l_value := a_holding.quantity.amount
					if not l_value.is_zero then
						l_fx_rate := fx_rate (l_currency_future.currency, a_currency, a_date)
						l_price := l_currency_future.price_in_currency (l_fx_rate, a_currency, a_date)
						l_value := l_value * l_price.price
						Result := a_currency.monies (l_value)
						log_price (portfolio (a_holding), l_price, a_holding.quantity, a_date, a_bucket)
					end
				end
			end
		end

end
