indexing
	description: "Calendar where weekends only are non-bank non-market days"
	author: "it"
	date: "$Date: 2010/02/24 $"
	revision: "$Revision: #1 $"
	archive: "$File: //rose/source/kernel/expert_system/ref/rp_weekdays_calendar.e $"

class
	RP_WEEKDAYS_CALENDAR

inherit
	RP_CALENDAR

feature	-- Queries

	is_work_day (a_date: ROSE_DATE): BOOLEAN is
			-- Is 'a_date' a work day in this calendar?
		do
			Result := a_date.day_of_the_week /= 1 and a_date.day_of_the_week /= 7
		end

	ith_work_day_after(a_date : ROSE_DATE;a_days : INTEGER) : ROSE_DATE is
			-- Work day 'a_days' after 'a_date'
		do
			create Result.make_ccyymmdd (a_date.ccyymmdd)
			Result.add_n_days (a_days)
			Result := next_work_day (Result)
		end

	ith_work_day_before(a_date : ROSE_DATE;a_days : INTEGER) : ROSE_DATE is
			-- Work day 'a_days' before 'a_date'
		do
			create Result.make_ccyymmdd (a_date.ccyymmdd)
			Result.add_n_days (- a_days)
			Result := last_work_day (Result)
		end

	last_work_day(a_date : ROSE_DATE) : ROSE_DATE is
			-- Work day prior to 'a_date'
		do
			create Result.make_ccyymmdd (a_date.ccyymmdd)
			-- sunday?
			if Result.day_of_the_week = 1 then
				-- make it saturday
				Result.add_n_days (-1)
			end
			-- saturday?
			if Result.day_of_the_week = 7 then
				-- make it friday
				Result.add_n_days (-1)
			end
		end

	next_work_day(a_date : ROSE_DATE) : ROSE_DATE is
			-- Next work day after 'a_date'
		do
			create Result.make_ccyymmdd (a_date.ccyymmdd)
			-- saturday?
			if Result.day_of_the_week = 7 then
				-- make it sunday
				Result.add_n_days (1)
			end
			-- sunday?
			if Result.day_of_the_week = 1 then
				-- make it monday
				Result.add_n_days (1)
			end
		end
end
