indexing

	description:

		"Doubly-linked list of DailyReturns for zonal product (composite)"

	date: "$Date: 2009/02/23 $"
	revision: "$Revision: #5 $"

class RP_ZONAL_PRODUCT_DAILY_RETURNS

inherit

	RP_PRODUCT_DAILY_RETURNS [RP_ZONAL_PRODUCT, RP_PORTFOLIO]

create

	make

feature {NONE} -- Implementation

	retrieve_components is
			-- Retrieve list of distinct `portfolios'
		do
			create components.make_equal (17)
			product.portfolios.do_all (agent add_portfolio (?))
		end

	add_portfolio (a_interval: RP_PORTFOLIO_HISTORY_INTERVAL) is
			-- Add portfolio from `a_interval' to `portfolios'
		do
			components.force (a_interval.portfolio)
		end

	membership_start_date: ROSE_DATE is
			-- Membership start date
		do
			Result := product.portfolios.min_start_date
		end

	membership_end_date: ROSE_DATE is
			-- Membership end date
		do
			Result := product.portfolios.max_end_date
		end

	component_name (a_component: RP_PORTFOLIO): STRING is
			-- Name of `a_component'
		do
			Result := a_component.code
		end

end
