indexing
	description: "Eiffel runtime memory model"
	author: "Pierre Nallet"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #6 $"

class
	RUN_TIME_MEMORY_MODEL

inherit
	MEMORY_MODEL

feature -- Initialization

	id: INTEGER is 1
			-- Identification of this MEMORY_MODEL

	alloc (a_size: INTEGER): POINTER is
			-- Address of new allocated memory buffer with 'a_size' in bytes
		do
			Result := c_calloc (a_size, 1)
		end

feature -- Basic operations

	free (a_pointer: POINTER) is
			-- Free memory block pointed by 'a_pointer'.
		do
			c_free (a_pointer)
		end

feature {NONE} -- Implementation

	c_calloc (a_size, a_byte_size: INTEGER): POINTER is
		external
			"C [macro <string.h>] (size_t, size_t): EIF_POINTER"
		alias
			"calloc"
		end

	c_free (a_pointer: POINTER) is
		external
			"C [macro <string.h>] (void *) "
		alias
			"free"
		end

end -- class RUN_TIME_MEMORY_MODEL
