indexing
	description: "Interface of a RX_EXPRESSION_FACTORY"
	notice: "Provide a descendant of this class to implement semantic actions for the RX_EXPRESSION pseudo language"
	author: "Zoran Simic"
	date: "$Date: 2009/04/06 $"
	revision: "$Revision: #5 $"

deferred class
	RX_EXPRESSION_FACTORY [G -> RX_EXPRESSION]

feature -- Access

	expression_from_id (a_id: STRING): G is
			-- Expression corresponding to 'a_id'
		require
			id_not_void: a_id /= Void
		deferred
		end

	binary_operator_plus (a_left, a_right: G): G is
			-- Expression corresponding to 'a_left' + 'a_right'
		require
			left_and_right_not_void: a_left /= Void and then a_right /= Void
		deferred
		end

	binary_operator_at (a_left, a_right: G): G is
			-- Expression corresponding to 'a_left' @ 'a_right'
		require
			left_and_right_not_void: a_left /= Void and then a_right /= Void
		deferred
		end

	binary_operator_delta (a_left, a_right: G): G is
			-- Expression corresponding to 'a_left' & 'a_right'
		require
			left_and_right_not_void: a_left /= Void and then a_right /= Void
		deferred
		end

	binary_operator_unknown (a_left, a_right: G): G is
			-- Expression corresponding to 'a_left' ? 'a_right'
		require
			left_and_right_not_void: a_left /= Void and then a_right /= Void
		deferred
		end

end
