indexing
	description: "Scanner for RX_EXPRESSION-s"
	author: "Zoran Simic"
	generator: "Gobo - geyacc"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #3 $"

class
	RX_EXPRESSION_SCANNER

inherit
	YY_COMPRESSED_SCANNER_SKELETON
		rename
			make as make_compressed_scanner_skeleton,
			reset as reset_compressed_scanner_skeleton,
			output as yy_scanner_output
		end

	RX_EXPRESSION_TOKENS
		export {NONE} all end

create
	make_scanner

feature {NONE} -- Initialization

	make_scanner is
			-- Make scanner.
		do
			make_with_buffer (Empty_buffer)
			create lexical_buffer.make (Init_lexical_buffer_size)
			line_number := 1
		end

feature -- Initialization

	reset is
			-- Reset scanner before scanning next input.
		do
			reset_compressed_scanner_skeleton
			line_number := 1
			lexical_buffer.wipe_out
		end

feature -- Access

	line_number: INTEGER
			-- Current line number


feature -- Status report

	valid_start_condition (sc: INTEGER): BOOLEAN is
			-- Is `sc' a valid start condition?
		do
			Result := (INITIAL <= sc and sc <= IN_STR)
		end

feature {NONE} -- Implementation

	yy_build_tables is
			-- Build scanner tables.
		do
			yy_nxt := yy_nxt_template
			yy_chk := yy_chk_template
			yy_base := yy_base_template
			yy_def := yy_def_template
			yy_ec := yy_ec_template
			yy_meta := yy_meta_template
			yy_accept := yy_accept_template
		end

	yy_execute_action (yy_act: INTEGER) is
			-- Execute semantic action.
		do
if yy_act <= 39 then
if yy_act <= 20 then
if yy_act <= 10 then
if yy_act <= 5 then
if yy_act <= 3 then
if yy_act <= 2 then
if yy_act = 1 then
--|#line 57 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 57")
end
-- Separators ignored
else
--|#line 58 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 58")
end
-- Comments ignored
end
else
--|#line 60 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 60")
end
line_number := line_number + 1
end
else
if yy_act = 4 then
--|#line 63 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 63")
end
last_token := RE_FALSE
else
--|#line 64 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 64")
end
last_token := RE_TRUE
end
end
else
if yy_act <= 8 then
if yy_act <= 7 then
if yy_act = 6 then
--|#line 67 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 67")
end
last_token := RE_ABS
else
--|#line 68 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 68")
end
last_token := RE_AND
end
else
--|#line 69 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 69")
end
last_token := RE_DIV
end
else
if yy_act = 9 then
--|#line 70 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 70")
end
last_token := RE_DIV
else
--|#line 71 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 71")
end
last_token := RE_IMPLIES
end
end
end
else
if yy_act <= 15 then
if yy_act <= 13 then
if yy_act <= 12 then
if yy_act = 11 then
--|#line 72 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 72")
end
last_token := RE_MOD
else
--|#line 73 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 73")
end
last_token := RE_OR
end
else
--|#line 74 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 74")
end
last_token := RE_XOR
end
else
if yy_act = 14 then
--|#line 75 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 75")
end
last_token := RE_NOT
else
--|#line 76 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 76")
end
last_token := RE_LE
end
end
else
if yy_act <= 18 then
if yy_act <= 17 then
if yy_act = 16 then
--|#line 77 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 77")
end
last_token := RE_GE
else
--|#line 78 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 78")
end
last_token := RE_NE
end
else
--|#line 79 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 79")
end
last_token := RE_NE
end
else
if yy_act = 19 then
	yy_end := yy_end - 1
--|#line 82 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 82")
end

						last_token := RE_DOUBLE
						last_string_value := text

else
--|#line 83 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 83")
end

						last_token := RE_DOUBLE
						last_string_value := text

end
end
end
end
else
if yy_act <= 30 then
if yy_act <= 25 then
if yy_act <= 23 then
if yy_act <= 22 then
if yy_act = 21 then
--|#line 84 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 84")
end

						last_token := RE_DOUBLE
						last_string_value := text

else
--|#line 90 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 90")
end

						last_token := RE_INTEGER
						last_string_value := text

end
else
--|#line 96 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 96")
end
last_token := RE_CHARACTER; last_string_value := text_substring (2,2)
end
else
if yy_act = 24 then
--|#line 97 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 97")
end
last_token := RE_CHARACTER; last_string_value := "%A"
else
--|#line 98 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 98")
end
last_token := RE_CHARACTER; last_string_value := "%B"
end
end
else
if yy_act <= 28 then
if yy_act <= 27 then
if yy_act = 26 then
--|#line 99 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 99")
end
last_token := RE_CHARACTER; last_string_value := "%C"
else
--|#line 100 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 100")
end
last_token := RE_CHARACTER; last_string_value := "%D"
end
else
--|#line 101 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 101")
end
last_token := RE_CHARACTER; last_string_value := "%F"
end
else
if yy_act = 29 then
--|#line 102 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 102")
end
last_token := RE_CHARACTER; last_string_value := "%H"
else
--|#line 103 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 103")
end
last_token := RE_CHARACTER; last_string_value := "%L"
end
end
end
else
if yy_act <= 35 then
if yy_act <= 33 then
if yy_act <= 32 then
if yy_act = 31 then
--|#line 104 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 104")
end
last_token := RE_CHARACTER; last_string_value := "%N"
else
--|#line 105 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 105")
end
last_token := RE_CHARACTER; last_string_value := "%Q"
end
else
--|#line 106 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 106")
end
last_token := RE_CHARACTER; last_string_value := "%R"
end
else
if yy_act = 34 then
--|#line 107 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 107")
end
last_token := RE_CHARACTER; last_string_value := "%S"
else
--|#line 108 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 108")
end
last_token := RE_CHARACTER; last_string_value := "%T"
end
end
else
if yy_act <= 37 then
if yy_act = 36 then
--|#line 109 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 109")
end
last_token := RE_CHARACTER; last_string_value := "%U"
else
--|#line 110 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 110")
end
last_token := RE_CHARACTER; last_string_value := "%V"
end
else
if yy_act = 38 then
--|#line 111 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 111")
end
last_token := RE_CHARACTER; last_string_value := "%%"
else
--|#line 112 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 112")
end
last_token := RE_CHARACTER; last_string_value := "%'"
end
end
end
end
end
else
if yy_act <= 58 then
if yy_act <= 49 then
if yy_act <= 44 then
if yy_act <= 42 then
if yy_act <= 41 then
if yy_act = 40 then
--|#line 113 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 113")
end
last_token := RE_CHARACTER; last_string_value := "%""
else
--|#line 114 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 114")
end
last_token := RE_CHARACTER; last_string_value := "%("
end
else
--|#line 115 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 115")
end
last_token := RE_CHARACTER; last_string_value := "%)"
end
else
if yy_act = 43 then
--|#line 116 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 116")
end
last_token := RE_CHARACTER; last_string_value := "%<"
else
--|#line 117 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 117")
end
last_token := RE_CHARACTER; last_string_value := "%>"
end
end
else
if yy_act <= 47 then
if yy_act <= 46 then
if yy_act = 45 then
--|#line 120 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 120")
end
		--"
			last_token := RE_STRING
			last_string_value := text_substring (2, text_count - 1)

else
--|#line 124 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 124")
end

			if text_count > 1 then
				lexical_buffer.append_string (text_substring (2, text_count))
			end
			set_start_condition (IN_STR)

end
else
--|#line 130 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 130")
end
lexical_buffer.append_string (text)		--"
end
else
if yy_act = 48 then
--|#line 131 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 131")
end
lexical_buffer.append_character ('%A')
else
--|#line 132 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 132")
end
lexical_buffer.append_character ('%B')
end
end
end
else
if yy_act <= 54 then
if yy_act <= 52 then
if yy_act <= 51 then
if yy_act = 50 then
--|#line 133 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 133")
end
lexical_buffer.append_character ('%C')
else
--|#line 134 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 134")
end
lexical_buffer.append_character ('%D')
end
else
--|#line 135 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 135")
end
lexical_buffer.append_character ('%F')
end
else
if yy_act = 53 then
--|#line 136 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 136")
end
lexical_buffer.append_character ('%H')
else
--|#line 137 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 137")
end
lexical_buffer.append_character ('%L')
end
end
else
if yy_act <= 56 then
if yy_act = 55 then
--|#line 138 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 138")
end
lexical_buffer.append_character ('%N')
else
--|#line 139 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 139")
end
lexical_buffer.append_character ('%Q')
end
else
if yy_act = 57 then
--|#line 140 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 140")
end
lexical_buffer.append_character ('%R')
else
--|#line 141 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 141")
end
lexical_buffer.append_character ('%S')
end
end
end
end
else
if yy_act <= 68 then
if yy_act <= 63 then
if yy_act <= 61 then
if yy_act <= 60 then
if yy_act = 59 then
--|#line 142 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 142")
end
lexical_buffer.append_character ('%T')
else
--|#line 143 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 143")
end
lexical_buffer.append_character ('%U')
end
else
--|#line 144 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 144")
end
lexical_buffer.append_character ('%V')
end
else
if yy_act = 62 then
--|#line 145 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 145")
end
lexical_buffer.append_character ('%%')
else
--|#line 146 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 146")
end
lexical_buffer.append_character ('%'')
end
end
else
if yy_act <= 66 then
if yy_act <= 65 then
if yy_act = 64 then
--|#line 147 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 147")
end
lexical_buffer.append_character ('%"')		--"
else
--|#line 148 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 148")
end
lexical_buffer.append_character ('%(')
end
else
--|#line 149 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 149")
end
lexical_buffer.append_character ('%)')
end
else
if yy_act = 67 then
--|#line 150 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 150")
end
lexical_buffer.append_character ('%<')
else
--|#line 151 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 151")
end
lexical_buffer.append_character ('%>')
end
end
end
else
if yy_act <= 73 then
if yy_act <= 71 then
if yy_act <= 70 then
if yy_act = 69 then
--|#line 152 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 152")
end
line_number := line_number + 1
else
--|#line 153 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 153")
end

			last_token := RE_STRING
			if text_count > 1 then
				lexical_buffer.append_string (text_substring (1, text_count - 1))
			end
			last_string_value := clone (lexical_buffer)
			lexical_buffer.wipe_out
			set_start_condition (INITIAL)

end
else
--|#line 162 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 162")
end
lexical_buffer.append_character (text_item (2))
end
else
if yy_act = 72 then
--|#line 163 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 163")
end
	--| Catch-all rules (no backing up)
			last_token := RE_ERROR
			set_start_condition (INITIAL)

else
--|#line 164 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 164")
end
	--| Catch-all rules (no backing up)
			last_token := RE_ERROR
			set_start_condition (INITIAL)

end
end
else
if yy_act <= 75 then
if yy_act = 74 then
--|#line 165 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 165")
end
	--| Catch-all rules (no backing up)
			last_token := RE_ERROR
			set_start_condition (INITIAL)

else
--|#line 172 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 172")
end
last_token := RE_IDENTIFIER; last_string_value := text
end
else
if yy_act = 76 then
--|#line 178 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 178")
end
last_token := text_item (1).code
else
--|#line 0 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 0")
end
last_token := yyError_token
fatal_error ("scanner jammed")
end
end
end
end
end
end
		end

	yy_execute_eof_action (yy_sc: INTEGER) is
			-- Execute EOF semantic action.
		do
			inspect yy_sc
when 0 then
--|#line 0 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 0")
end

			last_token := RE_EOF
			--| terminate

when 1 then
--|#line 0 "..\..\External\parsing\rx_expression_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file '..\..\External\parsing\rx_expression_scanner.l' at line 0")
end
	--| Catch-all rules (no backing up)
			last_token := RE_ERROR
			set_start_condition (INITIAL)

			else
				terminate
			end
		end

feature {NONE} -- Table templates

	yy_nxt_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    6,    7,    8,    9,    6,   10,    6,    6,    6,
			   11,   12,   13,   14,   15,    6,   16,   17,   18,   18,
			   19,   18,   20,   18,   18,   21,   18,   22,   23,   24,
			   18,   18,   18,   18,   25,   18,   18,   26,   17,   18,
			   19,   18,   20,   18,   23,   18,   18,   25,   18,   18,
			    6,   28,   29,   30,   28,   29,   30,   38,   46,   40,
			   39,   41,   42,   43,   49,   53,   45,   54,   47,   40,
			  109,   41,  118,   60,   60,  118,   60,  119,   53,   46,
			   54,  150,  120,  109,   47,   49,   58,   59,   60,   61,
			   62,   63,   64,   65,   58,   58,   58,   66,   58,   67,

			   58,   68,   69,   70,   71,   72,   58,   73,   58,   74,
			   58,   75,   58,   76,   58,   58,   77,   78,   79,   80,
			   81,   82,   58,   58,   58,   58,   58,   58,   58,   58,
			   58,   58,   58,   58,   58,   58,   84,   85,   86,   87,
			   88,  110,  112,  152,  111,   37,   89,  107,   90,   91,
			   92,   93,   94,  105,   95,  108,   96,  111,   97,  112,
			   98,  110,  114,   99,  100,  101,  102,  103,  104,  149,
			  115,  116,  117,  105,  152,  108,  142,  142,  107,  147,
			  143,  148,  114,  115,  116,  117,  144,  145,  145,  149,
			  155,  146,  147,  151,  151,  156,  154,  152,  148,   27,

			   27,   27,   27,   27,   27,  153,  144,  146,  156,   32,
			  155,  146,   32,   32,   32,   34,  143,   34,   56,   34,
			   34,   56,   56,   56,   36,  143,   36,   36,   36,   36,
			  106,  106,  106,  106,  141,  106,  140,  139,  138,  137,
			  136,  135,  134,  133,  132,  131,  130,  129,  128,  127,
			  126,  125,  124,  123,  122,  121,  120,   57,  113,   83,
			   33,   31,   57,   55,   52,   51,   50,   48,   44,   37,
			   36,   35,   33,   31,  157,    5,  157,  157,  157,  157,
			  157,  157,  157,  157,  157,  157,  157,  157,  157,  157,
			  157,  157,  157,  157,  157,  157,  157,  157,  157,  157,

			  157,  157,  157,  157,  157,  157,  157,  157,  157,  157,
			  157,  157,  157,  157,  157,  157,  157,  157,  157,  157,
			  157,  157,  157,  157,  157,  157, yy_Dummy>>)
		end

	yy_chk_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    3,    3,    3,    4,    4,    4,   13,   17,   14,
			   13,   14,   15,   15,   20,   24,  161,   25,   17,   41,
			   46,   41,   59,   59,   60,  118,  118,   60,   24,   17,
			   25,  120,  120,   46,   17,   20,   30,   30,   30,   30,
			   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,

			   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
			   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
			   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
			   30,   30,   30,   30,   30,   30,   35,   35,   35,   35,
			   35,   47,   49,  152,   48,   37,   35,   40,   35,   35,
			   35,   35,   35,   37,   35,   40,   35,   48,   35,   49,
			   35,   47,   51,   35,   35,   35,   35,   35,   35,  116,
			   52,   54,   55,   37,  151,   40,  105,  105,  107,  112,
			  105,  113,   51,   52,   54,   55,  107,  108,  108,  116,
			  154,  108,  112,  144,  144,  155,  148,  144,  113,  158,

			  158,  158,  158,  158,  158,  147,  107,  146,  155,  159,
			  154,  145,  159,  159,  159,  160,  143,  160,  162,  160,
			  160,  162,  162,  162,  163,  142,  163,  163,  163,  163,
			  164,  164,  164,  164,  104,  164,  103,  102,  101,  100,
			   99,   98,   97,   96,   95,   94,   93,   92,   91,   90,
			   89,   88,   87,   86,   85,   84,   66,   56,   50,   34,
			   32,   31,   27,   26,   23,   22,   21,   19,   16,   12,
			   11,   10,    9,    7,    5,  157,  157,  157,  157,  157,
			  157,  157,  157,  157,  157,  157,  157,  157,  157,  157,
			  157,  157,  157,  157,  157,  157,  157,  157,  157,  157,

			  157,  157,  157,  157,  157,  157,  157,  157,  157,  157,
			  157,  157,  157,  157,  157,  157,  157,  157,  157,  157,
			  157,  157,  157,  157,  157,  157, yy_Dummy>>)
		end

	yy_base_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    0,    0,   48,   51,  274,  275,  271,  275,  268,
			  266,  260,  256,   45,   48,   47,  253,   40,    0,  242,
			   47,  239,  236,  235,   33,   35,  234,  258,  275,  275,
			   85,  259,  256,  275,  253,  132,    0,  132,  275,  275,
			  134,   58,  275,  275,  275,    0,   37,  121,  108,  116,
			  228,  142,  136,    0,  136,  140,  253,  275,  275,   70,
			   72,  275,  275,  275,  275,  275,  243,  275,  275,  275,
			  275,  275,  275,  275,  275,  275,  275,  275,  275,  275,
			  275,  275,  275,  275,  249,  248,  247,  246,  245,  244,
			  243,  242,  241,  240,  239,  238,  237,  236,  235,  234,

			  233,  232,  231,  230,  228,  167,  275,  165,  178,    0,
			    0,    0,  146,  155,    0,    0,  148,    0,   73,  275,
			   69,  275,  275,  275,  275,  275,  275,  275,  275,  275,
			  275,  275,  275,  275,  275,  275,  275,  275,  275,  275,
			  275,  275,  212,  203,  184,  198,  194,  164,  171,    0,
			  275,  161,  130,    0,  169,  162,    0,  275,  198,  208,
			  214,   60,  217,  223,  229, yy_Dummy>>)
		end

	yy_def_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,  157,    1,  158,  158,  157,  157,  157,  157,  159,
			  160,  157,  157,  157,  157,  157,  157,  161,  161,  161,
			  161,  161,  161,  161,  161,  161,  161,  162,  157,  157,
			  157,  157,  159,  157,  157,  157,  163,  157,  157,  157,
			  164,  157,  157,  157,  157,  161,  161,  161,  161,  161,
			  161,  161,  161,  161,  161,  161,  162,  157,  157,  157,
			  157,  157,  157,  157,  157,  157,  157,  157,  157,  157,
			  157,  157,  157,  157,  157,  157,  157,  157,  157,  157,
			  157,  157,  157,  157,  157,  157,  157,  157,  157,  157,
			  157,  157,  157,  157,  157,  157,  157,  157,  157,  157,

			  157,  157,  157,  157,  157,  157,  157,  157,  157,  161,
			  161,  161,  161,  161,  161,  161,  161,  161,  157,  157,
			  157,  157,  157,  157,  157,  157,  157,  157,  157,  157,
			  157,  157,  157,  157,  157,  157,  157,  157,  157,  157,
			  157,  157,  157,  157,  157,  157,  157,  161,  161,  161,
			  157,  157,  157,  161,  161,  161,  161,    0,  157,  157,
			  157,  157,  157,  157,  157, yy_Dummy>>)
		end

	yy_ec_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    2,
			    3,    1,    1,    2,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    2,    1,    4,    1,    1,    5,    1,    6,
			    7,    8,    1,    9,    1,   10,   11,   12,   13,   13,
			   13,   13,   13,   13,   13,   13,   13,   13,    1,    1,
			   14,   15,   16,    1,    1,   17,   18,   19,   20,   21,
			   22,   23,   24,   25,   23,   23,   26,   27,   28,   29,
			   30,   31,   32,   33,   34,   35,   36,   23,   37,   23,
			   23,    1,    1,    1,    1,   23,    1,   38,   39,   23,

			   40,   41,   42,   23,   23,   25,   23,   23,   43,   27,
			   44,   29,   30,   23,   45,   46,   47,   48,   49,   23,
			   37,   23,   23,    1,   50,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1, yy_Dummy>>)
		end

	yy_meta_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    2,    1,    3,    4,    1,    1,    1,
			    1,    5,    1,    6,    1,    1,    1,    6,    6,    6,
			    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
			    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
			    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
			    6, yy_Dummy>>)
		end

	yy_accept_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    0,    0,    0,    0,   78,   76,    1,    3,   46,
			   76,   76,   76,   76,   22,   76,   76,   75,   75,   75,
			   75,   75,   75,   75,   75,   75,   75,   47,   72,   70,
			   72,    1,   46,   45,    0,    0,    2,   21,    9,   18,
			    0,   22,   15,   17,   16,   75,   75,   75,   75,   75,
			   75,   75,   75,   12,   75,   75,   47,   70,   71,   71,
			   73,   64,   62,   63,   65,   66,   71,   67,   68,   48,
			   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,
			   59,   60,   61,   23,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

			    0,    0,    0,    0,    0,    0,   19,   21,   19,    6,
			    7,    8,   75,   75,   11,   14,   75,   13,    0,   69,
			   74,   40,   38,   39,   41,   42,   43,   44,   24,   25,
			   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
			   36,   37,    0,   21,    0,    0,   20,   75,   75,    5,
			   74,    0,   20,    4,   75,   75,   10,    0, yy_Dummy>>)
		end

feature {NONE} -- Constants

	yyJam_base: INTEGER is 275
			-- Position in `yy_nxt'/`yy_chk' tables
			-- where default jam table starts

	yyJam_state: INTEGER is 157
			-- State id corresponding to jam state

	yyTemplate_mark: INTEGER is 158
			-- Mark between normal states and templates

	yyNull_equiv_class: INTEGER is 1
			-- Equivalence code for NULL character

	yyReject_used: BOOLEAN is false
			-- Is `reject' called?

	yyVariable_trail_context: BOOLEAN is false
			-- Is there a regular expression with
			-- both leading and trailing parts having
			-- variable length?

	yyReject_or_variable_trail_context: BOOLEAN is false
			-- Is `reject' called or is there a
			-- regular expression with both leading
			-- and trailing parts having variable length?

	yyNb_rules: INTEGER is 77
			-- Number of rules

	yyEnd_of_buffer: INTEGER is 78
			-- End of buffer rule code

	yyLine_used: BOOLEAN is false
			-- Are line and column numbers used?

	yyPosition_used: BOOLEAN is false
			-- Is `position' used?

	INITIAL: INTEGER is 0
	IN_STR: INTEGER is 1
			-- Start condition codes

feature -- User-defined features



feature {NONE} -- Implementation

	lexical_buffer: STRING
			-- Buffer for lexical tokens

	code_: INTEGER
			-- Attribute used as temporary integer

	last_indentation: STRING
		-- Keep indentation to save back config almost as read

feature {NONE} -- Constants

	Init_lexical_buffer_size: INTEGER is 256
				-- Initial size for `lexical_buffer'

end
