note

	description:

		"the entity to map external/internal sector definition"

	author: "Anand Surelia"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/06/22 $"
	revision: "$Revision: #8 $"
	path: "$File: //rose/source/kernel/entities/reference/sector.e $"

class
	SECTOR

inherit
	INVESTMENT_ENTITY
	PERSISTENT_SECTOR
		undefine
			context,
			make,
			make_context,
			debug_output
		end

create
	make, make_anonymous

feature -- Basic operations

	similars : like sector_to_similars_group_history is
			-- Similars
		do
			if similars_saved = Void then
				similars_saved := sector_to_similars_group_history
			end
			Result := similars_saved
		end

	industry : like context.industry_template is
			-- industry
		local
			l_similars_group : like context.similars_group_template
		do
			if industry_saved = Void then
				l_similars_group := something_related_by_sector_to_similars_group
				if l_similars_group /= Void then
					industry_saved := l_similars_group.something_corelated_by_industry_to_similars_group
				end
			end
			Result := industry_saved
		end

	economic_sector(a_group_name : STRING; a_date : ROSE_DATE) : like context.economic_sector_template is
			-- economic sector
		require
			valid_group_name : a_group_name /= Void
		local
			l_similars_group : like context.similars_group_template
		do
			l_similars_group := something_related_by_sector_to_similars_group
			if l_similars_group /= Void then
				Result := l_similars_group.economic_sector(a_group_name, a_date)
			end
		end

feature {NONE} -- Implementation

	similars_saved : like sector_to_similars_group_history
	industry_saved : like context.industry_template

end
