indexing
	description : "[
		Class for sharing database errors
		]"
	author : "Mark Howard"
	date: "$Date: 2009/06/23 $"
	revision: "$Revision: #4 $"

class
	SELECTION_ERROR
feature  --Access
	fail_on_error : BOOLEAN is
			--should we fail on error?
		do
			if fail_on_error_local /= void then
				Result := fail_on_error_local.item
			else
				Result := fail_on_error_global.item
			end
		end
	set_global_fail_on_error (a_value : BOOLEAN) is
		do
			fail_on_error_global.put (a_value)
		end
	set_fail_on_error (a_value : BOOLEAN) is
		do
			create fail_on_error_local.put (a_value)
		end
	forget_fail_on_error is
	--if fail_on_error_local is not void then it will always be looked at, so
	--this allows us to pass responsibility to once feature
		do
			fail_on_error_local := void
		end
feature {NONE} --Implementation
	fail_on_error_global : CELL[BOOLEAN] is
		once
			create Result.put (False)
		end
	fail_on_error_local : CELL[BOOLEAN]
	ignoring_global : BOOLEAN
end -- class SELECTION_ERROR
