indexing
	description : "[
		Common ancestor for SIMPLE_PREDICATE and COLLECTING_PREDICATE.  If you
		want to collect the rows from a query into an array, use COLLECTING_PREDICATE.
		If you want to handle each row as it is retrieved with an agent then use
		SIMPLE_PREDICATE.  If G does not have default_create as a creation procedure
		then you must use this class directly instead of those.
		]"
	author : "Mark Howard"
	date: "$Date: 2010/02/08 $"
	revision: "$Revision: #32 $"

class
	SELECTION_PREDICATE [G]

inherit
	REFERENCE_SELECTION_PREDICATE [G]
		export
			{ANY} item
		end

create
	make, make_with_parameter_template

feature -- Basic operations

	set_template (a_template : like empty_vessel) is
   		-- Set 'template' (prototype row item)
		do
			vessel := a_template.deep_twin
			empty_vessel := a_template.deep_twin
		end

	make_extendable_iterator is
			-- Creation procedure.
		do
			  create {EXTENDABLE_PREDICATE_ITERATOR[G]} iterator.make(Current)
		end

	make_indexable_iterator is
			-- Creation procedure.
		do
			   create {INDEXABLE_PREDICATE_ITERATOR[G]} iterator.make(Current)
		end

	general_selection_predicate_make(a_server : DATA_SERVER;a_selection : STRING) is
			-- Generic creation procedure.
		do
		end

end
