indexing
	description: "See the table 'server_request' in the repository."
	author: "RJ"
	date: "$Date: 2014/02/26 $"
	revision: "$Revision: #12 $"
	archive: "$File: //rose/source/kernel/infrastructure/network/server_request.e $"

class
	SERVER_REQUEST

inherit
	DEBUG_OUTPUT

feature -- Data (and set_ routines).
	machine: STRING
	set_machine(a_value : like machine) is
	local
		l_dot_pos: INTEGER
		l_machine_name: STRING
	do
		l_machine_name := a_value.as_upper
		l_dot_pos := l_machine_name.index_of('.', 1)
		if l_dot_pos/=0
		then
			l_machine_name := l_machine_name.substring(1, l_dot_pos - 1)
		end

		machine := l_machine_name
	end

	server_executable: STRING
	set_server_executable(a_value : like server_executable) is
	do
		server_executable := a_value
	end

	user_id: STRING

	client: STRING

	arguments: STRING

	command: STRING

	server_pid: INTEGER
	set_server_pid(a_value : like server_pid) is
	do
		server_pid := a_value
	end

	client_pid: INTEGER

	port: INTEGER

	log_file: STRING

	timestamp: ROSE_DATE
	set_timestamp(a_value : like timestamp) is
	do
		timestamp := a_value
	end

	terminated_by: STRING

	terminated_at: ROSE_DATE

feature -- Utility.
	string_array: ROSE_LINEAR_ARRAY[STRING] is
	-- Returns each data item as a STRING in an ARRAY.
	do
		create Result.make_empty
		Result.extend(machine)
		Result.extend(server_executable)
		Result.extend(user_id)
		Result.extend(client)
		Result.extend(arguments)
		Result.extend(command)
		Result.extend(server_pid.out)
		if client_pid>500_000_000
		then
			Result.extend(client_pid.to_hex_string)		-- VMS
		else
			Result.extend(client_pid.out)
		end

		Result.extend(port.out)
		Result.extend(log_file)
		if timestamp/=Void
		then
			Result.extend(timestamp.formatted_out(date_time_format))
		else
			Result.extend("Void")
		end

		Result.extend(terminated_by)
		if terminated_at/=Void
		then
			Result.extend(terminated_at.formatted_out(date_time_format))
		else
			Result.extend("")
		end
	end

	debug_output: STRING is
	do
		Result := machine + "/" + server_pid.out
	end

	date_time_format: STRING is "YYYY/[0]MM/[0]DD [0]HH:[0]MI:[0]SS"

end
