indexing
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #9 $"
	path: "$File: //rose/source/kernel/infrastructure/network/server_status_message.e $"
	
class
	SERVER_STATUS_MESSAGE
	
inherit
	PORT_SERVER_MESSAGE
	
create
	default_create,
	make_failed
	
feature
	
	make_failed is
		do
			create creation_time
			create exit_time
			create kernel_time
			create user_time
			create memory_counter
		end
	
feature
	
	server_pid : INTEGER
	set_server_pid(a_value : like server_pid) is
		do
			server_pid := a_value
		end
	
	creation_time : WINDOWS_FILETIME
	set_creation_time(a_value : like creation_time) is
		do
			creation_time := a_value
		end
	
	exit_time : WINDOWS_FILETIME
	set_exit_time(a_value : like exit_time) is
		do
			exit_time := a_value
		end
	
	kernel_time : WINDOWS_FILETIME
	set_kernel_time(a_value : like kernel_time) is
		do
			kernel_time := a_value
		end
	
	user_time : WINDOWS_FILETIME
	set_user_time(a_value : like user_time) is
		do
			user_time := a_value
		end
	
	memory_counter : PROCESS_MEMORY_COUNTERS
	set_memory_counter(a_value : like memory_counter) is
		do
			memory_counter := a_value
		end
	
	string_array: ROSE_LINEAR_ARRAY[STRING] is
		local
			l_systemtime: SYSTEMTIME
			l_time: ROSE_TIME
		do
			create Result.make_empty
			
			--		if creation_time/=Void
			--		then
			--			Result.extend(creation_time.date_time_from_ut.formatted_out(Date_time_format))
			--		else
			--			Result.extend("")
			--		end
			
			if memory_counter/=Void then
				Result.extend(numeric_formatter.formatted((memory_counter.workingsetsize / 1024 / 1024).truncated_to_integer))
				Result.extend(numeric_formatter.formatted((memory_counter.pagefileusage / 1024 / 1024).truncated_to_integer))
			else
				Result.extend("")
				Result.extend("")
			end
			
			if user_time/=Void then
				create l_systemtime.make_from_filetime(user_time)
				l_time := l_systemtime.time
				Result.extend((l_systemtime.wday - 1).out + " " + l_time.formatted_out(time_format))
			else
				Result.extend("")
			end
			
			if kernel_time/=Void then
				create l_systemtime.make_from_filetime(kernel_time)
				l_time := l_systemtime.time
				Result.extend((l_systemtime.wday - 1).out + " " + l_time.formatted_out(time_format))
			else
				Result.extend("")
			end
		end
	
feature
	
	numeric_formatter: FORMAT_INTEGER is
		do
			create Result.make(1)
			Result.set_separator(',')
		end
	
	date_time_format: STRING is "YYYY/[0]MM/[0]DD [0]HH:[0]MI:[0]SS"
	
	time_format: STRING is "[0]HH:[0]MI:[0]SS"
	
end

