note

	description: "[
		Shared SQL table name parser.
	]"
	author: "Karine Bezault"
	last_editor: "$Author: an $"
	date: "$Date: 2013/11/08 $"
	revision: "$Revision: #2 $"
	path: "$File: //rose/source/kernel/infrastructure/persistence/shared_sql_table_name_parser.e $"

class SHARED_SQL_TABLE_NAME_PARSER

feature -- Access

	sql_table_name_parser: SQL_TABLE_NAME_PARSER
			-- Shared SQL table name parser
		once
			create Result.make
		ensure
			sql_table_name_parser_not_void: Result /= Void
		end

feature -- Basic actions

	parse_sql_statement (a_statement: STRING; a_db_definition: DATABASE_DEFINITION)
			-- Record in `a_db_definition the table names found in `a_statement'.
		require
			a_statement_not_void: a_statement /= Void
			a_db_definition_not_void: a_db_definition /= Void
		local
			l_sql_table_name_parser: SQL_TABLE_NAME_PARSER
		do
			l_sql_table_name_parser := sql_table_name_parser
			l_sql_table_name_parser.parse_sql_statement (a_statement)
			l_sql_table_name_parser.input_table_names.do_all (agent a_db_definition.add_input_table_name)
			l_sql_table_name_parser.output_table_names.do_all (agent a_db_definition.add_output_table_name)
			if l_sql_table_name_parser.syntax_error then
				if l_sql_table_name_parser.in_select_query then
					a_db_definition.add_input_table_name ("*unknown table*")
				else
					a_db_definition.add_output_table_name ("*unknown table*")
				end
			end
		end

end
