indexing
	revision: "$Revision: #13 $"
	path : "$File: //rose/source/kernel/persistence/databases/signature_tagged/signature_tagged_cache.e $"
	
class
	
	SIGNATURE_TAGGED_CACHE[G -> ROSE_SIGNATURE_RECORD[ENTITY]]
	
create
	
	make
	
feature
	
	make(a_cache_id : INTEGER) is
		do
			cache_id := a_cache_id
			create signature_pool.make_empty
		end
	
	reset(a_cache_id : INTEGER) is
		do
			cache_id := a_cache_id
			signature_pool.start
		end
	
	next_signature(a_signature : G) : ROSE_VIRTUAL_RECORD[G] is
		do
			if not signature_pool.off then
				Result := signature_pool.current_item
				Result.set_signature(a_signature)
				Result.clear
			else
				if virtual_record_template /= Void then
					Result := virtual_record_template.duplicate
					Result.make(a_signature)
				else	    
					create Result.make(a_signature)
				end
				signature_pool.extend(Result)
			end
			signature_pool.forth
		end
	
	next_duplicate(a_virtual_record : ROSE_VIRTUAL_RECORD [G]) : ROSE_VIRTUAL_RECORD[G] is
		do
			if not signature_pool.off then
				Result := signature_pool.current_item
				Result.clone_virtual_record (a_virtual_record)
			else
				Result := a_virtual_record.duplicate
				signature_pool.extend(Result)
			end
			signature_pool.forth
		end
	
	cache_id : INTEGER
	
	signature_pool : ROSE_LINEAR_ARRAY[ROSE_VIRTUAL_RECORD[G]]
	
	virtual_record_template : ROSE_VIRTUAL_RECORD[G]
	
	set_virtual_record_template(a_template : ROSE_VIRTUAL_RECORD[G]) is
		do
			virtual_record_template := a_template
			signature_pool.make_empty -- If there is a change in virtual record template, we cannot reuse the virtual records as they are of different type.
		end
	
end
