Indexing
	description: "Signature tagged data types"
	keywords: "database,signature,item,tagged,manager"
	author: "Nelson Chui"
	revision: "$Revision: #5 $"
	path : "$File: //rose/source/kernel/persistence/databases/signature_tagged/signature_tagged_data_types.e $"
	
class
	SIGNATURE_TAGGED_DATA_TYPES
	
feature
	
	base_data_types_by_name: HASH_TABLE [PAIR [STRING, INTEGER], STRING] is
		local
			i: INTEGER
		once
			create Result.make (base_data_types.count)
			from i := base_data_types.lower
			until i > base_data_types.upper
			loop
				Result.force (base_data_types.item (i), base_data_types.item (i).first)
				i := i + 1
			end
		end
	
	base_data_types: ROSE_LINEAR_ARRAY [PAIR [STRING,INTEGER]] is
		once
			create Result.make_empty
			Result.extend(create {PAIR[STRING,INTEGER]}.make ("REAL", stim_real_type))
			Result.extend(create {PAIR[STRING,INTEGER]}.make ("INTEGER", stim_int32_type))
			Result.extend(create {PAIR[STRING,INTEGER]}.make ("DOUBLE", stim_double_type))
			Result.extend(create {PAIR[STRING,INTEGER]}.make ("STRING", stim_string_type))
			Result.extend(create {PAIR[STRING,INTEGER]}.make ("IMAGE", stim_image_type))
			Result.extend(create {PAIR[STRING,INTEGER]}.make ("DATETIME", stim_date_type))
		end
	
	signature_data_type: PAIR [STRING, INTEGER] is
        once
			create Result.make ("SIGNATURE_DATA", stim_signature_data_type)
        end
    
	signature_version_type: PAIR [STRING, INTEGER] is
        once
			create Result.make ("SIGNATURE_VERSION", stim_signature_version_type)
        end
    
    stim_int32_type: INTEGER is 1
    stim_real_type: INTEGER is 2
    stim_double_type: INTEGER is 3
    stim_string_type: INTEGER is 4 
	stim_image_type: INTEGER is 5
	stim_date_type: INTEGER is 6
	stim_record_type: INTEGER is 7
	stim_signature_data_type: INTEGER is 8
	stim_signature_version_type: INTEGER is 9
	
	Blocking_override_type_id: INTEGER is 1
	Absolute_override_type_id: INTEGER is 2	  
	Confident_override_type_id: INTEGER is 3  
	Provisional_override_type_id: INTEGER is 4
	Terminating_override_type_id: INTEGER is 5

end -- END OF CLASS
