note

	description:

		"Signature data item storing blobs"

	author: "Randy John"
	last_editor: "$Author: it $"
	date: "$Date: 2015/02/18 $"
	revision: "$Revision: #9 $"
	path: "$File: //rose/source/kernel/persistence/databases/signature_tagged/signature_tagged_image_item.e $"

class
	SIGNATURE_TAGGED_IMAGE_ITEM

inherit
	SIGNATURE_TAGGED_ITEM[STRING]
		rename
			make as old_make
		redefine
			copy_to_history_statement,
			delete_no_change,
			update_data
		end

create
	make

feature {NONE} -- Initialization

	make(a_server: SQL_DATA_SERVER; a_process_id: INTEGER; a_data_name: STRING) is
		do
			old_make(a_server, a_process_id, "IMAGE", a_data_name)
		end

feature -- Access

	copy_to_history_statement: STRING is
		do
			Result := ""
		end

	delete_no_change is
		do
		end

	update_data is
		local
			l_statement : STRING
			l_retry_count : INTEGER
		do
			-- For image data we always update the history table
			l_statement :=
				"insert into " + data_value_history_table + " (signature_id, item_id, value, process_id) " +
				" select " +
				"signature_id,item_id,value,process_id " +
				"from " +
				data_value_table +
				" where exists (" +
				"select item_id,signature_id from " +
				data_value_temp_table +
				" where " +
				data_value_table + ".signature_id = " + data_value_temp_table + ".signature_id " +
				"and " +
				data_value_table + ".item_id = " + data_value_temp_table + ".item_id " +
				"and " +
				data_value_table + ".process_id <> " + data_value_temp_table + ".process_id)"

			temp_table_server.sql_execute_immediate(l_statement)
			if not temp_table_server.success then
				raise("update data failed")
			end
			-- The chage here is that we don't compare the old data with the new.
			-- ALL data is updated.
			l_statement :=
				"update " + data_value_table +
				" set " +
				"value = var1.value, " +
				"process_id = var1.process_id " +
				"from " +
				data_value_temp_table +  " as var1 " +
				"where " +
				"var1.item_id = " + data_value_table + ".item_id and " +
				"var1.signature_id = " + data_value_table + ".signature_id"
			temp_table_server.sql_execute_immediate(l_statement)
			if not temp_table_server.success then
				raise("update data failed")
			end
		rescue
			if l_retry_count < retry_limit then
				l_retry_count := l_retry_count + 1
				retry
			end
		end

end
