indexing
	description: "Signature Tagged Expression with external defined neighborhood"
	author: "Nelson Chui"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #3 $"
	archive: "$File: //rose/source/kernel/persistence/databases/signature_tagged/signature_tagged_neighborhood_expression.e $"

class
	SIGNATURE_TAGGED_NEIGHBORHOOD_EXPRESSION [reference G -> ROSE_SIGNATURE_RECORD [ENTITY] create default_create end]

inherit
	SIGNATURE_TAGGED_EXPRESSION [G]
		redefine
			expression_cache_neighborhood,
			cache_virtual_records
		end

create
	make

feature -- Access

feature -- Basic operations

feature {NONE} -- Implementation

	expression_cache_neighborhood (a_target: like signature_anchor): ROSE_LINEAR_ARRAY [like signature_anchor]
			-- expression cache neighborhood
		local
			l_targets: ROSE_LINEAR_ARRAY [like signature_anchor]
		do
			create l_targets.make (1, 1)
			l_targets.put (a_target, 1)
			Result := a_target.targets (l_targets, Void)
		end

	cache_virtual_records (a_targets: ROSE_LINEAR_ARRAY [like signature_anchor]; a_historical: BOOLEAN): ROSE_LINEAR_ARRAY [ROSE_VIRTUAL_RECORD [like signature_anchor]]
			-- Cache virtual records and return cached targets
			-- a_targets need to be sorted by signature_id, and as_of_date needs to be set
			-- require else
			--	cache_pool_off: not ur_signature.data_manager.virtual_record_set.cache_pool_on
		do
			if a_targets.count > 0 then
				Result := a_targets.first.data_manager.retrieve_virtual_records (a_historical, a_targets, Void, Void)
			end
			if Result = Void or else Result.count = 0 then
				a_targets.do_all (agent expression_cache_force (Void, ?))
			else
				load_virtual_records_to_cache (Result, a_historical, False)
			end
			if Result = Void then
				create Result.make_empty
			end
		end

end
