indexing
	description: "Objects that enable users to specify the level of output generated by signature tagged databases."
	author: "Julian Rogers"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #2 $"
	archive: "$File: //rose/source/kernel/persistence/databases/signature_tagged/signature_tagged_output_level.e $"

class
	SIGNATURE_TAGGED_OUTPUT_LEVEL

feature -- Access

	is_silent: BOOLEAN is
			-- Is no output generated by normal operation?
		do
			Result := is_silent_cell.item
		end

feature -- Basic operations

	set_silent_mode (a_is_silent: BOOLEAN) is
			-- Assign `a_is_silent' to `is_silent'.
		do
			is_silent_cell.put (a_is_silent)
		ensure
			is_silent_set: is_silent = a_is_silent
		end

feature {NONE} -- Implementation

	is_silent_cell: CELL [BOOLEAN] is
			-- Implementation to hold `is_silent' as a Once.
		once
			create Result.put (False)
		ensure
			result_not_void: Result /= Void
		end

end
