note

	description:

		"Simple expression"

	author: "Mark Howard"
	last_editor: "$Author: er $"
	date: "$Date: 2013/06/18 $"
	revision: "$Revision: #36 $"
	path: "$File: //rose/source/kernel/expressions/simple_expression.e $"
	storable_version: ""

class SIMPLE_EXPRESSION [reference G]

inherit

	ROSE_EXPRESSION [G]
		rename
			make as rose_expression_make
		redefine
			defined,
			display_string,
			units,
			value_in_market_currency,
			is_defined_real,
			is_defined_double
		end

	ROSE_LEGACY_UNDEFINED
		undefine
			default_create
		redefine
			is_defined_real,
			is_defined_double,
			is_defined_integer
		end

create

	make,
	rose_expression_make

feature {NONE} -- Initialization

	make (a_mnemonic: STRING) is
			-- Creat the expression
		require
			valid_mnemonic: a_mnemonic /= Void
		do
			set_expression_index
			mnemonic := a_mnemonic.twin
			name := mnemonic + "(Unknown)"
			create variable_description
			variable_description.set_name (mnemonic)
			variable_description.set_mnemonic (mnemonic)
			variable_description.set_type (mnemonic)
		end

feature -- Access

	defined (a_entity: G): BOOLEAN is
		do
		end

	type_string: STRING is
		do
			Result := mnemonic
		end

	description: STRING is
			-- Description
		do
			Result := mnemonic
		end

	display_string (a_entity: G): STRING is
			-- Display string
		do
			Result := "undefined"
		end

	get_real_value (a_entity: G): REAL is
		do
		end

	get_double_value (a_entity: G): DOUBLE is
		do
		end

	get_integer_value (a_entity: G): INTEGER is
		do
		end

	value_in_market_currency (a_market: MARKET; a_currency: PERSISTENT_CURRENCY; a_entity: G; a_date: ROSE_DATE): DOUBLE is
		do
			Result := double_value (a_entity)
		end

	units (a_entity: G): ROSE_UNITS is
		do
			Result := pure_units
		end

	old_units_in_currency (a_currency: PERSISTENT_CURRENCY; a_entity: G): ROSE_UNITS is
		do
			Result := pure_units
		end

	currency (a_entity: G): PERSISTENT_CURRENCY is
		do
		end

feature -- Query

	is_defined_real (a_real: REAL): BOOLEAN is
		do
		end

	is_defined_double (a_double: DOUBLE): BOOLEAN is
		do
		end

	is_defined_integer (a_integer: INTEGER): BOOLEAN is
		do
		end

end
