indexing
	description : "Object which represents an array of database selection columns"
	author : "Mark Howard"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #6 $"

class
	SQL_DATA_STRUCTURE

inherit
	DATA_STRUCTURE [SQL_SQLVAR]

create
	make

feature -- Access

	has_list_varbyte: BOOLEAN

feature -- Basic operations

	set_has_list_varbyte (a_boolean: BOOLEAN) is
		do
			has_list_varbyte := a_boolean
		end

	execute (a_object: ANY; a_values: ARRAY [ANY]) is
		local
			i, j: INTEGER
			l_message: STRING
		do
			if input_object_map = Void or else a_object = Void then
				from i := 1 until i > count
				loop
					item (i).execute (a_values.item (i))
					i := i + 1
				end
			else
				from i := 1 until i > count
				loop
					j := input_object_map.item (i)
					if j /= 0 then
						item (i).execute (internal.field (j,a_object))
					else
						j := input_array_map.item (i)
						if a_values /= Void and then a_values.valid_index (j) then
							item (i).execute (a_values.item (j))
						else
							l_message := "Parameter " + i.out
							if input_name_map = Void or else input_name_map.item (i) = Void then
								l_message.append (" (unnamed) is missing")
							elseif input_name_map.valid_index (i) then
								l_message.append (" (" + input_name_map.item (i) + ") is missing")
							else
								l_message.append (" () is missing")
							end
							raise (l_message)
							-- If we ever change this to check for the proper number
							-- of parameters we must also change INSERTION_PREDICATE:insert
							-- because it depends upon this behaviour.
						end
					end
					i := i + 1
				end
			end
		end

end -- class SQL_DATA_STRUCTURE
