indexing
	description: "SQL error info"
	author: "PN"
	last_editor: "$Author: rj $"
	date: "$Date: 2010/09/07 $"
	revision: "$Revision: #12 $"
	path: "$File: //rose/source/kernel/infrastructure/persistence/windows/classic2/sql_error_info.e $"

class
	SQL_ERROR_INFO

inherit
	COM_UNKNOWN
	MEMORY
		rename
			free as memory_free
		redefine
			dispose
		end

create
	make,
	make_by_record

feature -- Access

	make (e: ERROR_INFO) is
			-- Creation procedure.
		require
			e_not_void: e /= Void
			e_exists: e.p /= default_pointer
		local
			i: INTEGER
			l_p: POINTER
		do
			l_p := p
			i := e.query_interface (IID_ISQLErrorInfo, $l_p)
			p := l_p
		end

	make_by_record (e: ERROR_RECORDS; i: INTEGER)
			-- Wrapper for IErrorRecords::GetCustomErrorObject.
		require
			e_not_void: e /= Void
			e_exists: e.p /= default_pointer
			i_large_enough: i >= 0
			i_small_enough: i < e.get_record_count
		local
			hr: INTEGER
			l_p: POINTER
		do
			release
			l_p := p
			hr := e.Get_custom_error_object (i, IID_ISQLErrorInfo, $l_p)
			p := l_p
		end

	native_error: INTEGER is
		require
			exists: exists
		local
			i: INTEGER
			l_pointer: POINTER
		do
			i := ISQLErrorInfo_GetSQLInfo (p, $l_pointer, $Result)
		end

feature {NONE} -- Implementation.
	dispose
	-- Tell OLEDB to remove our reference.
	do
		release
	end

	ISQLErrorInfo_GetSQLInfo(This,pbstrSQLState,plNativeError: POINTER) : INTEGER is
		external
			"C [macro <oledbext.h>] (ISQLErrorInfo*, BSTR*, LONG*): EIF_INTEGER"
		alias
			"ISQLErrorInfo_GetSQLInfo"
		end

	IID_ISQLErrorInfo: POINTER is
		external
			"C [macro <oledbext.h>]"
		alias
			"&IID_ISQLErrorInfo"
		end

end
