indexing
	description: "Used by the Watcher.  This class contains certain utilities that a GUI will need to display a sysprocess."
	author: "RJ"
	last_editor: "$Author: rj $"
	date: "$Date: 2014/05/16 $"
	revision: "$Revision: #3 $"
	path: "$File: //rose/source/applications/system/data_connection_viewer/sql_server_sysprocess_gui.e $"

class SQL_SERVER_SYSPROCESS_GUI

feature	-- Interface.
	title_node: RP_GRID_TITLE_NODE[SQL_SERVER_SYSPROCESS]
	-- A title_node for an RP_DATA_GRID containing rows of data from SQL_SERVER_PROCESSES.
	local
		i: INTEGER
		l_label_item: RP_DATA_GRID_LABEL_ITEM
		l_font: EV_FONT
	do
		create Result.make(grid_titles)
		from
			i := 1
			l_label_item ?= Result.i_th(i)
			l_font := l_label_item.font
			l_font.set_weight((create {EV_FONT_CONSTANTS}).weight_regular)
		until
			i>Result.count
		loop
			l_label_item ?= Result.i_th(i)
			l_label_item.set_font(l_font)
			i := i + 1
		end
	end

feature {NONE}	-- Implementation.
	grid_titles: ARRAY[RP_DATA_GRID_LABEL_ITEM] is
	-- Used by 'title_node', above.
	local
		i: INTEGER
		l_item: RP_DATA_GRID_LABEL_ITEM
	do
		create Result.make(1, string_titles.count)
		from
			i := 1
		until
			i>Result.count
		loop
			create l_item.make_with_text(string_titles.item(i))
			if should_right_justify.item(i)
			then
				l_item.align_text_right
			end

			Result.put(l_item, i)
			i := i + 1
		end
	end

	string_titles: ARRAY[STRING] is
	-- Used by 'grid_titles', above.
	once
		Result :=
			<<
			"Server",
			"dbid",
			"hostname",
			"loginame",
			"program_name",
			"cpu",
			"cmd",
			"spid",
			"blocked by",
			"waittime",
			"lastwaittype",
			"waitresource",
			"login_time",
			"last_batch",

			"kpid",
--			"waittype",
			"uid",
			"physical_io",
			"memusage",
			"ecid",
			"open_tran",
			"status",
--			"sid",
			"hostprocess",
			"nt_domain",
			"nt_username",
			"net_address",
			"net_library",
--			"context_info",
--			"sql_handle",
			"stmt_start",
			"stmt_end"
			>>
	end

	should_right_justify: ARRAY[BOOLEAN] is
	-- True if a column should be right justified.
	once
		Result :=
			<<
			False,			-- "Server",
			False,			-- "dbid",
			False,			-- "hostname",
			False,			-- "loginame",
			False,			-- "program_name",
			True,			-- "cpu",
			False,			-- "cmd",
			True,			-- "spid",
			True,			-- "blocked by",
			True,			-- "waittime",
			False,			-- "waitresource",
			False,			-- "lastwaittype",
			False,			-- "login_time",
			False,			-- "last_batch",

			True,			-- "kpid",
							-- "waittype",
			True,			-- "uid",
			True,			-- "physical_io",
			True,			-- "memusage",
			True,			-- "ecid",
			True,			-- "open_tran",
			False,			-- "status",
							-- "sid",
			True,			-- "hostprocess",
			False,			-- "nt_domain",
			False,			-- "nt_username",
			False,			-- "net_address",
			False,			-- "net_library",
							-- "context_info",
							-- "sql_handle",
			True,			-- "stmt_start",
			True			-- "stmt_end"
			>>
	end

end
