note

	description: "SQL table name scanners"
	author: "Karine Bezault"
	last_editor: "$Author: an $"
	date: "$Date: 2013/11/08 $"
	revision: "$Revision: #3 $"
	path: "$File: //rose/source/kernel/infrastructure/persistence/sql_table_name_scanner.e $"

class SQL_TABLE_NAME_SCANNER

inherit

	YY_COMPRESSED_SCANNER_SKELETON
		rename
			make as make_compressed_scanner_skeleton,
			reset as reset_compressed_scanner_skeleton
		end

	SQL_TABLE_NAME_TOKENS
		export {NONE} all end

	UT_CHARACTER_CODES
		export {NONE} all end

	KL_IMPORTED_INTEGER_ROUTINES
	KL_IMPORTED_STRING_ROUTINES
	KL_SHARED_PLATFORM

create

	make

feature -- Status report

	valid_start_condition (sc: INTEGER): BOOLEAN
			-- Is `sc' a valid start condition?
		do
			Result := (sc = INITIAL)
		end

feature {NONE} -- Implementation

	yy_build_tables
			-- Build scanner tables.
		do
			yy_nxt := yy_nxt_template
			yy_chk := yy_chk_template
			yy_base := yy_base_template
			yy_def := yy_def_template
			yy_ec := yy_ec_template
			yy_meta := yy_meta_template
			yy_accept := yy_accept_template
		end

	yy_execute_action (yy_act: INTEGER)
			-- Execute semantic action.
		do
if yy_act <= 23 then
if yy_act <= 12 then
if yy_act <= 6 then
if yy_act <= 3 then
if yy_act <= 2 then
if yy_act = 1 then
--|#line 42 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 42")
end
-- Ignore separators
else
--|#line 43 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 43")
end
-- Ignore separators
end
else
--|#line 48 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 48")
end
-- Ignore comments
end
else
if yy_act <= 5 then
if yy_act = 4 then
--|#line 49 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 49")
end
-- Ignore comments
else
--|#line 54 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 54")
end
last_token := T_EQUALS
end
else
--|#line 55 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 55")
end
last_token := T_COMPARISON
end
end
else
if yy_act <= 9 then
if yy_act <= 8 then
if yy_act = 7 then
--|#line 56 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 56")
end
last_token := T_COMPARISON
else
--|#line 57 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 57")
end
last_token := T_COMPARISON
end
else
--|#line 58 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 58")
end
last_token := T_COMPARISON
end
else
if yy_act <= 11 then
if yy_act = 10 then
--|#line 59 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 59")
end
last_token := T_COMPARISON
else
--|#line 60 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 60")
end
last_token := T_COMPARISON
end
else
--|#line 61 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 61")
end
last_token := T_STRING_CONCAT_OPERATOR
end
end
end
else
if yy_act <= 18 then
if yy_act <= 15 then
if yy_act <= 14 then
if yy_act = 13 then
--|#line 62 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 62")
end
last_token := Minus_code
else
--|#line 63 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 63")
end
last_token := Plus_code
end
else
--|#line 64 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 64")
end
last_token := Star_code
end
else
if yy_act <= 17 then
if yy_act = 16 then
--|#line 65 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 65")
end
last_token := Slash_code
else
--|#line 66 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 66")
end
last_token := Ampersand_code
end
else
--|#line 67 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 67")
end
last_token := Bar_code
end
end
else
if yy_act <= 21 then
if yy_act <= 20 then
if yy_act = 19 then
--|#line 68 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 68")
end
last_token := Tilde_code
else
--|#line 69 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 69")
end
last_token := Left_parenthesis_code
end
else
--|#line 70 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 70")
end
last_token := Right_parenthesis_code
end
else
if yy_act = 22 then
--|#line 71 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 71")
end
last_token := Comma_code
else
--|#line 72 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 72")
end
last_token := Dot_code
end
end
end
end
else
if yy_act <= 35 then
if yy_act <= 29 then
if yy_act <= 26 then
if yy_act <= 25 then
if yy_act = 24 then
--|#line 73 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 73")
end
last_token := Semicolon_code
else
--|#line 74 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 74")
end
last_token := Left_bracket_code
end
else
--|#line 75 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 75")
end
last_token := Right_bracket_code
end
else
if yy_act <= 28 then
if yy_act = 27 then
--|#line 76 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 76")
end
last_token := T_COLON
else
--|#line 77 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 77")
end
last_token := T_DOUBLE_COLON
end
else
--|#line 78 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 78")
end
last_token := T_PLACEHOLDER
end
end
else
if yy_act <= 32 then
if yy_act <= 31 then
if yy_act = 30 then
--|#line 82 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 82")
end

		process_identifier (text)
	
else
--|#line 86 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 86")
end

		last_token := T_IDENTIFIER
		last_string_value := text
	
end
else
--|#line 91 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 91")
end

		last_token := T_IDENTIFIER
		last_string_value := text_substring (2, text_count - 1)
	
end
else
if yy_act <= 34 then
if yy_act = 33 then
--|#line 96 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 96")
end

		last_token := T_IDENTIFIER
		last_string_value := text_substring (2, text_count - 1)
	
else
--|#line 101 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 101")
end

		last_token := T_IDENTIFIER
		last_string_value := text_substring (2, text_count - 15)
	
end
else
--|#line 106 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 106")
end

		last_token := T_IDENTIFIER
		last_string_value := text_substring (2, text_count - 15)
	
end
end
end
else
if yy_act <= 41 then
if yy_act <= 38 then
if yy_act <= 37 then
if yy_act = 36 then
--|#line 111 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 111")
end

		last_token := T_PARAMETER_LITERAL
	
else
--|#line 117 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 117")
end

		last_token := T_STRING
	
end
else
--|#line 121 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 121")
end

		last_token := T_NSTRING
	
end
else
if yy_act <= 40 then
if yy_act = 39 then
--|#line 127 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 127")
end

		last_token := T_INTNUM
	
else
--|#line 128 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 128")
end

		last_token := T_INTNUM
	
end
else
--|#line 129 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 129")
end

		last_token := T_INTNUM
	
end
end
else
if yy_act <= 44 then
if yy_act <= 43 then
if yy_act = 42 then
--|#line 133 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 133")
end

		last_token := T_APPROXNUM
	
else
--|#line 134 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 134")
end

		last_token := T_APPROXNUM
	
end
else
--|#line 135 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 135")
end

		last_token := T_APPROXNUM
	
end
else
if yy_act = 45 then
--|#line 142 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 142")
end
last_token := text_item (1).code
else
--|#line 0 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 0")
end
last_token := yyError_token
fatal_error ("scanner jammed")
end
end
end
end
end
		end

	yy_execute_eof_action (yy_sc: INTEGER)
			-- Execute EOF semantic action.
		do
			inspect yy_sc
when 0 then
--|#line 0 "sql_table_name_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'sql_table_name_scanner.l' at line 0")
end
terminate
			else
				terminate
			end
		end

feature {NONE} -- Table templates

	yy_nxt_template: SPECIAL [INTEGER]
			-- Template for `yy_nxt'
		once
			Result := yy_fixed_array (<<
			    0,    4,    5,    6,    5,    7,    8,    9,   10,   11,
			   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,
			   22,   23,   24,   25,   26,   26,   27,   28,   29,    8,
			   26,   26,   26,   26,   26,   26,   26,   26,   26,   30,
			   31,   32,   35,   32,   40,   42,   53,   43,   47,   48,
			   35,   32,   41,   32,   40,   44,   57,   53,   57,   59,
			   59,   58,   41,   98,   42,   35,   43,   60,   60,   53,
			   61,   97,   61,   35,   44,   62,   46,   99,   96,   65,
			   53,   99,   56,   95,   56,   67,   94,   67,   46,   69,
			   68,   99,   54,   36,   36,   93,   36,   36,   36,   36,

			   46,   46,   46,   66,   46,   51,   92,   51,   51,   51,
			   51,   91,   90,   70,   37,   89,   37,   37,   37,   37,
			   37,   37,   37,   54,   88,   87,   54,   54,   54,   54,
			   39,   39,   39,   39,   39,   39,   39,   39,   39,   52,
			   86,   52,   52,   52,   52,   52,   52,   52,   64,   64,
			   85,   64,   64,   64,   64,   84,   83,   82,   81,   80,
			   79,   78,   77,   76,   75,   74,   73,   72,   68,   68,
			   71,   52,   62,   62,   58,   58,   63,   50,   56,   37,
			   38,   99,   33,   55,   52,   50,   49,   45,   39,   38,
			   34,   33,   99,    3,   99,   99,   99,   99,   99,   99,

			   99,   99,   99,   99,   99,   99,   99,   99,   99,   99,
			   99,   99,   99,   99,   99,   99,   99,   99,   99,   99,
			   99,   99,   99,   99,   99,   99,   99,   99,   99,   99,
			   99,   99,   99,   99, yy_Dummy>>)
		end

	yy_chk_template: SPECIAL [INTEGER]
			-- Template for `yy_chk'
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    5,    8,    5,   17,   19,   28,   19,   22,   22,
			   35,   32,   17,   32,   40,   19,   41,   53,   41,   42,
			   59,   41,   40,   96,   43,    8,   43,   42,   59,   28,
			   44,   95,   44,   35,   43,   44,   46,   46,   94,   54,
			   53,   54,   56,   93,   56,   60,   92,   60,   46,   64,
			   60,   64,   54,  100,  100,   91,  100,  100,  100,  100,

			  102,  102,  102,   54,  102,  103,   90,  103,  103,  103,
			  103,   89,   88,   64,  101,   87,  101,  101,  101,  101,
			  101,  101,  101,  104,   86,   85,  104,  104,  104,  104,
			  105,  105,  105,  105,  105,  105,  105,  105,  105,  106,
			   84,  106,  106,  106,  106,  106,  106,  106,  107,  107,
			   83,  107,  107,  107,  107,   82,   81,   80,   79,   78,
			   77,   76,   75,   74,   73,   72,   71,   69,   68,   67,
			   65,   63,   62,   61,   58,   57,   52,   50,   39,   38,
			   37,   36,   33,   30,   27,   25,   24,   20,   16,   10,
			    7,    6,    3,   99,   99,   99,   99,   99,   99,   99,

			   99,   99,   99,   99,   99,   99,   99,   99,   99,   99,
			   99,   99,   99,   99,   99,   99,   99,   99,   99,   99,
			   99,   99,   99,   99,   99,   99,   99,   99,   99,   99,
			   99,   99,   99,   99, yy_Dummy>>)
		end

	yy_base_template: SPECIAL [INTEGER]
			-- Template for `yy_base'
		once
			Result := yy_fixed_array (<<
			    0,    0,    0,  192,  193,   39,  188,  169,   36,  193,
			  181,  193,  193,  193,  193,  193,  174,   27,  193,   30,
			  169,  193,   27,  193,  165,  168,    0,  176,   40,  193,
			  144,  193,   49,  179,  193,   44,  175,  172,  171,  175,
			   37,   44,   42,   49,   58,  193,   59,  193,  193,  193,
			  160,    0,  168,   51,   75,  193,   80,  158,  157,   43,
			   73,  156,  155,  163,   85,  161,  193,  152,  151,  158,
			  193,  128,  127,  132,  131,  125,  124,  129,  128,  154,
			  153,  121,  120,  114,  104,   91,   90,   79,   76,   81,
			   76,   62,   53,   73,   68,   43,   35,  193,  193,  193,

			   90,  113,   95,  101,  120,  129,  138,  145, yy_Dummy>>)
		end

	yy_def_template: SPECIAL [INTEGER]
			-- Template for `yy_def'
		once
			Result := yy_fixed_array (<<
			    0,   99,    1,   99,   99,   99,   99,   99,  100,   99,
			  101,   99,   99,   99,   99,   99,   99,   99,   99,   99,
			  102,   99,   99,   99,   99,   99,  103,  103,  104,   99,
			   99,   99,   99,   99,   99,  100,  100,  101,   99,  105,
			   99,   99,   99,   99,   99,   99,  102,   99,   99,   99,
			   99,  103,  106,  107,  104,   99,   99,   99,   99,   99,
			   99,   99,   99,   99,  107,   99,   99,   99,   99,   99,
			   99,   99,   99,   99,   99,   99,   99,   99,   99,   99,
			   99,   99,   99,   99,   99,   99,   99,   99,   99,   99,
			   99,   99,   99,   99,   99,   99,   99,   99,   99,    0,

			   99,   99,   99,   99,   99,   99,   99,   99, yy_Dummy>>)
		end

	yy_ec_template: SPECIAL [INTEGER]
			-- Template for `yy_ec'
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    2,
			    3,    1,    1,    2,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    4,    5,    1,    6,    1,    1,    7,    8,
			    9,   10,   11,   12,   13,   14,   15,   16,   17,   17,
			   17,   17,   17,   17,   17,   17,   17,   17,   18,   19,
			   20,   21,   22,   23,    6,   24,   24,   24,   24,   25,
			   24,   24,   24,   24,   24,   24,   24,   24,   26,   24,
			   24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
			   24,   27,    1,   28,    1,   29,    1,   24,   24,   30,

			   24,   25,   24,   24,   31,   32,   24,   33,   34,   24,
			   35,   36,   24,   24,   24,   24,   37,   24,   24,   38,
			   24,   24,   24,    1,   39,    1,   40,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1, yy_Dummy>>)
		end

	yy_meta_template: SPECIAL [INTEGER]
			-- Template for `yy_meta'
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    2,    1,    1,    3,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    4,    5,    1,
			    1,    1,    1,    1,    6,    6,    7,    1,    1,    8,
			    6,    6,    6,    6,    6,    6,    6,    6,    9,    1,
			    1, yy_Dummy>>)
		end

	yy_accept_template: SPECIAL [INTEGER]
			-- Template for `yy_accept'
		once
			Result := yy_fixed_array (<<
			    0,    0,    0,   47,   45,    1,    2,   45,   45,   17,
			   45,   20,   21,   15,   14,   22,   13,   23,   16,   39,
			   27,   24,    9,    5,    8,   29,   30,   30,   25,   26,
			   18,   19,    1,    2,    6,    0,   31,    0,   37,    3,
			   41,    0,    0,   39,    0,   28,   36,   10,    7,   11,
			   29,   30,    0,    0,    0,   12,    4,    0,   44,   40,
			    0,    0,   42,   38,    0,    0,   32,    0,   43,    0,
			   33,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,   34,   35,    0, yy_Dummy>>)
		end

feature {NONE} -- Constants

	yyJam_base: INTEGER = 193
			-- Position in `yy_nxt'/`yy_chk' tables
			-- where default jam table starts

	yyJam_state: INTEGER = 99
			-- State id corresponding to jam state

	yyTemplate_mark: INTEGER = 100
			-- Mark between normal states and templates

	yyNull_equiv_class: INTEGER = 1
			-- Equivalence code for NULL character

	yyReject_used: BOOLEAN = false
			-- Is `reject' called?

	yyVariable_trail_context: BOOLEAN = false
			-- Is there a regular expression with
			-- both leading and trailing parts having
			-- variable length?

	yyReject_or_variable_trail_context: BOOLEAN = false
			-- Is `reject' called or is there a
			-- regular expression with both leading
			-- and trailing parts having variable length?

	yyNb_rules: INTEGER = 46
			-- Number of rules

	yyEnd_of_buffer: INTEGER = 47
			-- End of buffer rule code

	yyLine_used: BOOLEAN = false
			-- Are line and column numbers used?

	yyPosition_used: BOOLEAN = false
			-- Is `position' used?

	INITIAL: INTEGER = 0
			-- Start condition codes

feature -- User-defined features



feature {NONE} -- Initialization

	make
			-- Create a new SQL scanner.
		do
			make_with_buffer (Empty_buffer)
			create eif_buffer.make (Init_buffer_size)
		end

feature -- Initialization

	reset
			-- Reset scanner before scanning next input.
		do
			reset_compressed_scanner_skeleton
			eif_buffer.wipe_out
			in_select_query := False
		end

feature -- Access

	eif_buffer: STRING
			-- Buffer for lexial tokens

	in_select_query: BOOLEAN
			-- Is the scanner processing a "select" query or subquery?
			
feature {NONE} -- Processing

	process_identifier (a_identifier: STRING)
			-- Process current identifier token.
			-- Check whether it's a reserved word.
		require
			a_identifier_not_void: a_identifier /= Void
		do
			reserved_words.search (a_identifier.as_upper)
			if reserved_words.found then
				last_token := reserved_words.found_item
				last_string_value := a_identifier
				if last_token = T_BEGIN then
					in_select_query := False
				end
			else
				last_token := T_IDENTIFIER
				last_string_value := a_identifier
			end
		end
		
	reserved_words: DS_HASH_TABLE [INTEGER, STRING]
			-- Reserved words
		once
			create Result.make (280)
			Result.put_last (T_ADA, "ADA")
			Result.put_last (T_ADD, "ADD")
			Result.put_last (T_ADMIN, "ADMIN")
			Result.put_last (T_AFTER, "AFTER")
			Result.put_last (T_AGGREGATE, "AGGREGATE")
			Result.put_last (T_ALL, "ALL")
			Result.put_last (T_ALTER, "ALTER")
			Result.put_last (T_AND, "AND")
			Result.put_last (T_AMMSC, "AVG")
			Result.put_last (T_AMMSC, "MIN")
			Result.put_last (T_AMMSC, "MAX")
			Result.put_last (T_AMMSC, "SUM")
			Result.put_last (T_AMMSC, "COUNT")
			Result.put_last (T_ANY, "ANY")
			Result.put_last (T_ARE, "ARE")
			Result.put_last (T_ARRAY, "ARRAY")
			Result.put_last (T_AS, "AS")
			Result.put_last (T_ASC, "ASC")
			Result.put_last (T_ASSEMBLY, "ASSEMBLY")
			Result.put_last (T_ATTACH, "ATTACH")
			Result.put_last (T_ATTRIBUTE, "ATTRIBUTE")
			Result.put_last (T_AUTHORIZATION, "AUTHORIZATION")
			Result.put_last (T_AUTOREGISTER, "AUTOREGISTER")
			Result.put_last (T_BACKUP, "BACKUP")
			Result.put_last (T_BEFORE, "BEFORE")
			Result.put_last (T_BEGIN_CALL, "BEGIN_CALL")
			Result.put_last (T_BEGIN_EQCALL, "BEGIN_EQCALL")
			Result.put_last (T_BEGIN_FN, "BEGIN_FN")
			Result.put_last (T_BEGIN_OJ, "BEGIN_OJ")
			Result.put_last (T_BEGIN_U, "BEGIN_U")
			Result.put_last (T_BEGIN, "BEGIN")
			Result.put_last (T_BEST, "BEST")
			Result.put_last (T_BETWEEN, "BETWEEN")
			Result.put_last (T_BINARY, "BINARY")
			Result.put_last (T_BY, "BY")
			Result.put_last (T_C, "C")
			Result.put_last (T_CALL, "CALL")
			Result.put_last (T_CALLED, "CALLED")
			Result.put_last (T_CASCADE, "CASCADE")
			Result.put_last (T_CASE, "CASE")
			Result.put_last (T_CAST, "CAST")
			Result.put_last (T_CHARACTER, "CHAR")
			Result.put_last (T_CHARACTER, "CHARACTER")
			Result.put_last (T_CHECK, "CHECK")
			Result.put_last (T_CHECKED, "CHECKED")
			Result.put_last (T_CHECKPOINT, "CHECKPOINT")
			Result.put_last (T_CLOSE, "CLOSE")
			Result.put_last (T_CLR, "CLR")
			Result.put_last (T_CLUSTERED, "CLUSTERED")
			Result.put_last (T_COALESCE, "COALESCE")
			Result.put_last (T_COBOL, "COBOL")
			Result.put_last (T_COLLATE, "COLLATE")
			Result.put_last (T_COLUMN, "COLUMN")
			Result.put_last (T_COMMIT, "COMMIT")
			Result.put_last (T_CONSTRAINT, "CONSTRAINT")
			Result.put_last (T_CONSTRUCTOR, "CONSTRUCTOR")
			Result.put_last (T_CONTAINS, "CONTAINS")
			Result.put_last (T_CONTIGUOUS, "CONTIGUOUS")
			Result.put_last (T_CONTINUE, "CONTINUE")
			Result.put_last (T_CONVERT, "CONVERT")
			Result.put_last (T_CORRESPONDING, "CORRESPONDING")
			Result.put_last (T_CREATE, "CREATE")
			Result.put_last (T_CROSS, "CROSS")
			Result.put_last (T_CUBE, "CUBE")
			Result.put_last (T_CURRENT, "CURRENT")
			Result.put_last (T_CURRENT_DATE, "CURRENT_DATE")
			Result.put_last (T_CURRENT_TIME, "CURRENT_TIME")
			Result.put_last (T_CURRENT_TIMESTAMP, "CURRENT_TIMESTAMP")
			Result.put_last (T_CURSOR, "CURSOR")
			Result.put_last (T_DATA, "DATA")
-- Grammar conflict. We use 'date' as an identifier, not as a type.
--			Result.put_last (T_DATE, "DATE")
			Result.put_last (T_DATETIME, "DATETIME")
			Result.put_last (T_DEALLOCATE, "DEALLOCATE")
			Result.put_last (T_DECIMAL, "DECIMAL")
			Result.put_last (T_DECLARE, "DECLARE")
			Result.put_last (T_DEFAULT, "DEFAULT")
			Result.put_last (T_DELETE, "DELETE")
			Result.put_last (T_DESC, "DESC")
			Result.put_last (T_DETERMINISTIC, "DETERMINISTIC")
			Result.put_last (T_DISCONNECT, "DISCONNECT")
			Result.put_last (T_DISTINCT, "DISTINCT")
			Result.put_last (T_DO, "DO")
			Result.put_last (T_DOUBLE, "DOUBLE")
			Result.put_last (T_DROP, "DROP")
			Result.put_last (T_DTD, "DTD")
			Result.put_last (T_DYNAMIC, "DYNAMIC")
			Result.put_last (T_ELSE, "ELSE")
			Result.put_last (T_ELSEIF, "ELSEIF")
			Result.put_last (T_ENCODING, "ENCODING")
			Result.put_last (T_END, "END")
			Result.put_last (T_ESCAPE, "ESCAPE")
			Result.put_last (T_EXCEPT, "EXCEPT")
			Result.put_last (T_EXCLUSIVE, "EXCLUSIVE")
			Result.put_last (T_EXEC, "EXEC")
			Result.put_last (T_EXECUTE, "EXECUTE")
			Result.put_last (T_EXISTS, "EXISTS")
			Result.put_last (T_EXIT, "EXIT")
			Result.put_last (T_EXTERNAL, "EXTERNAL")
			Result.put_last (T_EXTRACT, "EXTRACT")
			Result.put_last (T_FETCH, "FETCH")
			Result.put_last (T_FINAL, "FINAL")
			Result.put_last (T_FLOAT, "FLOAT")
			Result.put_last (T_FOR, "FOR")
			Result.put_last (T_FOREACH, "FOREACH")
			Result.put_last (T_FOREIGN, "FOREIGN")
			Result.put_last (T_FORTRAN, "FORTRAN")
			Result.put_last (T_FOUND, "FOUND")
			Result.put_last (T_FROM, "FROM")
			Result.put_last (T_FULL, "FULL")
			Result.put_last (T_FUNCTION, "FUNCTION")
			Result.put_last (T_GENERAL, "GENERAL")
			Result.put_last (T_GENERATED, "GENERATED")
			Result.put_last (T_GO, "GO")
			Result.put_last (T_GOTO, "GOTO")
			Result.put_last (T_GRANT, "GRANT")
			Result.put_last (T_GROUP, "GROUP")
			Result.put_last (T_GROUPING, "GROUPING")
			Result.put_last (T_HANDLER, "HANDLER")
			Result.put_last (T_HASH, "HASH")
			Result.put_last (T_HAVING, "HAVING")
			Result.put_last (T_IDENTIFIED, "IDENTIFIED")
			Result.put_last (T_IDENTITY, "IDENTITY")
			Result.put_last (T_IF, "IF")
			Result.put_last (T_IN, "IN")
			Result.put_last (T_INCREMENT, "INCREMENT")
			Result.put_last (T_INCREMENTAL, "INCREMENTAL")
			Result.put_last (T_INDEX, "INDEX")
			Result.put_last (T_INDICATOR, "INDICATOR")
			Result.put_last (T_INNER, "INNER")
			Result.put_last (T_INOUT, "INOUT")
			Result.put_last (T_INPUT, "INPUT")
			Result.put_last (T_INSERT, "INSERT")
			Result.put_last (T_INSTANCE, "INSTANCE")
			Result.put_last (T_INSTEAD, "INSTEAD")
			Result.put_last (T_INTEGER, "INT")
			Result.put_last (T_INTEGER, "INTEGER")
			Result.put_last (T_INTERNAL, "INTERNAL")
			Result.put_last (T_INTERSECT, "INTERSECT")
			Result.put_last (T_INTERVAL, "INTERVAL")
			Result.put_last (T_INTO, "INTO")
			Result.put_last (T_IS, "IS")
			Result.put_last (T_JAVA, "JAVA")
			Result.put_last (T_JOIN, "JOIN")
			Result.put_last (T_KEY, "KEY")
			Result.put_last (T_KEYSET, "KEYSET")
			Result.put_last (T_LANGUAGE, "LANGUAGE")
			Result.put_last (T_LEFT, "LEFT")
			Result.put_last (T_LIBRARY, "LIBRARY")
			Result.put_last (T_LIKE, "LIKE")
			Result.put_last (T_LOCATOR, "LOCATOR")
			Result.put_last (T_LOG, "LOG")
			Result.put_last (T_LONG, "LONG")
			Result.put_last (T_LOOP, "LOOP")
			Result.put_last (T_METHOD, "METHOD")
			Result.put_last (T_MODIFIES, "MODIFIES")
			Result.put_last (T_MODIFY, "MODIFY")
			Result.put_last (T_MODULE, "MODULE")
			Result.put_last (T_MUMPS, "MUMPS")
			Result.put_last (T_NAME, "NAME")
			Result.put_last (T_NATURAL, "NATURAL")
			Result.put_last (T_NCHAR, "NCHAR")
			Result.put_last (T_NEW, "NEW")
			Result.put_last (T_NO, "NO")
			Result.put_last (T_NOLOCK, "NOLOCK")
			Result.put_last (T_NONCLUSTERED, "NONCLUSTERED")
			Result.put_last (T_NONINCREMENTAL, "NONINCREMENTAL")
			Result.put_last (T_NOT, "NOT")
			Result.put_last (T_NULL, "NULL")
			Result.put_last (T_NULLIF, "NULLIF")
			Result.put_last (T_NUMERIC, "NUMERIC")
			Result.put_last (T_NVARCHAR, "NVARCHAR")
			Result.put_last (T_OBJECT_ID, "OBJECT_ID")
			Result.put_last (T_OF, "OF")
			Result.put_last (T_OFF, "OFF")
			Result.put_last (T_OLD, "OLD")
			Result.put_last (T_ON, "ON")
			Result.put_last (T_OPEN, "OPEN")
			Result.put_last (T_OPTION, "OPTION")
			Result.put_last (T_OR, "OR")
			Result.put_last (T_ORDER, "ORDER")
			Result.put_last (T_OUT, "OUT")
			Result.put_last (T_OUTER, "OUTER")
			Result.put_last (T_OUTPUT, "OUTPUT")
			Result.put_last (T_OVERRIDING, "OVERRIDING")
			Result.put_last (T_PARAMETER, "PARAMETER")
			Result.put_last (T_PASCAL, "PASCAL")
			Result.put_last (T_PASSWORD, "PASSWORD")
			Result.put_last (T_PERCENT, "PERCENT")
			Result.put_last (T_PERMISSION_SET, "PERMISSION_SET")
			Result.put_last (T_PERSISTENT, "PERSISTENT")
			Result.put_last (T_PLI, "PLI")
			Result.put_last (T_PRECISION, "PRECISION")
			Result.put_last (T_PREFETCH, "PREFETCH")
			Result.put_last (T_PRIMARY, "PRIMARY")
			Result.put_last (T_PRINT, "PRINT")
			Result.put_last (T_PRIVILEGES, "PRIVILEGES")
			Result.put_last (T_PROCEDURE, "PROCEDURE")
			Result.put_last (T_PUBLIC, "PUBLIC")
			Result.put_last (T_PURGE, "PURGE")
			Result.put_last (T_READS, "READS")
			Result.put_last (T_REAL, "REAL")
			Result.put_last (T_REF, "REF")
			Result.put_last (T_REFERENCES, "REFERENCES")
			Result.put_last (T_REFERENCING, "REFERENCING")
			Result.put_last (T_REMOTE, "REMOTE")
			Result.put_last (T_RENAME, "RENAME")
			Result.put_last (T_REPLACING, "REPLACING")
			Result.put_last (T_REPLICATION, "REPLICATION")
			Result.put_last (T_RESIGNAL, "RESIGNAL")
			Result.put_last (T_RESTRICT, "RESTRICT")
			Result.put_last (T_RESULT, "RESULT")
			Result.put_last (T_RETURN, "RETURN")
			Result.put_last (T_RETURNS, "RETURNS")
			Result.put_last (T_REVOKE, "REVOKE")
			Result.put_last (T_REXECUTE, "REXECUTE")
			Result.put_last (T_RIGHT, "RIGHT")
			Result.put_last (T_ROLE, "ROLE")
			Result.put_last (T_ROLLBACK, "ROLLBACK")
			Result.put_last (T_ROLLUP, "ROLLUP")
			Result.put_last (T_ROWLOCK, "ROWLOCK")
			Result.put_last (T_SAFE, "SAFE")
			Result.put_last (T_SCHEMA, "SCHEMA")
			Result.put_last (T_SELECT, "SELECT")
			Result.put_last (T_SELF, "SELF")
			Result.put_last (T_SET, "SET")
			Result.put_last (T_SHUTDOWN, "SHUTDOWN")
			Result.put_last (T_SMALLINT, "SMALLINT")
			Result.put_last (T_SNAPSHOT, "SNAPSHOT")
			Result.put_last (T_SOFT, "SOFT")
			Result.put_last (T_SOME, "SOME")
			Result.put_last (T_SOURCE, "SOURCE")
			Result.put_last (T_SPECIFIC, "SPECIFIC")
			Result.put_last (T_SQL, "SQL")
			Result.put_last (T_SQL_TSI, "SQL_TSI")
			Result.put_last (T_SQLCODE, "SQLCODE")
			Result.put_last (T_SQLERROR, "SQLERROR")
			Result.put_last (T_SQLEXCEPTION, "SQLEXCEPTION")
			Result.put_last (T_SQLSTATE, "SQLSTATE")
			Result.put_last (T_SQLWARNING, "SQLWARNING")
			Result.put_last (T_START, "START")
			Result.put_last (T_STATIC, "STATIC")
			Result.put_last (T_STYLE, "STYLE")
			Result.put_last (T_SYNC, "SYNC")
			Result.put_last (T_SYSTEM, "SYSTEM")
			Result.put_last (T_TABLE, "TABLE")
			Result.put_last (T_TEMPORARY, "TEMPORARY")
			Result.put_last (T_TEXT, "TEXT")
			Result.put_last (T_THEN, "THEN")
			Result.put_last (T_TIES, "TIES")
			Result.put_last (T_TIME, "TIME")
			Result.put_last (T_TIMESTAMP, "TIMESTAMP")
			Result.put_last (T_TIMESTAMP_FUNC, "TIMESTAMP_FUNC")
			Result.put_last (T_TO, "TO")
			Result.put_last (T_TOP, "TOP")
			Result.put_last (T_TRANSACTION, "TRANSACTION")
			Result.put_last (T_TRIGGER, "TRIGGER")
			Result.put_last (T_TRUNCATE, "TRUNCATE")
			Result.put_last (T_TYPE, "TYPE")
			Result.put_last (T_UNDER, "UNDER")
			Result.put_last (T_UNION, "UNION")
			Result.put_last (T_UNIQUE, "UNIQUE")
			Result.put_last (T_UNRESTRICTED, "UNRESTRICTED")
			Result.put_last (T_UPDATE, "UPDATE")
			Result.put_last (T_USE, "USE")
			Result.put_last (T_USER, "USER")
			Result.put_last (T_USING, "USING")
			Result.put_last (T_VALUE, "VALUE")
			Result.put_last (T_VALUES, "VALUES")
			Result.put_last (T_VARBINARY, "VARBINARY")
			Result.put_last (T_VARCHAR, "VARCHAR")
			Result.put_last (T_VARIABLE, "VARIABLE")
			Result.put_last (T_VIEW, "VIEW")
			Result.put_last (T_WHEN, "WHEN")
			Result.put_last (T_WHENEVER, "WHENEVER")
			Result.put_last (T_WHERE, "WHERE")
			Result.put_last (T_WHILE, "WHILE")
			Result.put_last (T_WITH, "WITH")
			Result.put_last (T_WORK, "WORK")
			Result.put_last (T_XML, "XML")
			Result.put_last (T_XPATH, "XPATH")
		ensure
			reserved_words_not_void: Result /= Void
		end
		
feature {NONE} -- Constants

	Init_buffer_size: INTEGER = 256
				-- Initial size for `eif_buffer'
				
	Ampersand_code: INTEGER
			-- ASCII code for '&'
		once
			Result := ('&').code
		end

invariant

	eif_buffer_not_void: eif_buffer /= Void

end
