note

	description: "SQL OLEDB constants.  Mostly properties, but some others."
	author: "pn"
	last_editor: "$Author: er $"
	date: "$Date: 2014/04/28 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/infrastructure/persistence/windows/classic/sqloledb_property_constants.e $"

class
	SQLOLEDB_PROPERTY_CONSTANTS

feature -- The constants.

	E_CLSID_SQLOLEDB: ECOM_GUID
	-- Eiffel version of CLSID_SQLOLEDB.
	once
		create Result.make_from_pointer(CLSID_SQLOLEDB)
	end

	CLSID_SQLOLEDB: POINTER
			-- The class id for "Microsoft OLE DB Provider for SQL Server" (SQLOLEDB.DLL).
		external
			"C [macro <sqloledb.h>]"
		alias
			"&CLSID_SQLOLEDB"
		end

	CLSID_SQLOLEDB_ERROR: POINTER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"&CLSID_SQLOLEDB_ERROR"
		end

	CLSID_SQLOLEDB_ENUMERATOR: POINTER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"&CLSID_SQLOLEDB_ENUMERATOR"
		end

	E_SQLNCLI_CLSID_PROVIDER: STRING = "'SQL Server Native Client 11.0' (SQLNCLI11.DLL)"
		-- Provider name associated with E_SQLNCLI_CLSID.  If you change one, change the other as well.

	E_SQLNCLI_CLSID: ECOM_GUID
	-- Eiffel version of SQLNCLI_CLSID.  We don't actually have SQLNCLI_CLSID available.  This is because we would have
	-- to include both sqlncli.h and sqloledb.h.  These are required to be included in the order sqloledb.h THEN sqlncli.h.
	-- There is no way to guarantee that ordering with Eiffel.  If you change this class id, be sure to change E_SQLNCLI_CLSID_PROVIDER.
	once
		create Result.make_from_string("{397C2819-8272-4532-AD3A-FB5E43BEAA39}")
	end

--	SQLNCLI_CLSID: POINTER
--	-- The class id for the SQL Native Client.
--	external
--		"C [macro <sqlncli.h>]"								-- DO NOT INCLUDE sqlncli.h.  See E_SQLNCLI_CLSID.
--	alias
--		"&SQLNCLI_CLSID"									-- Currently defined to be CLSID_SQLNCLI11.
--	end

	SSPROP_INIT_MARSCONNECTION: INTEGER = 16				-- Multiple Active Row Sets.  DO NOT INCLUDE sqlncli.h.  See E_SQLNCLI_CLSID.
--	SSPROP_INIT_MARSCONNECTION: INTEGER
--	external
--		"C [macro <sqlncli.h>]"								-- DO NOT INCLUDE sqlncli.h.  See E_SQLNCLI_CLSID.
--	alias
--		"SSPROP_INIT_MARSCONNECTION"
--	end

--	CLSID_ADsDSOObject: POINTER is
--		external
--			"C [macro <ADSIid.h>]"
--		alias
--			"&CLSID_SQLOLEDB"
--		end

	IID_ISQLServerErrorInfo: POINTER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"&IID_ISQLServerErrorInfo"
		end

	IID_IRowsetFastLoad: POINTER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"&IID_IRowsetFastLoad"
		end

--	SSCOLUMN_HIDDEN: POINTER is
--		external
--			"C [macro <sqloledb.h>]"
--		alias
--			"&SSCOLUMN_HIDDEN"
--		end

--	SSCOLUMN_KEY: POINTER is
--		external
--			"C [macro <sqloledb.h>]"
--		alias
--			"&SSCOLUMN_KEY"
--		end

	DBSCHEMA_LINKEDSERVERS: POINTER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"&DBSCHEMA_LINKEDSERVERS"
		end

	CRESTRICTIONS_DBSCHEMA_LINKEDSERVERS: INTEGER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"CRESTRICTIONS_DBSCHEMA_LINKEDSERVERS"
		end

	DBPROPSET_SQLSERVERDBINIT: POINTER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"&DBPROPSET_SQLSERVERDBINIT"
		end

	DBPROPSET_SQLSERVERROWSET: POINTER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"&DBPROPSET_SQLSERVERROWSET"
		end

	DBPROPSET_SQLSERVERDATASOURCE: POINTER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"&DBPROPSET_SQLSERVERDATASOURCE"
		end

	DBPROPSET_SQLSERVERSESSION: POINTER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"&DBPROPSET_SQLSERVERSESSION"
		end

--	SSPROP_AUTH_TRUSTEDCONNECTION: INTEGER is
--		external
--			"C [macro <sqloledb.h>]"
--		alias
--			"SSPROP_AUTH_TRUSTEDCONNECTION"
--		end

	SSPROP_INIT_CURRENTLANGUAGE: INTEGER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"SSPROP_INIT_CURRENTLANGUAGE"
		end

	SSPROP_INIT_NETWORKADDRESS: INTEGER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"SSPROP_INIT_NETWORKADDRESS"
		end

	SSPROP_INIT_NETWORKLIBRARY: INTEGER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"SSPROP_INIT_NETWORKLIBRARY"
		end

	SSPROP_INIT_USEPROCFORPREP: INTEGER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"SSPROP_INIT_USEPROCFORPREP"
		end

	SSPROP_INIT_AUTOTRANSLATE: INTEGER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"SSPROP_INIT_AUTOTRANSLATE"
		end

	SSPROP_INIT_PACKETSIZE: INTEGER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"SSPROP_INIT_PACKETSIZE"
		end

	SSPROP_INIT_APPNAME: INTEGER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"SSPROP_INIT_APPNAME"
		end

	SSPROP_INIT_WSID: INTEGER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"SSPROP_INIT_WSID"
		end

	SSPROPVAL_USEPROCFORPREP_OFF: INTEGER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"SSPROPVAL_USEPROCFORPREP_OFF"
		end

	SSPROPVAL_USEPROCFORPREP_ON: INTEGER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"SSPROPVAL_USEPROCFORPREP_ON"
		end

	SSPROPVAL_USEPROCFORPREP_ON_DROP: INTEGER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"SSPROPVAL_USEPROCFORPREP_ON_DROP"
		end


	SSPROP_ENABLEFASTLOAD: INTEGER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"SSPROP_ENABLEFASTLOAD"
		end

	SSPROP_QUOTEDCATALOGNAMES: INTEGER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"SSPROP_QUOTEDCATALOGNAMES"
		end

--	SSPROP_CONCURRENCY: INTEGER is
--		external
--			"C [macro <sqloledb.h>]"
--		alias
--			"SSPROP_CONCURRENCY"
--		end

--	SSPROP_POSITIONONNEWROW: INTEGER is
--		external
--			"C [macro <sqloledb.h>]"
--		alias
--			"SSPROP_POSITIONONNEWROW"
--		end

--	SSPROP_HIDDENCOLUMNS: INTEGER is
--		external
--			"C [macro <sqloledb.h>]"
--		alias
--			"SSPROP_HIDDENCOLUMNS"
--		end

--	SSPROP_NOBROWSETABLE: INTEGER is
--		external
--			"C [macro <sqloledb.h>]"
--		alias
--			"SSPROP_NOBROWSETABLE"
--		end

--	SSPROP_TEXTPTRLOGGING: INTEGER is
--		external
--			"C [macro <sqloledb.h>]"
--		alias
--			"SSPROP_TEXTPTRLOGGING"
--		end

	SSPROP_MAXBLOBLENGTH: INTEGER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"SSPROP_MAXBLOBLENGTH"
		end

	SSPROP_FASTLOADOPTIONS: INTEGER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"SSPROP_FASTLOADOPTIONS"
		end

	SSPROP_FASTLOADKEEPNULLS: INTEGER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"SSPROP_FASTLOADKEEPNULLS"
		end

	SSPROP_FASTLOADKEEPIDENTITY: INTEGER is
		external
			"C [macro <sqloledb.h>]"
		alias
			"SSPROP_FASTLOADKEEPIDENTITY"
		end

--	SSPROPVAL_CONCUR_ROWVER: INTEGER is
--		external
--			"C [macro <sqloledb.h>]"
--		alias
--			"SSPROPVAL_CONCUR_ROWVER"
--		end

--	SSPROPVAL_CONCUR_VALUES: INTEGER is
--		external
--			"C [macro <sqloledb.h>]"
--		alias
--			"SSPROPVAL_CONCUR_VALUES"
--		end

--	SSPROPVAL_CONCUR_LOCK: INTEGER is
--		external
--			"C [macro <sqloledb.h>]"
--		alias
--			"SSPROPVAL_CONCUR_LOCK"
--		end

--	SSPROPVAL_CONCUR_READ_ONLY: INTEGER is
--		external
--			"C [macro <sqloledb.h>]"
--		alias
--			"SSPROPVAL_CONCUR_READ_ONLY"
--		end

end
