note

	description:

		"Constant expression with a string value"

	author: "Pierre Nallet"
	last_editor: "$Author: it $"
	date: "$Date: 2014/03/14 $"
	revision: "$Revision: #5 $"
	path: "$File: //rose/source/kernel/math/string_constant_expression.e $"

class
	STRING_CONSTANT_EXPRESSION [reference G]
inherit
	CONSTANT_EXPRESSION [G]
		redefine
			string_value
		end

creation

	make_string

feature {NONE} -- Initialization

	make_string (a_string : STRING) is
			-- Initialize with a new string value.
		do
			set_expression_index
			type := String_type
			string_constant_value := a_string
			name := a_string
			create variable_description
			variable_description.set_name(name)
			variable_description.set_mnemonic(name)
			variable_description.set_type ("string")
		end

feature -- Access


	string_constant_value : STRING
		-- Actual string value

	string_value (a_entity : G) : STRING is
			-- String value
		do
			Result := string_constant_value
		end
feature -- Basic operations

	set_string (a_string : STRING) is
			-- Set the string value.
		do
			type := String_type
			string_constant_value := a_string
		end


end
