indexing
	description: "Supplier data signature"
	author: "Srilatha Singh"
	date: "$Date: 2009/08/13 $"
	revision: "$Revision: #27 $"
    path: "$File: //rose/source/kernel/supplier_data/reference/supplier_data_signature.e $"

deferred class
   	SUPPLIER_DATA_SIGNATURE [reference G -> ENTITY]

inherit
   	ROSE_SIGNATURE_RECORD [G]
		redefine
			set_date,
			output_for_verification
		end
	ROSE_ID_USER
		undefine
			is_equal
		end

feature -- Initialization

    make, make_with_unspecified_start_date (a_entity_id: INTEGER; a_end_date: ROSE_DATE;
    	a_periodicity: INTEGER; a_currency_id: INTEGER; a_value_description_id: INTEGER) is
			-- Use make when you know the values for all six arguments
		do
			entity_id:= a_entity_id
			period_end_date:= a_end_date
			periodicity_id:= a_periodicity
			currency_id:= a_currency_id
			value_description_id:= a_value_description_id
			end_current_date := default_next_data_date
		end

    fields_: STRING is
    		--signature fields
		once
			Result:= "entity_id,period_end_date,periodicity_id,currency_id,value_description_id"
		end

	entity_id: INTEGER
			-- Entity
	period_end_date: ROSE_DATE
			-- Not required anymore

	periodicity_id: INTEGER
			-- Periodicity id
	currency_id: INTEGER
			-- Currency id
	value_description_id: INTEGER  -------- (previously called adjustment_id)

	default_next_data_date: ROSE_DATE is
			--99991231
		once
			create Result.make_ccyymmdd (99991231)
		end

feature -- Access
	output_for_verification : STRING
			--empty string
		do
			Result := ""
		end
	set_entity_id (a_id: INTEGER) is
			-- Set entity id.
		do
			entity_id:= a_id
		end

	set_date, set_period_end_date (a_date: ROSE_DATE) is
			-- Set period end date.
		do
			period_end_date := a_date
		end

	set_currency_id (a_id: INTEGER) is
			-- Set currency id.
		do
			currency_id := a_id
		end

	set_periodicity_id (a_id: INTEGER) is
			-- Set periodicity id.
		do
			periodicity_id := a_id
		end

	set_value_description_id (a_id: INTEGER) is
			-- Set value restriction identifier.
		do
			value_description_id := a_id
		end

	restriction_statement: STRING is
			-- Void restriction statement
		do
		end

end
