indexing

   description: "Supplier entity base."
   status: "Development"
   author: "David Stevens"
   date: "$Date: 2008/12/01 $"
   revision: "$Revision: #21 $"

deferred class

   SUPPLIER_ENTITY_BASE

inherit

   SUPPLIER_ENTITY_ID_ROW
  --/
    undefine
	 is_equal
      end
  --/-

   MISSING_PARAMETERS
      undefine
	 is_equal
      end

   ERROR_LOG_USE
      undefine
	 is_equal
      end

   DATABASE_SERVER
      undefine
	 is_equal
      end

   SUPPLIER_ATTRIBUTE_TYPE_MANAGER_USE
      undefine
	 is_equal
      end

   SUPPLIER_RELATIONSHIP_TYPE_MANAGER_USE
      undefine
	 is_equal
      end
	ANY
		undefine
			is_equal
		end

feature -- Comparison

   is_equal (other: like Current): BOOLEAN is
      deferred
      end

feature {SUPPLIER_ENTITY} -- Element change

   set_category_id (a_category_id: INTEGER) is
   	--set category id
      do
	 category_id := a_category_id
      end

   set_entity_id (a_entity_id: INTEGER) is
      do
	 entity_id := a_entity_id
      end

feature {ENTITY_SERVER} -- Implementation

   server : ENTITY_SERVER[SUPPLIER_ENTITY] is
      deferred
      end

   -- Select
   select_statement: STRING is
      deferred
      end

   select_predicate: COLLECTING_PREDICATE [like Current] is
      do
		 Result := server.select_predicate
      end

   make_select_predicate: COLLECTING_PREDICATE [like Current] is
      do
	 create Result.make (data_server, select_statement)
	 if not Result.success then
	    error_log.set_severity (error_log.Fatal)
	    error_log.set_message ("ERROR: Could not make predicate")
	    error_log.set_class_name ("SUPPLIER_ENTITY_BASE")
	    error_log.set_feature_name ("make_select_predicate")
	    error_log.put
      	 end
      end

   -- Insert
   insert_statement: STRING is
      deferred
      end

   insert_predicate: EXECUTION_PREDICATE is
	  do
		 Result := server.insert_predicate
      end

   make_insert_predicate: EXECUTION_PREDICATE is
      do
	 create Result.make (data_server, insert_statement)
	 if not Result.success then
	    error_log.set_severity (error_log.Fatal)
	    error_log.set_message ("ERROR: Could not make predicate")
	    error_log.set_class_name ("SUPPLIER_ENTITY_BASE")
	    error_log.set_feature_name ("make_insert_predicate")
	    error_log.put
	 end
      end

   -- Update
   update_statement: STRING is
      deferred
      end

   update_predicate: EXECUTION_PREDICATE is
      do
		 Result := server.update_predicate
	  end

   make_update_predicate: EXECUTION_PREDICATE is
      do
	 create Result.make (data_server, update_statement)
	 if not Result.success then
	    error_log.set_severity (error_log.Fatal)
	    error_log.set_message ("ERROR: Could not make predicate")
	    error_log.set_class_name ("SUPPLIER_ENTITY_BASE")
	    error_log.set_feature_name ("make_update_predicate")
	    error_log.put
	 end
      end

feature {SUPPLIER_ENTITY_ATTRIBUTE, SUPPLIER_ENTITY_CACHE}  --Data server
   data_server : DATA_SERVER is
      deferred
      end

end -- class SUPPLIER_ENTITY_BASE
