indexing
	description: ""
	author: "Michael Zhang"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #3 $"
	archive: "$File: //rose/source/kernel/supplier_data/supplier_process_history.e $"

class
	SUPPLIER_PROCESS_HISTORY

inherit
	ROSE_LINEAR_ARRAY[SUPPLIER_PROCESS]

create
	make, make_empty, make_from_array, make_from_linear
	
feature
	history_by_process_name : ROSE_KEYED_PARTITION[like item, STRING] is
		do
			create Result.make(Current, Agent process_key)
		end

	file_dates : ROSE_HASHED_LINEAR_ARRAY[ROSE_DATE] is
		local
			l_process : like item
		do
			create Result.make_empty
			from start until off loop
				l_process := current_item
				if Result.new_index_of(l_process.file_date) = 0 then
					Result.extend(l_process.file_date)
				end
				forth
			end
			Result.sort_by(Agent date_order)
		end

feature
	process_key(a_process : like item) : STRING is
		do
			Result := a_process.name	
		end
	
	date_order(a_date1, a_date2 : ROSE_DATE) : BOOLEAN is
		do
			Result := (a_date1 /= Void and a_date2 /= Void) and then (a_date1 < a_date2)	
		end
end 
