note

	description:

		"Test The Watcher"

	author: "RJ"
	last_editor: "$Author: c4 $"
	date: "$Date: 2014/07/16 $"
	revision: "$Revision: #9 $"
	path: "$File: //rose/source/applications/system/data_connection_viewer/test_rcmd_data_connection_viewer.e $"

class
	TEST_RCMD_DATA_CONNECTION_VIEWER

inherit
	RCMD_DATA_CONNECTION_VIEWER
		rename
			default_create as rdcv_default_create
		end

	TS_TEST_CASE
		rename
			execute as ttc_execute,
			logger as tester_logger,
			set_logger as set_tester_logger
		select
			default_create
		end

create
	make_default

feature -- Testing

	test_the_watcher
	-- Test RCMD_DATA_CONNECTION_VIEWER (The Watcher).
	do
		testing := True				-- Tells RCMD_DATA_CONNECTION_VIEWER to be a little less gui than normal.  Prevents dialogs.
		rdcv_default_create			-- Use the default values that would normally be read from the config file.
		initialize_window

		-- This tests the Status' tab and the grid along the left side.
		-- We can't test the blockers (or blockees) since there may not be any.
		refresh
		assert("data_server_status_grid.count>0", data_server_status_grid.row_count>0)
		assert("other_server_status_grid.count>0", other_server_status_grid.row_count>0)
		assert("port_served_apps_grid.count>0", port_served_apps_grid.row_count>0)

		-- Test the 'Performance Charts' tab.
		notebook.select_item(perf_vbox)
		check_one_perf_graph(data_server_status_grid)
		check_one_perf_graph(port_served_apps_grid)
		check_one_perf_graph(other_server_status_grid)
		assert("One perf graph was tested", perf_graph_tested)

		-- Test the 'Performance Summary' tab.
		refresh_perf_summary
		assert("perf_summary_grid.row_count>0", perf_summary_grid.row_count>0)

		-- Test the 'Sysprocesses' tab.
		refresh_sysprocesses
		assert("sysprocesses_grid.row_count>0", sysprocesses_grid.row_count>0)

		-- Test the 'Open Transactions' tab.
		show_open_transactions
		assert("oldest_transactions_grid.row_count>0", open_transactions_grid.row_count>0)

		-- Test the 'Disk Usage' tab.
		show_disk_usage
		assert("disk_usage_grid.row_count>0", disk_usage_grid.row_count>0)
	end

	check_one_perf_graph(a_grid: RP_DATA_GRID[ANY])
	-- Loops through all available machines until it finds one that has perf information.
	-- Not all do.  Once one is found, subsequent calls do nothing.
	require
		grid_not_void: a_grid/=Void
	local
		i: INTEGER
	do
		from
			i := 1
		until
			perf_graph_tested or i>a_grid.row_count
		loop
			a_grid.select_row(i)
			show_perf_graphs
			if perf_charts.plot_count>0
			then
				perf_graph_tested := True
			else
				i := i + 1
			end

			a_grid.remove_selection
		end
	end

	perf_graph_tested: BOOLEAN				-- Gets set when the first perf graph has been tested.

end
