indexing
	description: "Columnwise linearize upper triangular of a square matrix"
	author: "MK, MZ"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #3 $"

class
	TRIANGULAR_LINEARIZATION

feature	
	frozen linear_mapping(i, j  : INTEGER) : INTEGER is
		do
			Result := (j * (j - 1)) // 2 + i
		end
		
	frozen inverse_mapping(n : INTEGER) : PAIR[INTEGER, INTEGER] is
		local
			i, j : INTEGER
		do
			j := (0.5 + math.sqrt(0.25 + 2 * n)).ceiling - 1
			i := n - (j * (j -1)) // 2
			create Result.make(i, j)
		end
		
	frozen linear_count(a_size : INTEGER) : INTEGER is
		require
			a_size > 1
		do
			Result := (a_size * (a_size + 1)) // 2
		end		
	--
	-- xp version is excluding diagnal elements
	--
	frozen xp_linear_mapping(i, j  : INTEGER) : INTEGER is
		require
			j > i and i > 0
		do
			Result := ((j - 1) * (j - 2)) // 2 + i
		end
		
	frozen xp_inverse_mapping(n : INTEGER) : PAIR[INTEGER, INTEGER] is
		local
			i, j : INTEGER
		do
			j := (1.5 + math.sqrt(2.25 + 2 * (n - 1))).ceiling - 1
			i := n - ((j - 1) * (j -2)) // 2
			create Result.make(i, j)
		end		

	frozen xp_count(a_size : INTEGER) : INTEGER is
		require
			a_size > 1
		do
			Result := (a_size * (a_size - 1)) // 2
		end
		
	math : DOUBLE_MATH is once create Result end
end 
