note

	description:

		"UID manipulation"

	author: "Mark Howard"
	last_editor: "$Author: mk $"
	date: "$Date: 2012/02/18 $"
	revision: "$Revision: #2 $"
	path: "$File: //rose/source/kernel/entities/reference/uid_aware.e $"

class
	UID_AWARE

feature  --Access
	id_handlers : attached TUPLE_KEYED_HASH_TABLE[ID_HANDLER,TUPLE[supplier_id,category_id : INTEGER]]
			--Global cache of id handlers by supplier_id
		once
			create Result.make(10)
		end
	id_handler_from_id (a_supplier_id,a_category_id : INTEGER) : attached ID_HANDLER
			--id handler for this supplier id
		do
			Result := id_handlers[[a_supplier_id,a_category_id]]
			if Result = Void then
				create Result.make(a_supplier_id,a_category_id)
				id_handlers[[a_supplier_id,a_category_id]] := Result
			end
		ensure
			non_void : Result /= Void
		end
	constructed_uid(a_supplier_id,a_category_id,a_handle : INTEGER) : INTEGER_64
			--construct uid
		do
			Result := a_supplier_id.to_integer_64 |<< 48 + a_category_id.to_integer_64 |<< 32 + a_handle
		end
	uid_handle(a_uid : INTEGER_64) : INTEGER is
			--handle from uid
		do
			Result := a_uid.bit_and (0xFFFFFFFF).to_integer_32
		end
	uid_category_id (a_uid : INTEGER_64) : INTEGER
			--category_id from uid
		do
			Result := (a_uid |>> 32).bit_and(0xFFFF).to_integer_32
		end
	uid_supplier_id (a_uid : INTEGER_64) : INTEGER
			--supplier_id from uid
		do
			Result := (a_uid |>> 48).bit_and(0xFFFFFFFF).to_integer_32
		end
end
