note

	description:

		"A unique integer retrieved from a database."

	status: "Development"
	author: "David Stevens"
	last_editor: "$Author: mb $"
	date: "$Date: 2011/03/21 $"
	revision: "$Revision: #8 $"
	path: "$File: //rose/source/kernel/infrastructure/persistence/unique_integer_retriever.e $"

class UNIQUE_INTEGER_RETRIEVER

create

	make

feature {NONE} -- Initialization

	make (a_server: DATA_SERVER) is
			-- Initialization.
		require
			a_server_not_void: a_server /= Void
		do
			server := a_server
		end

feature -- Access

	item (a_sql_statement: STRING): INTEGER is
			-- A unique integer retrieved according `a_sql_statement'.
		require
			a_sql_statement_not_void: a_sql_statement /= Void
		local
			l_integer_selector: INTEGER_PREDICATE
		do
			create l_integer_selector.make (server, a_sql_statement)
			if not l_integer_selector.success then
				print ("Error making UNIQUE_INTEGER_RETRIEVER selection predicate: " + a_sql_statement)
				exceptions.die (1)
			end
			l_integer_selector.retrieve (Void, Void)
			if l_integer_selector.success and then l_integer_selector.array.count = 1 then
				Result := l_integer_selector.array.item (1)
			else
				print ("Error in UNIQUE_INTEGER_RETRIEVER selection: " + a_sql_statement)
				exceptions.die (1)
			end
		end

feature {NONE} -- Implementation

	server: DATA_SERVER

	exceptions: EXCEPTIONS is
			-- Access to Exceptions
		once
			create Result
		ensure
			valid_result: Result /= Void
		end

end
