note

	description:

		"Unitized version of a price record"

	author: "Mark Howard"
	last_editor: "$Author: mk $"
	date: "$Date: 2013/06/04 $"
	revision: "$Revision: #1 $"
	path: "$File: //rose/source/kernel/data/market/unitized_price_record.e $"

class
	UNITIZED_PRICE_RECORD
inherit
	ROSE_UNITS_ENVIRONMENT
create
	make
feature --Creation
	make(a_record : RMDAT_PRICE_RECORD)
			--Creation
		local
			l_units : ROSE_UNITS
		do
			record := a_record
			if record.currency /= Void then
				l_units := currency_units(record.currency)
			else
				do_nothing
				l_units := pure_units
--				l_units := record.listing. (record.date)
			end
			create open.make_with_units(record.open,l_units)
			create close.make_with_units(record.close,l_units)
			create high.make_with_units(record.high,l_units)
			create low.make_with_units(record.low,l_units)
			create bid.make_with_units(record.bid,l_units)
			create ask.make_with_units(record.ask,l_units)
		end
feature --Access
	record : RMDAT_PRICE_RECORD
	open : ROSE_UNITIZED_VALUE[DOUBLE]
	close : ROSE_UNITIZED_VALUE[DOUBLE]
	high : ROSE_UNITIZED_VALUE[DOUBLE]
	low : ROSE_UNITIZED_VALUE[DOUBLE]
	bid : ROSE_UNITIZED_VALUE[DOUBLE]
	ask : ROSE_UNITIZED_VALUE[DOUBLE]

end
