indexing
	description: "Facilities for comparing snapshots"
	author: "Mark Howard"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #4 $"

class
	VALIDATION
create
	make
feature
	make (a_class : ANY;a_title : STRING;a_snapshot : ROSE_SNAPSHOT[DOUBLE]) is
		require
			class_not_void : a_class /= void
		do
			title := a_title
			snapshot := a_snapshot
			class_name := a_class.generator
		end
	class_name : STRING
	title : STRING
	snapshot : ROSE_SNAPSHOT[DOUBLE]
	passed : ROSE_LINEAR_ARRAY[STRING]
	failed : ROSE_LINEAR_ARRAY[STRING]
	compare (a_other : like Current) : BOOLEAN is
		local
			l_key : STRING 
		do
			create passed.make_empty
			create failed.make_empty
			Result := true
			from snapshot.start until snapshot.off loop
				l_key := snapshot.key_for_iteration
--				if (snapshot.current_value - a_other.snapshot.value_at(l_key)).abs < snapshot.current_tolerance then
				if snapshot.compare_current(a_other.snapshot) then
					passed.extend(l_key)
				else
					failed.extend(l_key)
					Result := false
				end
				snapshot.forth
			end
		end
	display : STRING is
		do
			Result := title 
			Result := Result + "Failed : %N"
			from failed.start until failed.off loop
				Result := Result + "%T" + failed.current_item + "%N"
				failed.forth
			end
			Result := Result + "Passed : %N"
			from passed.start until passed.off loop
				Result := Result + "%T" + passed.current_item + "%N"
				passed.forth
			end
		end
end -- class VALIDATION
