indexing
	description: "Contains information about a change that has%
		%taken place in a date and time picker control."
	author: "David Jenkins"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #2 $"

class
	WEL_NM_DATE_TIME_CHANGE

inherit
	WEL_STRUCTURE

create
	make,
	make_by_nmhdr,
	make_by_pointer

feature {NONE} -- Initialization

	make_by_nmhdr (a_nmhdr: WEL_NMHDR) is
			-- Make the structure with `a_nmhdr'.
		require
			a_nmhdr_not_void: a_nmhdr /= Void
		do
			make_by_pointer (a_nmhdr.item)
		end

feature -- Access

	hdr: WEL_NMHDR is
			-- Information about the Wm_notify message
		do
			create Result.make_by_pointer(c_nm_datetimechange_get_hdr(item))
		ensure
			result_not_void: Result /= Void
		end

	flags:INTEGER is
			-- Indicates whether control was set to "no date"
			-- status and whether system_time is valid
		do
			Result := c_nm_datetimechange_flags(item)
		end

	system_time: MC_SYSTEM_TIME is
			-- Current system date and time
		do
			create Result.make_by_pointer(c_nm_datetimechange_st(item))
		ensure
			result_not_void: Result /= Void
		end

feature -- Measurement

	structure_size:INTEGER is
			-- Size to allocate (in bytes)
		once
			Result := c_size_of_nm_datetimechange
		end

feature {NONE} -- Implementation

	c_size_of_nm_datetimechange:INTEGER is
		external
			"C[macro %"nmdtchng.h%"]"
		alias
			"sizeof(NMDATETIMECHANGE)"
		end

	c_nm_datetimechange_get_hdr(handle:POINTER):POINTER is
		external
			"C[macro %"nmdtchng.h%"](NMDATETIMECHANGE*):EIF_POINTER"
		end

	c_nm_datetimechange_flags(handle:POINTER):INTEGER is
		external
			"C [struct %"wel.h%"] (NMDATETIMECHANGE): DWORD"
		alias
			"dwFlags"
		end

	c_nm_datetimechange_st(handle:POINTER):POINTER is
		external
			"C [macro %"nmdtchng.h%"](NMDATETIMECHANGE*):LPSYSTEMTIME"
		end

end -- class WEL_NM_DATE_TIME_CHANGE

--|-------------------------------------------------------------|
--|Created by David Jenkins										|
--|																|
--|It's not my fault if it works								|
--|-------------------------------------------------------------|
