indexing
	description: "An array of 2 SYSTEMTIME structs occupying%
		%contiguous storage"
	author: "David Jenkins"
	date: "$Date: 2008/12/01 $"
	revision: "$Revision: #2 $"

class
	WEL_SYSTEM_TIME_PAIR

inherit
	WEL_STRUCTURE
		export
			{NONE} set_item
		redefine
			make
		end

create
	make,
	make_by_pointer
feature {NONE} -- Initialization

	make is
			-- Allocate storage for 2 SYSTEMTIME structs
		local 
			syst: MC_SYSTEM_TIME
		do
			item := c_calloc(2,structure_size)
			if item = default_pointer then
				c_enomem
			end
			shared := False
			create syst.make_by_pointer(item)
			low_system_time := syst
			create syst.make_by_pointer(item + structure_size)
			high_system_time := syst
		end;

feature -- Access

	low_system_time: MC_SYSTEM_TIME
			-- The first SYSTEMTIME struct

	high_system_time: MC_SYSTEM_TIME
			-- The second SYSTEMTIME struct

feature -- Measurement

	structure_size: INTEGER is
			-- Size of each SYSTEMTIME struct in the pair
		once
			Result := c_size_of_system_time
		end

feature -- Element change

feature {NONE} -- Externals

	c_size_of_system_time: INTEGER is
		external
			"C [macro %"wel_time.h%"]"
		alias
			"sizeof(SYSTEMTIME)"
		end

invariant
	low_syst_exists: low_system_time.exists
	high_syst_exists: high_system_time.exists

end -- class WEL_SYSTEM_TIME_PAIR

--|-------------------------------------------------------------|
--|Created by David Jenkins										|
--|																|
--|It's not my fault if it works								|
--|-------------------------------------------------------------|

