indexing
	description: "Windows process"
	author: "Mauricio Bustos"
	last_editor: "$Author: rj $"
	date: "$Date: 2013/09/18 $"
	revision: "$Revision: #8 $"
	path: "$File: //rose/source/kernel/infrastructure/windows/winbase_services.e $"

class
	WINBASE_SERVICES

feature -- Externals.

	openprocess(dwDesiredAccess : INTEGER; bInheritHandle : BOOLEAN; dwProcessId : INTEGER) : INTEGER is
		external
			"C [macro <windows.h>] (DWORD,BOOL,DWORD) : HANDLE"
		alias
			"OpenProcess"
		end

	terminateprocess(hProcess, uExitCode : INTEGER) : BOOLEAN is
		external
			"C [macro <windows.h>] (HANDLE, UINT) : BOOLEAN"
		alias
			"TerminateProcess"
		end

	closehandle(handle : INTEGER) : BOOLEAN is
		external
			"C [macro <windows.h>] (HANDLE) : BOOL"
		alias
			"CloseHandle"
		end

	getprocesstimes(hprocess : INTEGER; lpCreationTime, lpExitTime, lpKernelTime, lpUserTime : POINTER) : BOOLEAN is
		external
			"C [macro <windows.h>] (HANDLE,LPFILETIME,LPFILETIME,LPFILETIME,LPFILETIME) : BOOL"
		alias
			"GetProcessTimes"
		end

	getcurrentprocess() : INTEGER is
		external
			"C [macro <windows.h>] () : EIF_INTEGER"
		alias
			"GetCurrentProcess()"
		end

	getcurrentprocessid() : INTEGER is
		external
			"C [macro <windows.h>] () : EIF_INTEGER"
		alias
			"GetCurrentProcessId()"
		end

-- Must have Win2003 or WinXP-SP1 or higher.  Not on Win2000!
--	getprocessid(process : INTEGER) : INTEGER is
--		external
--			"C [macro <windows.h>] (HANDLE) : EIF_INTEGER"
--		alias
--			"GetProcessId"
--		end

	getlasterror() : INTEGER is
		obsolete "use {ROSE_EXECUTION_ENVIRONMENT}.last_system_call_status"
		external
			"C [macro <windows.h>] () : EIF_INTEGER"
		alias
			"GetLastError()"
		end

	getprocessmemoryinfo(process : INTEGER; ppsmemCounters : POINTER; cb : INTEGER) : BOOLEAN is
		external
			"C [macro <psapi.h>] (HANDLE,PPROCESS_MEMORY_COUNTERS,DWORD) : BOOL"
		alias
			"GetProcessMemoryInfo"
		end

	getexitcodeprocess(a_process_id: INTEGER; a_exit_code_ptr: POINTER): BOOLEAN is
	-- Returns STILL_ACTIVE if the process is not dead.
	external
		"C [macro <windows.h>] (HANDLE, LPDWORD) : BOOL"
	alias
		"GetExitCodeProcess"
	end

feature -- Constants

	PROCESS_ALL_ACCESS : INTEGER is
	-- See MSDN documentation "Process Security and Access Rights".
	external
		"C [macro <windows.h>] "
	alias
		"PROCESS_ALL_ACCESS"
	end

	PROCESS_QUERY_INFORMATION: INTEGER
	-- See MSDN documentation "Process Security and Access Rights".
	external
		"C [macro <windows.h>] "
	alias
		"PROCESS_QUERY_INFORMATION"
	end

	PROCESS_TERMINATE: INTEGER
	-- See MSDN documentation "Process Security and Access Rights".
	external
		"C [macro <windows.h>] "
	alias
		"PROCESS_TERMINATE"
	end

	PROCESS_VM_READ: INTEGER
	-- See MSDN documentation "Process Security and Access Rights".
	external
		"C [macro <windows.h>] "
	alias
		"PROCESS_VM_READ"
	end

	STILL_ACTIVE: INTEGER is
	-- See 'getexitcodeprocess'.
	external
		"C [macro <winbase.h>]"
	alias
		"STILL_ACTIVE"
	end

end


