indexing

	description: "[
			Parent to class producing a widget;
			that can be placed within another window,
			or opened in its own window.
		]"

	author: "Franck Arnaud"
	last_editor: "$Author: it $"
	revision: "$Revision: #2 $"
	date: "$Date: 2008/12/01 $"
	archive: "$File: //rose/source/kernel/infrastructure/widgets/with_widget.e $"

deferred class WITH_WIDGET

inherit
	ANY

	ROSE_SHARED_GLOBAL_GUI
		export
			{NONE} all
		end

feature -- Access

	widget: EV_WIDGET
			-- Top-level widget

feature -- Access

	window_title: STRING is
			-- Title for window if opened separately using `open_in_window'
		deferred
		ensure
			not_void: Result /= Void
		end

	window_icon_name: STRING is
			-- Name of icon used for window if opened separately `open_in_window'
		deferred
		end

	window_height: INTEGER is
			-- Default size for `open_in_window'
		do
			Result := 500
		end

	window_width: INTEGER is
			-- Default size for `open_in_window'
		do
			Result := 700
		end

feature -- Basic operation(s)

	open_in_window is
			-- Open widget in a separate window.
		local
			l_window: EV_TITLED_WINDOW
		do
			l_window := Gui.factory.new_window (window_title, window_icon_name, window_width, window_height)
			--l_window.set_size (Gui.screen.width.min (window_width), Gui.screen.height.min (window_height))
			setup_window (l_window)
			l_window.extend (widget)
			l_window.set_title (window_title)
			Gui.open_window (window_id, l_window)
		end

feature {NONE} -- Implementation

	setup_window (a_window: EV_TITLED_WINDOW) is
			-- Add menu to window created by `open_in_window'.
		require
			a_window_not_void: a_window /= Void
		do
			Gui.factory.add_menu (a_window, True, Void)
		end

	window_id: STRING is
			-- Configuration id for `open_in_window'
		do
			Result := window_title
		end

invariant
	widget_not_void: widget /= Void

end
