note

	description:

		"Cross section matrix"

	author: "Michael Zhang"
	last_editor: "$Author: er $"
	date: "$Date: 2013/06/18 $"
	revision: "$Revision: #6 $"
	path: "$File: //rose/source/kernel/math/xsection_matrix.e $"
	storable_version: ""

class
	XSECTION_MATRIX[G->HASHABLE]

inherit
	HASHED_MATRIX[G, STRING]
		redefine
			sub_matrix
		end
create
	make_all, make,
	make_from_matrix
create {XSECTION_MATRIX}
	make_identity,
	make_as_inverse
feature --Access
	sub_matrix (r: ARRAY[INTEGER]; j0, j1: INTEGER): XSECTION_MATRIX[G] is
			-- Submatrix composed of columns within [j0, j1] and rows in `r'
		local
			i, j: INTEGER
		do
			create Result.make (r.count, j1 - j0 + 1)
			from i := 1 until i > r.count loop
				from j := j0 until j > j1 loop
					if valid_row_index (r.item(i)) then
						Result [i, j - j0 + 1] := Current [r [i], j]
					end
					j := j + 1
				end
				i := i + 1
			end
		end

end
