indexing
	description: "The Watcher"
	author: "RJ"
	last_editor: "$Author: rj $"
	date: "$Date: 2014/05/16 $"
	revision: "$Revision: #55 $"
	path: "$File: //rose/source/applications/system/data_connection_viewer/rcmd_data_connection_viewer.e $"

class
	RCMD_DATA_CONNECTION_VIEWER

inherit
	RCMD_WINDOW
		redefine
			window,
			default_create
		end
	SOCKET_RESOURCES
		rename
			error as sr_error
		redefine
			default_create
		end
	DATABASE_SERVER
		redefine
			default_create
		end
	SQL_SERVER_SYSPROCESS_GUI
		rename
			title_node as child_title_node,
			grid_titles as child_grid_titles,
			string_titles as child_string_titles,
			should_right_justify as should_right_justify_child
		export
			{NONE} all
		redefine
			default_create
		end
	PORTABLE_MEMORY
		redefine
			default_create
		end
	EXCEL_INTERFACE
		redefine
			default_create
		end
	IEEE_MATH
		export
			{NONE} all
		redefine
			default_create
		end
	WINDOWS_SYSTEM_CODES
		export
			{NONE} all
		redefine
			default_create
		end

create
	default_create

feature -- Access

	signature: STRING is ""						-- Crap from RCMD_WINDOW.

	id: STRING is "data_connection_viewer"		-- Crap from RCMD_WINDOW.

	help: STRING is ""							-- Crap from RCMD_WINDOW.

	is_unique: BOOLEAN is True					-- Crap from RCMD_WINDOW.

feature -- Basic operations

	check_prerequisites is						-- Crap from RCMD_WINDOW.
	do
	end

feature {NONE} -- Implementation
	default_create is
	-- Read configuation values.
	do
		{INET_PROPERTIES}.set_ipv4_stack_preferred(True)		-- Turn off IPv6 (causes 'set_non_blocking' to do nothing; probably other problems).
		default_partner_timeout := config.integer("default_partner_timeout", 2)
		partner_timeout := default_partner_timeout
		default_ps_time_interval := config.integer("default_ps_time_interval", 7)
		timeout_for_kill := config.integer("timeout_for_kill", 60)
		default_timer_interval := config.integer("refresh_interval", 900)
		default_repository_name := servers.repository_server.database
	end

	do_execute is
	-- Crap from RCMD_WINDOW.
	do
		show
		init_after_show
		refresh
	end

	initialize_window is
	-- This is the first starting point of this class.  The second is 'refresh'.
	local
		l_vbox: EV_VERTICAL_BOX
		l_vbox1: EV_VERTICAL_BOX
		l_hbox1: EV_HORIZONTAL_BOX
		l_hbox11: EV_HORIZONTAL_BOX
		l_hbox12: EV_HORIZONTAL_BOX
		l_hbox13: EV_HORIZONTAL_BOX
		l_status_bar: EV_STATUS_BAR
		l_ps_status_bar: EV_STATUS_BAR
		l_timer_edit: EV_TEXT_FIELD
		l_timeout_label: EV_LABEL
		l_last_update_time_text_frame: EV_FRAME
		l_timeout_label_frame: EV_FRAME
		l_chart_label: EV_LABEL
		l_chart_info_button: EV_BUTTON
--		l_dc_count_button: EV_BUTTON
		l_rescan_button: EV_BUTTON
		l_chart_frame: EV_FRAME
		l_show_processes_label: EV_LABEL
		l_f5_key: EV_KEY
		l_f5_accelerator: EV_ACCELERATOR
		l_data_server_status_frame: EV_FRAME
		l_other_server_status_frame: EV_FRAME
		l_port_server_status_grid_frame: EV_FRAME
		l_count_objects_button: EV_BUTTON
		l_ps_time_label: EV_LABEL
		l_ps_time_edit: EV_TEXT_FIELD
		l_ps_cpu_label: EV_LABEL
		l_ps_cpu_edit: EV_TEXT_FIELD
		l_ps_memory_label: EV_LABEL
		l_ps_memory_edit: EV_TEXT_FIELD
		l_excel_button: EV_TOOL_BAR_BUTTON
		l_excel_toolbar: EV_TOOL_BAR
	do
		gui.set_idle_auto_close_timeout(1440 * 4)	-- 4 days.

		-- Stuff that I will need later.
		create l_vbox
		create l_vbox1
		create splitter1
		create splitter11
		create splitter111
		create splitter12
		create splitter121
		create l_hbox1
		create l_hbox11
		create l_hbox12
		create l_hbox13

		-- F5 accelerator.
		create l_f5_key.make_with_code(Gui.rep.keys.Key_f5)
		create l_f5_accelerator.make_with_key_combination(l_f5_key, False, False, False)
		l_f5_accelerator.actions.extend(agent refresh)

		-- The window.
		create window
		window.accelerators.extend(l_f5_accelerator)
		Gui.Factory.decorate_window(window, "The Watcher", "eye19.ico", 800, 600)

		-- Open_transactions.
		create open_transactions_grid.make(
			<<
			"Server",
			"dbid",
			"SPID",
			"Start Time",
			"Type",
			"State",
			"Log record count",
			"Replicate record count",
			"Log bytes used",
			"Log bytes reserved",
			"Log bytes used system",
			"Log bytes reserved system"
			>>,
			Void)
		set_grid_font_weight(open_transactions_grid)

		right_align_grid_columns(open_transactions_grid, <<3, 7, 8, 9, 10, 11, 12>>, False)

		open_transactions_grid.column(1).set_width(110)
		open_transactions_grid.column(2).set_width(150)
		open_transactions_grid.column(3).set_width(50)
		open_transactions_grid.column(4).set_width(135)
		open_transactions_grid.column(5).set_width(50)
		open_transactions_grid.column(6).set_width(80)
		open_transactions_grid.column(7).set_width(110)
		open_transactions_grid.column(8).set_width(130)
		open_transactions_grid.column(9).set_width(105)
		open_transactions_grid.column(10).set_width(115)
		open_transactions_grid.column(11).set_width(115)
		open_transactions_grid.column(12).set_width(150)

		open_transactions_grid.enable_tree(True)
		open_transactions_grid.enable_single_row_selection
		open_transactions_grid.enable_selection_on_single_button_click
		open_transactions_grid.set_are_raised_titles_enabled_on_header_node(True)
		open_transactions_grid.set_are_raised_titles_enabled(True)
		open_transactions_grid.set_are_columns_resizable_on_dividers_enabled(True)
		open_transactions_grid.set_are_sticky_parents_enabled(True)
		open_transactions_grid.enable_multiple_row_selection
		open_transactions_grid.enable_column_separators
		open_transactions_grid.enable_row_separators
		open_transactions_grid.set_separator_color(separator_color)

		-- Disk usage.
		create disk_usage_grid.make(
			<<
			"Server",
			"Disk",
			"Free Space (GB)",
			"Notes"
			>>,
			Void)
		set_grid_font_weight(disk_usage_grid)

		right_align_grid_columns(disk_usage_grid, <<3>>, False)

		disk_usage_grid.column(1).set_width(250)
		disk_usage_grid.column(2).set_width(100)
		disk_usage_grid.column(3).set_width(120)

		disk_usage_grid.enable_tree(True)
		disk_usage_grid.enable_single_row_selection
		disk_usage_grid.enable_selection_on_single_button_click
		disk_usage_grid.set_are_raised_titles_enabled_on_header_node(True)
		disk_usage_grid.set_are_raised_titles_enabled(True)
		disk_usage_grid.set_are_columns_resizable_on_dividers_enabled(True)
		disk_usage_grid.pre_draw_overlay_actions.extend(agent pre_grid_draw)
		disk_usage_grid.set_are_sticky_parents_enabled(True)
		disk_usage_grid.enable_multiple_row_selection
		disk_usage_grid.enable_column_separators
		disk_usage_grid.enable_row_separators
		disk_usage_grid.set_separator_color(separator_color)

		-- Port_served_apps.
		-- The next line has a mate in SERVER_STATUS_MESSAGE and SERVER_REQUEST:string_array.
		create port_served_apps_grid.make(
			<<
			"machine",
			"server_executable",
			"user_id",
			"client",
			"arguments",
			"command",
			"server_pid",
			"client_pid",
			"port",
			"log_file",
			"timestamp",
			"terminated_by",
			"terminated_at",
--			"creation time",
			"workingset (MB)",
			"pagefile (MB)",
			"user time",
			"kernel time"
			>>,
			Void)

--		port_served_apps_grid.pointer_enter_item_actions.extend(agent show_tooltip_agent)
		port_served_apps_grid.column(1).set_width(110)
		port_served_apps_grid.column(3).set_width(60)
		port_served_apps_grid.column(7).set_width(60)
		port_served_apps_grid.column(9).set_width(60)
		port_served_apps_grid.column(11).set_width(110)
		port_served_apps_grid.column(14).set_width(110)
		port_served_apps_grid.column(15).set_width(110)
--		port_served_apps_grid.column(17).set_width(60)
--		port_served_apps_grid.column(18).set_width(60)
--		port_served_apps_grid.column(25).set_width(60)
--		port_served_apps_grid.column(26).set_width(60)

		right_align_grid_columns(port_served_apps_grid, <<7, 8, 9, 14, 15, 16, 17>>, False)

		port_served_apps_grid.pre_draw_overlay_actions.extend(agent pre_grid_draw)
		port_served_apps_grid.post_draw_overlay_actions.extend(agent post_grid_draw)
		port_served_apps_grid.set_are_lock_icons_displayed_on_header_node(True)
--		port_served_apps_grid.column(1).lock
--		port_served_apps_grid.column(2).lock
--		port_served_apps_grid.column(3).lock
--		port_served_apps_grid.column(4).lock
--		port_served_apps_grid.column(5).lock

		set_grid_font_weight(port_served_apps_grid)

		port_served_apps_grid.enable_single_row_selection
		port_served_apps_grid.enable_selection_on_single_button_click
		port_served_apps_grid.enable_tree(True)
		port_served_apps_grid.enable_column_separators
		port_served_apps_grid.enable_row_separators
		port_served_apps_grid.set_separator_color(separator_color)
		port_served_apps_grid.set_are_raised_titles_enabled_on_header_node(True)
		port_served_apps_grid.set_are_raised_titles_enabled(True)
		port_served_apps_grid.set_are_columns_resizable_on_dividers_enabled(True)
		port_served_apps_grid.set_are_sticky_parents_enabled(True)

		create port_served_apps_frame.make_with_text("Port served applications")
		port_served_apps_frame.set_foreground_color(nearly_black)
		port_served_apps_frame.extend(port_served_apps_grid)
		port_served_apps_frame.pointer_button_press_actions.extend(agent show_server_request_server_menu)

		-- Blockers.
		create blockers_frame.make_with_text("Blockers")
		blockers_grid := new_sysprocesses_grid
		blockers_frame.extend(blockers_grid)
		blockers_grid.row_select_actions.extend(agent show_blocker_detail)
		blockers_frame.set_foreground_color(blocker_color)

		-- Blockees.
		create blockees_frame.make_with_text("Blockees")
		blockees_grid := new_sysprocesses_grid
		blockees_frame.extend(blockees_grid)
		blockees_frame.hide
		blockees_frame.set_foreground_color(blockee_color)

		-- Port server status.
		create port_server_status_grid.make(<<"Server", "Status", "Port">>, Void)
		right_align_grid_columns(port_server_status_grid, <<3>>, True)
		port_server_status_grid.column(2).set_width(40)
		port_server_status_grid.column(3).set_width(40)
		port_server_status_grid.enable_multiple_row_selection
		port_server_status_grid.enable_column_separators
		port_server_status_grid.enable_row_separators
		port_server_status_grid.set_separator_color(separator_color)
		port_server_status_grid.row_select_actions.extend(agent may_show_perf_graphs_dummy2)
		port_server_status_grid.row_deselect_actions.extend(agent may_show_perf_graphs_dummy2)
		port_server_status_grid.set_are_raised_titles_enabled_on_header_node(True)
		port_server_status_grid.set_are_raised_titles_enabled(True)
		port_server_status_grid.set_are_columns_resizable_on_dividers_enabled(True)
		port_server_status_grid.enable_selection_on_single_button_click
		port_server_status_grid.grid.pre_draw_overlay_actions.extend(agent set_focused_color_agent)
		port_server_status_grid.grid.post_draw_overlay_actions.extend(agent reset_focused_color_agent)

		set_grid_font_weight(port_server_status_grid)

		-- Data server status.
		create l_data_server_status_frame.make_with_text("Data Servers")
		l_data_server_status_frame.set_foreground_color(nearly_black)
		l_data_server_status_frame.extend(data_server_status_grid)
		splitter111.extend(l_data_server_status_frame)
		create l_port_server_status_grid_frame.make_with_text("Port Servers")
		l_port_server_status_grid_frame.set_foreground_color(nearly_black)
		l_port_server_status_grid_frame.extend(port_server_status_grid)
		l_port_server_status_grid_frame.pointer_button_press_actions.extend(agent show_server_request_server_menu)
		splitter111.extend(l_port_server_status_grid_frame)
--		splitter111.set_split_position(1000)
		splitter11.extend(splitter111)

		-- Other server status.
		create l_other_server_status_frame.make_with_text("Other Servers")
		l_other_server_status_frame.set_foreground_color(nearly_black)
		l_other_server_status_frame.extend(other_server_status_grid)
		splitter11.extend(l_other_server_status_frame)
		splitter121.extend(port_served_apps_frame)
		splitter121.extend(blockers_frame)
		splitter12.extend(splitter121)
		splitter12.extend(blockees_frame)

		-- Timeout label (automatic update interval).
		create l_timeout_label.make_with_text(" Update interval (secs)  ")
		create l_timeout_label_frame
		l_timeout_label_frame.extend(l_timeout_label)
		l_timeout_label_frame.set_style({EV_FRAME_CONSTANTS}.Ev_frame_lowered)

		-- Timer and timer_edit (for automatic updates).
		create l_timer_edit.make_with_text(default_timer_interval.out)
		create timer.make_with_interval(default_timer_interval * 1000)
--		l_timer_edit.set_right_justify
		l_timer_edit.return_actions.extend(agent change_timer(l_timer_edit))

		-- Refresh button (for manual updates).
		create refresh_button.make_with_text("Update")
		refresh_button.select_actions.extend(agent refresh)

		-- Last update time (shows when we last updated the screen).
		create last_update_time_text
		create l_last_update_time_text_frame
		l_last_update_time_text_frame.extend(last_update_time_text)
		l_last_update_time_text_frame.set_style({EV_FRAME_CONSTANTS}.Ev_frame_lowered)

		-- Chart length (text and combo).
		create l_chart_label.make_with_text("Only show data for the last ")
		create chart_length_combo
		chart_length_combo.disable_edit
		chart_length_combo.extend(chart_length_3h)
		chart_length_combo.extend(chart_length_24h)
		chart_length_24h.enable_select
		chart_length_combo.extend(chart_length_7d)
		chart_length_combo.extend(chart_length_30d)
		chart_length_combo.set_minimum_width(10 * 8)
		chart_length_combo.select_actions.extend(agent may_show_perf_graphs)

		-- Show all server requests button.
		create show_all_server_requests.make_with_text("Show dead port served apps")
		show_all_server_requests.select_actions.extend(agent refresh)

		-- The "Log blockers" button.
		create log_blockers.make_with_text("Log blockers")
		log_blockers.select_actions.extend(agent ask_for_blocker_log_file)

		-- Action text (shows what's happening right now so we can see which part is slow).
		create action_text

		-- Count objects button (for debugging) (only available to certain users).
		create l_count_objects_button.make_with_text("Count objects")
		l_count_objects_button.select_actions.extend(agent count_objects)

		-- Excel button.
		create l_excel_button
		l_excel_button.set_pixmap(gui.factory.new_pixmap_from_file("excel_small.ico"))
		l_excel_button.set_tooltip("Export to Excel")
		l_excel_button.select_actions.extend(agent export_to_excel)
		create l_excel_toolbar
		l_excel_toolbar.extend(l_excel_button)

		-- DC count button.
--		create l_dc_count_button.make_with_text("DC Count")
--		l_dc_count_button.select_actions.extend(agent show_dc_count)

		-- Status bar.
		create l_status_bar
		l_status_bar.disable_homogeneous
		l_status_bar.extend(l_last_update_time_text_frame)
		l_status_bar.disable_item_expand(l_last_update_time_text_frame)
		l_status_bar.extend(refresh_button)
		l_status_bar.disable_item_expand(refresh_button)
		l_status_bar.extend(l_timeout_label_frame)
		l_status_bar.disable_item_expand(l_timeout_label_frame)
		l_status_bar.extend(l_timer_edit)
		l_status_bar.disable_item_expand(l_timer_edit)
		l_status_bar.extend(show_all_server_requests)
		l_status_bar.disable_item_expand(show_all_server_requests)
		l_status_bar.extend(log_blockers)
		l_status_bar.disable_item_expand(log_blockers)
		if equal(global.user.user.login_id, "RJ") or
		   equal(global.user.user.login_id, "JQ") or
		   global.env.get("COUNT_OBJECTS_BUTTON")/=Void
		then
			l_status_bar.extend(l_count_objects_button)
			l_status_bar.disable_item_expand(l_count_objects_button)
		end

		l_status_bar.extend(l_excel_toolbar)
		l_status_bar.disable_item_expand(l_excel_toolbar)
		l_status_bar.extend(action_text)
		l_status_bar.disable_item_expand(action_text)
--		l_status_bar.extend(l_dc_count_button)
--		l_status_bar.disable_item_expand(l_dc_count_button)

		-- Show processes button.
		create show_processes_button.make_with_text("Show processes")
		show_processes_button.select_actions.extend(agent show_processes_pressed)

		-- Chart info button.
		create l_chart_info_button.make_with_text("How?")
		l_chart_info_button.select_actions.extend(agent show_explanation)

		-- Rescan button.
		create l_rescan_button.make_with_text("Rescan")
		l_rescan_button.select_actions.extend(agent rescan)

		-- Show processes (label and button).
		create l_show_processes_label.make_with_text("      ")
		create show_processes_button.make_with_text("Show processes")

		-- Populate all of the h boxes.
		l_hbox11.extend(l_chart_label)
		l_hbox11.disable_item_expand(l_chart_label)
		l_hbox11.extend(chart_length_combo)
		l_hbox11.disable_item_expand(chart_length_combo)
		l_hbox12.extend(l_show_processes_label)
		l_hbox12.disable_item_expand(l_show_processes_label)
		l_hbox12.extend(show_processes_button)
		l_hbox12.disable_item_expand(show_processes_button)
		l_hbox13.extend(l_chart_info_button)
		l_hbox13.disable_item_expand(l_chart_info_button)

		l_hbox1.extend(l_hbox11)
		l_hbox1.disable_item_expand(l_hbox11)
		l_hbox1.extend(l_hbox12)
		l_hbox1.enable_item_expand(l_hbox12)	-- Yes, I really want to expand!
		l_hbox1.extend(l_hbox13)
		l_hbox1.disable_item_expand(l_hbox13)

		-- Perf charts
		create l_chart_frame
		create perf_charts.make(l_chart_frame)	-- Also extends l_chart_frame.
		perf_charts.display.palette.set_color(1, processor_color)
		perf_charts.display.palette.set_color(2, memory_color)
		perf_charts.set_processor_yellow_alert_level(processor_yellow_alert_level)
		perf_charts.set_processor_red_alert_level(processor_red_alert_level)
		perf_charts.set_memory_yellow_alert_level(memory_yellow_alert_level)
		perf_charts.set_memory_red_alert_level(memory_red_alert_level)
		create perf_vbox
		perf_vbox.extend(l_chart_frame)
		perf_vbox.extend(l_hbox1)
		perf_vbox.disable_item_expand(l_hbox1)

		-- Performance summary grid.
		create perf_summary_grid.make(
			<<"Server", "Exceeded CPU%NCount", "Exceeded CPU%NAverage (%%)", "Exceeded CPU%NMinutes", "Exceeded memory%NCount", "Exceeded memory%NAverage (MB)", "Exceeded memory%NMinutes">>, Void)
		right_align_grid_columns(perf_summary_grid, <<2, 3, 4, 5, 6, 7>>, True)

		-- Set the height of the header to the height of a string that is two char's high.
		check attached {RP_DATA_GRID_LABEL_ITEM} perf_summary_grid.header_node.i_th(1) as al_label_item
		then
			perf_summary_grid.header_node.set_height(al_label_item.font.string_size("A%NA").integer_item(2) + 5)
		end

		perf_summary_grid.column(2).set_width(120)
		perf_summary_grid.column(3).set_width(120)
		perf_summary_grid.column(4).set_width(120)
		perf_summary_grid.column(5).set_width(120)
		perf_summary_grid.column(6).set_width(120)
		perf_summary_grid.column(7).set_width(120)
		perf_summary_grid.enable_multiple_row_selection
		perf_summary_grid.enable_column_separators
		perf_summary_grid.enable_row_separators
		perf_summary_grid.set_separator_color(separator_color)
		perf_summary_grid.set_are_raised_titles_enabled_on_header_node(True)
		perf_summary_grid.set_are_raised_titles_enabled(True)
		perf_summary_grid.set_are_columns_resizable_on_dividers_enabled(True)
		perf_summary_grid.enable_selection_on_single_button_click

		-- Perf summary labels and controls.
		create l_ps_status_bar
		l_ps_status_bar.disable_homogeneous

		create l_ps_time_label.make_with_text(" How far back (days) ")
		create l_ps_time_edit.make_with_text(default_ps_time_interval.out)
		create l_ps_cpu_label.make_with_text(" Max CPU (%%) ")
		create l_ps_cpu_edit.make_with_text(processor_red_alert_level.out)
		create l_ps_memory_label.make_with_text(" Min memory (MB) ")
		create l_ps_memory_edit.make_with_text(memory_red_alert_level.out)

		l_ps_status_bar.extend(l_ps_time_label)
		l_ps_status_bar.disable_item_expand(l_ps_time_label)
		l_ps_status_bar.extend(l_ps_time_edit)
		l_ps_status_bar.disable_item_expand(l_ps_time_edit)
		l_ps_status_bar.extend(l_ps_cpu_label)
		l_ps_status_bar.disable_item_expand(l_ps_cpu_label)
		l_ps_status_bar.extend(l_ps_cpu_edit)
		l_ps_status_bar.disable_item_expand(l_ps_cpu_edit)
		l_ps_status_bar.extend(l_ps_memory_label)
		l_ps_status_bar.disable_item_expand(l_ps_memory_label)
		l_ps_status_bar.extend(l_ps_memory_edit)
		l_ps_status_bar.disable_item_expand(l_ps_memory_edit)

		-- VBOX for perf_summary_grid and its controls.
		create perf_summary_vbox
		perf_summary_vbox.extend(perf_summary_grid)
		perf_summary_vbox.extend(l_ps_status_bar)
		perf_summary_vbox.disable_item_expand(l_ps_status_bar)

		-- Sysprocceses_grid.
		sysprocesses_grid := new_sysprocesses_grid

		-- Error messages pane.
		create error_message_pane
		error_message_pane.set_font(gui.rep.fonts.new_typewriter_font(False, False, 12))

		-- Build and populate the notebook.
		create notebook
		notebook.extend(splitter12)
		notebook.set_item_text(splitter12, "Status")
		notebook.extend(perf_vbox)
		notebook.set_item_text(perf_vbox, "Performance Charts")
		notebook.extend(perf_summary_vbox)
		notebook.set_item_text(perf_summary_vbox, "Performance Summary")
		notebook.extend(sysprocesses_grid)
		notebook.set_item_text(sysprocesses_grid, "Sysprocesses")
		notebook.extend(open_transactions_grid)
		notebook.set_item_text(open_transactions_grid, "Open Transactions")
		notebook.extend(disk_usage_grid)
		notebook.set_item_text(disk_usage_grid, "Disk Usage")
		notebook.extend(error_message_pane)
		notebook.set_item_text(error_message_pane, "Errors")

		notebook.selection_actions.extend(agent notebook_selected_agent)

		-- Populate more boxes.
		l_vbox1.extend(splitter11)
		l_vbox1.extend(l_rescan_button)
		l_vbox1.disable_item_expand(l_rescan_button)
		splitter1.extend(l_vbox1)
		splitter1.extend(notebook)
		l_vbox.extend(splitter1)
		l_vbox.extend(l_status_bar)
		l_vbox.disable_item_expand(l_status_bar)
		window.extend(l_vbox)

		-- Start the timer.
		timer.actions.extend(agent refresh)
	end

	init_after_show is
	-- Stuff that can only be done AFTER the window is shown.
	do
		splitter1.set_split_position(135)
		splitter11.set_proportion(0.66)
		splitter111.set_proportion(0.5)
		splitter12.set_proportion(0.9)
		splitter121.set_proportion(0.75)

		-- Make menus.
		populate_repositories_menu
	end

	right_align_grid_columns(a_grid: RP_DATA_GRID[ANY]; a_column_ids: ARRAY[INTEGER]; a_align_data_too: BOOLEAN)
	-- Right align the headers on columns in 'a_column_ids' in 'a_grid'.
	-- If 'a_align_data_too' then also set the same alignment for future data rows.  This should NOT be used
	-- when a grid has expansion rows with different alignment.
	require
		valid_grid: a_grid /= Void
		a_column_ids: a_column_ids /= Void and then not a_column_ids.is_empty
	do
		across a_column_ids as c_column_ids
		loop
			check attached {RP_DATA_GRID_LABEL_ITEM} a_grid.header_node.i_th(c_column_ids.item) as l_label_item
			then
				-- Align the column header.
				l_label_item.align_text_right
			end

			if a_align_data_too
			then
				-- Indicate that future data should be aligned.
				a_grid.column(c_column_ids.item).align_text_right
			end
		end
	end

--	count_objects
--	-- For debugging.  Starts the memory analyzer.
--	local
--	do
--		create ma.make("C:\estudio\32bit\6.7.8.5123\library\memory_analyzer")
--		ma.close_request_actions.extend(agent handle_close_ma_window)
--		ma.show
--	end

--	handle_close_ma_window is
--	do
--		ma.destroy
--	end

	count_objects is
	-- For debugging.  Counts the Eiffel objects and dumps to a DOS window.
	local
		l_eoc: EIFFEL_OBJECT_COUNTER
		l_cas: HASH_TABLE[PAIR[INTEGER_64, INTEGER_64], STRING]
	do
		create l_eoc
		l_cas := l_eoc.counts_and_sizes
		l_eoc.dump_cas_by_size_asc(l_cas, 1000)
		l_cas := Void
	end

	populate_repositories_menu
	-- The 'repositories_menu' allows the user to select the default environment or a test environment.
	local
		l_predicate: COLLECTING_PREDICATE[TRIPLE[STRING, STRING, STRING]]
	do
		repositories_menu := Gui.factory.new_menu(["Contextual", [Void]])

		gui.factory.add_menu_item(
			repositories_menu,
			[
				"Select a test environment",
				agent do_nothing
			],
			True)
		repositories_menu.extend(create {EV_MENU_SEPARATOR})
		gui.factory.add_menu_item(
			repositories_menu,
			[
				"Default = " + servers.repository_server.database + " - " + servers.repository_server.node,
				agent set_server_request_server_and_refresh(servers.repository_server.node, servers.repository_server.database)
			],
			True)

		if servers.repository_server.has_table("testenv_repositories")
		then
			create l_predicate.make(servers.repository_server,
									"select repository_db as first, server as second, [user] as third %N%
									%from testenv_repositories %N%
									%order by repository_db, server")
			if not l_predicate.success
			then
				show_dialog_with_error(window, "Predicate failed", "Failed to create the repositories predicate.", Void)
			else
				l_predicate.retrieve(Void, Void)
				if not l_predicate.success
				then
					show_dialog_with_error_fatal(window, "Predicate failed", "The repositories predicate failed.", Void)
				else
					from
						l_predicate.array.start
					until
						l_predicate.array.off
					loop
						gui.factory.add_menu_item(
							repositories_menu,
							[
								l_predicate.array.current_item.first + " - " + l_predicate.array.current_item.second,
								agent set_server_request_server_and_refresh(l_predicate.array.current_item.second, l_predicate.array.current_item.first)
							],
							True)
						l_predicate.array.forth
					end
				end
			end
		else
			-- This happens during testing.
			show_dialog_with_error(window, "No testenv_repositories", "Could not find the 'testenv_repositories' table.", Void)
		end
	end

	export_to_excel is
	-- Export the visible data to Excel.
	do
		if refresh_running
		then
			request_export_to_excel := True		-- We will come back here when the refresh is finished.
		else
			request_export_to_excel := False
			if notebook.selected_item=splitter12
			then
				array2_array_to_excel(
					<<
					[other_server_status_grid.to_array2, "Other servers"],
					[port_server_status_grid.to_array2, "Port servers"],
					[data_server_status_grid.to_array2, "Data servers"],
					[blockees_grid.to_array2, "Blockees"],
					[blockers_grid.to_array2, "Blockers"],
					[port_served_apps_grid.to_array2, port_served_apps_frame.text.to_string_8]
					>>)
			elseif notebook.selected_item=perf_summary_vbox
			then
				array2_array_to_excel(
					<<
					[other_server_status_grid.to_array2, "Other servers"],
					[port_server_status_grid.to_array2, "Port servers"],
					[data_server_status_grid.to_array2, "Data servers"],
					[perf_summary_grid.to_array2, "Performance Summary"]
					>>)
			elseif notebook.selected_item=sysprocesses_grid
			then
				array2_array_to_excel(
					<<
					[other_server_status_grid.to_array2, "Other servers"],
					[port_server_status_grid.to_array2, "Port servers"],
					[data_server_status_grid.to_array2, "Data servers"],
					[sysprocesses_grid.to_array2, notebook.item_text(sysprocesses_grid).to_string_8]
					>>)
			elseif notebook.selected_item=open_transactions_grid
			then
				array2_array_to_excel(
					<<
					[other_server_status_grid.to_array2, "Other servers"],
					[port_server_status_grid.to_array2, "Port servers"],
					[data_server_status_grid.to_array2, "Data servers"],
					[open_transactions_grid.to_array2, notebook.item_text(open_transactions_grid).to_string_8]
					>>)
			elseif notebook.selected_item=disk_usage_grid
			then
				array2_array_to_excel(
					<<
					[other_server_status_grid.to_array2, "Other servers"],
					[port_server_status_grid.to_array2, "Port servers"],
					[data_server_status_grid.to_array2, "Data servers"],
					[disk_usage_grid.to_array2, "Disk Usage"],
					[disk_usage_flattened, "Disk Usage (flattened)"]
					>>)
			else
				show_dialog_with_inform(window, " ", "Not implemented on this tab.", Void)
			end
		end
	end

	show_tooltip_agent(a_grid: BOOLEAN; a_item: EV_GRID_ITEM) is
	-- Displays a tooltip.
	do
		if a_item/=Void
		then
			if attached {RP_DATA_GRID_LABEL_ITEM} a_item as al_grid_label_item
			then
				if a_item.required_width>a_item.column.width
				then
					a_item.set_tooltip(al_grid_label_item.text)
				else
					a_item.set_tooltip("")
				end
			end
		end
	end

	data_server_sort_started_agent
	-- Called when the 'data_server_status_grid' is about to be sorted.  We remove the 'none' row.  We will replace it in 'data_server_sort_ended_agent'.
	do
		data_server_status_grid.remove_row(data_server_none_row)
	end

	data_server_sort_ended_agent
	-- Called after the 'data_server_status_grid' has been sorted.  We replace the 'none' row that was removed in 'data_server_sort_started_agent'.
	do
		data_server_status_grid.insert(data_server_none_row, 1)
	end

	pre_grid_draw(a_drawable: EV_DRAWABLE; a_grid_item: EV_GRID_ITEM; a_row_index_xxx, a_col_index_xxx: INTEGER) is
	-- Draws odd/even background colors.
	local
		l_grandparent_row: EV_GRID_ROW
		l_parent_row: EV_GRID_ROW
		l_row_index, l_col_index: INTEGER
		l_is_title_node: BOOLEAN
	do
		l_row_index := a_grid_item.row.index
		l_col_index := a_grid_item.column.index
		l_parent_row := a_grid_item.row.parent_row
		if l_parent_row/=Void
		then
			l_grandparent_row := l_parent_row.parent_row
		end

		if (l_parent_row/=Void or else a_grid_item.row.is_expanded) and
		   (a_grid_item.parent/=disk_usage_grid.grid or l_grandparent_row/=Void)
		then
			l_is_title_node := attached {RP_GRID_TITLE_NODE[ANY]} a_grid_item.row.data
			if not l_is_title_node or else l_col_index=1
			then
				if l_row_index \\ 2=0 or a_grid_item.parent=disk_usage_grid.grid
				then
					a_drawable.set_foreground_color(even_background_color)
				else
					a_drawable.set_foreground_color(odd_background_color)
				end

				if l_is_title_node
				then
					a_drawable.fill_rectangle(0, 0, a_grid_item.horizontal_indent - 1, a_drawable.height - 1)
				else
					a_drawable.fill_rectangle(0, 0, a_drawable.width - 1, a_drawable.height - 1)
				end
			end
		end
	end

	post_grid_draw(a_drawable: EV_DRAWABLE; a_grid_item: EV_GRID_ITEM; a_row_index_xxx, a_col_index_xxx: INTEGER) is
	-- Draws a box around an expanded node.
	local
		l_parent_row: EV_GRID_ROW
		l_row_index, l_col_index: INTEGER
	do
		l_row_index := a_grid_item.row.index
		l_col_index := a_grid_item.column.index
		a_drawable.set_foreground_color(colors.black)
		l_parent_row := a_grid_item.row.parent_row
		if l_parent_row/=Void
		then
			if l_parent_row.subrow(l_parent_row.subrow_count)=a_grid_item.row
			then
				-- Bottom line.
				a_drawable.draw_segment(0, a_drawable.height - 1, a_drawable.width - 1, a_drawable.height - 1)
			end

			if l_col_index=1
			then
				-- Left.
				a_drawable.draw_segment(0, 0, 0, a_drawable.height - 1)
			end

			if l_col_index=a_grid_item.row.count
			then
				-- Right.
				a_drawable.draw_segment(a_drawable.width - 1, 0, a_drawable.width - 1, a_drawable.height - 1)
			end
		else
			if a_grid_item.row.is_expanded
			then
				-- Top.
				a_drawable.draw_segment(0, 0, a_drawable.width - 1, 0)
				if l_col_index=1
				then
					-- Left.
					a_drawable.draw_segment(0, 0, 0, a_drawable.height - 1)
				end

				if l_col_index=a_grid_item.row.count
				then
					-- Right.
					a_drawable.draw_segment(a_drawable.width - 1, 0, a_drawable.width - 1, a_drawable.height - 1)
				end
			end
		end
	end

	new_sysprocesses_grid: RP_DATA_GRID[SQL_SERVER_SYSPROCESS]
	-- Common code to create a grid of sysprocesses.
	do
		create Result.make(
			<<
				"Server",
				"dbid",
				"hostname",
				"loginame",
				"program_name",
				"cpu",
				"cmd",
				"spid",
				"blocked by",
				"waittime",
				"lastwaittype",
				"waitresource",
				"login_time",
				"last_batch",
				"kpid",
--				"waittype",
				"uid",
				"physical_io",
				"memusage",
				"ecid",
				"open_tran",
				"status",
--				"sid",
				"hostprocess",
				"nt_domain",
				"nt_username",
				"net_address",
				"net_library",
--				"context_info",
--				"sql_handle",
				"stmt_start",
				"stmt_end"
			>>,
			Void
			)

		Result.column(1).set_width(70)
		Result.column(7).set_width(100)
		Result.column(8).set_width(60)
		Result.column(13).set_width(110)
		Result.column(14).set_width(110)
		Result.column(15).set_width(60)
		Result.column(16).set_width(60)
		Result.column(19).set_width(60)
		Result.column(20).set_width(60)
		Result.column(27).set_width(60)
		Result.column(28).set_width(60)

		right_align_grid_columns(Result, <<6, 8, 9, 10, 15, 16, 17, 18, 19, 20, 22, 27, 28>>, False)

		Result.set_are_lock_icons_displayed_on_header_node(True)

		set_grid_font_weight(Result)

--		Result.enable_single_row_selection
		Result.enable_multiple_row_selection
		Result.enable_selection_on_single_button_click
--		Result.enable_tree(True)
		Result.enable_column_separators
		Result.enable_row_separators
		Result.set_separator_color(separator_color)
		Result.set_are_raised_titles_enabled_on_header_node(True)
		Result.set_are_raised_titles_enabled(True)
		Result.set_are_columns_resizable_on_dividers_enabled(True)
--		Result.set_are_sticky_parents_enabled(True)
		Result.pointer_double_press_actions.extend(agent refresh_selected_sysprocesses_from_doubleclick(Result, ?, ?, ?, ?, ?, ?, ?, ?))
	end

	end_application is
	-- Action to be executed before exiting the application.
	do
		if not found_interesting_blocker and not alert_was_set
		then
			window.destroy_default_shell_notify_icon
		end

		collection_off
		Gui.destroy
	end

	set_focused_color_agent(a_drawable: EV_DRAWABLE; a_grid_item: EV_GRID_ITEM; a_column_index, a_row_index: INTEGER)
	-- When a grid item is selected, the foreground color turns white and the background color turns blue (this can
	-- be changed by Windows).  This causes a loss of information when a server is in red or yellow alert.  This routine
	-- changes the text color (for selected items) to be reprentative of the alert state.
	--
	-- This hack relies on internal knowledge of EV_GRID_DRAWER_I.redraw_area_in_drawable_coordinates and
	-- EV_GRID_LABEL_ITEM_I.perform_redraw.  The first calls:
	--		pre_draw_overlay_actions_internal (which calls 'set_focused_color_agent')
	--		EV_GRID_LABEL_ITEM_I.perform_redraw
	--		post_draw_overlay_actions_internal (which calls 'reset_focused_color_agent')
	-- If the grid item is selected, the middle routine uses either the 'focused_selection_color' or
	-- 'non_focused_selection_color' for the text color.  In this routine we change those two colors
	-- and in 'reset_focused_color_agent' we restore them.
	local
		l_color: EV_COLOR
		l_background_color: EV_COLOR
	do
		l_background_color := a_grid_item.background_color
		if l_background_color /= Void and then
		   (l_background_color = red_alert_color or l_background_color = yellow_alert_color or l_background_color = orange_alert_color) and
		   a_grid_item.is_selected
		then
			if old_focused_selection_text_color = Void
			then
				old_focused_selection_text_color := a_grid_item.parent.focused_selection_text_color
				old_non_focused_selection_text_color := a_grid_item.parent.non_focused_selection_text_color
			end

			if l_background_color = red_alert_color
			then
				l_color := colors.dark_red		-- This looks better against the dark blue background.
			elseif l_background_color = yellow_alert_color
			then
				if a_grid_item.parent.has_focus
				then
					l_color := colors.yellow
				else
					l_color := yellow_alert_inactive_selected_color
				end
			else
				l_color := l_background_color
			end

			a_grid_item.parent.set_focused_selection_text_color(l_color)
			a_grid_item.parent.set_non_focused_selection_text_color(l_color)
		end
	end

	reset_focused_color_agent(a_drawable: EV_DRAWABLE; a_grid_item: EV_GRID_ITEM; a_column_index, a_row_index: INTEGER)
	-- See 'set_focused_color_agent'.
	do
		if old_focused_selection_text_color /= Void
		then
			a_grid_item.parent.set_focused_selection_text_color(old_focused_selection_text_color)
			a_grid_item.parent.set_non_focused_selection_text_color(old_non_focused_selection_text_color)
		end
	end

	refresh is
	-- Almost all of the action starts here.  This refreshes whatever is visible on screen.
	local
		i: INTEGER
		l_sysprocesses: SQL_SERVER_SYSPROCESSES
		l_machine_name: STRING
		l_dot_pos: INTEGER
		l_old_interval: INTEGER
		l_a_little_while_ago: ROSE_DATE
		l_backwards_duration: DATE_TIME_DURATION
		l_counter_summary: COUNTER_SUMMARY_VIEW
		l_yellow_alert: BOOLEAN
		l_orange_alert: BOOLEAN
		l_red_alert: BOOLEAN
		l_color: EV_COLOR
		l_trouble_machines: HASH_TABLE[EV_COLOR, STRING]
		l_backslash_position: INTEGER
		l_predicate: COLLECTING_PREDICATE[COUNTER_SUMMARY_VIEW]
		l_text: STRING
	do
		l_old_interval := timer.interval
		timer.set_interval(0)				-- Reset the timer in case we are here without a timeout.
		timer.set_interval(l_old_interval)

		if equal(global.user.user.login_id, "RJ") and not collecting
		then
			print("Collection was turned off!%N")
		end

		collection_on						-- Just to make sure.

		if not refresh_running
		then
			refresh_running := True
			gui.start_busy_wait
			update_time

			restart_timer

			save_timer_actions
			timer.actions.wipe_out

			-- Find machines that are in trouble.
			action_text.set_text("   Finding machines in trouble")
			Gui.process_events

			create l_trouble_machines.make(10)
			alert_was_set := False
			create l_backwards_duration.make_definite(0, 0, -20, 0)
			create l_a_little_while_ago.make_now
			l_a_little_while_ago.add(l_backwards_duration)
			l_predicate := machines_in_trouble_predicate(l_a_little_while_ago.formatted_out("YYYY-[0]MM-[0]DD [0]HH:[0]MI"))
			l_predicate.retrieve(Void, Void)

			if l_predicate.success
			then
				from
					l_predicate.array.start
				until
					l_predicate.array.off
				loop
					l_yellow_alert := False
					l_orange_alert := False
					l_red_alert := False
					l_counter_summary := l_predicate.array.current_item
					if equal(l_counter_summary.objectname, "Memory")
					then
						if l_counter_summary.countervalue<memory_red_alert_level
						then
							if l_counter_summary.countervalue>0
							then
								l_red_alert := True
							else
								l_orange_alert := True
							end
						else
							l_yellow_alert := True
						end
					end

					if equal(l_counter_summary.objectname, "Processor") and not l_red_alert
					then
						if l_counter_summary.countervalue>processor_red_alert_level
						then
							l_red_alert := True
						else
							l_yellow_alert := True
						end
					end

					if l_red_alert
					then
						l_color := red_alert_color
					else
						if l_yellow_alert
						then
							l_color := yellow_alert_color
						else
							l_color := orange_alert_color
						end
					end

					l_machine_name := l_counter_summary.machinename.twin
					l_machine_name.prune_all('\')
					l_machine_name.to_upper
					l_trouble_machines.search(l_machine_name)
					if not l_trouble_machines.found or else l_trouble_machines.found_item/=red_alert_color
					then
						l_trouble_machines.force(l_color, l_machine_name)
					end

					l_predicate.array.forth
				end
			end

			-- Refresh each data server.
			create all_sysprocesses.make(500)
			action_text.set_text("   Finding data servers")
			Gui.process_events

			from
				i := 1
			until
				i>data_server_status_grid.row_count
			loop
				check attached {RP_DATA_GRID_LABEL_ITEM} data_server_status_grid.row(i).i_th(1) as al_label_item
				then
					l_machine_name := al_label_item.text.twin
				end

				l_backslash_position := l_machine_name.index_of('\', 1)
				if l_backslash_position/=0
				then
					l_machine_name := l_machine_name.substring(1, l_backslash_position - 1)
				end

				l_trouble_machines.search(l_machine_name)
				if l_trouble_machines.found
				then
					l_color := l_trouble_machines.found_item
					if l_color=red_alert_color
					then
						alert_was_set := True
					end
				else
					l_color := colors.white
				end

				data_server_status_grid.row(i).i_th(1).set_background_color(l_color)
				data_server_status_grid.row(i).i_th(2).set_background_color(l_color)

				if data_server_status_grid.selected_items.count=0 or data_server_status_grid.row(i).is_selected
				then
					l_sysprocesses := data_server_status_grid.row(i).data
					if l_sysprocesses.connected
					then
						action_text.set_text("   Refreshing " + l_sysprocesses.name)
						Gui.process_events

						l_sysprocesses.refresh
						if l_sysprocesses.success
						then
							update_data_server_status_grid(l_sysprocesses.name, "UP")
							load_all_process(l_sysprocesses)

							if l_sysprocesses.processes.count = 1
							then
								-- This can happen if you lack the "VIEW SERVER STATE" priv.
								check attached {RP_DATA_GRID_LABEL_ITEM} data_server_status_grid.row(i).i_th(1) as al_label_item1 and
									  attached {RP_DATA_GRID_LABEL_ITEM} data_server_status_grid.row(i).i_th(2) as al_label_item2
								then
									-- Set the tooltip.
									al_label_item1.set_tooltip(k_no_view_server_state)
									al_label_item2.set_tooltip(k_no_view_server_state)

									-- Make the font more noticable.
									al_label_item1.set_font(tooltip_available_font)
									al_label_item2.set_font(tooltip_available_font)
								end
							end
						else
							update_data_server_status_grid(l_sysprocesses.name, "Could not refresh")
						end
					else
						if l_sysprocesses.name ~ k_none
						then
							l_text := ""
						else
							l_text := "DOWN"
						end

						update_data_server_status_grid(l_sysprocesses.name, l_text)
					end
				end

				Gui.process_events

				i := i + 1
			end

			-- Get all server requests.
			action_text.set_text("   Finding port served applications")
			Gui.process_events

			--===============================
			create server_requests.make_empty
			get_server_requests.set_container(server_requests)		-- These lines are
			get_server_requests.retrieve(Void, Void)				-- repeated below.
			--===============================

			if not get_server_requests.success
			then
				-- The server with the server_requests table must be down.  Rebuild the predicate and try again (once).
				if may_rebuild_server_request_server
				then
					may_rebuild_server_request_server := False
					get_server_requests_saved := Void					-- Force the predicate to be rebuilt.
					--===============================
					create server_requests.make_empty					-- Copied from above.
					get_server_requests.set_container(server_requests)	-- Copied from above.
					get_server_requests.retrieve(Void, Void)			-- Copied from above.
					--===============================
				end
			end

			Gui.process_events
			if get_server_requests.success
			then
				-- Make minor format changes to the server_requests.
				from
					server_requests.start
				until
					server_requests.off
				loop
					-- I think that 'machine' used to be of the form 'machine.axaros.com'.
					-- This code removes the stuff from the '.' on.  Couldn't hurt.
					-- Note that 'l_machine_name' is the same object as
					-- 'server_requests.current_item.machine'.  That's intended.
					l_machine_name := server_requests.current_item.machine
					l_machine_name.to_upper
					l_dot_pos := l_machine_name.index_of('.', 1)
					if l_dot_pos/=0
					then
						l_machine_name.keep_head(l_dot_pos - 1)
					end

					-- Reformat the paths so that the program name comes first.
					reformat_path(server_requests.current_item.server_executable)
					reformat_path(server_requests.current_item.client)

					server_requests.forth
				end
			end

			-- Show trouble machines in color.
			from
				i := 1
			until
				i>port_server_status_grid.row_count
			loop
				check attached {RP_DATA_GRID_LABEL_ITEM} port_server_status_grid.row(i).i_th(1) as al_label_item
				then
					l_trouble_machines.search(al_label_item.text)
				end

				if l_trouble_machines.found
				then
					l_color := l_trouble_machines.found_item
					if l_color=red_alert_color
					then
						alert_was_set := True
					end
				else
					l_color := colors.white
				end

				port_server_status_grid.row(i).i_th(1).set_background_color(l_color)
				port_server_status_grid.row(i).i_th(2).set_background_color(l_color)
				port_server_status_grid.row(i).i_th(3).set_background_color(l_color)
				i := i + 1
			end

			-- Show trouble machines in color.
			from
				i := 1
			until
				i>other_server_status_grid.row_count
			loop
				check attached {RP_DATA_GRID_LABEL_ITEM} other_server_status_grid.row(i).i_th(1) as al_label_item
				then
					l_trouble_machines.search(al_label_item.text)
				end

				if l_trouble_machines.found
				then
					l_color := l_trouble_machines.found_item
					if l_color=red_alert_color
					then
						alert_was_set := True
					end
				else
					l_color := colors.white
				end

				other_server_status_grid.row(i).i_th(1).set_background_color(l_color)
				i := i + 1
			end

			-- Refresh the appropriate notebook page.
			if notebook.selected_item=perf_vbox
			then
				show_perf_graphs
			elseif notebook.selected_item=perf_summary_vbox
			then
				refresh_perf_summary
			elseif notebook.selected_item=sysprocesses_grid
			then
				refresh_sysprocesses
			elseif notebook.selected_item=open_transactions_grid
			then
				show_open_transactions
			elseif notebook.selected_item=disk_usage_grid
			then
				show_disk_usage
			else
				-- Refresh the port served apps.
				refresh_port_served_apps

				-- Refresh the blockers_grid.
				refresh_blockers
			end

			restore_timer_actions

			action_text.set_text("")
			gui.end_wait
			Gui.process_events
			refresh_running := False
			if request_blocker_detail_row/=Void
			then
				show_blocker_detail_guts(request_blocker_detail_row)
				request_blocker_detail_row := Void
			end

			if request_export_to_excel
			then
				request_export_to_excel := False
				export_to_excel
			end

--			if request_blocker_detail_process/=Void
--			then
--				show_blocker_detail_from_leaf(request_blocker_detail_process)
--				request_blocker_detail_process := Void
--			end
		end
	end

	load_all_process(a_sysprocesses: SQL_SERVER_SYSPROCESSES) is
	-- Collects info on all sysprocesses.
	local
		l_sysprocesses: ROSE_LINEAR_ARRAY[SQL_SERVER_SYSPROCESS]
		l_sysprocesses2: ROSE_LINEAR_ARRAY[SQL_SERVER_SYSPROCESS]
		l_key: STRING
	do
		l_sysprocesses := a_sysprocesses.processes
		from
			l_sysprocesses.start
		until
			l_sysprocesses.off
		loop
			l_key := l_sysprocesses.current_item.hostname + l_sysprocesses.current_item.hostprocess.out
			if l_key.count/=0
			then
				l_sysprocesses2 := all_sysprocesses.item(l_key)
				if l_sysprocesses2=Void
				then
					create l_sysprocesses2.make_empty
					all_sysprocesses.put(l_sysprocesses2, l_key)
				end

				l_sysprocesses2.extend(l_sysprocesses.current_item)
			end

			l_sysprocesses.forth
		end
	end

	refresh_sysprocesses is
	-- Refreshes the 'sysprocesses' tab.
	local
		l_sysprocesses: SQL_SERVER_SYSPROCESSES
		l_all_sysprocesses: ROSE_LINEAR_ARRAY[SQL_SERVER_SYSPROCESS]
		i: INTEGER
	do
		Gui.start_busy_wait
		update_time
		action_text.set_text("   Gathering sysprocesses")
		Gui.process_events

		create l_all_sysprocesses.make_empty

		from
			i := 1
		until
			i>data_server_status_grid.row_count
		loop
			if data_server_status_grid.selected_items.count=0 or data_server_status_grid.row(i).is_selected
			then
				l_sysprocesses := data_server_status_grid.row(i).data
				if l_sysprocesses.connected
				then
					if l_sysprocesses.success
					then
						l_all_sysprocesses.append_array(l_sysprocesses.processes)
					end
				end
			end

			Gui.process_events

			i := i + 1
		end

		action_text.set_text("   Displaying sysprocesses")
		Gui.process_events
		refresh_sysprocess_list(l_all_sysprocesses, sysprocesses_grid)
--		if blockers_grid.count/=0
--		then
--			window.show_default_shell_notify_icon
--		else
--			window.destroy_default_shell_notify_icon
--		end

		action_text.set_text("")
		gui.end_wait
		Gui.process_events
	end

	refresh_blockers is
	-- Refreshes the 'blockers' tab.
	local
		l_sysprocesses: SQL_SERVER_SYSPROCESSES
		l_blocker: SQL_SERVER_SYSPROCESS
		l_blocker_sysprocesses: ROSE_LINEAR_ARRAY[SQL_SERVER_SYSPROCESS]
		l_blocker_sysprocesses_temp: ROSE_LINEAR_ARRAY[SQL_SERVER_SYSPROCESS]
		l_shown_first_blocker: BOOLEAN
		l_prefix: STRING
		i: INTEGER
	do
		Gui.start_busy_wait
		update_time
		action_text.set_text("   Finding blockers")
		Gui.process_events

		create l_blocker_sysprocesses.make_empty

		from
			i := 1
		until
			i>data_server_status_grid.row_count
		loop
			if data_server_status_grid.selected_items.count=0 or data_server_status_grid.row(i).is_selected
			then
				l_sysprocesses := data_server_status_grid.row(i).data
				if l_sysprocesses.connected
				then
					if l_sysprocesses.success
					then
						l_blocker_sysprocesses_temp := l_sysprocesses.blockers
						l_blocker_sysprocesses.append_array(l_blocker_sysprocesses_temp)

						if log_blockers.is_selected
						then
							from
								l_blocker_sysprocesses_temp.start
							until
								l_blocker_sysprocesses_temp.off
							loop
								if not l_shown_first_blocker
								then
									l_shown_first_blocker := True
									blocker_log_file.put_string("%N")
									blocker_log_file.put_string("Blocker report @ " + Global.interpreted("$now:%N"))
								end

								l_blocker := l_blocker_sysprocesses_temp.current_item
								l_prefix := l_sysprocesses.server.node + "." + l_sysprocesses.dbname(l_blocker.dbid) + "%T"
								blocker_log_file.put_string(
									l_prefix +
									l_blocker.spid.out + "%T" +
									l_blocker.hostname_or_void + "/" + l_blocker.hostprocess_or_void + "%T" +
									"wait (secs)%T" +
									l_blocker.loginame + "%T" +
									l_blocker.program_name + "%N")
								refresh_blockees(l_blocker, l_prefix)

								l_blocker_sysprocesses_temp.forth
							end

							if l_shown_first_blocker
							then
								blocker_log_file.flush
							end
						end
					end
				end
			end

			Gui.process_events

			i := i + 1
		end

		refresh_sysprocess_list(l_blocker_sysprocesses, blockers_grid)

		if found_interesting_blocker or alert_was_set
		then
			window.show_default_shell_notify_icon
		else
			window.destroy_default_shell_notify_icon
		end

		action_text.set_text("")
		gui.end_wait
		Gui.process_events
	end

	show_blocker_detail(a_row: EV_GRID_ROW) is
	-- Shows the blockees for one blocker.
	local
		l_row: RP_GRID_NODE[SQL_SERVER_SYSPROCESS]
	do
		l_row := blockers_grid.row(a_row.index)
		if refresh_running
		then
			request_blocker_detail_row := l_row
		else
			show_blocker_detail_guts(l_row)
		end
	end

	show_blocker_detail_guts(a_row: RP_GRID_NODE[SQL_SERVER_SYSPROCESS])
	-- Shows the blockees for one blocker.
	local
		l_process: SQL_SERVER_SYSPROCESS
	do
		if not in_show_blocker_detail_guts
		then
			in_show_blocker_detail_guts := True
			showing_blocker_detail := True
			Gui.start_busy_wait
			save_timer_actions
			timer.actions.wipe_out
			refresh_button.set_foreground_color(Colors.Red)

			l_process := a_row.data
			highlight_port_served_apps(l_process)
			refresh_blockees(l_process, Void)

			gui.end_wait
			in_show_blocker_detail_guts := False
		end
	rescue
		in_show_blocker_detail_guts := False
	end

--	show_blocker_detail_by_id(a_server_name: STRING; a_blocker_spid: INTEGER) is
--	-- Shows the blockees that are blocked by 'a_blocker_spid'.
--	local
--		l_processes: ROSE_LINEAR_ARRAY[SQL_SERVER_SYSPROCESS]
--		l_done: BOOLEAN
--		l_saved_index: INTEGER
--		l_saved_processes_index: INTEGER
--	do
--		l_saved_index := Data_servers.index
--		from
--			data_servers.start
--		until
--			data_servers.off
--		loop
--			if equal(data_servers.current_item.name, a_server_name) and then data_servers.current_item.success
--			then
--				l_processes := data_servers.current_item.processes
--				l_saved_processes_index := l_processes.index
--				from
--					l_processes.start
--				until
--					l_processes.off or l_done
--				loop
--					if l_processes.current_item.spid=a_blocker_spid
--					then
--						if l_processes.current_item.blocked/=0
--						then
--							-- A recursive call!
--							show_blocker_detail_by_id(a_server_name, l_processes.current_item.blocked)
--						else
--							show_blocker_detail_from_leaf(l_processes.current_item)
--						end

--						l_done := True
--					end

--					l_processes.forth
--				end

--				l_processes.go_i_th(l_saved_processes_index)
--			end

--			data_servers.forth
--		end

--		Data_servers.go_i_th(l_saved_index)
--	end

--	show_blocker_detail_from_leaf(a_sysprocess: SQL_SERVER_SYSPROCESS) is
--	-- Shows the blockees that are blocked by 'a_sysprocess'.
--	do
--		if not showing_blocker_detail
--		then
--			if refresh_running
--			then
--				request_blocker_detail_process := a_sysprocess
--			else
--				showing_blocker_detail := True
--				Gui.start_busy_wait
--				save_timer_actions
--				timer.actions.wipe_out
--				refresh_button.set_background_color(Colors.Red)

--				highlight_port_served_apps(a_sysprocess)
--				highlight_blocker(a_sysprocess)
--				refresh_blockees(a_sysprocess)

--				gui.end_wait
--			end
--		end
--	end

--	highlight_blocker(a_sysprocess: SQL_SERVER_SYSPROCESS) is
--	local
--		i: INTEGER
--		l_process: SQL_SERVER_SYSPROCESS
--	do
--		from
--			i := 1
--		until
--			i>blockers_grid.row_count
--		loop
--			l_process ?= blockers_grid.row(i).data
--			if equal(l_process.parent.name, a_sysprocess.parent.name) and
--			   l_process.spid=a_sysprocess.spid
--			then
--				blockers_grid.row(i).set_foreground_color(blocker_color)	-- Huh?!?!  This doesn't make sense.
--			end

--			i := i + 1
--		end
--	end

	highlight_port_served_apps(a_sysprocess: SQL_SERVER_SYSPROCESS) is
	-- Highlight (with color) those apps which are blockers.
	local
		i: INTEGER
	do
		refresh_port_served_apps
		update_time
		action_text.set_text("   Highlighting port served applications")
		Gui.process_events
		if a_sysprocess.hostprocess.is_integer
		then
			from
				i := 1
			until
				i>port_served_apps_grid.row_count
			loop
				check attached {SERVER_REQUEST_TREE_NODE} port_served_apps_grid.row(i) as al_node
				then
					al_node.highlight_if(a_sysprocess)
				end

				i := i + 1
			end
		end

		action_text.set_text("")
		Gui.process_events
	end

	show_sysprocesses_menu(a_sysprocess: SQL_SERVER_SYSPROCESS; a_x, a_y, a_button: INTEGER; a_item: RP_DATA_GRID_ITEM) is
	-- Called when the user presses MB3 on a sysprocess row.
	local
		l_menu: EV_MENU
		l_sysprocess: SQL_SERVER_SYSPROCESS
		l_sql_statement: STRING
		l_sql_statement_no_cr: STRING
		l_simple_command: DATA_SERVER_SIMPLE_COMMAND
		l_integer: INTEGER
	do
		if a_button=3 and a_item/=Void
		then
			blockers_grid.row_select_actions.block		-- Don't perform the select actions on the next line.
			a_item.parent.select_row(a_item.row.index)
			blockers_grid.row_select_actions.resume

			l_sysprocess := a_sysprocess
			if not l_sysprocess.cmd.has_substring("LAZY WRITER") and
			   not l_sysprocess.cmd.has_substring("LOCK MONITOR") and
			   not l_sysprocess.cmd.has_substring("SIGNAL HANDLER") and
			   not l_sysprocess.cmd.has_substring("LOG WRITER") and
			   not l_sysprocess.cmd.has_substring("CHECKPOINT SLEEP")
			then
				-- Some processes shouldn't be killed.  They also fail when you call 'inputbuffer'.
				l_simple_command := l_sysprocess.sysprocesses.server.simple_command("dbcc inputbuffer(" + l_sysprocess.spid.out + ")")
				--l_simple_command := l_sysprocess.parent.server.simple_command("dbcc inputbuffer(9999)")	-- Will fail.

				l_integer := l_simple_command.execute(True)
				if l_integer>=0
				then
					l_integer := l_simple_command.move_first
					l_sql_statement := l_simple_command.get_uc_string_value(3).string

					-- No CR allowed in an EV_TEXT.
					l_sql_statement_no_cr := l_sql_statement.twin
					l_sql_statement_no_cr.replace_substring_all("%R%N", " ")
					l_sql_statement_no_cr.replace_substring_all("%R", " ")
					l_sql_statement_no_cr.replace_substring_all("%N", " ")
				else
					do_nothing
				end

				check attached {RP_DATA_GRID[SQL_SERVER_SYSPROCESS]} a_item.node.grid as al_grid
				then
					if l_sql_statement_no_cr/=Void and then l_sql_statement_no_cr.count/=0
					then
						l_menu := Gui.factory.new_menu
							(["Contextual",
								["Refresh selected (double-click)", agent refresh_selected_sysprocesses(al_grid)],
								["Kill SPID...", agent kill_spid(l_sysprocess)],
								["Profile", agent start_profiler(l_sysprocess)],
								[l_sql_statement_no_cr, agent show_sql_statement(l_sql_statement.twin)]
							])
					else
						l_menu := Gui.factory.new_menu
							(["Contextual",
								["Refresh selected (double-click)", agent refresh_selected_sysprocesses(al_grid)],
								["Kill SPID...", agent kill_spid(l_sysprocess)],
								["Profile", agent start_profiler(l_sysprocess)]
							])
					end
				end

				l_menu.show
			end
		end
	rescue
		if blockers_grid/=Void and then blockers_grid.row_select_actions/=Void
		then
			blockers_grid.row_select_actions.resume
		end
	end

	start_profiler(a_sysprocess: SQL_SERVER_SYSPROCESS)
	-- Start the SQL Server Profiler on the SPID found in 'a_sysprocess'.  To do this I used the Profiler to create
	-- a fake template.  I then found where the SPID is stored (last 4 bytes) and saved that file (the TDF file).  Here,
	-- we read the fake template and write a new template (in the location that the Profiler wants) with the desired SPID.
	-- The user must have run the Profiler once and made a template to create the folder.
	local
		i: INTEGER
		l_contents: STRING
		l_tdf_name: STRING
		l_input_file_name: STRING
		l_input_file: ROSE_RAW_FILE
		l_input_file_rj: ROSE_RAW_FILE
		l_input_folder_name: STRING
		l_output_file_name: STRING
		l_output_file: ROSE_RAW_FILE
		l_output_folder: DIRECTORY
		l_output_folder_name: STRING
		l_output_folder_name_11: STRING
		l_output_folder_name_10: STRING
		l_output_folder_name_9: STRING
		l_process_factory: PROCESS_FACTORY
		l_process: PROCESS
		l_args: STRING
		l_this_is_11_or_higher: BOOLEAN
		l_an_output_file_was_created: BOOLEAN
	do
		-- Check to see if the input file (the fake template) and the output folder exist.
		l_tdf_name := "data_connection_viewer_90"		-- We may need other flavors for future versions of the Profiler.
		l_input_folder_name := global.app.env.current_working_directory
		l_input_file_name := l_input_folder_name + "\" + l_tdf_name + ".tdf"
		create l_input_file.make(l_input_file_name)

		if not l_input_file.exists and global.user.user.login_id ~ "RJ"
		then
			-- Everytime I rebuild from scratch, the .tdf file is destroyed.  Copy it from a known location.
			create l_input_file_rj.make_open_read("C:\RJ\data_connection_viewer\" + l_tdf_name + ".tdf")

			if l_input_file_rj.exists
			then
				l_input_file.open_write
				l_input_file_rj.copy_to(l_input_file)
				l_input_file_rj.close
				l_input_file.close

				-- Try again.
				create l_input_file.make(l_input_file_name)
			end
		end

		if not l_input_file.exists
		then
			show_dialog_with_error(window, "Can't find the TDF file!", "Could not find " + l_input_file_name + ".", Void)
		else
			-- The 'l_output_folder' is where the Profiler wants to see templates (.TDF).  Try version 11 first.
			l_output_folder_name_11 := global.env.folders.appdata + "\Microsoft\SQL Profiler\11.0\Templates\Microsoft SQL Server\110"
			l_output_folder_name := l_output_folder_name_11
			l_this_is_11_or_higher := True
			create l_output_folder.make(l_output_folder_name_11)
			if l_output_folder.exists
			then
				-- Remove the version number (we will add it back later).
				l_output_folder_name_11 := global.env.folders.appdata + "\Microsoft\SQL Profiler\11.0\Templates\Microsoft SQL Server"
			else
				-- OK, try version 10.
				l_this_is_11_or_higher := False
				l_output_folder_name_10 := global.env.folders.appdata + "\Microsoft\SQL Profiler\10.0\Templates\Microsoft SQL Server\100"
				l_output_folder_name := l_output_folder_name_10
				create l_output_folder.make(l_output_folder_name_10)
				if not l_output_folder.exists
				then
					-- OK, try version 9.
					l_output_folder_name_9 := global.env.folders.appdata + "\Microsoft\SQL Profiler\9.0\Templates\Microsoft SQL Server\90"
					l_output_folder_name := l_output_folder_name_9
					create l_output_folder.make(l_output_folder_name_9)
					if not l_output_folder.exists
					then
						show_dialog_with_error(window,
											   "Can't find Profiler folder!",
											   "Could not find " + l_output_folder_name_11 + ".%N%
											   %Could not find " + l_output_folder_name_10 + ".%N%
											   %Could not find " + l_output_folder_name_9 + ".%N%
											   %Run the SQL Profiler and make a template (to create this folder).",
											   Void)
						l_output_folder := Void
					end
				end
			end

			if l_output_folder/=Void
			then
				-- Read my fake template.
				l_input_file.open_read
				l_input_file.read_stream(l_input_file.count)
				l_contents := l_input_file.last_string
				l_input_file.close

				from
					i := 1
				until
					i > 3 or (i > 1 and not l_this_is_11_or_higher)
				loop
					-- We have to put it into the correct folder according to the version of the server we are profiling (which we don't know).  Do 'em all.
					if l_this_is_11_or_higher
					then
						inspect i
						when 1 then
							l_output_folder_name := l_output_folder_name_11 + "\110"
						when 2 then
							l_output_folder_name := l_output_folder_name_11 + "\100"
						when 3 then
							l_output_folder_name := l_output_folder_name_11 + "\90"
						end
					end

					-- Write it out to the Profiles template folder (but put the SPID in the last four bytes).
					create l_output_folder.make(l_output_folder_name)
					if l_output_folder.exists
					then
						l_output_file_name := l_output_folder_name + "\" + l_tdf_name + ".tdf"
						create l_output_file.make_open_write(l_output_file_name)
						l_output_file.put_string(l_contents.substring(1, l_contents.count - 4))
						l_output_file.put_integer(a_sysprocess.spid)
						l_output_file.close
						l_an_output_file_was_created := True
					end

					i := i + 1
				end

				if not l_an_output_file_was_created
				then
					show_dialog_with_error(window,
										   "Something went wrong!",
										   "Did not create an output file.%N" +
										   "This probably won't work.",
										   Void)
				end

				-- Spawn the Profiler.  The /s argument is the machine and the /t argument is the template (which we just wrote).
				l_args := " /s " + a_sysprocess.sysprocesses.name + " /t " + l_tdf_name
				create l_process_factory

				l_process := l_process_factory.process_launcher_with_command_line("profiler" + l_args, Void)		-- Version 10 or 11.
				l_process.launch
				if not l_process.launched
				then
					l_process := l_process_factory.process_launcher_with_command_line("profiler90" + l_args, Void)	-- Version 9.
					l_process.launch
					if not l_process.launched
					then
						show_dialog_with_error(window, "Failed to launch the Profiler", "Failed to launch the Profiler.", Void)
					end
				end
			end
		end
	end

	refresh_selected_sysprocesses_from_doubleclick(
		a_grid: RP_DATA_GRID[SQL_SERVER_SYSPROCESS]; x, y, button: INTEGER; x_tilt, y_tilt, pressure: DOUBLE; screen_x, screen_y: INTEGER)
	-- Called when the user double-clicks a sysprocess row.  Version 1.
	do
		refresh_selected_sysprocesses(a_grid)
	end

	refresh_selected_sysprocesses_from_doubleclick2(
		a_grid: RP_DATA_GRID[SQL_SERVER_SYSPROCESS]; x, y, button: INTEGER; a_grid_item: RP_DATA_GRID_ITEM)
	-- Called when the user double-clicks a sysprocess row.  Version 2 (has different signature from version 1).
	do
		refresh_selected_sysprocesses(a_grid)
	end

	refresh_selected_sysprocesses(a_grid: RP_DATA_GRID[SQL_SERVER_SYSPROCESS])
	-- Called when the user selects one or more rows, clicks MB3 and selects 'refresh selected' (or double-clicks on one row).
	local
		l_nodes: ARRAYED_LIST[RP_GRID_NODE[SQL_SERVER_SYSPROCESS]]
		l_sysprocess: SQL_SERVER_SYSPROCESS
		l_index: INTEGER
		l_row: RP_GRID_NODE[SQL_SERVER_SYSPROCESS]
	do
		if not in_show_blocker_detail_guts
		then
			l_nodes := a_grid.selected_nodes

			from
				l_nodes.start
			until
				l_nodes.off
			loop
				l_sysprocess := l_nodes.item.data
				l_sysprocess.refresh
				l_row := sysprocess_to_grid_row(l_sysprocess, l_nodes.item.grid, Void)
				l_index := l_nodes.item.index
				a_grid.replace_row(l_nodes.item, l_row)
				a_grid.row_select_actions.block
				a_grid.select_row(l_index)
				a_grid.row_select_actions.resume
				l_nodes.forth
			end
		end
	rescue
		if a_grid/=Void and then a_grid.row_select_actions/=Void
		then
			a_grid.row_select_actions.resume
		end
	end

	show_sql_statement(a_sql_statement: STRING) is
	-- Pops a window with 'a_sql_statement' in it.
	local
		l_window: EV_TITLED_WINDOW
		l_text: EV_TEXT
	do
		create l_text
		l_text.set_text(a_sql_statement)

		create l_window.make_with_title(" ")
		l_window.set_size(400, 200)
		l_window.extend(l_text)
		l_window.close_request_actions.extend(agent l_window.hide)

		l_window.show
	end

	show_data_server_status_menu(
		a_x, a_y, a_button: INTEGER;
		a_item: RP_DATA_GRID_ITEM) is
	-- Shows the right-click menu for the 'data_server_status_grid'.
	local
		l_menu: EV_MENU
		l_sysprocesses: SQL_SERVER_SYSPROCESSES
		l_sql_log_file_name: STRING
		l_sql_log_folder_name: STRING
		l_machine_name: STRING
		l_end: INTEGER
	do
		if a_button=3 and a_item/=Void
		then
			l_menu := Gui.factory.new_menu(["Contextual", [Void]])
			l_sysprocesses := data_server_status_grid.row(a_item.row.index).data
			l_end := l_sysprocesses.name.index_of('\', 3) - 1
			if l_end<=0
			then
				l_end := l_sysprocesses.name.count
			end

			l_machine_name := l_sysprocesses.name.substring(1, l_end)
			l_sql_log_folder_name := "\\" + l_machine_name + "\" + l_machine_name + "_ERRORLOG\"
			l_sql_log_file_name := l_sql_log_folder_name + "ERRORLOG"
			gui.factory.add_menu_item(
				l_menu,
				["View SQL Server log file", agent (global.env).launch("NOTEPAD " + l_sql_log_file_name)],
				True)
			gui.factory.add_menu_item(
				l_menu,
				["Explore the SQL Server log file's folder", agent Global.explore(l_sql_log_folder_name)],
				True)
			gui.factory.add_menu_item(
				l_menu,
				["Attempt to reconnect", agent rescan_dataserver(l_sysprocesses)],
				not l_sysprocesses.connected)
			l_menu.show
		end
	end

	show_port_server_status_menu(
		a_x, a_y, a_button: INTEGER;
		a_item: RP_DATA_GRID_ITEM) is
	-- Shows the right-click menu for the 'port_server_status_grid'.
	local
		l_menu: EV_MENU
		l_server_name: STRING
		l_portnumber: STRING
		l_status: STRING
		l_log_file_name: STRING
		l_full_filename: STRING
		l_win32_find_data: WIN32_FIND_DATA
		l_any: ANY
		l_buffer: STRING
		l_buffer_area: ANY
		l_handle: INTEGER
		l_result: INTEGER
		l_collecting: BOOLEAN
		l_log_file_path: STRING
		l_colon_pos: INTEGER
	do
		if a_button=3 and a_item/=Void
		then
			check attached {RP_DATA_GRID_LABEL_ITEM} a_item.node.i_th(1) as al_label_item1 and
				  attached {RP_DATA_GRID_LABEL_ITEM} a_item.node.i_th(2) as al_label_item2 and
				  attached {RP_DATA_GRID_LABEL_ITEM} a_item.node.i_th(3) as al_label_item3
			then
				l_server_name := al_label_item1.text
				l_status := al_label_item2.text
				l_portnumber := al_label_item3.text
			end

			-- Find the name of the portserver's log file.
			l_collecting := collecting
			collection_off

			-- Setup stuff for 'find_first_file'.
			load_config_values(l_server_name)
			l_log_file_path := port_server_config_values[l_server_name].log_path + "\"
			l_colon_pos := l_log_file_path.index_of(':', 1)
			if l_colon_pos/=0
			then
				l_log_file_path := "\\" + l_server_name + l_log_file_path.substring(l_colon_pos + 1, l_log_file_path.count)
			end

			l_full_filename := l_log_file_path + "port_server_" + l_server_name + "*.log"
			create l_win32_find_data	-- Where results from find_first_file/find_next_file will go.
			create l_buffer.make(l_win32_find_data.record_length_)	-- Need buffer space for l_win32_find_data.
			l_buffer_area := l_buffer.area
			l_win32_find_data.set($l_buffer_area)	-- Collection must be 'off' from here on.
			l_any := l_full_filename.area

			l_handle := find_first_file($l_any, $l_buffer_area)		-- Get the first name.

			from
				l_result := 1
				l_log_file_name := ""
			until
				l_handle=invalid_handle_value or l_result=0
			loop
				l_win32_find_data.read
				if l_win32_find_data.filename>l_log_file_name
				then
					-- We want the one with the highest value (we want name_20060902_120102, not name_20060901_090102).
					l_log_file_name := l_win32_find_data.filename.twin
				end

				l_result := find_next_file(l_handle, $l_buffer_area)	-- Get the next name.
			end

			if l_collecting
			then
				collection_on
			end

			if l_log_file_name.count>0
			then
				l_log_file_name.prepend(l_log_file_path)
			end

			l_menu := Gui.factory.new_menu(["Contextual", [Void]])
			if l_log_file_name.count>0
			then
				gui.factory.add_menu_item(
					l_menu,
					["View log file (TextPad)", agent (global.env).launch("cmd /c start TEXTPAD -q " + l_log_file_name)],
					True)
				gui.factory.add_menu_item(
					l_menu,
					["View log file (Notepad)", agent (global.env).launch("NOTEPAD " + l_log_file_name)],
					True)
				gui.factory.add_menu_item(
					l_menu,
					["View log file (WordPad - file must be closed)", agent (global.env).launch("cmd /c start WORDPAD " + l_log_file_name)],
					True)
			else
				gui.factory.add_menu_item(
					l_menu,
					["Strange!  No log file was found.", Void],
					True)
			end

			gui.factory.add_menu_item(
				l_menu,
				["Explore the log file's folder", agent Global.explore(l_log_file_path)],
				True)

			gui.factory.add_menu_item(
				l_menu,
				["Kill all applications...", agent kill_all_apps(l_server_name)],
				allowed_to_kill_processes and then l_portnumber/=Void and then l_portnumber.is_integer and then l_portnumber.to_integer>0)

			if equal(environment_name, default_repository_name) and port_server_port_number(l_server_name)=2000
			then
				gui.factory.add_menu_item(
					l_menu,
					["Restart port_server service...", agent restart_port_server_service(l_server_name, "")],
					True)
			else
				gui.factory.add_menu_item(
					l_menu,
					["Restart port_server service (port_server_" + environment_name + ")...", agent restart_port_server_service(l_server_name, environment_name)],
					True)
			end

			gui.factory.add_menu_item(
				l_menu,
				["Attempt to reconnect", agent rescan_portserver(l_server_name, a_item.node)],
				not equal(l_status, "UP") and not equal(l_status, "?"))

			l_menu.show
		end
	end

	show_port_served_app_menu(
		a_tree_node: SERVER_REQUEST_TREE_NODE;
		a_x, a_y, a_button: INTEGER;
		a_item: RP_DATA_GRID_ITEM) is
	-- Shows the right-click menu for the 'port_served_apps_grid'.
	local
		l_menu: EV_MENU
		l_pos: INTEGER
		l_log_file_name: STRING
		l_log_file: ROSE_TEXT_FILE
		l_log_file_size_string: STRING
		l_folder_name: STRING
	do
		if a_button=3
		then
			a_item.parent.remove_selection
			a_item.parent.select_row(a_item.row.index)
			l_menu := Gui.factory.new_menu(["Contextual", [Void]])

			l_log_file_name := a_tree_node.server_request.log_file
			if l_log_file_name/=Void
			then
				l_pos := l_log_file_name.index_of(':', 1)
				if l_pos/=0
				then
					l_log_file_name :=
						l_log_file_name.substring(l_pos + 1, l_log_file_name.count)
				end

				if not l_log_file_name.has_substring("\\")
				then
					l_log_file_name := "\\" + a_tree_node.server_request.machine + l_log_file_name
				end

				l_folder_name := l_log_file_name.twin
				l_folder_name.replace_substring_all("/", "\")		-- Convert to Windows format.
				l_pos := l_folder_name.last_index_of('\', l_folder_name.count)
				if l_pos/=0
				then
					l_folder_name := l_folder_name.substring(1, l_pos - 1)
				end

				create l_log_file.make(l_log_file_name)
				l_log_file_size_string := integer_formatter.formatted(safe_file_size(l_log_file))

				gui.factory.add_menu_item(
					l_menu,
					["View log file (TextPad)", agent (global.env).launch("cmd /c start TEXTPAD -q " + l_log_file_name)],
					True)
				gui.factory.add_menu_item(
					l_menu,
					["View log file (Notepad)", agent (global.env).launch("NOTEPAD " + l_log_file_name)],
					True)
				gui.factory.add_menu_item(
					l_menu,
					["View log file (WordPad - file must be closed)", agent (global.env).launch("cmd /c start WORDPAD " + l_log_file_name)],
					True)
				gui.factory.add_menu_item(
					l_menu,
					["Explore the log file's folder", agent Global.explore(l_folder_name)],
					True)
				gui.factory.add_menu_item(
					l_menu,
					["(Log file size = " + l_log_file_size_string + " bytes)", agent do_nothing],
					True)
			end

			gui.factory.add_menu_item(
				l_menu,
				["Kill process...", agent kill_app(a_tree_node.server_request, True)],
				allowed_to_kill_processes and a_tree_node.server_request.terminated_by=Void)

			if a_tree_node.is_persistent
			then
				gui.factory.add_menu_item(
					l_menu,
					["Send custom monitor message...", agent send_custom_monitor_message(a_tree_node)],
					True)
			end

			if l_menu.count > 0 then
				l_menu.show
			end
		end
	end

	safe_file_size(a_log_file: FILE): INTEGER
	-- Safely find the size of the file.  Returns 0 if an error occurred.
	--
	-- In the past I would use "a_log_file.count".  In Windows Server 2012 this no longer works.  It seems that 'count'
	-- only returns the size as stored in the directory - which can trail behind the true size.  In previous versions of
	-- Windows, the size in the directory would be updated whenever the cache was flushed.  Not perfect, but often enough.
	-- In Server 2012, it doesn't happen until the file is closed.  A simple open/close returns quickly enough but it may
	-- be many seconds before the directory is updated.  Instead, I get the 'position' instead of the 'count'.
	local
		l_retry: BOOLEAN
	do
		if not l_retry
		then
			a_log_file.open_read
			a_log_file.finish
			Result := a_log_file.position
			a_log_file.close
		end
	rescue
		l_retry := True
		retry
	end

	send_custom_monitor_message(a_node: SERVER_REQUEST_TREE_NODE)
	-- Send any message that the user wants to send.
	require
		not_testing: not testing
	local
		l_answer: STRING
		l_response: ARRAY[ANY]
	do
		l_answer := gui.dialogs.ask_for_string(window, "", "Message: ", "")
		if l_answer/=Void and then l_answer.count>0
		then
			l_response := a_node.custom_monitor_response(<<l_answer>>)
		end
	end

	ask_for_blocker_log_file
	-- Ask the user where he wants to log blocker info to.
	-- Alternatively, if the file is closed if it is already open.
	local
		l_filename: STRING
	do
		if not log_blockers.is_selected
		then
			if blocker_log_file/=Void and then not blocker_log_file.is_closed
			then
				blocker_log_file.close
			end
		else
			l_filename := gui.dialogs.select_save_file(window, Void, Void)
			if l_filename/=Void
			then
				if blocker_log_file/=Void and then not blocker_log_file.is_closed
				then
					blocker_log_file.close
				else
					create blocker_log_file.make_open_write(l_filename)
				end
			else
				log_blockers.select_actions.block
				log_blockers.disable_select
				log_blockers.select_actions.resume
			end
		end
	end

	refresh_port_served_apps is
	-- Refreshes the 'port_served_apps_grid'.
	local
		l_sysprocesses: ROSE_LINEAR_ARRAY[SQL_SERVER_SYSPROCESS]
		l_server_request: SERVER_REQUEST
		l_server_status_message: SERVER_STATUS_MESSAGE
		l_tree_node: SERVER_REQUEST_TREE_NODE
		l_filter_table: HASH_TABLE[BOOLEAN, STRING]
		l_selected_items: ARRAYED_LIST[RP_GRID_NODE[ANY]]
		l_virt_x_pos: INTEGER
		l_virt_y_pos: INTEGER
--		l_even: BOOLEAN
	do
		l_virt_x_pos := port_served_apps_grid.virtual_x_position
		l_virt_y_pos := port_served_apps_grid.virtual_y_position
		port_served_apps_grid.remove_all_nodes
		update_time
		action_text.set_text("   Displaying port served applications")
		Gui.process_events
		l_selected_items := port_server_status_grid.selected_nodes
		if l_selected_items.count/=0
		then
			create l_filter_table.make(l_selected_items.count)
			from
				l_selected_items.start
			until
				l_selected_items.off
			loop
				check attached {RP_DATA_GRID_LABEL_ITEM} l_selected_items.item.i_th(1) as al_label_item
				then
					l_filter_table.put(True, al_label_item.text.as_upper)
				end

				l_selected_items.forth
			end
		end

		from
			server_requests.start
		until
			server_requests.off
		loop
			l_server_request := server_requests.current_item
			if l_server_request.terminated_by=Void or show_all_server_requests.is_selected
			then
				if l_filter_table=Void or else l_filter_table.has(l_server_request.machine.as_upper)
				then
					l_sysprocesses := all_sysprocesses.item(l_server_request.machine + l_server_request.server_pid.out)
					if l_sysprocesses=Void
					then
						create l_sysprocesses.make_empty
					end

--					action_text.set_text("   Getting status for " + l_server_request.debug_output)
--					Gui.process_events				-- Too slow!
					l_server_status_message := get_status_message(l_server_request)
					create l_tree_node.make(
						l_server_request,
						l_sysprocesses,
						l_server_status_message,
						window,
--						agent show_blocker_detail_from_leaf,
--						agent show_blocker_detail_by_id,
						agent show_sysprocesses_menu(?, ?, ?, ?, ?),
						agent refresh_selected_sysprocesses(port_served_apps_grid))
					l_tree_node.pointer_button_press_actions.extend(agent show_port_served_app_menu(l_tree_node, ?, ?, ?, ?))
--					if l_even
--					then
--						l_tree_node.set_background_color(even_background_color)
--					else
--						l_tree_node.set_background_color(odd_background_color)
--					end

--					l_even := not l_even
					port_served_apps_grid.extend(l_tree_node)
				end
			else
				-- No live sessions but there have been some recently.
				poke_port_server(l_server_request.machine, False)
			end

--			Gui.process_events
			server_requests.forth
		end

		refresh_psa_count
		port_served_apps_grid.header_node.filter_from_filter_node
		if port_served_apps_grid.sort_states.count/=0
		then
			port_served_apps_grid.sort
		end

		port_served_apps_grid.set_virtual_position(
			l_virt_x_pos.min(port_served_apps_grid.maximum_virtual_x_position),
			l_virt_y_pos.min(port_served_apps_grid.maximum_virtual_y_position))
		action_text.set_text("")
		Gui.process_events
		if port_served_apps_grid.row_count/=0
		then
			gui.ev_application.do_once_on_idle(agent check_for_empty_psa_rows(1))
		end
	end

	refresh_psa_count
	-- Shows how many rows are in 'port_served_apps_grid'.
	local
		l_text: STRING
	do
		if environment_name=Void
		then
			environment_name := "Void"
		end

		l_text := "Port served applications - "
		if port_served_apps_grid.row_count=0
		then
			if port_server_status_grid.selected_nodes.count/=0
			then
				l_text.append("filtered - ")
			end
		else
			if port_server_status_grid.selected_nodes.count/=0
			then
				l_text.append("filtered - ")
			end

			l_text.append(port_served_apps_grid.row_count.out + " - ")
		end

		l_text.append(environment_name + " (click to change)")
		port_served_apps_frame.set_text(l_text)
	end

	check_for_empty_psa_rows(a_row_index: INTEGER) is
	-- Called 'on_idle' to determine if a node in 'port_served_apps_grid' is expandable.
	local
		l_fast: BOOLEAN
		l_process_timer: ROSE_PROCESS_TIMER
	do
		if a_row_index<=port_served_apps_grid.row_count
		then
			create l_process_timer
			check attached {SERVER_REQUEST_TREE_NODE} port_served_apps_grid.row(a_row_index) as al_tree_node
			then
				if al_tree_node.server_request.terminated_at/=Void
				then
					al_tree_node.ensure_non_expandable
					l_fast := True
				else
					if al_tree_node.parent_row=Void
					then
						if al_tree_node.child_nodes(Void, Void)=Void
						then
							al_tree_node.ensure_non_expandable
						end

						l_process_timer.interrupt			-- 'elapsed' gets set here.
					end
				end
			end

			if l_fast or l_process_timer.elapsed=0
			then
				check_for_empty_psa_rows(a_row_index + 1)
			else
				gui.ev_application.do_once_on_idle(agent check_for_empty_psa_rows(a_row_index + 1))
			end
		else
			do_nothing
		end
	end

	check_for_empty_disk_usage_rows(a_row_index: INTEGER) is
	-- Called 'on_idle' to remove any disk usage rows that don't have any children.
	do
		if a_row_index<=disk_usage_grid.row_count
		then
			check attached {RP_GRID_NODE[ANY]} disk_usage_grid.row(a_row_index) as al_tree_node
			then
				if al_tree_node.parent_row=Void
				then
					check attached {FUNCTION[ANY, TUPLE, RP_TITLED_NODES[ANY]]} al_tree_node.data as al_agent
					then
						-- 'al_agent' points to 'disk_usage_expand_agent'.
						if al_agent.item(Void) = Void		-- Calling 'item' calls 'disk_usage_expand_agent'.
						then
							al_tree_node.hide
						end
					end
				end
			end

			gui.ev_application.do_once_on_idle(agent check_for_empty_disk_usage_rows(a_row_index + 1))
		else
			do_nothing
		end
	end

	kill_spid(a_sysprocess: SQL_SERVER_SYSPROCESS) is
	-- Pops up a dialog asking the user if he wants to kill an SPID.
	require
		not_testing: not testing
	do
		if gui.Dialogs.answer(
			window, "", " ", "Really kill SQL/Server process id " + a_sysprocess.spid.out + "?", Void)
		then
			a_sysprocess.sysprocesses.server.sql_execute_immediate("kill " + a_sysprocess.spid.out)
		end
	end

	restart_port_server_service(a_server_name, a_suffix: STRING)
	-- Attempts to talk the the SCM on the remote machine and asks it to stop and then restart the port server.
	require
		not_testing: not testing
	local
		l_sc_handle: INTEGER
		l_service_handle: INTEGER
		l_service_name: STRING
		l_any: ANY
		l_success: BOOLEAN
		l_service_status: MANAGED_POINTER
	do
		l_any := a_server_name.to_c
		gui.start_wait_msg("Contacting the SCM on "  + a_server_name + ".")

		-- Do NOT ask permission for START/STOP at this point - you will be denied.  Apparently, that would be a request
		-- for the START/STOP permission on ALL services.  We will request that permission for port_server only later
		-- during 'open_service'.
		l_sc_handle := open_service_control_manager($l_any, default_pointer, SC_MANAGER_CONNECT)
		gui.end_wait_msg(Void)
		if l_sc_handle=0
		then
			gui.Dialogs.inform(window, " ", "Could not talk to the service control manager much less the service. Error = $1.", <<getlasterror>>)
		else
			if a_suffix/=Void and then a_suffix.count>0
			then
				l_service_name := "port_server_" + a_suffix
			else
				l_service_name := "port_server"
			end

			l_service_name := gui.dialogs.ask_for_string(window, "Service name", "Enter the service name", l_service_name)
			if l_service_name/=Void
			then
				if l_service_name ~ "port_server_parallel_test"
				then
					-- Parallel test is messed up.
					if gui.dialogs.answer(window, Void, Void, "Do you really mean port_server_test_parallel_DailyCycle_RC?", Void)
					then
						l_service_name := "port_server_test_parallel_DailyCycle_RC"
					end
				end

				l_any := l_service_name.to_c
				l_service_handle := open_service(l_sc_handle, $l_any, service_start | service_stop)
				if l_service_handle/=0
				then
					gui.start_wait_msg("Stopping the port_server on "  + a_server_name + ".")
					create l_service_status.make(sizeof_service_status)
					gui.end_wait_msg(Void)
					l_success := control_service(l_service_handle, service_control_stop, l_service_status.item)
					if not l_success
					then
						gui.Dialogs.inform(window, " ", "Could not stop the service.  Error = $1.  Will now try to start it.", <<getlasterror>>)
					end

					gui.start_wait_msg("Starting the port_server on "  + a_server_name + ".")
					l_success := start_service(l_service_handle, 0, default_pointer)
					gui.end_wait_msg(Void)
					if not l_success
					then
						gui.Dialogs.inform(window, " ", "Could not start the service.  Error = $1.", <<getlasterror>>)
					end

					close_service_handle(l_service_handle)
				else
					gui.Dialogs.inform(window, " ", "Could not open the service.  Error = $1.", <<getlasterror>>)
				end

				close_service_handle(l_sc_handle)
			end
		end
	end

	kill_all_apps(a_server_name: STRING) is
	-- Pops up a dialog and asks the user if he wants to kill all apps on a port server.  If yes,
	-- a message is sent to the port server.
	require
		not_testing: not testing
	local
		l_server_request: SERVER_REQUEST
		i: INTEGER
	do
		if gui.Dialogs.answer(window, "", " ", "Really kill all apps under " + a_server_name + "? (timeout=" + timeout_for_kill.out + ")", Void)
		then
			partner_timeout := timeout_for_kill

			from
				i := 1
			until
				i>port_served_apps_grid.row_count
			loop
				if attached {SERVER_REQUEST_TREE_NODE} port_served_apps_grid.row(i) as l_tree_node
				then
					l_server_request := l_tree_node.server_request
					if equal(l_server_request.machine, a_server_name)
					then
						kill_app(l_server_request, False)
					end
				end

				i := i + 1
			end

			partner_timeout := default_partner_timeout
		end
	end

	kill_app(a_server_request: SERVER_REQUEST; a_ask_first: BOOLEAN) is
	-- Pops up a dialog and asks the user if he wants to kill one app on a port server.  If yes,
	-- a message is sent to the port server.
	require
		not_testing: not testing
	local
		l_response: SERVER_STATUS_MESSAGE
	do
		if not a_ask_first or else gui.Dialogs.answer(
			window, "", " ", "Really kill process " + a_server_request.server_pid.out + "? (timeout=" + timeout_for_kill.out + ")", Void)
		then
			partner_timeout := timeout_for_kill
			l_response := send_command_to_port_server(a_server_request, "kill", False)
			partner_timeout := default_partner_timeout
			if l_response.server_pid=0
			then
				gui.Dialogs.inform(window, " ", "Failed to send the request to the port_server", Void)
			else
				gui.Dialogs.inform(window, " ", "The request was sent to the port_server", Void)
			end
		end
	end

	poke_port_server(a_machine: STRING; a_force_the_test: BOOLEAN) is
	-- Pokes the port server too see if it is alive.  Relies on a side effect in 'send_command_to_port_server'.
	local
		l_server_request: SERVER_REQUEST
		l_server_status_message: SERVER_STATUS_MESSAGE
	do
		create l_server_request	-- Sets the 'server_pid' to 0.
		if a_force_the_test
		then
			l_server_request.set_server_pid(-1)			-- Indicates that we want the test to 'really' be performed.
		end

		l_server_request.set_machine(a_machine)
		l_server_status_message := send_command_to_port_server(l_server_request, "", False)
	end

	get_status_message(a_server_request: SERVER_REQUEST): SERVER_STATUS_MESSAGE
	-- Sends 'a_server_request' to a port server with a blank command and returns the reponse.
	-- The response includes run-time information like cpu time.
	do
		Result := send_command_to_port_server(a_server_request, "", True)
	end

	send_command_to_port_server(
		a_server_request: SERVER_REQUEST;
		a_command: STRING;
		a_want_result: BOOLEAN): SERVER_STATUS_MESSAGE is
	-- Sends 'a_server_request' to a port server and returns the reponse (if requested).
	local
		l_socket: NETWORK_STREAM_SOCKET
		l_server_status_message: SERVER_STATUS_MESSAGE
		l_retry_failed: BOOLEAN
		l_collecting: BOOLEAN
		l_found: BOOLEAN
		l_down: BOOLEAN
		l_error_string: STRING
		l_error_string2: STRING
		i: INTEGER
		l_exe_name: STRING
		l_pos: INTEGER
		l_retries: INTEGER
		l_exceptions: EXCEPTIONS
		l_port_server_port_number: INTEGER
	do
		create Result
		l_collecting := collecting
		if not l_retry_failed
		then
			from
				i := 1
			until
				i>port_server_status_grid.row_count or l_found
			loop
				check attached {RP_DATA_GRID_LABEL_ITEM} port_server_status_grid.row(i).i_th(1) as al_label_item
				then
					if al_label_item.text.is_equal(a_server_request.machine)
					then
						l_found := True
						l_down := port_server_status_grid.row(i).data/=Void
					else
						i := i + 1
					end
				end
			end

			if not l_down and
			   (a_server_request.server_pid/=0 or not l_found or a_server_request.server_pid=-1)
			then
				l_port_server_port_number := port_server_port_number(a_server_request.machine)
				if l_port_server_port_number<=0
				then
					update_port_server_status(a_server_request.machine, "?", False)
				else
					-- If the 'server_pid=0 then this is just a test to see if we can talk to the portserver.
					-- But don't bother if the portserver already exists (l_found) in 'port_server_status'.
					-- But definitely bother if 'server_pid'=-1, that means "yes, it was found - do it anyway".
					create l_socket.make_client_by_port(l_port_server_port_number, a_server_request.machine)
					l_socket.set_timeout(partner_timeout)	-- This is for 'select()'.  Useless for the 'connect' that is coming.

					-- SO_RCV_TIMEOUT is only for receives, not 'connect'.  To 'connect' with a timeout you
					-- will have to do weird stuff with non-blocking sockets, select and or other timers.  The default
					-- timeout is something like: wait 3 seconds, double the timeout and try again, repeat 'n' times.  See
					-- http://www.codeguru.com/forum/showthread.php?t=312668
					-- My machine takes 22 seconds to timeout - ouch!
					c_set_sock_opt_int(l_socket.descriptor, level_sol_socket, so_rcv_timeo, partner_timeout * 1000)

					l_socket.connect
					if l_socket.is_open_read
					then
						update_port_server_status(a_server_request.machine, "UP", True)
						create l_server_status_message
						l_server_status_message.set_server_pid(a_server_request.server_pid)
						if equal(a_command, "kill")
						then
							l_exe_name := a_server_request.server_executable
							if l_exe_name/=Void
							then
								l_exe_name := l_exe_name.twin			-- This disconnects us from 'a_server_request.server_executable'.
								l_pos := l_exe_name.index_of(' ', 1)	-- Find the position of the first space (divides exe name from folder).
								if l_pos/=0
								then
									l_exe_name := l_exe_name.substring(1, l_pos)
								end

								l_server_status_message.set_executable(l_exe_name)
							end

							l_server_status_message.set_port(a_server_request.port)
						end

						l_server_status_message.set_user_id(Global.app.user.login_id)
						l_server_status_message.set_command_line(a_command)
--l_socket.close		-- Useful for testing socket failures.
						l_socket.independent_store(l_server_status_message)
						if a_want_result
						then
							if attached {SERVER_STATUS_MESSAGE} l_socket.retrieved as al_result and then al_result.user_time /= Void
							then
								Result := al_result
							else
								-- Sometimes we get a Result with user_time (and everything) Void.
								-- Probably the PID doesn't exist.
								-- Set Result to everything 0.
								create Result.make_failed
							end
						else
							create Result
							Result.set_server_pid(a_server_request.server_pid)	-- Indicates some kind of success.
						end

						l_socket.close
					else
						update_port_server_status(a_server_request.machine, "DOWN", False)
						create Result.make_failed
					end
				end
			end
		else
			if l_error_string=Void or else l_error_string.count=0
			then
				l_error_string2 := "BAD DATA?"
			else
				l_error_string2 := l_error_string
			end

			l_error_string := Void
			update_port_server_status(a_server_request.machine, l_error_string2, False)
			create Result.make_failed
		end
	rescue
		if l_collecting
		then
			collection_on
		else
			collection_off
		end

		create l_exceptions
		if l_retries<5
		then
			l_retries := l_retries + 1
			if equal(global.user.user.login_id, "RJ") or
			   global.env.get("SHOW_SOCKET_ERRORS")/=Void
			then
				print(Global.interpreted("($now) "))
				print(a_server_request.machine + "/" + a_server_request.server_pid.out + "/" + a_command + "%N")
				print("WSAGetLastError = " + WSAGetLastError.out + "%N")
				WSASetLastError(0)	-- Clear the last error.
				print(l_exceptions.exception.out + "%T" + l_exceptions.meaning(l_exceptions.exception))
				if l_exceptions.tag_name/=Void and then l_exceptions.tag_name.count>0
				then
					print("%T" + l_exceptions.tag_name)
				end
				print("%N")
			end

			l_socket.close
			global.env.sleep(1000)	-- Sleep 1 second.
			retry
		end

		if l_socket/=Void and then not l_socket.is_closed
		then
			l_socket.close
		end

		l_error_string := ((create {EXCEPTIONS}).tag_name).twin
		if l_error_string=Void or else l_error_string.count=0
		then
			l_error_string := ((create {EXCEPTIONS}).meaning(l_exceptions.exception)).twin
		end

		l_retry_failed := True
		retry
	end

	refresh_blockees(a_blocker_process: SQL_SERVER_SYSPROCESS; a_log_only_prefix: STRING)
	-- Refreshes the blockee grid or, if 'a_log_only_prefix' is not Void, logs to the console.
	local
		l_blockee: SQL_SERVER_SYSPROCESS
		l_processes: ROSE_LINEAR_ARRAY[SQL_SERVER_SYSPROCESS]
		l_saved_index: INTEGER
		l_log_only: BOOLEAN
		l_log_only_prefix: STRING
		i: INTEGER
	do
		l_log_only := a_log_only_prefix/=Void
		if l_log_only
		then
			from
				l_log_only_prefix := a_log_only_prefix.twin
				i := 1
			until
				i>l_log_only_prefix.count
			loop
				if l_log_only_prefix[i]/='%T'
				then
--					l_log_only_prefix[i] := ' '		-- This crashes in 14.11 and earlier.
					l_log_only_prefix.put(' ', i)
				end

				i := i + 1
			end
		else
			blockees_frame.show
			update_time
			action_text.set_text("   Finding blockees")
			Gui.process_events
		end

		create l_processes.make_empty
		l_saved_index := Data_servers.index

		from
			data_servers.start
		until
			data_servers.off
		loop
			if data_servers.current_item.name /~ k_none
			then
				if data_servers.current_item.connected
				then
					if equal(Data_servers.current_item.name, a_blocker_process.sysprocesses.name)
				    then
--						It takes too long to refresh the server, so I commented it out.
--						data_servers.current_item.refresh
--						if data_servers.current_item.success
--						then
--							update_data_server_status_grid(data_servers.current_item.name, "UP")
							l_processes.append_array(data_servers.current_item.blockees(a_blocker_process.spid))
--						else
--							update_data_server_status_grid(data_servers.current_item.name, "Could not refresh")
--						end
					end
				else
					if not l_log_only
					then
						update_data_server_status_grid(data_servers.current_item.name, "Disconnected")
					end
				end
			end

			if not l_log_only
			then
				Gui.process_events
			end

			data_servers.forth
		end

		data_servers.go_i_th(l_saved_index)

		if l_log_only
		then
			from
				l_processes.start
			until
				l_processes.off
			loop
				l_blockee := l_processes.current_item
				blocker_log_file.put_string(
					l_log_only_prefix +
					l_blockee.spid.out + "%T" +
					l_blockee.hostname_or_void + "/" + l_blockee.hostprocess_or_void + "%T" +
					(l_blockee.waittime / 1000).truncated_to_integer.out + "%T%T" +
					l_blockee.loginame + "%T" +
					l_blockee.program_name + "%N")

				l_processes.forth
			end
		else
			refresh_sysprocess_list(l_processes, blockees_grid)
			action_text.set_text("")
			Gui.process_events
		end
	end

	update_data_server_status_grid(a_server_name, a_status_message: STRING) is
	-- Updates the 'data_server_status_grid'.
	local
		l_found: BOOLEAN
		l_row: RP_GRID_NODE[SQL_SERVER_SYSPROCESSES]
		i: INTEGER
	do
		from
			i := 1
		until
			i>data_server_status_grid.row_count or l_found
		loop
			if attached {RP_DATA_GRID_LABEL_ITEM} data_server_status_grid.row(i).i_th(1) as al_label_item1 and then
			   al_label_item1.text ~ a_server_name
			then
				l_found := True

				check attached {RP_DATA_GRID_LABEL_ITEM} data_server_status_grid.row(i).i_th(2) as al_label_item2
				then
					al_label_item2.set_text(a_status_message)
					al_label_item2.set_comparable(a_status_message)
				end
			else
				i := i + 1
			end
		end

		if not l_found
		then
			create l_row.make_from_array(
				<<
				create {ROSE_LIST_ITEM}.make_text(a_server_name),
				create {ROSE_LIST_ITEM}.make_text(a_status_message)
				>>)
			l_row.pointer_button_press_actions.extend(agent show_data_server_status_menu)
			data_server_status_grid.extend(l_row)
			if data_server_status_grid.sort_states.count/=0
			then
				data_server_status_grid.title_grid.sort		-- Calling 'sort' on the title forces calls to 'data_server_sort_started_agent' and 'data_server_sort_ended_agent'.
			end
		end
	end

	update_port_server_status(a_server_name, a_status_message: STRING; a_connected: BOOLEAN)
	-- Updates the 'port_server_status_grid'.
	local
		l_found: BOOLEAN
		l_row: RP_GRID_NODE[ANY]
		l_other_row: RP_GRID_NODE[ANY]
		l_server_name: STRING
		l_dot_pos: INTEGER
		l_machine_name: STRING
		l_label_item: RP_DATA_GRID_LABEL_ITEM
		i: INTEGER
	do
		l_server_name := a_server_name.as_upper

		l_machine_name := l_server_name.as_upper
		l_dot_pos := l_machine_name.index_of('.', 1)
		if l_dot_pos/=0
		then
			l_machine_name := l_machine_name.substring(1, l_dot_pos - 1)
		end

		l_other_row := remove_from_other_names(l_machine_name)

		from
			i := 1
		until
			i>port_server_status_grid.row_count or l_found
		loop
			check attached {RP_DATA_GRID_LABEL_ITEM} port_server_status_grid.row(i).i_th(1) as al_label_item
			then
				l_label_item := al_label_item
			end

			if l_label_item.text ~ l_machine_name
			then
				l_found := True
				if not a_connected
				then
					-- Set a flag to indicate that this node is down.  If at some later date
					-- we need a real object here, then move the flag into the object.
					port_server_status_grid.row(i).set_data("")
				end

				check attached {RP_DATA_GRID_LABEL_ITEM} port_server_status_grid.row(i).i_th(2) as al_label_item
				then
					al_label_item.set_text(a_status_message)
					al_label_item.set_comparable(a_status_message)
				end
			else
				i := i + 1
			end
		end

		if not l_found
		then
			create l_label_item.make_with_text(port_server_port_number(a_server_name).out)
			l_label_item.align_text_right
			create l_row.make_expandable_from_array(<<l_machine_name, a_status_message, l_label_item>>, Void)
			if l_other_row/=Void
			then
				l_row.set_background_color(l_other_row.i_th(1).background_color)
			end

			l_row.pointer_button_press_actions.extend(agent show_port_server_status_menu)
			if not a_connected
			then
				-- Set a flag to indicate that this node is down.  If at some later date
				-- we need a real object here then move the flag into the object.
				l_row.set_data("")
			end

			port_server_status_grid.extend(l_row)
			if port_server_status_grid.sort_states.count/=0
			then
				port_server_status_grid.sort
			end
		end
	end

	refresh_sysprocess_list(a_sysprocesses: ROSE_LINEAR_ARRAY[SQL_SERVER_SYSPROCESS]; a_grid: RP_DATA_GRID[SQL_SERVER_SYSPROCESS]) is
	-- Refreshes 'a_grid' with 'a_sysprocesses'.
	local
		l_row: RP_GRID_NODE[SQL_SERVER_SYSPROCESS]
		l_color: EV_COLOR
	do
		a_grid.remove_all_nodes
		if a_grid=blockers_grid
		then
			found_interesting_blocker := False
		end

		from
			a_sysprocesses.start
		until
			a_sysprocesses.off
		loop
--			Gui.process_events				-- This is really slow!
			if a_grid=blockers_grid
			then
				if a_sysprocesses.current_item.is_interesting_blocker
				then
					l_color := Void
					found_interesting_blocker := True
				else
					l_color := uninteresting_blocker_color
				end
			else
				l_color := Void
			end

			l_row := sysprocess_to_grid_row(a_sysprocesses.current_item, a_grid, l_color)
			a_grid.extend(l_row)
			a_sysprocesses.forth
		end

		a_grid.header_node.filter_from_filter_node
		if a_grid.sort_states.count/=0
		then
			a_grid.sort
		end

		if a_grid=sysprocesses_grid
		then
			refresh_sysprocesses_count
		end
	end

	refresh_sysprocesses_count
	-- Shows how many rows are in 'sysprocesses_grid'.
	do
		if sysprocesses_grid.row_count/=0
		then
			if data_server_status_grid.selected_items.count=0
			then
				notebook.set_item_text(sysprocesses_grid, "Sysprocesses - " + sysprocesses_grid.row_count.out)
			else
				notebook.set_item_text(sysprocesses_grid, "Sysprocesses - filtered - " + sysprocesses_grid.row_count.out)
			end
		end
	end

	sysprocess_to_grid_row(a_sysprocess: SQL_SERVER_SYSPROCESS; a_grid: RP_DATA_GRID[SQL_SERVER_SYSPROCESS]; a_dbid_color: EV_COLOR): RP_GRID_NODE[SQL_SERVER_SYSPROCESS]
	-- Return an RP_GRID_NODE from 'a_sysprocesses' suitable for display in 'a_grid'.
	local
		l_strings: ROSE_LINEAR_ARRAY[TUPLE[text: STRING; comparable: COMPARABLE]]
		l_string: STRING
		l_item: RP_DATA_GRID_LABEL_ITEM
		l_items: ARRAY[RP_DATA_GRID_LABEL_ITEM]
	do
		l_strings := a_sysprocess.string_array
		create l_items.make(1, l_strings.count)

		from
			l_strings.start
		until
			l_strings.off
		loop
			l_string := l_strings.current_item.text.twin
			create l_item.make_with_text(l_string)
			if l_strings.index=2
			then
				l_item.set_foreground_color(a_dbid_color)
			end

			if l_strings.current_item.comparable = Void
			then
				l_item.set_comparable(l_strings.current_item.text.as_upper)
			else
				l_item.set_comparable(l_strings.current_item.comparable)
			end

			inspect l_strings.index
			when 6, 8, 9, 10, 15, 16, 17, 18, 19, 20, 22, 27, 28
			then
				l_item.align_text_right
			else
			end

			l_items.put(l_item, l_strings.index)

			l_strings.forth
		end

		create Result.make_expandable_from_array(l_items, Void)
		Result.set_data(a_sysprocess)
		Result.pointer_button_press_actions.extend(agent show_sysprocesses_menu(a_sysprocess, ?, ?, ?, ?))
		Result.pointer_double_press_actions.extend(agent refresh_selected_sysprocesses_from_doubleclick2(a_grid, ?, ?, ?, ?))
	end

	may_show_perf_graphs_dummy2(a_dummy: EV_GRID_ROW) is
	-- Version 2 of 'may_show_perf_graphs' (differenent signature).
	do
		may_show_perf_graphs
	end

	may_show_perf_graphs is
	-- Called when you may need to redraw a graph.  We don't actually call the redraw here, we let 'refresh' do it
	-- at the next idle time.
	do
		if data_server_status_grid.selected_items.count=0
		then
			blockers_frame.set_text("Blockers")
			blockees_frame.set_text("Blockees")
			notebook.set_item_text(open_transactions_grid, "Open Transactions")
		else
			blockers_frame.set_text("Blockers - filtered")
			blockees_frame.set_text("Blockees - filtered")
			notebook.set_item_text(open_transactions_grid, "Open Transactions - filtered")
		end

		refresh_sysprocesses_count
		refresh_psa_count

		if not refresh_once_in_progress
		then
			-- If I remember correctly, both the select and unselect action were causing a redraw.
			-- Now, the first one sets the 'do_once_on_idle' and the second one does nothing.
			refresh_once_in_progress := True
			gui.ev_application.do_once_on_idle(agent refresh_once)
		end

--		refresh
--		if notebook.selected_item=perf_vbox
--		then
--			show_perf_graphs
--		end
	end

	refresh_once is
	-- An agent that is used to call 'refresh' only one time.
	do
		refresh
		refresh_once_in_progress := False
	end

	notebook_selected_agent is
	-- Called when the user selects a tab of our notebook.
	do
		if notebook.selected_item=sysprocesses_grid
		then
			refresh
		elseif notebook.selected_item=perf_vbox
		then
			show_perf_graphs
		elseif notebook.selected_item=open_transactions_grid
		then
			show_open_transactions
		elseif notebook.selected_item=disk_usage_grid
		then
			show_disk_usage
		elseif notebook.selected_item=error_message_pane
		then
			show_error_message_pane
		else
			refresh
		end
	end

	show_error_message_pane
	-- Refreshes the 'error_message_pane'.
	do
		error_message_pane.set_text(gui.console.output_box.text)
		error_message_pane.scroll_to_end
	end

	show_disk_usage is
	-- Refreshes the 'disk_usage_grid'.
	local
		i: INTEGER
		l_sysprocesses: SQL_SERVER_SYSPROCESSES
		l_parent_row: RP_GRID_NODE[ANY]
		l_row: ROSE_LINEAR_ARRAY[RP_DATA_GRID_LABEL_ITEM]
		l_item: RP_DATA_GRID_LABEL_ITEM
		l_disk_usage: TUPLE[drive_letter: STRING; free_space: DOUBLE; notes: STRING]
		l_disk_usages: ROSE_LINEAR_ARRAY[TUPLE[drive_letter: STRING; free_space: DOUBLE; notes: STRING]]
		l_string: STRING
	do
		Gui.start_busy_wait
		update_time
		action_text.set_text("   Finding disk usage")
		Gui.process_events

		disk_usage_grid.remove_all_nodes

		from
			i := 1
		until
			i>data_server_status_grid.row_count
		loop
			l_sysprocesses := data_server_status_grid.row(i).data
			if l_sysprocesses.connected
			then
				if l_sysprocesses.success
				then
					l_disk_usages := l_sysprocesses.disk_usages
					from
						l_disk_usages.start
					until
						l_disk_usages.off
					loop
						create l_row.make(1, 4)
						l_disk_usage := l_disk_usages.current_item

						create l_item.make_with_text(l_sysprocesses.name)
						l_string := l_sysprocesses.name.twin
						l_item.set_comparable(l_string.as_upper)
						l_row.put(l_item, 1)

						create l_item.make_with_text(l_disk_usage.drive_letter)
						l_row.put(l_item, 2)

						create l_item.make_with_text(format_digits_past_decimal(l_disk_usage.free_space, 3))
						l_item.align_text_right
						l_item.set_comparable(l_disk_usage.free_space)
						l_row.put(l_item, 3)

						create l_item.make_with_text(l_disk_usage.notes)
						l_row.put(l_item, 4)

						-- Make a new parent row and put it into the grid.
						create l_parent_row.make_from_array(l_row)
						disk_usage_grid.extend(l_parent_row)
						l_parent_row.        set_data(agent disk_usage_expand_agent(l_sysprocesses, l_parent_row, l_disk_usage.drive_letter))
						l_parent_row.set_expand_agent(agent disk_usage_expand_agent(l_sysprocesses, l_parent_row, l_disk_usage.drive_letter))

						l_disk_usages.forth
					end
				end
			end

			i := i + 1
		end

		if disk_usage_grid.sort_states.count/=0
		then
			disk_usage_grid.sort
		end

		action_text.set_text("")
		gui.end_wait
		Gui.process_events
--		gui.ev_application.do_once_on_idle(agent check_for_empty_disk_usage_rows(1))
		check_for_empty_disk_usage_rows(1)
	end

	disk_usage_flattened: ARRAY2[STRING] is
	-- Creates an ARRAY2 reformatted and suitable for Excel.
	local
		i: INTEGER
		l_db_usages: ROSE_LINEAR_ARRAY[TUPLE[dbname: STRING; size: DOUBLE; filename: STRING; unused_space: DOUBLE]]
	do
		create Result.make(0, 4)
		Result.force("Server", 1, 1)
		Result.force("Database", 1, 2)
		Result.force("Filename", 1, 3)
		Result.force("Size (GB)", 1, 4)
		i := 1

		from
			data_servers.start
		until
			data_servers.off
		loop
			if data_servers.current_item.connected
			then
				from
					l_db_usages := data_servers.current_item.db_usages
					l_db_usages.start
				until
					l_db_usages.off
				loop
					i := i + 1
					Result.force(data_servers.current_item.name, i, 1)
					Result.force(l_db_usages.current_item.dbname, i, 2)
					Result.force(l_db_usages.current_item.filename, i, 3)
					Result.force(l_db_usages.current_item.size.out, i, 4)
					l_db_usages.forth
				end
			end

			data_servers.forth
		end
	end

	disk_usage_expand_agent(
		a_sysprocesses: SQL_SERVER_SYSPROCESSES;
		a_parent_row: RP_GRID_NODE[ANY];
		a_drive_letter: STRING): RP_TITLED_NODES[ANY]
	-- Called when someone expands a Disk Usage row.
	local
		l_titles: RP_GRID_TITLE_NODE[ANY]
		l_node: RP_GRID_NODE[ANY]
		l_nodes: ROSE_LINEAR_ARRAY[RP_GRID_NODE[ANY]]
		l_label_item: RP_DATA_GRID_LABEL_ITEM
		l_label_items: ROSE_LINEAR_ARRAY[RP_DATA_GRID_LABEL_ITEM]
		l_db_usages_for_db: ROSE_LINEAR_ARRAY[TUPLE[dbname: STRING; size: DOUBLE; filename: STRING; unused_space: DOUBLE]]
		l_db_usages: ROSE_LINEAR_ARRAY[TUPLE[dbname: STRING; size: DOUBLE; filename: STRING; unused_space: DOUBLE]]
		l_db_usage: TUPLE[dbname: STRING; size: DOUBLE; filename: STRING; unused_space: DOUBLE]
		l_dbname: STRING
		l_total_size: DOUBLE
		l_tempdb_found: BOOLEAN
		l_non_tempdb_found: BOOLEAN
		l_cursor_is_busy: BOOLEAN
	do
		create l_nodes.make_empty
		l_dbname := ""

		if a_sysprocesses.db_usages_saved=Void
		then
			Gui.start_busy_wait
			action_text.set_text("   Finding disk usage for " + a_sysprocesses.name)
			Gui.process_events
			l_cursor_is_busy := True
		end

		l_db_usages := a_sysprocesses.db_usages

		if l_cursor_is_busy
		then
			action_text.set_text("")
			gui.end_wait
			Gui.process_events
		end

		create l_db_usages_for_db.make_empty
		l_dbname := ""
		l_total_size := 0

		from
			l_db_usages.start
		until
			l_db_usages.off
		loop
			l_db_usage := l_db_usages.current_item

			if l_db_usage.filename.as_upper.starts_with(a_drive_letter.as_upper)
			then
				l_dbname := l_db_usage.dbname.twin
				l_total_size := l_total_size + l_db_usage.size
				l_tempdb_found := l_tempdb_found or l_db_usage.dbname.is_case_insensitive_equal("tempdb")
				l_non_tempdb_found := l_non_tempdb_found or not l_db_usage.dbname.is_case_insensitive_equal("tempdb")
				l_db_usages_for_db.extend(l_db_usage)

				if (l_db_usages.index=l_db_usages.upper or else
					(not equal(l_dbname, l_db_usages.next_item.dbname) or
					 not l_db_usages.next_item.filename.as_upper.starts_with(a_drive_letter.as_upper))) and
				   l_db_usage.filename.as_upper.starts_with(a_drive_letter.as_upper)
				then
					-- We get here when the db name changes or on the last row.
					if l_dbname.count>0		-- l_dbname is "" on the first pass.
					then
						create l_label_items.make(1, 2)

						-- dbname
						create l_label_item.make_with_text(l_dbname)
						l_label_item.set_comparable(l_dbname.as_upper)
						l_label_items.put(l_label_item, 1)

						-- total size
						create l_label_item.make_with_text(format_digits_past_decimal(l_total_size, 3))
						l_label_item.align_text_right
						l_label_item.set_comparable(l_total_size)
						l_label_items.put(l_label_item, 2)

						create l_node.make_from_array(l_label_items)
						l_node.set_expand_agent(agent disk_usage_child_expand_agent(l_db_usages_for_db))
						l_node.set_data(a_sysprocesses)

						l_nodes.extend(l_node)
					end

					create l_db_usages_for_db.make_empty
					l_total_size := 0
				end
			end

			l_db_usages.forth
		end

		if l_nodes.count>0
		then
			-- Return the title node and all of the children in Result.
			create l_titles.make(<<"dbid", "Total Size (GB)", "Unused Space (GB)">>)	-- A fourth column for notes is untitled.
			create Result.make_from_array(l_titles, l_nodes)

			check attached {RP_DATA_GRID_LABEL_ITEM} l_titles.i_th(2) as al_label_item
			then
				al_label_item.align_text_right
			end

			check attached {RP_DATA_GRID_LABEL_ITEM} l_titles.i_th(3) as al_label_item
			then
				al_label_item.align_text_right
				al_label_item.set_foreground_color(not_pressed_color)
				al_label_item.pointer_button_press_actions.extend(agent show_unused_space(Result, ?, ?, ?, ?, ?, ?, ?, ?))
			end

			if l_tempdb_found
			then
				check attached {RP_DATA_GRID_LABEL_ITEM} l_titles.i_th(4) as al_label_item
				then
					if l_non_tempdb_found
					then
						al_label_item.set_text("tempdb, etc.")
					else
						al_label_item.set_text("tempdb")
					end
				end
			end
		else
--			a_parent_row.hide
		end
	end

	show_unused_space(
		a_titled_nodes: RP_TITLED_NODES[ANY];
		x: INTEGER; y: INTEGER; button: INTEGER; x_tilt: DOUBLE; y_tilt: DOUBLE;
		pressure: DOUBLE; screen_x: INTEGER; screen_y: INTEGER) is
	-- Called when the Free Space title item is pressed.
	local
		i: INTEGER
		j: INTEGER
		l_row: RP_GRID_NODE[ANY]
		l_subrow: RP_GRID_NODE[ANY]
		l_parent_row: RP_GRID_NODE[ANY]
		l_unused_spaces: ROSE_LINEAR_ARRAY[TUPLE[filename: STRING; unused_space: DOUBLE; error_text: STRING]]
		l_item: RP_DATA_GRID_LABEL_ITEM
		l_found: BOOLEAN
		l_total: DOUBLE
	do
		l_parent_row := a_titled_nodes.titles.parent_row
		if a_titled_nodes.titles.i_th(3).foreground_color.is_equal(not_pressed_color)
		then
			Gui.start_busy_wait
			action_text.set_text("   Finding unused space")
			Gui.process_events

			a_titled_nodes.titles.i_th(3).set_foreground_color(pressed_color)

			-- Loop over each DB with files on this drive.
			from
				i := 2			-- Skip the title row.
			until
				i>l_parent_row.subrow_count
			loop
				l_row := l_parent_row.subrow(i)
				l_row.expand	-- Make sure that there ARE some sub-rows.

				check attached {SQL_SERVER_SYSPROCESSES} l_row.data as al_sysprocesses and
				      attached {RP_DATA_GRID_LABEL_ITEM} l_row.i_th(1) as al_row_label_item
				then
					l_item := Void
					l_unused_spaces := al_sysprocesses.unused_spaces(al_row_label_item.text)

					-- Loop over each file.
					from
						j := 2		-- Skip the title row.
						l_total := 0
					until
						j>l_row.subrow_count
					loop
						l_subrow := l_row.subrow(j)

						if l_unused_spaces /= Void and then not l_unused_spaces.is_empty and then l_unused_spaces.first.filename /= Void
						then
							check attached {RP_DATA_GRID_LABEL_ITEM} l_subrow.i_th(1) as al_subrow_label_item
							then
								from
									l_found := False
									l_unused_spaces.start
								until
									l_unused_spaces.off or l_found
								loop
									if al_subrow_label_item.text.is_case_insensitive_equal(l_unused_spaces.current_item.filename)
									then
										l_found := True
									else
										l_unused_spaces.forth
									end
								end

								if l_found
								then
									create l_item.make_with_text(format_digits_past_decimal(l_unused_spaces.current_item.unused_space, 3))
									l_item.align_text_right
									l_item.set_comparable(l_unused_spaces.current_item.unused_space)
									l_subrow.set_item(l_item, 3)
									l_total := l_total + l_unused_spaces.current_item.unused_space
								end
							end
						else
							create l_item.make_with_text("error")
							l_item.align_text_right
							l_subrow.set_item(l_item, 3)
						end

						j := j + 1
					end

					if l_unused_spaces /= Void
					then
						if not l_unused_spaces.is_empty and then l_unused_spaces.first.filename = Void
						then
							create l_item.make_with_text("error")
							l_item.align_text_right
							l_row.set_item(l_item, 3)
						else
							create l_item.make_with_text(format_digits_past_decimal(l_total, 3))
							l_item.align_text_right
							l_item.set_comparable(l_total)
							l_row.set_item(l_item, 3)
						end
					else
						create l_item.make_with_text("error")
						l_item.align_text_right
						l_row.set_item(l_item, 3)
					end

					if l_item /= Void and not l_unused_spaces.is_empty and then l_unused_spaces.first.filename = Void
					then
						l_item.set_tooltip(l_unused_spaces.first.error_text)
					end

					l_row.collapse
					Gui.process_events
				end

				i := i + 1
			end

			action_text.set_text("")
			gui.end_wait
			Gui.process_events
		end
	end

	disk_usage_child_expand_agent(a_db_usages_for_db: ROSE_LINEAR_ARRAY[TUPLE[dbname: STRING; size: DOUBLE; filename: STRING; unused_space: DOUBLE]])
		: RP_TITLED_NODES[FUNCTION[ANY, TUPLE, RP_TITLED_NODES[ANY]]]
	-- Called when someone expands a child of a Disk Usage row.
	local
		l_node: RP_GRID_NODE[FUNCTION[ANY, TUPLE, RP_TITLED_NODES[ANY]]]
		l_nodes: ROSE_LINEAR_ARRAY[RP_GRID_NODE[FUNCTION[ANY, TUPLE, RP_TITLED_NODES[ANY]]]]
		l_item: RP_DATA_GRID_LABEL_ITEM
		l_items: ROSE_LINEAR_ARRAY[RP_DATA_GRID_LABEL_ITEM]
		l_db_usage: TUPLE[dbname: STRING; size: DOUBLE; filename: STRING; unused_space: DOUBLE]
		l_titles: RP_GRID_TITLE_NODE[FUNCTION[ANY, TUPLE, RP_TITLED_NODES[ANY]]]
	do
		create l_nodes.make_empty

		from
			a_db_usages_for_db.start
		until
			a_db_usages_for_db.off
		loop
			l_db_usage := a_db_usages_for_db.current_item

			create l_items.make(1, 3)

			create l_item.make_with_text(l_db_usage.filename)
			l_items.put(l_item, 1)

			create l_item.make_with_text(format_digits_past_decimal(l_db_usage.size, 3))
			l_item.align_text_right
			l_item.set_comparable(l_db_usage.size)
			l_items.put(l_item, 2)

			if isfinite(l_db_usage.unused_space)
			then
				create l_item.make_with_text(format_digits_past_decimal(l_db_usage.unused_space, 3))
				l_item.align_text_right
				l_item.set_comparable(l_db_usage.unused_space)
				l_items.put(l_item, 3)
			end

			create l_node.make_from_array(l_items)
			l_node.set_background_color(even_background_color)
			l_nodes.extend(l_node)

			a_db_usages_for_db.forth
		end

		if l_nodes.count>0
		then
			-- Return the title node and all of the children in Result.
			create l_titles.make(<<"Filename", "Size (GB)">>)

			check attached {RP_DATA_GRID_LABEL_ITEM} l_titles.i_th(2) as al_item_label
			then
				al_item_label.align_text_right
				create Result.make_from_array(l_titles, l_nodes)
			end
		end
	end

	show_open_transactions is
	-- Refreshes the 'open_transactions_grid'.
	local
		i: INTEGER
		l_sysprocesses: SQL_SERVER_SYSPROCESSES
		l_predicate: COLLECTING_PREDICATE[DCV_OPEN_TRANSACTION]
		l_parent_row: RP_GRID_NODE[SQL_SERVER_SYSPROCESS]
		l_row: ROSE_LINEAR_ARRAY[RP_DATA_GRID_LABEL_ITEM]
		l_item: RP_DATA_GRID_LABEL_ITEM
		l_spid: INTEGER
		l_transaction: DCV_OPEN_TRANSACTION
		l_transactions: ROSE_LINEAR_ARRAY[DCV_OPEN_TRANSACTION]
		l_text: STRING
	do
		Gui.start_busy_wait
		update_time
		action_text.set_text("   Finding open transactions")
		Gui.process_events

		open_transactions_grid.remove_all_nodes

		from
			i := 1
		until
			i>data_server_status_grid.row_count
		loop
			if data_server_status_grid.selected_items.count=0 or data_server_status_grid.row(i).is_selected
			then
				l_sysprocesses := data_server_status_grid.row(i).data
				if l_sysprocesses.connected
				then
					if l_sysprocesses.success
					then
						create l_predicate.make(
							l_sysprocesses.server,
							"select * from %N%
							%	sys.dm_tran_database_transactions a, %N%
							%	sys.dm_tran_session_transactions b %N%
							%where %N%
							%	a.transaction_id=b.transaction_id and %N%
							%	database_transaction_begin_time is not null %N%
							%order by database_transaction_begin_time, a.transaction_id")
						if l_predicate.success
						then
							create l_transactions.make_empty
							l_predicate.set_container(l_transactions)
							l_predicate.retrieve(Void, Void)
							if l_predicate.success
							then
								from
									l_transactions.start
								until
									l_transactions.off
								loop
									l_transaction := l_transactions.current_item
									create l_row.make(1, 12)

									create l_item.make_with_text(l_sysprocesses.server.node)
									l_row.put(l_item, 1)

									create l_item.make_with_text(l_sysprocesses.dbname(l_transaction.database_id))
									l_row.put(l_item, 2)

									l_spid := l_transaction.session_id
									create l_item.make_with_text(l_spid.out)
									l_item.set_comparable(l_spid)
									l_item.align_text_right
									l_row.put(l_item, 3)

									create l_item.make_with_text(l_transaction.database_transaction_begin_time.debug_output)
									l_item.set_comparable(l_transaction.database_transaction_begin_time)
									l_row.put(l_item, 4)

									create l_item.make_with_text(l_transaction.interpreted_database_transaction_type)
									l_row.put(l_item, 5)

									create l_item.make_with_text(l_transaction.interpreted_database_transaction_state)
									l_row.put(l_item, 6)

									create l_item.make_with_text(integer_formatter.formatted(l_transaction.database_transaction_log_record_count))
									l_item.set_comparable(l_transaction.database_transaction_log_record_count)
									l_item.align_text_right
									l_row.put(l_item, 7)

									create l_item.make_with_text(integer_formatter.formatted(l_transaction.database_transaction_replicate_record_count))
									l_item.set_comparable(l_transaction.database_transaction_replicate_record_count)
									l_item.align_text_right
									l_row.put(l_item, 8)

									l_text := integer64_formatter.formatted(l_transaction.database_transaction_log_bytes_used)
									l_text.prune_all_trailing('.')
									create l_item.make_with_text(l_text)
									l_item.set_comparable(l_transaction.database_transaction_log_bytes_used)
									l_item.align_text_right
									l_row.put(l_item, 9)

									l_text := integer64_formatter.formatted(l_transaction.database_transaction_log_bytes_reserved)
									l_text.prune_all_trailing('.')
									create l_item.make_with_text(l_text)
									l_item.set_comparable(l_transaction.database_transaction_log_bytes_reserved)
									l_item.align_text_right
									l_row.put(l_item, 10)

									create l_item.make_with_text(integer_formatter.formatted(l_transaction.database_transaction_log_bytes_used_system))
									l_item.set_comparable(l_transaction.database_transaction_log_bytes_used_system)
									l_item.align_text_right
									l_row.put(l_item, 11)

									create l_item.make_with_text(integer_formatter.formatted(l_transaction.database_transaction_log_bytes_reserved_system))
									l_item.set_comparable(l_transaction.database_transaction_log_bytes_reserved_system)
									l_item.align_text_right
									l_row.put(l_item, 12)

									-- Make a new parent row and put it into the grid.
									create l_parent_row.make_from_array(l_row)
									open_transactions_grid.extend(l_parent_row)
									l_parent_row.set_expand_agent(agent open_transaction_expand_agent(l_sysprocesses, l_spid))

									l_transactions.forth
								end
							end
						end
					end
				end
			end

--			Gui.process_events
			i := i + 1
		end

		if open_transactions_grid.sort_states.count/=0
		then
			open_transactions_grid.sort
		end

		action_text.set_text("")
		gui.end_wait
		Gui.process_events
	end

	open_transaction_expand_agent(
		a_sysprocesses: SQL_SERVER_SYSPROCESSES;
		a_spid: INTEGER): RP_TITLED_NODES[SQL_SERVER_SYSPROCESS]
	-- Called when the user expands a row in 'open_transactions_grid'.
	local
		l_nodes: ROSE_LINEAR_ARRAY[RP_GRID_NODE[SQL_SERVER_SYSPROCESS]]
	do
		-- Find the row in sysprocesses that corresponds to this SPID.
		from
			create l_nodes.make_empty
			a_sysprocesses.processes.start
		until
			a_sysprocesses.processes.off
		loop
			if a_spid=a_sysprocesses.processes.current_item.spid
			then
				-- Make a child row and save it.
				l_nodes.extend(sysprocess_to_grid_row(a_sysprocesses.processes.current_item, open_transactions_grid, Void))
			end

			a_sysprocesses.processes.forth
		end

		if l_nodes.count>0
		then
			-- Return the title node and all of the children in Result.
			create Result.make_from_array(child_title_node, l_nodes)
		end
	end

	show_perf_graphs is
	-- Redraws the perf graphs.
	local
		l_machines: ROSE_LINEAR_ARRAY[STRING]
		l_sysprocesses: SQL_SERVER_SYSPROCESSES
		l_backslash_pos: INTEGER
		l_name: STRING
		l_server_requests: ROSE_LINEAR_ARRAY[SERVER_REQUEST]
		l_length_code: INTEGER
		l_server_requests_index: INTEGER
		i: INTEGER
	do
		if notebook.selected_item=perf_vbox and server_requests/=Void
		then
			gui.start_busy_wait
			create l_machines.make_empty
			action_text.set_text("   Building the graph")
			Gui.process_events

			from
				i := 1
			until
				i>data_server_status_grid.row_count
			loop
--				if data_server_status_grid.selected_count=0 or data_server_status_grid.item.is_selected
				if data_server_status_grid.row(i).is_selected
				then
					l_sysprocesses := data_server_status_grid.row(i).data
					l_name := l_sysprocesses.name
					l_backslash_pos := l_name.index_of('\', 1)
					if l_backslash_pos/=0
					then
						l_name := l_name.substring(1, l_backslash_pos - 1)
					end

					l_machines.extend(l_name.as_lower)
				end

				i := i + 1
			end

			from
				i := 1
			until
				i>other_server_status_grid.row_count
			loop
--				if other_server_status.selected_count=0 or other_server_status.item.is_selected
				if other_server_status_grid.row(i).is_selected
				then
					check attached {STRING} other_server_status_grid.row(i).data as al_name
					then
						l_machines.extend(al_name.as_lower)
					end
				end

				i := i + 1
			end

			from
				i := 1
			until
				i>port_server_status_grid.row_count
			loop
				if port_server_status_grid.row(i).is_selected
				then
					check attached {RP_DATA_GRID_LABEL_ITEM} port_server_status_grid.row(i).i_th(1) as al_label_item
					then
						l_name := al_label_item.text
					end

					l_backslash_pos := l_name.index_of('\', 1)
					if l_backslash_pos/=0
					then
						l_name := l_name.substring(1, l_backslash_pos - 1)
					end

					l_machines.extend(l_name.as_lower)
				end

				i := i + 1
			end

			create l_server_requests.make_empty

			if show_processes_button.is_selected
			then
				l_server_requests_index := server_requests.index
				from
					server_requests.start
				until
					server_requests.off
				loop
					l_server_requests.extend(server_requests.current_item)
					server_requests.current_item.machine.to_lower
					server_requests.forth
				end
			end

			server_requests.go_i_th(l_server_requests_index)

			if chart_length_combo.selected_item=Chart_length_3h
			then
				l_length_code := 1
			elseif chart_length_combo.selected_item=Chart_length_7d
			then
				l_length_code := 3
			elseif chart_length_combo.selected_item=Chart_length_30d
			then
				l_length_code := 4
			else
				l_length_code := 2
			end

			perf_charts.graph_performance_objects_and_events(l_machines, l_server_requests, l_length_code)

			gui.end_wait
			action_text.set_text("")
			Gui.process_events
		end
	end

	refresh_perf_summary is
	-- Show the performance summary grid.
	local
		l_predicate: COLLECTING_PREDICATE[COUNTER_SUMMARY_VIEW]
		l_start_time: ROSE_DATE
		l_machine_name: STRING
		l_row: RP_GRID_NODE[ANY]
		l_item: RP_DATA_GRID_LABEL_ITEM
		l_items: ARRAY[RP_DATA_GRID_LABEL_ITEM]
		l_exceeded_cpu_count: INTEGER
		l_exceeded_cpu_total: DOUBLE
		l_exceeded_memory_count: INTEGER
		l_exceeded_memory_total: DOUBLE
		l_counter_summary: COUNTER_SUMMARY_VIEW
	do
		Gui.start_busy_wait
		update_time
		action_text.set_text("   Gathering summary data")
		Gui.process_events

		perf_summary_grid.remove_all_nodes
		create l_start_time.make_now
		l_start_time.add_n_days(-7)
		create l_predicate.make_strict(
			perf_counter_server,
			"SELECT%N%
			% b.MachineName, b.CounterName,%N%
			% cast(count(*) as int) as firstvaluea, cast(sum(countervalue) as int) as firstvalueb%N%
			%FROM%N%
			% CounterData a INNER JOIN CounterDetails b%N%
			%ON%N%
			% a.CounterID = b.CounterID and%N%
			% a.counterdatetime>'" + l_start_time.formatted_out("YYYY-[0]MM-[0]DD [0]HH:[0]MI") + "' and %N%
			%((b.countername='%% Processor Time' and a.countervalue>70) or %N%
			% (b.countername<>'%% Processor Time' and a.countervalue<400)) %N%
			%group by b.machinename,  b.countername %N%
			%order by b.machinename,  b.countername")
		l_predicate.retrieve(Void, Void)

		from
			l_predicate.array.start
			l_machine_name := l_predicate.array.current_item.machinename
		until
			l_predicate.array.off
		loop
			l_counter_summary := l_predicate.array.current_item
			if not equal(l_machine_name, l_counter_summary.machinename)
			then
				create l_items.make(1, 7)
				l_machine_name.prune_all_leading('\')
				l_machine_name.to_upper

				create l_item.make_with_text(l_machine_name)
				l_item.set_comparable(l_machine_name.as_upper)
				l_items.put(l_item, 1)

				create l_item.make_with_text(l_exceeded_cpu_count.out)
				l_item.set_comparable(l_exceeded_cpu_count)
				l_item.align_text_right
				l_items.put(l_item, 2)

				if l_exceeded_cpu_total>0 and l_exceeded_cpu_count>0
				then
					create l_item.make_with_text((l_exceeded_cpu_total / l_exceeded_cpu_count).truncated_to_integer.out)
					l_item.set_comparable(l_exceeded_cpu_total / l_exceeded_cpu_count)
				else
					create l_item.make_with_text("N/A")
				end

				l_item.align_text_right
				l_items.put(l_item, 3)

				create l_item.make_with_text((l_exceeded_cpu_count * 15).out)
				l_item.set_comparable(l_exceeded_cpu_count)
				l_item.align_text_right
				l_items.put(l_item, 4)

				create l_item.make_with_text(l_exceeded_memory_count.out)
				l_item.set_comparable(l_exceeded_memory_count)
				l_item.align_text_right
				l_items.put(l_item, 5)

				if l_exceeded_memory_count>0
				then
					create l_item.make_with_text((l_exceeded_memory_total / l_exceeded_memory_count).truncated_to_integer.out)
					l_item.set_comparable(l_exceeded_memory_total / l_exceeded_memory_count)
				else
					create l_item.make_with_text("N/A")
				end

				l_item.align_text_right
				l_items.put(l_item, 6)

				create l_item.make_with_text((l_exceeded_memory_count * 15).out)
				l_item.set_comparable(l_exceeded_memory_count)
				l_item.align_text_right
				l_items.put(l_item, 7)

				create l_row.make_expandable_from_array(l_items, Void)
				perf_summary_grid.extend(l_row)

				l_exceeded_cpu_count := 0
				l_exceeded_cpu_total := 0
				l_exceeded_memory_count := 0
				l_exceeded_memory_total := 0
				l_machine_name := l_counter_summary.machinename
			end

			if equal(l_counter_summary.countername, "%% Processor Time")
			then
				l_exceeded_cpu_count := l_counter_summary.firstvaluea
				l_exceeded_cpu_total := l_counter_summary.firstvalueb
			else
				l_exceeded_memory_count := l_counter_summary.firstvaluea
				l_exceeded_memory_total := l_counter_summary.firstvalueb
			end

			l_predicate.array.forth
		end

		gui.end_wait
		action_text.set_text("")
		Gui.process_events
	end

	restart_timer is
	-- Restores the timer if we are showing blocker detail (which turns off the timer).
	do
		if showing_blocker_detail
		then
			showing_blocker_detail := False
			blockees_frame.hide
			refresh_button.set_default_colors
			blockers_grid.remove_selection
			blockees_grid.remove_all_nodes
--			set_def_colors_port_served_apps
			restore_timer_actions
		end
	end

	change_timer(a_text_field: EV_TEXT_FIELD) is
	-- Called when the user changes the timer edit field.
	local
		l_beeper: WEL_WINDOWS_ROUTINES
	do
		if a_text_field.text.is_integer
		then
			timer.set_interval(a_text_field.text.to_integer * 1000)
			refresh
		else
			create l_beeper
			l_beeper.message_beep_asterisk
			show_dialog_with_error_fatal(window, "You entered an illegal number", "You entered an illegal number", Void)
		end
	end

	save_timer_actions is
	-- Used to save the 'timer' action when we show blocker detail (which turns off the timer).
	do
		if saved_timer_actions=Void
		then
			create saved_timer_actions
			copy_actions(timer.actions, saved_timer_actions)
		end
	end

	restore_timer_actions is
	-- Used to restore the 'timer' action when we stop showing blocker detail (which had turned off the timer).
	do
		copy_actions(saved_timer_actions, timer.actions)
		saved_timer_actions := Void
	end

	copy_actions(a_actions_src, a_actions_dest: EV_NOTIFY_ACTION_SEQUENCE) is
	-- Copies an action sequence.
	do
		from
			a_actions_src.start
		until
			a_actions_src.off
		loop
			a_actions_dest.extend(a_actions_src.item)
			a_actions_src.forth
		end
	end

	update_time is
	-- Update the 'last_update_time' field with the current time.
	local
		l_now: ROSE_DATE
	do
		create l_now.make_now
		last_update_time_text.set_text(" Last updated at: " + l_now.formatted_out(date_time_format) + "   ")
	end

	show_processes_pressed is
	-- Called when the user changes the check box "Show Processes" (in the charts tab).
	do
		show_perf_graphs
	end

	show_explanation is
	-- Called when the user presses the "How?" button (in the charts tab)".
	do
		show_dialog_with_inform(window, "How?",
			"This data is currently being collected by ORPCB04 (RJ).%N%
			%To change the collected data, edit the file%N%
			%C:\RJ\collect_counter_data_for_dcv.cfg on ORPCB04.  To manage%N%
			%the job see the Task Scheduler job 'collect_counter_data_for_dcv'.",
			Void)
	end

	rescan_dataserver(a_sysprocesses: SQL_SERVER_SYSPROCESSES) is
	-- Rescans one server as opposed to all servers.
	do
		a_sysprocesses.make(a_sysprocesses.name)
		a_sysprocesses.refresh
		if a_sysprocesses.success
		then
			update_data_server_status_grid(a_sysprocesses.name, "UP")
			data_server_status_grid.refresh_now
		end
	end

	rescan_portserver(a_port_server_name: STRING; a_node: RP_GRID_NODE[ANY]) is
	-- Rescans one server as opposed to all servers.
	do
		a_node.set_data(Void)						-- Clear the flag that says that this node is down.
		poke_port_server(a_port_server_name, True)	-- Update the status (attempt to communicate with the server).
		port_served_apps_grid.refresh_now
	end

	rescan is
	-- Like 'refresh' but attempts to recontact ALL of the servers, even the ones that are DOWN.
	do
		other_server_names_saved := Void
		may_rebuild_server_request_server := True
		port_server_status_grid.remove_all_nodes

		from
			data_servers.start
		until
			data_servers.off
		loop
			if data_servers.current_item.name /~ k_none and not data_servers.current_item.connected
			then
				data_servers.current_item.make(data_servers.current_item.name)
			end

			data_servers.forth
		end

		refresh
	end

	reformat_path(a_path: STRING) is
	-- Takes a full path of the form "c:\folder\abc.exe" and turns it into "abc.exe - c:\folder".
	-- This puts the important part (the EXE name) at the front.
	local
		l_path: STRING
		l_backslash_pos: INTEGER
		l_bracket_pos: INTEGER
		l_pos: INTEGER
	do
		if a_path.count/=0
		then
			l_pos := a_path.substring_index(":[", 1)
			if l_pos/=0
			then
				l_path := a_path.substring(l_pos + 1, a_path.count)
				a_path.wipe_out
				a_path.append(l_path)
			end

			l_backslash_pos := a_path.last_index_of('\', a_path.count)
			l_bracket_pos := a_path.last_index_of(']', a_path.count)
			l_pos := l_bracket_pos.max(l_backslash_pos)
			if l_pos/=0
			then
				l_path :=
					a_path.substring(l_pos + 1, a_path.count) +
					" - " +
					a_path.substring(1, l_pos)
				a_path.wipe_out
				a_path.append(l_path)
			end
		end
	end

	show_dc_count is
	-- For debugging.  Counts up the number of device contexts (DC) and displays the count.
	local
		l_a: ARRAY [ANY]
		l_internal: INTERNAL
		l_spec_type: INTEGER
		l_dc_type: INTEGER
		l_spec, l_instances: SPECIAL [ANY]
		l_out: STRING
	do
		create l_internal
		create l_a.make(0, 1)
		l_spec := l_a.area
		l_spec_type := l_internal.dynamic_type(l_spec)
		l_out := ""

		l_dc_type := l_internal.dynamic_type_from_string("WEL_PAINT_DC")
		l_instances := find_instance_of(l_dc_type, l_spec_type)
		l_out.append(l_instances.count.out + " ")

		l_dc_type := l_internal.dynamic_type_from_string("WEL_DESKTOP_DC")
		l_instances := find_instance_of(l_dc_type, l_spec_type)
		l_out.append(l_instances.count.out + " ")

		l_dc_type := l_internal.dynamic_type_from_string("WEL_SCREEN_DC")
		l_instances := find_instance_of(l_dc_type, l_spec_type)
		l_out.append(l_instances.count.out + " ")

		l_dc_type := l_internal.dynamic_type_from_string("WEL_CLIENT_DC")
		l_instances := find_instance_of(l_dc_type, l_spec_type)
		l_out.append(l_instances.count.out + " ")

		l_dc_type := l_internal.dynamic_type_from_string("WEL_WINDOW_DC")
		l_instances := find_instance_of(l_dc_type, l_spec_type)
		l_out.append(l_instances.count.out + " ")

		gui.Dialogs.inform(window, "DC Count", l_out, Void)
	end

	set_grid_font_weight(a_grid: RP_DATA_GRID[ANY]) is
	-- Used on all grids to set the font and font weight to my desired values.
	local
		i: INTEGER
		l_font: EV_FONT
	do
		from
			i := 1

			check attached {RP_DATA_GRID_LABEL_ITEM} a_grid.header_node.i_th(i) as al_label_item
			then
				l_font := al_label_item.font
				l_font.set_weight((create {EV_FONT_CONSTANTS}).weight_regular)
			end
		until
			i>a_grid.header_node.count
		loop
			check attached {RP_DATA_GRID_LABEL_ITEM} a_grid.header_node.i_th(i) as al_label_item
			then
				al_label_item.set_font(l_font)
				i := i + 1
			end
		end
	end

	format_digits_past_decimal(a_number: DOUBLE; a_decimals: INTEGER): STRING is
	-- Change 'a_number' into a STRING of the form ####.## with 'a_decimal' digits after the decimal.
	local
		l_pos: INTEGER
		l_fmt: FORMAT_DOUBLE
	do
		create l_fmt.make(50, a_decimals)
		Result := l_fmt.formatted(a_number)
		Result.prune_all(' ')
		l_pos := Result.index_of('.', 1)
		if l_pos=0
		then
			Result.append_character('.')
			l_pos := Result.count
		end

		if l_pos + a_decimals<=Result.count
		then
			Result := Result.substring(1, l_pos + a_decimals)
		else
			from

			until
				Result.count>=l_pos + a_decimals
			loop
				Result.append_character('0')
			end
		end
	end

	load_config_values(a_server_name: STRING)
	-- Reads the port_server_64.cfg for 'a_server' and fetches certain values
	-- to be loaded into 'port_server_config_values'.
	require
		server_name_not_void: a_server_name/=Void
	local
		l_folder_name: STRING
		l_file_name: STRING
		l_cfg_file: ROSE_FILE
		l_config: ROSE_CONFIGURATION
	do
		if port_server_config_values=Void
		then
			create port_server_config_values.make(15)
		end

		if port_server_config_values[a_server_name]=Void
		then
			l_folder_name := "\\" + a_server_name + "\servers\"
			if not equal(environment_name, default_repository_name)
			then
				l_folder_name.append(environment_name + "\")
			end

			create l_cfg_file.make(l_folder_name + "port_server_64.cfg")
			if l_cfg_file.exists
			then
				l_file_name := "port_server_64.cfg"
			end

			if l_file_name = Void
			then
				show_warning("Could not find $1 in $2.", <<"%"" + l_file_name + "%"", "%"" + l_folder_name + "%"">>)
				port_server_config_values[a_server_name] := [-1, ""]
			else
				create l_config.make_default
				global.config_manager.load(l_config, Void, l_folder_name + l_file_name)

				if error.signaled
				then
					show_warning("Could not open the port_server config file $1.", <<"%"" + l_folder_name + l_file_name + "%"">>)
					error.disregard
					port_server_config_values[a_server_name] := [-1, ""]
				else
					port_server_config_values[a_server_name] :=
						[l_config.integer("/port_server/port", -1), l_config.value_default("/port_server/log_path", "")]
				end
			end
		end
	end

	port_server_port_number(a_server_name: STRING): INTEGER
	-- Port number to use when connecting to a port_server (from delivery.cfg).
	-- -1 means that we don't know and can't talk to the port server.
	do
		load_config_values(a_server_name)
		Result := port_server_config_values[a_server_name].port_number
	end

	show_warning(a_message: STRING; a_args: ARRAY[ANY])
	-- A wrapper around 'error.warn' that prevents a dialog from popping up during testing.
	do
		if testing
		then
			print(global.formatted(a_message, a_args) + "%N")
		else
			error.warn(a_message, a_args)
			error.flush_and_acknowledge
		end
	end

	show_dialog_with_error(a_widget: EV_WIDGET; a_title, a_message: STRING; a_args: ARRAY[ANY])
	-- A wrapper around the 'error' dialog that prevents a stall if there is no user (because of testing).
	do
		if testing
		then
			print(global.formatted(a_message, a_args) + "%N")
		else
			gui.dialogs.error(a_widget, a_title, a_message, a_args)
		end
	end

	show_dialog_with_error_fatal(a_widget: EV_WIDGET; a_title, a_message: STRING; a_args: ARRAY[ANY])
	-- A wrapper around the 'error' dialog that prevents a stall if there is no user (because of testing).
	-- This feature will raise an exception if 'testing'.
	local
		l_exceptions: EXCEPTIONS
	do
		if testing
		then
			create l_exceptions
			l_exceptions.raise(a_message)
		else
			gui.dialogs.error(a_widget, a_title, a_message, a_args)
		end
	end

	show_dialog_with_inform(a_widget: EV_WIDGET; a_title, a_message: STRING; a_args: ARRAY[ANY])
	-- A wrapper around the 'inform' dialog that prevents a stall if there is no user (because of testing).
	do
		if testing
		then
			print(a_message + "%N")
		else
			gui.dialogs.inform(a_widget, a_title, a_message, a_args)
		end
	end

feature {NONE} -- Once (and once-like) functions.
	sql_server_names: ROSE_LINEAR_ARRAY[STRING] is
	-- The list of names of the SQL Server that we are going to monitor.
	once
		Result := config.children_values("data_servers")
		if Result=Void
		then
			-- We only go here if the variable 'data_servers' was not found in the config file
			-- (like during testing).
			create Result.make_empty
			Result.extend("RCSQL5\x64Devel01")
			Result.extend("RCSQL6\x64Devel03")
			Result.extend("RCSQL7\x64Devel04")
			Result.extend("ARSQL3\A")
			Result.extend("ARSQL5\RC")
			Result.extend("ARSQL7\x64Devel02")
			Result.extend("ARSQL9\x64Prod01")
			Result.extend("ARSQL10\x64Prod02")
			Result.extend("ARSQL11\x64Prod03")
			Result.extend("ARSQL12\x64Devel05")
			Result.extend("ARSQL15\x64Prod05")
			Result.extend("ARSQL16\x64Prod06")
			Result.extend("GIISQL\GII")
			Result.extend("GIISQL2")
			Result.extend("GIISQL3\DEVEL")
			Result.extend("GIISQL4\A")
		end
	end

	data_servers: ROSE_LINEAR_ARRAY[SQL_SERVER_SYSPROCESSES]
	-- The list of SQL_SERVER_SYSPROCESSES that we are going to monitor.  Each SQL_SERVER_SYSPROCESSES represents a SQL Server.
	local
		l_server_sysprocesses: SQL_SERVER_SYSPROCESSES
	once
		gui.start_busy_wait
		create Result.make_empty
		Result.extend(create {SQL_SERVER_SYSPROCESSES}.make_name_only(k_none))	-- Put in a fake server that the user can select (to make everything faster).

		from
			sql_server_names.start
		until
			sql_server_names.off
		loop
			create l_server_sysprocesses.make(sql_server_names.current_item)
			Result.extend(l_server_sysprocesses)
			sql_server_names.forth
		end

		gui.end_wait
	end

	data_server_status_grid: RP_DATA_GRID[SQL_SERVER_SYSPROCESSES]
	-- Grid showing the names and current state of the SQL Servers that we monitor.
	local
		l_row: RP_GRID_NODE[SQL_SERVER_SYSPROCESSES]
	once
		create Result.make(<<"Server", "Status">>, Void)
		Result.enable_multiple_row_selection
		Result.enable_column_separators
		Result.enable_row_separators
		Result.set_separator_color(separator_color)
		Result.row_select_actions.extend(agent may_show_perf_graphs_dummy2)
		Result.row_deselect_actions.extend(agent may_show_perf_graphs_dummy2)
		Result.set_are_raised_titles_enabled_on_header_node(True)
		Result.set_are_raised_titles_enabled(True)
		Result.set_are_columns_resizable_on_dividers_enabled(True)
		Result.enable_selection_on_single_button_click
		Result.header_node.sort_started_actions.extend(agent data_server_sort_started_agent)
		Result.header_node.sort_ended_actions.extend(agent data_server_sort_ended_agent)
		Result.grid.pre_draw_overlay_actions.extend(agent set_focused_color_agent)
		Result.grid.post_draw_overlay_actions.extend(agent reset_focused_color_agent)

		set_grid_font_weight(Result)

		from
			data_servers.start
		until
			data_servers.off
		loop
			create l_row.make_from_array(<<data_servers.current_item.name, "">>)

			if data_servers.current_item.name ~ k_none
			then
				data_server_none_row := l_row
				l_row.i_th(1).set_tooltip("Select this row to speed up the update (but you won't get database info either).")

				-- Make the font more noticable.
				check attached {RP_DATA_GRID_LABEL_ITEM} l_row.i_th(1) as al_label_item
				then
					al_label_item.set_font(tooltip_available_font)
				end
			end

			l_row.set_data(data_servers.current_item)
			l_row.pointer_button_press_actions.extend(agent show_data_server_status_menu)
			Result.extend(l_row)
			data_servers.forth
		end
	end

	other_server_names: ROSE_LINEAR_ARRAY[STRING] is
	-- Names of servers that we want to be able to see 'perf_graphs' for but aren't SQL Servers or port servers.
	local
		l_exceptions: EXCEPTIONS
		l_names_to_exclude: ROSE_LINEAR_ARRAY[STRING]
		l_machine_name: STRING
		l_found: BOOLEAN
		l_pos: INTEGER
	do
		if other_server_names_saved=Void
		then
			-- Get machine names that will appear in other lists.
			from
				create l_names_to_exclude.make_empty
				sql_server_names.start
			until
				sql_server_names.off
			loop
				l_machine_name := sql_server_names.current_item.twin
				l_machine_name.to_upper
				l_pos := l_machine_name.index_of('\', 1)
				if l_pos/=0
				then
					l_machine_name := l_machine_name.substring(1, l_pos - 1)
				end

				l_names_to_exclude.extend(l_machine_name)
				sql_server_names.forth
			end

			-- Get the list of machine names that have stats.
			machine_names_with_perf_data_predicate.retrieve(Void, Void)
			if not machine_names_with_perf_data_predicate.success
			then
				create l_exceptions
				l_exceptions.raise("machine_names_with_perf_data_predicate failed")
			end

			-- Build Result but do not include names that appear in other lists.
			create other_server_names_saved.make_empty
			from
				machine_names_with_perf_data_predicate.array.start
			until
				machine_names_with_perf_data_predicate.array.off
			loop
				l_machine_name := machine_names_with_perf_data_predicate.array.current_item.machinename
				l_machine_name.replace_substring_all("\", "")
				l_machine_name.to_upper

				from
					l_found := False
					l_names_to_exclude.start
				until
					l_names_to_exclude.off or l_found
				loop
					l_found := equal(l_names_to_exclude.current_item, l_machine_name)
					l_names_to_exclude.forth
				end

				if not l_found
				then
					other_server_names_saved.extend(l_machine_name)
				else
					do_nothing
				end

				machine_names_with_perf_data_predicate.array.forth
			end
		end

		Result := other_server_names_saved
	end

	remove_from_other_names(a_machine_name: STRING): RP_GRID_NODE[ANY]
	-- Called when a machine moves out of the 'other' list.  Usually, it's going into the list of port servers.
	local
		l_done: BOOLEAN
		i: INTEGER
		l_label_item: RP_DATA_GRID_LABEL_ITEM
	do
		from
			i := 1
		until
			i>other_server_status_grid.row_count or l_done
		loop
			check attached {RP_DATA_GRID_LABEL_ITEM} other_server_status_grid.row(i).i_th(1) as al_label_item
			then
				l_label_item := al_label_item
			end

			if l_label_item.text ~ a_machine_name
			then
				l_done := True
				Result := other_server_status_grid.row(i)
				other_server_status_grid.remove_row(Result)
			else
				i := i + 1
			end
		end
	end

	other_server_status_grid: RP_DATA_GRID[ANY] is
	-- Grid showing the names and states of machines that aren't SQL Servers or port servers.
	local
		l_row: RP_GRID_NODE[ANY]
	once
		create Result.make(<<"Server">>, Void)
		Result.enable_multiple_row_selection
		Result.enable_column_separators
		Result.enable_row_separators
		Result.set_separator_color(separator_color)
		Result.row_select_actions.extend(agent may_show_perf_graphs_dummy2)
		Result.row_deselect_actions.extend(agent may_show_perf_graphs_dummy2)
		Result.set_are_raised_titles_enabled_on_header_node(True)
		Result.set_are_raised_titles_enabled(True)
		Result.set_are_columns_resizable_on_dividers_enabled(True)
		Result.enable_selection_on_single_button_click
		Result.grid.pre_draw_overlay_actions.extend(agent set_focused_color_agent)
		Result.grid.post_draw_overlay_actions.extend(agent reset_focused_color_agent)

		set_grid_font_weight(Result)

		from
			other_server_names.start
		until
			other_server_names.off
		loop
			create l_row.make_from_array(<<other_server_names.current_item, "">>)
			l_row.set_data(other_server_names.current_item)
			l_row.set_data(other_server_names.current_item)
			Result.extend(l_row)
			other_server_names.forth
		end

		-- At this point we could check to see if he wants the grid sorted but the user
		-- hasn't had a chance to do that yet.
	end

	show_server_request_server_menu(
		a_x, a_y, a_button: INTEGER; a_x_tilt, a_y_tilt, a_pressure: DOUBLE; a_screen_x, a_screen_y: INTEGER)
	-- Shows the right-click menu for the frame for the 'port_server_status_grid'.
	do
		repositories_menu.show
	end

	server_request_server: SQLOLEDB_DATA_SERVER
	-- A 'once_like' function that returns the data server used to store the repository.  This
	-- database contains the 'server_request' table.
	do
		if server_request_server_saved=Void
		then
			set_server_request_server(servers.repository_server.node, servers.repository_server.database)
		end

		Result := server_request_server_saved
	end

	set_server_request_server_and_refresh(a_node_name, a_database_name: STRING)
	-- See 'server_request_server'.
	do
		set_server_request_server(a_node_name, a_database_name)
		if not refresh_running
		then
			refresh
		else
			if not refresh_once_in_progress
			then
				refresh_once_in_progress := True
				gui.ev_application.do_once_on_idle(agent refresh_once)
			end
		end
	end

	set_server_request_server(a_node_name, a_database_name: STRING)
	-- See 'server_request_server' for details.
	local
		l_propset: OLEDB_PROPERTY_SET
		l_property_constants: OLEDB_PROPERTY_CONSTANTS
		l_saved_server: like server_request_server_saved
	do
		gui.start_busy_wait
		create l_saved_server.make_integrated_security_with_timeout(a_node_name, a_database_name, partner_timeout)
		if l_saved_server.success
		then
			server_request_server_saved := l_saved_server
			create l_property_constants
			create l_propset.make(l_property_constants.DBPROPSET_ROWSET)
			l_propset.add_integer_property(l_property_constants.dbprop_commandtimeout, 2)
			server_request_server_saved.set_default_command_propset(l_propset)
			server_request_server_saved.set_implicit_transaction_off

			get_server_requests_saved := Void				-- This predicate is using the previous server.
			port_server_status_grid.remove_all_nodes		-- This contains port servers from the previous repository.
			environment_name := a_database_name
			refresh_psa_count
			port_server_config_values := Void				-- Force this to be recreated.
			allowed_to_kill_processes_saved := Void			-- Force this to be recreated.
			port_served_apps_grid.remove_all_nodes
		else
			show_dialog_with_inform(window, " ", "Failed to connect to $1.$2.", <<a_node_name, a_database_name>>)
		end

		gui.end_wait
		gui.process_events
	end

	get_server_requests: COLLECTING_PREDICATE[SERVER_REQUEST] is
	-- This 'once-like' predicate returns full rows from the 'server_request' table.
	do
		-- Catch all rows that are still running (we hope) or were started within the
		-- last 7 days (so we can "show processes" on a chart even if terminated).
		if get_server_requests_saved=Void
		then
			create get_server_requests_saved.make(
				server_request_server,
				"select * from server_request (nolock) where terminated_at is NULL or timestamp>DATEADD([day], -7, GETDATE())")
			if not get_server_requests_saved.success
			then

			end
		end

		Result := get_server_requests_saved
	end

	allowed_to_kill_processes: BOOLEAN
	-- True if this user is allowed to request the port_server to kill a process.
	local
		l_predicate: INTEGER_PREDICATE
		l_success: BOOLEAN
	do
		if allowed_to_kill_processes_saved=Void
		then
			create allowed_to_kill_processes_saved
			if server_request_server.has_table("allowed_to_kill_processes_in_the_watcher") and
			   environment_name /~ default_repository_name
			then
				create l_predicate.make(
					server_request_server, "select count(*) from allowed_to_kill_processes_in_the_watcher (nolock) where user_id=?")
				if l_predicate.success
				then
					l_predicate.retrieve(Void, <<Global.Env.get("USERNAME")>>)
					if l_predicate.success
					then
						allowed_to_kill_processes_saved.set_item(l_predicate.array.item(1)>0)
						l_success := True
					end
				end

				if not l_success
				then
					show_dialog_with_inform(window, " ", "I could not determine if you are allowed to kill processes.  Sorry.", Void)
				end
			else
				-- If the table doesn't exist (like in a test environment) then it's OK for him to kill.
				allowed_to_kill_processes_saved.set_item(True)
			end
		end

		Result := allowed_to_kill_processes_saved.item
	end

	perf_counter_server: SQL_DATA_SERVER is
	-- Server for the 'perf_counter' database.
	once
		Result := servers.make_from_repository("perf_counters")
		Result.set_implicit_transaction_off
	end

	transaction_date_in_code_string: DATE_TIME_CODE_STRING is
	-- Date format that we get transaction start dates.
	once
		create Result.make("mmm dd yyyy hh12:mi:ss.ff3 PM")
	end

	transaction_date_out_code_string: DATE_TIME_CODE_STRING is
	-- Date format to use to display transaction start dates.
	once
		create Result.make("yyyy/[0]mm/[0]dd [0]hh:[0]mi:[0]ss.ff3")
	end

	machine_names_with_perf_data_predicate: COLLECTING_PREDICATE[COUNTER_SUMMARY_VIEW]
	-- Returns the machines which have performance data.  Exclude those too old to show.
	local
		l_exceptions: EXCEPTIONS
		l_two_months_ago: ROSE_DATE
		l_statement: STRING
	once
		create l_two_months_ago.make_today
		l_two_months_ago.add_n_months(-2)
		l_statement := Global.formatted(
											"[
												select distinct a.machinename
												from
													counterdetails a,
													(
														select counterid from counterdata where CounterDateTime > '$1' group by counterid
													) b
												where
													a.counterid=b.counterid
											]",
											<<l_two_months_ago.formatted_out("YYYY-[0]MM-[0]DD [0]HH:[0]MI")>>
									   )
		create Result.make(perf_counter_server, l_statement)
		if not Result.success
		then
			create l_exceptions
			l_exceptions.raise("Failed to create the machine_names_with_perf_data_predicate")
		end
	end

	machines_in_trouble_predicate(a_time_string: STRING): COLLECTING_PREDICATE[COUNTER_SUMMARY_VIEW] is
	-- Returns machines that are low in memory or high in CPU usage.
	local
		l_exceptions: EXCEPTIONS
	do
		-- Wow!  This function is a LOT faster than using a once function.  This is because a once
		-- function would have to use a parameter for the time and SQL/Server's optimizer would not
		-- know what that time would be.  So it probably guesses that it will be somewhere in the
		-- middle of the available range.  BUT, in this predicate, the time is always pushed right
		-- up against the end of the range.  By preparing the predicate everytime WITH the parameter
		-- included, the optimizer can choose a different (more efficient) plan.  OK, that might be
		-- wrong, but the results are much faster (50 milliseconds vs. 2 seconds).
		create Result.make_with_parameter_template(
			perf_counter_server,
			"select a.* %
			%from counter_summary2_view a inner join %
			%(%
			% select max(CounterDateTime) AS max_time, MachineName, objectname %
			% from counter_summary2_view %
			% where counterDateTime>'" + a_time_string + "' %
			% group by MachineName, objectname) b %
			%on %
			%a.CounterDateTime=b.max_time and %
			%a.MachineName = b.MachineName and %
			%((a.objectname='Memory' and a.countervalue<" + memory_yellow_alert_level.out + ") or %
			% (a.objectname='Processor' and a.countervalue>" + processor_yellow_alert_level.out + ")) %
			%order by a.machinename",
			<<"STRING">>)
		if not Result.success
		then
			create l_exceptions
			l_exceptions.raise("Failed to create the machines_in_trouble_predicate")
		end
	end

--	machines_in_trouble_predicate: COLLECTING_PREDICATE[COUNTER_SUMMARY_VIEW] is
--	local
--		l_exceptions: EXCEPTIONS
--	once
--		create Result.make_with_parameter_template(
--			perf_counter_server,
--			"select a.* %
--			%from counter_summary2_view a inner join %
--			%(%
--			% select max(CounterDateTime) AS max_time, MachineName %
--			% from counter_summary2_view %
--			% where counterDateTime>? %
--			% group by MachineName) b %
--			%on %
--			%a.CounterDateTime=b.max_time and %
--			%a.MachineName = b.MachineName and %
--			%((a.objectname='Memory' and a.countervalue<700) or %
--			% (a.objectname='Processor' and a.countervalue>40)) %
--			%order by a.machinename",
--			<<"STRING">>)
--		if not Result.success
--		then
--			create l_exceptions
--			l_exceptions.raise("Failed to create the machines_in_trouble_predicate")
--		end
--	end

	colors: EV_STOCK_COLORS is
	-- Stock colors like red, green, etc.
	once
		create Result
	end

	integer_formatter: FORMAT_INTEGER is
	-- Formats an integer with commas, like this: 1,234,567.
	once
		create Result.make(1)
		Result.set_separator(',')
	end

	integer64_formatter: FORMAT_DOUBLE
	-- Formats an integer with commas, like this: 1,234,567.  We use FORMAT_DOUBLE because there is no FORMAT_INTEGER_64.
	once
		create Result.make(1, 0)
		Result.set_separator(',')
	end

	tooltip_available_font: EV_FONT
	-- The font used to indicate that a message is available in the tooltip.
	once
		create Result
		Result.set_shape((create {EV_FONT_CONSTANTS}).shape_italic)
		Result.set_weight((create {EV_FONT_CONSTANTS}).weight_bold)
	end

	not_pressed_color: EV_COLOR is
	-- Color which indicates that the user can press this title because it is actually a button.
	once
		create Result.make_with_8_bit_rgb(0, 0, 255)
	end

	pressed_color: EV_COLOR is
	-- See 'not_pressed_color'.
	once
		create Result.make_with_8_bit_rgb(0, 0, 0)
	end

	blockee_color: EV_COLOR is
	-- Color to indicate that this item is blocked.
	once
		create Result.make_with_8_bit_rgb(0, 0, 255)
	end

	blocker_color: EV_COLOR is
	-- Color to indicate that this item is blocking somebody.
	once
		create Result.make_with_8_bit_rgb(255, 0, 0)
	end

	uninteresting_blocker_color: EV_COLOR is
	-- This color indicates that the item is a blocker but not very interesting.
	once
		create Result.make_with_8_bit_rgb(128, 128, 128)
	end

	blockee_blocker_color: EV_COLOR is
	-- Indicates that a program has both blockers and blockees.
	once
		create Result.make_with_8_bit_rgb(255, 0, 255)
	end

	red_alert_color: EV_COLOR is
	-- The color to use for red alerts.
	once
		create Result.make_with_8_bit_rgb(255, 185, 185)
	end

	orange_alert_color: EV_COLOR is
	-- No data for this machine.
	once
		create Result.make_with_8_bit_rgb(255, 153, 0)
	end

	yellow_alert_color: EV_COLOR is
	-- The color to use for yellow alerts.
	once
		create Result.make_with_8_bit_rgb(255, 255, 185)
	end

	yellow_alert_inactive_selected_color: EV_COLOR is
	-- The color to use for yellow alerts when the item is selected but not active (gray background).
	once
		create Result.make_with_8_bit_rgb(180, 160, 0)
	end

	odd_background_color: EV_COLOR is
	-- In some places we alternate the color of successive rows.
	once
		create Result.make_with_8_bit_rgb(255, 255, 224)
	end

	even_background_color: EV_COLOR is
	-- In some places we alternate the color of successive rows.
	once
		create Result.make_with_8_bit_rgb(255, 255, 192)
	end

	blocking_process_background_color: EV_COLOR is
	-- Used to indicate the process with holds the blocking SPID.
	once
		create Result.make_with_8_bit_rgb(255, 255, 177)
	end

	separator_color: EV_COLOR is
	-- A very faint gray used for the grid lines (separators).
	once
		create Result.make_with_8_bit_rgb(240, 240, 240)
	end

	chart_length_3h: EV_LIST_ITEM is
	-- An item in 'chart_length_combo'.
	once
		create Result.make_with_text("3 hours")
	end

	chart_length_24h: EV_LIST_ITEM is
	-- An item in 'chart_length_combo'.
	once
		create Result.make_with_text("24 hours")
	end

	chart_length_7d: EV_LIST_ITEM is
	-- An item in 'chart_length_combo'.
	once
		create Result.make_with_text("7 days")
	end

	chart_length_30d: EV_LIST_ITEM is
	-- An item in 'chart_length_combo'.
	once
		create Result.make_with_text("30 days")
	end

	nearly_black: EV_COLOR is
	-- Not so grey that you would notice, but not (0, 0, 0) which is the default foreground color and
	-- is then converted by Common Controls V6 to blue.
	once
		create Result.make_with_8_bit_rgb(1, 1, 1)
	end

	processor_color: EV_COLOR
	-- Color used in the perf graph for the processor time (brown is on the ground).
	once
		create Result.make_with_8_bit_rgb(139, 69, 19)
	end

	memory_color: EV_COLOR
	-- Color used in the perf graph for the memory (blue is in the sky).
	once
		create Result.make_with_8_bit_rgb(162, 223, 254)
	end

	tester: TEST_RCMD_DATA_CONNECTION_VIEWER			-- This is merely to force this class into our system.
	once
	end

	k_none: STRING = "--NONE--"							-- Name of the server to select when you don't want any servers.

	k_no_view_server_state: STRING = "You probably lack the privilege VIEW SERVER STATE.  Can't monitor blocking, etc."
														-- If "select * from sysprocess" returns only one row then you may lack VIEW SERVER STATE.

	processor_yellow_alert_level: INTEGER is 40			-- Go to yellow alert when CPU usage exceeds this percentage.
	processor_red_alert_level: INTEGER is 70			-- Go to red alert when CPU usage exceeds this percentage.
	memory_yellow_alert_level: INTEGER is 700			-- Go to yellow alert when available memory falls below this value (MB).
	memory_red_alert_level: INTEGER is 400				-- Go to red alert when available memory falls below this value (MB).

feature {NONE} -- Externals.
	WSAGetLastError(): INTEGER
	-- The last error that happened to a socket.
	external
		"C signature (): INTEGER use <winsock.h>"		-- Nuts!  When I use winsock2 I get 100's of linkage errors.
	alias
		"WSAGetLastError"
	end

	WSASetLastError(a_error_code: INTEGER)
	-- Useful for clearing the error that WSAGetLastError reports.
	external
		"C signature (int) use <winsock.h>"				-- Nuts!  When I use winsock2 I get 100's of linkage errors.
	alias
		"WSASetLastError"
	end

	c_set_sock_opt_int(fd, level, opt, val: INTEGER) is
	-- Socket options.
	external
		"C"
	end

	open_service_control_manager(a_machine_name, a_database_name: POINTER; a_desired_access: INTEGER): INTEGER is
	-- To control services on a remote machine.
	external
		"C [macro <windows.h>]"
	alias
		"OpenSCManagerA"
	end

	open_service(a_scmanager: INTEGER; a_service_name: POINTER; a_desired_access: INTEGER): INTEGER is
	-- Creates a handle on a remote service.
	external
		"C [macro <windows.h>]"
	alias
		"OpenServiceA"
	end

	close_service_handle(a_handle: INTEGER) is
	-- Closes the handle returned by 'open_service'.
	external
		"C [macro <windows.h>]"
	alias
		"CloseServiceHandle"
	end

	control_service(a_service: INTEGER; a_control: INTEGER; a_service_status: POINTER): BOOLEAN is
	-- Sends a message to a remote service.
	external
		"C [macro <windows.h>]"
	alias
		"ControlService"
	end

	start_service(a_service: INTEGER; a_num_service_eargs: INTEGER; a_service_args_vector: POINTER): BOOLEAN is
	-- Starts a remote service.
	external
		"C [macro <windows.h>]"
	alias
		"StartService"
	end

	sizeof_service_status: INTEGER is
	-- Sizeof the struct SERVICE_STATUS.
	external
		"C [macro <windows.h>]"
	alias
		"sizeof(SERVICE_STATUS)"
	end

	service_start: INTEGER is
	-- Constant used to indicate desired access in 'open_service' and 'open_service'.
	external
		"C [macro <windows.h>]"
	alias
		"SERVICE_START"
	end

	service_stop: INTEGER is
	-- Constant used to indicate desired access in 'open_service' and 'open_service'.
	external
		"C [macro <windows.h>]"
	alias
		"SERVICE_STOP"
	end

	service_control_stop: INTEGER is
	-- Constant used by 'control_service' to stop a service.
	external
		"C [macro <windows.h>]"
	alias
		"SERVICE_CONTROL_STOP"
	end

	SC_MANAGER_CONNECT: INTEGER
	-- Constant used by 'control_service' to connect to a service.
	external
		"C [macro <windows.h>]"
	alias
		"SC_MANAGER_CONNECT"
	end

	find_first_file(a_char_ptr: POINTER; a_win32_find_data_ptr: POINTER):INTEGER is
	-- Wrapper for 'FindFirstFile'.
	external
		"C signature (EIF_POINTER, EIF_POINTER): INTEGER use <windows.h>"
	alias
		"FindFirstFileA"
	end

	find_next_file(a_handle: INTEGER; a_win32_find_data_ptr: POINTER): INTEGER is
	-- Wrapper for 'FindNextFile'.
	external
		"C signature (int, EIF_POINTER):INTEGER use <windows.h>"
	alias
		"FindNextFileA"
	end

	invalid_handle_value: INTEGER is
	-- Value returned by 'FindFirstFile' or 'FindNextFile' when there are no more files.
	external
		"C [macro <windows.h>]: EIF_INTEGER"
	alias
		"INVALID_HANDLE_VALUE"
	end

feature {NONE} -- Attributes (alpha order).
	action_text: EV_LABEL							-- We display the programs current action here.

	alert_was_set: BOOLEAN							-- Display the shell notification icon if true.

	allowed_to_kill_processes_saved: BOOLEAN_REF	-- See 'allowed_to_kill_processes'.

	all_sysprocesses: HASH_TABLE[ROSE_LINEAR_ARRAY[SQL_SERVER_SYSPROCESS], STRING]
													-- All sysprocesses hashed by 'hostname' and 'hostprocess'.

	blockers_grid: RP_DATA_GRID[SQL_SERVER_SYSPROCESS]
													-- The blockers are displayed here.

	blockers_frame: EV_FRAME						-- Surrounds 'blockers_grid'.

	blocker_log_file: PLAIN_TEXT_FILE				-- This is where blocker info is logged when 'log_blockers' is selected.

	blockees_grid: RP_DATA_GRID[SQL_SERVER_SYSPROCESS]
													-- The blockees are displayed here.

	blockees_frame: EV_FRAME						-- Surrounds 'blockees_grid'.

	chart_length_combo: EV_COMBO_BOX				-- Allows the user to choose the width of the perf graph.

	data_server_none_row: RP_GRID_NODE[SQL_SERVER_SYSPROCESSES]
													-- Row of the server named 'none'.

	date_time_format: STRING is "YYYY/[0]MM/[0]DD [0]HH:[0]MI:[0]SS"
													-- Format for the 'Last updated at' field.

	default_repository_name: STRING					-- Used to check if user is in the default enviroment or a test environment.

	default_timer_interval: INTEGER					-- How often to automatically call 'refresh'.

	default_partner_timeout: INTEGER				-- How long to wait (in seconds) on other machines before timing out.

	default_ps_time_interval: INTEGER				-- How far back in days to analyze data in the perf summ grid.

	disk_usage_grid: RP_DATA_GRID[ANY]				-- Disk usage data goes here.

	environment_name: STRING						-- Name of the test environment that the user has selected.

	error_message_pane: EV_TEXT						-- Copy of the messages from gui.error_reporter.

	found_interesting_blocker: BOOLEAN				-- Display the shell notification icon if true.

	get_server_requests_saved: COLLECTING_PREDICATE[SERVER_REQUEST]
													-- Saved value for 'get_server_requests'.

	in_show_blocker_detail_guts: BOOLEAN			-- Used to prevent us from accessing a row that just got deselected.

	last_update_time_text: EV_LABEL					-- Holds the 'Last updated at...' message.

	log_blockers: EV_CHECK_BUTTON					-- If selected, then print selected info about blockers to the console.

--	ma: MA_WINDOW									-- Memory Analyzer window.

	may_rebuild_server_request_server: BOOLEAN		-- If true and the server_request_server fails, we may attempt to rebuild it.

	notebook: EV_NOTEBOOK							-- Holds all of the tabs.

	old_focused_selection_text_color: EV_COLOR		-- Always paired with 'old_non_focused_selection_color'.  See 'set_focused_color_agent'.

	old_non_focused_selection_text_color: EV_COLOR	-- Always paired with 'old_focused_selection_color'.  See 'set_focused_color_agent'.

	open_transactions_grid: RP_DATA_GRID[SQL_SERVER_SYSPROCESS]
													-- Open transaction data goes here.

	other_server_names_saved: ROSE_LINEAR_ARRAY [STRING_8]
													-- Saved value of 'other_server_names'.

	partner_timeout: INTEGER						-- How long to wait (in seconds) on other machines before timing out.

	perf_charts: PERFORMANCE_MONITOR_GRAPH_WIDGET	-- Shows the perf graph.

	perf_summary_grid: RP_DATA_GRID[ANY]			-- This is used in the 'Performance Summary' tab.

	perf_summary_vbox: EV_VERTICAL_BOX				-- The window that actually goes into the notebook.  Holds the perf summary chart.

	perf_vbox: EV_VERTICAL_BOX						-- The window that actually goes into the notebook.  Holds the perf chart.

	port_served_apps_grid: RP_DATA_GRID[SQL_SERVER_SYSPROCESS]
													-- The data on the port served applications goes here.

	port_served_apps_frame: EV_FRAME				-- Surrounds 'port_served_apps_grid'.

	port_server_config_values: HASH_TABLE[TUPLE[port_number: INTEGER; log_path: STRING], STRING]
													-- Maps server names to their port_number and log_path.

	port_server_status_grid: RP_DATA_GRID[ANY]		-- The status data on port servers goes here.

	refresh_button: EV_BUTTON						-- If pressed, perform a 'refresh'.

	refresh_once_in_progress: BOOLEAN				-- True while 'refresh' is being run on_idle.

	refresh_running: BOOLEAN						-- If true, we have recursively called 'refresh'.

	repositories_menu: EV_MENU						-- The menu to select the repositories.

	request_blocker_detail_row: RP_GRID_NODE[SQL_SERVER_SYSPROCESS]
													-- Blocker detail will be shown on this row on the next call to 'refresh'
													-- Only set if the user request blocker detail while 'refresh' was running.

--	request_blocker_detail_process: SQL_SERVER_SYSPROCESS

	request_export_to_excel: BOOLEAN				-- The user pressed the Excel button while a refresh was in progress.

	saved_timer_actions: EV_NOTIFY_ACTION_SEQUENCE	-- Used to save the timer actions while the timer is off.

	server_requests: ROSE_LINEAR_ARRAY[SERVER_REQUEST]
													-- Place to store data from the server_requests table.

	server_request_server_saved: SQLOLEDB_DATA_SERVER
													-- Saved value of 'server_request_server'.

	show_all_server_requests: EV_CHECK_BUTTON		-- If selected, then show all port_served apps, even if they are terminated.

	showing_blocker_detail: BOOLEAN					-- True if we are showing blocker detail (and can't perform an automatic refresh).

	show_processes_button: EV_CHECK_BUTTON			-- Button with the text 'Show processes' (on a perf chart).

	splitter1: EV_HORIZONTAL_SPLIT_AREA				-- Top of splitter of many.

	splitter11: EV_VERTICAL_SPLIT_AREA				-- First split of 'splitter_1'.

	splitter111: EV_VERTICAL_SPLIT_AREA				-- First split of 'splitter11'.

	splitter12: EV_VERTICAL_SPLIT_AREA				-- Second split of 'splitter_1'.

	splitter121: EV_VERTICAL_SPLIT_AREA				-- First split of 'splitter12'.

	sysprocesses_grid: RP_DATA_GRID[SQL_SERVER_SYSPROCESS]
													-- Data on sysprocesses goes here.

	testing: BOOLEAN								-- True when TEST_RCMD_DATA_CONNECTION_VIEWER is running.  Used to prevent
													-- user interaction (dialog boxes) from appearing during a test.

	timeout_for_kill: INTEGER						-- How long to wait (in seconds) for a portserver to kill a process.

	timer: EV_TIMEOUT								-- Calls 'refresh' on expiration.  Sometimes turned off.

	window: ROSE_EV_TITLED_WINDOW					-- Our main window.

end
